/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/resources","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],L=0,A=te.length;L<A;L++)e[L]=re[te[L]];return e};define(re[61],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(D){return(R,C,S)=>{let I=null,w=null;if(typeof S.value=="function"?(I="value",w=S.value):typeof S.get=="function"&&(I="get",w=S.get),!w)throw new Error("not supported");S[I]=D(w,C)}}function A(D,R,C){let S=null,I=null;if(typeof C.value=="function"?(S="value",I=C.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(S="get",I=C.get),!I)throw new Error("not supported");const w=`$memoize$${R}`;C[S]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,g)}),this[w]}}e.memoize=A;function c(D,R,C){return L((S,I)=>{const w=`$debounce$${I}`,g=`$debounce$result$${I}`;return function(...f){this[g]||(this[g]=C?C():void 0),clearTimeout(this[w]),R&&(this[g]=R(this[g],...f),f=[this[g]]),this[w]=setTimeout(()=>{S.apply(this,f),this[g]=C?C():void 0},D)}})}e.debounce=c;function k(D,R,C){return L((S,I)=>{const w=`$throttle$timer$${I}`,g=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...v){if(this[g]||(this[g]=C?C():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...v)),this[d])return;const h=this[f]+D;h<=Date.now()?(this[f]=Date.now(),S.apply(this,[this[g]]),this[g]=C?C():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),S.apply(this,[this[g]]),this[g]=C?C():void 0},h-Date.now()))}})}e.throttle=k}),define(re[8],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?E.isErrorNoTelemetry(o)?new E(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(t=>{t(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=L,e.errorHandler=new L;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function c(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=c;function k(i){S(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=k;function D(i){S(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=D;function R(i){if(i instanceof Error){const{name:o,message:t}=i,n=i.stacktrace||i.stack;return{$isError:!0,name:o,message:t,stack:n,noTelemetry:E.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=R;const C="Canceled";function S(i){return i instanceof I?!0:i instanceof Error&&i.name===C&&i.message===C}e.isCancellationError=S;class I extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=I;function w(){const i=new Error(C);return i.name=i.message,i}e.canceled=w;function g(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=g;function f(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=f;function d(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function v(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=v;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=h;class u extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=u;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class E extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof E)return o;const t=new E;return t.message=o.message,t.stack=o.stack,t}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class P extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype);debugger}}e.BugIndicatingError=P}),define(re[21],oe([0,1,8]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(K,Z=0){return K[K.length-(1+Z)]}e.tail=A;function c(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=c;function k(K,Z,ie=(le,he)=>le===he){if(K===Z)return!0;if(!K||!Z||K.length!==Z.length)return!1;for(let le=0,he=K.length;le<he;le++)if(!ie(K[le],Z[le]))return!1;return!0}e.equals=k;function D(K,Z){const ie=K.length-1;Z<ie&&(K[Z]=K[ie]),K.pop()}e.removeFastWithoutKeepingOrder=D;function R(K,Z,ie){return C(K.length,le=>ie(K[le],Z))}e.binarySearch=R;function C(K,Z){let ie=0,le=K-1;for(;ie<=le;){const he=(ie+le)/2|0,me=Z(he);if(me<0)ie=he+1;else if(me>0)le=he-1;else return he}return-(ie+1)}e.binarySearch2=C;function S(K,Z){let ie=0,le=K.length;if(le===0)return 0;for(;ie<le;){const he=Math.floor((ie+le)/2);Z(K[he])?le=he:ie=he+1}return ie}e.findFirstInSorted=S;function I(K,Z,ie){if(K=K|0,K>=Z.length)throw new TypeError("invalid index");const le=Z[Math.floor(Z.length*Math.random())],he=[],me=[],pe=[];for(const we of Z){const Ee=ie(we,le);Ee<0?he.push(we):Ee>0?me.push(we):pe.push(we)}return K<he.length?I(K,he,ie):K<he.length+pe.length?pe[0]:I(K-(he.length+pe.length),me,ie)}e.quickSelect=I;function w(K,Z){const ie=[];let le;for(const he of K.slice(0).sort(Z))!le||Z(le[0],he)!==0?(le=[he],ie.push(le)):le.push(he);return ie}e.groupBy=w;function g(K,Z,ie){const le=[];function he(we,Ee,ke){if(Ee===0&&ke.length===0)return;const De=le[le.length-1];De&&De.start+De.deleteCount===we?(De.deleteCount+=Ee,De.toInsert.push(...ke)):le.push({start:we,deleteCount:Ee,toInsert:ke})}let me=0,pe=0;for(;;){if(me===K.length){he(me,0,Z.slice(pe));break}if(pe===Z.length){he(me,K.length-me,[]);break}const we=K[me],Ee=Z[pe],ke=ie(we,Ee);ke===0?(me+=1,pe+=1):ke<0?(he(me,1,[]),me+=1):ke>0&&(he(me,0,[Ee]),pe+=1)}return le}e.sortedDiff=g;function f(K,Z,ie){const le=g(K,Z,ie),he=[],me=[];for(const pe of le)he.push(...K.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:he,added:me}}e.delta=f;function d(K,Z,ie){if(ie===0)return[];const le=K.slice(0,ie).sort(Z);return h(K,Z,le,ie,K.length),le}e.top=d;function v(K,Z,ie,le,he){return ie===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const we=K.length,Ee=K.slice(0,ie).sort(Z);for(let ke=ie,De=Math.min(ie+le,we);ke<we;ke=De,De=Math.min(De+le,we)){if(ke>ie&&await new Promise(qe=>setTimeout(qe)),he&&he.isCancellationRequested)throw new L.CancellationError;h(K,Z,Ee,ke,De)}return Ee})().then(me,pe)})}e.topAsync=v;function h(K,Z,ie,le,he){for(const me=ie.length;le<he;le++){const pe=K[le];if(Z(pe,ie[me-1])<0){ie.pop();const we=S(ie,Ee=>Z(pe,Ee)<0);ie.splice(we,0,pe)}}}function u(K){return K.filter(Z=>!!Z)}e.coalesce=u;function m(K){let Z=0;for(let ie=0;ie<K.length;ie++)K[ie]&&(K[Z]=K[ie],Z+=1);K.length=Z}e.coalesceInPlace=m;function p(K,Z,ie){K.splice(ie,0,K.splice(Z,1)[0])}e.move=p;function E(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=E;function P(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=P;function i(K,Z=ie=>ie){const ie=new Set;return K.filter(le=>{const he=Z(le);return ie.has(he)?!1:(ie.add(he),!0)})}e.distinct=i;function o(K){const Z=new Set;return ie=>{const le=K(ie);return Z.has(le)?!1:(Z.add(le),!0)}}e.uniqueFilter=o;function t(K,Z){const ie=n(K,Z);if(ie!==-1)return K[ie]}e.findLast=t;function n(K,Z){for(let ie=K.length-1;ie>=0;ie--){const le=K[ie];if(Z(le))return ie}return-1}e.lastIndex=n;function s(K,Z){return K.length>0?K[0]:Z}e.firstOrDefault=s;function a(K,Z){return K.length>0?K[K.length-1]:Z}e.lastOrDefault=a;function r(K,Z,ie=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(K.length,Z.length);he<me&&ie(K[he],Z[he]);he++)le++;return le}e.commonPrefixLength=r;function l(K){return[].concat(...K)}e.flatten=l;function y(K,Z){let ie=typeof Z=="number"?K:0;typeof Z=="number"?ie=K:(ie=0,Z=K);const le=[];if(ie<=Z)for(let he=ie;he<Z;he++)le.push(he);else for(let he=ie;he>Z;he--)le.push(he);return le}e.range=y;function b(K,Z,ie){return K.reduce((le,he)=>(le[Z(he)]=ie?ie(he):he,le),Object.create(null))}e.index=b;function O(K,Z){return K.push(Z),()=>N(K,Z)}e.insert=O;function N(K,Z){const ie=K.indexOf(Z);if(ie>-1)return K.splice(ie,1),Z}e.remove=N;function F(K,Z,ie){const le=K.slice(0,Z),he=K.slice(Z);return le.concat(ie,he)}e.arrayInsert=F;function z(K,Z){let ie;if(typeof Z=="number"){let le=Z;ie=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ie=Math.random;for(let le=K.length-1;le>0;le-=1){const he=Math.floor(ie()*(le+1)),me=K[le];K[le]=K[he],K[he]=me}}e.shuffle=z;function G(K,Z){const ie=K.indexOf(Z);ie>-1&&(K.splice(ie,1),K.unshift(Z))}e.pushToStart=G;function Y(K,Z){const ie=K.indexOf(Z);ie>-1&&(K.splice(ie,1),K.push(Z))}e.pushToEnd=Y;function W(K,Z){for(const ie of Z)K.push(ie)}e.pushMany=W;function T(K,Z){return Array.isArray(K)?K.map(Z):Z(K)}e.mapArrayOrNot=T;function B(K){return Array.isArray(K)?K:[K]}e.asArray=B;function _(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=_;function q(K,Z){for(const ie of K){const le=Z(ie);if(le!==void 0)return le}}e.mapFind=q;function x(K,Z,ie){const le=X(K,Z),he=K.length,me=ie.length;K.length=he+me;for(let pe=he-1;pe>=le;pe--)K[pe+me]=K[pe];for(let pe=0;pe<me;pe++)K[pe+le]=ie[pe]}e.insertInto=x;function M(K,Z,ie,le){const he=X(K,Z),me=K.splice(he,ie);return x(K,he,le),me}e.splice=M;function X(K,Z){return Z<0?Math.max(Z+K.length,0):Math.min(Z,K.length)}var Q;(function(K){function Z(he){return he<0}K.isLessThan=Z;function ie(he){return he>0}K.isGreaterThan=ie;function le(he){return he===0}K.isNeitherLessOrGreaterThan=le,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function se(K,Z){return(ie,le)=>Z(K(ie),K(le))}e.compareBy=se;function ae(...K){return(Z,ie)=>{for(const le of K){const he=le(Z,ie);if(!Q.isNeitherLessOrGreaterThan(he))return he}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const V=(K,Z)=>K-Z;e.numberComparator=V;function j(K,Z){if(K.length===0)return;let ie=K[0];for(let le=1;le<K.length;le++){const he=K[le];Z(he,ie)>0&&(ie=he)}return ie}e.findMaxBy=j;function U(K,Z){if(K.length===0)return;let ie=K[0];for(let le=1;le<K.length;le++){const he=K[le];Z(he,ie)>=0&&(ie=he)}return ie}e.findLastMaxBy=U;function $(K,Z){return j(K,(ie,le)=>-Z(ie,le))}e.findMinBy=$;class H{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let ie=this.c;for(;ie<this.f.length&&Z(this.f[ie]);)ie++;const le=ie===this.c?null:this.f.slice(this.c,ie);return this.c=ie,le}takeFromEndWhile(Z){let ie=this.d;for(;ie>=0&&Z(this.f[ie]);)ie--;const le=ie===this.d?null:this.f.slice(ie+1,this.d+1);return this.d=ie,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const ie=this.f.slice(this.c,this.c+Z);return this.c+=Z,ie}}e.ArrayQueue=H;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(ie=>(Z(ie),!0))}toArray(){const Z=[];return this.iterate(ie=>(Z.push(ie),!0)),Z}filter(Z){return new ee(ie=>this.iterate(le=>Z(le)?ie(le):!0))}map(Z){return new ee(ie=>this.iterate(le=>ie(Z(le))))}some(Z){let ie=!1;return this.iterate(le=>(ie=Z(le),!ie)),ie}findFirst(Z){let ie;return this.iterate(le=>Z(le)?(ie=le,!1):!0),ie}findLast(Z){let ie;return this.iterate(le=>(Z(le)&&(ie=le),!0)),ie}findLastMaxBy(Z){let ie,le=!0;return this.iterate(he=>((le||Q.isGreaterThan(Z(he,ie)))&&(le=!1,ie=he),!0)),ie}}ee.empty=new ee(K=>{}),e.CallbackIterable=ee}),define(re[128],oe([0,1,8]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(C,S){if(!C)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=A;function c(C,S="Unreachable"){throw new Error(S)}e.assertNever=c;function k(C){if(!C)throw new L.BugIndicatingError("Assertion Failed")}e.assert=k;function D(C){if(!C()){debugger;C(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function R(C,S){let I=0;for(;I<C.length-1;){const w=C[I],g=C[I+1];if(!S(w,g))return!1;I++}return!0}e.checkAdjacentItems=R}),define(re[81],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(A){const c=this;let k=!1,D;return function(){return k||(k=!0,D=A.apply(c,arguments)),D}}e.once=L}),define(re[62],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(A){function c(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}A.is=c;const k=Object.freeze([]);function D(){return k}A.empty=D;function*R(E){yield E}A.single=R;function C(E){return c(E)?E:R(E)}A.wrap=C;function S(E){return E||k}A.from=S;function I(E){return!E||E[Symbol.iterator]().next().done===!0}A.isEmpty=I;function w(E){return E[Symbol.iterator]().next().value}A.first=w;function g(E,P){for(const i of E)if(P(i))return!0;return!1}A.some=g;function f(E,P){for(const i of E)if(P(i))return i}A.find=f;function*d(E,P){for(const i of E)P(i)&&(yield i)}A.filter=d;function*v(E,P){let i=0;for(const o of E)yield P(o,i++)}A.map=v;function*h(...E){for(const P of E)for(const i of P)yield i}A.concat=h;function u(E,P,i){let o=i;for(const t of E)o=P(o,t);return o}A.reduce=u;function*m(E,P,i=E.length){for(P<0&&(P+=E.length),i<0?i+=E.length:i>E.length&&(i=E.length);P<i;P++)yield E[P]}A.slice=m;function p(E,P=Number.POSITIVE_INFINITY){const i=[];if(P===0)return[i,E];const o=E[Symbol.iterator]();for(let t=0;t<P;t++){const n=o.next();if(n.done)return[i,A.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=p})(L=e.Iterable||(e.Iterable={}))}),define(re[35],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var c;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(c=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function D(i,o=!1){let t=0;const n=i.length;let s="",a=0,r=16,l=0;function y(Y){let W=0,T=0;for(;W<Y;){const B=i.charCodeAt(t);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;t++,W++}return W<Y&&(T=-1),T}function b(Y){t=Y,s="",a=0,r=16,l=0}function O(){const Y=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&S(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&S(i.charCodeAt(t)))for(t++;t<i.length&&S(i.charCodeAt(t));)t++;else return l=3,i.substring(Y,t);let W=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&S(i.charCodeAt(t))){for(t++;t<i.length&&S(i.charCodeAt(t));)t++;W=t}else l=3;return i.substring(Y,W)}function N(){let Y="",W=t;for(;;){if(t>=n){Y+=i.substring(W,t),l=2;break}const T=i.charCodeAt(t);if(T===34){Y+=i.substring(W,t),t++;break}if(T===92){if(Y+=i.substring(W,t),t++,t>=n){l=2;break}switch(i.charCodeAt(t++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const _=y(4);_>=0?Y+=String.fromCharCode(_):l=4;break}default:l=5}W=t;continue}if(T>=0&&T<=31)if(C(T)){Y+=i.substring(W,t),l=2;break}else l=6;t++}return Y}function F(){if(s="",l=0,a=t,t>=n)return a=n,r=17;let Y=i.charCodeAt(t);if(R(Y)){do t++,s+=String.fromCharCode(Y),Y=i.charCodeAt(t);while(R(Y));return r=15}if(C(Y))return t++,s+=String.fromCharCode(Y),Y===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),r=14;switch(Y){case 123:return t++,r=1;case 125:return t++,r=2;case 91:return t++,r=3;case 93:return t++,r=4;case 58:return t++,r=6;case 44:return t++,r=5;case 34:return t++,s=N(),r=10;case 47:{const W=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!C(i.charCodeAt(t));)t++;return s=i.substring(W,t),r=12}if(i.charCodeAt(t+1)===42){t+=2;const T=n-1;let B=!1;for(;t<T;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,B=!0;break}t++}return B||(t++,l=1),s=i.substring(W,t),r=13}return s+=String.fromCharCode(Y),t++,r=16}case 45:if(s+=String.fromCharCode(Y),t++,t===n||!S(i.charCodeAt(t)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),r=11;default:for(;t<n&&z(Y);)t++,Y=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode(Y),t++,r=16}}function z(Y){if(R(Y)||C(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Y;do Y=F();while(Y>=12&&Y<=15);return Y}return{setPosition:b,getPosition:()=>t,scan:o?G:F,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>l}}e.createScanner=D;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function S(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function w(i,o){const t=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function l(y,b,O,N){a.value=y,a.offset=b,a.length=O,a.type=N,a.colonOffset=void 0,s=a}try{p(i,{onObjectBegin:(y,b)=>{if(o<=y)throw n;s=void 0,r=o>y,t.push("")},onObjectProperty:(y,b,O)=>{if(o<b||(l(y,b,O,"property"),t[t.length-1]=y,o<=b+O))throw n},onObjectEnd:(y,b)=>{if(o<=y)throw n;s=void 0,t.pop()},onArrayBegin:(y,b)=>{if(o<=y)throw n;s=void 0,t.push(0)},onArrayEnd:(y,b)=>{if(o<=y)throw n;s=void 0,t.pop()},onLiteralValue:(y,b,O)=>{if(o<b||(l(y,b,O,P(y)),o<=b+O))throw n},onSeparator:(y,b,O)=>{if(o<=b)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=b,r=!1,s=void 0;else if(y===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(r=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:t,previousNode:s,isAtPropertyKey:r,matches:y=>{let b=0;for(let O=0;b<y.length&&O<t.length;O++)if(y[b]===t[O]||y[b]==="*")b++;else if(y[b]!=="**")return!1;return b===y.length}}}e.getLocation=w;function g(i,o=[],t=k.DEFAULT){let n=null,s=[];const a=[];function r(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return p(i,{onObjectBegin:()=>{const y={};r(y),a.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];r(y),a.push(s),s=y,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:r,onError:(y,b,O)=>{o.push({error:y,offset:b,length:O})}},t),s[0]}e.parse=g;function f(i,o=[],t=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function a(y){return n.children.push(y),y}p(i,{onObjectBegin:y=>{n=a({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,b,O)=>{n=a({type:"property",offset:b,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:b,length:O,parent:n})},onObjectEnd:(y,b)=>{n.length=y+b-n.offset,n=n.parent,s(y+b)},onArrayBegin:(y,b)=>{n=a({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,b)=>{n.length=y+b-n.offset,n=n.parent,s(y+b)},onLiteralValue:(y,b,O)=>{a({type:P(y),offset:b,length:O,parent:n,value:y}),s(b+O)},onSeparator:(y,b,O)=>{n.type==="property"&&(y===":"?n.colonOffset=b:y===","&&s(b))},onError:(y,b,O)=>{o.push({error:y,offset:b,length:O})}},t);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=f;function d(i,o){if(!i)return;let t=i;for(const n of o)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=d;function v(i){if(!i.parent||!i.parent.children)return[];const o=v(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;o.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&o.push(t)}return o}e.getNodePath=v;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const o=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(o[t.children[0].value]=h(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function u(i,o,t=!1){return o>=i.offset&&o<i.offset+i.length||t&&o===i.offset+i.length}e.contains=u;function m(i,o,t=!1){if(u(i,o,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const a=m(n[s],o,t);if(a)return a}return i}}e.findNodeAtOffset=m;function p(i,o,t=k.DEFAULT){const n=D(i,!1);function s(se){return se?()=>se(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(se){return se?ae=>se(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=s(o.onObjectBegin),l=a(o.onObjectProperty),y=s(o.onObjectEnd),b=s(o.onArrayBegin),O=s(o.onArrayEnd),N=a(o.onLiteralValue),F=a(o.onSeparator),z=s(o.onComment),G=a(o.onError),Y=t&&t.disallowComments,W=t&&t.allowTrailingComma;function T(){for(;;){const se=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:Y||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(se){case 12:case 13:Y?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return se}}}function B(se,ae=[],V=[]){if(G(se),ae.length+V.length>0){let j=n.getToken();for(;j!==17;){if(ae.indexOf(j)!==-1){T();break}else if(V.indexOf(j)!==-1)break;j=T()}}}function _(se){const ae=n.getTokenValue();return se?N(ae):l(ae),T(),!0}function q(){switch(n.getToken()){case 11:{let se=0;try{se=JSON.parse(n.getTokenValue()),typeof se!="number"&&(B(2),se=0)}catch{B(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return T(),!0}function x(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(_(!1),n.getToken()===6?(F(":"),T(),Q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function M(){r(),T();let se=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(se||B(4,[],[]),F(","),T(),n.getToken()===2&&W)break}else se&&B(6,[],[]);x()||B(4,[],[2,5]),se=!0}return y(),n.getToken()!==2?B(7,[2],[]):T(),!0}function X(){b(),T();let se=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(se||B(4,[],[]),F(","),T(),n.getToken()===4&&W)break}else se&&B(6,[],[]);Q()||B(4,[],[4,5]),se=!0}return O(),n.getToken()!==4?B(8,[4],[]):T(),!0}function Q(){switch(n.getToken()){case 3:return X();case 1:return M();case 10:return _(!0);default:return q()}}return T(),n.getToken()===17?t.allowEmptyContent?!0:(B(4,[],[]),!1):Q()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=p;function E(i,o){const t=D(i),n=[];let s,a=0,r;do switch(r=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==r&&n.push(i.substring(a,r)),o!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,o)),a=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=E;function P(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(re[42],oe([0,1,35]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(S,I,w){let g,f,d,v,h;if(I){for(v=I.offset,h=v+I.length,d=v;d>0&&!C(S,d-1);)d--;let r=h;for(;r<S.length&&!C(S,r);)r++;f=S.substring(d,r),g=D(f,w)}else f=S,g=0,d=0,v=0,h=S.length;const u=R(w,S);let m=!1,p=0,E;w.insertSpaces?E=k(" ",w.tabSize||4):E="	";const P=(0,L.createScanner)(f,!1);let i=!1;function o(){return u+k(E,g+p)}function t(){let r=P.scan();for(m=!1;r===15||r===14;)m=m||r===14,r=P.scan();return i=r===16||P.getTokenError()!==0,r}const n=[];function s(r,l,y){!i&&l<h&&y>v&&S.substring(l,y)!==r&&n.push({offset:l,length:y-l,content:r})}let a=t();if(a!==17){const r=P.getTokenOffset()+d,l=k(E,g);s(l,d,r)}for(;a!==17;){let r=P.getTokenOffset()+P.getTokenLength()+d,l=t(),y="";for(;!m&&(l===12||l===13);){const O=P.getTokenOffset()+d;s(" ",r,O),r=P.getTokenOffset()+P.getTokenLength()+d,y=l===12?o():"",l=t()}if(l===2)a!==1&&(p--,y=o());else if(l===4)a!==3&&(p--,y=o());else{switch(a){case 3:case 1:p++,y=o();break;case 5:case 12:y=o();break;case 13:m?y=o():y=" ";break;case 6:y=" ";break;case 10:if(l===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?y=" ":l!==5&&l!==17&&(i=!0);break;case 16:i=!0;break}m&&(l===12||l===13)&&(y=o())}const b=P.getTokenOffset()+d;s(y,r,b),a=l}return n}e.format=A;function c(S,I){const w=JSON.stringify(S,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?w.replace(/\r\n|\r|\n/g,I.eol):w}e.toFormattedString=c;function k(S,I){let w="";for(let g=0;g<I;g++)w+=S;return w}function D(S,I){let w=0,g=0;const f=I.tabSize||4;for(;w<S.length;){const d=S.charAt(w);if(d===" ")g++;else if(d==="	")g+=f;else break;w++}return Math.floor(g/f)}function R(S,I){for(let w=0;w<I.length;w++){const g=I.charAt(w);if(g==="\r")return w+1<I.length&&I.charAt(w+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function C(S,I){return`\r
`.indexOf(S.charAt(I))!==-1}e.isEOL=C}),define(re[82],oe([0,1,35,42]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function c(S,I,w){return k(S,I,void 0,w)}e.removeProperty=c;function k(S,I,w,g,f){const d=I.slice(),v=[],h=(0,L.parseTree)(S,v);let u,m;for(;d.length>0&&(m=d.pop(),u=(0,L.findNodeAtLocation)(h,d),u===void 0&&w!==void 0);)typeof m=="string"?w={[m]:w}:w=[w];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const p=(0,L.findNodeAtLocation)(u,[m]);if(p!==void 0)if(w===void 0){if(!p.parent)throw new Error("Malformed AST");const E=u.children.indexOf(p.parent);let P,i=p.parent.offset+p.parent.length;if(E>0){const o=u.children[E-1];P=o.offset+o.length}else P=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return D(S,{offset:P,length:i-P,content:""},g)}else return D(S,{offset:p.offset,length:p.length,content:JSON.stringify(w)},g);else{if(w===void 0)return[];const E=`${JSON.stringify(m)}: ${JSON.stringify(w)}`,P=f?f(u.children.map(o=>o.children[0].value)):u.children.length;let i;if(P>0){const o=u.children[P-1];i={offset:o.offset+o.length,length:0,content:","+E}}else u.children.length===0?i={offset:u.offset+1,length:0,content:E}:i={offset:u.offset+1,length:0,content:E+","};return D(S,i,g)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(w!==void 0){const p=`${JSON.stringify(w)}`;let E;if(u.children.length===0||m===0)E={offset:u.offset+1,length:0,content:u.children.length===0?p:p+","};else{const P=m===-1||m>u.children.length?u.children.length:m,i=u.children[P-1];E={offset:i.offset+i.length,length:0,content:","+p}}return D(S,E,g)}else{const p=m,E=u.children[p];let P;if(u.children.length===1)P={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===p){const i=u.children[p-1],o=i.offset+i.length,t=u.offset+u.length;P={offset:o,length:t-2-o,content:""}}else P={offset:E.offset,length:u.children[p+1].offset-E.offset,content:""};return D(S,P,g)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(S,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(w)},g)}}e.setProperty=k;function D(S,I,w){let g=R(S,I),f=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,A.isEOL)(g,f-1);)f--;for(;d<g.length&&!(0,A.isEOL)(g,d);)d++}const v=(0,A.format)(g,{offset:f,length:d-f},w);for(let u=v.length-1;u>=0;u--){const m=v[u];g=R(g,m),f=Math.min(f,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const h=S.length-(g.length-d)-f;return[{offset:f,length:h,content:g.substring(f,d)}]}e.withFormatting=D;function R(S,I){return S.substring(0,I.offset)+I.content+S.substring(I.offset+I.length)}e.applyEdit=R;function C(S,I){const w=I.slice(0).sort((f,d)=>{const v=f.offset-d.offset;return v===0?f.length-d.length:v});let g=S.length;for(let f=w.length-1;f>=0;f--){const d=w[f];if(d.offset+d.length<=g)S=R(S,d);else throw new Error("Overlapping edit");g=d.offset}return S}e.applyEdits=C}),define(re[129],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(c){this.d=c,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(c){this.c=c}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(re[2],oe([0,1,81,62]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const c=!1;let k=null;function D(a){k=a}if(e.setDisposableTracker=D,c){const a="__is_disposable_tracked__";D(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==m.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==m.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function R(a){return k?.trackDisposable(a),a}function C(a){k?.markAsDisposed(a)}function S(a,r){k?.setParent(a,r)}function I(a,r){if(!!k)for(const l of a)k.setParent(l,r)}function w(a){return k?.markAsSingleton(a),a}e.markAsSingleton=w;function g(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=g;function f(a){if(A.Iterable.is(a)){const r=[];for(const l of a)if(l)try{l.dispose()}catch(y){r.push(y)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=f;function d(a){for(const r of a)g(r)&&r.dispose();return[]}e.disposeIfDisposable=d;function v(...a){const r=h(()=>f(a));return I(a,r),r}e.combinedDisposable=v;function h(a){const r=R({dispose:(0,L.once)(()=>{C(r),a()})});return r}e.toDisposable=h;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(C(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return S(r,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class m{constructor(){this.q=new u,R(this),S(this.q,this)}dispose(){C(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class p{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&S(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,C(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&S(r,null),r}}e.MutableDisposable=p;class E{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(r){let l=r;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,C(this))},this}}e.SafeDisposable=P;class i{constructor(){this.a=new Map}acquire(r,...l){let y=this.a.get(r);y||(y={counter:0,object:this.b(r,...l)},this.a.set(r,y));const{object:b}=y,O=(0,L.once)(()=>{--y.counter===0&&(this.c(r,y.object),this.a.delete(r))});return y.counter++,{object:b,dispose:O}}}e.ReferenceCollection=i;class o{constructor(r){this.a=r}async acquire(r,...l){const y=this.a.acquire(r,...l);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(b){throw y.dispose(),b}}}e.AsyncReferenceCollection=o;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t;function n(a){const r=new u;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=n;class s{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){C(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,l,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(r)?.dispose(),this.a.set(r,l)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[83],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(k){this.element=k,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class A{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let k=this.a;for(;k!==L.Undefined;){const D=k.next;k.prev=L.Undefined,k.next=L.Undefined,k=D}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,D){const R=new L(k);if(this.a===L.Undefined)this.a=R,this.b=R;else if(D){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(R))}}shift(){if(this.a!==L.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==L.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==L.Undefined&&k.next!==L.Undefined){const D=k.prev;D.next=k.next,k.next.prev=D}else k.prev===L.Undefined&&k.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):k.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):k.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==L.Undefined;)yield k.element,k=k.next}}e.LinkedList=A}),define(re[37],oe([0,1]),function(te,e){"use strict";var L,A,c;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(d,v,h){let u=d.get(v);return u===void 0&&(u=h,d.set(v,u)),u}e.getOrSet=k;function D(d){const v=[];return d.forEach((h,u)=>{v.push(`${u} => ${h}`)}),`Map(${d.size}) {${v.join(", ")}}`}e.mapToString=D;function R(d){const v=[];return d.forEach(h=>{v.push(h)}),`Set(${d.size}) {${v.join(", ")}}`}e.setToString=R;class C{constructor(v,h){this.uri=v,this.value=h}}class S{constructor(v,h){this[L]="ResourceMap",v instanceof S?(this.b=new Map(v.b),this.c=h??S.a):(this.b=new Map,this.c=v??S.a)}set(v,h){return this.b.set(this.c(v),new C(v,h)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,h){typeof h<"u"&&(v=v.bind(h));for(const[u,m]of this.b)v(m.value,m.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}S.a=d=>d.toString(),e.ResourceMap=S;class I{constructor(v,h){this[A]="ResourceSet",!v||typeof v=="function"?this.a=new S(v):(this.a=new S(h),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,h){this.a.forEach((u,m)=>v.call(h,m,m,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var w;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class g{constructor(){this[c]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,h=0){const u=this.a.get(v);if(!!u)return h!==0&&this.j(u,h),u.value}set(v,h,u=0){let m=this.a.get(v);if(m)m.value=h,u!==0&&this.j(m,u);else{switch(m={key:v,value:h,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(v,m),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const h=this.a.get(v);if(!!h)return this.a.delete(v),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,h){const u=this.e;let m=this.b;for(;m;){if(h?v.bind(h)(m.value,m.key,this):v(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const v=this,h=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return m}values(){const v=this,h=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return m}entries(){const v=this,h=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return m}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>v;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const h=v.next,u=v.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}v.next=void 0,v.previous=void 0,this.e++}j(v,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(v===this.b)return;const u=v.next,m=v.previous;v===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(h===2){if(v===this.c)return;const u=v.next,m=v.previous;v===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((h,u)=>{v.push([u,h])}),v}fromJSON(v){this.clear();for(const[h,u]of v)this.set(h,u)}}e.LinkedMap=g;class f extends g{constructor(v,h=1){super(),this.k=v,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,h=2){return super.get(v,h)}peek(v){return super.get(v,0)}set(v,h){return super.set(v,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(re[84],oe([0,1,37]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new L.LRUCache(1e4);function c(S){return C(S,"NFC",A)}e.normalizeNFC=c;const k=new L.LRUCache(1e4);function D(S){return C(S,"NFD",k)}e.normalizeNFD=D;const R=/[^\u0000-\u0080]/;function C(S,I,w){if(!S)return S;const g=w.get(S);if(g)return g;let f;return R.test(S)?f=S.normalize(I):f=S,w.set(S,f),f}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(I){return D(I).replace(S,"")}}()}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(R,C,S){return Math.min(Math.max(R,C),S)}e.clamp=L;function A(R,C){return(C+R%C)%C}e.rot=A;class c{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=c;class k{constructor(){this.a=1,this.b=0}update(C){return this.b=this.b+(C-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=k;class D{constructor(C){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(C),this.c.fill(0,0,C)}update(C){const S=this.c[this.d];return this.c[this.d]=C,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=C,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function te(c){const k=[];typeof c=="number"&&k.push("code/timeOrigin",c);function D(C){k.push(C,Date.now())}function R(){const C=[];for(let S=0;S<k.length;S+=2)C.push({name:k[S],startTime:k[S+1]});return C}return{mark:D,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(c){performance.mark(c)},getMarks(){let c=performance.timeOrigin;typeof c!="number"&&(c=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(c)}];for(const D of performance.getEntriesByType("mark"))k.push({name:D.name,startTime:Math.round(c+D.startTime)});return k}};if(typeof process=="object"){const c=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(c)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function L(c){return c.MonacoPerformanceMarks||(c.MonacoPerformanceMarks=e()),c.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=L(A))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var A in L)(typeof exports=="object"?exports:te)[A]=L[A]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function L(A){if(e[A])return e[A].exports;var c=e[A]={i:A,l:!1,exports:{}};return te[A].call(c.exports,c,c.exports,L),c.l=!0,c.exports}return L.m=te,L.c=e,L.d=function(A,c,k){L.o(A,c)||Object.defineProperty(A,c,{enumerable:!0,get:k})},L.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},L.t=function(A,c){if(1&c&&(A=L(A)),8&c||4&c&&typeof A=="object"&&A&&A.__esModule)return A;var k=Object.create(null);if(L.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:A}),2&c&&typeof A!="string")for(var D in A)L.d(k,D,function(R){return A[R]}.bind(null,D));return k},L.n=function(A){var c=A&&A.__esModule?function(){return A.default}:function(){return A};return L.d(c,"a",c),c},L.o=function(A,c){return Object.prototype.hasOwnProperty.call(A,c)},L.p="",L(L.s=0)}([function(te,e,L){(function(A){var c;e=te.exports=V,c=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],S=0,I=S++;C[I]="0|[1-9]\\d*";var w=S++;C[w]="[0-9]+";var g=S++;C[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=S++;C[f]="("+C[I]+")\\.("+C[I]+")\\.("+C[I]+")";var d=S++;C[d]="("+C[w]+")\\.("+C[w]+")\\.("+C[w]+")";var v=S++;C[v]="(?:"+C[I]+"|"+C[g]+")";var h=S++;C[h]="(?:"+C[w]+"|"+C[g]+")";var u=S++;C[u]="(?:-("+C[v]+"(?:\\."+C[v]+")*))";var m=S++;C[m]="(?:-?("+C[h]+"(?:\\."+C[h]+")*))";var p=S++;C[p]="[0-9A-Za-z-]+";var E=S++;C[E]="(?:\\+("+C[p]+"(?:\\."+C[p]+")*))";var P=S++,i="v?"+C[f]+C[u]+"?"+C[E]+"?";C[P]="^"+i+"$";var o="[v=\\s]*"+C[d]+C[m]+"?"+C[E]+"?",t=S++;C[t]="^"+o+"$";var n=S++;C[n]="((?:<|>)?=?)";var s=S++;C[s]=C[w]+"|x|X|\\*";var a=S++;C[a]=C[I]+"|x|X|\\*";var r=S++;C[r]="[v=\\s]*("+C[a]+")(?:\\.("+C[a]+")(?:\\.("+C[a]+")(?:"+C[u]+")?"+C[E]+"?)?)?";var l=S++;C[l]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[m]+")?"+C[E]+"?)?)?";var y=S++;C[y]="^"+C[n]+"\\s*"+C[r]+"$";var b=S++;C[b]="^"+C[n]+"\\s*"+C[l]+"$";var O=S++;C[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;C[N]="(?:~>?)";var F=S++;C[F]="(\\s*)"+C[N]+"\\s+",R[F]=new RegExp(C[F],"g");var z=S++;C[z]="^"+C[N]+C[r]+"$";var G=S++;C[G]="^"+C[N]+C[l]+"$";var Y=S++;C[Y]="(?:\\^)";var W=S++;C[W]="(\\s*)"+C[Y]+"\\s+",R[W]=new RegExp(C[W],"g");var T=S++;C[T]="^"+C[Y]+C[r]+"$";var B=S++;C[B]="^"+C[Y]+C[l]+"$";var _=S++;C[_]="^"+C[n]+"\\s*("+o+")$|^$";var q=S++;C[q]="^"+C[n]+"\\s*("+i+")$|^$";var x=S++;C[x]="(\\s*)"+C[n]+"\\s*("+o+"|"+C[r]+")",R[x]=new RegExp(C[x],"g");var M=S++;C[M]="^\\s*("+C[r]+")\\s+-\\s+("+C[r]+")\\s*$";var X=S++;C[X]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var Q=S++;C[Q]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)c(se,C[se]),R[se]||(R[se]=new RegExp(C[se]));function ae(ce,fe){if(ce instanceof V)return ce;if(typeof ce!="string"||ce.length>k||!(fe?R[t]:R[P]).test(ce))return null;try{return new V(ce,fe)}catch{return null}}function V(ce,fe){if(ce instanceof V){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof V))return new V(ce,fe);c("SemVer",ce,fe),this.loose=fe;var ge=ce.trim().match(fe?R[t]:R[P]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<D)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var ge=ae(ce,fe);return ge?ge.version:null},e.clean=function(ce,fe){var ge=ae(ce.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(ce){return c("SemVer.compare",this.version,this.loose,ce),ce instanceof V||(ce=new V(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},V.prototype.compareMain=function(ce){return ce instanceof V||(ce=new V(ce,this.loose)),U(this.major,ce.major)||U(this.minor,ce.minor)||U(this.patch,ce.patch)},V.prototype.comparePre=function(ce){if(ce instanceof V||(ce=new V(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ce.prerelease[fe];if(c("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return U(ge,Ie)}while(++fe)},V.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new V(ce,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(K(ce,fe))return null;var ge=ae(ce),Ie=ae(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=U;var j=/^[0-9]+$/;function U(ce,fe){var ge=j.test(ce),Ie=j.test(fe);return ge&&Ie&&(ce=+ce,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ce<fe?-1:ce>fe?1:0}function $(ce,fe,ge){return new V(ce,ge).compare(new V(fe,ge))}function H(ce,fe,ge){return $(ce,fe,ge)>0}function ee(ce,fe,ge){return $(ce,fe,ge)<0}function K(ce,fe,ge){return $(ce,fe,ge)===0}function Z(ce,fe,ge){return $(ce,fe,ge)!==0}function ie(ce,fe,ge){return $(ce,fe,ge)>=0}function le(ce,fe,ge){return $(ce,fe,ge)<=0}function he(ce,fe,ge,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=K(ce,ge,Ie);break;case"!=":Pe=Z(ce,ge,Ie);break;case">":Pe=H(ce,ge,Ie);break;case">=":Pe=ie(ce,ge,Ie);break;case"<":Pe=ee(ce,ge,Ie);break;case"<=":Pe=le(ce,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function me(ce,fe){if(ce instanceof me){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,fe);c("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,c("comp",this)}e.rcompareIdentifiers=function(ce,fe){return U(fe,ce)},e.major=function(ce,fe){return new V(ce,fe).major},e.minor=function(ce,fe){return new V(ce,fe).minor},e.patch=function(ce,fe){return new V(ce,fe).patch},e.compare=$,e.compareLoose=function(ce,fe){return $(ce,fe,!0)},e.rcompare=function(ce,fe,ge){return $(fe,ce,ge)},e.sort=function(ce,fe){return ce.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=H,e.lt=ee,e.eq=K,e.neq=Z,e.gte=ie,e.lte=le,e.cmp=he,e.Comparator=me;var pe={};function we(ce,fe){if(ce instanceof we)return ce.loose===fe?ce:new we(ce.raw,fe);if(ce instanceof me)return new we(ce.value,fe);if(!(this instanceof we))return new we(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function ke(ce,fe,ge,Ie,Pe,Fe,Le,Be,Me,Ne,$e,ne,ue){return((fe=Ee(ge)?"":Ee(Ie)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Be=Ee(Me)?"":Ee(Ne)?"<"+(+Me+1)+".0.0":Ee($e)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+$e+"-"+ne:"<="+Be)).trim()}function De(ce,fe){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ce.length;ge++)if(c(ce[ge].semver),ce[ge].semver!==pe&&ce[ge].semver.prerelease.length>0){var Ie=ce[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function qe(ce,fe,ge){try{fe=new we(fe,ge)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,ge,Ie){var Pe,Fe,Le,Be,Me;switch(ce=new V(ce,Ie),fe=new we(fe,Ie),ge){case">":Pe=H,Fe=le,Le=ee,Be=">",Me=">=";break;case"<":Pe=ee,Fe=ie,Le=H,Be="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var $e=fe.set[Ne],ne=null,ue=null;if($e.forEach(function(de){de.semver===pe&&(de=new me(">=0.0.0")),ne=ne||de,ue=ue||de,Pe(de.semver,ne.semver,Ie)?ne=de:Le(de.semver,ue.semver,Ie)&&(ue=de)}),ne.operator===Be||ne.operator===Me||(!ue.operator||ue.operator===Be)&&Fe(ce,ue.semver)||ue.operator===Me&&Le(ce,ue.semver))return!1}return!0}me.prototype.parse=function(ce){var fe=this.loose?R[_]:R[q],ge=ce.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new V(ge[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return c("Comparator.test",ce,this.loose),this.semver===pe||(typeof ce=="string"&&(ce=new V(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,fe){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new we(ce.value,fe),qe(this.value,ge,fe);if(ce.operator==="")return ge=new we(this.value,fe),qe(ce.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Be=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Le||Be||Me},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),c("range",ce,fe);var ge=fe?R[X]:R[M];ce=ce.replace(ge,ke),c("hyphen replace",ce),ce=ce.replace(R[x],"$1$2$3"),c("comparator trim",ce,R[x]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[W],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[_]:R[q],Pe=ce.split(" ").map(function(Fe){return function(Le,Be){return c("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function($e){return function(ne,ue){c("caret",ne,ue);var de=ue?R[B]:R[T];return ne.replace(de,function(Se,ve,Ce,Re,Ae){var Te;return c("caret",ne,Se,ve,Ce,Re,Ae),Ee(ve)?Te="":Ee(Ce)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Re)?Te=ve==="0"?">="+ve+"."+Ce+".0 <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+".0 <"+(+ve+1)+".0.0":Ae?(c("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ce==="0"?">="+ve+"."+Ce+"."+Re+Ae+" <"+ve+"."+Ce+"."+(+Re+1):">="+ve+"."+Ce+"."+Re+Ae+" <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+"."+Re+Ae+" <"+(+ve+1)+".0.0"):(c("no pr"),Te=ve==="0"?Ce==="0"?">="+ve+"."+Ce+"."+Re+" <"+ve+"."+Ce+"."+(+Re+1):">="+ve+"."+Ce+"."+Re+" <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+"."+Re+" <"+(+ve+1)+".0.0"),c("caret return",Te),Te})}($e,Ne)}).join(" ")}(Le,Be),c("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function($e){return function(ne,ue){var de=ue?R[G]:R[z];return ne.replace(de,function(Se,ve,Ce,Re,Ae){var Te;return c("tilde",ne,Se,ve,Ce,Re,Ae),Ee(ve)?Te="":Ee(Ce)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Re)?Te=">="+ve+"."+Ce+".0 <"+ve+"."+(+Ce+1)+".0":Ae?(c("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ce+"."+Re+Ae+" <"+ve+"."+(+Ce+1)+".0"):Te=">="+ve+"."+Ce+"."+Re+" <"+ve+"."+(+Ce+1)+".0",c("tilde return",Te),Te})}($e,Ne)}).join(" ")}(Le,Be),c("tildes",Le),Le=function(Me,Ne){return c("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function($e){return function(ne,ue){ne=ne.trim();var de=ue?R[b]:R[y];return ne.replace(de,function(Se,ve,Ce,Re,Ae,Te){c("xRange",ne,Se,ve,Ce,Re,Ae,Te);var Ue=Ee(Ce),je=Ue||Ee(Re),ze=je||Ee(Ae);return ve==="="&&ze&&(ve=""),Ue?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(je&&(Re=0),ze&&(Ae=0),ve===">"?(ve=">=",je?(Ce=+Ce+1,Re=0,Ae=0):ze&&(Re=+Re+1,Ae=0)):ve==="<="&&(ve="<",je?Ce=+Ce+1:Re=+Re+1),Se=ve+Ce+"."+Re+"."+Ae):je?Se=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ze&&(Se=">="+Ce+"."+Re+".0 <"+Ce+"."+(+Re+1)+".0"),c("xRange return",Se),Se})}($e,Ne)}).join(" ")}(Le,Be),c("xrange",Le),Le=function(Me,Ne){return c("replaceStars",Me,Ne),Me.trim().replace(R[Q],"")}(Le,Be),c("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new me(Fe,fe)})},we.prototype.intersects=function(ce,fe){if(!(ce instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new we(ce,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new V(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(De(this.set[fe],ce))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new we(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new V(Ie=Le,ge)))}),Ie},e.minSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new we(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new V(Ie=Le,ge)))}),Ie},e.validRange=function(ce,fe){try{return new we(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,ge){return Ye(ce,fe,"<",ge)},e.gtr=function(ce,fe,ge){return Ye(ce,fe,">",ge)},e.outside=Ye,e.prerelease=function(ce,fe){var ge=ae(ce,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,fe,ge){return ce=new we(ce,ge),fe=new we(fe,ge),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof V)return ce;if(typeof ce!="string")return null;var fe=ce.match(R[O]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(te,e){var L,A,c=te.exports={};function k(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(h){if(L===setTimeout)return setTimeout(h,0);if((L===k||!L)&&setTimeout)return L=setTimeout,setTimeout(h,0);try{return L(h,0)}catch{try{return L.call(null,h,0)}catch{return L.call(this,h,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:k}catch{L=k}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var C,S=[],I=!1,w=-1;function g(){I&&C&&(I=!1,C.length?S=C.concat(S):w=-1,S.length&&f())}function f(){if(!I){var h=R(g);I=!0;for(var u=S.length;u;){for(C=S,S=[];++w<u;)C&&C[w].run();w=-1,u=S.length}C=null,I=!1,function(m){if(A===clearTimeout)return clearTimeout(m);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(m);try{A(m)}catch{try{return A.call(null,m)}catch{return A.call(this,m)}}}(h)}}function d(h,u){this.fun=h,this.array=u}function v(){}c.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];S.push(new d(h,u)),S.length!==1||I||R(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=v,c.addListener=v,c.once=v,c.off=v,c.removeListener=v,c.removeAllListeners=v,c.emit=v,c.prependListener=v,c.prependOnceListener=v,c.listeners=function(h){return[]},c.binding=function(h){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(h){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}}])}),define(re[131],oe([0,1]),function(te,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(R,C,S){this.level=R,this.key=C,this.value=S,this.forward=[]}}const c=void 0;class k{constructor(R,C=2**16){this.comparator=R,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new A(this.c,c,c)}get size(){return this.f}clear(){this.e=new A(this.c,c,c)}has(R){return Boolean(k.g(this,R,this.comparator))}get(R){return k.g(this,R,this.comparator)?.value}set(R,C){return k.h(this,R,C,this.comparator)&&(this.f+=1),this}delete(R){const C=k.k(this,R,this.comparator);return C&&(this.f-=1),C}forEach(R,C){let S=this.e.forward[0];for(;S;)R.call(C,S.value,S.key,this),S=S.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this.e.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static g(R,C,S){let I=R.e;for(let w=R.d-1;w>=0;w--)for(;I.forward[w]&&S(I.forward[w].key,C)<0;)I=I.forward[w];if(I=I.forward[0],I&&S(I.key,C)===0)return I}static h(R,C,S,I){const w=[];let g=R.e;for(let f=R.d-1;f>=0;f--){for(;g.forward[f]&&I(g.forward[f].key,C)<0;)g=g.forward[f];w[f]=g}if(g=g.forward[0],g&&I(g.key,C)===0)return g.value=S,!1;{const f=k.j(R);if(f>R.d){for(let d=R.d;d<f;d++)w[d]=R.e;R.d=f}g=new A(f,C,S);for(let d=0;d<f;d++)g.forward[d]=w[d].forward[d],w[d].forward[d]=g;return!0}}static j(R,C=.5){let S=1;for(;Math.random()<C&&S<R.c;)S+=1;return S}static k(R,C,S){const I=[];let w=R.e;for(let g=R.d-1;g>=0;g--){for(;w.forward[g]&&S(w.forward[g].key,C)<0;)w=w.forward[g];I[g]=w}if(w=w.forward[0],!w||S(w.key,C)!==0)return!1;for(let g=0;g<R.d&&I[g].forward[g]===w;g++)I[g].forward[g]=w.forward[g];for(;R.d>0&&R.e.forward[R.d-1]===c;)R.d-=1;return!0}}e.SkipList=k}),define(re[43],oe([0,1,8,2]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function c(E){const P=E;return P?typeof P.read=="function":!1}e.isReadable=c;function k(E){const P=E;return P?[P.on,P.pause,P.resume,P.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=k;function D(E){const P=E;return P?k(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.isReadableBufferedStream=D;function R(E,P){return new C(E,P)}e.newWriteableStream=R;class C{constructor(P,i){this.e=P,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(i=>i(P))}h(P){this.c.error.length===0?(0,L.onUnexpectedError)(P):this.c.error.slice(0).forEach(i=>i(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,i){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(P,i){if(this.a.destroyed)return;let o;switch(P){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(i);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(E,P){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return P(i)}e.consumeReadable=S;function I(E,P,i){const o=[];let t;for(;(t=E.read())!==null&&o.length<i;)o.push(t);return t===null&&o.length>0?P(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return E.read()}}}e.peekReadable=I;function w(E,P){return new Promise((i,o)=>{const t=[];g(E,{onData:n=>{P&&t.push(n)},onError:n=>{P?o(n):i(void 0)},onEnd:()=>{i(P?P(t):void 0)}})})}e.consumeStream=w;function g(E,P){let i=!1;return E.on("error",o=>{i||P.onError(o)}),E.on("end",()=>{i||P.onEnd()}),E.on("data",o=>{i||P.onData(o)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=g;function f(E,P){return new Promise((i,o)=>{const t=new A.DisposableStore,n=[],s=l=>{if(n.push(l),n.length>P)return t.dispose(),E.pause(),i({stream:E,buffer:n,ended:!1})},a=l=>o(l),r=()=>i({stream:E,buffer:n,ended:!0});t.add((0,A.toDisposable)(()=>E.removeListener("error",a))),E.on("error",a),t.add((0,A.toDisposable)(()=>E.removeListener("end",r))),E.on("end",r),t.add((0,A.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}e.peekStream=f;function d(E,P){const i=R(P);return i.end(E),i}e.toStream=d;function v(){const E=R(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=v;function h(E){let P=!1;return{read:()=>P?null:(P=!0,E)}}e.toReadable=h;function u(E,P,i){const o=R(i);return g(E,{onData:t=>o.write(P.data(t)),onError:t=>o.error(P.error?P.error(t):t),onEnd:()=>o.end()}),o}e.transform=u;function m(E,P,i){let o=!1;return{read:()=>{const t=P.read();return o?t:(o=!0,t!==null?i([E,t]):E)}}}e.prefixedReadable=m;function p(E,P,i){let o=!1;const t=R(i);return g(P,{onData:n=>o?t.write(n):(o=!0,t.write(i([E,n]))),onError:n=>t.error(n),onEnd:()=>{o||(o=!0,t.write(E)),t.end()}}),t}e.prefixedStream=p}),define(re[16],oe([0,1,43]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let c,k;class D{static alloc(l){return A?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return A&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,y){return!(y?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(l)):(c||(c=new TextEncoder),new D(c.encode(l)))}static fromByteArray(l){const y=D.alloc(l.length);for(let b=0,O=l.length;b<O;b++)y.buffer[b]=l[b];return y}static concat(l,y){if(typeof y>"u"){y=0;for(let N=0,F=l.length;N<F;N++)y+=l[N].byteLength}const b=D.alloc(y);let O=0;for(let N=0,F=l.length;N<F;N++){const z=l[N];b.set(z,O),O+=z.byteLength}return b}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return A?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(l,y){return new D(this.buffer.subarray(l,y))}set(l,y){if(l instanceof D)this.buffer.set(l.buffer,y);else if(l instanceof Uint8Array)this.buffer.set(l,y);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),y);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return S(this.buffer,l)}writeUInt32BE(l,y){I(this.buffer,l,y)}readUInt32LE(l){return w(this.buffer,l)}writeUInt32LE(l,y){g(this.buffer,l,y)}readUInt8(l){return f(this.buffer,l)}writeUInt8(l,y){d(this.buffer,l,y)}}e.VSBuffer=D;function R(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=R;function C(r,l,y){r[y+0]=l&255,l=l>>>8,r[y+1]=l&255}e.writeUInt16LE=C;function S(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=S;function I(r,l,y){r[y+3]=l,l=l>>>8,r[y+2]=l,l=l>>>8,r[y+1]=l,l=l>>>8,r[y]=l}e.writeUInt32BE=I;function w(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=w;function g(r,l,y){r[y+0]=l&255,l=l>>>8,r[y+1]=l&255,l=l>>>8,r[y+2]=l&255,l=l>>>8,r[y+3]=l&255}e.writeUInt32LE=g;function f(r,l){return r[l]}e.readUInt8=f;function d(r,l,y){r[y]=l}e.writeUInt8=d;function v(r){return L.consumeReadable(r,l=>D.concat(l))}e.readableToBuffer=v;function h(r){return L.toReadable(r)}e.bufferToReadable=h;function u(r){return L.consumeStream(r,l=>D.concat(l))}e.streamToBuffer=u;async function m(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=m;function p(r){return L.toStream(r,l=>D.concat(l))}e.bufferToStream=p;function E(r){return L.transform(r,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=E;function P(r){return L.newWriteableStream(l=>D.concat(l),r)}e.newWriteableBufferStream=P;function i(r,l){return L.prefixedReadable(r,l,y=>D.concat(y))}e.prefixedBufferReadable=i;function o(r,l){return L.prefixedStream(r,l,y=>D.concat(y))}e.prefixedBufferStream=o;function t(r){let l=0,y=0,b=0;const O=new Uint8Array(Math.floor(r.length/4*3)),N=z=>{switch(y){case 3:O[b++]=l|z,y=0;break;case 2:O[b++]=l|z>>>2,l=z<<6,y=3;break;case 1:O[b++]=l|z>>>4,l=z<<4,y=2;break;default:l=z<<2,y=1}};for(let z=0;z<r.length;z++){const G=r.charCodeAt(z);if(G>=65&&G<=90)N(G-65);else if(G>=97&&G<=122)N(G-97+26);else if(G>=48&&G<=57)N(G-48+52);else if(G===43||G===45)N(62);else if(G===47||G===95)N(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${r[z]}`)}}const F=b;for(;y>0;)N(0);return D.wrap(O).slice(0,F)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:r},l=!0,y=!1){const b=y?s:n;let O="";const N=r.byteLength%3;let F=0;for(;F<r.byteLength-N;F+=3){const z=r[F+0],G=r[F+1],Y=r[F+2];O+=b[z>>>2],O+=b[(z<<4|G>>>4)&63],O+=b[(G<<2|Y>>>6)&63],O+=b[Y&63]}if(N===1){const z=r[F+0];O+=b[z>>>2],O+=b[z<<4&63],l&&(O+="==")}else if(N===2){const z=r[F+0],G=r[F+1];O+=b[z>>>2],O+=b[(z<<4|G>>>4)&63],O+=b[G<<2&63],l&&(O+="=")}return O}e.encodeBase64=a}),define(re[132],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(re[12],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function A(o){return Array.isArray(o)&&o.every(t=>L(t))}e.isStringArray=A;function c(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=c;function k(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=k;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=R;function C(o){return o===!0||o===!1}e.isBoolean=C;function S(o){return typeof o>"u"}e.isUndefined=S;function I(o){return!w(o)}e.isDefined=I;function w(o){return S(o)||o===null}e.isUndefinedOrNull=w;function g(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function f(o){if(w(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function d(...o){const t=[];for(let n=0;n<o.length;n++){const s=o[n];if(w(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function h(o){if(!c(o))return!1;for(const t in o)if(v.call(o,t))return!1;return!0}e.isEmptyObject=h;function u(o){return typeof o=="function"}e.isFunction=u;function m(...o){return o.length>0&&o.every(u)}e.areFunctions=m;function p(o,t){const n=Math.min(o.length,t.length);for(let s=0;s<n;s++)E(o[s],t[s])}e.validateConstraints=p;function E(o,t){if(L(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(o instanceof t)return}catch{}if(!w(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function P(o){return o===null?void 0:o}e.withNullAsUndefined=P;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(re[52],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function c(R,C){if((0,L.isString)(C)){const S=A[C];if(S===void 0)throw new Error(`${R} references an unknown codicon: ${C}`);C=S}return A[R]=C,{id:R}}function k(){return A}e.getCodiconFontCharacters=k;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),bracket:c("bracket",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(re[32],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([p,E])=>{m[p]=E&&typeof E=="object"?A(E):E}),m}e.deepClone=A;function c(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const E in p)if(k.call(p,E)){const P=p[E];typeof P=="object"&&!Object.isFrozen(P)&&!(0,L.isTypedArray)(P)&&m.push(P)}}return u}e.deepFreeze=c;const k=Object.prototype.hasOwnProperty;function D(u,m){return R(u,m,new Set)}e.cloneAndChange=D;function R(u,m,p){if((0,L.isUndefinedOrNull)(u))return u;const E=m(u);if(typeof E<"u")return E;if(Array.isArray(u)){const P=[];for(const i of u)P.push(R(i,m,p));return P}if((0,L.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const P={};for(const i in u)k.call(u,i)&&(P[i]=R(u[i],m,p));return p.delete(u),P}return u}function C(u,m,p=!0){return(0,L.isObject)(u)?((0,L.isObject)(m)&&Object.keys(m).forEach(E=>{E in u?p&&((0,L.isObject)(u[E])&&(0,L.isObject)(m[E])?C(u[E],m[E],p):u[E]=m[E]):u[E]=m[E]}),u):m}e.mixin=C;function S(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let p,E;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(p=0;p<u.length;p++)if(!S(u[p],m[p]))return!1}else{const P=[];for(E in u)P.push(E);P.sort();const i=[];for(E in m)i.push(E);if(i.sort(),!S(P,i))return!1;for(p=0;p<P.length;p++)if(!S(u[P[p]],m[P[p]]))return!1}return!0}e.equals=S;function I(u){const m=new Set;return JSON.stringify(u,(p,E)=>{if((0,L.isObject)(E)||Array.isArray(E)){if(m.has(E))return"[Circular]";m.add(E)}return E})}e.safeStringify=I;function w(u,m){const p=Object.create(null);return!u||!m||Object.keys(m).forEach(P=>{const i=u[P],o=m[P];S(i,o)||(p[P]=o)}),p}e.distinct=w;function g(u,m){const p=m.toLowerCase(),E=Object.keys(u).find(P=>P.toLowerCase()===p);return E?u[E]:u[m]}e.getCaseInsensitive=g;function f(u,m){const p=Object.create(null);for(const[E,P]of Object.entries(u))m(E,P)&&(p[E]=P);return p}e.filter=f;function d(u){let m=[],p=Object.getPrototypeOf(u);for(;Object.prototype!==p;)m=m.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return m}e.getAllPropertyNames=d;function v(u){const m=[];for(const p of d(u))typeof u[p]=="function"&&m.push(p);return m}e.getAllMethodNames=v;function h(u,m){const p=P=>function(){const i=Array.prototype.slice.call(arguments,0);return m(P,i)},E={};for(const P of u)E[P]=p(P);return E}e.createProxyObject=h}),define(re[133],oe([0,1,52]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function R(C){return C&&typeof C=="object"&&typeof C.id=="string"}D.isThemeColor=R})(A=e.ThemeColor||(e.ThemeColor={}));function c(D){return{id:D}}e.themeColorFromId=c;var k;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function C(m){const p=R.exec(m.id);if(!p)return C(L.Codicon.error);const[,E,P]=p,i=["codicon","codicon-"+E];return P&&i.push("codicon-modifier-"+P.substring(1)),i}D.asClassNameArray=C;function S(m){return C(m).join(" ")}D.asClassName=S;function I(m){return"."+C(m).join(".")}D.asCSSSelector=I;function w(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||A.isThemeColor(m.color))}D.isThemeIcon=w;const g=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(m){const p=g.exec(m);if(!p)return;const[,E]=p;return{id:E}}D.fromString=f;function d(m){return{id:m}}D.fromId=d;function v(m,p){let E=m.id;const P=E.lastIndexOf("~");return P!==-1&&(E=E.substring(0,P)),p&&(E=`${E}~${p}`),{id:E}}D.modify=v;function h(m){const p=m.id.lastIndexOf("~");if(p!==-1)return m.id.substring(p+1)}D.getModifier=h;function u(m,p){return m.id===p.id&&m.color?.id===p.color?.id}D.isEqual=u})(k=e.ThemeIcon||(e.ThemeIcon={}))}),define(re[31],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(c){return L.test(c)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let c;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?c=crypto.getRandomValues.bind(crypto):c=function(R){for(let C=0;C<R.length;C++)R[C]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),D=[];for(let R=0;R<256;R++)D.push(R.toString(16).padStart(2,"0"));return function(){c(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let C=0,S="";return S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S+="-",S+=D[k[C++]],S+=D[k[C++]],S+="-",S+=D[k[C++]],S+=D[k[C++]],S+="-",S+=D[k[C++]],S+=D[k[C++]],S+="-",S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S+=D[k[C++]],S}}()}),define(re[134],oe([0,1,34]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function c(D){const R=D.replace(/\-/g,":").toLowerCase();return!A.has(R)}function k(){const D=(0,L.networkInterfaces)();for(const R in D){const C=D[R];if(C){for(const{mac:S}of C)if(c(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(re[135],oe([0,1,85]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(R,C,S,I=1){let w=!1;return new Promise(g=>{const f=setTimeout(()=>{if(!w)return w=!0,g(0)},S);c(R,C,I,d=>{if(!w)return w=!0,clearTimeout(f),g(d)})})}e.findFreePort=A;function c(R,C,S,I){if(C===0)return I(0);const w=new L.Socket;w.once("connect",()=>(D(w),c(R+S,C-1,S,I))),w.once("data",()=>{}),w.once("error",g=>(D(w),g.code!=="ECONNREFUSED"?c(R+S,C-1,S,I):I(R))),w.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,C,S,I="127.0.0.1"){let w=!1,g,f=1;const d=L.createServer({pauseOnConnect:!0});function v(h,u){w||(w=!0,d.removeAllListeners(),d.close(),g&&clearTimeout(g),u(h))}return new Promise(h=>{g=setTimeout(()=>{v(0,h)},S),d.on("listening",()=>{v(R,h)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<C?(R++,f++,d.listen(R,I)):v(0,h)}),d.on("close",()=>{v(0,h)}),d.listen(R,I)})}e.findFreePortFaster=k;function D(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(re[86],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(A){return!!A.parentPort}e.isUtilityProcess=L}),define(re[136],oe([9,7]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[63],oe([0,1,136]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,c=A*60,k=c*24,D=k*7,R=k*30,C=k*365;function S(w,g,f,d){typeof w!="number"&&(w=w.getTime());const v=Math.round((new Date().getTime()-w)/1e3);if(v<-30)return(0,L.localize)(0,null,S(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,L.localize)(1,null);let h;return v<A?(h=v,g?h===1?f?(0,L.localize)(2,null,h):(0,L.localize)(3,null,h):f?(0,L.localize)(4,null,h):(0,L.localize)(5,null,h):h===1?f?(0,L.localize)(6,null,h):(0,L.localize)(7,null,h):f?(0,L.localize)(8,null,h):(0,L.localize)(9,null,h)):v<c?(h=Math.floor(v/A),g?h===1?f?(0,L.localize)(10,null,h):(0,L.localize)(11,null,h):f?(0,L.localize)(12,null,h):(0,L.localize)(13,null,h):h===1?f?(0,L.localize)(14,null,h):(0,L.localize)(15,null,h):f?(0,L.localize)(16,null,h):(0,L.localize)(17,null,h)):v<k?(h=Math.floor(v/c),g?h===1?f?(0,L.localize)(18,null,h):(0,L.localize)(19,null,h):f?(0,L.localize)(20,null,h):(0,L.localize)(21,null,h):h===1?f?(0,L.localize)(22,null,h):(0,L.localize)(23,null,h):f?(0,L.localize)(24,null,h):(0,L.localize)(25,null,h)):v<D?(h=Math.floor(v/k),g?h===1?(0,L.localize)(26,null,h):(0,L.localize)(27,null,h):h===1?(0,L.localize)(28,null,h):(0,L.localize)(29,null,h)):v<R?(h=Math.floor(v/D),g?h===1?f?(0,L.localize)(30,null,h):(0,L.localize)(31,null,h):f?(0,L.localize)(32,null,h):(0,L.localize)(33,null,h):h===1?f?(0,L.localize)(34,null,h):(0,L.localize)(35,null,h):f?(0,L.localize)(36,null,h):(0,L.localize)(37,null,h)):v<C?(h=Math.floor(v/R),g?h===1?f?(0,L.localize)(38,null,h):(0,L.localize)(39,null,h):f?(0,L.localize)(40,null,h):(0,L.localize)(41,null,h):h===1?f?(0,L.localize)(42,null,h):(0,L.localize)(43,null,h):f?(0,L.localize)(44,null,h):(0,L.localize)(45,null,h)):(h=Math.floor(v/C),g?h===1?f?(0,L.localize)(46,null,h):(0,L.localize)(47,null,h):f?(0,L.localize)(48,null,h):(0,L.localize)(49,null,h):h===1?f?(0,L.localize)(50,null,h):(0,L.localize)(51,null,h):f?(0,L.localize)(52,null,h):(0,L.localize)(53,null,h))}e.fromNow=S;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(re[137],oe([9,7]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,21,12,137]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(w,g){return g&&(w.stack||w.stacktrace)?c.localize(0,null,R(w),D(w.stack)||D(w.stacktrace)):R(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?c.localize(1,null,w.message):w.message||c.localize(2,null)}function C(w=null,g=!1){if(!w)return c.localize(3,null);if(Array.isArray(w)){const f=L.coalesce(w),d=C(f[0],g);return f.length>1?c.localize(4,null,d,f.length):d}if(A.isString(w))return w;if(w.detail){const f=w.detail;if(f.error)return k(f.error,g);if(f.exception)return k(f.exception,g)}return w.stack?k(w,g):w.message?w.message:c.localize(5,null)}e.toErrorMessage=C;function S(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=S;function I(w,g){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=g,f}e.createErrorWithActions=I}),define(re[138],oe([9,7]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[139],oe([0,1,138]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(c){switch(c){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(re[140],oe([9,7]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,140]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,c=!1,k=!1,D=!1,R=!1,C=!1,S=!1,I=!1,w=!1,g=!1,f,d=e.LANGUAGE_DEFAULT,v,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",p=m&&u?.type==="renderer";if(typeof navigator=="object"&&!p)h=navigator.userAgent,A=h.indexOf("Windows")>=0,c=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=h.indexOf("Linux")>=0,g=h?.indexOf("Mobi")>=0,C=!0,f=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,d=f;else if(typeof u=="object"){A=u.platform==="win32",c=u.platform==="darwin",k=u.platform==="linux",D=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=m,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),y=l.availableLanguages["*"];f=l.locale,d=y||e.LANGUAGE_DEFAULT,v=l._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var E;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let i=0;c?i=1:A?i=3:k&&(i=2),e.isWindows=A,e.isMacintosh=c,e.isLinux=k,e.isLinuxSnap=D,e.isNative=R,e.isElectron=S,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=g,e.isCI=w,e.platform=i,e.userAgent=h,e.language=d;var o;(function(r){function l(){return e.language}r.value=l;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=y;function b(){return e.language==="en"}r.isDefault=b})(o=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let b=0,O=r.length;b<O;b++){const N=r[b];if(N.id===y.data.vscodeScheduleAsyncWork){r.splice(b,1),N.callback();return}}});let l=0;return y=>{const b=++l;r.push({id:b,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return r=>setTimeout(r)})();var t;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=c||I?2:A?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,n=new Uint16Array(r.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const c=L.globals.vscode.process;A={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(re[13],oe([0,1,36]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,c=97,k=90,D=122,R=46,C=47,S=92,I=58,w=63;class g extends Error{constructor(o,t,n){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const a=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${a} ${s} of type ${t}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new g(o,"Object",i)}function d(i,o){if(typeof i!="string")throw new g(o,"string",i)}const v=L.platform==="win32";function h(i){return i===C||i===S}function u(i){return i===C}function m(i){return i>=A&&i<=k||i>=c&&i<=D}function p(i,o,t,n){let s="",a=0,r=-1,l=0,y=0;for(let b=0;b<=i.length;++b){if(b<i.length)y=i.charCodeAt(b);else{if(n(y))break;y=C}if(n(y)){if(!(r===b-1||l===1))if(l===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const O=s.lastIndexOf(t);O===-1?(s="",a=0):(s=s.slice(0,O),a=s.length-1-s.lastIndexOf(t)),r=b,l=0;continue}else if(s.length!==0){s="",a=0,r=b,l=0;continue}}o&&(s+=s.length>0?`${t}..`:"..",a=2)}else s.length>0?s+=`${t}${i.slice(r+1,b)}`:s=i.slice(r+1,b),a=b-r-1;r=b,l=0}else y===R&&l!==-1?++l:l=-1}return s}function E(i,o){f(o,"pathObject");const t=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return t?t===o.root?`${t}${n}`:`${t}${i}${n}`:n}e.win32={resolve(...i){let o="",t="",n=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],d(a,"path"),a.length===0)continue}else o.length===0?a=L.cwd():(a=L.env[`=${o}`]||L.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===S)&&(a=`${o}\\`));const r=a.length;let l=0,y="",b=!1;const O=a.charCodeAt(0);if(r===1)h(O)&&(l=1,b=!0);else if(h(O))if(b=!0,h(a.charCodeAt(1))){let N=2,F=N;for(;N<r&&!h(a.charCodeAt(N));)N++;if(N<r&&N!==F){const z=a.slice(F,N);for(F=N;N<r&&h(a.charCodeAt(N));)N++;if(N<r&&N!==F){for(F=N;N<r&&!h(a.charCodeAt(N));)N++;(N===r||N!==F)&&(y=`\\\\${z}\\${a.slice(F,N)}`,l=N)}}}else l=1;else m(O)&&a.charCodeAt(1)===I&&(y=a.slice(0,2),l=2,r>2&&h(a.charCodeAt(2))&&(b=!0,l=3));if(y.length>0)if(o.length>0){if(y.toLowerCase()!==o.toLowerCase())continue}else o=y;if(n){if(o.length>0)break}else if(t=`${a.slice(l)}\\${t}`,n=b,b&&o.length>0)break}return t=p(t,!n,"\\",h),n?`${o}\\${t}`:`${o}${t}`||"."},normalize(i){d(i,"path");const o=i.length;if(o===0)return".";let t=0,n,s=!1;const a=i.charCodeAt(0);if(o===1)return u(a)?"\\":i;if(h(a))if(s=!0,h(i.charCodeAt(1))){let l=2,y=l;for(;l<o&&!h(i.charCodeAt(l));)l++;if(l<o&&l!==y){const b=i.slice(y,l);for(y=l;l<o&&h(i.charCodeAt(l));)l++;if(l<o&&l!==y){for(y=l;l<o&&!h(i.charCodeAt(l));)l++;if(l===o)return`\\\\${b}\\${i.slice(y)}\\`;l!==y&&(n=`\\\\${b}\\${i.slice(y,l)}`,t=l)}}}else t=1;else m(a)&&i.charCodeAt(1)===I&&(n=i.slice(0,2),t=2,o>2&&h(i.charCodeAt(2))&&(s=!0,t=3));let r=t<o?p(i.slice(t),!s,"\\",h):"";return r.length===0&&!s&&(r="."),r.length>0&&h(i.charCodeAt(o-1))&&(r+="\\"),n===void 0?s?`\\${r}`:r:s?`${n}\\${r}`:`${n}${r}`},isAbsolute(i){d(i,"path");const o=i.length;if(o===0)return!1;const t=i.charCodeAt(0);return h(t)||o>2&&m(t)&&i.charCodeAt(1)===I&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,t;for(let a=0;a<i.length;++a){const r=i[a];d(r,"path"),r.length>0&&(o===void 0?o=t=r:o+=`\\${r}`)}if(o===void 0)return".";let n=!0,s=0;if(typeof t=="string"&&h(t.charCodeAt(0))){++s;const a=t.length;a>1&&h(t.charCodeAt(1))&&(++s,a>2&&(h(t.charCodeAt(2))?++s:n=!1))}if(n){for(;s<o.length&&h(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(i,o){if(d(i,"from"),d(o,"to"),i===o)return"";const t=e.win32.resolve(i),n=e.win32.resolve(o);if(t===n||(i=t.toLowerCase(),o=n.toLowerCase(),i===o))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===S;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===S;)a--;const r=a-s;let l=0;for(;l<o.length&&o.charCodeAt(l)===S;)l++;let y=o.length;for(;y-1>l&&o.charCodeAt(y-1)===S;)y--;const b=y-l,O=r<b?r:b;let N=-1,F=0;for(;F<O;F++){const G=i.charCodeAt(s+F);if(G!==o.charCodeAt(l+F))break;G===S&&(N=F)}if(F!==O){if(N===-1)return n}else{if(b>O){if(o.charCodeAt(l+F)===S)return n.slice(l+F+1);if(F===2)return n.slice(l+F)}r>O&&(i.charCodeAt(s+F)===S?N=F:F===2&&(N=3)),N===-1&&(N=0)}let z="";for(F=s+N+1;F<=a;++F)(F===a||i.charCodeAt(F)===S)&&(z+=z.length===0?"..":"\\..");return l+=N,z.length>0?`${z}${n.slice(l,y)}`:(n.charCodeAt(l)===S&&++l,n.slice(l,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const t=o.charCodeAt(2);if(t!==w&&t!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(m(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return i},dirname(i){d(i,"path");const o=i.length;if(o===0)return".";let t=-1,n=0;const s=i.charCodeAt(0);if(o===1)return h(s)?i:".";if(h(s)){if(t=n=1,h(i.charCodeAt(1))){let l=2,y=l;for(;l<o&&!h(i.charCodeAt(l));)l++;if(l<o&&l!==y){for(y=l;l<o&&h(i.charCodeAt(l));)l++;if(l<o&&l!==y){for(y=l;l<o&&!h(i.charCodeAt(l));)l++;if(l===o)return i;l!==y&&(t=n=l+1)}}}}else m(s)&&i.charCodeAt(1)===I&&(t=o>2&&h(i.charCodeAt(2))?3:2,n=t);let a=-1,r=!0;for(let l=o-1;l>=n;--l)if(h(i.charCodeAt(l))){if(!r){a=l;break}}else r=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,o){o!==void 0&&d(o,"ext"),d(i,"path");let t=0,n=-1,s=!0,a;if(i.length>=2&&m(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let r=o.length-1,l=-1;for(a=i.length-1;a>=t;--a){const y=i.charCodeAt(a);if(h(y)){if(!s){t=a+1;break}}else l===-1&&(s=!1,l=a+1),r>=0&&(y===o.charCodeAt(r)?--r===-1&&(n=a):(r=-1,n=l))}return t===n?n=l:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(h(i.charCodeAt(a))){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let o=0,t=-1,n=0,s=-1,a=!0,r=0;i.length>=2&&i.charCodeAt(1)===I&&m(i.charCodeAt(0))&&(o=n=2);for(let l=i.length-1;l>=o;--l){const y=i.charCodeAt(l);if(h(y)){if(!a){n=l+1;break}continue}s===-1&&(a=!1,s=l+1),y===R?t===-1?t=l:r!==1&&(r=1):t!==-1&&(r=-1)}return t===-1||s===-1||r===0||r===1&&t===s-1&&t===n+1?"":i.slice(t,s)},format:E.bind(null,"\\"),parse(i){d(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const t=i.length;let n=0,s=i.charCodeAt(0);if(t===1)return h(s)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(h(s)){if(n=1,h(i.charCodeAt(1))){let N=2,F=N;for(;N<t&&!h(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&h(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&!h(i.charCodeAt(N));)N++;N===t?n=N:N!==F&&(n=N+1)}}}}else if(m(s)&&i.charCodeAt(1)===I){if(t<=2)return o.root=o.dir=i,o;if(n=2,h(i.charCodeAt(2))){if(t===3)return o.root=o.dir=i,o;n=3}}n>0&&(o.root=i.slice(0,n));let a=-1,r=n,l=-1,y=!0,b=i.length-1,O=0;for(;b>=n;--b){if(s=i.charCodeAt(b),h(s)){if(!y){r=b+1;break}continue}l===-1&&(y=!1,l=b+1),s===R?a===-1?a=b:O!==1&&(O=1):a!==-1&&(O=-1)}return l!==-1&&(a===-1||O===0||O===1&&a===l-1&&a===r+1?o.base=o.name=i.slice(r,l):(o.name=i.slice(r,a),o.base=i.slice(r,l),o.ext=i.slice(a,l))),r>0&&r!==n?o.dir=i.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const P=(()=>{if(v){const i=/\\/g;return()=>{const o=L.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let o="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const s=n>=0?i[n]:P();d(s,"path"),s.length!==0&&(o=`${s}/${o}`,t=s.charCodeAt(0)===C)}return o=p(o,!t,"/",u),t?`/${o}`:o.length>0?o:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C,t=i.charCodeAt(i.length-1)===C;return i=p(i,!o,"/",u),i.length===0?o?"/":t?"./":".":(t&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===C},join(...i){if(i.length===0)return".";let o;for(let t=0;t<i.length;++t){const n=i[t];d(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(d(i,"from"),d(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const t=1,n=i.length,s=n-t,a=1,r=o.length-a,l=s<r?s:r;let y=-1,b=0;for(;b<l;b++){const N=i.charCodeAt(t+b);if(N!==o.charCodeAt(a+b))break;N===C&&(y=b)}if(b===l)if(r>l){if(o.charCodeAt(a+b)===C)return o.slice(a+b+1);if(b===0)return o.slice(a+b)}else s>l&&(i.charCodeAt(t+b)===C?y=b:b===0&&(y=0));let O="";for(b=t+y+1;b<=n;++b)(b===n||i.charCodeAt(b)===C)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(a+y)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C;let t=-1,n=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===C){if(!n){t=s;break}}else n=!1;return t===-1?o?"/":".":o&&t===1?"//":i.slice(0,t)},basename(i,o){o!==void 0&&d(o,"ext"),d(i,"path");let t=0,n=-1,s=!0,a;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let r=o.length-1,l=-1;for(a=i.length-1;a>=0;--a){const y=i.charCodeAt(a);if(y===C){if(!s){t=a+1;break}}else l===-1&&(s=!1,l=a+1),r>=0&&(y===o.charCodeAt(r)?--r===-1&&(n=a):(r=-1,n=l))}return t===n?n=l:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===C){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let o=-1,t=0,n=-1,s=!0,a=0;for(let r=i.length-1;r>=0;--r){const l=i.charCodeAt(r);if(l===C){if(!s){t=r+1;break}continue}n===-1&&(s=!1,n=r+1),l===R?o===-1?o=r:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||n===-1||a===0||a===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:E.bind(null,"/"),parse(i){d(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const t=i.charCodeAt(0)===C;let n;t?(o.root="/",n=1):n=0;let s=-1,a=0,r=-1,l=!0,y=i.length-1,b=0;for(;y>=n;--y){const O=i.charCodeAt(y);if(O===C){if(!l){a=y+1;break}continue}r===-1&&(l=!1,r=y+1),O===R?s===-1?s=y:b!==1&&(b=1):s!==-1&&(b=-1)}if(r!==-1){const O=a===0&&t?1:a;s===-1||b===0||b===1&&s===r-1&&s===a+1?o.base=o.name=i.slice(O,r):(o.name=i.slice(O,s),o.base=i.slice(O,r),o.ext=i.slice(s,r))}return a>0?o.dir=i.slice(0,a-1):t&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(re[141],oe([0,1,13]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(I){const w=(0,L.extname)(I),g=A[w.toLowerCase()];return g!==void 0?g:D(I)}e.getMediaOrTextMime=k;function D(I){const w=(0,L.extname)(I);return c[w.toLowerCase()]}e.getMediaMime=D;function R(I){for(const w in c)if(c[w]===I)return w}e.getExtensionForMimeType=R;const C=/^(.+)\/(.+?)(;.+)?$/;function S(I,w){const g=C.exec(I);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:I}e.normalizeMimeType=S}),define(re[87],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var c;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(c=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(R,...C){const S=C.reduce((g,f)=>(g[f]=!0,g),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!S[g]).forEach(g=>{for(let f=0;f<I.length;f++)if(g.search(I[f])!==-1){delete R[g];break}})}e.sanitizeProcessEnvironment=k;function D(R){!R||(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(re[88],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=L.globals.performance&&typeof L.globals.performance.now=="function";class c{static create(D=!0){return new c(D)}constructor(D){this.a=A&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=c}),define(re[3],oe([0,1,8,81,2,83,88]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,C=!1;var S;(function(a){a.None=()=>c.Disposable.None;function r($){if(C){const{onDidAddListener:H}=$,ee=d.create();let K=0;$.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),H?.()}}}function l($,H){return W($,()=>{},0,void 0,!0,void 0,H)}a.defer=l;function y($){return(H,ee=null,K)=>{let Z=!1,ie;return ie=$(le=>{if(!Z)return ie?ie.dispose():Z=!0,H.call(ee,le)},null,K),Z&&ie.dispose(),ie}}a.once=y;function b($,H,ee){return Y((K,Z=null,ie)=>$(le=>K.call(Z,H(le)),null,ie),ee)}a.map=b;function O($,H,ee){return Y((K,Z=null,ie)=>$(le=>{H(le),K.call(Z,le)},null,ie),ee)}a.forEach=O;function N($,H,ee){return Y((K,Z=null,ie)=>$(le=>H(le)&&K.call(Z,le),null,ie),ee)}a.filter=N;function F($){return $}a.signal=F;function z(...$){return(H,ee=null,K)=>(0,c.combinedDisposable)(...$.map(Z=>Z(ie=>H.call(ee,ie),null,K)))}a.any=z;function G($,H,ee,K){let Z=ee;return b($,ie=>(Z=H(Z,ie),Z),K)}a.reduce=G;function Y($,H){let ee;const K={onWillAddFirstListener(){ee=$(Z.fire,Z)},onDidRemoveLastListener(){ee?.dispose()}};H||r(K);const Z=new h(K);return H?.add(Z),Z.event}function W($,H,ee=100,K=!1,Z=!1,ie,le){let he,me,pe,we=0,Ee;const ke={leakWarningThreshold:ie,onWillAddFirstListener(){he=$(qe=>{we++,me=H(me,qe),K&&!pe&&(De.fire(me),me=void 0),Ee=()=>{const Ye=me;me=void 0,pe=void 0,(!K||we>1)&&De.fire(Ye),we=0},typeof ee=="number"?(clearTimeout(pe),pe=setTimeout(Ee,ee)):pe===void 0&&(pe=0,queueMicrotask(Ee))})},onWillRemoveListener(){Z&&we>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,he.dispose()}};le||r(ke);const De=new h(ke);return le?.add(De),De.event}a.debounce=W;function T($,H=0,ee){return a.debounce($,(K,Z)=>K?(K.push(Z),K):[Z],H,void 0,!0,void 0,ee)}a.accumulate=T;function B($,H=(K,Z)=>K===Z,ee){let K=!0,Z;return N($,ie=>{const le=K||!H(ie,Z);return K=!1,Z=ie,le},ee)}a.latch=B;function _($,H,ee){return[a.filter($,H,ee),a.filter($,K=>!H(K),ee)]}a.split=_;function q($,H=!1,ee=[]){let K=ee.slice(),Z=$(he=>{K?K.push(he):le.fire(he)});const ie=()=>{K?.forEach(he=>le.fire(he)),K=null},le=new h({onWillAddFirstListener(){Z||(Z=$(he=>le.fire(he)))},onDidAddFirstListener(){K&&(H?setTimeout(ie):ie())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return le.event}a.buffer=q;class x{constructor(H){this.event=H,this.c=new c.DisposableStore}map(H){return new x(b(this.event,H,this.c))}forEach(H){return new x(O(this.event,H,this.c))}filter(H){return new x(N(this.event,H,this.c))}reduce(H,ee){return new x(G(this.event,H,ee,this.c))}latch(){return new x(B(this.event,void 0,this.c))}debounce(H,ee=100,K=!1,Z=!1,ie){return new x(W(this.event,H,ee,K,Z,ie,this.c))}on(H,ee,K){return this.event(H,ee,K)}once(H,ee,K){return y(this.event)(H,ee,K)}dispose(){this.c.dispose()}}function M($){return new x($)}a.chain=M;function X($,H,ee=K=>K){const K=(...he)=>le.fire(ee(...he)),Z=()=>$.on(H,K),ie=()=>$.removeListener(H,K),le=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:ie});return le.event}a.fromNodeEventEmitter=X;function Q($,H,ee=K=>K){const K=(...he)=>le.fire(ee(...he)),Z=()=>$.addEventListener(H,K),ie=()=>$.removeEventListener(H,K),le=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:ie});return le.event}a.fromDOMEventEmitter=Q;function se($){return new Promise(H=>y($)(H))}a.toPromise=se;function ae($,H){return H(void 0),$(ee=>H(ee))}a.runAndSubscribe=ae;function V($,H){let ee=null;function K(ie){ee?.dispose(),ee=new c.DisposableStore,H(ie,ee)}K(void 0);const Z=$(ie=>K(ie));return(0,c.toDisposable)(()=>{Z.dispose(),ee?.dispose()})}a.runAndSubscribeWithStore=V;class j{constructor(H,ee){this.obs=H,this.c=0,this.d=!1;const K={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};ee||r(K),this.emitter=new h(K),ee&&ee.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,ee){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U($,H){return new j($,H).emitter.event}a.fromObservable=U})(S=e.Event||(e.Event={}));class I{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${I.c++}`,I.all.add(this)}start(r){this.d=new D.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}I.all=new Set,I.c=0,e.EventProfiling=I;let w=-1;function g(a){const r=w;return w=a,{dispose(){w=r}}}e.setGlobalLeakWarningThreshold=g;class f{constructor(r,l=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=l,this.d=0}dispose(){this.c?.clear()}check(r,l){const y=this.threshold;if(y<=0||l<y)return;this.c||(this.c=new Map);const b=this.c.get(r.value)||0;if(this.c.set(r.value,b+1),this.d-=1,this.d<=0){this.d=y*.5;let O,N=0;for(const[F,z]of this.c)(!O||N<z)&&(O=F,N=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this.c.get(r.value)||0;this.c.set(r.value,O-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(r,l,y){this.callback=r,this.callbackThis=l,this.stack=y,this.subscription=new c.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class h{constructor(r){this.j=!1,this.d=r,this.f=w>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??w):void 0,this.g=this.d?._profName?new I(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const r=Array.from(this.q);queueMicrotask(()=>{for(const l of r)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,l,y)=>{if(this.q||(this.q=new k.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),c.Disposable.None;const b=this.q.isEmpty();b&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=d.create(),O=this.f.check(N,this.q.size+1)),R&&(N=N??d.create());const F=new v(r,l,N),z=this.q.push(F);b&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,l);const G=F.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return y instanceof c.DisposableStore?y.add(G):Array.isArray(y)&&y.push(G),G}),this.l}fire(r){if(this.q){this.m||(this.m=new m);for(const l of this.q)this.m.push(this,l,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class u{constructor(){this.c=new k.LinkedList}get size(){return this.c.size}push(r,l,y){this.c.push(new p(r,l,y))}clear(r){const l=new k.LinkedList;for(const y of this.c)y.emitter!==r&&l.push(y);this.c=l}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(l){(0,L.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=u;class m extends u{clear(r){this.c.clear()}}class p{constructor(r,l,y){this.emitter=r,this.listener=l,this.event=y}}class E extends h{async fireAsync(r,l,y){if(!!this.q){this.c||(this.c=new k.LinkedList);for(const b of this.q)this.c.push([b,r]);for(;this.c.size>0&&!l.isCancellationRequested;){const[b,O]=this.c.shift(),N=[],F={...O,token:l,waitUntil:z=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");y&&(z=y(z,b.callback)),N.push(z)}};try{b.invoke(F)}catch(z){(0,L.onUnexpectedError)(z);continue}Object.freeze(N),await Promise.allSettled(N).then(z=>{for(const G of z)G.status==="rejected"&&(0,L.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=E;class P extends h{constructor(r){super(r),this.h=0,this.s=new k.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=P;class i extends P{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class o extends h{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(l=>super.fire(l)),this.c=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const l={event:r,listener:null};this.f.push(l),this.d&&this.j(l);const y=()=>{this.d&&this.k(l);const b=this.f.indexOf(l);this.f.splice(b,1)};return(0,c.toDisposable)((0,A.once)(y))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(l=>this.c.fire(l))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.c=[]}wrapEvent(r){return(l,y,b)=>r(O=>{const N=this.c[this.c.length-1];N?N.push(()=>l.call(y,O)):l.call(y,O)},void 0,b)}bufferEvents(r){const l=[];this.c.push(l);const y=r();return this.c.pop(),l.forEach(b=>b()),y}}e.EventBufferer=n;class s{constructor(){this.c=!1,this.d=S.None,this.f=c.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[24],oe([0,1,3]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(R,C){const S=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(S)}}});var c;(function(R){function C(S){return S===R.None||S===R.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(c=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(C){this.a=void 0,this.b=void 0,this.b=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new k),this.a}cancel(){this.a?this.a instanceof k&&this.a.cancel():this.a=c.Cancelled}dispose(C=!1){C&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof k&&this.a.dispose():this.a=c.None}}e.CancellationTokenSource=D}),define(re[142],oe([0,1,24]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new L.CancellationTokenSource,C=this.b(R.token);return this.a={promise:C,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=A;class c{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const C=JSON.stringify(R);return this.b!==C&&(this.b=C,this.a=this.c(R)),this.a}}e.LRUCachedFunction=c;class k{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const C=this.b(R);return this.a.set(R,C),C}}e.CachedFunction=k}),define(re[27],oe([0,1,142,129]),function(te,e,L,A){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=k;const D=/{(\d+)}/g;function R(ne,...ue){return ue.length===0?ne:ne.replace(D,function(de,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=ue.length?de:ue[ve]})}e.format=R;const C=/{([^}]+)}/g;function S(ne,ue){return ne.replace(C,(de,Se)=>ue[Se]??de)}e.format2=S;function I(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function g(ne,ue){let de=0;const Se=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===Se&&de++;return de}e.count=g;function f(ne,ue,de="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${de}`}e.truncate=f;function d(ne,ue=" "){const de=v(ne,ue);return h(de,ue)}e.trim=d;function v(ne,ue){if(!ne||!ue)return ne;const de=ue.length;if(de===0||ne.length===0)return ne;let Se=0;for(;ne.indexOf(ue,Se)===Se;)Se=Se+de;return ne.substring(Se)}e.ltrim=v;function h(ne,ue){if(!ne||!ue)return ne;const de=ue.length,Se=ne.length;if(de===0||Se===0)return ne;let ve=Se,Ce=-1;for(;Ce=ne.lastIndexOf(ue,ve-1),!(Ce===-1||Ce+de!==ve);){if(Ce===0)return"";ve=Ce}return ne.substring(0,ve)}e.rtrim=h;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(ne){return ne.replace(/\*/g,"")}e.stripWildcards=m;function p(ne,ue,de={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=w(ne)),de.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Se="";return de.global&&(Se+="g"),de.matchCase||(Se+="i"),de.multiline&&(Se+="m"),de.unicode&&(Se+="u"),new RegExp(ne,Se)}e.createRegExp=p;function E(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function P(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function o(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=o;function t(ne){for(let ue=0,de=ne.length;ue<de;ue++){const Se=ne.charCodeAt(ue);if(Se!==32&&Se!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function n(ne,ue=0,de=ne.length){for(let Se=ue;Se<de;Se++){const ve=ne.charCodeAt(Se);if(ve!==32&&ve!==9)return ne.substring(ue,Se)}return ne.substring(ue,de)}e.getLeadingWhitespace=n;function s(ne,ue=ne.length-1){for(let de=ue;de>=0;de--){const Se=ne.charCodeAt(de);if(Se!==32&&Se!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function a(ne,ue,de){const Se=[];let ve=0;for(const Ce of ne.matchAll(ue)){if(Se.push(ne.slice(ve,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ve=Ce.index+Ce[0].length,Se.push(de(Ce[0],...Ce.slice(1),Ce.index,ne,Ce.groups))}return Se.push(ne.slice(ve)),Promise.all(Se).then(Ce=>Ce.join(""))}e.replaceAsync=a;function r(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=r;function l(ne,ue,de=0,Se=ne.length,ve=0,Ce=ue.length){for(;de<Se&&ve<Ce;de++,ve++){const Te=ne.charCodeAt(de),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=Se-de,Ae=Ce-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=l;function y(ne,ue){return b(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=y;function b(ne,ue,de=0,Se=ne.length,ve=0,Ce=ue.length){for(;de<Se&&ve<Ce;de++,ve++){let Te=ne.charCodeAt(de),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return l(ne.toLowerCase(),ue.toLowerCase(),de,Se,ve,Ce);N(Te)&&(Te-=32),N(Ue)&&(Ue-=32);const je=Te-Ue;if(je!==0)return je}const Re=Se-de,Ae=Ce-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=b;function O(ne){return ne>=48&&ne<=57}e.isAsciiDigit=O;function N(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=N;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function z(ne,ue){return ne.length===ue.length&&b(ne,ue)===0}e.equalsIgnoreCase=z;function G(ne,ue){const de=ue.length;return ue.length>ne.length?!1:b(ne,ue,0,de)===0}e.startsWithIgnoreCase=G;function Y(ne,ue){const de=Math.min(ne.length,ue.length);let Se;for(Se=0;Se<de;Se++)if(ne.charCodeAt(Se)!==ue.charCodeAt(Se))return Se;return de}e.commonPrefixLength=Y;function W(ne,ue){const de=Math.min(ne.length,ue.length);let Se;const ve=ne.length-1,Ce=ue.length-1;for(Se=0;Se<de;Se++)if(ne.charCodeAt(ve-Se)!==ue.charCodeAt(Ce-Se))return Se;return de}e.commonSuffixLength=W;function T(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=T;function B(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=B;function _(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=_;function q(ne,ue,de){const Se=ne.charCodeAt(de);if(T(Se)&&de+1<ue){const ve=ne.charCodeAt(de+1);if(B(ve))return _(Se,ve)}return Se}e.getNextCodePoint=q;function x(ne,ue){const de=ne.charCodeAt(ue-1);if(B(de)&&ue>1){const Se=ne.charCodeAt(ue-2);if(T(Se))return _(Se,de)}return de}class M{get offset(){return this.e}constructor(ue,de=0){this.c=ue,this.d=ue.length,this.e=de}setOffset(ue){this.e=ue}prevCodePoint(){const ue=x(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=q(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=M;class X{get offset(){return this.c.offset}constructor(ue,de=0){this.c=new M(ue,de)}nextGraphemeLength(){const ue=Ie.getInstance(),de=this.c,Se=de.offset;let ve=ue.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Ce=de.offset,Re=ue.getGraphemeBreakType(de.nextCodePoint());if(fe(ve,Re)){de.setOffset(Ce);break}ve=Re}return de.offset-Se}prevGraphemeLength(){const ue=Ie.getInstance(),de=this.c,Se=de.offset;let ve=ue.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Ce=de.offset,Re=ue.getGraphemeBreakType(de.prevCodePoint());if(fe(Re,ve)){de.setOffset(Ce);break}ve=Re}return Se-de.offset}eol(){return this.c.eol()}}e.GraphemeIterator=X;function Q(ne,ue){return new X(ne,ue).nextGraphemeLength()}e.nextCharLength=Q;function se(ne,ue){return new X(ne,ue).prevGraphemeLength()}e.prevCharLength=se;function ae(ne,ue){ue>0&&B(ne.charCodeAt(ue))&&ue--;const de=ue+Q(ne,ue);return[de-se(ne,de),de]}e.getCharContainingOffset=ae;function V(ne){const ue=new X(ne);let de=0;for(;!ue.eol();)de++,ue.nextGraphemeLength();return de}e.charCount=V;let j;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(ne){return j||(j=U()),j.test(ne)}e.containsRTL=$;const H=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return H.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=K;function Z(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Z;function ie(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ie;function le(ne,ue){if(ne.length<ue)return ne;const de=/\b/g;let Se=0;for(;de.test(ne)&&!(ne.length-de.lastIndex<ue);)Se=de.lastIndex,de.lastIndex+=1;return ne.substring(Se).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function we(ne){return pe(ne)?ne.substr(1):ne}e.stripUTF8BOM=we;function Ee(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const de=ue.length,Se=ne.toLowerCase();let ve=0,Ce=-1;for(;ve<de;){const Re=Se.indexOf(ue[ve],Ce+1);if(Re<0)return!1;Ce=Re,ve++}return!0}e.fuzzyContains=Ee;function ke(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=ke;function De(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=De;function qe(ne,ue=1){if(ue===0)return"";let de=-1;do de=ne.indexOf(`
`,de+1),ue--;while(ue>0&&de>=0);return de===-1?ne:(ne[de-1]==="\r"&&de--,ne.substr(0,de))}e.getNLines=qe;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var ge;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const de=this.d,Se=de.length/3;let ve=1;for(;ve<=Se;)if(ue<de[3*ve])ve=2*ve;else if(ue>de[3*ve+1])ve=2*ve+1;else return de[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const de=Le(ne,ue);if(de!==void 0)return de;const Se=new M(ue,ne);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Fe;function Le(ne,ue){const de=new M(ue,ne);let Se=de.prevCodePoint();for(;Be(Se)||Se===65039||Se===8419;){if(de.offset===0)return;Se=de.prevCodePoint()}if(!ie(Se))return;let ve=de.offset;return ve>0&&de.prevCodePoint()===8205&&(ve=de.offset),ve}function Be(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}c=Ne,Ne.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new L.LRUCachedFunction(ne=>{function ue(Ue){const je=new Map;for(let ze=0;ze<Ue.length;ze+=2)je.set(Ue[ze],Ue[ze+1]);return je}function de(Ue,je){const ze=new Map(Ue);for(const[_e,nt]of je)ze.set(_e,nt);return ze}function Se(Ue,je){if(!Ue)return je;const ze=new Map;for(const[_e,nt]of Ue)je.has(_e)&&ze.set(_e,nt);return ze}const ve=c.c.value;let Ce=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ce.length===0&&(Ce=["_default"]);let Re;for(const Ue of Ce){const je=ue(ve[Ue]);Re=Se(Re,je)}const Ae=ue(ve._common),Te=de(Ae,Re);return new Ne(Te)}),Ne.e=new A.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class $e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set($e.c())),this.d}static isInvisibleCharacter(ue){return $e.e().has(ue)}static get codePoints(){return $e.e()}}$e.d=void 0,e.InvisibleCharacters=$e}),define(re[48],oe([0,1,13,4,27,12]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function C(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function S(s,a=L.posix.sep){if(!s)return"";const r=s.length,l=s.charCodeAt(0);if(D(l)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let b=3;const O=b;for(;b<r&&!D(s.charCodeAt(b));b++);if(O!==b&&!D(s.charCodeAt(b+1))){for(b+=1;b<r;b++)if(D(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(u(l)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let y=s.indexOf("://");if(y!==-1){for(y+=3;y<r;y++)if(D(s.charCodeAt(y)))return s.slice(0,y+1)}return""}e.getRoot=S;function I(s){if(!A.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let r=2;const l=r;for(;r<s.length&&(a=s.charCodeAt(r),a!==92);r++);return!(l===r||(a=s.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=I;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=A.isWindows){const r=a?w:g;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||a&&f.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function v(s,a,r){const l=s===a;return!r||l?l:!s||!a?!1:(0,c.equalsIgnoreCase)(s,a)}e.isEqual=v;function h(s,a,r,l=L.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(r){if(!(0,c.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let b=a.length;return a.charAt(a.length-1)===l&&b--,s.charAt(b)===l}return a.charAt(a.length-1)!==l&&(a+=l),s.indexOf(a)===0}e.isEqualOrParent=h;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function m(s,a){return A.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(a,s)),s=(0,L.normalize)(s),A.isWindows?(s=(0,c.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,c.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=m;function p(s){const a=(0,L.normalize)(s);return A.isWindows?s.length>3?!1:E(a)&&(s.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=p;function E(s,a=A.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function P(s){return E(s)?s[0]:void 0}e.getDriveLetter=P;function i(s,a,r){return a.length>s.length?-1:s===a?0:(r&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function o(s){const a=s.split(":");let r,l,y;for(const b of a){const O=Number(b);(0,k.isNumber)(O)?l===void 0?l=O:y===void 0&&(y=O):r=r?[r,b].join(":"):b}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:y!==void 0?y:l!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,r=8){let l="";for(let b=0;b<r;b++)l+=t.charAt(Math.floor(Math.random()*t.length));let y;return a?y=`${a}-${l}`:y=l,s?(0,L.join)(s,y):y}e.randomPath=n}),define(re[64],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(u){return c(u,0)}e.hash=A;function c(u,m){switch(typeof u){case"object":return u===null?k(349,m):Array.isArray(u)?C(u,m):S(u,m);case"string":return R(u,m);case"boolean":return D(u,m);case"number":return k(u,m);case"undefined":return k(937,m);default:return k(617,m)}}e.doHash=c;function k(u,m){return(m<<5)-m+u|0}e.numberHash=k;function D(u,m){return k(u?433:863,m)}function R(u,m){m=k(149417,m);for(let p=0,E=u.length;p<E;p++)m=k(u.charCodeAt(p),m);return m}e.stringHash=R;function C(u,m){return m=k(104579,m),u.reduce((p,E)=>c(E,p),m)}function S(u,m){return m=k(181387,m),Object.keys(u).sort().reduce((p,E)=>(p=R(E,p),c(u[E],p)),m)}class I{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=c(m,this.g),this.g}}e.Hasher=I;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(u,m,p=32){const E=p-m,P=~((1<<E)-1);return(u<<m|(P&u)>>>E)>>>0}function f(u,m=0,p=u.byteLength,E=0){for(let P=0;P<p;P++)u[m+P]=E}function d(u,m,p="0"){for(;u.length<m;)u=p+u;return u}function v(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(p=>p.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),m/4)}e.toHexString=v;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const p=m.length;if(p===0)return;const E=this.p;let P=this.r,i=this.u,o,t;for(i!==0?(o=i,t=-1,i=0):(o=m.charCodeAt(0),t=0);;){let n=o;if(L.isHighSurrogate(o))if(t+1<p){const s=m.charCodeAt(t+1);L.isLowSurrogate(s)?(t++,n=L.computeCodePoint(o,s)):n=65533}else{i=o;break}else L.isLowSurrogate(o)&&(n=65533);if(P=this.w(E,P,n),t++,t<p)o=m.charCodeAt(t);else break}this.r=P,this.u=i}w(m,p,E){return E<128?m[p++]=E:E<2048?(m[p++]=192|(E&1984)>>>6,m[p++]=128|(E&63)>>>0):E<65536?(m[p++]=224|(E&61440)>>>12,m[p++]=128|(E&4032)>>>6,m[p++]=128|(E&63)>>>0):(m[p++]=240|(E&1835008)>>>18,m[p++]=128|(E&258048)>>>12,m[p++]=128|(E&4032)>>>6,m[p++]=128|(E&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=h.g,p=this.q;for(let r=0;r<64;r+=4)m.setUint32(r,p.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)m.setUint32(r,g(m.getUint32(r-12,!1)^m.getUint32(r-32,!1)^m.getUint32(r-56,!1)^m.getUint32(r-64,!1),1),!1);let E=this.h,P=this.l,i=this.m,o=this.n,t=this.o,n,s,a;for(let r=0;r<80;r++)r<20?(n=P&i|~P&o,s=1518500249):r<40?(n=P^i^o,s=1859775393):r<60?(n=P&i|P&o|i&o,s=2400959708):(n=P^i^o,s=3395469782),a=g(E,5)+n+t+s+m.getUint32(r*4,!1)&4294967295,t=o,o=i,i=g(P,30),P=E,E=a;this.h=this.h+E&4294967295,this.l=this.l+P&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}h.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(re[89],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(c){c[c.Ignore=0]="Ignore",c[c.Info=1]="Info",c[c.Warning=2]="Warning",c[c.Error=3]="Error"})(A||(A={})),function(c){const k="error",D="warning",R="warn",C="info",S="ignore";function I(g){return g?L.equalsIgnoreCase(k,g)?c.Error:L.equalsIgnoreCase(D,g)||L.equalsIgnoreCase(R,g)?c.Warning:L.equalsIgnoreCase(C,g)?c.Info:c.Ignore:c.Ignore}c.fromValue=I;function w(g){switch(g){case c.Error:return k;case c.Warning:return D;case c.Info:return C;default:return S}}c.toString=w}(A||(A={})),e.default=A}),define(re[49],oe([0,1,21,27]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class c{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.StringIterator=c;class k{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=k;class D{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class C{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=C;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(I||(I={}));class w{static forUris(f=()=>!1,d=()=>!1){return new w(new C(f,d))}static forPaths(f=!1){return new w(new D(void 0,!f))}static forStrings(){return new w(new c)}static forConfigKeys(){return new w(new k)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,L.shuffle)(v);for(const h of v)this.set(h,f)}else{const v=f.slice(0);(0,L.shuffle)(v);for(const h of v)this.set(h[0],h[1])}}set(f,d){const v=this.b.reset(f);let h;this.c||(this.c=new S,this.c.segment=v.value());const u=[];for(h=this.c;;){const p=v.cmp(h.segment);if(p>0)h.left||(h.left=new S,h.left.segment=v.value()),u.push([-1,h]),h=h.left;else if(p<0)h.right||(h.right=new S,h.right.segment=v.value()),u.push([1,h]),h=h.right;else if(v.hasNext())v.next(),h.mid||(h.mid=new S,h.mid.segment=v.value()),u.push([0,h]),h=h.mid;else break}const m=h.value;h.value=d,h.key=f;for(let p=u.length-1;p>=0;p--){const E=u[p][1];E.updateHeight();const P=E.balanceFactor();if(P<-1||P>1){const i=u[p][0],o=u[p+1][0];if(i===1&&o===1)u[p][1]=E.rotateLeft();else if(i===-1&&o===-1)u[p][1]=E.rotateRight();else if(i===1&&o===-1)E.right=u[p+1][1]=u[p+1][1].rotateRight(),u[p][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=u[p+1][1]=u[p+1][1].rotateLeft(),u[p][1]=E.rotateRight();else throw new Error;if(p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this.c=u[0][1]}}return m}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const h=d.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),h=[];let u=this.c;for(;u;){const m=v.cmp(u.segment);if(m>0)h.push([-1,u]),u=u.left;else if(m<0)h.push([1,u]),u=u.right;else if(v.hasNext())v.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:p,value:E,segment:P}=m;this.e(m.key,!1),u.key=p,u.value=E,u.segment=P}}else{const m=u.left??u.right;if(h.length>0){const[p,E]=h[h.length-1];switch(p){case-1:E.left=m;break;case 0:E.mid=m;break;case 1:E.right=m;break}}else this.c=m}for(let m=h.length-1;m>=0;m--){const p=h[m][1];p.updateHeight();const E=p.balanceFactor();if(E>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),h[m][1]=p.rotateLeft()):E<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),h[m][1]=p.rotateRight()),m>0)switch(h[m-1][0]){case-1:h[m-1][1].left=h[m][1];break;case 1:h[m-1][1].right=h[m][1];break;case 0:h[m-1][1].mid=h[m][1];break}else this.c=h[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,h;for(;v;){const u=d.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(d.hasNext())d.next(),h=v.value||h,v=v.mid;else break}return v&&v.value||h}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let h=this.c;for(;h;){const u=v.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(v.hasNext())v.next(),h=h.mid;else return h.mid?this.h(h.mid):d?h.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){!f||(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.TernarySearchTree=w}),define(re[10],oe([0,1,13,4]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const c=/^\w[\w\d+.-]*$/,k=/^\//,D=/^\/\//;function R(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!c.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,n){return!t&&!n?"file":t}function S(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const I="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,a,r,l,y=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=C(n,y),this.authority=s||I,this.path=S(this.scheme,a||I),this.query=r||I,this.fragment=l||I,R(this,y))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:r,query:l,fragment:y}=n;return s===void 0?s=this.scheme:s===null&&(s=I),a===void 0?a=this.authority:a===null&&(a=I),r===void 0?r=this.path:r===null&&(r=I),l===void 0?l=this.query:l===null&&(l=I),y===void 0?y=this.fragment:y===null&&(y=I),s===this.scheme&&a===this.authority&&r===this.path&&l===this.query&&y===this.fragment?this:new v(s,a,r,l,y)}static parse(n,s=!1){const a=g.exec(n);return a?new v(a[2]||I,o(a[4]||I),o(a[5]||I),o(a[7]||I),o(a[9]||I),s):new v(I,I,I,I,I)}static file(n){let s=I;if(A.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const a=n.indexOf(w,2);a===-1?(s=n.substring(2),n=w):(s=n.substring(2,a),n=n.substring(a)||w)}return new v("file",s,n,I,I)}static from(n){const s=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return R(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.isWindows&&n.scheme==="file"?a=f.file(L.win32.join(p(n,!0),...s)).path:a=L.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return E(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const s=new v(n);return s._formatted=n.external,s._fsPath=n._sep===d?n.fsPath:null,s}}else return n}}e.URI=f;const d=A.isWindows?1:void 0;class v extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,s){let a,r=-1;for(let l=0;l<t.length;l++){const y=t.charCodeAt(l);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||n&&y===47||s&&y===91||s&&y===93||s&&y===58)r!==-1&&(a+=encodeURIComponent(t.substring(r,l)),r=-1),a!==void 0&&(a+=t.charAt(l));else{a===void 0&&(a=t.substr(0,l));const b=h[y];b!==void 0?(r!==-1&&(a+=encodeURIComponent(t.substring(r,l)),r=-1),a+=b):r===-1&&(r=l)}}return r!==-1&&(a+=encodeURIComponent(t.substring(r))),a!==void 0?a:t}function m(t){let n;for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);a===35||a===63?(n===void 0&&(n=t.substr(0,s)),n+=h[a]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function p(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,A.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=p;function E(t,n){const s=n?m:u;let a="",{scheme:r,authority:l,path:y,query:b,fragment:O}=t;if(r&&(a+=r,a+=":"),(l||r==="file")&&(a+=w,a+=w),l){let N=l.indexOf("@");if(N!==-1){const F=l.substr(0,N);l=l.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=s(F,!1,!1):(a+=s(F.substr(0,N),!1,!1),a+=":",a+=s(F.substr(N+1),!1,!0)),a+="@"}l=l.toLowerCase(),N=l.lastIndexOf(":"),N===-1?a+=s(l,!1,!0):(a+=s(l.substr(0,N),!1,!0),a+=l.substr(N))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const N=y.charCodeAt(1);N>=65&&N<=90&&(y=`/${String.fromCharCode(N+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const N=y.charCodeAt(0);N>=65&&N<=90&&(y=`${String.fromCharCode(N+32)}:${y.substr(2)}`)}a+=s(y,!0,!1)}return b&&(a+="?",a+=s(b,!1,!1)),O&&(a+="#",a+=n?O:u(O,!1,!1)),a}function P(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+P(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(i)?t.replace(i,n=>P(n)):t}}),define(re[143],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(S){const I=S;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=A;function c(S){const I=[];let w;try{const g=JSON.parse(S.arguments),f=g[g.length-1];f&&f.__$stack&&(g.pop(),w=f.__$stack),I.push(...g)}catch{I.push("Unable to log remote console arguments",S.arguments)}return{args:I,stack:w}}e.parse=c;function k(S){if(typeof S!="string")return k(c(S).stack);const I=S;if(I){const w=D(I),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function D(S){if(!S)return S;const I=S.indexOf(`
`);return I===-1?S:S.substring(0,I)}function R(S,I){const{args:w,stack:g}=c(S),f=typeof w[0]=="string"&&w.length===1;let d=D(g);d&&(d=`(${d.trim()})`);let v=[];if(typeof w[0]=="string"?d&&f?v=[`%c[${I}] %c${w[0]} %c${d}`,C("blue"),C(""),C("grey")]:v=[`%c[${I}] %c${w[0]}`,C("blue"),C(""),...w.slice(1)]:v=[`%c[${I}]%`,C("blue"),...w],d&&!f&&v.push(d),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,v)}e.log=R;function C(S){return`color: ${S}`}}),define(re[90],oe([0,1,16,27,10]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,R)}e.stringify=k;function D(S){let I=JSON.parse(S);return I=C(I),I}e.parse=D;function R(S,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,A.regExpFlags)(I)}:I}function C(S,I=0){if(!S||I>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return c.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof L.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=C(S[w],I+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=C(S[w],I+1))}return S}e.revive=C}),define(re[22],oe([0,1,8,4,10]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(I){this.d=I}setDelegate(I){this.e=I}setServerRootPath(I){this.f=`${I}/${k.vscodeRemoteResource}`}set(I,w,g){this.a[I]=w,this.b[I]=g}setConnectionToken(I,w){this.c[I]=w}getPreferredWebSchema(){return this.d}rewrite(I){if(this.e)try{return this.e(I)}catch(h){return L.onUnexpectedError(h),I}const w=I.authority;let g=this.a[w];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const f=this.b[w],d=this.c[w];let v=`path=${encodeURIComponent(I.path)}`;return typeof d=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),c.URI.from({scheme:A.isWeb?this.d:k.vscodeRemoteResource,authority:`${g}:${f}`,path:this.f,query:v})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(I){const w=this.b(I,te);return this.uriToBrowserUri(w)}uriToBrowserUri(I){return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${k.vscodeFileResource}://${R.a}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||R.a,query:null,fragment:null}):I}asFileUri(I){const w=this.b(I,te);return this.uriToFileUri(w)}uriToFileUri(I){return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==R.a?I.authority:null,query:null,fragment:null}):I}b(I,w){return c.URI.isUri(I)?I:c.URI.parse(w.toUrl(I))}}R.a="vscode-app",e.FileAccess=new R;var C;(function(S){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(I.get("3"));const w="vscode-coi";function g(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:c.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const h=v?.get(w);if(!!h)return I.get(h)}S.getHeadersFromQuery=g;function f(d,v,h){if(!globalThis.crossOriginIsolated)return;const u=v&&h?"3":h?"2":"1";d instanceof URLSearchParams?d.set(w,u):d[w]=u}S.addSearchParam=f})(C=e.COI||(e.COI={}))}),define(re[25],oe([0,1,48,22,13,4,27,10]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=C;class S{constructor(d){this.a=d}compare(d,v,h=!1){return d===v?0:(0,D.compare)(this.getComparisonKey(d,h),this.getComparisonKey(v,h))}isEqual(d,v,h=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,h)===this.getComparisonKey(v,h)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,h=!1){if(d.scheme===v.scheme){if(d.scheme===A.Schemas.file)return L.isEqualOrParent(C(d),C(v),this.a(d))&&d.query===v.query&&(h||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return L.isEqualOrParent(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(h||d.fragment===v.fragment)}return!1}joinPath(d,...v){return R.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return c.posix.basename(d.path)}extname(d){return c.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===A.Schemas.file?v=R.URI.file(c.dirname(C(d))).path:(v=c.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===A.Schemas.file?v=R.URI.file(c.normalize(C(d))).path:v=c.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===A.Schemas.file){const m=c.relative(C(d),C(v));return k.isWindows?L.toSlashes(m):m}let h=d.path||"/";const u=v.path||"/";if(this.a(d)){let m=0;for(const p=Math.min(h.length,u.length);m<p&&!(h.charCodeAt(m)!==u.charCodeAt(m)&&h.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);h=u.substr(0,m)+h.substr(m)}return c.posix.relative(h,u)}resolvePath(d,v){if(d.scheme===A.Schemas.file){const h=R.URI.file(c.resolve(C(d),v));return d.with({authority:h.authority,path:h.path})}return v=L.toPosixPath(v),d.with({path:c.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,D.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=c.sep){if(d.scheme===A.Schemas.file){const h=C(d);return h.length>L.getRoot(h).length&&h[h.length-1]===v}else{const h=d.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=c.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=c.sep){let h=!1;if(d.scheme===A.Schemas.file){const u=C(d);h=u!==void 0&&u.length===L.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=d.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(f=>f.scheme===A.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new S(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,d){const v=[];for(let h=0;h<f.length;h++){const u=d(f[h]);f.some((m,p)=>p===h?!1:(0,e.isEqualOrParent)(u,d(m)))||v.push(f[h])}return v}e.distinctParents=I;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const h=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(p=>{const[E,P]=p.split(":");E&&P&&h.set(E,P)});const m=v.path.substring(0,v.path.indexOf(";"));return m&&h.set(f.META_DATA_MIME,m),h}f.parseMetaData=d})(w=e.DataUri||(e.DataUri={}));function g(f,d,v){if(d){let h=f.path;return h&&h[0]!==c.posix.sep&&(h=c.posix.sep+h),f.with({scheme:v,authority:d,path:h})}return f.with({scheme:v})}e.toLocalResource=g}),define(re[6],oe([0,1,24,8,3,2,25,4,132]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(V){return!!V&&typeof V.then=="function"}e.isThenable=S;function I(V){const j=new L.CancellationTokenSource,U=V(j.token),$=new Promise((H,ee)=>{const K=j.token.onCancellationRequested(()=>{K.dispose(),j.dispose(),ee(new A.CancellationError)});Promise.resolve(U).then(Z=>{K.dispose(),j.dispose(),H(Z)},Z=>{K.dispose(),j.dispose(),ee(Z)})});return new class{cancel(){j.cancel()}then(H,ee){return $.then(H,ee)}catch(H){return this.then(void 0,H)}finally(H){return $.finally(H)}}}e.createCancelablePromise=I;function w(V,j,U){return new Promise(($,H)=>{const ee=j.onCancellationRequested(()=>{ee.dispose(),$(U)});V.then($,H).finally(()=>ee.dispose())})}e.raceCancellation=w;function g(V,j){return new Promise((U,$)=>{const H=j.onCancellationRequested(()=>{H.dispose(),$(new A.CancellationError)});V.then(U,$).finally(()=>H.dispose())})}e.raceCancellationError=g;async function f(V){let j=-1;const U=V.map((H,ee)=>H.then(K=>(j=ee,K))),$=await Promise.race(U);return V.forEach((H,ee)=>{ee!==j&&H.cancel()}),$}e.raceCancellablePromises=f;function d(V,j,U){let $;const H=setTimeout(()=>{$?.(void 0),U?.()},j);return Promise.race([V.finally(()=>clearTimeout(H)),new Promise(ee=>$=ee)])}e.raceTimeout=d;function v(V){return new Promise((j,U)=>{const $=V();S($)?$.then(j,U):j($)})}e.asPromise=v;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(j){if(this.a){if(this.d=j,!this.b){const U=()=>{this.b=null;const $=this.queue(this.d);return this.d=null,$};this.b=new Promise($=>{this.a.then(U,U).then($)})}return new Promise((U,$)=>{this.b.then(U,$)})}return this.a=j(),new Promise((U,$)=>{this.a.then(H=>{this.a=null,U(H)},H=>{this.a=null,$(H)})})}}e.Throttler=h;class u{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.Sequencer=u;class m{constructor(){this.a=new Map}queue(j,U){const H=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(j)===H&&this.a.delete(j)});return this.a.set(j,H),H}}e.SequencerByKey=m;const p=(V,j)=>{let U=!0;const $=setTimeout(()=>{U=!1,j()},V);return{isTriggered:()=>U,dispose:()=>{clearTimeout($),U=!1}}},E=V=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,V())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class P{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,U=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((H,ee)=>{this.d=H,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const H=this.g;return this.g=null,H()}}));const $=()=>{this.a=null,this.d?.(null)};return this.a=U===C.MicrotaskDelay?E($):p(U,$),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class i{constructor(j){this.a=new P(j),this.b=new h}trigger(j,U){return this.a.trigger(()=>this.b.queue(j),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((j,U)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class t extends o{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function n(V,j){return j?new Promise((U,$)=>{const H=setTimeout(()=>{ee.dispose(),U()},V),ee=j.onCancellationRequested(()=>{clearTimeout(H),ee.dispose(),$(new A.CancellationError)})}):I(U=>n(V,U))}e.timeout=n;function s(V,j=0){const U=setTimeout(V,j);return(0,k.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function a(V){const j=[];let U=0;const $=V.length;function H(){return U<$?V[U++]():null}function ee(K){K!=null&&j.push(K);const Z=H();return Z?Z.then(ee):Promise.resolve(j)}return Promise.resolve(null).then(ee)}e.sequence=a;function r(V,j=$=>!!$,U=null){let $=0;const H=V.length,ee=()=>{if($>=H)return Promise.resolve(U);const K=V[$++];return Promise.resolve(K()).then(ie=>j(ie)?Promise.resolve(ie):ee())};return ee()}e.first=r;function l(V,j=$=>!!$,U=null){if(V.length===0)return Promise.resolve(U);let $=V.length;const H=()=>{$=-1;for(const ee of V)ee.cancel?.()};return new Promise((ee,K)=>{for(const Z of V)Z.then(ie=>{--$>=0&&j(ie)?(H(),ee(ie)):$===0&&ee(U)}).catch(ie=>{--$>=0&&(H(),K(ie))})})}e.firstParallel=l;class y{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new c.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((U,$)=>{this.f.push({factory:j,c:U,e:$}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const U=j.factory();U.then(j.c,j.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class b extends y{constructor(){super(1)}}e.Queue=b;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new x;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,U=D.extUri){const $=U.getComparisonKey(j);let H=this.a.get($);return H||(H=new b,c.Event.once(H.onDrained)(()=>{H?.dispose(),this.a.delete($),this.f()}),this.a.set($,H)),H}f(){!this.d()||this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(j,U){this.a=-1,typeof j=="function"&&typeof U=="number"&&this.setIfNotSet(j,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},U)}setIfNotSet(j,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},U))}}e.TimeoutTimer=N;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,U){this.cancel(),this.a=setInterval(()=>{j()},U)}}e.IntervalTimer=F;class z{constructor(j,U){this.b=-1,this.a=j,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=z;class G{constructor(j,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=j,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class Y extends z{constructor(j,U){super(j,U),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class W extends k.Disposable{constructor(j,U){super(),this.g=j,this.h=U,this.a=[],this.b=this.B(new k.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of j)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,R.setTimeout0)(()=>{if(j)return;const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(V,j)=>{const U=requestIdleCallback(V,typeof j=="number"?{timeout:j}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(U))}}}}();class T{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function B(V,j,U){let $;for(let H=0;H<U;H++)try{return await V()}catch(ee){$=ee,await n(j)}throw $}e.retry=B;class _{hasPending(j){return this.a?typeof j=="number"?this.a.taskId===j:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(j,U,$){return this.a={taskId:j,cancel:()=>$?.(),promise:U},U.then(()=>this.d(j),()=>this.d(j)),U}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this.b)this.b.run=j;else{let U,$;const H=new Promise((ee,K)=>{U=ee,$=K});this.b={run:j,promise:H,promiseResolve:U,promiseReject:$}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=_;class q{constructor(j,U=()=>Date.now()){this.d=j,this.f=U,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.IntervalCounter=q;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((j,U)=>{this.a=j,this.b=U})}complete(j){return new Promise(U=>{this.a(j),this.f=!0,U()})}error(j){return new Promise(U=>{this.b(j),this.d=!0,U()})}cancel(){new Promise(j=>{this.b(new A.CancellationError),this.d=!0,j()})}}e.DeferredPromise=x;var M;(function(V){async function j($){let H;const ee=await Promise.all($.map(K=>K.then(Z=>Z,Z=>{H||(H=Z)})));if(typeof H<"u")throw H;return ee}V.settled=j;function U($){return new Promise(async(H,ee)=>{try{await $(H,ee)}catch(K){ee(K)}})}V.withAsyncBody=U})(M=e.Promises||(e.Promises={}));var X;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(X||(X={}));class Q{static fromArray(j){return new Q(U=>{U.emitMany(j)})}static fromPromise(j){return new Q(async U=>{U.emitMany(await j)})}static fromPromises(j){return new Q(async U=>{await Promise.all(j.map(async $=>U.emitOne(await $)))})}static merge(j){return new Q(async U=>{await Promise.all(j.map(async $=>{for await(const H of $)U.emitOne(H)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new c.Emitter,queueMicrotask(async()=>{const U={emitOne:$=>this.g($),emitMany:$=>this.h($),reject:$=>this.k($)};try{await Promise.resolve(j(U)),this.j()}catch($){this.k($)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await c.Event.toPromise(this.f.event)}while(!0)}}}static map(j,U){return new Q(async $=>{for await(const H of j)$.emitOne(U(H))})}map(j){return Q.map(this,j)}static filter(j,U){return new Q(async $=>{for await(const H of j)U(H)&&$.emitOne(H)})}filter(j){return Q.filter(this,j)}static coalesce(j){return Q.filter(j,U=>!!U)}coalesce(){return Q.coalesce(this)}static async toPromise(j){const U=[];for await(const $ of j)U.push($);return U}toPromise(){return Q.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}Q.EMPTY=Q.fromArray([]),e.AsyncIterableObject=Q;class se extends Q{constructor(j,U){super(U),this.l=j}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function ae(V){const j=new L.CancellationTokenSource,U=V(j.token);return new se(j,async $=>{const H=j.token.onCancellationRequested(()=>{H.dispose(),j.dispose(),$.reject(new A.CancellationError)});try{for await(const ee of U){if(j.token.isCancellationRequested)return;$.emitOne(ee)}H.dispose(),j.dispose()}catch(ee){H.dispose(),j.dispose(),$.reject(ee)}})}e.createCancelableAsyncIterable=ae}),define(re[91],oe([0,1,21,6,48,37,13,4,27]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",w="[^/\\\\]",g=/\//g;function f(q,x){switch(q){case 0:return"";case 1:return`${w}*?`;default:return`(?:${I}|${w}+${I}${x?`|${I}${w}+`:""})*?`}}function d(q,x){if(!q)return[];const M=[];let X=!1,Q=!1,se="";for(const ae of q){switch(ae){case x:if(!X&&!Q){M.push(se),se="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}se+=ae}return se&&M.push(se),M}e.splitGlobAware=d;function v(q){if(!q)return"";let x="";const M=d(q,e.GLOB_SPLIT);if(M.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;M.forEach((Q,se)=>{if(Q===e.GLOBSTAR){if(X)return;x+=f(2,se===M.length-1)}else{let ae=!1,V="",j=!1,U="";for(const $ of Q){if($!=="}"&&ae){V+=$;continue}if(j&&($!=="]"||!U)){let H;$==="-"?H=$:($==="^"||$==="!")&&!U?H="^":$===e.GLOB_SPLIT?H="":H=(0,C.escapeRegExpCharacters)($),U+=H;continue}switch($){case"{":ae=!0;continue;case"[":j=!0;continue;case"}":{x+=`(?:${d(V,",").map(K=>v(K)).join("|")})`,ae=!1,V="";break}case"]":{x+="["+U+"]",j=!1,U="";break}case"?":x+=w;continue;case"*":x+=f(1);continue;default:x+=(0,C.escapeRegExpCharacters)($)}}se<M.length-1&&(M[se+1]!==e.GLOBSTAR||se+2<M.length)&&(x+=I)}X=Q===e.GLOBSTAR})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,P=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),o=function(){return!1},t=function(){return null};function n(q,x){if(!q)return t;let M;typeof q!="string"?M=q.pattern:M=q,M=M.trim();const X=`${M}_${!!x.trimForExclusions}`;let Q=i.get(X);if(Q)return s(Q,q);let se;return h.test(M)?Q=r(M.substr(4),M):(se=u.exec(a(M,x)))?Q=l(se[1],M):(x.trimForExclusions?p:m).test(M)?Q=y(M,x):(se=E.exec(a(M,x)))?Q=b(se[1].substr(1),M,!0):(se=P.exec(a(M,x)))?Q=b(se[1],M,!1):Q=O(M),i.set(X,Q),s(Q,q)}function s(q,x){if(typeof x=="string")return q;const M=function(X,Q){return(0,c.isEqualOrParent)(X,x.base,!R.isLinux)?q((0,C.ltrim)(X.substr(x.base.length),D.sep),Q):null};return M.allBasenames=q.allBasenames,M.allPaths=q.allPaths,M.basenames=q.basenames,M.patterns=q.patterns,M}function a(q,x){return x.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function r(q,x){return function(M,X){return typeof M=="string"&&M.endsWith(q)?x:null}}function l(q,x){const M=`/${q}`,X=`\\${q}`,Q=function(ae,V){return typeof ae!="string"?null:V?V===q?x:null:ae===q||ae.endsWith(M)||ae.endsWith(X)?x:null},se=[q];return Q.basenames=se,Q.patterns=[x],Q.allBasenames=se,Q}function y(q,x){const M=B(q.slice(1,-1).split(",").map(V=>n(V,x)).filter(V=>V!==t),q),X=M.length;if(!X)return t;if(X===1)return M[0];const Q=function(V,j){for(let U=0,$=M.length;U<$;U++)if(M[U](V,j))return q;return null},se=M.find(V=>!!V.allBasenames);se&&(Q.allBasenames=se.allBasenames);const ae=M.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ae.length&&(Q.allPaths=ae),Q}function b(q,x,M){const X=D.sep===D.posix.sep,Q=X?q:q.replace(g,D.sep),se=D.sep+Q,ae=D.posix.sep+q;let V;return M?V=function(j,U){return typeof j=="string"&&(j===Q||j.endsWith(se)||!X&&(j===q||j.endsWith(ae)))?x:null}:V=function(j,U){return typeof j=="string"&&(j===Q||!X&&j===q)?x:null},V.allPaths=[(M?"*/":"./")+q],V}function O(q){try{const x=new RegExp(`^${v(q)}$`);return function(M){return x.lastIndex=0,typeof M=="string"&&x.test(M)?q:null}}catch{return t}}function N(q,x,M){return!q||typeof x!="string"?!1:F(q)(x,void 0,M)}e.match=N;function F(q,x={}){if(!q)return o;if(typeof q=="string"||z(q)){const M=n(q,x);if(M===t)return o;const X=function(Q,se){return!!M(Q,se)};return M.allBasenames&&(X.allBasenames=M.allBasenames),M.allPaths&&(X.allPaths=M.allPaths),X}return W(q,x)}e.parse=F;function z(q){const x=q;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=z;function G(q){return q.allBasenames||[]}e.getBasenameTerms=G;function Y(q){return q.allPaths||[]}e.getPathTerms=Y;function W(q,x){const M=B(Object.getOwnPropertyNames(q).map(V=>T(V,q[V],x)).filter(V=>V!==t)),X=M.length;if(!X)return t;if(!M.some(V=>!!V.requiresSiblings)){if(X===1)return M[0];const V=function($,H){let ee;for(let K=0,Z=M.length;K<Z;K++){const ie=M[K]($,H);if(typeof ie=="string")return ie;(0,A.isThenable)(ie)&&(ee||(ee=[]),ee.push(ie))}return ee?(async()=>{for(const K of ee){const Z=await K;if(typeof Z=="string")return Z}return null})():null},j=M.find($=>!!$.allBasenames);j&&(V.allBasenames=j.allBasenames);const U=M.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return U.length&&(V.allPaths=U),V}const Q=function(V,j,U){let $,H;for(let ee=0,K=M.length;ee<K;ee++){const Z=M[ee];Z.requiresSiblings&&U&&(j||(j=(0,D.basename)(V)),$||($=j.substr(0,j.length-(0,D.extname)(V).length)));const ie=Z(V,j,$,U);if(typeof ie=="string")return ie;(0,A.isThenable)(ie)&&(H||(H=[]),H.push(ie))}return H?(async()=>{for(const ee of H){const K=await ee;if(typeof K=="string")return K}return null})():null},se=M.find(V=>!!V.allBasenames);se&&(Q.allBasenames=se.allBasenames);const ae=M.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ae.length&&(Q.allPaths=ae),Q}function T(q,x,M){if(x===!1)return t;const X=n(q,M);if(X===t)return t;if(typeof x=="boolean")return X;if(x){const Q=x.when;if(typeof Q=="string"){const se=(ae,V,j,U)=>{if(!U||!X(ae,V))return null;const $=Q.replace("$(basename)",()=>j),H=U($);return(0,A.isThenable)(H)?H.then(ee=>ee?q:null):H?q:null};return se.requiresSiblings=!0,se}}return X}function B(q,x){const M=q.filter(V=>!!V.basenames);if(M.length<2)return q;const X=M.reduce((V,j)=>{const U=j.basenames;return U?V.concat(U):V},[]);let Q;if(x){Q=[];for(let V=0,j=X.length;V<j;V++)Q.push(x)}else Q=M.reduce((V,j)=>{const U=j.patterns;return U?V.concat(U):V},[]);const se=function(V,j){if(typeof V!="string")return null;if(!j){let $;for($=V.length;$>0;$--){const H=V.charCodeAt($-1);if(H===47||H===92)break}j=V.substr($)}const U=X.indexOf(j);return U!==-1?Q[U]:null};se.basenames=X,se.patterns=Q,se.allBasenames=X;const ae=q.filter(V=>!V.basenames);return ae.push(se),ae}function _(q,x){return(0,L.equals)(q,x,(M,X)=>typeof M=="string"&&typeof X=="string"?M===X:typeof M!="string"&&typeof X!="string"?M.base===X.base&&M.pattern===X.pattern:!1)}e.patternsEquals=_}),define(re[92],oe([0,1,16,10]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function c(w){return w.toJSON()}class k{constructor(g){this.a=g}transformIncoming(g){const f=this.a.transformIncoming(g);return f===g?g:c(A.URI.from(f))}transformOutgoing(g){const f=this.a.transformOutgoing(g);return f===g?g:c(A.URI.from(f))}transformOutgoingURI(g){const f=this.a.transformOutgoing(g);return f===g?g:A.URI.from(f)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,g,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof A.URI)return g.transformOutgoing(w);for(const d in w)if(Object.hasOwnProperty.call(w,d)){const v=D(w[d],g,f+1);v!==null&&(w[d]=v)}}return null}function R(w,g){const f=D(w,g,0);return f===null?w:f}e.transformOutgoingURIs=R;function C(w,g,f,d){if(!w||d>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?A.URI.revive(g.transformIncoming(w)):g.transformIncoming(w);if(w instanceof L.VSBuffer)return null;for(const v in w)if(Object.hasOwnProperty.call(w,v)){const h=C(w[v],g,f,d+1);h!==null&&(w[v]=h)}}return null}function S(w,g){const f=C(w,g,!1,0);return f===null?w:f}e.transformIncomingURIs=S;function I(w,g){const f=C(w,g,!0,0);return f===null?w:f}e.transformAndReviveIncomingURIs=I}),define(re[144],oe([0,1,34,8,49,31,134]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=c.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,w=0;const g=(0,L.networkInterfaces)();for(const f in g){const d=g[f];if(d)for(const{mac:v,internal:h}of d)h||(w+=1,this.c(v.toUpperCase())&&(I+=1))}this.b=w>0?I/w:0}return this.b}};let R;async function C(){return R||(R=(async()=>await S()||k.generateUuid())()),R}e.getMachineId=C;async function S(){try{const I=await new Promise((g,f)=>{te(["crypto"],g,f)}),w=(0,D.getMac)();return I.createHash("sha256").update(w,"utf8").digest("hex")}catch(I){A.onUnexpectedError(I);return}}}),define(re[28],oe([0,1,53,34,290,6,48,84,13,4,25,10]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function f(W,T=g.UNLINK){if((0,D.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return T===g.UNLINK?v(W):d(W)}async function d(W){try{const T=(0,D.randomPath)((0,A.tmpdir)());try{await L.promises.rename(W,T)}catch(B){return B.code==="ENOENT"?void 0:v(W)}v(T).catch(B=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function v(W){return(0,c.promisify)(L.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function h(W){if((0,D.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(W,T){return E(await(T?m(W):(0,c.promisify)(L.readdir)(W)))}async function m(W){try{return await(0,c.promisify)(L.readdir)(W,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const T=[],B=await u(W);for(const _ of B){let q=!1,x=!1,M=!1;try{const X=await e.Promises.lstat((0,C.join)(W,_));q=X.isFile(),x=X.isDirectory(),M=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}T.push({name:_,isFile:()=>q,isDirectory:()=>x,isSymbolicLink:()=>M})}return T}function p(W){return E(L.readdirSync(W))}e.readdirSync=p;function E(W){return W.map(T=>typeof T=="string"?S.isMacintosh?(0,R.normalizeNFC)(T):T:(T.name=S.isMacintosh?(0,R.normalizeNFC)(T.name):T.name,T))}async function P(W){const T=await u(W),B=[];for(const _ of T)await o.existsDirectory((0,C.join)(W,_))&&B.push(_);return B}function i(W,T=1e3){return new Promise(B=>{let _=!1;const q=setInterval(()=>{_||(_=!0,L.access(W,x=>{_=!1,x&&(clearInterval(q),B(void 0))}))},T)})}e.whenDeleted=i;var o;(function(W){async function T(q){let x;try{if(x=await e.Promises.lstat(q),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(S.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw M}}W.stat=T;async function B(q){try{const{stat:x,symbolicLink:M}=await W.stat(q);return x.isFile()&&M?.dangling!==!0}catch{}return!1}W.existsFile=B;async function _(q){try{const{stat:x,symbolicLink:M}=await W.stat(q);return x.isDirectory()&&M?.dangling!==!0}catch{}return!1}W.existsDirectory=_})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function n(W,T,B){return t.queueFor(w.URI.file(W),I.extUriBiasedIgnorePathCase).queue(()=>{const _=y(B);return new Promise((q,x)=>r(W,T,_,M=>M?x(M):q()))})}let s=!0;function a(W){s=W}e.configureFlushOnWrite=a;function r(W,T,B,_){if(!s)return L.writeFile(W,T,{mode:B.mode,flag:B.flag},_);L.open(W,B.flag,B.mode,(q,x)=>{if(q)return _(q);L.writeFile(x,T,M=>{if(M)return L.close(x,()=>_(M));L.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),a(!1)),L.close(x,Q=>_(Q))))})})}function l(W,T,B){const _=y(B);if(!s)return L.writeFileSync(W,T,{mode:_.mode,flag:_.flag});const q=L.openSync(W,_.flag,_.mode);try{L.writeFileSync(q,T);try{L.fdatasyncSync(q)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),a(!1)}}finally{L.closeSync(q)}}e.writeFileSync=l;function y(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function b(W,T){if(W!==T)try{await e.Promises.rename(W,T)}catch(B){if(W.toLowerCase()!==T.toLowerCase()&&B.code==="EXDEV"||W.endsWith("."))await O(W,T,{preserveSymlinks:!1}),await f(W,g.MOVE);else throw B}}async function O(W,T,B){return F(W,T,{root:{source:W,target:T},options:B,handledSourcePaths:new Set})}const N=511;async function F(W,T,B){if(B.handledSourcePaths.has(W))return;B.handledSourcePaths.add(W);const{stat:_,symbolicLink:q}=await o.stat(W);if(q){if(B.options.preserveSymlinks)try{return await Y(W,T,B)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(q.dangling)return}return _.isDirectory()?z(W,T,_.mode&N,B):G(W,T,_.mode&N)}async function z(W,T,B,_){await e.Promises.mkdir(T,{recursive:!0,mode:B});const q=await u(W);for(const x of q)await F((0,C.join)(W,x),(0,C.join)(T,x),_)}async function G(W,T,B){await e.Promises.copyFile(W,T),await e.Promises.chmod(T,B)}async function Y(W,T,B){let _=await e.Promises.readlink(W);(0,D.isEqualOrParent)(_,B.root.source,!S.isLinux)&&(_=(0,C.join)(B.root.target,_.substr(B.root.source.length+1))),await e.Promises.symlink(_,T)}e.Promises=new class{get access(){return(0,c.promisify)(L.access)}get stat(){return(0,c.promisify)(L.stat)}get lstat(){return(0,c.promisify)(L.lstat)}get utimes(){return(0,c.promisify)(L.utimes)}get read(){return(W,T,B,_,q)=>new Promise((x,M)=>{L.read(W,T,B,_,q,(X,Q,se)=>X?M(X):x({bytesRead:Q,buffer:se}))})}get readFile(){return(0,c.promisify)(L.readFile)}get write(){return(W,T,B,_,q)=>new Promise((x,M)=>{L.write(W,T,B,_,q,(X,Q,se)=>X?M(X):x({bytesWritten:Q,buffer:se}))})}get appendFile(){return(0,c.promisify)(L.appendFile)}get fdatasync(){return(0,c.promisify)(L.fdatasync)}get truncate(){return(0,c.promisify)(L.truncate)}get rename(){return(0,c.promisify)(L.rename)}get copyFile(){return(0,c.promisify)(L.copyFile)}get open(){return(0,c.promisify)(L.open)}get close(){return(0,c.promisify)(L.close)}get symlink(){return(0,c.promisify)(L.symlink)}get readlink(){return(0,c.promisify)(L.readlink)}get chmod(){return(0,c.promisify)(L.chmod)}get mkdir(){return(0,c.promisify)(L.mkdir)}get unlink(){return(0,c.promisify)(L.unlink)}get rmdir(){return(0,c.promisify)(L.rmdir)}get realpath(){return(0,c.promisify)(L.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return P}get writeFile(){return n}get rm(){return f}get move(){return b}get copy(){return O}}}),define(re[145],oe([0,1,53,13,4,27,28]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(c.isLinux)return g;const f=(0,A.dirname)(g);if(g===f)return g;const d=((0,A.basename)(g)||g).toLowerCase();try{const h=(0,D.readdirSync)(f).filter(u=>u.toLowerCase()===d);if(h.length===1){const u=R(f);if(u)return(0,A.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(d);if(u>=0){const m=R(f);if(m)return(0,A.join)(m,h[u])}}}catch{}return null}e.realcaseSync=R;async function C(g){if(c.isLinux)return g;const f=(0,A.dirname)(g);if(g===f)return g;const d=((0,A.basename)(g)||g).toLowerCase();try{const h=(await D.Promises.readdir(f)).filter(u=>u.toLowerCase()===d);if(h.length===1){const u=await C(f);if(u)return(0,A.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(d);if(u>=0){const m=await C(f);if(m)return(0,A.join)(m,h[u])}}}catch{}return null}e.realcase=C;async function S(g){try{return await D.Promises.realpath(g)}catch{const d=w(g);return await D.Promises.access(d,L.constants.R_OK),d}}e.realpath=S;function I(g){try{return L.realpathSync(g)}catch{const d=w(g);return L.accessSync(d,L.constants.R_OK),d}}e.realpathSync=I;function w(g){return(0,k.rtrim)((0,A.normalize)(g),A.sep)}}),define(re[93],oe([0,1,34,13,28]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,D=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(C||(C={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(P,i,o){this.exePath=P,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await c.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:E=!1}={}){return E?S===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:P=!1}={}){const i=g({useAlternateBitness:E});if(!i)return null;const o=A.join(i,"PowerShell");if(!await c.SymlinkSupport.existsDirectory(o))return null;let t=-1,n=null;for(const r of await c.Promises.readdir(o)){let l=-1;if(P){const b=r.indexOf("-");if(b<0)continue;const O=r.substring(0,b);if(!k.test(O)||r.substring(b+1)!=="preview")continue;l=parseInt(O,10)}else{if(!k.test(r))continue;l=parseInt(r,10)}if(l<=t)continue;const y=A.join(o,r,"pwsh.exe");!await c.SymlinkSupport.existsFile(y)||(n=y,t=l)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",a=P?" Preview":"";return new w(n,`PowerShell${a}${s}`,!0)}async function d({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const P=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await c.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await c.Promises.readdir(P))if(i.test(t)){const n=A.join(P,t,"pwsh.exe");return new w(n,o)}return null}function v(){const E=A.join(L.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function h(){const E=A.join(process.env.windir,S===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*u(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await d(),E&&(yield E),E=v(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=h(),E&&(yield E)}async function*m(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=m;async function p(){for await(const E of m())return E;return null}e.getFirstAvailablePowerShellInstallation=p}),define(re[94],oe([0,1,13,4,36,87,12,28]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function C(w=c.env){return w.comspec||"cmd.exe"}e.getWindowsShell=C;function S(w){let g=[],f=!1;const d=function(v){if(f){g.push(v);return}(!w.send(v,u=>{if(u&&console.error(u),f=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(p=>d(p))}})||A.isWindows)&&(f=!0)};return{send:d}}e.createQueuedSender=S;var I;(function(w){async function g(f,d,v){if(L.isAbsolute(f))return f;if(d===void 0&&(d=c.cwd()),L.dirname(f)!=="."||(v===void 0&&D.isString(c.env.PATH)&&(v=c.env.PATH.split(L.delimiter)),v===void 0||v.length===0))return L.join(d,f);async function u(m){if(await R.Promises.exists(m)){let p;try{p=await R.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(p=await R.Promises.lstat(m))}return p?!p.isDirectory():!1}return!1}for(const m of v){let p;if(L.isAbsolute(m)?p=L.join(m,f):p=L.join(d,m,f),await u(p))return p;let E=p+".com";if(await u(E)||(E=p+".exe",await u(E)))return E}return L.join(d,f)}w.findExecutable=g})(I=e.win32||(e.win32={}))}),define(re[146],oe([0,1,50,22]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function c(D){return new Promise((R,C)=>{let S;const I=new Map;function w(f,d,v,h,u){const m=I.get(d);if(f===D||m){const p={name:g(v),cmd:v,pid:f,ppid:d,load:h,mem:u};I.set(f,p),f===D&&(S=p),m&&(m.children||(m.children=[]),m.children.push(p),m.children.length>1&&(m.children=m.children.sort((E,P)=>E.pid-P.pid)))}}function g(f){const d=/--vscode-window-kind=shared-process/i,v=/--vscode-window-kind=issue-reporter/i,h=/--vscode-window-kind=process-explorer/i,u=/--utility-sub-type=network/i,m=/--vscode-utility-kind=extensionHost/i,p=/--vscode-utility-kind=fileWatcher/i,E=/--vscode-utility-kind=shared-process/i,P=/--ms-enable-electron-run-as-node/i,i=/--crashes-directory/i,o=/\\pipe\\winpty-control/i,t=/conhost\.exe/i,n=/--type=([a-zA-Z-]+)/;if(i.exec(f))return"electron-crash-reporter";if(o.exec(f))return"winpty-process";if(t.exec(f))return"console-window-host (Windows internal process)";let s=n.exec(f);if(s&&s.length===2)return s[1]==="renderer"?d.exec(f)?"shared-process":v.exec(f)?"issue-reporter":h.exec(f)?"process-explorer":"window":s[1]==="utility"?u.exec(f)?"utility-network-service":m.exec(f)?"extension-host":p.exec(f)?"file-watcher":E.exec(f)?"shared-process":"utility-process":s[1]==="extensionHost"?"extension-host":s[1];const a=/[a-zA-Z-]+\.js/g;let r="";do s=a.exec(f),s&&(r+=s+" ");while(s);return r&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${r})`:P.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{te(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(D,v=>{if(!v){C(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(v,h=>{const u=new Map;h.forEach(m=>{const p=f(m.commandLine||"");u.set(m.pid,{name:g(p),cmd:p,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=u.get(D),S?(u.forEach(m=>{const p=u.get(m.ppid);p&&(p.children||(p.children=[]),p.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((p,E)=>p.pid-E.pid))}),R(S)):C(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let f=function(){let d=[S];const v=[];for(;d.length;){const u=d.shift();u&&(v.push(u.pid),u.children&&(d=d.concat(u.children)))}let h=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+v.join(" "),(0,L.exec)(h,{},(u,m,p)=>{if(u||p)C(u||new Error(p.toString()));else{const E=m.toString().split(`
`);for(let P=0;P<v.length;P++){const i=I.get(v[P]);i.load=parseFloat(E[P])}if(!S){C(new Error(`Root process ${D} not found`));return}R(S)}})};(0,L.exec)("which ps",{},(d,v,h)=>{if(d||h)if(process.platform!=="linux")C(d||new Error(h.toString()));else{const u=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(u,{},(m,p,E)=>{m||E?C(m||new Error(E.toString())):(k(p,w),f())})}else{const u=v.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,E,P)=>{p||P&&!P.includes("screen size is bogus")?C(p||new Error(P.toString())):(k(E,w),process.platform==="linux"?f():S?R(S):C(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=c;function k(D,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=D.toString().split(`
`);for(const I of S){const w=C.exec(I.trim());w&&w.length===6&&R(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(re[147],oe([0,1,34,4,93,94]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(w,g){return w===1?A.isWindows?I():k.getWindowsShell(g):C(w,g)}e.getSystemShell=D;let R=null;function C(w,g){if(A.isLinux&&w===2||A.isMacintosh&&w===3)return"/bin/bash";if(!R){let f;if(A.isWindows)f="/bin/bash";else{if(f=g.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}R=f}return R}let S=null;async function I(){return S||(S=(await(0,c.getFirstAvailablePowerShellInstallation)()).exePath),S}});var ye=this&&this.__decorate||function(te,e,L,A){var c=arguments.length,k=c<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,L):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(te,e,L,A);else for(var R=te.length-1;R>=0;R--)(D=te[R])&&(k=(c<3?D(k):c>3?D(e,L,k):D(e,L))||k);return c>3&&k&&Object.defineProperty(e,L,k),k};define(re[39],oe([0,1,21,6,16,24,61,8,3,2,90,27,12]),function(te,e,L,A,c,k,D,R,C,S,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f||(f={}));function d(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function h(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(u||(u={}));function m(x){let M=0;for(let X=0;;X+=7){const Q=x.read(1);if(M|=(Q.buffer[0]&127)<<X,!(Q.buffer[0]&128))return M}}const p=t(0);function E(x,M){if(M===0){x.write(p);return}let X=0;for(let se=M;se!==0;se=se>>>7)X++;const Q=c.VSBuffer.alloc(X);for(let se=0;M!==0;se++)Q.buffer[se]=M&127,M=M>>>7,M>0&&(Q.buffer[se]|=128);x.write(Q)}class P{constructor(M){this.b=M,this.a=0}read(M){const X=this.b.slice(this.a,this.a+M);return this.a+=X.byteLength,X}}e.BufferReader=P;class i{constructor(){this.a=[]}get buffer(){return c.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=i;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function t(x){const M=c.VSBuffer.alloc(1);return M.writeUInt8(x,0),M}const n={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},s=typeof Buffer<"u";function a(x,M){if(typeof M>"u")x.write(n.Undefined);else if(typeof M=="string"){const X=c.VSBuffer.fromString(M);x.write(n.String),E(x,X.byteLength),x.write(X)}else if(s&&Buffer.isBuffer(M)){const X=c.VSBuffer.wrap(M);x.write(n.Buffer),E(x,X.byteLength),x.write(X)}else if(M instanceof c.VSBuffer)x.write(n.VSBuffer),E(x,M.byteLength),x.write(M);else if(Array.isArray(M)){x.write(n.Array),E(x,M.length);for(const X of M)a(x,X)}else if(typeof M=="number"&&(M|0)===M)x.write(n.Uint),E(x,M);else{const X=c.VSBuffer.fromString(JSON.stringify(M));x.write(n.Object),E(x,X.byteLength),x.write(X)}}e.serialize=a;function r(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(m(x)).toString();case o.Buffer:return x.read(m(x)).buffer;case o.VSBuffer:return x.read(m(x));case o.Array:{const X=m(x),Q=[];for(let se=0;se<X;se++)Q.push(r(x));return Q}case o.Object:return JSON.parse(x.read(m(x)).toString());case o.Int:return m(x)}}e.deserialize=r;class l{constructor(M,X,Q=null,se=1e3){this.h=M,this.j=X,this.k=Q,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(M,X){this.b.set(M,X),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const X=this.o([M.type]);this.k?.logOutgoing(X,0,1,h(M.type));return}case 201:case 202:case 204:case 203:{const X=this.o([M.type,M.id],M.data);this.k?.logOutgoing(X,M.id,1,h(M.type),M.data);return}}}o(M,X=void 0){const Q=new i;return a(Q,M),a(Q,X),this.p(Q.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const X=new P(M),Q=r(X),se=r(X),ae=Q[0];switch(ae){case 100:return this.k?.logIncoming(M.byteLength,Q[1],1,`${d(ae)}: ${Q[2]}.${Q[3]}`,se),this.s({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:se});case 102:return this.k?.logIncoming(M.byteLength,Q[1],1,`${d(ae)}: ${Q[2]}.${Q[3]}`,se),this.t({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:se});case 101:return this.k?.logIncoming(M.byteLength,Q[1],1,`${d(ae)}`),this.u({type:ae,id:Q[1]});case 103:return this.k?.logIncoming(M.byteLength,Q[1],1,`${d(ae)}`),this.u({type:ae,id:Q[1]})}}s(M){const X=this.b.get(M.channelName);if(!X){this.v(M);return}const Q=new k.CancellationTokenSource;let se;try{se=X.call(this.j,M.name,M.arg,Q.token)}catch(j){se=Promise.reject(j)}const ae=M.id;se.then(j=>{this.m({id:ae,data:j,type:201}),this.d.delete(M.id)},j=>{j instanceof Error?this.m({id:ae,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:ae,data:j,type:203}),this.d.delete(M.id)});const V=(0,S.toDisposable)(()=>Q.cancel());this.d.set(M.id,V)}t(M){const X=this.b.get(M.channelName);if(!X){this.v(M);return}const Q=M.id,ae=X.listen(this.j,M.name,M.arg)(V=>this.m({id:Q,data:V,type:204}));this.d.set(M.id,ae)}u(M){const X=this.d.get(M.id);X&&(X.dispose(),this.d.delete(M.id))}v(M){let X=this.g.get(M.channelName);X||(X=[],this.g.set(M.channelName,X));const Q=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:M,timeoutTimer:Q})}w(M){const X=this.g.get(M);if(X){for(const Q of X)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var y;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,X=null){this.l=M,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=X}getChannel(M){const X=this;return{call(Q,se,ae){return X.a?Promise.reject(new R.CancellationError):X.m(M,Q,se,ae)},listen(Q,se){return X.a?C.Event.None:X.o(M,Q,se)}}}m(M,X,Q,se=k.CancellationToken.None){const ae=this.g++,j={id:ae,type:100,channelName:M,name:X,arg:Q};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let U;return new Promise((H,ee)=>{if(se.isCancellationRequested)return ee(new R.CancellationError);const K=()=>{const he=me=>{switch(me.type){case 201:this.f.delete(ae),H(me.data);break;case 202:{this.f.delete(ae);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,ee(pe);break}case 203:this.f.delete(ae),ee(me.data);break}};this.f.set(ae,he),this.p(j)};let Z=null;this.b===u.Idle?K():(Z=(0,A.createCancelablePromise)(he=>this.u()),Z.then(()=>{Z=null,K()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.p({id:ae,type:101}),ee(new R.CancellationError)},le=se.onCancellationRequested(ie);U=(0,S.combinedDisposable)((0,S.toDisposable)(ie),le),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(M,X,Q){const se=this.g++,V={id:se,type:102,channelName:M,name:X,arg:Q};let j=null;const U=new C.Emitter({onWillAddFirstListener:()=>{j=(0,A.createCancelablePromise)(H=>this.u()),j.then(()=>{j=null,this.d.add(U),this.p(V)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(U),this.p({id:se,type:103}))}}),$=H=>U.fire(H.data);return this.f.set(se,$),U.event}p(M){switch(M.type){case 100:case 102:{const X=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(X,M.id,0,`${d(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const X=this.q([M.type,M.id]);this.j?.logOutgoing(X,M.id,0,d(M.type));return}}}q(M,X=void 0){const Q=new i;return a(Q,M),a(Q,X),this.r(Q.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const X=new P(M),Q=r(X),se=r(X),ae=Q[0];switch(ae){case 200:return this.j?.logIncoming(M.byteLength,0,0,h(ae)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,Q[1],0,h(ae),se),this.t({type:Q[0],id:Q[1],data:se})}}t(M){if(M.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([D.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class O{get connections(){const M=[];return this.f.forEach(X=>M.push(X)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new C.Emitter,this.onDidAddConnection=this.g.event,this.h=new C.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:X,onDidClientDisconnect:Q})=>{C.Event.once(X.onMessage)(ae=>{const V=new P(ae),j=r(V),U=new l(X,j),$=new b(X);this.a.forEach((ee,K)=>U.registerChannel(K,ee));const H={channelServer:U,channelClient:$,ctx:j};this.f.add(H),this.g.fire(H),Q(()=>{U.dispose(),$.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(M,X){const Q=this;return{call(se,ae,V){let j;if((0,g.isFunction)(X)){const $=(0,L.getRandomElement)(Q.connections.filter(X));j=$?Promise.resolve($):C.Event.toPromise(C.Event.filter(Q.onDidAddConnection,X))}else j=X.routeCall(Q,se,ae);const U=j.then($=>$.channelClient.getChannel(M));return F(U).call(se,ae,V)},listen(se,ae){if((0,g.isFunction)(X))return Q.j(M,X,se,ae);const V=X.routeEvent(Q,se,ae).then(j=>j.channelClient.getChannel(M));return F(V).listen(se,ae)}}}j(M,X,Q,se){const ae=this;let V=new S.DisposableStore;const j=new C.Emitter({onWillAddFirstListener:()=>{V=new S.DisposableStore;const U=new C.EventMultiplexer,$=new Map,H=K=>{const ie=K.channelClient.getChannel(M).listen(Q,se),le=U.add(ie);$.set(K,le)},ee=K=>{const Z=$.get(K);!Z||(Z.dispose(),$.delete(K))};ae.connections.filter(X).forEach(H),C.Event.filter(ae.onDidAddConnection,X)(H,void 0,V),ae.onDidRemoveConnection(ee,void 0,V),U.event(j.fire,j,V),V.add(U)},onDidRemoveLastListener:()=>{V.dispose()}});return j.event}registerChannel(M,X){this.a.set(M,X),this.f.forEach(Q=>{Q.channelServer.registerChannel(M,X)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(M,X,Q=null){const se=new i;a(se,X),M.send(se.buffer),this.a=new b(M,Q),this.d=new l(M,X,Q)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,X){this.d.registerChannel(M,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function F(x){return{call(M,X,Q){return x.then(se=>se.call(M,X,Q))},listen(M,X){const Q=new C.Relay;return x.then(se=>Q.input=se.listen(M,X)),Q.event}}}e.getDelayedChannel=F;function z(x){let M=!1;return{call(X,Q,se){return M?x.call(X,Q,se):(0,A.timeout)(0).then(()=>M=!0).then(()=>x.call(X,Q,se))},listen(X,Q){if(M)return x.listen(X,Q);const se=new C.Relay;return(0,A.timeout)(0).then(()=>M=!0).then(()=>se.input=x.listen(X,Q)),se.event}}}e.getNextTickChannel=z;class G{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const X of M.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await C.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=G;var Y;(function(x){function M(ae,V){const j=ae,U=V&&V.disableMarshalling,$=new Map;for(const H in j)Q(H)&&$.set(H,C.Event.buffer(j[H],!0));return new class{listen(H,ee,K){const Z=$.get(ee);if(Z)return Z;if(se(ee)){const ie=j[ee];if(typeof ie=="function")return ie.call(j,K)}throw new Error(`Event not found: ${ee}`)}call(H,ee,K){const Z=j[ee];if(typeof Z=="function"){if(!U&&Array.isArray(K))for(let ie=0;ie<K.length;ie++)K[ie]=(0,I.revive)(K[ie]);return Z.apply(j,K)}throw new Error(`Method not found: ${ee}`)}}}x.fromService=M;function X(ae,V){const j=V&&V.disableMarshalling;return new Proxy({},{get(U,$){if(typeof $=="string")return V?.properties?.has($)?V.properties.get($):se($)?function(H){return ae.listen($,H)}:Q($)?ae.listen($):async function(...H){let ee;V&&!(0,g.isUndefinedOrNull)(V.context)?ee=[V.context,...H]:ee=H;const K=await ae.call($,ee);return j?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String($)}`)}})}x.toService=X;function Q(ae){return ae[0]==="o"&&ae[1]==="n"&&w.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&w.isUpperAsciiLetter(ae.charCodeAt(9))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const M=x.toString();if(M!=="[object Object]")return M}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function _(x,M,X,Q,se,ae,V){V=B(V);const j=W[se],U=j[Q%j.length];let $=[`%c[${x}]%c[${String(M).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?($=$.concat(V),$.push(")")):$.push(V),console.log.apply(console,$)}class q{constructor(M,X){this.d=M,this.f=X,this.a=0,this.b=0}logOutgoing(M,X,Q,se,ae){this.b+=M,_(this.d,this.b,M,X,Q,se,ae)}logIncoming(M,X,Q,se,ae){this.a+=M,_(this.f,this.a,M,X,Q,se,ae)}}e.IPCLogger=q}),define(re[148],oe([0,1,16,3,39]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(C){this.a=C,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",S=>L.VSBuffer.wrap(S.data)),C.start()}send(C){this.a.postMessage(C.buffer)}disconnect(){this.a.close()}}e.Protocol=k;class D extends c.IPCClient{constructor(C,S){const I=new k(C);super(I,S),this.b=I}dispose(){this.b.disconnect()}}e.Client=D}),define(re[95],oe([0,1,6,16,3,2,39]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(b){b.enableDiagnostics=!1,b.records=[];const O=new WeakMap;let N=0;function F(G,Y){if(!O.has(G)){const W=String(++N);O.set(G,W)}return O.get(G)}function z(G,Y,W,T){if(!b.enableDiagnostics)return;const B=F(G,Y);if(T instanceof A.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const _=A.VSBuffer.alloc(T.byteLength);_.set(T),b.records.push({timestamp:Date.now(),id:B,label:Y,type:W,buff:_})}else b.records.push({timestamp:Date.now(),id:B,label:Y,type:W,data:T})}b.traceSocketEvent=z})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function w(){return I||(I=A.VSBuffer.alloc(0)),I}class g{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,N){if(O===0)return w();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const Y=this.a[0];return N&&(this.a.shift(),this.b-=O),Y}if(this.a[0].byteLength>O){const Y=this.a[0].slice(0,O);return N&&(this.a[0]=this.a[0].slice(O),this.b-=O),Y}const F=A.VSBuffer.alloc(O);let z=0,G=0;for(;O>0;){const Y=this.a[G];if(Y.byteLength>O){const W=Y.slice(0,O);F.set(W,z),z+=O,N&&(this.a[G]=Y.slice(O),this.b-=O),O-=O}else F.set(Y,z),z+=Y.byteLength,N?(this.a.shift(),this.b-=Y.byteLength):G++,O-=Y.byteLength}return F}}e.ChunkStream=g;var f;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function d(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(O,N,F,z){this.type=O,this.id=N,this.ack=F,this.data=z,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends k.Disposable{constructor(O){super(),this.f=this.B(new c.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new g,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,z=this.g.id,G=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new h(F,z,G,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=A.VSBuffer.alloc(13);N.writeUInt8(O.type,0),N.writeUInt32BE(O.id,1),N.writeUInt32BE(O.ack,5),N.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(N,O.data)}g(O,N){const F=this.f===0;return this.d.push(O,N),this.f+=O.byteLength+N.byteLength,F}h(){const O=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,N){this.g(O,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class p extends k.Disposable{constructor(O){super(),this.f=new c.Emitter,this.onMessage=this.f.event,this.g=new c.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new m(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new h(1,0,0,O))}}e.Protocol=p;class E extends D.IPCClient{static fromSocket(O,N){return new E(new p(O),N)}get onDidDispose(){return this.b.onDidDispose}constructor(O,N,F=null){super(O,N,F),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=E;class P{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=P;class i{constructor(O){this.data=O,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let O=0,N=this.a;for(;N;)N=N.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let N=0,F=this.a;for(;F;)O[N++]=F.data,F=F.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const N=new i(O);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const O=Date.now();for(let N=0;N<t.a;N++)this.c[N]=O-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),N=(1+t.a)*1e3;let F=0;for(let z=0;z<t.a;z++)O-this.c[z]<=N&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var n;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function s(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=a;class r{constructor(O,N){this.roundTripTime=O,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=r;class l{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new P,this.onControlMessage=this.x.event,this.y=new P,this.onMessage=this.y.event,this.z=new P,this.onDidDispose=this.z.event,this.A=new P,this.onSocketClose=this.A.event,this.B=new P,this.onSocketTimeout=this.B.event,this.C=new P,this.onHighRoundTripTime=this.C.event,this.D=new P,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??t.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new k.DisposableStore,this.o=O.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new h(5,0,0,w());this.p.write(O),this.p.flush()}sendPause(){const O=new h(7,0,0,w());this.p.write(O)}sendResume(){const O=new h(8,0,0,w());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,N){this.a=!0,this.t.dispose(),this.t=new k.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new h(3,0,this.h,w());this.p.write(O);const N=this.b.toArray();for(let F=0,z=N.length;F<z;F++)this.p.write(N[F]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const N=this.b.peek();if(N&&N.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new h(6,0,0,w())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let F=0,z=N.length;F<z;F++)this.p.write(N[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const N=++this.c;this.h=this.g;const F=new h(1,N,this.h,O);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(O){const N=new h(2,0,0,O);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),N=Date.now()-O.writtenTime,F=Date.now()-this.q.lastReadTime,z=Date.now()-this.n;if(N>=2e4&&F>=2e4&&z>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:F});return}const G=Math.max(2e4-N,2e4-F,2e4-z,500);this.f=setTimeout(()=>{this.f=null,this.G()},G)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new h(3,0,this.h,w());this.p.write(O)}I(){this.h=this.g;const O=new h(9,0,this.h,w());this.p.write(O)}J(O){this.h=this.g;const N=new h(10,0,this.h,O);this.p.write(N)}K(O){this.h=this.g;const N=new h(11,0,this.h,O);this.p.write(N)}}e.PersistentProtocol=l;class y extends k.Disposable{constructor(){super(),this.a=this.B(new c.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new c.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new c.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,N=A.VSBuffer.alloc(4);N.writeUInt32BE(O,0),this.a.fire(N)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const N=O.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const F=Date.now()-this.g,z=this.k++;this.j[z%this.j.length]=F;const G=this.l,Y=this.j.filter(W=>W>=1e3).length;this.l=Y>=3?1:0,F>1e3&&this.b.fire(new r(F,Y)),G!==this.l&&this.c.fire(this.l)}}}),define(re[149],oe([0,1,150,3,39,148]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class D extends c.IPCServer{static b(){const C=A.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(S,I)=>I);return A.Event.map(C,S=>{const{port1:I,port2:w}=new MessageChannel,f={protocol:new k.Protocol(I),onDidClientDisconnect:A.Event.fromDOMEventEmitter(I,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[w]),f})}constructor(){super(D.b())}}e.Server=D}),define(re[65],oe([0,1,50,6,16,24,143,8,3,2,32,94,87,39]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends f.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",m=>c.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new C.Emitter,this.onDidProcessExit=this.h.event;const p=m&&m.timeout?m.timeout:6e4;this.b=new A.Delayer(p),this.d=null,this.f=null}getChannel(u){const m=this;return{call(p,E,P){return m.k(u,p,E,P)},listen(p,E){return m.l(u,p,E)}}}k(u,m,p,E=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const P=this.n(u),i=(0,A.createCancelablePromise)(n=>P.call(m,p,n)),o=E.onCancellationRequested(()=>i.cancel()),t=(0,S.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,m,p){if(!this.b)return C.Event.None;this.b.cancel();let E;const P=new C.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(m,p)(P.fire,P),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(m.env),this.d=(0,L.fork)(this.i,u,m);const p=new C.Emitter;C.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.j.serverName}`);return}p.fire(c.VSBuffer.wrap(Buffer.from(s,"base64")))});const P=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&P.send(s.buffer.toString("base64")),o=p.event,t={send:i,onMessage:o};this.f=new f.ChannelClient(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",n),this.c.forEach(r=>(0,S.dispose)(r)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(re[151],oe([0,1,86,16,39,3,12,21]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class C{constructor(g){this.a=g,this.onMessage=k.Event.fromNodeEventEmitter(this.a,"message",f=>A.VSBuffer.wrap(f.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class S extends c.IPCServer{static b(){(0,D.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const g=new k.Emitter;return process.parentPort.on("message",f=>{const d=(0,R.firstOrDefault)(f.ports);d&&g.fire(d)}),k.Event.map(g.event,f=>({protocol:new C(f),onDidClientDisconnect:k.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(S.b())}}e.Server=S;function I(w,g,f){const d=v=>{v.data===g&&(w.removeListener("message",d),f())};w.on("message",d)}e.once=I}),define(re[152],oe([0,1,16,8,3,2,13,4,31,39,95]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class g{traceSocketEvent(r,l){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,l)}constructor(r,l=""){this.f=!0,this.debugLabel=l,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,A.onUnexpectedError)(y)}},this.socket.on("error",this.a),this.b=y=>{this.traceSocketEvent("close",{hadError:y}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const l=y=>{this.traceSocketEvent("read",y),r(L.VSBuffer.wrap(y))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(r){const l=y=>{r({type:0,hadError:y,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(r){const l=()=>{r()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,A.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,A.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=g;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize",a[a.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class v extends k.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,l){this.socket.traceSocketEvent(r,l)}constructor(r,l,y,b){super(),this.f=this.B(new c.Emitter),this.g=this.B(new c.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:y?.byteLength||0,recordInflateBytes:b}),this.a=this.B(new h(this,l,y,b,this.f,(O,N)=>this.k(O,N))),this.B(this.a.onError(O=>{console.error(O),(0,A.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new I.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){let l=0;for(;l<r.byteLength;)this.a.writeMessage(r.slice(l,Math.min(l+262144,r.byteLength))),l+=262144}k(r,l){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let y=2;r.byteLength<126?y+=0:r.byteLength<2**16?y+=2:y+=8;const b=L.VSBuffer.alloc(y);if(l?b.writeUInt8(194,0):b.writeUInt8(130,0),r.byteLength<126)b.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){b.writeUInt8(126,1);let O=1;b.writeUInt8(r.byteLength>>>8&255,++O),b.writeUInt8(r.byteLength>>>0&255,++O)}else{b.writeUInt8(127,1);let O=1;b.writeUInt8(0,++O),b.writeUInt8(0,++O),b.writeUInt8(0,++O),b.writeUInt8(0,++O),b.writeUInt8(r.byteLength>>>24&255,++O),b.writeUInt8(r.byteLength>>>16&255,++O),b.writeUInt8(r.byteLength>>>8&255,++O),b.writeUInt8(r.byteLength>>>0&255,++O)}this.socket.write(L.VSBuffer.concat([b,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const l=this.b.peek(this.j.readLen),y=l.readUInt8(0),b=(y&128)>>>7,O=(y&64)>>>6,N=l.readUInt8(1),F=(N&128)>>>7,z=N&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=b,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(b),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const l=this.b.read(this.j.readLen),y=l.readUInt8(1),b=(y&128)>>>7;let O=y&127,N=1;O===126?O=l.readUInt8(++N)*2**8+l.readUInt8(++N):O===127&&(O=l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N));let F=0;b&&(F=l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N)),this.j.state=3,this.j.readLen=O,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const l=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),p(l,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(l,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class h extends k.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(r,l,y,b,O,N){super(),this.l=r,this.m=O,this.n=N,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new c.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new c.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,l?(this.b=this.B(new u(this.l,b,y,{windowBits:15})),this.f=this.B(new m(this.l,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const l=await this.s(this.f,r);this.n(l,!0)}else this.n(r,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(r,l){return new Promise((y,b)=>{r.write(l),r.flush(O=>y(O))})}acceptFrame(r,l,y){this.h.push({data:r,isCompressed:l,isLastFrameOfMessage:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const l=await this.w(this.b,r.data,r.isLastFrameOfMessage);this.m.fire(l)}else this.m.fire(r.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(r,l,y){return new Promise((b,O)=>{r.write(l),y&&r.write(L.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>b(N))})}}class u extends k.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(r,l,y,b){super(),this.h=r,this.j=l,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=w().zlib.createInflateRaw(b),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(L.VSBuffer.wrap(O))}),y&&(this.h.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this.b.write(y.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const l=L.VSBuffer.concat(this.g);this.g.length=0,r(l)})}}class m extends k.Disposable{constructor(r,l){super(),this.g=r,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.b=w().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",y=>{this.g.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this.a.fire(y)}),this.b.on("data",y=>{this.g.traceSocketEvent("zlibDeflateData",y),this.f.push(L.VSBuffer.wrap(y))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let l=L.VSBuffer.concat(this.f);this.f.length=0,l=l.slice(0,l.byteLength-4),r(l)})}}function p(a,r){if(r===0)return;const l=a.byteLength>>>2;for(let z=0;z<l;z++){const G=a.readUInt32BE(z*4);a.writeUInt32BE(G^r,z*4)}const y=l*4,b=a.byteLength-y,O=r>>>24&255,N=r>>>16&255,F=r>>>8&255;b>=1&&a.writeUInt8(a.readUInt8(y)^O,y),b>=2&&a.writeUInt8(a.readUInt8(y+1)^N,y+1),b>=3&&a.writeUInt8(a.readUInt8(y+2)^F,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function P(){const a=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;const r=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:w().os.tmpdir(),l=(0,D.join)(r,`vscode-ipc-${a}.sock`);return o(l),l}e.createRandomIPCHandle=P;function i(a,r,l){const y=w().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${l}-${r}-sock`;const b=l.substr(0,4),O=r.substr(0,6),N=y.substr(0,8);let F;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${b}-${O}.sock`):F=(0,D.join)(a,`${b}-${O}.sock`),o(F),F}e.createStaticIPCHandle=i;function o(a){const r=E[R.platform];typeof r=="number"&&a.length>=r&&console.warn(`WARNING: IPC handle "${a}" is longer than ${r} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(r){const l=c.Event.fromNodeEventEmitter(r,"connection");return c.Event.map(l,y=>({protocol:new I.Protocol(new g(y,"ipc-server-connection")),onDidClientDisconnect:c.Event.once(c.Event.fromNodeEventEmitter(y,"close"))}))}constructor(r){super(t.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function n(a){return new Promise((r,l)=>{const y=w().net.createServer();y.on("error",l),y.listen(a,()=>{y.removeListener("error",l),r(new t(y))})})}e.serve=n;function s(a,r){return new Promise((l,y)=>{const b=w().net.createConnection(a,()=>{b.removeListener("error",y),l(I.Client.fromSocket(new g(b,`ipc-client${r}`),r))});b.once("error",y)})}e.connect=s}),define(re[66],oe([0,1,6,3,2,12]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function R(w){const g=w;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class S extends c.Disposable{constructor(g,f=Object.create(null)){super(),this.m=g,this.n=f,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=C.None,this.f=new Map,this.g=new L.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((f,d)=>this.s(d,f)),g.deleted?.forEach(f=>this.s(f,void 0))}s(g,f){if(this.c===C.Closed)return;let d=!1;(0,k.isUndefinedOrNull)(f)?d=this.f.delete(g):this.f.get(g)!==f&&(this.f.set(g,f),d=!0),d&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===C.None&&(this.c=C.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,f){const d=this.f.get(g);return(0,k.isUndefinedOrNull)(d)?f:d}getBoolean(g,f){const d=this.get(g);return(0,k.isUndefinedOrNull)(d)?f:d==="true"}getNumber(g,f){const d=this.get(g);return(0,k.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(g,f){if(this.c===C.Closed)return;if((0,k.isUndefinedOrNull)(f))return this.delete(g);const d=String(f);if(this.f.get(g)!==d)return this.f.set(g,d),this.j.set(g,d),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===C.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=C.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}S.a=100,e.Storage=S;class I{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((f,d)=>this.a.set(d,f)),g.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(re[153],oe([9,7]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[154],oe([9,7]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[155],oe([9,7]),function(te,e){return te.create("vs/platform/environment/node/argv",e)}),define(re[156],oe([9,7]),function(te,e){return te.create("vs/platform/environment/node/argvHelper",e)}),define(re[157],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[158],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[159],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[160],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(re[161],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[162],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[163],oe([9,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[164],oe([9,7]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[165],oe([9,7]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[166],oe([9,7]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[167],oe([9,7]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[168],oe([9,7]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[169],oe([9,7]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[170],oe([9,7]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[171],oe([9,7]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[172],oe([9,7]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[173],oe([9,7]),function(te,e){return te.create("vs/platform/shell/node/shellEnv",e)}),define(re[174],oe([9,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[175],oe([9,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[176],oe([9,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[177],oe([9,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[178],oe([9,7]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[179],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[180],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[181],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[182],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[183],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[184],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[185],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[186],oe([9,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[187],oe([9,7]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[188],oe([0,1,8]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(A=e.TokenType||(e.TokenType={}));class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(D){if(D.type!==19)throw(0,L.illegalArgument)(`expected an error token but got ${JSON.stringify(D)}`);switch(D.lexeme){case"=":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '||'?`;default:{const R=D.lexeme;return R&&R.length>1&&R.startsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to close the string?`:R&&R.length>1&&R.endsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to open the string?`:`Unexpected token '${D.lexeme}' at offset ${D.offset}`}}}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(){const D={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(D),this.f.push(D)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const R=this.c.substring(this.d,this.e),C=c.b.get(R);C?this.k(C):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,R=!1,C=!1;for(;;){if(D>=this.c.length){this.e=D,this.l();return}const I=this.c.charCodeAt(D);if(R)R=!1;else if(I===47&&!C){D++;break}else I===91?C=!0:I===92?R=!0:I===93&&(C=!1);D++}for(;D<this.c.length&&c.a.has(this.c.charCodeAt(D));)D++;this.e=D;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}c.a=new Set(["i","g","s","m","y","u"].map(k=>k.charCodeAt(0))),c.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=c}),define(re[189],oe([0,1,63,61,22,13,36,25,10]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,k.dirname)(c.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?C.URI.file((0,k.join)(f,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.resolve)(f):(0,k.normalize)((0,k.join)(c.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?C.URI.file((0,k.resolve)(f)):C.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.resolve)(f);const d=D.env.VSCODE_EXTENSIONS;if(d)return d;const v=D.env.VSCODE_PORTABLE;return v?(0,k.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(d=>/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file((0,k.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,k.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const d of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(d);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?C.URI.file((0,k.join)(f,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,d,v){this.a=f,this.b=d,this.c=v,this.editSessionId=this.args.editSessionId}}ye([A.memoize],S.prototype,"appRoot",null),ye([A.memoize],S.prototype,"userHome",null),ye([A.memoize],S.prototype,"userDataPath",null),ye([A.memoize],S.prototype,"appSettingsHome",null),ye([A.memoize],S.prototype,"tmpDir",null),ye([A.memoize],S.prototype,"cacheHome",null),ye([A.memoize],S.prototype,"stateResource",null),ye([A.memoize],S.prototype,"userRoamingDataHome",null),ye([A.memoize],S.prototype,"userDataSyncHome",null),ye([A.memoize],S.prototype,"userDataSyncLogResource",null),ye([A.memoize],S.prototype,"editSessionsLogResource",null),ye([A.memoize],S.prototype,"sync",null),ye([A.memoize],S.prototype,"machineSettingsResource",null),ye([A.memoize],S.prototype,"workspaceStorageHome",null),ye([A.memoize],S.prototype,"localHistoryHome",null),ye([A.memoize],S.prototype,"keyboardLayoutResource",null),ye([A.memoize],S.prototype,"argvResource",null),ye([A.memoize],S.prototype,"isExtensionDevelopment",null),ye([A.memoize],S.prototype,"untitledWorkspacesHome",null),ye([A.memoize],S.prototype,"installSourcePath",null),ye([A.memoize],S.prototype,"builtinExtensionsPath",null),ye([A.memoize],S.prototype,"extensionsPath",null),ye([A.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([A.memoize],S.prototype,"extensionDevelopmentKind",null),ye([A.memoize],S.prototype,"extensionTestsLocationURI",null),ye([A.memoize],S.prototype,"debugExtensionHost",null),ye([A.memoize],S.prototype,"logLevel",null),ye([A.memoize],S.prototype,"extensionLogLevel",null),ye([A.memoize],S.prototype,"serviceMachineIdResource",null),ye([A.memoize],S.prototype,"telemetryLogResource",null),ye([A.memoize],S.prototype,"disableWorkspaceTrust",null),ye([A.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function I(g,f){return w(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function w(g,f,d,v,h,u){const p=Number(f||g)||(v?null:d),E=p?Boolean(!!f):!1;let P;if(u)try{P=JSON.parse(u)}catch{}return{port:p,break:E,debugId:h,env:P}}e.parseDebugParams=w}),define(re[190],oe([0,1,291,4,155]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,c.localize)(0,null),e:(0,c.localize)(1,null),t:(0,c.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,c.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,c.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,c.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,c.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,c.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,c.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,c.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,c.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,c.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,c.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,c.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,c.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,c.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,c.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,c.localize)(17,null)},category:{type:"string",cat:"e",description:(0,c.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,c.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,c.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,c.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,c.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,c.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,c.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,c.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,c.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,c.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,c.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,c.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,c.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,c.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,c.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,c.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,c.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,c.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(v,h,u=D){const m=v.find(a=>a.length>0&&a[0]!=="-"),p={},E=["_"],P=[],i={};let o;for(const a in h){const r=h[a];r.type==="subcommand"?a===m&&(o=r):(r.alias&&(p[a]=r.alias),r.type==="string"||r.type==="string[]"?(E.push(a),r.deprecates&&E.push(...r.deprecates)):r.type==="boolean"&&(P.push(a),r.deprecates&&P.push(...r.deprecates)),r.global&&(i[a]=r))}if(o&&m){const a=i;for(const b in o.options)a[b]=o.options[b];const r=v.filter(b=>b!==m),l=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,y=R(r,a,l);return{[m]:y,_:[]}}const t=L(v,{string:E,boolean:P,alias:p}),n={},s=t;n._=t._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in h){const r=h[a];if(r.type==="subcommand")continue;r.alias&&delete s[r.alias];let l=s[a];if(r.deprecates)for(const y of r.deprecates)s.hasOwnProperty(y)&&(l||(l=s[y],l&&u.onDeprecatedOption(y,r.deprecationMessage||(0,c.localize)(36,null,a))),delete s[y]);if(typeof l<"u"){if(r.type==="string[]"){if(Array.isArray(l)||(l=[l]),!r.allowEmptyValue){const y=l.filter(b=>b.length>0);y.length!==l.length&&(u.onEmptyValue(a),l=y.length>0?y:void 0)}}else r.type==="string"&&(Array.isArray(l)?(l=l.pop(),u.onMultipleValues(a,l)):!l&&!r.allowEmptyValue&&(u.onEmptyValue(a),l=void 0));n[a]=l,r.deprecationMessage&&u.onDeprecatedOption(a,r.deprecationMessage)}delete s[a]}for(const a in s)u.onUnknownOption(a);return n}e.parseArgs=R;function C(v,h){let u="";return h.args&&(Array.isArray(h.args)?u=` <${h.args.join("> <")}>`:u=` <${h.args}>`),h.alias?`-${h.alias} --${v}${u}`:`--${v}${u}`}function S(v,h){const u=[];for(const m in v){const p=v[m],E=C(m,p);u.push([E,p.description])}return I(u,h)}e.formatOptions=S;function I(v,h){const m=v.reduce((P,i)=>Math.max(P,i[0].length),12)+2+1;if(h-m<25)return v.reduce((P,i)=>P.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const p=h-m-1,E=[];for(const P of v){const i=P[0],o=g(P[1],p),t=w(m-i.length-2);E.push("  "+i+t+o[0]);for(let n=1;n<o.length;n++)E.push(w(m)+o[n])}return E}function w(v){return" ".repeat(v)}function g(v,h){const u=[];for(;v.length;){const m=v.length<h?v.length:v.lastIndexOf(" ",h),p=v.slice(0,m).trim();v=v.slice(m),u.push(p)}return u}function f(v,h,u,m,p){const E=process.stdout.isTTY&&process.stdout.columns||80,P=p?.noInputFiles!==!0?`[${(0,c.localize)(37,null)}...]`:"",i=[`${v} ${u}`];i.push(""),i.push(`${(0,c.localize)(38,null)}: ${h} [${(0,c.localize)(39,null)}]${P}`),i.push(""),p?.noPipe!==!0&&(A.isWindows?i.push((0,c.localize)(40,null,h)):i.push((0,c.localize)(41,null,h)),i.push(""));const o={},t=[];for(const n in m){const s=m[n];if(s.type==="subcommand")s.description&&t.push({command:n,description:s.description});else if(s.description&&s.cat){let a=o[s.cat];a||(o[s.cat]=a={}),a[n]=s}}for(const n in o){const s=n,a=o[s];a&&(i.push(k[s]),i.push(...S(a,E)),i.push(""))}return t.length&&(i.push((0,c.localize)(42,null)),i.push(...I(t.map(n=>[n.command,n.description]),E)),i.push("")),i.join(`
`)}e.buildHelpMessage=f;function d(v,h){return`${v||(0,c.localize)(43,null)}
${h||(0,c.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(re[191],oe([0,1,292,156,190]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function D(g,f){const d=(E,P)=>{console.warn((0,A.localize)(0,null,E,P))},v=E=>{console.warn((0,A.localize)(1,null,E))},h=(E,P)=>{console.warn((0,A.localize)(2,null,E,P))},u=E=>({onUnknownOption:P=>{E!=="tunnel"&&console.warn((0,A.localize)(3,null,P,E))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:h,getSubcommandReporter:E!=="tunnel"?u:void 0}),m={onUnknownOption:E=>{console.warn((0,A.localize)(4,null,E))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:h,getSubcommandReporter:u},p=(0,c.parseArgs)(g,c.OPTIONS,f?m:void 0);return p.goto&&p._.forEach(E=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,A.localize)(5,null))),p["max-memory"]&&L(parseInt(p["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),p}function R(g){const f=g.findIndex(d=>!/^-/.test(d));if(f>-1)return[...g.slice(0,f),...g.slice(f+1)]}function C(g){let[,...f]=g;process.env.VSCODE_DEV&&(f=R(f)||[]);const d=!w(process.env);return D(f,d)}e.parseMainProcessArgv=C;function S(g){let[,,...f]=g;return process.env.VSCODE_DEV&&(f=R(f)||[]),D(f,!0)}e.parseCLIProcessArgv=S;function I(g,...f){const d=g.indexOf("--");return d===-1?g.push(...f):g.splice(d,0,...f),g}e.addArg=I;function w(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function te(e,L,A){function c(D,R){const C=k(D,R),S=[C];return e.isAbsolute(C)||S.unshift(A),e.resolve(...S)}function k(D,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(w,"AppData","Roaming")}break;case"darwin":S=e.join(L.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:c}}if(typeof define=="function")define(re[192],oe([293,34,36]),function(e,L,A){return te(e,L,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=te(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[96],oe([0,1,34,189,192]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class k extends A.AbstractNativeEnvironmentService{constructor(S,I){super(S,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,c.getUserDataPath)(S,I.nameShort)},I)}}e.NativeEnvironmentService=k;function D(C,S){return(0,A.parseDebugParams)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,S,C.extensionEnvironment)}e.parsePtyHostDebugPort=D;function R(C,S){return(0,A.parseDebugParams)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,S,C.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(re[193],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const A=/^([^@:]+@)?([^:]+):/,c=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,D=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(h){const u=h.match(D);return u?u[1]:null}function I(h){if(h.indexOf("://")===-1){const u=h.match(A);return u?S(u[2]):null}try{const u=L.URI.parse(h);if(u.authority)return S(u.authority)}catch{}return null}function w(h,u){const m=new Set;let p;for(;p=R.exec(h);){const P=I(p[1]);P&&m.add(P)}const E=new Set(u);return Array.from(m).map(P=>E.has(P)?P:P.replace(C,"a"))}e.getDomainsOfRemotes=w;function g(h){const u=h.match(k);return u?u[2]:null}function f(h,u,m){return h&&u?(m&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${h}${u}`:`${h}/${u}`):null}function d(h,u){if(h.indexOf("://")===-1){const m=h.match(c);if(m)return f(m[2],m[3],u)}try{const m=L.URI.parse(h);if(m.authority)return f(g(m.authority),m.path,u)}catch{}return null}function v(h,u=!1){const m=[];let p;for(;p=R.exec(h);){const E=d(p[1],u);E&&m.push(E)}return m}e.getRemotes=v}),define(re[194],oe([0,1,12,159]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function c(D,R,C){try{k(D,R,C)}catch(S){console.error(S?.message??S)}return D}e.localizeManifest=c;function k(D,R,C){const S=(I,w,g)=>{const f=I[w];if((0,L.isString)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const h=d.substr(1,v-2);let u=R[h];u===void 0&&C&&(u=C[h]);const m=typeof u=="string"?u:u?.message,p=C?.[h],E=typeof p=="string"?p:p?.message;if(!m){E||console.warn(`[${D.name}]: ${(0,A.localize)(0,null,h)}`);return}if(g&&(w==="title"||w==="category")&&E&&E!==m){const P={value:m,original:E};I[w]=P}else I[w]=m}}else if((0,L.isObject)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?S(f,d,!0):S(f,d,g));else if(Array.isArray(f))for(let d=0;d<f.length;d++)S(f,d,g)};for(const I in D)D.hasOwnProperty(I)&&S(D,I)}}),define(re[195],oe([0,1,8]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(k,D){this.a.set(k,D)}updateManifest(k){if(!(typeof k.main>"u"&&typeof k.browser>"u")&&(k.activationEvents===void 0&&Object.assign(k,{activationEvents:[]}),!(!Array.isArray(k.activationEvents)||!k.contributes)))for(const D in k.contributes){const R=this.a.get(D);if(!R)continue;const C=k.contributes[D],S=Array.isArray(C)?C:[C];try{R(S,k.activationEvents)}catch(I){(0,L.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(re[196],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,D,R,C){return this.a.call("promptImportantExtensionsInstallNotification",[k,D,R,C])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class A{constructor(k){this.a=k}listen(k,D){throw new Error(`Event not found: ${D}`)}call(k,D,R){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${D}`)}}e.ExtensionRecommendationNotificationServiceChannel=A}),define(re[67],oe([0,1,25,89,164,54]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||D.test(u)}e.isValidVersionStr=C;function S(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=S;function I(u){if(!u)return null;const m=u.majorBase,p=u.majorMustEqual,E=u.minorBase;let P=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(m===0||(P=!1),o=!1);let t=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,s,a,r]=n;t=Date.UTC(Number(s),Number(a)-1,Number(r))}}return{majorBase:m,majorMustEqual:p,minorBase:E,minorMustEqual:P,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function w(u,m,p){let E;typeof u=="string"?E=I(S(u)):E=u;let P;m instanceof Date?P=m.getTime():typeof m=="string"&&(P=new Date(m).getTime());let i;if(typeof p=="string"?i=I(S(p)):i=p,!E||!i)return!1;const o=E.majorBase,t=E.minorBase,n=E.patchBase;let s=i.majorBase,a=i.minorBase,r=i.patchBase;const l=i.notBefore;let y=i.majorMustEqual,b=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:t>a?!0:t<a||P&&P<l?!1:n>=r:(o===1&&s===0&&(!y||!b||!O)&&(s=1,a=0,r=0,y=!0,b=!1,O=!1),o<s?!1:o>s?!y:t<a?!1:t>a?!b:n<r?!1:n>r?!O:!(P&&P<l))}e.isValidVersion=w;function g(u,m,p,E,P){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([A.default.Error,c.localize(0,null)]),i;if(typeof E.name!="string")return i.push([A.default.Error,c.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([A.default.Error,c.localize(2,null,"version")]),i;if(!E.engines)return i.push([A.default.Error,c.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([A.default.Error,c.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!h(E.extensionDependencies))return i.push([A.default.Error,c.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!h(E.activationEvents))return i.push([A.default.Error,c.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([A.default.Error,c.localize(7,null,"activationEvents","main")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([A.default.Warning,c.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([A.default.Error,c.localize(9,null,"main")]),i;{const n=(0,L.joinPath)(p,E.main);(0,L.isEqualOrParent)(n,p)||i.push([A.default.Warning,c.localize(10,null,n.path,p.path)])}if(typeof E.activationEvents>"u")return i.push([A.default.Error,c.localize(11,null,"activationEvents","main")]),i}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([A.default.Error,c.localize(12,null,"browser")]),i;{const n=(0,L.joinPath)(p,E.browser);(0,L.isEqualOrParent)(n,p)||i.push([A.default.Warning,c.localize(13,null,n.path,p.path)])}if(typeof E.activationEvents>"u")return i.push([A.default.Error,c.localize(14,null,"activationEvents","browser")]),i}if(!k.valid(E.version))return i.push([A.default.Error,c.localize(15,null)]),i;const o=[];if(!f(u,m,E,P,o))for(const n of o)i.push([A.default.Error,n]);return i}e.validateExtensionManifest=g;function f(u,m,p,E,P){return E||typeof p.main>"u"&&typeof p.browser>"u"?!0:v(u,m,p.engines.vscode,P)}e.isValidExtensionVersion=f;function d(u,m,p){return u==="*"||v(m,p,u)}e.isEngineValid=d;function v(u,m,p,E=[]){const P=I(S(p));if(!P)return E.push(c.localize(16,null,p)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return E.push(c.localize(17,null,p)),!1}else if(!P.majorMustEqual)return E.push(c.localize(18,null,p)),!1;return w(u,m,P)?!0:(E.push(c.localize(19,null,u,p)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let m=0,p=u.length;m<p;m++)if(typeof u[m]!="string")return!1;return!0}}),define(re[44],oe([0,1,16,31]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function c(k,D,R){let C=R&&R.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const I=(await D.readFile(k.serviceMachineIdResource)).value.toString();C=(0,A.isUUID)(I)?I:null}catch{C=null}if(!C){C=(0,A.generateUuid)();try{await D.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return R?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=c}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(c,k=[],D=!1){this.ctor=c,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=L}),define(re[197],oe([0,1,68]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var c;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(c=e.InstantiationType||(e.InstantiationType={}));function k(R,C,S){C instanceof L.SyncDescriptor||(C=new L.SyncDescriptor(C,[],Boolean(S))),A.push([R,C])}e.registerSingleton=k;function D(){return A}e.getSingletonServiceDescriptors=D}),define(re[198],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(k,D){this.key=k,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class A{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const D of this.a.values())D.outgoing.size===0&&k.push(D);return k}insertEdge(k,D){const R=this.lookupOrInsertNode(k),C=this.lookupOrInsertNode(D);R.outgoing.set(C.key,C),C.incoming.set(R.key,R)}removeNode(k){const D=this.b(k);this.a.delete(D);for(const R of this.a.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(k){const D=this.b(k);let R=this.a.get(D);return R||(R=new L(D,k),this.a.set(D,R)),R}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[D,R]of this.a)k.push(`${D}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,D]of this.a){const R=new Set([k]),C=this.c(D,R);if(C)return C}}c(k,D){for(const[R,C]of k.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const S=this.c(C,D);if(S)return S;D.delete(R)}}}e.Graph=A}),define(re[5],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=c("instantiationService");function A(D,R,C){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:D,index:C}):(R[L.DI_DEPENDENCIES]=[{id:D,index:C}],R[L.DI_TARGET]=R)}function c(D){if(L.serviceIds.has(D))return L.serviceIds.get(D);const R=function(C,S,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,C,I)};return R.toString=()=>D,L.serviceIds.set(D,R),R}e.createDecorator=c;function k(D){return D}e.refineServiceDecorator=k}),define(re[199],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(re[17],oe([0,1,12,10,5]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,c.createDecorator)("configurationService");function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationOverrides=k;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function S(h,u){const m=Object.create(null);for(const p in h)I(m,p,h[p],u);return m}e.toValuesTree=S;function I(h,u,m,p){const E=u.split("."),P=E.pop();let i=h;for(let o=0;o<E.length;o++){const t=E[o];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${E.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[P]=m}catch{p(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=I;function w(h,u){const m=u.split(".");g(h,m)}e.removeFromValueTree=w;function g(h,u){const m=u.shift();if(u.length===0){delete h[m];return}if(Object.keys(h).indexOf(m)!==-1){const p=h[m];typeof p=="object"&&!Array.isArray(p)&&(g(p,u),Object.keys(p).length===0&&delete h[m])}}function f(h,u,m){function p(i,o){let t=i;for(const n of o){if(typeof t!="object"||t===null)return;t=t[n]}return t}const E=u.split("."),P=p(h,E);return typeof P>"u"?m:P}e.getConfigurationValue=f;function d(h,u,m){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in h?L.isObject(h[p])&&L.isObject(u[p])?d(h[p],u[p],m):m&&(h[p]=u[p]):h[p]=u[p])})}e.merge=d;function v(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(re[200],oe([0,1,4,27,188,5]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",L.isMacintosh),D.set("isLinux",L.isLinux),D.set("isWindows",L.isWindows),D.set("isWeb",L.isWeb),D.set("isMacNative",L.isMacintosh&&!L.isWeb),D.set("isEdge",L.isEdge),D.set("isFirefox",L.isFirefox),D.set("isChrome",L.isChrome),D.set("isSafari",L.isSafari);const R=Object.prototype.hasOwnProperty;var C;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return d.INSTANCE}static true(){return v.INSTANCE}static has(T){return h.create(T)}static equals(T,B){return u.create(T,B)}static notEquals(T,B){return E.create(T,B)}static regex(T,B){return a.create(T,B)}static in(T,B){return m.create(T,B)}static notIn(T,B){return p.create(T,B)}static not(T){return P.create(T)}static and(...T){return y.create(T,null,!0)}static or(...T){return b.create(T,null,!0)}static greater(T,B){return o.create(T,B)}static greaterEquals(T,B){return t.create(T,B)}static smaller(T,B){return n.create(T,B)}static smallerEquals(T,B){return s.create(T,B)}static deserializeOrErrorNew(T){if(!T)return{type:"error",lexingErrors:[],parsingErrors:[]};const B=new w,_=B.parse(T);return _===void 0?{type:"error",lexingErrors:B.lexingErrors.map(q=>c.Scanner.reportError(q)),parsingErrors:B.parsingErrors}:{type:"ok",expr:_}}static deserialize(T){if(!!T)return this.c(T)}static c(T){const B=T.split("||");return b.create(B.map(_=>this.d(_)),null,!0)}static d(T){const B=T.split("&&");return y.create(B.map(_=>this.f(_)),null,!0)}static f(T){if(T=T.trim(),T.indexOf("!=")>=0){const B=T.split("!=");return E.create(B[0].trim(),this.g(B[1]))}if(T.indexOf("==")>=0){const B=T.split("==");return u.create(B[0].trim(),this.g(B[1]))}if(T.indexOf("=~")>=0){const B=T.split("=~");return a.create(B[0].trim(),this.h(B[1]))}if(T.indexOf(" not in ")>=0){const B=T.split(" not in ");return p.create(B[0].trim(),this.g(B[1]))}if(T.indexOf(" in ")>=0){const B=T.split(" in ");return m.create(B[0].trim(),this.g(B[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const B=T.split(">=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const B=T.split(">");return o.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const B=T.split("<=");return s.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const B=T.split("<");return n.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(T)?P.create(T.substr(1).trim()):h.create(T)}static g(T){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const B=/^'([^']*)'$/.exec(T);return B?B[1].trim():T}static h(T){if((0,A.isFalsyOrWhitespace)(T))return null;const B=T.indexOf("/"),_=T.lastIndexOf("/");if(B===_||B<0)return null;const q=T.slice(B+1,_),x=T[_+1]==="i"?"i":"";try{return new RegExp(q,x)}catch{return null}}}e.ContextKeyExpr=S;class I extends Error{}class w{constructor(){this.c=new c.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(T){if(T===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(T).scan(),this.f=0,this.g=[];try{const B=this.h();if(!this.D())throw this.z(this.C());return B}catch(B){if(!(B instanceof I)){const _=this.C();this.g.push(`Unexpected error: ${B} for token ${c.Scanner.getLexeme(_)} at offset ${_.offset}.`)}return}}h(){return this.k()}k(){const T=[this.l()];for(;this.v(16);){const B=this.l();T.push(B)}return T.length===1?T[0]:S.or(...T)}l(){const T=[this.o()];for(;this.v(15);){const B=this.o();T.push(B)}return T.length===1?T[0]:S.and(...T)}o(){if(this.v(2)){const T=this.C();switch(T.type){case 17:return this.w(),S.not(T.lexeme);case 11:return this.w(),S.false();case 12:return this.w(),S.true();default:throw this.y("KEY, 'true', or 'false'",T)}}return this.s()}s(){const T=this.C();switch(T.type){case 11:return this.w(),S.true();case 12:return this.w(),S.false();case 0:{this.w();const B=this.h();return this.x(1,"')'"),B}case 17:{const B=T.lexeme;if(this.w(),this.v(9)){const q=this.C();switch(q.type){case 10:case 19:{const x=[q.lexeme];this.w();let M=this.C(),X=0;for(let j=0;j<q.lexeme.length;j++)q.lexeme.charCodeAt(j)===40?X++:q.lexeme.charCodeAt(j)===41&&X--;for(;!this.D()&&M.type!==15&&M.type!==16;){switch(M.type){case 0:X++;break;case 1:X--;break;case 10:case 18:for(let j=0;j<M.lexeme.length;j++)M.lexeme.charCodeAt(j)===40?X++:q.lexeme.charCodeAt(j)===41&&X--}if(X<0)break;x.push(c.Scanner.getLexeme(M)),this.w(),M=this.C()}const Q=x.join(""),se=Q.lastIndexOf("/"),ae=se===Q.length-1?void 0:Q.substring(se+1),V=new RegExp(Q.substring(1,se),ae);return S.regex(B,V)}case 18:{const x=q.lexeme;this.w();let M=null;if(!(0,A.isFalsyOrWhitespace)(x)){const X=x.indexOf("/"),Q=x.lastIndexOf("/");if(X!==Q&&X>=0){const se=x.slice(X+1,Q),ae=x[Q+1]==="i"?"i":"";try{M=new RegExp(se,ae)}catch{}}}if(M===null)throw this.y("REGEX",q);return a.create(B,M)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const q=this.t();return S.notIn(B,q)}switch(this.C().type){case 3:{this.w();const q=this.t();switch(q){case"true":return S.has(B);case"false":return S.not(B);default:return S.equals(B,q)}}case 4:{this.w();const q=this.t();switch(q){case"true":return S.not(B);case"false":return S.has(B);default:return S.notEquals(B,q)}}case 5:return this.w(),n.create(B,this.t());case 6:return this.w(),s.create(B,this.t());case 7:return this.w(),o.create(B,this.t());case 8:return this.w(),t.create(B,this.t());case 13:return this.w(),S.in(B,this.t());default:return S.has(B)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const T=this.C();switch(T.type){case 17:case 18:return this.w(),T.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(T){return this.B(T)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(T,B){if(this.B(T))return this.w();throw this.y(B,this.C())}y(T,B){return this.A(`Expected ${T} but got '${c.Scanner.getLexeme(B)}' at offset ${B.offset}.`)}z(T){return this.A(`Unexpected '${c.Scanner.getLexeme(T)}' at offset ${T.offset}.`)}A(T){return this.g.push(T),new I}B(T){return this.C().type===T}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=w;function g(W,T){const B=W?W.substituteConstants():void 0,_=T?T.substituteConstants():void 0;return!B&&!_?!0:!B||!_?!1:B.equals(_)}e.expressionsAreEqualWithConstantSubstitution=g;function f(W,T){return W.cmp(T)}class d{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return v.INSTANCE}}d.INSTANCE=new d,e.ContextKeyFalseExpr=d;class v{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return d.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class h{static create(T,B=null){const _=D.get(T);return typeof _=="boolean"?_?v.INSTANCE:d.INSTANCE:new h(T,B)}constructor(T,B){this.key=T,this.c=B,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:N(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=D.get(this.key);return typeof T=="boolean"?T?v.INSTANCE:d.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class u{static create(T,B,_=null){if(typeof B=="boolean")return B?h.create(T,_):P.create(T,_);const q=D.get(T);return typeof q=="boolean"?B===(q?"true":"false")?v.INSTANCE:d.INSTANCE:new u(T,B,_)}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=D.get(this.c);if(typeof T=="boolean"){const B=T?"true":"false";return this.d===B?v.INSTANCE:d.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class m{static create(T,B){return new m(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:F(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const B=T.getValue(this.f),_=T.getValue(this.d);return Array.isArray(B)?B.includes(_):typeof _=="string"&&typeof B=="object"&&B!==null?R.call(B,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class p{static create(T,B){return new p(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=11,this.c=m.create(T,B)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=p;class E{static create(T,B,_=null){if(typeof B=="boolean")return B?P.create(T,_):h.create(T,_);const q=D.get(T);return typeof q=="boolean"?B===(q?"true":"false")?d.INSTANCE:v.INSTANCE:new E(T,B,_)}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=D.get(this.c);if(typeof T=="boolean"){const B=T?"true":"false";return this.d===B?d.INSTANCE:v.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=E;class P{static create(T,B=null){const _=D.get(T);return typeof _=="boolean"?_?d.INSTANCE:v.INSTANCE:new P(T,B)}constructor(T,B){this.c=T,this.d=B,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:N(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=D.get(this.c);return typeof T=="boolean"?T?d.INSTANCE:v.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=P;function i(W,T){if(typeof W=="string"){const B=parseFloat(W);isNaN(B)||(W=B)}return typeof W=="string"||typeof W=="number"?T(W):d.INSTANCE}class o{static create(T,B,_=null){return i(B,q=>new o(T,q,_))}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=o;class t{static create(T,B,_=null){return i(B,q=>new t(T,q,_))}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=t;class n{static create(T,B,_=null){return i(B,q=>new n(T,q,_))}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class s{static create(T,B,_=null){return i(B,q=>new s(T,q,_))}constructor(T,B,_){this.c=T,this.d=B,this.f=_,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:F(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(T,B){return new a(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const B=this.f?this.f.source:"",_=T.f?T.f.source:"";return B<_?-1:B>_?1:0}equals(T){if(T.type===this.type){const B=this.f?this.f.source:"",_=T.f?T.f.source:"";return this.d===T.d&&B===_}return!1}substituteConstants(){return this}evaluate(T){const B=T.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=r.create(this)),this.c}}e.ContextKeyRegexExpr=a;class r{static create(T){return new r(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new r(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=r;function l(W){let T=null;for(let B=0,_=W.length;B<_;B++){const q=W[B].substituteConstants();if(W[B]!==q&&T===null){T=[];for(let x=0;x<B;x++)T[x]=W[x]}T!==null&&(T[B]=q)}return T===null?W:T}class y{static create(T,B,_){return y.d(T,B,_)}constructor(T,B){this.expr=T,this.c=B,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let B=0,_=this.expr.length;B<_;B++){const q=f(this.expr[B],T.expr[B]);if(q!==0)return q}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let B=0,_=this.expr.length;B<_;B++)if(!this.expr[B].equals(T.expr[B]))return!1;return!0}return!1}substituteConstants(){const T=l(this.expr);return T===this.expr?this:y.create(T,this.c,!1)}evaluate(T){for(let B=0,_=this.expr.length;B<_;B++)if(!this.expr[B].evaluate(T))return!1;return!0}static d(T,B,_){const q=[];let x=!1;for(const M of T)if(!!M){if(M.type===1){x=!0;continue}if(M.type===0)return d.INSTANCE;if(M.type===6){q.push(...M.expr);continue}q.push(M)}if(q.length===0&&x)return v.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(f);for(let M=1;M<q.length;M++)q[M-1].equals(q[M])&&(q.splice(M,1),M--);if(q.length===1)return q[0];for(;q.length>1;){const M=q[q.length-1];if(M.type!==9)break;q.pop();const X=q.pop(),Q=q.length===0,se=b.create(M.expr.map(ae=>y.create([ae,X],null,_)),null,Q);se&&(q.push(se),q.sort(f))}if(q.length===1)return q[0];if(_){for(let M=0;M<q.length;M++)for(let X=M+1;X<q.length;X++)if(q[M].negate().equals(q[X]))return d.INSTANCE;if(q.length===1)return q[0]}return new y(q,B)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const B of this.expr)T.push(...B.keys());return T}map(T){return new y(this.expr.map(B=>B.map(T)),null)}negate(){if(!this.c){const T=[];for(const B of this.expr)T.push(B.negate());this.c=b.create(T,this,!0)}return this.c}}class b{static create(T,B,_){return b.d(T,B,_)}constructor(T,B){this.expr=T,this.c=B,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let B=0,_=this.expr.length;B<_;B++){const q=f(this.expr[B],T.expr[B]);if(q!==0)return q}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let B=0,_=this.expr.length;B<_;B++)if(!this.expr[B].equals(T.expr[B]))return!1;return!0}return!1}substituteConstants(){const T=l(this.expr);return T===this.expr?this:b.create(T,this.c,!1)}evaluate(T){for(let B=0,_=this.expr.length;B<_;B++)if(this.expr[B].evaluate(T))return!0;return!1}static d(T,B,_){let q=[],x=!1;if(T){for(let M=0,X=T.length;M<X;M++){const Q=T[M];if(!!Q){if(Q.type===0){x=!0;continue}if(Q.type===1)return v.INSTANCE;if(Q.type===9){q=q.concat(Q.expr);continue}q.push(Q)}}if(q.length===0&&x)return d.INSTANCE;q.sort(f)}if(q.length!==0){if(q.length===1)return q[0];for(let M=1;M<q.length;M++)q[M-1].equals(q[M])&&(q.splice(M,1),M--);if(q.length===1)return q[0];if(_){for(let M=0;M<q.length;M++)for(let X=M+1;X<q.length;X++)if(q[M].negate().equals(q[X]))return v.INSTANCE;if(q.length===1)return q[0]}return new b(q,B)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const B of this.expr)T.push(...B.keys());return T}map(T){return new b(this.expr.map(B=>B.map(T)),null)}negate(){if(!this.c){const T=[];for(const B of this.expr)T.push(B.negate());for(;T.length>1;){const B=T.shift(),_=T.shift(),q=[];for(const x of Y(B))for(const M of Y(_))q.push(y.create([x,M],null,!1));T.unshift(b.create(q,null,!1))}this.c=b.create(T,this,!0)}return this.c}}class O extends h{static all(){return O.d.values()}constructor(T,B,_){super(T,null),this.f=B,typeof _=="object"?O.d.push({..._,key:T}):_!==!0&&O.d.push({key:T,description:_,type:B!=null?typeof B:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return u.create(this.key,T)}notEqualsTo(T){return E.create(this.key,T)}}O.d=[],e.RawContextKey=O,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function N(W,T){return W<T?-1:W>T?1:0}function F(W,T,B,_){return W<B?-1:W>B?1:T<_?-1:T>_?1:0}function z(W,T){if(W.type===0||T.type===1)return!0;if(W.type===9)return T.type===9?G(W.expr,T.expr):!1;if(T.type===9){for(const B of T.expr)if(z(W,B))return!0;return!1}if(W.type===6){if(T.type===6)return G(T.expr,W.expr);for(const B of W.expr)if(z(B,T))return!0;return!1}return W.equals(T)}e.implies=z;function G(W,T){let B=0,_=0;for(;B<W.length&&_<T.length;){const q=W[B].cmp(T[_]);if(q<0)return!1;q===0&&B++,_++}return B===W.length}function Y(W){return W.type===9?W.expr:[W]}}),define(re[97],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function A(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=A;class c{async getPerformanceInfo(D,R){return{}}async getSystemInfo(D,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,R){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=c}),define(re[98],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(re[15],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],oe([0,1,158,5]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function c(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=c;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function D(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function R(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function C(u,m,p){return R(m,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:S(p).includes(u)}e.isTargetPlatformCompatible=C;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=I;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(m,p){super(m),this.code=p,this.name=p}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(re[201],oe([0,1,3,2,32,10,92,29]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(h,u){return h?k.URI.revive(u?u.transformIncoming(h):h):void 0}function S(h,u){return u?u.transformOutgoingURI(h):h}function I(h,u){u=u||D.DefaultURITransformer;const m=h.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...h,manifest:void 0},u),manifest:m}}function w(h,u){return h?.profileLocation?(0,D.transformAndReviveIncomingURIs)(h,u??D.DefaultURITransformer):h}function g(h,u){return u?(0,c.cloneAndChange)(h,m=>m instanceof k.URI?u.transformOutgoingURI(m):void 0):h}class f{constructor(u,m){this.a=u,this.b=m,this.onInstallExtension=L.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,m){const p=this.b(u);switch(m){case"onInstallExtension":return L.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?S(E.profileLocation,p):E.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,E=>E.map(P=>({...P,local:P.local?g(P.local,p):P.local,profileLocation:P.profileLocation?S(P.profileLocation,p):P.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?S(E.profileLocation,p):E.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?S(E.profileLocation,p):E.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,E=>g(E,p))}throw new Error("Invalid listen")}async call(u,m,p){const E=this.b(u);switch(m){case"zip":{const P=I(p[0],E),i=await this.a.zip(P);return S(i,E)}case"unzip":return this.a.unzip(C(p[0],E));case"install":return this.a.install(C(p[0],E),w(p[1],E));case"installFromLocation":return this.a.installFromLocation(C(p[0],E),C(p[1],E));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(p[0],C(p[1],E),C(p[2],E));case"getManifest":return this.a.getManifest(C(p[0],E));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],w(p[1],E));case"uninstall":return this.a.uninstall(I(p[0],E),w(p[1],E));case"reinstallFromGallery":return this.a.reinstallFromGallery(I(p[0],E));case"getInstalled":return(await this.a.getInstalled(p[0],C(p[1],E))).map(i=>g(i,E));case"copyExtensions":return this.a.copyExtensions(C(p[0],E),C(p[1],E));case"updateMetadata":{const P=await this.a.updateMetadata(I(p[0],E),p[1],C(p[2],E));return g(P,E)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class d extends A.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new L.Emitter),this.f=this.B(new L.Emitter),this.g=this.B(new L.Emitter),this.h=this.B(new L.Emitter),this.j=this.B(new L.Emitter),this.B(this.k.listen("onInstallExtension")(m=>this.l(this.c,{...m,source:this.m(m.source)?k.URI.revive(m.source):m.source,profileLocation:k.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(m=>this.l(this.f,m.map(p=>({...p,local:p.local?I(p.local,null):p.local,source:this.m(p.source)?k.URI.revive(p.source):p.source,profileLocation:k.URI.revive(p.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(m=>this.l(this.g,{...m,profileLocation:k.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(m=>this.l(this.h,{...m,profileLocation:k.URI.revive(m.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(m=>this.j.fire(I(m,null))))}l(u,m){u.fire(m)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const m=await this.getTargetPlatform();return u.allTargetPlatforms.some(p=>(0,R.isTargetPlatformCompatible)(p,u.allTargetPlatforms,m))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(m=>k.URI.revive(m)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,m){return Promise.resolve(this.k.call("install",[u,m])).then(p=>I(p,null))}installFromLocation(u,m){return Promise.resolve(this.k.call("installFromLocation",[u,m])).then(p=>I(p,null))}async installExtensionsFromProfile(u,m,p){return(await this.k.call("installExtensionsFromProfile",[u,m,p])).map(P=>I(P,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,m){return Promise.resolve(this.k.call("installFromGallery",[u,m])).then(p=>I(p,null))}uninstall(u,m){return Promise.resolve(this.k.call("uninstall",[u,m]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(m=>I(m,null))}getInstalled(u=null,m){return Promise.resolve(this.k.call("getInstalled",[u,m])).then(p=>p.map(E=>I(E,null)))}updateMetadata(u,m,p){return Promise.resolve(this.k.call("updateMetadata",[u,m,p])).then(E=>I(E,null))}copyExtensions(u,m){return this.k.call("copyExtensions",[u,m])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,m){const p=await this.k.call("download",[u,m]);return k.URI.revive(p)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class v{constructor(u){this.a=u}listen(u,m){throw new Error("Invalid listen")}call(u,m,p){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(re[99],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((k,D)=>te(["node-vsce-sign"],async R=>k(R),D))),this.a}async verify(k,D,R){let C;try{C=await this.b()}catch{return!1}return C.verify(k,D,R)}}e.ExtensionSignatureVerificationService=A}),define(re[100],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var A;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(A=e.RecommendationSource||(e.RecommendationSource={}));function c(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=c;var k;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],oe([0,1,49,13,27,12,10,166,5,4,22]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function w(M){return M.create===!0}e.isFileOpenForWriteOptions=w;var g;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(g=e.FileType||(e.FileType={}));var f;(function(M){M[M.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var d;(function(M){M[M.None=0]="None",M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=v;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=u;function m(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function p(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=p;function E(M){return v(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(X,Q){const se=new i(X.toString(),Q);return n(se,Q),se}constructor(X,Q){super(X),this.code=Q}}e.FileSystemProviderError=i;function o(M,X){return i.create(M,X)}e.createFileSystemProviderError=o;function t(M){return M||o((0,R.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=t;function n(M,X){return M.name=X?`${X} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=n;function s(M){if(!M)return P.Unknown;if(M instanceof i)return M.code;const X=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!X)return P.Unknown;switch(X[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=s;function a(M){if(M instanceof N)return M.fileOperationResult;switch(s(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(X,Q,se){this.resource=X,this.operation=Q,this.target=se}isOperation(X){return this.operation===X}}e.FileOperationEvent=l;var y;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(y=e.FileChangeType||(e.FileChangeType={}));class b{constructor(X,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of X){const V=se.get(ae.type);switch(V?V.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,V]of se)switch(ae){case 1:this.a=L.TernarySearchTree.forUris(()=>Q),this.a.fill(V);break;case 0:this.b=L.TernarySearchTree.forUris(()=>Q),this.b.fill(V);break;case 2:this.c=L.TernarySearchTree.forUris(()=>Q),this.c.fill(V);break}}contains(X,...Q){return this.d(X,{includeChildren:!1},...Q)}affects(X,...Q){return this.d(X,{includeChildren:!0},...Q)}d(X,Q,...se){if(!X)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(X)||Q.includeChildren&&this.a?.findSuperstr(X))||(!ae||se.includes(0))&&(this.b?.get(X)||Q.includeChildren&&this.b?.findSuperstr(X))||(!ae||se.includes(2))&&(this.c?.findSubstr(X)||Q.includeChildren&&this.c?.findSuperstr(X)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=b;function O(M,X,Q){return!M||!X||M===X||X.length>M.length?!1:(X.charAt(X.length-1)!==A.sep&&(X+=A.sep),Q?(0,c.startsWithIgnoreCase)(M,X):M.indexOf(X)===0)}e.isParent=O;class N extends Error{constructor(X,Q,se){super(X),this.fileOperationResult=Q,this.options=se}}e.FileOperationError=N;class F extends N{constructor(X,Q,se,ae){super(X,Q,ae),this.fileOperationResult=Q,this.size=se}}e.TooLargeFileOperationError=F;class z extends N{constructor(X,Q,se){super(X,2,se),this.stat=Q}}e.NotModifiedSinceFileOperationError=z;var G;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Y;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=W;async function T(M,X){if(!X.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(Q=>{const se=X.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===M.scheme&&ae.added&&(se.dispose(),Q())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(X){return(0,k.isNumber)(X)||(X=0),X<B.KB?(0,R.localize)(1,null,X.toFixed(0)):X<B.MB?(0,R.localize)(2,null,(X/B.KB).toFixed(2)):X<B.GB?(0,R.localize)(3,null,(X/B.MB).toFixed(2)):X<B.TB?(0,R.localize)(4,null,(X/B.GB).toFixed(2)):(0,R.localize)(5,null,(X/B.TB).toFixed(2))}}B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB,e.ByteSize=B;var _;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(_=e.Arch||(e.Arch={}));function q(M){return{maxFileSize:M===0?300*B.MB:16*B.GB,maxHeapSize:M===0?700*B.MB:2*700*B.MB}}e.getPlatformFileLimits=q;function x(M){const X=typeof M=="string"||M?.scheme===I.Schemas.vscodeRemote;return typeof M!="string"&&M?.scheme===I.Schemas.file?1024*B.MB:X?10*B.MB:S.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=x});var J=this&&this.__param||function(te,e){return function(L,A){e(L,A,te)}};define(re[202],oe([0,1,101,43,14]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.a=R}async checksum(R){const C=(await this.a.readFileStream(R)).value;return new Promise((S,I)=>{const w=(0,L.createHash)("md5");(0,A.listenStream)(C,{onData:g=>w.update(g.buffer),onError:g=>I(g),onEnd:()=>S(w.digest("base64").replace(/=+$/,""))})})}};k=ye([J(0,c.IFileService)],k),e.ChecksumService=k}),define(re[203],oe([0,1,16,38,8,3,2,43,10,31,14]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends D.Disposable{constructor(f,d){super(),this.a=f,this.b=d,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,d){const{buffer:v}=await this.a.call("readFile",[f,d]);return v}readFileStream(f,d,v){const h=(0,R.newWriteableStream)(m=>L.VSBuffer.concat(m.map(p=>L.VSBuffer.wrap(p))).buffer),u=this.a.listen("readFileStream",[f,d])(m=>{if(m instanceof L.VSBuffer)h.write(m.buffer);else{if(m==="end")h.end();else{let p;if(m instanceof Error)p=m;else{const E=m;p=(0,I.createFileSystemProviderError)(E.message??(0,A.toErrorMessage)(E),E.code??I.FileSystemProviderErrorCode.Unknown)}h.error(p),h.end()}u.dispose()}});return v.onCancellationRequested(()=>{h.error((0,c.canceled)()),h.end(),u.dispose()}),h}writeFile(f,d,v){return this.a.call("writeFile",[f,L.VSBuffer.wrap(d),v])}open(f,d){return this.a.call("open",[f,d])}close(f){return this.a.call("close",[f])}async read(f,d,v,h,u){const[m,p]=await this.a.call("read",[f,d,u]);return v.set(m.buffer.slice(0,p),h),p}write(f,d,v,h,u){return this.a.call("write",[f,d,L.VSBuffer.wrap(v),h,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,d){return this.a.call("delete",[f,d])}rename(f,d,v){return this.a.call("rename",[f,d,v])}copy(f,d,v){return this.a.call("copy",[f,d,v])}cloneFile(f,d){return this.a.call("cloneFile",[f,d])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const d=f;this.f.fire(d.map(v=>({resource:C.URI.revive(v.resource),type:v.type})))}else{const d=f;this.g.fire(d)}}))}watch(f,d){const v=(0,S.generateUuid)();return this.a.call("watch",[this.h,v,f,d]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=w}),define(re[102],oe([0,1,16,8,167,14]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,w,g,f,d,v){let h;try{await R(I,w,g,f,d,v)}catch(u){h=u}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h<"u"&&g.error(h),g.end()}}e.readFileIntoStream=D;async function R(I,w,g,f,d,v){C(v);const h=await I.open(w,{create:!1});try{C(v);let u=0,m=0,p=d&&typeof d.length=="number"?d.length:void 0,E=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof p=="number"?p:d.bufferSize)),P=d&&typeof d.position=="number"?d.position:0,i=0;do m=await I.read(h,P,E.buffer,i,E.byteLength-i),P+=m,i+=m,u+=m,typeof p=="number"&&(p-=m),i===E.byteLength&&(await g.write(f(E)),E=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof p=="number"?p:d.bufferSize)),i=0);while(m>0&&(typeof p!="number"||p>0)&&C(v)&&S(u,d));if(i>0){let o=i;typeof p=="number"&&(o=Math.min(i,p)),g.write(f(E.slice(0,o)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await I.close(h)}}function C(I){if(I.isCancellationRequested)throw(0,A.canceled)();return!0}function S(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,k.createFileSystemProviderError)((0,c.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,k.createFileSystemProviderError)((0,c.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[55],oe([0,1,91,2,13,4,10,14]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class S extends A.Disposable{constructor(m,p,E,P){super(),this.h=m,this.i=p,this.j=E,this.k=P,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new A.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(p=>this.h(p))),m.add(this.b.onDidLogMessage(p=>this.i(p))),m.add(this.b.onDidError(p=>this.n(p)))}n(m){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}s(m){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}S.a=5,e.AbstractWatcherClient=S;class I extends S{constructor(m,p,E){super(m,p,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class w extends S{constructor(m,p,E){super(m,p,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function g(u){return u.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}e.toFileChanges=g;function f(u){const m=new h;for(const p of u)m.processEvent(p);return m.coalesce()}e.coalesceEvents=f;function d(u,m){return typeof m=="string"&&!m.startsWith(L.GLOBSTAR)&&!(0,c.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=d;function v(u,m){const p=[];for(const E of m)p.push((0,L.parse)(d(u,E)));return p}e.parseWatcherPatterns=v;class h{constructor(){this.a=new Set,this.b=new Map}c(m){return k.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.b.get(this.c(m));let E=!1;if(p){const P=p.type,i=m.type;p.path!==m.path&&(m.type===2||m.type===1)?E=!0:P===1&&i===2?(this.b.delete(this.c(m)),this.a.delete(p)):P===2&&i===1?p.type=0:P===1&&i===0||(p.type=i)}else E=!0;E&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],p=[];return Array.from(this.a).filter(E=>E.type!==2?(m.push(E),!1):!0).sort((E,P)=>E.path.length-P.path.length).filter(E=>p.some(P=>(0,R.isParent)(E.path,P,!k.isLinux))?!1:(p.push(E.path),!0)).concat(m)}}}),define(re[204],oe([0,1,53,6,24,48,2,84,13,4,145,28,55]),function(te,e,L,A,c,k,D,R,C,S,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends D.Disposable{constructor(h,u,m,p){super(),this.j=h,this.k=u,this.l=m,this.m=p,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new A.RunOnceWorker(E=>this.u(E),f.b)),this.g=(0,g.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,g.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new c.CancellationTokenSource,this.ready=this.n()}async n(){try{const h=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await w.Promises.stat(h);this.B(await this.s(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.w(h):this.z(h)}}async r(h){let u=h.path;try{u=await w.Promises.realpath(h.path),h.path===u&&(u=await(0,I.realcase)(h.path)??h.path),h.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async s(h,u){if(S.isMacintosh&&(0,k.isEqualOrParent)(h,"/Volumes/",!0))return this.w(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const m=new c.CancellationTokenSource(this.i.token),p=new D.DisposableStore;try{const E=(0,C.basename)(h),P=(0,L.watch)(h);p.add((0,D.toDisposable)(()=>{P.removeAllListeners(),P.close()})),this.z(`Started watching: '${h}'`);const i=new Set;if(u)try{for(const t of await w.Promises.readdir(h))i.add(t)}catch(t){this.w(t)}const o=new Map;p.add((0,D.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),P.on("error",(t,n)=>{this.w(`Failed to watch ${h} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),P.on("change",(t,n)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),S.isMacintosh&&(s=(0,R.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===E&&!await w.Promises.exists(h)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,C.join)(h,s));if(m.token.isCancellationRequested)return;let l;r?i.has(s)?l=0:(l=1,i.add(s)):(i.delete(s),l=2),this.t({path:(0,C.join)(this.j.path,s),type:l})},f.a);o.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.t({path:(0,C.join)(this.j.path,s),type:a})}else if(t==="rename"||s!==E){const a=setTimeout(async()=>{const r=await w.Promises.exists(h);m.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(h,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);p.clear(),p.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await w.Promises.exists(h)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${h} for changes using fs.watch() (${E.toString()})`)}return(0,D.toDisposable)(()=>{m.dispose(!0),p.dispose()})}t(h,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!u&&this.g.some(m=>m(h.path))?this.m&&this.z(` >> ignored (excluded) ${h.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(m=>m(h.path))?this.m&&this.z(` >> ignored (not included) ${h.path}`):this.f.work(h))}u(h){const u=(0,g.coalesceEvents)(h);if(u.length>0){if(this.m)for(const p of u)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(h){if(S.isLinux)return w.Promises.exists(h);try{const u=(0,C.basename)(h);return(await w.Promises.readdir((0,C.dirname)(h))).some(p=>p===u)}catch(u){return this.z(u),!1}}setVerboseLogging(h){this.m=h}w(h){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}y(h){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}z(h){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}f.a=100,f.b=75,e.NodeJSFileWatcherLibrary=f;async function d(v,h,u,m,p=512){const E=await w.Promises.open(v,"r"),P=Buffer.allocUnsafe(p),i=new c.CancellationTokenSource(m);let o,t=!1;const n={path:v,excludes:[],recursive:!1},s=new f(n,a=>{(async()=>{for(const{type:r}of a)if(r===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:l}=await w.Promises.read(E,P,0,p,null);if(!l||i.token.isCancellationRequested)break;h(P.slice(0,l))}}catch(l){o=new Error(l),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((a,r)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await w.Promises.close(E)}catch(l){o=new Error(l)}o?r(o):a()})})}e.watchFileContents=d}),define(re[205],oe([0,1,3,91,2,4,204]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends c.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(S){const I=this.i(S),w=I.filter(f=>{const d=this.c.get(f.path);return d?!(0,A.patternsEquals)(d.request.excludes,f.excludes)||!(0,A.patternsEquals)(d.request.includes,f.includes):!0}),g=Array.from(this.c.values()).filter(({request:f})=>!I.find(d=>d.path===f.path&&(0,A.patternsEquals)(d.excludes,f.excludes)&&(0,A.patternsEquals)(d.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.j(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const f of g)this.h(f);for(const f of w)this.g(f)}g(S){const I=new D.NodeJSFileWatcherLibrary(S,g=>this.a.fire(g),g=>this.b.fire(g),this.f),w={request:S,instance:I};this.c.set(S.path,w)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const I=this.c.get(S);I&&(this.c.delete(S),I.instance.dispose())}i(S){const I=new Map;for(const w of S){const g=k.isLinux?w.path:w.path.toLowerCase();I.set(g,w)}return Array.from(I.values())}async setVerboseLogging(S){this.f=S;for(const[,I]of this.c)I.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,I){return I?`[File Watcher (node.js)] ${S} (path: ${I.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(re[206],oe([0,1,55,205]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class c extends L.AbstractNonRecursiveWatcherClient{constructor(D,R,C){super(D,R,C),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=c}),define(re[207],oe([0,1,22,39,65,55]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends k.AbstractUniversalWatcherClient{constructor(C,S,I){super(C,S,I),this.m()}l(C){const S=C.add(new c.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(S.onDidProcessExit(({code:I,signal:w})=>this.n(`terminated by itself with code ${I}, signal: ${w}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(re[69],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...c){this.a=new Map;for(const[k,D]of c)this.set(k,D)}set(c,k){const D=this.a.get(c);return this.a.set(c,k),D}has(c){return this.a.has(c)}get(c){return this.a.get(c)}}e.ServiceCollection=L}),define(re[208],oe([0,1,6,8,2,68,198,5,69,83]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class w extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class g{constructor(h=new C.ServiceCollection,u=!1,m,p=I){this.f=h,this.g=u,this.h=m,this.i=p,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=p?m?._globalGraph??new D.Graph(E=>E):void 0}createChild(h){return new g(h,this.g,this,this.i)}invokeFunction(h,...u){const m=d.traceInvocation(this.i,h);let p=!1;try{return h({get:P=>{if(p)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(P,m);if(!i)throw new Error(`[invokeFunction] unknown service '${P}'`);return i}},...u)}finally{p=!0,m.stop()}}createInstance(h,...u){let m,p;return h instanceof k.SyncDescriptor?(m=d.traceCreation(this.i,h.ctor),p=this.j(h.ctor,h.staticArguments.concat(u),m)):(m=d.traceCreation(this.i,h),p=this.j(h,u,m)),m.stop(),p}j(h,u=[],m){const p=R._util.getServiceDependencies(h).sort((i,o)=>i.index-o.index),E=[];for(const i of p){const o=this.m(i.id,m);o||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const P=p.length>0?p[0].index:u.length;if(u.length!==P){console.trace(`[createInstance] First service dependency of ${h.name} at position ${P+1} conflicts with ${u.length} static arguments`);const i=P-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,P)}return Reflect.construct(h,u.concat(E))}k(h,u){if(this.f.get(h)instanceof k.SyncDescriptor)this.f.set(h,u);else if(this.h)this.h.k(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const u=this.f.get(h);return!u&&this.h?this.h.l(h):u}m(h,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const m=this.l(h);return m instanceof k.SyncDescriptor?this.q(h,m,u.branch(h,!0)):(u.branch(h,!1),m)}q(h,u,m){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,u,m)}finally{this.o.delete(h)}}r(h,u,m){const p=new D.Graph(i=>i.id.toString());let E=0;const P=[{id:h,desc:u,_trace:m}];for(;P.length;){const i=P.pop();if(p.lookupOrInsertNode(i),E++>1e3)throw new w(p);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),t instanceof k.SyncDescriptor){const n={id:o.id,desc:t,_trace:i._trace.branch(o.id,!0)};p.insertEdge(i,n),P.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:o}of i){if(this.l(o.id)instanceof k.SyncDescriptor){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}p.removeNode(o)}}return this.l(h)}s(h,u,m=[],p,E){if(this.f.get(h)instanceof k.SyncDescriptor)return this.t(h,u,m,p,E);if(this.h)return this.h.s(h,u,m,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(h,u,m=[],p,E){if(p){const P=new g(void 0,this.g,this,this.i);P.c=String(h);const i=new Map,o=new L.IdleValue(()=>{const t=P.j(u,m,E);for(const[n,s]of i){const a=t[n];if(typeof a=="function")for(const r of s)a.apply(t,r)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let r=i.get(n);return r||(r=new S.LinkedList,i.set(n,r)),(y,b,O)=>{const N=r.push([y,b,O]);return(0,c.toDisposable)(N)}}if(n in t)return t[n];const s=o.value;let a=s[n];return typeof a!="function"||(a=a.bind(s),t[n]=a),a},set(t,n,s){return o.value[n]=s,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,m,E)}u(h,u){if(u&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=g;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class d{static traceInvocation(h,u){return h?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(h,u){return h?new d(1,u.name):d.c}constructor(h,u){this.type=h,this.name=u,this.g=Date.now(),this.h=[]}branch(h,u){const m=new d(3,h.toString());return this.h.push([h,u,m]),m}stop(){const h=Date.now()-this.g;d.f+=h;let u=!1;function m(E,P){const i=[],o=new Array(E+1).join("	");for(const[t,n,s]of P.h)if(n&&s){u=!0,i.push(`${o}CREATES -> ${t}`);const a=m(E+1,s);a&&i.push(a)}else i.push(`${o}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(h>2||u)&&d.all.add(p.join(`
`))}}d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0,e.Trace=d}),define(re[70],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class A{constructor(k,D){this.a=k,this.b=D}getChannel(k){return this.a.getChannel(k,this.b)}registerChannel(k,D){this.a.registerChannel(k,D)}}e.MainProcessService=A}),define(re[71],oe([0,1,24,2,4,169,29,5]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends A.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new L.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const d=g.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(h=>h.startsWith("lp-"))).map(v=>{const h=v.properties.localizedLanguages?.[0],u=C(v);return{...this.f(u,h,v),extensionId:v.identifier.id,galleryExtension:v}});return d.push(this.f("en","English")),d}f(w,g,f){const d=g??w;let v;if(d!==w&&(v=`(${w})`),w.toLowerCase()===c.language.toLowerCase()&&(v??="",v+=(0,k.localize)(0,null)),f?.installCount){v??="";const h=f.installCount;let u;h>1e6?u=`${Math.floor(h/1e5)/10}M`:h>1e3?u=`${Math.floor(h/1e3)}K`:u=String(h),v+=` $(cloud-download) ${u}`}return{id:w,label:d,description:v}}};S=ye([J(0,D.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(re[209],oe([0,1,2,71]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let c=class extends L.Disposable{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};c=ye([J(0,A.ILanguagePackService)],c),e.LocalizationsUpdater=c}),define(re[11],oe([0,1,38,3,2,37,4,12,10,5]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function I(){return new Date().toISOString()}function w(r){return(0,R.isNumber)(r)}e.isLogLevel=w;var g;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function f(r,l,y){switch(l){case g.Trace:r.trace(y);break;case g.Debug:r.debug(y);break;case g.Info:r.info(y);break;case g.Warning:r.warn(y);break;case g.Error:r.error(y);break;case g.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=f;function d(r){let l="";for(let y=0;y<r.length;y++){let b=r[y];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}l+=(y>0?" ":"")+b}return l}e.format=d;class v extends c.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==g.Off&&this.b<=l}}e.AbstractLogger=v;class h extends v{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...y){this.f(g.Trace)&&this.g(g.Trace,d([l,...y]))}debug(l,...y){this.f(g.Debug)&&this.g(g.Debug,d([l,...y]))}info(l,...y){this.f(g.Info)&&this.g(g.Info,d([l,...y]))}warn(l,...y){this.f(g.Warning)&&this.g(g.Warning,d([l,...y]))}error(l,...y){if(this.f(g.Error))if(l instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=l.stack,this.g(g.Error,d(b))}else this.g(g.Error,d([l,...y]))}flush(){}}e.AbstractMessageLogger=h;class u extends v{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!D.isWindows}trace(l,...y){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...y):console.log(`[main ${I()}]`,l,...y))}debug(l,...y){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...y):console.log(`[main ${I()}]`,l,...y))}info(l,...y){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...y):console.log(`[main ${I()}]`,l,...y))}warn(l,...y){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,l,...y):console.warn(`[main ${I()}]`,l,...y))}error(l,...y){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,l,...y):console.error(`[main ${I()}]`,l,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class m extends v{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...y){this.f(g.Trace)&&console.log("%cTRACE","color: #888",l,...y)}debug(l,...y){this.f(g.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...y)}info(l,...y){this.f(g.Info)&&console.log("%c INFO","color: #33f",l,...y)}warn(l,...y){this.f(g.Warning)&&console.log("%c WARN","color: #993",l,...y)}error(l,...y){this.f(g.Error)&&console.log("%c  ERR","color: #f33",l,...y)}dispose(){}flush(){}}e.ConsoleLogger=m;class p extends v{constructor(l,y=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(y)}trace(l,...y){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(l),...y])}debug(l,...y){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(l),...y])}info(l,...y){this.f(g.Info)&&this.g.log(g.Info,[this.h(l),...y])}warn(l,...y){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(l),...y])}error(l,...y){this.f(g.Error)&&this.g.log(g.Error,[this.h(l),...y])}h(l){return typeof l=="string"?l:(0,L.toErrorMessage)(l,this.f(g.Trace))}dispose(){}flush(){}}e.AdapterLogger=p;class E extends v{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const y of this.g)y.setLevel(l);super.setLevel(l)}trace(l,...y){for(const b of this.g)b.trace(l,...y)}debug(l,...y){for(const b of this.g)b.debug(l,...y)}info(l,...y){for(const b of this.g)b.info(l,...y)}warn(l,...y){for(const b of this.g)b.warn(l,...y)}error(l,...y){for(const b of this.g)b.error(l,...y)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=E;class P extends c.Disposable{constructor(l,y){if(super(),this.j=l,this.b=new k.ResourceMap,this.c=new k.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,y)for(const b of y)this.c.set(b.resource,b)}getLogger(l){return this.b.get(l)}createLogger(l,y){let b=this.b.get(l);const O=y?.logLevel==="always"?g.Trace:y?.logLevel;return b||(b=this.k(l,O??this.getLogLevel(l)??this.j,y),this.b.set(l,b)),this.registerLogger({resource:l,id:y?.id??l.toString(),logLevel:O,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId}),b}setLogLevel(l,y){if(C.URI.isUri(l)){const b=l,O=y,N=this.c.get(b);N&&O!==N.logLevel&&(N.logLevel=O===this.j?void 0:O,this.b.get(b)?.setLevel(O),this.c.set(N.resource,N),this.g.fire([b,O]))}else{this.j=l;for(const[b,O]of this.b.entries())this.c.get(b)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,y){const b=this.c.get(l);b&&y!==!b.hidden&&(b.hidden=!y,this.c.set(b.resource,b),this.h.fire([l,y]))}getLogLevel(l){let y;return l&&(y=this.c.get(l)?.logLevel),y??this.j}registerLogger(l){const y=this.c.get(l.resource);y?y.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const y=this.c.get(l);if(y){this.c.delete(l);const b=this.b.get(l);b&&(this.b.delete(l),b.dispose()),this.f.fire({added:[],removed:[y]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=P;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(l){}getLevel(){return g.Info}trace(l,...y){}debug(l,...y){}info(l,...y){}warn(l,...y){}error(l,...y){}critical(l,...y){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class t extends P{constructor(){super(g.Info)}k(l,y,b){return new i}}e.NullLoggerService=t;function n(r){if(r.verbose)return g.Trace;if(typeof r.logLevel=="string"){const l=a(r.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(r){switch(r){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.LogLevelToString=s;function a(r){switch(r){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.parseLogLevel=a}),define(re[210],oe([0,1,6,8,2,13,28,15,11]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends c.Disposable{constructor(w,g){super(),this.a=w,this.b=g,this.B(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,k.basename)(this.a.logsPath),g=(0,k.dirname)(this.a.logsPath),v=(await D.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==w),h=v.slice(0,Math.max(0,v.length-9));h.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>D.Promises.rm((0,k.join)(g,u)))))}catch(w){(0,A.onUnexpectedError)(w)}}};S=ye([J(0,R.IEnvironmentService),J(1,C.ILogService)],S),e.LogsDataCleaner=S}),define(re[211],oe([0,1,21,6,8,3,2,13,55,11]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(g,f){super(),this.a=g,this.b=f,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(g,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(g,f):this.u(g,f)}l(g,f){const d={path:this.C(g),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,L.insert)(this.j,d);return this.m(),(0,D.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,c.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,C.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&g.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,f){const d={path:this.C(g),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,L.insert)(this.s,d);return this.v(),(0,D.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,c.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,C.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(re[212],oe([0,1,21,6,16,24,3,64,62,2,49,22,103,25,43,165,14,102,11,8]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends S.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const t=new S.DisposableStore;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),t.add(o.onDidChangeFile(n=>this.R.fire(new h.FileChangesEvent(n,!this.O(o))))),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.S.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,S.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(t){o.push(t)}}),!this.h.has(i)&&await A.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return C.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,f.isAbsolutePath)(i))throw new h.FileOperationError((0,v.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const t=new p.ErrorNoTelemetry;throw t.message=(0,v.localize)(1,null,i.toString()),t}return o}async k(i){const o=await this.j(i);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o)||(0,h.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const o=await this.j(i);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.n(i,o)}catch(t){throw(0,h.toFileSystemProviderErrorCode)(t)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,v.localize)(2,null,this.nb(i)),1):(0,h.ensureFileSystemProviderError)(t)}}async n(i,o){const t=await this.j(i),n=this.O(t),s=o?.resolveTo,a=o?.resolveSingleChildDescendants,r=o?.resolveMetadata,l=await t.stat(i);let y;return this.p(t,i,l,void 0,!!r,(b,O)=>(y||(y=I.TernarySearchTree.forUris(()=>!n),y.set(i,!0),s&&y.fill(!0,s)),y.get(b.resource)||y.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&a?O===1:!1))}async p(i,o,t,n,s,a){const{providerExtUri:r}=this.N(i),l={resource:o,name:r.basename(o),isFile:(t.type&h.FileType.File)!==0,isDirectory:(t.type&h.FileType.Directory)!==0,isSymbolicLink:(t.type&h.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&h.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,h.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(l.isDirectory&&a(l,n)){try{const y=await i.readdir(o),b=await A.Promises.settled(y.map(async([O,N])=>{try{const F=r.joinPath(o,O),z=s?await i.stat(F):{type:N};return await this.p(i,F,z,y.length,s,a)}catch(F){return this.b.trace(F),null}}));l.children=(0,L.coalesce)(b)}catch(y){this.b.trace(y),l.children=[]}return l}return l}async resolveAll(i){return A.Promises.settled(i.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),t=await o.stat(i);return this.p(o,i,t,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.r(i,o)}catch(t){return t}return!0}async r(i,o){if(!o?.overwrite&&await this.exists(i))throw new h.FileOperationError((0,v.localize)(3,null,this.nb(i)),3,o)}async createFile(i,o=c.VSBuffer.fromString(""),t){await this.r(i,t);const n=await this.writeFile(i,o);return this.m.fire(new h.FileOperationEvent(i,0,n)),n}async writeFile(i,o,t){const n=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(n);try{await this.s(n,i,t)||await this.P(n,s.dirname(i));let r;if((0,h.hasReadWriteCapability)(n)&&!(o instanceof c.VSBuffer))if((0,d.isReadableStream)(o)){const l=await(0,d.peekStream)(o,3);l.ended?r=c.VSBuffer.concat(l.buffer):r=l}else r=(0,d.peekReadable)(o,l=>c.VSBuffer.concat(l),3);else r=o;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&r instanceof c.VSBuffer?await this.cb(n,i,t,r):await this.Y(n,i,t,r instanceof c.VSBuffer?(0,c.bufferToReadable)(r):r),this.m.fire(new h.FileOperationEvent(i,4))}catch(a){throw new h.FileOperationError((0,v.localize)(4,null,this.nb(i),(0,h.ensureFileSystemProviderError)(a).toString()),(0,h.toFileOperationResult)(a),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,o,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(o)));let s;try{s=await i.stat(o)}catch{return}if((s.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,v.localize)(6,null,this.nb(o)),0,t);if(this.mb(o,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==h.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,h.etag)({mtime:t.mtime,size:s.size}))throw new h.FileOperationError((0,v.localize)(7,null),3,t);return s}async readFile(i,o,t){const n=await this.k(i);return o?.atomic?this.t(n,i,o,t):this.u(n,i,o,t)}async t(i,o,t,n){return new Promise((s,a)=>{this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{try{const r=await this.u(i,o,t,n);s(r)}catch(r){a(r)}})})}async u(i,o,t,n){const s=await this.v(i,o,{...t,preferUnbuffered:!0},n);return{...s,value:await(0,c.streamToBuffer)(s.value)}}async readFileStream(i,o,t){const n=await this.k(i);return this.v(n,i,o,t)}async v(i,o,t,n){const s=new k.CancellationTokenSource(n),a=this.F(o,t).then(l=>l,l=>{throw s.cancel(),l});let r;try{return typeof t?.etag=="string"&&t.etag!==h.ETAG_DISABLED&&await a,t?.atomic&&(0,h.hasFileAtomicReadCapability)(i)||!((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasFileReadStreamCapability)(i))||(0,h.hasReadWriteCapability)(i)&&t?.preferUnbuffered?r=this.D(i,o,t):(0,h.hasFileReadStreamCapability)(i)?r=this.z(i,o,s.token,t):r=this.C(i,o,s.token,t),{...await a,value:r}}catch(l){throw r&&await(0,d.consumeStream)(r),this.w(l,o,t)}}w(i,o,t){const n=(0,v.localize)(8,null,this.nb(o),(0,h.ensureFileSystemProviderError)(i).toString());return i instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(n,i.stat,t):i instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new h.FileOperationError(n,(0,h.toFileOperationResult)(i),t)}z(i,o,t,n=Object.create(null)){const s=i.readFileStream(o,n,t);return(0,d.transform)(s,{data:a=>a instanceof c.VSBuffer?a:c.VSBuffer.wrap(a),error:a=>this.w(a,o,n)},a=>c.VSBuffer.concat(a))}C(i,o,t,n=Object.create(null)){const s=(0,c.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,o,s,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,o,n)},t),s}D(i,o,t){const n=(0,d.newWriteableStream)(s=>c.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,h.hasFileAtomicReadCapability)(i)?s=await i.readFile(o,{atomic:!0}):s=await i.readFile(o),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(o,s.byteLength,t),n.end(c.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(i,o){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new h.FileOperationError((0,v.localize)(9,null,this.nb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==h.ETAG_DISABLED&&o.etag===t.etag)throw new h.NotModifiedSinceFileOperationError((0,v.localize)(10,null),t,o);return this.G(i,t.size,o),t}G(i,o,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&o>t.limits.size&&(n=7),typeof n=="number")throw new h.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(i)),n,o,t)}}async canMove(i,o,t){return this.H(i,o,"move",t)}async canCopy(i,o,t){return this.H(i,o,"copy",t)}async H(i,o,t,n){if(i.toString()!==o.toString())try{const s=t==="move"?this.lb(await this.l(i),i):await this.k(i),a=this.lb(await this.l(o),o);await this.M(s,i,a,o,t,n)}catch(s){return s}return!0}async move(i,o,t){const n=this.lb(await this.l(i),i),s=this.lb(await this.l(o),o),a=await this.I(n,i,s,o,"move",!!t),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(i,a==="move"?2:3,r)),r}async copy(i,o,t){const n=await this.k(i),s=this.lb(await this.l(o),o),a=await this.I(n,i,s,o,"copy",!!t),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(i,a==="copy"?3:2,r)),r}async I(i,o,t,n,s,a){if(o.toString()===n.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:l}=await this.M(i,o,t,n,s,a);if(r&&!l&&a&&await this.del(n,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(n)),s==="copy"){if(i===t&&(0,h.hasFileFolderCopyCapability)(i))await i.copy(o,n,{overwrite:a});else{const y=await this.resolve(o);y.isDirectory?await this.L(i,y,t,n):await this.J(i,o,t,n)}return s}else return i===t?(await i.rename(o,n,{overwrite:a}),s):(await this.I(i,o,t,n,"copy",a),await this.del(o,{recursive:!0}),"copy")}async J(i,o,t,n){if((0,h.hasOpenReadWriteCloseCapability)(i)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.eb(i,o,t,n);if((0,h.hasOpenReadWriteCloseCapability)(i)&&(0,h.hasReadWriteCapability)(t))return this.kb(i,o,t,n);if((0,h.hasReadWriteCapability)(i)&&(0,h.hasOpenReadWriteCloseCapability)(t))return this.ib(i,o,t,n);if((0,h.hasReadWriteCapability)(i)&&(0,h.hasReadWriteCapability)(t))return this.gb(i,o,t,n)}async L(i,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async s=>{const a=this.N(t).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),t,a):this.J(i,s.resource,t,a)}))}async M(i,o,t,n,s,a){let r=!1;if(i===t){const{providerExtUri:y,isPathCaseSensitive:b}=this.N(i);if(b||(r=y.isEqual(o,n)),r&&s==="copy")throw new Error((0,v.localize)(12,null,this.nb(o),this.nb(n)));if(!r&&y.isEqualOrParent(n,o))throw new Error((0,v.localize)(13,null,this.nb(o),this.nb(n)))}const l=await this.exists(n);if(l&&!r){if(!a)throw new h.FileOperationError((0,v.localize)(14,null,this.nb(o),this.nb(n)),4);if(i===t){const{providerExtUri:y}=this.N(i);if(y.isEqualOrParent(o,n))throw new Error((0,v.localize)(15,null,this.nb(o),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:r}}N(i){const o=this.O(i);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.lb(await this.j(i),i);await this.P(o,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(i,0,t)),t}async P(i,o){const t=[],{providerExtUri:n}=this.N(i);for(;!n.isEqual(o,n.dirname(o));)try{if(((await i.stat(o)).type&h.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(o)));break}catch(s){if((0,h.toFileSystemProviderErrorCode)(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(n.basename(o)),o=n.dirname(o)}for(let s=t.length-1;s>=0;s--){o=n.joinPath(o,t[s]);try{await i.mkdir(o)}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,o){try{await this.Q(i,o)}catch(t){return t}return!0}async Q(i,o){const t=this.lb(await this.j(i),i);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(i)));let s;try{s=await t.stat(i)}catch{}if(s)this.mb(i,s);else throw new h.FileOperationError((0,v.localize)(18,null,this.nb(i)),1);if(!!!o?.recursive){const r=await this.resolve(i);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(i)))}return t}async del(i,o){const t=await this.Q(i,o),n=!!o?.useTrash,s=!!o?.recursive;await t.delete(i,{recursive:s,useTrash:n}),this.m.fire(new h.FileOperationEvent(i,1))}async cloneFile(i,o){const t=await this.j(i),n=this.lb(await this.l(o),o);if(t===n&&this.N(t).providerExtUri.isEqual(i,o))return;if(t===n&&(0,h.hasFileCloneCapability)(t))return t.cloneFile(i,o);await this.P(n,this.N(n).providerExtUri.dirname(o));const s=this.X.queueFor(i,this.N(t).providerExtUri);return t===n&&(0,h.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(i,o,{overwrite:!0})):s.queue(()=>this.J(t,i,n,o))}watch(i,o={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let n=!1,s=()=>{n=!0};return t.add((0,S.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(i,o);n?(0,S.dispose)(a):s=()=>(0,S.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(i,o){const t=await this.j(i),n=(0,R.hash)([this.N(t).providerExtUri.getComparisonKey(i),o]);let s=this.U.get(n);return s||(s={count:0,disposable:t.watch(i,o)},this.U.set(n,s)),s.count+=1,(0,S.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,S.dispose)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,S.dispose)(i.disposable);this.U.clear()}async Y(i,o,t,n){return this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.Z(i,s,n):await this.ab(i,s,n)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await i.close(s)}})}async Z(i,o,t){let n=0,s;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=c.VSBuffer.concat(t.buffer);await this.bb(i,o,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((a,r)=>{(0,d.listenStream)(s,{onData:async l=>{s.pause();try{await this.bb(i,o,l,l.byteLength,n,0)}catch(y){return r(y)}n+=l.byteLength,setTimeout(()=>s.resume())},onError:l=>r(l),onEnd:()=>a()})})}async ab(i,o,t){let n=0,s;for(;(s=t.read())!==null;)await this.bb(i,o,s,s.byteLength,n,0),n+=s.byteLength}async bb(i,o,t,n,s,a){let r=0;for(;r<n;)r+=await i.write(o,s+r,t.buffer,a+r,n-r)}async cb(i,o,t,n){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.db(i,o,t,n))}async db(i,o,t,n){let s;n instanceof c.VSBuffer?s=n:(0,d.isReadableStream)(n)?s=await(0,c.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?s=await(0,c.bufferedStreamToBuffer)(n):s=(0,c.readableToBuffer)(n),await i.writeFile(o,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.fb(i,o,t,n))}async fb(i,o,t,n){let s,a;try{s=await i.open(o,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const r=c.VSBuffer.alloc(this.a);let l=0,y=0,b=0;do b=await i.read(s,l,r.buffer,y,r.byteLength-y),await this.bb(t,a,r,b,l,y),l+=b,y+=b,y===r.byteLength&&(y=0);while(b>0)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await A.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.hb(i,o,t,n))}async hb(i,o,t,n){return t.writeFile(n,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async ib(i,o,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.jb(i,o,t,n))}async jb(i,o,t,n){const s=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(o);await this.bb(t,s,c.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async kb(i,o,t,n){const s=await(0,c.streamToBuffer)(this.C(i,o,k.CancellationToken.None));await this.cb(t,n,void 0,s)}lb(i,o){if(i.capabilities&2048)throw new h.FileOperationError((0,v.localize)(20,null,this.nb(o)),6);return i}mb(i,o){if((o.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,v.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}};E=ye([J(0,m.ILogService)],E),e.FileService=E}),define(re[213],oe([0,1,53,294,6,37,16,3,48,2,13,4,25,43,28,168,14,102,211,38,207,206]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(o)}`)}})();class i extends m.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=R.Event.None,this.H=new k.ResourceMap(s=>g.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.C(t));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(t){try{const n=await d.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let r;a.isSymbolicLink()?r=(await this.stat((0,g.joinPath)(t,a.name))).type:r=this.G(a),s.push([a.name,r])}catch(r){this.a.trace(r)}})),s}catch(n){throw this.Y(n)}}G(t,n){let s;return n?.dangling?s=h.FileType.Unknown:t.isFile()?s=h.FileType.File:t.isDirectory()?s=h.FileType.Directory:s=h.FileType.Unknown,n&&(s|=h.FileType.SymbolicLink),s}async I(t){const n=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new c.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const a=this.C(t);return await d.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,n,s){const a=(0,f.newWriteableStream)(r=>D.VSBuffer.concat(r.map(l=>D.VSBuffer.wrap(l))).buffer);return(0,u.readFileIntoStream)(this,t,a,r=>r.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(t,n,s){let a;try{const r=this.C(t);if(!s.create||!s.overwrite){if(await d.Promises.exists(r)){if(!s.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(r){throw await this.Z(t,r)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){i.O=t}async open(t,n){const s=this.C(t);let a;(0,h.isFileOpenForWriteOptions)(n)&&(a=await this.I(t));let r;try{if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await d.SymlinkSupport.stat(s);y.mode&128||await d.Promises.chmod(s,y.mode|128)}catch(y){this.a.trace(y)}let l;if((0,h.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await d.Promises.truncate(s,0),l="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}l||(l="w")}else l="r";r=await d.Promises.open(s,l)}catch(l){throw a?.dispose(),(0,h.isFileOpenForWriteOptions)(n)?await this.Z(t,l):this.Y(l)}if(this.L.set(r,0),(0,h.isFileOpenForWriteOptions)(n)&&this.N.set(r,t),a){const l=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${s})`),this.M.set(r,a),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${s})`),l.dispose())}return r}async close(t){const n=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await d.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(t)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(t)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,a,r){const l=this.P(t,n);let y=null;try{y=(await d.Promises.read(t,s,a,r,l)).bytesRead}catch(b){throw this.Y(b)}finally{this.Q(t,l,y)}return y}P(t,n){return n===this.L.get(t)?null:n}Q(t,n,s){const a=this.L.get(t);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(t,a+s):this.L.delete(t)))}async write(t,n,s,a,r){return(0,c.retry)(()=>this.R(t,n,s,a,r),100,3)}async R(t,n,s,a,r){const l=this.P(t,n);let y=null;try{y=(await d.Promises.write(t,s,a,r,l)).bytesWritten}catch(b){throw await this.Z(this.N.get(t),b)}finally{this.Q(t,l,y)}return y}async mkdir(t){try{await d.Promises.mkdir(this.C(t))}catch(n){throw this.Y(n)}}async delete(t,n){try{const s=this.C(t);n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,n,s){const a=this.C(t),r=this.C(n);if(a!==r)try{await this.S(t,n,"move",s.overwrite),await d.Promises.move(a,r)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(r)),l.toString()))),this.Y(l)}}async copy(t,n,s){const a=this.C(t),r=this.C(n);if(a!==r)try{await this.S(t,n,"copy",s.overwrite),await d.Promises.copy(a,r,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(r)),l.toString()))),this.Y(l)}}async S(t,n,s,a){const r=this.C(t),l=this.C(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,C.isEqual)(r,l,!0)),y&&s==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!y&&await d.Promises.exists(l)){if(!a)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.U(t,n,!1)}async U(t,n,s){const a=this.C(t),r=this.C(n),l=!!(this.capabilities&1024);if((0,C.isEqual)(a,r,!l))return;const y=new S.DisposableStore;try{const[b,O]=await Promise.all([this.I(t),this.I(n)]);y.add(b),y.add(O),s&&await d.Promises.mkdir((0,I.dirname)(r),{recursive:!0}),await d.Promises.copyFile(a,r)}catch(b){if(b.code==="ENOENT"&&!s)return this.U(t,n,!0);throw this.Y(b)}finally{y.dispose()}}p(t,n,s){return new E.UniversalWatcherClient(a=>t(a),a=>n(a),s)}y(t,n,s){return new P.NodeJSWatcherClient(a=>t(a),a=>n(a),s)}Y(t){if(t instanceof h.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,n)}async Z(t,n){let s=this.Y(n);if(t&&s.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.C(t));a.mode&128||(s=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}i.D=!1,i.O=!0,e.DiskFileSystemProvider=i}),define(re[104],oe([0,1,3,2,5,11]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,c.createDecorator)("sharedProcessLifecycleService");let D=class extends A.Disposable{constructor(C){super(),this.b=C,this.a=this.B(new L.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};D=ye([J(0,k.ILogService)],D),e.SharedProcessLifecycleService=D}),define(re[105],oe([0,1,10,3,11,2]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends c.AbstractLoggerService{constructor(w,g,f,d){super(g,f),this.l=w,this.m=d,this.B(d.listen("onDidChangeLogLevel",w)(v=>{(0,c.isLogLevel)(v)?super.setLogLevel(v):super.setLogLevel(L.URI.revive(v[0]),v[1])})),this.B(d.listen("onDidChangeVisibility",w)(([v,h])=>super.setVisibility(L.URI.revive(v),h))),this.B(d.listen("onDidChangeLoggers",w)(({added:v,removed:h})=>{for(const u of v)super.registerLogger({...u,resource:L.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new c.AdapterLogger({log:(w,g)=>{this.m.call("consoleLog",[w,g])}})}registerLogger(w){super.registerLogger(w),this.m.call("registerLogger",[w,this.l])}deregisterLogger(w){super.deregisterLogger(w),this.m.call("deregisterLogger",[w,this.l])}setLogLevel(w,g){super.setLogLevel(w,g),this.m.call("setLogLevel",[w,g])}setVisibility(w,g){super.setVisibility(w,g),this.m.call("setVisibility",[w,g])}k(w,g,f){return new R(this.m,w,g,f,this.l)}static setLogLevel(w,g,f){return w.call("setLogLevel",[g,f])}}e.LoggerChannelClient=D;class R extends c.AbstractMessageLogger{constructor(w,g,f,d,v){super(d?.logLevel==="always"),this.m=w,this.n=g,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[g,d,v]).then(()=>{this.r(this.l),this.k=!0})}g(w,g){const f=[[w,g]];this.k?this.r(f):this.l.push(...f)}r(w){this.m.call("log",[this.n,w])}}class C{constructor(w,g){this.a=w,this.b=g}listen(w,g){const f=this.b(w);switch(g){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(v=>this.c(v,f)),removed:[...d.removed].map(v=>this.c(v,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,d=>[f.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,d=>(0,c.isLogLevel)(d)?d:[f.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${g}`)}async call(w,g,f){const d=this.b(w);switch(g){case"setLogLevel":return(0,c.isLogLevel)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(L.URI.revive(d.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,d)))}throw new Error(`Call not found: ${g}`)}c(w,g){return{...w,resource:g.transformOutgoingURI(w.resource)}}}e.LoggerChannel=C;class S extends k.Disposable{constructor(w,g){super(),g.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(f=>g.call("setLogLevel",[f]))),g.call("getRegisteredLoggers").then(f=>{for(const d of f)w.registerLogger({...d,resource:L.URI.revive(d.resource)})}),this.B(g.listen("onDidChangeVisibility")(([f,d])=>w.setVisibility(L.URI.revive(f),d))),this.B(g.listen("onDidChangeLoggers")(({added:f,removed:d})=>{for(const v of f)w.registerLogger({...v,resource:L.URI.revive(v.resource)});for(const v of d)w.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=S}),define(re[214],oe([0,1,2,11]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class c extends L.Disposable{constructor(D,R=[]){super(),this.a=new A.MultiplexLogger([D,...R]),this.B(D.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...R){this.a.trace(D,...R)}debug(D,...R){this.a.debug(D,...R)}info(D,...R){this.a.info(D,...R)}warn(D,...R){this.a.warn(D,...R)}error(D,...R){this.a.error(D,...R)}flush(){this.a.flush()}}e.LogService=c}),define(re[56],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(re[57],oe([0,1,3,62,2,5]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class D extends c.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const I=Object.keys(this.f).length;return this.f={...S,...this.f},I!==Object.keys(this.f).length&&await this.i(S),A.Iterable.reduce(this.g.entries(),(w,[g,f])=>({...w,[g]:f}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(S,[I,w])=>({...S,[I]:{definition:w,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=D;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(re[215],oe([0,1,3,2,57]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(C){this.b=C,this.a=new A.DisposableStore}listen(C,S){switch(S){case"onDidChange":return L.Event.map(this.b.onDidChange,I=>I.reduce((w,g)=>({...w,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(C,S,I){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=k;class D extends c.AbstractPolicyService{constructor(C,S){super(),this.a=S;for(const I in C){const{definition:w,value:g}=C[I];this.f[I]=w,g!==void 0&&this.g.set(I,g)}this.a.listen("onDidChange")(I=>{for(const w in I){const g=I[w];g===null?this.g.delete(w):this.g.set(w,g)}this.h.fire(Object.keys(I))})}async i(C){const S=await this.a.call("updatePolicyDefinitions",C);for(const I in S)this.g.set(I,S[I])}}e.PolicyChannelClient=D}),define(re[106],oe([0,1,4,36]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const k=L.globals.vscode.context.configuration();if(k)c=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:k.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(re[26],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[216],oe([0,1,6,8,2,13,28,11,26]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends c.Disposable{constructor(w,g,f){super(),this.b=g,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this.B(new L.RunOnceScheduler(()=>{this.f(w)},3e4)).schedule()}async f(w){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),f=(0,k.dirname)(w),d=(0,k.basename)(w),v=await D.Promises.readdir(f);await Promise.all(v.map(async h=>{if(h===d)return;const u=(0,k.join)(f,h),m=await D.Promises.stat(u);if(m.isDirectory()&&g-m.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${h}.`),D.Promises.rm(u)}))}catch(g){(0,A.onUnexpectedError)(g)}}};S=ye([J(1,C.IProductService),J(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(re[217],oe([0,1,6,8,2,13,28,15,11,26]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends c.Disposable{constructor(g,f,d){super(),this.b=g,this.c=f,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),f=JSON.parse(await D.Promises.readFile((0,k.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(f)){const p=f[m];g[`${p.hash}.${m}`]=!0}const d=(0,k.join)(this.b.userDataPath,"clp");if(!await D.Promises.exists(d))return;const h=await D.Promises.readdir(d);for(const m of h){if(g[m]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await D.Promises.rm((0,k.join)(d,m))}const u=Date.now();for(const m of Object.keys(g)){const p=(0,k.join)(d,m),E=await D.Promises.readdir(p);for(const P of E){if(P==="tcf.json")continue;const i=(0,k.join)(p,P),o=await D.Promises.stat(i);o.isDirectory()&&u-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(m,P)}`),await D.Promises.rm(i))}}}catch(g){(0,A.onUnexpectedError)(g)}}};I=ye([J(0,R.INativeEnvironmentService),J(1,C.ILogService),J(2,S.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(re[218],oe([0,1,13,5]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,A.createDecorator)("IV8InspectProfilingService");var c;(function(k){function D(C){return Boolean(C.samples&&C.timeDeltas)}k.isValidProfile=D;function R(C,S="noAbsolutePaths"){for(const I of C.nodes)I.callFrame&&I.callFrame.url&&((0,L.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,L.join)(S,(0,L.basename)(I.callFrame.url)));return C}k.rewriteAbsolutePaths=R})(c=e.Utils||(e.Utils={}))}),define(re[219],oe([0,1,31]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class A{constructor(){this.a=new Map}async startProfiling(k){const R=await(await new Promise((S,I)=>{te(["v8-inspect-profiler"],S,I)})).startProfiling({port:k.port,checkForPaused:!0}),C=(0,L.generateUuid)();return this.a.set(C,R),C}async stopProfiling(k){const D=this.a.get(k);if(!D)throw new Error(`UNKNOWN session '${k}'`);const R=await D.stop();return this.a.delete(k),R.profile}}e.InspectProfilingService=A}),define(re[40],oe([0,1,128,12]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class c{constructor(){this.a=new Map}add(D,R){L.ok(A.isString(D)),L.ok(A.isObject(R)),L.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,R)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new c}),define(re[107],oe([0,1,3,40]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function c(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,S){this.a[c(C)]=S,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const D=new k;A.Registry.add(e.Extensions.JSONContribution,D)}),define(re[45],oe([0,1,21,3,12,154,17,107,40]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=C.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const t=new Set;this.n(i,o,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const o=new Set;this.o(i,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const t=new Set;this.o(o,t),this.n(i,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const t=[];for(const{overrides:n,source:s}of i)for(const a in n)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const r=this.a.get(a),l=r?.valuesSources??new Map;if(s)for(const N of Object.keys(n[a]))l.set(N,s);const y={...r?.value||{},...n[a]};this.a.set(a,{source:s,value:y,valuesSources:l});const b=(0,D.getLanguageTagSettingPlainKey)(a),O={type:"object",default:y,description:k.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:c.isString(s)?void 0:s,defaultValueSource:s};t.push(...v(a)),this.d[a]=O,this.b.properties[a]=O}else{this.a.set(a,{value:n[a],source:s});const r=this.d[a];r&&(this.w(a,r),this.r(a,r))}this.m(t)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:t,source:n}of i)for(const s in t){const a=this.a.get(s),r=c.isString(n)?n:n?.id,l=c.isString(a?.source)?a?.source:a?.source?.id;if(r===l)if(o.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(i){let o=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,t){i.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,o){const t=n=>{if(n.properties)for(const s in n.properties){o.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,o=!0,t,n,s=3,a){s=c.isUndefinedOrNull(i.scope)?s:i.scope;const r=i.properties;if(r)for(const y in r){const b=r[y];if(o&&p(y,b)){delete r[y];continue}if(b.source=t,b.defaultDefaultValue=r[y].default,this.w(y,b),e.OVERRIDE_PROPERTY_REGEX.test(y)?b.scope=void 0:(b.scope=c.isUndefinedOrNull(b.scope)?s:b.scope,b.restricted=c.isUndefinedOrNull(b.restricted)?!!n?.includes(y):b.restricted),r[y].hasOwnProperty("included")&&!r[y].included){this.f[y]=r[y],delete r[y];continue}else this.d[y]=r[y],r[y].policy?.name&&this.e.set(r[y].policy.name,y);!r[y].deprecationMessage&&r[y].markdownDeprecationMessage&&(r[y].deprecationMessage=r[y].markdownDeprecationMessage),a.add(y)}const l=i.allOf;if(l)for(const y of l)this.p(y,o,t,n,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=t=>{const n=t.properties;if(n)for(const a in n)this.r(a,n[a]);t.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}}v(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const t=this.a.get(i);let n=t?.value,s=t?.source;c.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),c.isUndefined(n)&&(n=u(o.type)),o.default=n,o.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",d=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(P){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(P)){let o=d.exec(P);for(;o?.length;){const t=o[1].trim();t&&i.push(t),o=d.exec(P)}}return(0,L.distinct)(i)}e.overrideIdentifiersFromKey=v;function h(P){return P.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=h;function u(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new g;C.Registry.add(e.Extensions.Configuration,m);function p(P,i){return P.trim()?e.OVERRIDE_PROPERTY_REGEX.test(P)?k.localize(7,null,P):m.getConfigurationProperties()[P]!==void 0?k.localize(8,null,P):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,P,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}e.validateProperty=p;function E(){const P=[],i=m.getConfigurationProperties();for(const o of Object.keys(i))P.push([o,i[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=E}),define(re[72],oe([0,1,21,3,35,2,37,32,12,10,17,45,40]),function(te,e,L,A,c,k,D,R,C,S,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class d{constructor(t={},n=[],s=[],a){this.b=t,this.c=n,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof d)return n;const s=new v("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const s=this.rawConfiguration.getValue(t),a=n?this.rawConfiguration.getOverrideValue(t,n):void 0,r=n?this.rawConfiguration.override(n).getValue(t):s;return{value:s,override:a,merged:r}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,I.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return L.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.distinct(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=R.deepClone(this.contents),s=R.deepClone(this.overrides),a=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const l of t)if(r.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const y of l.overrides){const[b]=s.filter(O=>L.equals(O.identifiers,y.identifiers));b?(this.h(b.contents,y.contents),b.keys.push(...y.keys),b.keys=L.distinct(b.keys)):s.push(R.deepClone(y))}for(const y of l.keys)a.indexOf(y)===-1&&a.push(y)}return new d(n,a,s,r.every(l=>l instanceof d)?void 0:r)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let r=this.contents[a];const l=n[a];l&&(typeof r=="object"&&typeof l=="object"?(r=R.deepClone(r),this.h(r,l)):r=l),s[a]=r}return new d(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&C.isObject(t[s])&&C.isObject(n[s])){this.h(t[s],n[s]);continue}t[s]=R.deepClone(n[s])}}i(t){let n=null,s=null;const a=r=>{r&&(s?this.h(s,r):s=R.deepClone(r))};for(const r of this.overrides)L.equals(r.identifiers,[t])?n=r.contents:r.identifiers.includes(t)&&a(r.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}j(t,n,s){(0,I.addToValueTree)(this.contents,t,n,a=>console.error(a)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,I.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=d;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!C.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:a,overrides:r,restricted:l,hasExcludedProperties:y}=this.h(t,n);this.b=new d(s,a,r,y?[t]:void 0),this.c=l||[]}g(t){let n={},s=null,a=[];const r=[],l=[];function y(O){Array.isArray(a)?a.push(O):s!==null&&(a[s]=O)}const b={onObjectBegin:()=>{const O={};y(O),r.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const O=[];y(O),r.push(a),a=O,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:y,onError:(O,N,F)=>{l.push({error:O,offset:N,length:F})}};if(t)try{c.visit(t,b),n=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(t,n){const s=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,s,!0,n);t=a.raw;const r=(0,I.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),l=Object.keys(t),y=this.j(t,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:r,keys:l,overrides:y,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,n,s,a){let r=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:r};const l={},y=[];for(const b in t)if(w.OVERRIDE_PROPERTY_REGEX.test(b)&&s){const O=this.i(t[b],n,!1,a);l[b]=O.raw,r=r||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=n[b],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(b),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&O?.restricted)?l[b]=t[b]:r=!0}return{raw:l,restricted:y,hasExcludedProperties:r}}j(t,n){const s=[];for(const a of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const l in t[a])r[l]=t[a][l];s.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,I.toValuesTree)(r,n)})}return s}}e.ConfigurationModelParser=v;class h extends k.Disposable{constructor(t,n,s,a){super(),this.f=t,this.g=n,this.h=a,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new d}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class u{constructor(t,n,s,a,r,l,y,b,O,N,F,z,G){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=a,this.d=r,this.f=l,this.g=y,this.h=b,this.i=O,this.j=N,this.k=F,this.l=z,this.m=G}get value(){return f(this.c)}n(t,n,s){const a=t.inspect(n,s);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(t,n,s,a,r=new d,l=new d,y=new D.ResourceMap,b=new d,O=new D.ResourceMap){this.c=t,this.d=n,this.f=s,this.g=a,this.h=r,this.i=l,this.j=y,this.l=b,this.m=O,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(t,n,s){return this.q(t,n,s).getValue(t)}updateValue(t,n,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new d,this.m.set(s.resource,a))):a=this.l,n===void 0?a.removeValue(t):a.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const a=this.q(t,n,s),r=this.u(n.resource,s),l=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const b of a.overrides)for(const O of b.identifiers)a.getOverrideValue(t,O)!==void 0&&y.add(O);return new u(t,n,a.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,r||void 0,l)}keys(t){const n=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:a,updated:r,removed:l}=P(this.c,t);n=[...a,...r,...l]}for(const a of n)for(const r of(0,w.overrideIdentifiersFromKey)(a)){const l=this.c.getKeysForOverrideIdentifier(r),y=t.getKeysForOverrideIdentifier(r),b=[...y.filter(O=>l.indexOf(O)===-1),...l.filter(O=>y.indexOf(O)===-1),...l.filter(O=>!R.equals(this.c.override(r).getValue(O),t.override(r).getValue(O)))];s.push([r,b])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:a}=P(this.d,t),r=[...n,...s,...a];return r.length&&this.updatePolicyConfiguration(t),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=P(this.applicationConfiguration,t),l=[...n,...s,...a];return l.length&&this.updateApplicationConfiguration(t),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=P(this.localUserConfiguration,t),l=[...n,...s,...a];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=P(this.remoteUserConfiguration,t),l=[...n,...s,...a];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:a,overrides:r}=P(this.workspaceConfiguration,t),l=[...n,...s,...a];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:r}}compareAndUpdateFolderConfiguration(t,n){const s=this.p.get(t),{added:a,updated:r,removed:l,overrides:y}=P(s,n),b=[...a,...r,...l];return(b.length||!s)&&this.updateFolderConfiguration(t,n),{keys:b,overrides:y}}compareAndDeleteFolderConfiguration(t){const n=this.p.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:r,overrides:l}=P(n,void 0);return{keys:[...s,...a,...r],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,n,s){let a=this.r(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},n){let s=this.s();if(n&&t){const a=n.getFolder(t);a&&(s=this.t(a.uri)||s);const r=this.m.get(t);r&&(s=s.merge(r))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let n=this.b.get(t);if(!n){const s=this.s(),a=this.j.get(t);a?(n=s.merge(a),this.b.set(t,n)):n=s}return n}u(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:a,keys:r}=this.j.get(n);return t.push([n,{contents:s,overrides:a,keys:r}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.x(t.defaults),s=this.x(t.policy),a=this.x(t.application),r=this.x(t.user),l=this.x(t.workspace),y=t.folders.reduce((b,O)=>(b.set(S.URI.revive(O[0]),this.x(O[1])),b),new D.ResourceMap);return new m(n,s,a,r,new d,l,y,new d,new D.ResourceMap)}static x(t){return new d(t.contents,t.keys,t.overrides)}}e.Configuration=m;function p(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,n=new Map;for(const a of o)a.keys.forEach(r=>t.add(r)),a.overrides.forEach(([r,l])=>{const y=(0,D.getOrSet)(n,r,new Set);l.forEach(b=>y.add(b))});const s=[];return n.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=p;class E{constructor(t,n,s,a){this.change=t,this.f=n,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of t.keys)this.affectedKeys.add(r);for(const[,r]of t.overrides)for(const l of r)this.affectedKeys.add(l);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,a=this.d.indexOf(s);if(a<0)return!1;const r=a+s.length;if(r>=this.d.length)return!1;const l=this.d.charCodeAt(r);if(l!==this.b&&l!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,b=this.g.getValue(t,n,this.h);return!R.equals(y,b)}return!0}}e.ConfigurationChangeEvent=E;function P(o,t){const{added:n,removed:s,updated:a}=i(t?.rawConfiguration,o?.rawConfiguration),r=[],l=o?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const b=y.filter(O=>!l.includes(O));for(const O of b)r.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const b=l.filter(O=>!y.includes(O));for(const O of b)r.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const b of l)if(y.includes(b)){const O=i({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:t.getOverrideValue(void 0,b)||{},keys:t.getKeysForOverrideIdentifier(b)});r.push([b,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:s,updated:a,overrides:r}}function i(o,t){const n=o?t?o.keys.filter(r=>t.keys.indexOf(r)===-1):[...o.keys]:[],s=t?o?t.keys.filter(r=>o.keys.indexOf(r)===-1):[...t.keys]:[],a=[];if(o&&t){for(const r of t.keys)if(o.keys.indexOf(r)!==-1){const l=(0,I.getConfigurationValue)(t.contents,r),y=(0,I.getConfigurationValue)(o.contents,r);R.equals(l,y)||a.push(r)}}return{added:n,removed:s,updated:a}}}),define(re[220],oe([0,1,21,3,2,32,12,72,45,11,57,40]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends c.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:u})=>this.c(Array.from(h),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(h,u){this.h(h,w.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:h})}f(){return{}}g(){this.b=new R.ConfigurationModel;const h=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(h),h)}h(h,u){const m=this.f();for(const p of h){const E=m[p],P=u[p];E!==void 0?this.b.addValue(p,E):P?this.b.addValue(p,P.default):this.b.removeValue(p)}}}e.DefaultConfiguration=g;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let d=class extends c.Disposable{get configurationModel(){return this.b}constructor(h,u,m){super(),this.c=h,this.f=u,this.g=m,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.i(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.j(await this.h(h),!0))),this.b}async h(h){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",h);const u={},m=[],p=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const E of h){const P=p[E];if(!P){m.push(E);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}m.push(E),u[P.policy.name]={type:P.type}}}return(0,D.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),m}i(h){this.g.trace("PolicyConfiguration#onDidChangePolicies",h);const u=w.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),m=(0,L.coalesce)(h.map(p=>u.get(p)));this.j(m,!0)}j(h,u){this.g.trace("PolicyConfiguration#update",h);const m=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),p=[],E=this.b.isEmpty();for(const P of h){const i=m[P]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(E?o!==void 0:!(0,k.equals)(this.b.getValue(P),o))&&p.push([P,o])}else this.b.getValue(P)!==void 0&&p.push([P,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const P=this.b;this.b=new R.ConfigurationModel;for(const i of P.keys)this.b.setValue(i,P.getValue(i));for(const[i,o]of p)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);u&&this.a.fire(this.b)}}};d=ye([J(1,I.IPolicyService),J(2,S.ILogService)],d),e.PolicyConfiguration=d}),define(re[221],oe([0,1,6,3,2,25,17,72,220,57]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends c.Disposable{constructor(g,f,d,v){super(),this.i=g,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.DefaultConfiguration),this.c=d instanceof S.NullPolicyService?new C.NullPolicyConfiguration:this.B(new C.PolicyConfiguration(this.b,d,v)),this.f=this.B(new R.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,f)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:u})=>this.k(h,u))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,f,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(g,f,new R.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(g,f){const d=typeof g=="string"?g:void 0,v=(0,D.isConfigurationOverrides)(g)?g:(0,D.isConfigurationOverrides)(f)?f:{};return this.a.getValue(d,v,void 0)}updateValue(g,f,d,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const f=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(d,f,2)}k(g,f){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(g,f);this.m(v,d,7)}l(g){const f=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(g);this.m(d,f,7)}m(g,f,d){const v=new R.ConfigurationChangeEvent(g,{data:f},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(re[222],oe([0,1,8,5]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var c;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(c=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends L.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof k&&C._code===c.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof k&&C._code===c.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof k&&C._code===c.NoResolverFound}static isHandled(C){return C instanceof k&&C.isHandled}constructor(C,S=c.Unknown,I){super(C),this._message=C,this._code=S,this._detail=I,this.isHandled=S===c.NotAvailable&&I===!0,Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k;function D(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.getRemoteAuthorityPrefix=D}),define(re[73],oe([0,1,22]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(S){return S.scheme===L.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=A;function c(S){if(!S)return;const I=S.indexOf("+");return I<0?S:S.substr(0,I)}e.getRemoteName=c;function k(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=k;function D(S){const{host:I,port:w}=C(S);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}e.parseAuthorityWithPort=D;function R(S,I){let{host:w,port:g}=C(S);return typeof g>"u"&&(g=I),{host:w,port:g}}e.parseAuthorityWithOptionalPort=R;function C(S){const I=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=S.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=S.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:S,port:void 0}}}),define(re[46],oe([0,1,27,5,73]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,v){if(typeof d>"u"||d===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof d=="string"||typeof v=="string"){const h=typeof d=="string"?d:d.value,u=typeof v=="string"?v:v.value;return L.equalsIgnoreCase(h,u)}return d.c===v.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function S(f){return I(f)}e.isApplicationScopedExtension=S;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function w(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function g(f,d){if(d){const v=`onResolveRemoteAuthority:${(0,c.getRemoteName)(d)}`;return!!f.activationEvents?.includes(v)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[223],oe([0,1,2,13,28,46]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends L.Disposable{constructor(C,S){super(),this.b=C,this.a=(0,A.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(I=>this.c(I))),this.B(S.onDidUninstallExtension(I=>this.f(I)))}c(C){C.some(S=>!!S.local)&&this.invalidate()}f(C){C.error||this.invalidate()}invalidate(){c.Promises.rm(this.a,c.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(re[224],oe([0,1,6,16,24,8,3,2,103,88,31,95,222,73]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var v;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const $=new c.CancellationTokenSource;return setTimeout(()=>$.cancel(),U),$.token}function m(U,$){if(U.isCancellationRequested||$.isCancellationRequested)return c.CancellationToken.Cancelled;const H=new c.CancellationTokenSource;return U.onCancellationRequested(()=>H.cancel()),$.onCancellationRequested(()=>H.cancel()),H.token}class p{get didTimeout(){return this.c==="timedout"}constructor($){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((H,ee)=>{this.f=H,this.g=ee}),$.isCancellationRequested?this.h():this.d.add($.onCancellationRequested(()=>this.h()))}registerDisposable($){this.c==="pending"?this.d.add($):$.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f($))}reject($){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g($))}}function E(U,$){const H=new p($);return H.registerDisposable(U.onControlMessage(ee=>{const K=JSON.parse(ee.toString()),Z=X(K);Z?H.reject(Z):H.resolve(K)})),H.promise}function P(U,$,H,ee,K,Z,ie,le,he){const me=new p(he),pe=S.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),C.mark(`code/willCreateSocket/${ie}`),$.connect(H,ee,K,Z,le,(we,Ee)=>{me.didTimeout?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) finished after ${pe.elapsed()} ms, but this is too late and has timed out already.`),we&&U.error(we),Ee?.dispose()):we||!Ee?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) returned an error after ${pe.elapsed()} ms.`),me.reject(we)):(C.mark(`code/didCreateSocketOK/${ie}`),U.info(`Creating a socket (${le}) was successful after ${pe.elapsed()} ms.`),me.resolve(Ee))}),me.promise}function i(U,$){const H=new p($);return U.then(ee=>{H.didTimeout||H.resolve(ee)},ee=>{H.didTimeout||H.reject(ee)}),H.promise}async function o(U,$,H,ee){const K=V(U,$);U.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await P(U.logService,U.socketFactory,U.host,U.port,(0,f.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,h($),`renderer-${h($)}-${U.reconnectionToken}`,ee)}catch(pe){throw U.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),U.logService.error(pe),pe}U.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let ie,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(Z,null),ie=U.reconnectionProtocol,le=!1):(ie=new w.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const he=await i(U.signService.createNewMessage((0,I.generateUuid)()),ee),me={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};ie.sendControl(A.VSBuffer.fromString(JSON.stringify(me)));try{const pe=await E(ie,m(ee,u(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(U.logService.trace(`${K} 4/6. received SignRequest control message.`),!await i(U.signService.validate(he,pe.signedData),ee)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ee=await i(U.signService.sign(pe.data),ee),ke={type:"connectionType",commit:U.commit,signedData:Ee,desiredConnectionType:$};return H&&(ke.args=H),U.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(A.VSBuffer.fromString(JSON.stringify(ke))),{protocol:ie,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(U.logService.error(`${K} the handshake timed out. Error:`),U.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(pe)),le&&M(ie),pe}}async function t(U,$,H,ee){const K=Date.now(),Z=V(U,$),{protocol:ie,ownsProtocol:le}=await o(U,$,H,ee),he=new p(ee);return he.registerDisposable(ie.onControlMessage(me=>{const pe=JSON.parse(me.toString()),we=X(pe);we?(U.logService.error(`${Z} received error control message when negotiating connection. Error:`),U.logService.error(we),le&&M(ie),he.reject(we)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${j(K)}!`),he.resolve({protocol:ie,firstMessage:pe}))})),he.promise}async function n(U,$){const{protocol:H}=await t(U,1,void 0,$);return{protocol:H}}async function s(U,$,H){const{protocol:ee,firstMessage:K}=await t(U,2,$,H),Z=K&&K.debugPort;return{protocol:ee,debugPort:Z}}async function a(U,$,H){const ee=Date.now(),K=V(U,3),{protocol:Z}=await o(U,3,$,H);return U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${j(ee)}!`),Z}async function r(U,$,H){const{host:ee,port:K,connectionToken:Z}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:ee,port:K,connectionToken:Z,reconnectionToken:$,reconnectionProtocol:H,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function l(U,$,H){return b(U,async ee=>{const{protocol:K}=await n(ee,c.CancellationToken.None);return new q(U,$,H,ee.reconnectionToken,K)})}e.connectRemoteAgentManagement=l;async function y(U,$){return b(U,async H=>{const{protocol:ee,debugPort:K}=await s(H,$,c.CancellationToken.None);return new x(U,$,H.reconnectionToken,ee,K)})}e.connectRemoteAgentExtensionHost=y;async function b(U,$){for(let ee=1;;ee++)try{const K=(0,I.generateUuid)(),Z=await r(U,K,null);return await $(Z)}catch(K){if(ee<5)U.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(K);else throw U.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(K),_.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(K)),K}}async function O(U,$,H){const ee=await r(U,(0,I.generateUuid)(),null);return await a(ee,{host:$,port:H},c.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function N(U){return(0,L.createCancelablePromise)($=>new Promise((H,ee)=>{const K=setTimeout(H,U*1e3);$.onCancellationRequested(()=>{clearTimeout(K),H()})}))}var F;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class z{constructor($,H){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.type=0}}e.ConnectionLostEvent=z;class G{constructor($,H,ee,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.durationSeconds=ee,this.c=K,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=G;class Y{constructor($,H,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=Y;class W{constructor($,H,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=W;class T{constructor($,H){this.reconnectionToken=$,this.connectionHealth=H,this.type=5}}e.ConnectionHealthChangedEvent=T;class B{constructor($,H,ee,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class _ extends R.Disposable{static triggerPermanentFailure($,H,ee){this._permanentFailure=!0,this.f=$,this.g=H,this.h=ee,this.i.forEach(K=>K.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach($=>$.s())}static debugPauseSocketWriting(){this.i.forEach($=>$.w())}get k(){return this.c||_._permanentFailure}constructor($,H,ee,K,Z){super(),this.n=$,this.p=H,this.reconnectionToken=ee,this.protocol=K,this.r=Z,this.j=this.B(new D.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.B(K.onSocketClose(ie=>{const le=ae(this.n,this.reconnectionToken,!0);ie?ie.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.p.logService.error(ie.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.p.logService.error(ie.event)):this.p.logService.info(`${le} received socket close event.`),this.s()})),this.B(K.onSocketTimeout(ie=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(K.onHighRoundTripTime(ie=>{const le=se(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${ie.roundTripTime}ms (${ie.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(K.onDidChangeConnectionHealth(ie=>{this.j.fire(new T(this.reconnectionToken,ie))})),_.i.push(this),this.B((0,R.toDisposable)(()=>{const ie=_.i.indexOf(this);ie>=0&&_.i.splice(ie,1)})),this.k&&this.v(_.f,_.g,_.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const $=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const K=ee<H.length?H[ee]:H[H.length-1];try{if(K>0){const ie=N(K);this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,ie)),this.p.logService.info(`${$} waiting for ${K} seconds before reconnecting...`);try{await ie}catch{}}if(this.k){this.p.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.p.logService.info(`${$} resolving connection...`);const Z=await r(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${$} connecting to ${Z.host}:${Z.port}...`),await this.y(Z,u(d)),this.p.logService.info(`${$} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.p.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.p.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.p.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((0,k.isCancellationError)(Z)){this.p.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if(Z instanceof g.RemoteAuthorityResolverError){this.p.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,g.RemoteAuthorityResolverError.isHandled(Z));break}this.p.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k&&!this.m)}u($,H,ee){this.r?_.triggerPermanentFailure($,H,ee):this.v($,H,ee)}v($,H,ee){this.j.fire(new B(this.reconnectionToken,$,H,ee)),M(this.protocol)}w(){this.protocol.pauseSocketWriting()}}_._permanentFailure=!1,_.f=0,_.g=0,_.h=!1,_.i=[],e.PersistentConnection=_;class q extends _{constructor($,H,ee,K,Z){super(1,$,K,Z,!0),this.client=this.B(new w.Client(Z,{remoteAuthority:H,clientId:ee},$.ipcLogger))}async y($,H){await n($,H)}}e.ManagementPersistentConnection=q;class x extends _{constructor($,H,ee,K,Z){super(2,$,ee,K,!1),this.z=H,this.debugPort=Z}async y($,H){await s($,this.z,H)}}e.ExtensionHostPersistentConnection=x;function M(U){try{U.acceptDisconnect();const $=U.getSocket();U.dispose(),$.dispose()}catch($){(0,k.onUnexpectedError)($)}}function X(U){if(U&&U.type==="error"){const $=new Error(`Connection error: ${U.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function Q(U,$){for(;U.length<$;)U+=" ";return U}function se(U,$){return`[remote-connection][${Q(h(U),13)}][${$.substr(0,5)}\u2026]`}function ae(U,$,H){return`${se(U,$)}[${H?"reconnect":"initial"}]`}function V(U,$){return`${ae($,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function j(U){return`${Date.now()-U} ms`}}),define(re[225],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[226],oe([0,1,85,152]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(c,k,D,R,C,S){const I=g=>S(g,void 0),w=L.createConnection({host:c,port:k},()=>{w.removeListener("error",I);const g=Buffer.alloc(16);for(let h=0;h<16;h++)g[h]=Math.round(Math.random()*256);const f=g.toString("base64"),d=[`GET ws://${/:/.test(c)?`[${c}]`:c}:${k}${D}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];w.write(d.join(`\r
`)+`\r
\r
`);const v=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),S(void 0,new A.NodeSocket(w,C)))};w.on("data",v)});w.setNoDelay(!0),w.once("error",I)}}}),define(re[108],oe([0,1,5,170]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var c;(function(k){k.disconnected={type:"disconnected"},k.uninitialized={type:"uninitialized"},k.connected=D=>({type:"connected",info:D}),k.connecting=D=>({type:"connecting",progress:D})})(c=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,A.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(re[58],oe([0,1,16,172,45,5,40]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function R(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=R;function C(v){return v.res.statusCode===204}async function S(v){return C(v)?null:(await(0,L.streamToBuffer)(v.stream)).toString()}e.asText=S;async function I(v){if(!R(v))throw new Error("Server returned "+v.res.statusCode);return S(v)}e.asTextOrError=I;async function w(v){if(!R(v))throw new Error("Server returned "+v.res.statusCode);if(C(v))return null;const u=(await(0,L.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=w;function g(v){d(v)}e.updateProxyConfigurationsScope=g;let f;function d(v){const h=D.Registry.as(c.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:u?[u]:[]})}d(2)}),define(re[227],oe([0,1,24,22,14,58]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(C,S){this.a=C,this.b=S}async download(C,S,I=L.CancellationToken.None){if(C.scheme===A.Schemas.file||C.scheme===A.Schemas.vscodeRemote){await this.b.copy(C,S);return}const w={type:"GET",url:C.toString(!0)},g=await this.a.request(w,I);if(g.res.statusCode===200)await this.b.writeFile(S,g.stream);else{const f=await(0,k.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${f}`)}}};D=ye([J(0,k.IRequestService),J(1,c.IFileService)],D),e.DownloadService=D}),define(re[228],oe([0,1,16,24]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class c{constructor(R){this.a=R}listen(R,C){throw new Error("Invalid listen")}call(R,C,S,I=A.CancellationToken.None){switch(C){case"request":return this.a.request(S[0],I).then(async({res:w,stream:g})=>{const f=await(0,L.streamToBuffer)(g);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=c;class k{constructor(R){this.a=R}async request(R,C){const[S,I]=await this.a.call("request",[R],C);return{res:S,stream:(0,L.bufferToStream)(I)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=k}),define(re[109],oe([0,1,64,5]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function c(k){return(0,L.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=c,e.ISharedProcessWorkerService=(0,A.createDecorator)("sharedProcessWorkerService")}),define(re[229],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(A){A.Spawn="vscode:shared-process->shared-process-worker=spawn",A.Terminate="vscode:shared-process->shared-process-worker=terminate",A.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",A.Ready="vscode:shared-process-worker->shared-process=ready",A.Ack="vscode:shared-process-worker->shared-process=ack",A.Trace="vscode:shared-process-worker->shared-process=trace",A.Info="vscode:shared-process-worker->shared-process=info",A.Warn="vscode:shared-process-worker->shared-process=warn",A.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[230],oe([0,1,150,6,24,3,2,22,31,11,109,229]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(v){this.d=v,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(v){const h=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${h})`);const u=(0,I.hash)(v);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${h})`),this.f(v));const m=new c.CancellationTokenSource;let p,E,P;this.b.set(u,n=>{m.dispose(!0),p?.terminate(v,c.CancellationToken.None),E?.close(),P?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:n}))}),p=await this.e(v);const i=new Promise(n=>{this.c.set(u,n)});if(m.token.isCancellationRequested)return i;const{port1:o,port2:t}=new MessageChannel;return E=o,P=t,await p.spawn(v,P,m.token),m.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${h})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[E])),i}e(v){let h=this.a.get(v.process.moduleId);if(!h){this.d.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const u=new f(v.process.type,this.d);h=u.init(),u.onDidProcessSelfTerminate(({configuration:m,reason:p})=>{this.f(m,p)}),this.a.set(v.process.moduleId,h)}return h}async disposeWorker(v){return this.f(v)}f(v,h){const u=this.b.get((0,I.hash)(v));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),u(h))}};g=ye([J(0,S.ILogService)],g),e.SharedProcessWorkerService=g;class f extends D.Disposable{constructor(v,h){super(),this.f=v,this.g=h,this.a=this.B(new k.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const v=new A.DeferredPromise,h=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return h.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},h.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},h.onmessage=u=>{const{id:m,message:p,configuration:E,nonce:P}=u.data;switch(m){case w.SharedProcessWorkerMessages.Ready:v.complete(h);break;case w.SharedProcessWorkerMessages.Ack:if(P){const i=this.c.get(P);i&&(this.c.delete(P),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:E&&p&&this.a.fire({configuration:E,reason:JSON.parse(p)});break;case w.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case w.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},h.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async i(v,h,u){const m=await this.b;if(!h.isCancellationRequested)return new Promise(p=>{const E=(0,C.generateUuid)();this.c.set(E,p);const P={...v,nonce:E};u?m.postMessage(P,[u]):m.postMessage(P),h.onCancellationRequested(()=>{this.c.delete(E)&&p()})})}spawn(v,h,u){const m={id:w.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(m,u,h)}terminate(v,h){const u={id:w.SharedProcessWorkerMessages.Terminate,configuration:v};return this.i(u,h)}}}),define(re[231],oe([0,1,61,22,96]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends c.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}}ye([L.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(re[232],oe([0,1,50,13,173,24,38,8,4,31,147,191,6,130]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function v(u,m,p,E){return p["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(E)&&!p["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(E)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=g.Promises.withAsyncBody(async(P,i)=>{const o=new k.CancellationTokenSource;let t=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,f.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),i(new Error((0,c.localize)(0,null)))},t);try{P(await h(m,o.token))}catch(a){!(0,R.isCancellationError)(a)&&!o.token.isCancellationRequested?i(new Error((0,c.localize)(1,null,(0,D.toErrorMessage)(a)))):P({})}finally{clearTimeout(s),o.dispose()}})),d)}e.getResolvedShellEnv=v;async function h(u,m){const p=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",p);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const P=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(P+"({.*})"+P),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,I.getSystemShell)(C.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(m.isCancellationRequested)return s(new R.CancellationError);const a=(0,A.basename)(t);let r,l;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(r=`& '${process.execPath}' ${y} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,l=["-Login","-Command"]):(r=`'${process.execPath}' ${y} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),r);const b=(0,L.spawn)(t,[...l,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(b.kill(),s(new R.CancellationError))),b.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(F)),s(F)});const O=[];b.stdout.on("data",F=>O.push(F));const N=[];b.stderr.on("data",F=>N.push(F)),b.on("close",(F,z)=>{const G=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",G);const Y=Buffer.concat(N).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),F||z)return s(new Error((0,c.localize)(2,null,F,z)));const W=i.exec(G),T=W?W[1]:"{}";try{const B=JSON.parse(T);p?B.ELECTRON_RUN_AS_NODE=p:delete B.ELECTRON_RUN_AS_NODE,E?B.ELECTRON_NO_ATTACH_CONSOLE=E:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.VSCODE_RESOLVING_ENVIRONMENT,delete B.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",B),n(B)}catch(B){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(B)),s(B)}})})}}),define(re[110],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[233],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((c,k)=>te(["vsda"],c,k))}async createNewMessage(c){try{const k=await this.c(),D=new k.validator;if(D){const R=String(L.a++);return this.b.set(R,D),{id:R,data:D.createNewMessage(c)}}}catch{}return{id:"",data:c}}async validate(c,k){if(!c.id)return!0;const D=this.b.get(c.id);if(!D)return!1;this.b.delete(c.id);try{return D.validate(k)==="ok"}catch{return!1}}async sign(c){try{const k=await this.c(),D=new k.signer;if(D)return D.sign(c)}catch{}return c}}L.a=1,e.SignService=L}),define(re[74],oe([0,1,3,2]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class c extends A.Disposable{constructor(w,g,f){super(),this.a=w,this.b=g,this.c=f}async getItems(){const w={profile:this.b,workspace:this.c},g=await this.a.call("getItems",w);return new Map(g)}updateItems(w){const g={profile:this.b,workspace:this.c};return w.insert&&(g.insert=Array.from(w.insert.entries())),w.delete&&(g.delete=Array.from(w.delete.values())),this.a.call("updateItems",g)}}class k extends c{constructor(w,g){super(w,g,void 0),this.f=this.B(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(w=>this.h(w)))}h(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this.f.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class D extends k{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=D;class R extends k{constructor(w,g){super(w,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class C extends c{constructor(w,g){super(w,void 0,g),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class S{constructor(w){this.a=w}isUsed(w){const g={payload:w,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.StorageClient=S}),define(re[111],oe([0,1,4,36,10,31]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(S){if(L.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,I,w,g,f,d,v,h,u,m){const p=Object.create(null);p["common.machineId"]=v,p.sessionID=(0,k.generateUuid)()+Date.now(),p.commitHash=f,p.version=d,p["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,L.PlatformToString)(L.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=g,p["common.product"]=m||"desktop",h&&(p["common.msftInternal"]=h);let E=0;const P=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-P,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),L.isLinuxSnap&&(p["common.snap"]="true");const i=D(w);i&&(p["common.platformDetail"]=i);try{const o=await S.readFile(c.URI.file(u));p["common.source"]=o.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=R;function C(S){const I=A.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return S.some(g=>w===g)}e.verifyMicrosoftInternalDomain=C}),define(re[19],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var c;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(c=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[234],oe([0,1,34,6,35,22,13,4,10,144,28,146,97,14,26,19]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function u(i,o){const t=`${i}::${o.join(":")}`,n=h.get(t);if(n)return n;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,r=new Map,l=2e4;function y(O,N,F,z){const G=N.substring(O.length+1);return A.Promises.withAsyncBody(async Y=>{let W;try{W=await I.Promises.readdir(N,{withFileTypes:!0})}catch{Y();return}if(z.count>=l){z.count+=W.length,z.maxReached=!0,Y();return}let T=W.length;if(T===0){Y();return}let B=W;z.count+W.length>l&&(z.maxReached=!0,T=l-z.count,B=W.slice(0,T)),z.count+=W.length;for(const _ of B)if(_.isDirectory()){if(F.includes(_.name)||await y(O,(0,D.join)(N,_.name),F,z),--T===0){Y();return}}else{const q=_.name.lastIndexOf(".");if(q>=0){const x=_.name.substring(q+1);x&&a.set(x,(a.get(x)??0)+1)}for(const x of s)x.relativePathPattern?.test(G)!==!1&&x.filePattern.test(_.name)&&r.set(x.tag,(r.get(x.tag)??0)+1);if(--T===0){Y();return}}})}const b=A.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1};await y(i,i,o,N);const F=await E(i);O({configFiles:m(r),fileTypes:m(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:F})});return h.set(t,b),b}e.collectWorkspaceStats=u;function m(i){return Array.from(i.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function p(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=p;async function E(i){try{const o=new Map,t=(0,D.join)(i,".vscode","launch.json"),n=await I.Promises.readFile(t),s=[],a=(0,c.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,c.getNodeType)(a)==="object"&&a.configurations)for(const r of a.configurations){const l=r.type;l&&(o.has(l)?o.set(l,o.get(l)+1):o.set(l,1))}return m(o)}catch{return[]}}e.collectLaunchConfigs=E;let P=class{constructor(o,t){this.c=o,this.d=t}f(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}g(o){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const n=L.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,w.listProcesses)(o.mainPID),this.k(o)]).then(async n=>{let[s,a]=n,r=this.m(o,s);return t.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))r+=`
${l.errorMessage}`,a+=`
${l.errorMessage}`;else if(r+=`

Remote: ${l.hostName}`,l.processes&&(r+=`
${this.m(o,l.processes)}`),l.workspaceMetadata){a+=`
|  Remote: ${l.hostName}`;for(const y of Object.keys(l.workspaceMetadata)){const b=l.workspaceMetadata[y];let O=`${b.fileCount} files`;b.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${y}): ${O}`,a+=this.h(b)}}}),{processInfo:r,workspaceInfo:a}})}async getSystemInfo(o,t){const{memory:n,vmHint:s,os:a,cpus:r}=p(),l={os:a,memory:n,cpus:r,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(l.load=`${L.loadavg().map(y=>Math.round(y)).join(", ")}`),R.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(o,t){const n=[];return(0,w.listProcesses)(o.mainPID).then(async s=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,s)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),t.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(o,a.processes)),a.workspaceMetadata)for(const r of Object.keys(a.workspaceMetadata)){const l=a.workspaceMetadata[r];let y=`${l.fileCount} files`;l.maxFilesReached&&(y=`more than ${y}`),n.push(`Folder (${r}): ${y}`),n.push(this.h(l))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const t=[];let s=0;const a=(b,O)=>{const N=` ${b}(${O})`;s+N.length>60?(t.push(r),r="|                 ",s=r.length):s+=N.length,r+=N};let r="|      File types:";const l=10,y=o.fileTypes.length>l?l:o.fileTypes.length;for(let b=0;b<y;b++){const O=o.fileTypes[b];a(O.name,O.count)}if(t.push(r),o.configFiles.length>=0&&(r="|      Conf files:",s=0,o.configFiles.forEach(b=>{a(b.name,b.count)}),t.push(r)),o.launchConfigFiles.length>0){let b="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{b+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),t.push(b)}return t.join(`
`)}j(o){const t=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const t=[],n=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const r=C.URI.revive(a);if(r.scheme===k.Schemas.file){const l=r.fsPath;n.push(u(l,["node_modules",".git"]).then(y=>{let b=`${y.fileCount} files`;y.maxFilesReached&&(b=`more than ${b}`),t.push(`|    Folder (${(0,D.basename)(l)}): ${b}`),t.push(this.h(y))}).catch(y=>{t.push(`|      Error: Unable to collect workspace stats for folder ${l} (${y.toString()})`)}))}else t.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,t){const n=new Map;o.windows.forEach(a=>n.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(o.mainPID,n,s,t,0),s.join(`
`)}n(o,t,n,s,a){const r=a===0;let l;r?l=s.pid===o?`${this.d.applicationName} main`:"remote agent":(l=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(l=`${l} (${t.get(s.pid)})`));const y=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(s.children)&&s.children.forEach(b=>this.n(o,t,n,b,a+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:n}of o.folders){const s=C.URI.revive(n);if(s.scheme!==k.Schemas.file)continue;const a=s.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(l=>t.add(l.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const n=C.URI.revive(t);if(n.scheme!==k.Schemas.file)continue;const s=n.fsPath;try{const a=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};P=ye([J(0,v.ITelemetryService),J(1,d.IProductService)],P),e.DiagnosticsService=P}),define(re[235],oe([0,1,108,3,19,15,2,11,13,50,26,4,6,104,17,171,34,10]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const m=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let p=class extends D.Disposable{constructor(P,i,o,t,n,s){super(),this.r=P,this.s=i,this.t=o,this.u=s,this.b=new A.Emitter,this.onDidTokenFailed=this.b.event,this.f=new A.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new A.Emitter,this.onDidChangeAccount=this.g.event,this.k=L.TunnelStates.disconnected;const a=u.URI.file((0,C.join)(o.logsPath,L.LOG_FILE_NAME));this.h=this.B(t.createLogger(a,{name:L.LOGGER_NAME,id:L.LOG_CHANNEL_ID})),this.n=new g.Delayer(100),this.B(this.h.onDidChangeLogLevel(r=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(r)))),this.B(n.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(s.onDidChangeConfiguration(r=>{m.some(l=>r.affectsConfiguration(l))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(P){if(P&&this.i?P.token!==this.i.token||P.providerId!==this.i.providerId:P!==this.i){this.i=P,this.g.fire(P),P?this.h.info(`Account updated: ${P.accountLabel} (${P.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!P});try{await this.n.trigger(()=>this.w())}catch(i){this.h.error(i)}}return this.k}v(){if(!this.p){let P;w.isMacintosh?P=this.t.appRoot:P=(0,C.dirname)((0,C.dirname)(this.t.appRoot)),this.p=(0,C.join)(P,"bin",`${this.s.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(L.TunnelStates.disconnected);return}const{token:P,providerId:i,accountLabel:o}=this.i;this.y(L.TunnelStates.connecting((0,v.localize)(0,null,o,i)));const t=(l,y)=>{l=l.replaceAll(P,"*".repeat(4)),y?this.h.error(l):this.h.info(l),!this.t.isBuilt&&l.startsWith("   Compiling")&&this.y(L.TunnelStates.connecting((0,v.localize)(1,null)))},n=this.z("login",["user","login","--provider",i,"--access-token",P,"--log",(0,R.LogLevelToString)(this.h.getLevel())],t);this.j=n;try{if(await n,this.j!==n)return}catch(l){this.h.error(l),this.j=void 0,this.b.fire(!0),this.y(L.TunnelStates.disconnected);return}const s=this.D();s?this.y(L.TunnelStates.connecting((0,v.localize)(2,null,s))):this.y(L.TunnelStates.connecting((0,v.localize)(3,null)));const a=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];s?a.push("--name",s):a.push("--random-name"),this.C()&&a.push("--no-sleep");const r=this.z("tunnel",a,(l,y)=>{y?this.h.error(l):this.h.info(l);const b=l.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const O={link:b[1],domain:b[2],hostName:b[4]};this.y(L.TunnelStates.connected(O))}else l.match(/error refreshing token/)&&(r.cancel(),this.b.fire(!0),this.y(L.TunnelStates.disconnected))});this.j=r,r.finally(()=>{r===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(P){this.k=P,this.f.fire(P)}z(P,i,o=()=>{}){return(0,g.createCancelablePromise)(t=>new Promise((n,s)=>{t.isCancellationRequested&&n();let a;if(t.onCancellationRequested(()=>{a&&(this.h.info(`${P} terminating(${a.pid})`),a.kill())}),!this.t.isBuilt)o("Building tunnel CLI from sources and run",!1),o(`${P} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),a=(0,S.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,C.join)(this.t.appRoot,"cli")});else{o("Running tunnel CLI",!1);const r=this.v();o(`${P} Spawning: ${r} tunnel ${i.join(" ")}`,!1),a=(0,S.spawn)(r,["tunnel",...i],{cwd:(0,h.homedir)()})}a.stdout.on("data",r=>{if(a){const l=r.toString();o(l,!1)}}),a.stderr.on("data",r=>{if(a){const l=r.toString();o(l,!0)}}),a.on("exit",r=>{a&&(o(`${P} exit(${a.pid}): + ${r} `,!1),a=void 0,r===0?n():s())}),a.on("error",r=>{a&&(o(`${P} error(${a.pid}): + ${r} `,!0),a=void 0,s())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let P=this.u.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,h.hostname)();return P=P.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),P||void 0}};p=ye([J(0,c.ITelemetryService),J(1,I.IProductService),J(2,k.INativeEnvironmentService),J(3,R.ILoggerService),J(4,f.ISharedProcessLifecycleService),J(5,d.IConfigurationService)],p),e.RemoteTunnelService=p}),define(re[112],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(k){this.b=k}listen(k,D){throw new Error(`Event not found: ${D}`)}call(k,D,{eventName:R,data:C}){return this.b.forEach(S=>S.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class A{constructor(k){this.b=k}log(k,D){return this.b.call("log",{eventName:k,data:D}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(re[47],oe([0,1,32,12,3,17,73,111,19]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(r){this.value=r}}e.TelemetryTrustedValue=S;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,l){return Promise.resolve(void 0)}publicLog2(r,l){return this.publicLog(r,l)}publicLogError(r,l){return Promise.resolve(void 0)}publicLogError2(r,l){return this.publicLogError(r,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class w{async publicLog(r,l,y){}async publicLogError(r,l,y){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,r){return c.Event.debounce(r.onDidChangeConfiguration,(y,b)=>{const O=y?new Set([...y.affectedKeys,...b.affectedKeys]):b.affectedKeys;return{...b,affectedKeys:O}},1e3,!0)(y=>{y.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(y.source),configurationKeys:E(y.affectedKeys)})})}e.configurationTelemetry=g;function f(a,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!a.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function d(a,r){return!(r.isBuilt||r.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=d;function v(a){const r=a.getValue(C.TELEMETRY_SETTING_ID),l=a.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function h(a){const r={},l={},y={};p(a,y);for(let b in y){b=b.length>150?b.substr(b.length-149):b;const O=y[b];typeof O=="number"?l[b]=O:typeof O=="boolean"?l[b]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${O.length}`),r[b]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(r[b]=O)}return{properties:r,measurements:l}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(a){if(!a)return"none";const r=(0,D.getRemoteName)(a);return u.has(r)?r:"other"}e.cleanRemoteAuthority=m;function p(a,r,l=0,y){if(!!a)for(const b of Object.getOwnPropertyNames(a)){const O=a[b],N=y?y+b:b;Array.isArray(O)?r[N]=(0,L.safeStringify)(O):O instanceof Date?r[N]=O.toISOString():(0,A.isObject)(O)?l<2?p(O,r,l+1,N+"."):r[N]=(0,L.safeStringify)(O):r[N]=O}}function E(a){if(!a)return[];const r=[];return P(r,"",a),r}function P(a,r,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(y=>P(a,r?`${r}.${y}`:y,l[y])):a.push(r)}function i(a,r){const l=a.msftInternalDomains||[],y=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(l)||y}e.isInternalTelemetry=i;function o(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=o;function t(a,r){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let l=a;const y=[];for(const F of r)for(;;){const z=F.exec(a);if(!z)break;y.push([z.index,F.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(l="";;){const F=O.exec(a);if(!F)break;const z=y.some(([G,Y])=>F.index<Y&&G<O.lastIndex);!b.test(F[0])&&!z&&(l+=a.substring(N,F.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<a.length&&(l+=a.substr(N)),l}function n(a){if(!a)return a;const r=a.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of l)if(y.regex.test(r))return`<REDACTED: ${y.label}>`;return a}function s(a,r){return(0,L.cloneAndChange)(a,l=>{if(l instanceof S)return l.value;if(typeof l=="string"){let y=l.replaceAll("%20"," ");y=t(y,r);for(const b of r)y=y.replace(b,"");return y=n(y),y}})}e.cleanData=s}),define(re[33],oe([0,1,27,29,46,4,10,8,36,47]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=I;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,s,a)}static parse(n){const s=w.exec(n);return s&&s[1]&&s[2]?new g({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(t){const n=f.exec(t);return n&&n[1]?[h(n[1]),n[2]]:[h(t),void 0]}e.getIdAndVersion=d;function v(t,n){return`${t}.${n}`}e.getExtensionId=v;function h(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(t,n){return h(v(t,n))}e.getGalleryExtensionId=u;function m(t,n){const s=[],a=r=>{for(const l of s)if(l.some(y=>I(n(y),n(r))))return l;return null};for(const r of t){const l=a(r);l?l.push(r):s.push([r])}return s}e.groupByExtension=m;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function E(t){return{id:new S.TelemetryTrustedValue(t.identifier.id),name:new S.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new c.ExtensionIdentifier("pprice.better-merge");function P(t,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const r=a.shift();if(r&&s.every(l=>!I(l.identifier,{id:r}))){const l=t.filter(y=>I(y.identifier,{id:r}));l.length===1&&(s.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=P;async function i(t,n){if(!k.isLinux)return!1;let s;try{s=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,n){const s=await i(t,n),a=(0,A.getTargetPlatform)(s?"alpine":k.platform,C.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(re[236],oe([0,1,21,2,25,10,193,14,26,6,3,13,4,36,160,33]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let h=class extends A.Disposable{constructor(P,i){super(),this.b=P,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,o])=>this.a.set(o.configPath,o))}getConfigBasedTips(P){return this.f(P)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(P){const i=[];for(const[o,t]of this.a)if(!(t.configScheme&&t.configScheme!==P.scheme))try{const n=await this.b.readFile((0,c.joinPath)(P,o)),s=new Map;Object.entries(t.recommendations).forEach(([r,l])=>{if((0,L.isNonEmptyArray)(l.remotes))for(const y of l.remotes)s.set(y,{extensionId:r,extensionName:l.name,configName:t.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else i.push({extensionId:r,extensionName:l.name,configName:t.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const a=(0,D.getDomainsOfRemotes)(n.value.toString(),[...s.keys()]);for(const r of a){const l=s.get(r);l&&i.push(l)}}catch{}return i}};h=ye([J(0,R.IFileService),J(1,C.IProductService)],h),e.ExtensionTipsService=h;const u="extensionTips/promptedExecutableTips",m="extensionTips/lastPromptedMediumImpExeTime";class p extends h{constructor(P,i,o,t,n,s,a,r){super(a,r),this.m=P,this.n=i,this.p=o,this.r=t,this.s=n,this.t=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,r.exeBasedExtensionTips&&Object.entries(r.exeBasedExtensionTips).forEach(([l,y])=>{const b=[],O=[],N=[];Object.entries(y.recommendations).forEach(([F,z])=>{z.important?y.important?b.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):O.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):N.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),b.length&&this.g.set(l,{exeFriendlyName:y.friendlyName,windowsPath:y.windowsPath,recommendations:b}),O.length&&this.h.set(l,{exeFriendlyName:y.friendlyName,windowsPath:y.windowsPath,recommendations:O}),N.length&&this.j.set(l,{exeFriendlyName:y.friendlyName,windowsPath:y.windowsPath,recommendations:N})}),(0,S.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.z()})}async getImportantExecutableBasedTips(){const P=await this.J(this.g),i=await this.J(this.h);return[...P,...i]}getOtherExecutableBasedTips(){return this.J(this.j)}async u(){const P=await this.J(this.g),i=await this.J(this.h),o=await this.r.getInstalled();this.k=this.v(P,o),this.l=this.v(i,o)}v(P,i){const o=new Map;P.forEach(r=>o.set(r.extensionId.toLowerCase(),r));const{installed:t,uninstalled:n}=this.I([...o.keys()],i);for(const r of t){const l=o.get(r);l&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:r,exeName:l.exeName})}for(const r of n){const l=o.get(r);l&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:r,exeName:l.exeName})}const s=this.G(),a=new Map;for(const r of n){const l=o.get(r);if(l&&(!s[l.exeName]||!s[l.exeName].includes(l.extensionId))){let y=a.get(l.exeName);y||(y=[],a.set(l.exeName,y)),y.push(l)}}return a}w(){if(this.k.size===0)return;const[P,i]=[...this.k.entries()][0];this.C(i).then(o=>{switch(o){case"reacted":this.H(i[0].exeName,i);break;case"ignored":this.k.delete(P);break;case"incompatibleWindow":{const t=I.Event.once(I.Event.latch(I.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.w()));break}case"toomany":{const t=this.B((0,S.disposableTimeout)(()=>{t.dispose(),this.w()},36e5));break}}})}z(){if(this.l.size===0)return;const P=this.D(),i=Date.now()-P,o=7*24*60*60*1e3;if(i<o){const s=this.B((0,S.disposableTimeout)(()=>{s.dispose(),this.z()},o-i));return}const[t,n]=[...this.l.entries()][0];this.C(n).then(s=>{switch(s){case"reacted":{this.F(Date.now()),this.l.delete(t),this.H(n[0].exeName,n);const a=this.B((0,S.disposableTimeout)(()=>{a.dispose(),this.z()},o));break}case"ignored":this.l.delete(t),this.z();break;case"incompatibleWindow":{const a=I.Event.once(I.Event.latch(I.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(a(()=>this.z()));break}case"toomany":{const a=this.B((0,S.disposableTimeout)(()=>{a.dispose(),this.z()},36e5));break}}})}async C(P){const i=await this.r.getInstalled(1),o=P.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(s=>i.every(a=>!(0,v.areSameExtensions)(a.identifier,{id:s})))).map(({extensionId:n})=>n.toLowerCase()),t=(0,d.localize)(0,null,P[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(o,t,`@exe:"${P[0].exeName}"`,3)}D(){let P=this.s.getNumber(m,-1);return P||(P=Date.now(),this.F(P)),P}F(P){this.s.store(m,P,-1,1)}G(){return JSON.parse(this.s.get(u,-1,"{}"))}H(P,i){const o=this.G();o[P]=i.map(({extensionId:t})=>t.toLowerCase()),this.s.store(u,JSON.stringify(o),-1,0)}I(P,i){const o=[],t=[],n=i.reduce((s,a)=>(s.add(a.identifier.id.toLowerCase()),s),new Set);return P.forEach(s=>{n.has(s.toLowerCase())?o.push(s):t.push(s)}),{installed:o,uninstalled:t}}async J(P){const i=[],o=new Map;for(const t of P.keys()){const n=P.get(t);if(!n||!(0,L.isNonEmptyArray)(n.recommendations))continue;const s=[];g.isWindows?n.windowsPath&&s.push(n.windowsPath.replace("%USERPROFILE%",()=>f.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>f.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>f.env.ProgramFiles).replace("%APPDATA%",()=>f.env.APPDATA).replace("%WINDIR%",()=>f.env.WINDIR)):(s.push((0,w.join)("/usr/local/bin",t)),s.push((0,w.join)("/usr/bin",t)),s.push((0,w.join)(this.m.fsPath,t)));for(const a of s){let r=o.get(a);if(r===void 0&&(r=await this.b.exists(k.URI.file(a)),o.set(a,r)),r)for(const{extensionId:l,extensionName:y,isExtensionPack:b,whenNotInstalled:O}of n.recommendations)i.push({extensionId:l,extensionName:y,isExtensionPack:b,exeName:t,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:O})}}return i}}e.AbstractNativeExtensionTipsService=p}),define(re[237],oe([0,1,24,33]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function c(k,D,R,C,S){try{const I=await k.getExtensionsControlManifest();if(!I.deprecated)return;const w=await k.getInstalled(1);for(const[g,f]of Object.entries(I.deprecated)){if(!f?.extension)continue;const{id:d,autoMigrate:v,preRelease:h}=f.extension;if(!v)continue;const u=w.find(p=>(0,A.areSameExtensions)(p.identifier,{id:g}));if(!u)continue;const m=(await D.getExtensions([{id:d,preRelease:h}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!m){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${d}' extension...`);const p=!C.getDisabledExtensions().some(P=>(0,A.areSameExtensions)(P,u.identifier));await k.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let E=w.find(P=>(0,A.areSameExtensions)(P.identifier,{id:d}));(!E||!E.isPreReleaseVersion&&p)&&(E=await k.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${E.identifier.id}'`),p||(await C.disableExtension(E.identifier),S.info(`Disabled the pre-release extension '${E.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),v.storage&&(R.addToMigrationList((0,A.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,A.getExtensionId)(E.manifest.publisher,E.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${d}' extension.`)}catch(p){S.error(p)}}}catch(I){S.error(I)}}e.migrateUnsupportedExtensions=c}),define(re[238],oe([0,1,3,2,37,33,46]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends A.Disposable{constructor(S,I,w,g,f,d,v){super(),this.f=S,this.g=I,this.h=w,this.i=g,this.j=f,this.k=d,this.l=v,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.DisposableMap),this.m().then(null,h=>v.error(h))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,I){try{await Promise.all(I.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),S.length&&await Promise.all(S.map(w=>(this.c.set(w.id,(0,A.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(S){for(const I of S.extensions)this.D(this.G(I.identifier,I.version),S.profileLocation)}async s(S){for(const I of S.extensions){const w=this.G(I.identifier,I.version);S.error?this.F(w,S.profileLocation):this.D(w,S.profileLocation)}}async t(S){for(const I of S.extensions)this.F(this.G(I.identifier,I.version),S.profileLocation)}async u(S){const I=[],w=[];for(const g of S.extensions){const f=this.G(g.identifier,g.version);S.error?this.D(f,S.profileLocation):(this.F(f,S.profileLocation),this.b.has(f)||(this.l.debug("Extension is removed from all profiles",g.identifier.id,g.version),w.push(this.f.scanInstalledExtensionAtLocation(g.location).then(d=>{d?I.push(d):this.l.info("Extension not found at the location",g.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(w),I.length&&await this.C(I)}catch(g){this.l.error(g)}}v(S){for(const I of this.h.profiles)S.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(S){const I=[],w=[],g=await this.i.scanProfileExtensions(S),f=new Set,d=new Set;for(const[v,h]of this.b)h.has(S)&&d.add(v);for(const v of g){const h=this.G(v.identifier,v.version);f.add(h),d.has(h)||(I.push(v.identifier),this.D(h,S))}for(const v of d)if(!f.has(v)){const h=this.H(v);h&&(w.push(h.identifier),this.F(v,S))}(I.length||w.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:S}:void 0,removed:w.length?{extensions:w,profileLocation:S}:void 0})}async y(S){const I=await this.i.scanProfileExtensions(S);for(const w of I)this.D(this.G(w.identifier,w.version),S)}async z(S){for(const I of[...this.b.keys()])this.F(I,S);await this.C()}async C(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.G(w.identifier,w.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}D(S,I){let w=this.b.get(S);w||this.b.set(S,w=new c.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),w.add(I)}F(S,I){const w=this.b.get(S);w&&w.delete(I),w?.size||this.b.delete(S)}G(S,I){return`${D.ExtensionIdentifier.toKey(S.id)}@${I}`}H(S){const[I,w]=(0,k.getIdAndVersion)(S);return w?{identifier:{id:I},version:w}:void 0}}e.ExtensionsWatcher=R}),define(re[239],oe([0,1,44,47]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function c(k,D,R,C,S,I,w){const g={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${D.nameShort})`};if((0,A.supportsTelemetry)(D,R)&&(0,A.getTelemetryLevel)(C)===3){const f=await(0,L.getServiceMachineId)(R,S,I),{machineId:d}=await w.getTelemetryInfo();g["X-Market-User-Id"]=f,g["VSCode-SessionId"]=d||f}return g}e.resolveMarketplaceHeaders=c}),define(re[240],oe([0,1,101,21,6,2,22,13,28,15,29,33,11,71,10]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends f.LanguagePackBaseService{constructor(p,E,P,i){super(P),this.h=p,this.i=i,this.g=this.B(new h(E,i)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(p,E){const i=(await this.g.getLanguagePacks())[E];if(!i){this.i.warn(`No language pack found for ${E}`);return}const o=i.translations[p];return o?d.URI.file(o):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),E=Object.keys(p).map(P=>{const i=p[P];return{...this.f(P,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((P,i)=>P.label.localeCompare(i.label)),E}async j(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",p.identifier.id),await this.update())}async k(p){const E=await this.g.getLanguagePacks();Object.keys(E).some(P=>E[P]&&E[P].extensions.some(i=>(0,w.areSameExtensions)(i.extensionIdentifier,p.identifier)))&&(this.i.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(E);return!(0,A.equals)(Object.keys(p),Object.keys(P))}};v=ye([J(0,I.IExtensionManagementService),J(1,S.INativeEnvironmentService),J(2,I.IExtensionGalleryService),J(3,g.ILogService)],v),e.NativeLanguagePackService=v;let h=class extends k.Disposable{constructor(p,E){super(),this.i=E,this.c={},this.f=(0,R.join)(p.userDataPath,"languagepacks.json"),this.g=new c.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.m(E=>{Object.keys(E).forEach(P=>delete E[P]),this.j(E,...p)}).then(()=>this.c)}j(p,...E){for(const P of E)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.k(p,P);Object.keys(p).forEach(P=>this.l(p[P]))}k(p,E){const P=E.identifier,i=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of i)if(E.location.scheme===D.Schemas.file&&u(o)){let t=p[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},p[o.languageId]=t);const n=t.extensions.filter(s=>(0,w.areSameExtensions)(s.extensionIdentifier,P))[0];n?n.version=E.manifest.version:t.extensions.push({extensionIdentifier:P,version:E.manifest.version});for(const s of o.translations)t.translations[s.id]=(0,R.join)(E.location.fsPath,s.path)}}l(p){if(p){const E=(0,L.createHash)("md5");for(const P of p.extensions)E.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);p.hash=E.digest("hex")}}m(p=()=>null){return this.g.queue(()=>{let E=null;return C.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(E=p(P),P)).then(P=>{for(const o of Object.keys(P))P[o]||delete P[o];this.c=P,this.h=!0;const i=JSON.stringify(this.c);return this.i.debug("Writing language packs",i),C.Promises.writeFile(this.f,i)}).then(()=>E,P=>this.i.error(P))})}};h=ye([J(0,S.INativeEnvironmentService),J(1,g.ILogService)],h);function u(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const p of m.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(re[241],oe([0,1,8,32,47]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function R(S,I,w){const g=await new Promise((u,m)=>{te(["@microsoft/1ds-core-js"],u,m)}),f=await new Promise((u,m)=>{te(["@microsoft/1ds-post-js"],u,m)}),d=new g.AppInsightsCore,v=new f.PostChannel,h={instrumentationKey:S,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(w){h.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:w};h.extensionConfig[v.identifier]=u}return d.initialize(h,[]),d.addTelemetryInitializer(u=>{I&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class C{constructor(I,w,g,f,d){this.e=I,this.f=w,this.g=g,this.h=d,this.c=k,this.d=D,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(w=>{I(w)},w=>{(0,L.onUnexpectedError)(w),console.error(w)})}}log(I,w){if(!this.a)return;w=(0,A.mixin)(w,this.g),w=(0,c.validateTelemetryData)(w);const g=this.f+"/"+I;try{this.i(f=>{f.pluginVersionString=w?.properties.version??"Unknown",f.track({name:g,baseData:{name:g,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(re[113],oe([0,1,2,174,15,11,26,47]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=class extends L.Disposable{constructor(I,w,g,f,d=""){super(),this.b=d;const v=w.getLogger(g.telemetryLogResource);if(v)this.a=this.B(v);else{const u=(0,R.isLoggingOnly)(f,g)?" (Not Sent)":"",m=g.telemetryLogResource,p=()=>(0,R.supportsTelemetry)(f,g)&&I.getLevel()===k.LogLevel.Trace;this.a=this.B(w.createLogger(m,{id:R.telemetryLogChannelId,name:(0,A.localize)(0,null,u),hidden:!p()})),this.B(I.onDidChangeLogLevel(()=>w.setVisibility(m,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,w){this.a.trace(`${this.b}telemetry/${I}`,(0,R.validateTelemetryData)(w))}};C=ye([J(0,k.ILogService),J(1,k.ILoggerService),J(2,c.IEnvironmentService),J(3,D.IProductService)],C),e.TelemetryLogAppender=C}),define(re[114],oe([0,1,2,32,4,27,175,17,45,106,26,40,19,47]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,m,p){this.k=m,this.l=p,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(g.TELEMETRY_SETTING_ID)||E.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,f.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const p=m.usage?3:m.error?2:0;u=Math.min(u,p)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,m=u.sessionID,p=u["common.machineId"],E=u["common.firstSessionDate"],P=u["common.msftInternal"];return{sessionId:m,machineId:p,firstSessionDate:E,msftInternal:P}}dispose(){this.i.dispose()}n(u,m,p){return this.g<m?Promise.resolve(void 0):this.c.then(E=>{p=(0,A.mixin)(p,this.d),p=(0,f.cleanData)(p,this.j),p=(0,A.mixin)(p,E),this.b.forEach(P=>P.log(u,p))},E=>{console.error(E)})}publicLog(u,m){return this.n(u,3,m)}publicLog2(u,m){return this.publicLog(u,m)}publicLogError(u,m){return this.h?this.n(u,2,m):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ye([J(1,R.IConfigurationService),J(2,I.IProductService)],d),e.TelemetryService=d;function v(){const h=(0,D.localize)(0,null,S.default.nameLong),u=S.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=c.isWeb?"":(0,D.localize)(3,null),p=(0,D.localize)(4,null),E=(0,D.localize)(5,null),P=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${p} | ${E} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${h} ${u} ${m}

&nbsp;

${i}
${o}

&nbsp;

${t}
`}w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,D.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,D.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[242],oe([0,1,295,241]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class c extends A.AbstractOneDataSystemAppender{constructor(D,R,C,S){const I={sendPOST:(w,g)=>{const f={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const d=L.request(w.urlString,f,v=>{v.on("data",function(h){g(v.statusCode??200,v.headers,h.toString())}),v.on("error",function(h){g(0,{})})});d.write(w.data),d.end()}catch{g(0,{})}}};super(D,R,C,S,I)}}e.OneDataSystemAppender=c}),define(re[243],oe([0,1,22,65,17,15,11,26,19,112,113,114]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(d,v,h,u,m,p){this.b=d,this.c=v,this.d=h,this.e=u,this.f=m,this.g=p,this.a=new Map}async h(d){if(!this.a.has(d.id)){const{machineId:v,sessionId:h}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=v,u["common.vscodesessionid"]=h;const m=[d.id,JSON.stringify(u),d.aiKey],E=new A.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new S.TelemetryAppenderClient(E),new I.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new w.TelemetryService({appenders:P,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}async publicLog(d,v,h){await(await this.h(d)).publicLog(v,h)}async publicLogError(d,v,h){await(await this.h(d)).publicLogError(v,h)}};g=ye([J(0,c.IConfigurationService),J(1,C.ITelemetryService),J(2,D.ILogService),J(3,D.ILoggerService),J(4,k.IEnvironmentService),J(5,R.IProductService)],g),e.CustomEndpointTelemetryService=g}),define(re[115],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(re[244],oe([0,1,4,115]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class c{constructor(C){this.collections=C,this.map=new Map,C.forEach((S,I)=>{const w=S.map.entries();let g=w.next();for(;!g.done;){const f=g.value[0];let d=this.map.get(f);if(d||(d=[],this.map.set(f,d)),d.length>0&&d[0].type===A.EnvironmentVariableMutatorType.Replace){g=w.next();continue}const v=g.value[1];d.unshift({extensionIdentifier:I,value:v.value,type:v.type}),g=w.next()}})}async applyToProcessEnvironment(C,S){let I;L.isWindows&&(I={},Object.keys(C).forEach(w=>I[w.toLowerCase()]=w));for(const[w,g]of this.map){const f=L.isWindows&&I[w.toLowerCase()]||w;for(const d of g){const v=S?await S(d.value):d.value;switch(d.type){case A.EnvironmentVariableMutatorType.Append:C[f]=(C[f]||"")+v;break;case A.EnvironmentVariableMutatorType.Prepend:C[f]=v+(C[f]||"");break;case A.EnvironmentVariableMutatorType.Replace:C[f]=v;break}}}}diff(C){const S=new Map,I=new Map,w=new Map;if(C.map.forEach((g,f)=>{const d=this.map.get(f),v=k(g,d);v&&S.set(f,v)}),this.map.forEach((g,f)=>{const d=C.map.get(f),v=k(g,d);v&&w.set(f,v)}),this.map.forEach((g,f)=>{const d=C.map.get(f),v=D(g,d);v&&I.set(f,v)}),!(S.size===0&&I.size===0&&w.size===0))return{added:S,changed:I,removed:w}}}e.MergedEnvironmentVariableCollection=c;function k(R,C){if(!C)return R;const S=new Set;C.forEach(w=>S.add(w.extensionIdentifier));const I=[];return R.forEach(w=>{S.has(w.extensionIdentifier)||I.push(w)}),I.length===0?void 0:I}function D(R,C){if(!C)return;const S=new Map;C.forEach(w=>S.set(w.extensionIdentifier,w));const I=[];return R.forEach(w=>{const g=S.get(w.extensionIdentifier);g&&(w.type!==g.type||w.value!==g.value)&&I.push(g)}),I.length===0?void 0:I}}),define(re[245],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=L;function A(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=A;function c(D){return Array.from(D.entries()).map(R=>[R[0],L(R[1].map)])}e.serializeEnvironmentVariableCollections=c;function k(D){return new Map(D.map(R=>[R[0],{map:A(R[1])}]))}e.deserializeEnvironmentVariableCollections=k}),define(re[246],oe([0,1,6,24,3,2,11]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(S,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new c.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((I,w)=>{const g=++this.a;this.c.set(g,I),this.g.fire({requestId:g,...S});const f=new A.CancellationTokenSource;(0,L.timeout)(this.b,f.token).then(()=>w(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,k.toDisposable)(()=>f.cancel())])})}acceptReply(S,I){const w=this.c.get(S);w?(this.c.delete(S),(0,k.dispose)(this.f.get(S)||[]),this.f.delete(S),w(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=ye([J(1,D.ILogService)],R),e.RequestStore=R}),define(re[116],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var A;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(A=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var c;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.TabFocusMode="terminal.integrated.tabFocusMode",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(c=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(p){p.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var D;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(D=e.PosixShellType||(e.PosixShellType={}));var R;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Logger="logger",p.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var I;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var g;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(g=e.TerminalLocation||(e.TerminalLocation={}));var f;(function(p){p.TerminalView="view",p.Editor="editor"})(f=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}));var u;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[247],oe([0,1,52,10,177,133]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(g,f){const d=[{name:null,description:(0,c.localize)(0,null)}];return d.push(...g.map(v=>({name:v.profileName,description:R(v)}))),f&&d.push(...f.map(v=>({name:v.title,description:C(v)}))),{values:d.map(v=>v.name),markdownDescriptions:d.map(v=>v.description)}}e.createProfileSchemaEnums=D;function R(g){let f=`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:L.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?f+=`
- args: "${g.args}"`:f+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(f+=`
- overrideName: ${g.overrideName}`),g.color&&(f+=`
- color: ${g.color}`),g.env&&(f+=`
- env: ${JSON.stringify(g.env)}`),f}function C(g){return`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:L.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function S(g,f){if(!g&&!f)return!0;if(typeof g=="string"&&typeof f=="string")return g===f;if(Array.isArray(g)&&Array.isArray(f)){if(g.length!==f.length)return!1;for(let d=0;d<g.length;d++)if(g[d]!==f[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function I(g,f){if(!g&&!f)return!0;if(!g||!f)return!1;if(k.ThemeIcon.isThemeIcon(g)&&k.ThemeIcon.isThemeIcon(f))return g.id===f.id&&g.color===f.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof f=="object"&&"light"in f&&"dark"in f){const d=g,v=f;if((A.URI.isUri(d.light)||w(d.light))&&(A.URI.isUri(d.dark)||w(d.dark))&&(A.URI.isUri(v.light)||w(v.light))&&(A.URI.isUri(v.dark)||w(v.dark)))return d.light.path===v.light.path&&d.dark.path===v.dark.path}if(A.URI.isUri(g)&&A.URI.isUri(f)||w(g)||w(f)){const d=g,v=f;return d.path===v.path&&d.scheme===v.scheme}return!1}e.terminalIconsEqual=I;function w(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}e.isUriComponents=w}),define(re[248],oe([0,1,52,176,45,40,247]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),E=>E.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),E=>`$(${E.id})`)};const R={args:{description:(0,A.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,A.localize)(1,null),type:"boolean"},icon:{description:(0,A.localize)(2,null),...e.terminalIconSchema},color:{description:(0,A.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,A.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,A.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,A.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,A.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,A.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,A.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,A.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,A.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,A.localize)(26,null)}},{type:"string",markdownDescription:(0,A.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,A.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(30,null),type:"string"},id:{description:(0,A.localize)(31,null),type:"string"},title:{description:(0,A.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(34,null),type:"string"},id:{description:(0,A.localize)(35,null),type:"string"},title:{description:(0,A.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(38,null),type:"string"},id:{description:(0,A.localize)(39,null),type:"string"},title:{description:(0,A.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,A.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,A.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,A.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,A.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,A.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(c.Extensions.Configuration).registerConfiguration(h),p()}e.registerTerminalPlatformConfiguration=u;let m;function p(E,P){const i=k.Registry.as(c.Extensions.Configuration);let o;E&&(o=(0,D.createProfileSchemaEnums)(E?.profiles,P));const t=m;m={id:"terminal",order:100,title:(0,A.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:E?.os===3?o?.values:void 0,markdownEnumDescriptions:E?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:E?.os===2?o?.values:void 0,markdownEnumDescriptions:E?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:E?.os===1?o?.values:void 0,markdownEnumDescriptions:E?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(re[249],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(re[250],oe([0,1,34,22,32,13,4,36,27,12,28,115,245,244]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function d(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let s=0;return n&&n.length===4&&(s=parseInt(n[3])),s}e.getWindowsBuildNumber=d;async function v(n,s,a,r=R.env,l=I.Promises.exists){if(k.isAbsolute(n))return await l(n)?n:void 0;if(s===void 0&&(s=R.cwd()),k.dirname(n)!=="."){const N=k.join(s,n);return await l(N)?N:void 0}const b=(0,c.getCaseInsensitive)(r,"PATH");if(a===void 0&&(0,S.isString)(b)&&(a=b.split(k.delimiter)),a===void 0||a.length===0){const N=k.join(s,n);return await l(N)?N:void 0}for(const N of a){let F;if(k.isAbsolute(N)?F=k.join(N,n):F=k.join(s,N,n),await l(F))return F;if(D.isWindows){let z=F+".com";if(await l(z)||(z=F+".exe",await l(z)))return z}}const O=k.join(s,n);return await l(O)?O:void 0}e.findExecutable=v;function h(n,s,a,r,l){const y=D.isWindows&&(!s.windowsEnableConpty||d()<18309);if(!s.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||y)return;const b=n.args,O=R.platform==="win32"?k.basename(n.executable).toLowerCase():k.basename(n.executable),N=k.dirname(A.FileAccess.asFileUri("").fsPath);let F;const z={VSCODE_INJECTION:"1"};if(D.isWindows){if(O==="pwsh.exe"||O==="powershell.exe")return!b||o(b)?F=p.get(m.WindowsPwsh):i(b)&&(F=p.get(m.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],N,""),s.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:z}):void 0;r.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(O){case"bash":return!b||b.length===0?F=p.get(m.Bash):t(b)&&(z.VSCODE_SHELL_LOGIN="1",u(s,z),F=p.get(m.Bash)),F?(F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],N),{newArgs:F,envMixin:z}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=k.join(N,"out/vs/workbench/contrib/xdg_data");return z.XDG_DATA_DIRS=`${G}:${Y}`,u(s,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!b||o(b)?F=p.get(m.Pwsh):i(b)&&(F=p.get(m.PwshLogin)),F?(s.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],N,""),{newArgs:F,envMixin:z}):void 0;case"zsh":{if(!b||b.length===0?F=p.get(m.Zsh):t(b)?(F=p.get(m.ZshLogin),u(s,z)):(b===p.get(m.Zsh)||b===p.get(m.ZshLogin))&&(F=b),!F)return;F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],N);let G;try{G=L.userInfo().username}catch{G="unknown"}const Y=k.join(L.tmpdir(),`${G}-${l.applicationName}-zsh`);z.ZDOTDIR=Y;const W=a?.ZDOTDIR??L.homedir()??"~";z.USER_ZDOTDIR=W;const T=[];return T.push({source:k.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(Y,".zshrc")}),T.push({source:k.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(Y,".zprofile")}),T.push({source:k.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(Y,".zshenv")}),T.push({source:k.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(Y,".zlogin")}),{newArgs:F,envMixin:z,filesToCopy:T}}}r.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=h;function u(n,s){if(D.isMacintosh&&n.environmentVariableCollections){const a=(0,g.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),l=new f.MergedEnvironmentVariableCollection(a).map.get("PATH"),y=[];if(l)for(const b of l)b.type===w.EnvironmentVariableMutatorType.Prepend&&y.push(b.value);y.length>0&&(s.VSCODE_PATH_PREFIX=y.join(""))}}var m;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(m||(m={}));const p=new Map;p.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(m.Zsh,["-i"]),p.set(m.ZshLogin,["-il"]),p.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],P=["-nol","-nologo"];function i(n){return typeof n=="string"?E.includes(n.toLowerCase()):n.length===1&&E.includes(n[0].toLowerCase())||n.length===2&&(E.includes(n[0].toLowerCase())||E.includes(n[1].toLowerCase()))&&(P.includes(n[0].toLowerCase())||P.includes(n[1].toLowerCase()))}function o(n){return typeof n=="string"?P.includes(n.toLowerCase()):n.length===0||n?.length===1&&P.includes(n[0].toLowerCase())}function t(n){return n==="string"&&E.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&E.includes(n[0].toLowerCase())}}),define(re[251],oe([0,1,50,52,13,4,12,28,93,250]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,w=!0;function g(o,t,n,s,a=process.env,r,l,y,b){return r=r||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},k.isWindows?f(n,r,a,l,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),b,y):E(r,l,n,o&&typeof o=="object"?{...o}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),b,y,a)}e.detectAvailableProfiles=g;async function f(o,t,n,s,a,r,l,y,b){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let F=!1;(0,S.getWindowsBuildNumber)()>=16299&&(F=!0),await h(y);const z=new Map;if(o){z.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),z.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0}),z.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),z.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.Codicon.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;z.set("Cmder",{path:`${N}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}P(r,z);const G=await d(z.entries(),l,t,n,s,b);if(o||a)try{const Y=await m(`${N}\\${F?"wsl":"bash"}.exe`,l);for(const W of Y)(!r||!(W.profileName in r))&&G.push(W)}catch{w&&(s?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return G}async function d(o,t,n,s=process.env,a,r){const l=[];for(const[y,b]of o){if(b===null)continue;let O,N,F;if("source"in b){const W=I?.get(b.source);if(!W)continue;O=W.paths,N=b.args||W.args,b.icon?F=v(b.icon):W.icon&&(F=W.icon)}else O=Array.isArray(b.path)?b.path:[b.path],N=k.isWindows||Array.isArray(b.args)?b.args:void 0,F=v(b.icon);let z;if(r){const W=O.map(B=>typeof B=="string"?B:B.path),T=await r(W);z=new Array(O.length);for(let B=0;B<O.length;B++)typeof O[B]=="string"?z[B]=T[B]:z[B]={path:T[B],isUnsafe:!0}}else z=O.slice();let G;if(b.requiresPath){let W;if((0,D.isString)(b.requiresPath)?W=b.requiresPath:(W=b.requiresPath.path,b.requiresPath.isUnsafe&&(G=W)),!await n.existsFile(W))continue}const Y=await i(y,t,z,n,s,N,b.env,b.overrideName,b.isAutoDetected,G);Y?(Y.isAutoDetected=b.isAutoDetected,Y.icon=F,Y.color=b.color,l.push(Y)):a?.debug("Terminal profile not validated",y,O)}return a?.debug("Validated terminal profiles",l),l}function v(o){return typeof o=="string"?{id:o}:o}async function h(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await u(),icon:A.Codicon.terminalPowershell}))}async function u(){const o=[];for await(const t of(0,C.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function m(o,t){const n=[],s=await new Promise((l,y)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(b,O)=>{if(b)return y("Problem occurred when getting wsl distros");l(O)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),r=s.split(a).filter(l=>l.trim().length>0&&l!=="");for(const l of r){if(l===""||l.startsWith("docker-desktop"))continue;const y=`${l} (WSL)`,b={profileName:y,path:o,args:["-d",`${l}`],isDefault:y===t,icon:p(l),isAutoDetected:!1};n.push(b)}return n}function p(o){return o.includes("Ubuntu")?A.Codicon.terminalUbuntu:o.includes("Debian")?A.Codicon.terminalDebian:A.Codicon.terminalLinux}async function E(o,t,n,s,a,r,l,y){const b=new Map;if(n){const O=(await o.readFile("/etc/shells")).toString(),N=r||O.split(`
`).filter(z=>z.trim().includes("#")&&z.trim().length>0),F=new Map;for(const z of N){let G=(0,c.basename)(z),Y=F.get(G)||0;Y++,Y>1&&(G=`${G} (${Y})`),F.set(G,Y),b.set(G,{path:z,isAutoDetected:!0})}}return P(s,b),await d(b.entries(),a,o,y,t,l)}function P(o,t){if(!!o)for(const[n,s]of Object.entries(o))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(o,t,n,s,a,r,l,y,b,O){if(n.length===0)return Promise.resolve(void 0);const N=n.shift();if(N==="")return i(o,t,n,s,a,r,l,y,b);const F=typeof N!="string"&&N.isUnsafe,z=typeof N=="string"?N:N.path,G={profileName:o,path:z,args:r,env:l,overrideName:y,isAutoDetected:b,isDefault:o===t,isUnsafePath:F,requiresUnsafePath:O};if((0,c.basename)(z)===z){const W=a.PATH?a.PATH.split(c.delimiter):void 0,T=await(0,S.findExecutable)(z,void 0,W,void 0,s.existsFile);return T?(G.path=T,G.isFromPath=!0,G):i(o,t,n,s,a,r)}return await s.existsFile((0,c.normalize)(z))?G:i(o,t,n,s,a,r,l,y,b)}}),define(re[252],oe([0,1,3,2,22,4,39,65,17,15,96,232,11,246,116,248,251,105]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(P){P[P.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let p=0,E=class extends A.Disposable{constructor(i,o,t,n,s,a){super(),this.C=i,this.D=o,this.F=t,this.G=n,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new L.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new L.Emitter),this.onProcessData=this.s.event,this.t=this.B(new L.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new L.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new L.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new L.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new L.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new L.Emitter),this.onProcessExit=this.z.event,(0,v.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,A.toDisposable)(()=>this.O())),this.f=this.B(new f.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(k.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(i){return this.H.error("ptyHost was unable to resolve shell environment",i),{}}}N(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},o=(0,I.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const t=new R.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),D.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=m.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.B(new u.RemoteLoggerChannelClient(this.I,t.getChannel(d.TerminalIpcChannels.Logger)));const s=D.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(a=>this.s.fire(a))),this.B(s.onProcessReady(a=>this.t.fire(a))),this.B(s.onProcessExit(a=>this.z.fire(a))),this.B(s.onDidChangeProperty(a=>this.y.fire(a))),this.B(s.onProcessReplay(a=>this.u.fire(a))),this.B(s.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(s.onDidRequestDetach(a=>this.w.fire(a))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(i,o,t,n,s,a,r,l,y,b,O){const N=setTimeout(()=>this.S(),d.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(i,o,t,n,s,a,r,l,y,b,O);return clearTimeout(N),p=Math.max(p,F),F}updateTitle(i,o,t){return this.b.updateTitle(i,o,t)}updateIcon(i,o,t,n){return this.b.updateIcon(i,o,t,n)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,o){return this.b.detachFromProcess(i,o)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,o){return this.b.shutdown(i,o)}input(i,o){return this.b.input(i,o)}processBinary(i,o){return this.b.processBinary(i,o)}resize(i,o,t){return this.b.resize(i,o,t)}acknowledgeDataEvent(i,o){return this.b.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this.b.setUnicodeVersion(i,o)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,o){return this.b.installAutoReply(i,o)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,o,t,n=!1){const s=await this.c;return(0,h.detectAvailableProfiles)(o,t,n,this.F,s,void 0,this.H,this.W.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,o){return this.b.getWslPath(i,o)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this.b.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this.b.acceptDetachInstanceReply(i,o)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this.b.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this.b.refreshProperty(i,o)}async updateProperty(i,o,t){return this.b.updateProperty(i,o,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(i,o){return this.f.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this.f.acceptReply(i,o)}};E=ye([J(2,C.IConfigurationService),J(3,S.IEnvironmentService),J(4,g.ILogService),J(5,g.ILoggerService)],E),e.PtyHostService=E}),define(re[75],oe([0,1,3,17,5,11]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,c.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,c.createDecorator)("sharedTunnelsService");var D;(function(v){v.Http="http",v.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=w;function g(v,h,u,m){if(u===1)return!1;if(u===2&&w(h)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(p?.length===4&&parseInt(p[1])>=18)return!1}return v<1024}e.isPortPrivileged=g;class f{constructor(h,u,m){this.remoteAddress=h,this.localAddress=u,this.b=m,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let d=class{constructor(h,u){this.i=h,this.j=u,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],u=Array.from(this.d.values());for(const m of u){const p=Array.from(m.values());for(const E of p){const P=await E.value;P&&h.push(P)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:u}of h.values())await u.then(m=>m?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,u,m,p,E){this.o(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:m,privacy:p,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(w(h)||I(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const m=this.q(h,u);if(m)return++m.refcount,m.value}openTunnel(h,u,m,p,E,P=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${E}.`),!h)return;if(u||(u="localhost"),p||(p=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(h,u,m,p,E,P,i,o);return t?t.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this.d.get(h.tunnelRemoteHost);if(u){const m=u.get(h.tunnelRemotePort);m&&(m.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async n(h,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const p=m.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(u),p}}async closeTunnel(h,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const m=this.d.get(h);if(m&&m.has(u)){const p=m.get(u);p.refcount=0,await this.n(h,u,p)}}o(h,u,m){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(u,{refcount:1,value:m})}async p(h,u){const m=this.d.get(h);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(h))}q(h,u){const m=[h];I(h)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):w(h)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const p=m.map(E=>this.d.get(E));for(const E of p){const P=E?.get(u);if(P)return P}}canTunnel(h){return!!S(h)}s(h,u,m,p,E,P,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${p}.`);const o=m;this.h.add(o);const t=p===void 0?m:p,n={elevationRequired:E?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:m},localAddressPort:p,privacy:P,public:P?P!==R.Private:void 0,protocol:i},a=h.forwardPort(s,n);return a?(this.o(u,m,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),a}};d=ye([J(0,k.ILogService),J(1,A.IConfigurationService)],d),e.AbstractTunnelService=d}),define(re[253],oe([0,1,11,75,2,8,6]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends c.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.DeferredPromise),this.b.p)}setAddress(I){this.a=I,this.b&&(this.b.complete(I),this.b=null)}setTunnel(I){this.B(I)}}let C=class Dt extends c.Disposable{constructor(I,w){super(),this.f=I,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(I,w,g,f,d,v,h){const u=new R,m=await Promise.resolve(this.f.openTunnel(I,u,g,f,d,v,h));if(!m)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${f} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await m.dispose(),(0,k.canceled)();return u.setTunnel(m),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${g}:${f} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,w){const g=this.b.get(I);!g||g.setAddress(w)}async destroyTunnel(I){const w=this.b.get(I);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this.b.delete(I),await w.dispose();return}this.c.add(I)}};C.a=0,C=ye([J(0,A.ISharedTunnelsService),J(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(re[254],oe([0,1,85,34,135,226,6,2,17,11,26,224,75,110,4]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(E,P,i,o,t){let n;for(let s=3;s&&(n?.dispose(),n=await new h(E,P,i,o,t).waitForReady(),!(t&&c.BROWSER_RESTRICTED_PORTS[t]||!c.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class h extends R.Disposable{constructor(P,i,o,t,n){super(),this.j=i,this.k=n,this.privacy=g.TunnelPrivacyId.Private,this.i=new Map,this.a=P,this.b=L.createServer(),this.c=new D.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const P=this.k??this.tunnelRemotePort,i=(0,g.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,c.findFreePortFaster)(P,2,1e3,i),t=null;return this.b.listen(o,this.j),await this.c.wait(),t=this.b.address(),t||(o=0,this.b.listen(o,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(P){P.pause();const i=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,w.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&P.write(n.buffer),P.on("end",()=>{P.localAddress&&this.i.delete(P.localAddress),t.end()}),P.on("close",()=>t.end()),P.on("error",()=>{P.localAddress&&this.i.delete(P.localAddress),t.destroy()}),t.on("end",()=>P.end()),t.on("close",()=>P.end()),t.on("error",()=>{P.destroy()}),P.pipe(t),t.pipe(P),P.localAddress&&this.i.set(P.localAddress,()=>{P.end(),t.end()})}}let u=class extends g.AbstractTunnelService{constructor(P,i,o,t,n){super(i,n),this.t=P,this.u=o,this.v=t}isPortPrivileged(P){return(0,g.isPortPrivileged)(P,this.k,d.OS,A.release())}r(P,i,o,t,n,s,a,r){const l=this.q(i,o);if(l)return++l.refcount,l.value;if(this.e)return this.s(this.e,i,o,n,s,a,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${n}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:P,signService:this.u,logService:this.i,ipcLogger:null},b=v(y,t,i,o,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,o,b),b}}};u=ye([J(1,S.ILogService),J(2,f.ISignService),J(3,I.IProductService),J(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(P,i,o,t){super(k.nodeSocketFactory,P,i,o,t)}};m=ye([J(0,S.ILogService),J(1,f.ISignService),J(2,I.IProductService),J(3,C.IConfigurationService)],m),e.TunnelService=m;let p=class extends R.Disposable{constructor(P,i,o,t){super(),this.b=P,this.c=i,this.f=o,this.g=t,this.a=new Map}async openTunnel(P,i,o,t,n,s,a,r,l){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${s}.`),!this.a.has(P)){const y=new m(this.b,this.f,this.c,this.g);this.B(y),this.a.set(P,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(P))})}return this.a.get(P).openTunnel(i,o,t,n,s,a,r,l)}};p=ye([J(0,S.ILogService),J(1,I.IProductService),J(2,f.ISignService),J(3,C.IConfigurationService)],p),e.SharedTunnelsService=p}),define(re[30],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(re[255],oe([0,1,30,197,14,25,131,3,2]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(g){this.uri=g,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let I=class{constructor(g){this.g=g,this.c=new C.DisposableStore,this.f=2**16;const f=new Map,d=v=>{let h=f.get(v.scheme);return h===void 0&&(h=g.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,h)),h};this.c.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new k.ExtUri(d),this.d=new D.SkipList((v,h)=>this.extUri.compare(v,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,k.normalizePath)(g));const f=this.d.get(g);return f?f.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new S(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((d,v)=>d[1].time<v[1].time?1:d[1].time>v[1].time?-1:0);S._clock=0,this.d.clear();const f=this.f*.5;for(let d=0;d<f;d++)this.d.set(g[d][0],g[d][1].touch())}};I=ye([J(0,c.IFileService)],I),e.UriIdentityService=I,(0,A.registerSingleton)(L.IUriIdentityService,I,1)}),define(re[256],oe([0,1,3,2,14,43,49,16]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends A.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(I,w,g,f){super(),this.c=I,this.f=w,this.g=g,this.h=f,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=D.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(I,w){this.b.set(I,I);const g=this.f.watch(this.j(I),w);return(0,A.toDisposable)(()=>{this.b.delete(I),g.dispose()})}stat(I){return this.f.stat(this.j(I))}mkdir(I){return this.f.mkdir(this.j(I))}rename(I,w,g){return this.f.rename(this.j(I),this.j(w),g)}readFile(I){return this.f.readFile(this.j(I),{atomic:!0})}readFileStream(I,w,g){const f=(0,k.newWriteableStream)(d=>R.VSBuffer.concat(d.map(v=>R.VSBuffer.wrap(v))).buffer);return(async()=>{try{const d=await this.readFile(I);f.end(d)}catch(d){f.error(d),f.end()}})(),f}readdir(I){return this.f.readdir(this.j(I))}writeFile(I,w,g){return this.f.writeFile(this.j(I),w,g)}delete(I,w){return this.f.delete(this.j(I),w)}copy(I,w,g){if((0,c.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(I),this.j(w),g);throw new Error("copy not supported")}i(I){const w=[];for(const g of I){if(g.resource.scheme!==this.c)continue;const f=this.k(g.resource);this.b.findSubstr(f)&&w.push({resource:f,type:g.type})}w.length&&(this.h.debug("User data changed"),this.a.fire(w))}j(I){return I.with({scheme:this.c})}k(I){return I.with({scheme:this.g})}}e.FileUserDataProvider=C}),define(re[59],oe([0,1,82]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function A(D,R,C,S){const I=(0,L.setProperty)(D,R,C,S)[0];return I&&(D=D.substring(0,I.offset)+I.content+D.substring(I.offset+I.length)),D}e.edit=A;function c(D,R,C){let S=C;for(;S>=0;){if(D.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&D.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=c;function k(D,R,C){let S=C;for(;S>=0;)if(D.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&D.charAt(S)===R.charAt(1)))return S;return D.length-1}e.getLineEndOffset=k}),define(re[257],oe([0,1,32,54,12]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(f,d,v,h,u,m){const p=[],E=[],P=[];if(!d){const Y=f.filter(({identifier:W})=>u.every(T=>T.toLowerCase()!==W.id.toLowerCase()));return{local:{added:p,removed:E,updated:P},remote:Y.length>0?{added:Y,updated:[],removed:[],all:Y}:null}}f=f.map(w),d=d.map(w),v=v?v.map(w):null;const i=new Map,o=Y=>{Y.uuid&&i.set(Y.id.toLowerCase(),Y.uuid)};f.forEach(({identifier:Y})=>o(Y)),d.forEach(({identifier:Y})=>o(Y)),v?.forEach(({identifier:Y})=>o(Y));const t=Y=>{const W=Y.identifier.uuid||i.get(Y.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${Y.identifier.id.toLowerCase()}`},n=(Y,W)=>(Y.set(t(W),W),Y),s=f.reduce(n,new Map),a=d.reduce(n,new Map),r=d.reduce((Y,W)=>n(Y,(0,L.deepClone)(W)),new Map),l=v?v.reduce(n,new Map):null,y=h.reduce(n,new Map),b=u.reduce((Y,W)=>{const T=i.get(W.toLowerCase());return Y.add(T?`uuid:${T}`:`id:${W.toLowerCase()}`)},new Set),O=m?m.reduce((Y,{id:W,uuid:T})=>(T=T??i.get(W.toLowerCase()),Y.add(T?`uuid:${T}`:`id:${W.toLowerCase()}`)),new Set):null,N=D(s,a,b,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const Y=D(l,s,b,!1),W=D(l,a,b,!0),T=(B,_,q,x)=>{let M,X,Q;return _.installed?(M=x.pinned,Q=x.preRelease,M&&(X=x.version)):(M=q.pinned,Q=q.preRelease,M&&(X=q.version)),M===void 0&&(M=_.pinned,M&&(X=_.version)),Q===void 0&&(Q=_.preRelease),{...x,installed:_.installed||q.installed,pinned:M,preRelease:Q,version:X??(q.version&&(!_.installed||A.gt(q.version,_.version))?q.version:_.version),state:C(_,q,l?.get(B))}};for(const B of W.removed.values()){const _=s.get(B);if(!_)continue;const q=(0,c.assertIsDefined)(l?.get(B)),x=O&&!O.has(B)&&q.installed;_.installed&&x?E.push(_.identifier):r.set(B,_)}for(const B of W.added.values()){const _=(0,c.assertIsDefined)(a.get(B)),q=s.get(B);if(q){if(N.updated.has(B)){const x=T(B,q,_,_);R(q,_,!1,!1)||P.push(g(x,B)),r.set(B,x)}}else _.installed&&p.push(g(_,B))}for(const B of W.updated.values()){const _=(0,c.assertIsDefined)(a.get(B)),q=(0,c.assertIsDefined)(l?.get(B)),x=s.get(B);if(x)if(O&&!O.has(B)&&q.installed&&x.installed&&!_.installed)E.push(x.identifier);else{const X=T(B,x,_,_);P.push(g(X,B)),r.set(B,X)}else _.installed&&p.push(g(_,B))}for(const B of Y.added.values())W.added.has(B)||r.set(B,(0,c.assertIsDefined)(s.get(B)));for(const B of Y.updated.values()){if(W.removed.has(B)||W.updated.has(B))continue;const _=(0,c.assertIsDefined)(s.get(B)),q=(0,c.assertIsDefined)(a.get(B));r.set(B,T(B,_,q,_))}for(const B of Y.removed.values())W.updated.has(B)||W.removed.has(B)||y.has(B)||!(0,c.assertIsDefined)(a.get(B)).installed||!O||O.has(B)||!(0,c.assertIsDefined)(l?.get(B)).installed||r.delete(B)}const F=[],z=D(a,r,new Set,!0),G=z.added.size>0||z.updated.size>0||z.removed.size>0;return G&&r.forEach((Y,W)=>F.push(g(Y,W))),{local:{added:p,removed:E,updated:P},remote:G?{added:[...z.added].map(Y=>r.get(Y)),updated:[...z.updated].map(Y=>r.get(Y)),removed:[...z.removed].map(Y=>a.get(Y)),all:F}:null}}e.merge=k;function D(f,d,v,h){const u=f?[...f.keys()].filter(i=>!v.has(i)):[],m=[...d.keys()].filter(i=>!v.has(i)),p=m.filter(i=>u.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),E=u.filter(i=>m.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),P=new Set;for(const i of u){if(E.has(i))continue;const o=f.get(i),t=d.get(i);(!t||!R(o,t,h,!0))&&P.add(i)}return{added:p,removed:E,updated:P}}function R(f,d,v,h){return!(f.disabled!==d.disabled||h&&f.installed!==d.installed||f.installed&&d.installed&&(f.preRelease!==d.preRelease||f.pinned!==d.pinned||d.pinned&&f.version!==d.version)||!I(f.state,d.state)||v&&f.version!==d.version)}function C(f,d,v){const h=f.state,u=d.state,m=v?.state;if(!d.version||h&&A.gt(f.version,d.version))return h;if(u&&A.gt(d.version,f.version)||!h)return u;if(!u)return h;const p=(0,L.deepClone)(h),E=m?S(m,u):{added:Object.keys(u).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},P=m?S(m,h):{added:Object.keys(h).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...E.added.values(),...E.updated.values()])p[i]=u[i];for(const i of E.removed.values())P.updated.has(i)||delete p[i];return p}function S(f,d){const v=Object.keys(f),h=Object.keys(d),u=h.filter(E=>v.indexOf(E)===-1).reduce((E,P)=>(E.add(P),E),new Set),m=v.filter(E=>h.indexOf(E)===-1).reduce((E,P)=>(E.add(P),E),new Set),p=new Set;for(const E of v){if(m.has(E))continue;const P=f[E],i=d[E];(0,L.equals)(P,i)||p.add(E)}return{added:u,removed:m,updated:p}}function I(f={},d={}){const{added:v,removed:h,updated:u}=S(f,d);return v.size===0&&h.size===0&&u.size===0}function w(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function g(f,d){const v={identifier:{id:f.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(v.disabled=!0),f.installed&&(v.installed=!0),f.state&&(v.state=f.state),v}}),define(re[117],oe([0,1,21,17,5]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,c.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return S=S.filter(I=>I!==R&&I!==`-${R}`),C&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,C){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return S=S.filter(I=>I!==R&&I!==`-${R}`),C&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const C=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),S=this.b().map(g=>g.toLowerCase()),I=[],w=[];if(Array.isArray(S))for(const g of S)g.startsWith("-")?w.push(g.substring(1)):I.push(g);return(0,L.distinct)([...C,...I].filter(g=>w.indexOf(g)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};k=ye([J(0,A.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(re[258],oe([0,1,21,35,32,200,59]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(E){return(0,A.parse)(E)||[]}async function C(E,P,i,o,t){const n=R(E),s=R(P),a=i?R(i):null,r=[...n,...s,...a||[]].map(T=>T.key),l=await t.resolveUserBindings(r),y=I(n,s,a,l);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:E,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:P,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};const b=g(n),O=g(s),N=a?g(a):null,F=d(b,O,l),z=N?d(N,b,l):{added:[...b.keys()].reduce((T,B)=>(T.add(B),T),new Set),removed:new Set,updated:new Set},G=N?d(N,O,l):{added:[...O.keys()].reduce((T,B)=>(T.add(B),T),new Set),removed:new Set,updated:new Set},Y=S(F,z,G);let W=E;for(const T of Y.removed.values())Y.conflicts.has(T)||(W=m(W,T,o));for(const T of Y.added.values()){if(Y.conflicts.has(T))continue;const B=O.get(T);if(B.some(_=>_.command!==`-${T}`&&y.conflicts.has(l[_.key]))){Y.conflicts.add(T);continue}W=u(W,B,o)}for(const T of Y.updated.values()){if(Y.conflicts.has(T))continue;const B=O.get(T);if(B.some(_=>_.command!==`-${T}`&&y.conflicts.has(l[_.key]))){Y.conflicts.add(T);continue}W=p(W,T,B,o)}return{mergeContent:W,hasChanges:!0,hasConflicts:Y.conflicts.size>0}}e.merge=C;function S(E,P,i){const o=new Set,t=new Set,n=new Set,s=new Set;for(const a of P.removed.values())i.updated.has(a)&&s.add(a);for(const a of i.removed.values())s.has(a)||(P.updated.has(a)?s.add(a):t.add(a));for(const a of P.added.values())s.has(a)||i.added.has(a)&&E.updated.has(a)&&s.add(a);for(const a of i.added.values())s.has(a)||(P.added.has(a)?E.updated.has(a)&&s.add(a):o.add(a));for(const a of P.updated.values())s.has(a)||i.updated.has(a)&&E.updated.has(a)&&s.add(a);for(const a of i.updated.values())s.has(a)||(P.updated.has(a)?E.updated.has(a)&&s.add(a):n.add(a));return{added:o,removed:t,updated:n,conflicts:s}}function I(E,P,i,o){const t=new Set,n=w(E,o),s=w(P,o),a=i?w(i,o):null,r=f(n,s);if(r.added.size===0&&r.removed.size===0&&r.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const l=a?f(a,n):{added:[...n.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const y=a?f(a,s):{added:[...s.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:b,removed:O,updated:N,conflicts:F}=S(r,l,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:O,updated:N,conflicts:F}}function w(E,P){const i=new Map;for(const o of E){const t=P[o.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(o)}return i}function g(E){const P=new Map;for(const i of E){const o=i.command[0]==="-"?i.command.substring(1):i.command;let t=P.get(o);t||(t=[],P.set(o,t)),t.push(i)}return P}function f(E,P){const i=[...E.keys()],o=[...P.keys()],t=o.filter(a=>i.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),n=i.filter(a=>o.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),s=new Set;for(const a of i){if(n.has(a))continue;const r=E.get(a).map(y=>({...y,key:a})),l=P.get(a).map(y=>({...y,key:a}));(0,L.equals)(r,l,(y,b)=>h(y,b))||s.add(a)}return{added:t,removed:n,updated:s}}function d(E,P,i){const o=[...E.keys()],t=[...P.keys()],n=t.filter(r=>o.indexOf(r)===-1).reduce((r,l)=>(r.add(l),r),new Set),s=o.filter(r=>t.indexOf(r)===-1).reduce((r,l)=>(r.add(l),r),new Set),a=new Set;for(const r of o){if(s.has(r))continue;const l=E.get(r).map(b=>({...b,key:i[b.key]})),y=P.get(r).map(b=>({...b,key:i[b.key]}));v(l,y)||a.add(r)}return{added:n,removed:s,updated:a}}function v(E,P){return!(!(0,L.equals)(E.filter(({command:i})=>i[0]!=="-"),P.filter(({command:i})=>i[0]!=="-"),(i,o)=>h(i,o))||!(0,L.equals)(E.filter(({command:i})=>i[0]==="-"),P.filter(({command:i})=>i[0]==="-"),(i,o)=>h(i,o)))}function h(E,P){if(E.command!==P.command||E.key!==P.key)return!1;const i=k.ContextKeyExpr.deserialize(E.when),o=k.ContextKeyExpr.deserialize(P.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!c.equals(E.args,P.args))}function u(E,P,i){for(const o of P)E=D.edit(E,[-1],o,i);return E}function m(E,P,i){const o=R(E);for(let t=o.length-1;t>=0;t--)(o[t].command===P||o[t].command===`-${P}`)&&(E=D.edit(E,[t],void 0,i));return E}function p(E,P,i,o){const t=R(E),n=t.findIndex(s=>s.command===P||s.command===`-${P}`);for(let s=t.length-1;s>=0;s--)(t[s].command===P||t[s].command===`-${P}`)&&(E=D.edit(E,[s],void 0,o));for(let s=i.length-1;s>=0;s--)E=D.edit(E,[n],i[s],o);return E}}),define(re[259],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(k,D,R){const C={},S={},I=new Set;if(!D)return{local:{added:C,updated:S,removed:[...I.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const w=A(k,D);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:C,updated:S,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=A(R,k),f=A(R,D),d={},v={},h=new Set,u=new Set;for(const m of g.removed.values())f.updated.has(m)?C[m]=D[m]:h.add(m);for(const m of f.removed.values())u.has(m)||(g.updated.has(m)?u.add(m):I.add(m));for(const m of g.updated.values())u.has(m)||(f.updated.has(m)?w.updated.has(m)&&u.add(m):v[m]=k[m]);for(const m of f.updated.values())u.has(m)||(g.updated.has(m)?w.updated.has(m)&&u.add(m):k[m]!==void 0&&(S[m]=D[m]));for(const m of g.added.values())u.has(m)||(f.added.has(m)?w.updated.has(m)&&u.add(m):d[m]=k[m]);for(const m of f.added.values())u.has(m)||(g.added.has(m)?w.updated.has(m)&&u.add(m):C[m]=D[m]);return{local:{added:C,removed:[...I.values()],updated:S},remote:{added:d,removed:[...h.values()],updated:v},conflicts:[...u.values()]}}e.merge=L;function A(k,D){const R=k?Object.keys(k):[],C=D?Object.keys(D):[],S=C.filter(g=>R.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),I=R.filter(g=>C.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),w=new Set;for(const g of R){if(I.has(g))continue;const f=k[g],d=D[g];f!==d&&w.add(g)}return{added:S,removed:I,updated:w}}function c(k,D){const{added:R,removed:C,updated:S}=A(k,D);return R.size===0&&C.size===0&&S.size===0}e.areSame=c}),define(re[260],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(c,k,D,R){const C={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!k){const w=c.filter(({id:g})=>!R.includes(g));return w.length?S.added=w:S=null,{local:C,remote:S}}const I=A(c,k,R);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const w=A(D,c,R),g=A(D,k,R);for(const f of g.removed){const d=c.find(v=>v.id===f);d&&C.removed.push(d)}for(const f of g.added){const d=k.find(v=>v.id===f);w.added.includes(f)?I.updated.includes(f)&&C.updated.push(d):C.added.push(d)}for(const f of g.updated)C.updated.push(k.find(d=>d.id===f));for(const f of w.added)g.added.includes(f)||S.added.push(c.find(d=>d.id===f));for(const f of w.updated)g.removed.includes(f)||g.updated.includes(f)||S.updated.push(c.find(d=>d.id===f));for(const f of w.removed){const d=k.find(v=>v.id===f);d&&S.removed.push(d)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:C,remote:S}}e.merge=L;function A(c,k,D){c=c?c.filter(({id:g})=>!D.includes(g)):[],k=k.filter(({id:g})=>!D.includes(g));const R=c.map(({id:g})=>g),C=k.map(({id:g})=>g),S=C.filter(g=>R.indexOf(g)===-1),I=R.filter(g=>C.indexOf(g)===-1),w=[];for(const{id:g,name:f,shortName:d}of c){if(I.includes(g))continue;const v=k.find(h=>h.id===g);(!v||v.name!==f||v.shortName!==d)&&w.push(g)}return{added:S,removed:I,updated:w}}}),define(re[23],oe([0,1,21,12,183,45,29,5,107,40]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function w(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(y=>!!s[y].ignoreSync),r=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),l=I();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...r,...l])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const s="vscode://schemas/ignoredSettings",a=S.Registry.as(k.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,c.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,c.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,c.localize)(2,null),items:[{type:"string",pattern:D.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,c.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,c.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const r=S.Registry.as(C.Extensions.JSONContribution),l=()=>{const y=I(),b=w().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(z=>b.indexOf(z)===-1),N=b.filter(z=>y.indexOf(z)===-1),F={items:{type:"string",enum:[...O,...N.map(z=>`-${z}`)]}};r.registerSchema(s,F)};return a.onDidUpdateConfiguration(()=>l())}e.registerConfiguration=g;function f(s){return s&&(0,A.isObject)(s)&&(0,A.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=f;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(s,...a){return s?[s,...a]:a}e.getPathSegments=v;function h(s,a,r,l){return l.joinPath(r.userDataSyncHome,...v(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=h,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=u;var m;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(a,r,l,y){super(a),this.code=r,this.resource=l,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class E extends p{constructor(a,r,l,y,b){super(a,l,void 0,b),this.url=r,this.serverCode=y}}e.UserDataSyncStoreError=E;class P extends p{constructor(a,r){super(a,r)}}e.UserDataAutoSyncError=P,function(s){function a(r){if(r instanceof s)return r;const l=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(r.name);if(l&&l[1]){const y=l[2]==="unknown"?void 0:l[2],b=l[3]==="unknown"?void 0:l[3];return new s(r.message,l[1],y,b)}return new s(r.message,"Unknown")}s.toUserDataSyncError=a}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[261],oe([0,1,32,23]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function c(D,R,C,S,I){if(!R)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const w=k(D,R);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=C?k(C,R):{added:Object.keys(R).reduce((m,p)=>(m.add(p),m),new Set),removed:new Set,updated:new Set},f=C?k(C,D):{added:Object.keys(D).reduce((m,p)=>(m.add(p),m),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},v=L.deepClone(R),h=!C;for(const m of f.added.values())m!==A.SYNC_SERVICE_URL_TYPE&&h&&g.added.has(m)||(v[m]=D[m]);for(const m of f.updated.values())v[m]=D[m];for(const m of f.removed.values())S.unregistered.includes(m)||delete v[m];for(const m of g.added.values()){const p=R[m];if(S.machine.includes(m)){I.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(C&&f.added.has(m))continue;const E=D[m];E&&E.value===p.value||m===A.SYNC_SERVICE_URL_TYPE&&h&&f.added.has(m)||(E?d.updated[m]=p:d.added[m]=p)}for(const m of g.updated.values()){const p=R[m];if(S.machine.includes(m)){I.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(m)||f.removed.has(m))continue;const E=D[m];E&&E.value===p.value||(d.updated[m]=p)}for(const m of g.removed.values()){if(S.machine.includes(m)){I.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}f.updated.has(m)||f.removed.has(m)||d.removed.push(m)}const u=k(R,v);return{local:d,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:v}}}e.merge=c;function k(D,R){const C=Object.keys(D),S=Object.keys(R),I=S.filter(f=>C.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),w=C.filter(f=>S.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),g=new Set;for(const f of C){if(w.has(f))continue;const d=D[f],v=R[f];L.equals(d,v)||g.add(f)}return{added:I,removed:w,updated:g}}}),define(re[262],oe([0,1,21,35,82,42,32,59,23]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(r,l,y){let b=[];y?b=w(y):b=I(l);const O=[],N=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const F of b)F.startsWith("-")?N.push(F.substring(1)):O.push(F);return(0,L.distinct)([...r,...O].filter(F=>N.indexOf(F)===-1))}e.getIgnoredSettings=S;function I(r){let l=r.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=r.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:r.getValue("settingsSync.ignoredSettings")||[]}function w(r){const l=(0,A.parse)(r);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function g(r,l){const y=(0,A.parse)(r)||{};let b="{}";for(const O of Object.keys(y)){const N=(0,c.setProperty)(b,[O],y[O],l);b=(0,c.applyEdits)(b,N)}return b}e.removeComments=g;function f(r,l,y,b){if(y.length){const O=a(l),N=(0,A.parse)(l)||{},F=(0,A.parse)(r);if(!F)return r;const z=[];for(const G of y){const Y=N[G],W=F[G];Y===void 0?r=R.edit(r,[G],void 0,b):W!==void 0?r=R.edit(r,[G],Y,b):z.push(i(G,O))}z.sort((G,Y)=>G.startOffset-Y.startOffset),z.forEach(G=>r=m(G.setting.key,l,r,b))}return r}e.updateIgnoredSettings=f;function d(r,l,y,b,O,N){const F=f(r,l,b,N),z=y!==F,G=y!==l;if(!z&&!G)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!G)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(G&&!z)return{conflictsSettings:[],localContent:f(l,r,b,N),remoteContent:null,hasConflicts:!1};if(y===null&&h(r)){const $=v(r,l,b)?null:f(l,r,b,N);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let Y=r,W=l;const T=(0,A.parse)(r),B=(0,A.parse)(l),_=y?(0,A.parse)(y):null,q=b.reduce(($,H)=>($.add(H),$),new Set),x=u(T,B,q),M=u(_,T,q),X=u(_,B,q),Q=new Map,se=new Set,ae=$=>{se.add($);const H=O.filter(({key:ee})=>ee===$)[0];H?(Y=R.edit(Y,[$],H.value,N),W=R.edit(W,[$],H.value,N)):Q.set($,{key:$,localValue:T[$],remoteValue:B[$]})};for(const $ of M.removed.values())X.updated.has($)?ae($):W=R.edit(W,[$],void 0,N);for(const $ of X.removed.values())se.has($)||(M.updated.has($)?ae($):Y=R.edit(Y,[$],void 0,N));for(const $ of M.updated.values())se.has($)||(X.updated.has($)?x.updated.has($)&&ae($):W=R.edit(W,[$],T[$],N));for(const $ of X.updated.values())se.has($)||(M.updated.has($)?x.updated.has($)&&ae($):Y=R.edit(Y,[$],B[$],N));for(const $ of M.added.values())se.has($)||(X.added.has($)?x.updated.has($)&&ae($):W=m($,Y,W,N));for(const $ of X.added.values())se.has($)||(M.added.has($)?x.updated.has($)&&ae($):Y=m($,W,Y,N));const V=Q.size>0||!v(Y,W,b),j=V||!v(Y,r,[]),U=V||!v(W,l,[]);return{localContent:j?Y:null,remoteContent:U?W:null,conflictsSettings:[...Q.values()],hasConflicts:V}}e.merge=d;function v(r,l,y){if(r===l)return!0;const b=(0,A.parse)(r),O=(0,A.parse)(l),N=y.reduce((G,Y)=>(G.add(Y),G),new Set),F=a(r).filter(G=>!(G.setting&&N.has(G.setting.key))),z=a(l).filter(G=>!(G.setting&&N.has(G.setting.key)));if(F.length!==z.length)return!1;for(let G=0;G<F.length;G++){const Y=F[G],W=z[G];if(Y.setting&&W.setting){if(Y.setting.key!==W.setting.key||!D.equals(b[Y.setting.key],O[Y.setting.key]))return!1}else if(!Y.setting&&!W.setting){if(Y.value!==W.value)return!1}else return!1}return!0}function h(r){return r?a(r).length===0:!0}e.isEmpty=h;function u(r,l,y){const b=r?Object.keys(r).filter(G=>!y.has(G)):[],O=Object.keys(l).filter(G=>!y.has(G)),N=O.filter(G=>b.indexOf(G)===-1).reduce((G,Y)=>(G.add(Y),G),new Set),F=b.filter(G=>O.indexOf(G)===-1).reduce((G,Y)=>(G.add(Y),G),new Set),z=new Set;if(r)for(const G of b){if(F.has(G))continue;const Y=r[G],W=l[G];D.equals(Y,W)||z.add(G)}return{added:N,removed:F,updated:z}}function m(r,l,y,b){const O=(0,A.parse)(l),N=a(l),F=a(y),z=p(r,N,F);return E(y,r,O[r],z,F,b)}e.addSetting=m;function p(r,l,y){const b=l.findIndex(N=>N.setting?.key===r),O=l[b-1];if(O){if(O.setting){const F=i(O.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!0}}else{const F=o(b,l);if(F){const z=i(F.setting.key,y);if(z){const G=t(y.indexOf(z),y),Y=n(l,F,l[b]);if(G){const W=n(y,z,G),T=s(Y,W);return T?{index:y.indexOf(T),insertAfter:!0}:{index:y.indexOf(G),insertAfter:!1}}else{const W=n(y,z,y[y.length-1]),T=s(Y,W);return T?{index:y.indexOf(T),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const N=l[b+1];if(N)if(N.setting){const F=i(N.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!1}}else{const F=t(b,l);if(F){const z=i(F.setting.key,y);if(z){const G=o(y.indexOf(z),y),Y=n(l,l[b],F);if(G){const W=n(y,G,z),T=s(Y.reverse(),W.reverse());return T?{index:y.indexOf(T),insertAfter:!1}:{index:y.indexOf(G),insertAfter:!0}}else{const W=n(y,y[0],z),T=s(Y.reverse(),W.reverse());return T?{index:y.indexOf(T),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function E(r,l,y,b,O,N){let F;return b.index===-1?F=(0,c.setProperty)(r,[l],y,N):F=P(r,l,y,b,O,N).map(z=>(0,c.withFormatting)(r,z,N)[0]),(0,c.applyEdits)(r,F)}function P(r,l,y,b,O,N){const F=`${JSON.stringify(l)}: ${JSON.stringify(y)}`,z=(0,k.getEOL)(N,r),G=O[b.index];if(b.insertAfter){const Y=[];if(G.setting)Y.push({offset:G.endOffset,length:0,content:","+F});else{const W=t(b.index,O),T=o(b.index,O),B=T?.setting?.commaOffset;T&&B===void 0&&Y.push({offset:T.endOffset,length:0,content:","});const _=B!==void 0&&B>G.endOffset;Y.push({offset:_?B+1:G.endOffset,length:0,content:W?z+F+",":z+F})}return Y}else{if(G.setting)return[{offset:G.startOffset,length:0,content:F+","}];const Y=(O[b.index-1]&&!O[b.index-1].setting?z:"")+F+(t(b.index,O)?",":"")+z;return[{offset:G.startOffset,length:0,content:Y}]}}function i(r,l){return l.filter(y=>y.setting?.key===r)[0]}function o(r,l){for(let y=r-1;y>=0;y--)if(l[y].setting)return l[y]}function t(r,l){for(let y=r+1;y<l.length;y++)if(l[y].setting)return l[y]}function n(r,l,y){const b=r.indexOf(l),O=r.indexOf(y);return r.filter((N,F)=>b<F&&F<O)}function s(r,l){if(r.length&&l.length){let y=0;for(;y<l.length&&y<r.length;y++)if(r[y].value!==l[y].value)return l[y-1];return l[y-1]}}function a(r){const l=[];let y=-1,b,O;const N={onObjectBegin:F=>{y++},onObjectProperty:(F,z,G)=>{y===0&&(b=z,O=F)},onObjectEnd:(F,z)=>{y--,y===0&&l.push({startOffset:b,endOffset:F+z,value:r.substring(b,F+z),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(F,z)=>{y++},onArrayEnd:(F,z)=>{y--,y===0&&l.push({startOffset:b,endOffset:F+z,value:r.substring(b,F+z),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(F,z,G)=>{y===0&&l.push({startOffset:b,endOffset:z+G,value:r.substring(b,z+G),setting:{key:O,commaOffset:void 0}})},onSeparator:(F,z,G)=>{if(y===0&&F===","){let Y=l.length-1;for(;Y>=0&&!l[Y].setting;Y--);const W=l[Y];W&&l.splice(Y,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:z}})}},onComment:(F,z)=>{y===0&&l.push({startOffset:F,endOffset:F+z,value:r.substring(F,F+z)})}};return(0,A.visit)(r,N),l}}),define(re[76],oe([0,1,3,2,5,23]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,c.createDecorator)("IUserDataSyncAccountService");let D=class extends A.Disposable{get account(){return this.a}constructor(C,S){super(),this.g=C,this.h=S,this.b=this.B(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};D=ye([J(0,k.IUserDataSyncStoreService),J(1,k.IUserDataSyncLogService)],D),e.UserDataSyncAccountService=D}),define(re[263],oe([0,1,2,10]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class c{constructor(g){this.a=g}listen(g,f){switch(f){case"onError":return this.a.onError}throw new Error(`Event not found: ${f}`)}call(g,f,d){switch(f){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=c;class k{constructor(g){this.a=g}listen(g,f){throw new Error(`Event not found: ${f}`)}call(g,f,d){switch(f){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(A.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class D{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=D;class R{constructor(g){this.a=g}listen(g,f){switch(f){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${f}`)}async call(g,f,d){switch(f){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(g){this.a=g}listen(g,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(g,f,d){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class S{constructor(g){this.a=g}listen(g,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(g,f,d){switch(f){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class I extends L.Disposable{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:A.URI.revive(g.url),type:g.type,defaultUrl:A.URI.revive(g.defaultUrl),insidersUrl:A.URI.revive(g.insidersUrl),stableUrl:A.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(re[264],oe([0,1,184,15,11,23]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends c.AbstractLogger{constructor(C,S){super(),this.g=this.B(C.createLogger(S.userDataSyncLogResource,{id:k.USER_DATA_SYNC_LOG_ID,name:(0,L.localize)(0,null)}))}trace(C,...S){this.g.trace(C,...S)}debug(C,...S){this.g.debug(C,...S)}info(C,...S){this.g.info(C,...S)}warn(C,...S){this.g.warn(C,...S)}error(C,...S){this.g.error(C,...S)}flush(){this.g.flush()}};D=ye([J(0,c.ILoggerService),J(1,A.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(re[265],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(re[266],oe([0,1,6,3,2]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends c.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:S}){super(),this.a=this.B(new c.DisposableStore),A.Event.latch(A.Event.any(R,C))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>S()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=k}),define(re[118],oe([0,1,187,13,49,25,10,5,22]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function I(n){return typeof n?.id=="string"&&!S(n)&&!g(n)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,A.basename)(n)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=w;function g(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=g;function f(n){const s=n;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=f;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=v;function h(n){const s=n;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(s,a,r,l,y){this.h=s,this.j=r,this.k=l,this.l=y,this.c=c.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=c.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function p(n){return new m({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(n,s){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,s.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function P(n){let s;return D.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=P,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(n,s){return!E(n,s)&&!P(n)}e.isSavedWorkspace=o;function t(n){return(typeof n=="string"?(0,A.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(re[18],oe([0,1,64,3,2,25,10,178,15,14,5,11,118,37,30,6,31,27,12]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function E(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=E;function P(t,n,s,a){return{id:t,name:n,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,k.joinPath)(s,"globalStorage"),settingsResource:(0,k.joinPath)(s,"settings.json"),keybindingsResource:(0,k.joinPath)(s,"keybindings.json"),tasksResource:(0,k.joinPath)(s,"tasks.json"),snippetsHome:(0,k.joinPath)(s,"snippets"),extensionsResource:(0,k.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=P;let i=class extends c.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,a,r){super(),this.m=n,this.n=s,this.r=a,this.s=r,this.f=!0,this.g=this.B(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const l of this.I()){if(!l.name||!(0,m.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(P((0,k.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.s.error(l)}const s=new f.ResourceMap,a=new Map,r=this.v();if(n.unshift({...r,extensionsResource:this.N()??r.extensionsResource,isDefault:!0}),n.length)try{const l=this.L();if(l.workspaces)for(const[y,b]of Object.entries(l.workspaces)){const O=D.URI.parse(y),N=n.find(F=>F.id===b);N&&s.set(O,N)}if(l.emptyWindows)for(const[y,b]of Object.entries(l.emptyWindows)){const O=n.find(N=>N.id===b);O&&a.set(y,O)}}catch(l){this.s.error(l)}this.t={profiles:n,workspaces:s,emptyWindows:a}}return this.t}v(){return P("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const s="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let r=0;for(const y of this.profiles){const b=a.exec(y.name),O=b?parseInt(b[1]):0;r=O>r?O:r}const l=`${s} ${r+1}`;return this.createProfile((0,L.hash)((0,h.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,s,a){return this.createProfile((0,L.hash)((0,h.generateUuid)()).toString(16),n,s,a)}async createProfile(n,s,a,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(n,s,a);return r&&await this.setProfileForWorkspace(r,l),l}async w(n,s,a){if(!(0,m.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(s);return r||(r=(async()=>{try{const l=this.profiles.find(O=>O.name===s||O.id===n);if(l)return l;const y=P(n,s,(0,k.joinPath)(this.profilesHome,n),a);await this.n.createFolder(y.location);const b=[];return this.h.fire({profile:y,join(O){b.push(O)}}),await v.Promises.settled(b),this.C([y],[],[]),y}finally{this.k.delete(s)}})(),this.k.set(s,r)),r}async updateProfile(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(r=>r.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=P(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.C([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(r=>r.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:s,join(r){a.push(r)}});try{await Promise.allSettled(a)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.G(),this.C([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(r=>r.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.F(n,a)}unsetWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.z(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.y(n);return D.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}y(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}C(n,s,a){const r=[...this.profiles,...n],l=[];this.l.profiles=[];for(let y of r)y.isDefault||s.some(b=>y.id===b.id)||(y=a.find(b=>y.id===b.id)??y,y.isTransient?this.l.profiles.push(y):l.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.J(l),this.t=void 0,this.D(n,s,a)}D(n,s,a){this.g.fire({added:n,removed:s,updated:a,all:this.profiles})}F(n,s,a){a=s?.isTransient?!0:a,a||this.F(n,void 0,!0);const r=this.y(n),l=a?this.l:this.u;D.URI.isUri(r)?(l.workspaces.delete(r),s&&l.workspaces.set(r,s)):(l.emptyWindows.delete(r),s&&l.emptyWindows.set(r,s)),a||this.G()}G(){const n={};for(const[a,r]of this.u.workspaces.entries())n[a.toString()]=r.id;const s={};for(const[a,r]of this.u.emptyWindows.entries())s[a.toString()]=r.id;this.M({workspaces:n,emptyWindows:s}),this.t=void 0}H(n){const s={},a=this.v();if(n.workspaces)for(const[l,y]of Object.entries(n.workspaces)){const b=D.URI.parse(y);s[l]=this.r.extUri.isEqual(b,a.location)?a.id:this.r.extUri.basename(b)}const r={};if(n.emptyWindows)for(const[l,y]of Object.entries(n.emptyWindows)){const b=D.URI.parse(y);r[l]=this.r.extUri.isEqual(b,a.location)?a.id:this.r.extUri.basename(b)}return{workspaces:s,emptyWindows:r}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([J(0,C.IEnvironmentService),J(1,S.IFileService),J(2,d.IUriIdentityService),J(3,w.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=o}),define(re[267],oe([0,1,6,2,18]),function(te,e,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends A.Disposable{constructor(R){super(),this.B(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};k=ye([J(0,c.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(re[268],oe([0,1,21,6,24,8,3,2,4,10,157,29,33,46,11,26,19,18]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var m;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(m=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,a,r,l){super(),this.t=n,this.u=s,this.v=a,this.w=r,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.k.forEach(y=>y.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw i(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),P(a)}}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,s,a){const r={...a,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,f.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},l=z=>`${g.ExtensionKey.create(z).toString()}${r.profileLocation?`-${r.profileLocation.toString()}`:""}`;if(!S.URI.isUri(s)){const z=this.j.get(l(s));if(z)return this.v.info("Extensions is already requested to install",s.identifier.id),z.task.waitUntilTaskIsFinished()}const y=[],b=[],O=[],N=this.Q(n,s,r);S.URI.isUri(s)||this.j.set(l(s),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:s,profileLocation:r.profileLocation}),this.v.info("Installing extension:",N.identifier.id),y.push({task:N,manifest:n});let F=!1;try{if(r.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const G=await this.F(N.identifier,n,!!r.installOnlyNewlyAddedFromExtensionPack,!!r.installPreReleaseVersion,r.profileLocation),Y=await this.getInstalled(void 0,r.profileLocation);for(const{gallery:W,manifest:T}of(0,L.distinct)(G,({gallery:B})=>B.identifier.id)){F=F||!!T.extensionDependencies?.some(q=>(0,g.areSameExtensions)({id:q},N.identifier));const B=l(W),_=this.j.get(B);if(_){if(this.C(N,_.task)){const q=_.task.identifier;this.v.info("Waiting for already requested installing extension",q.id,N.identifier.id),_.waitingTasks.push(N),b.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,x=>x.some(M=>(0,g.areSameExtensions)(M.identifier,q)))).then(x=>{if(this.v.info("Finished waiting for already requested installing extension",q.id,N.identifier.id),!x.find(X=>(0,g.areSameExtensions)(X.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!Y.some(({identifier:q})=>(0,g.areSameExtensions)(q,W.identifier))){const q=this.Q(T,W,{...r,donotIncludePackAndDependencies:!0});this.j.set(B,{task:q,waitingTasks:[N]}),this.l.fire({identifier:q.identifier,source:W,profileLocation:r.profileLocation}),this.v.info("Installing extension:",q.identifier.id,N.identifier.id),y.push({task:q,manifest:T})}}}catch(G){if(S.URI.isUri(N.source))(0,L.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,G.message),(0,L.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,G.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),G}const z=y.reduce((G,{task:Y,manifest:W})=>(G.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:W}),G),new Map);for(;z.size;){let G;const Y=[...z.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(T=>z.has(T.toLowerCase())));Y.length?G=z.size===1?Y:Y.filter(({task:W})=>!(W===N&&!F)):(this.v.info("Found extensions with circular dependencies",Y.map(({task:W})=>W.identifier.id)),G=[...z.values()]),await this.D(G.map(async({task:W})=>{const T=new Date().getTime();try{const B=await W.run();if(await this.D(this.s.map(_=>_.postInstall(B,W.source,r,c.CancellationToken.None))),!S.URI.isUri(W.source)){const _=W.operation===3,q=_?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(i(this.u,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:q}),C.isWeb&&W.operation!==3)try{await this.t.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}O.push({local:B,identifier:W.identifier,operation:W.operation,source:W.source,context:r.context,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw S.URI.isUri(W.source)||i(this.u,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-T,error:B}),this.v.error("Error while installing the extension:",W.identifier.id),B}finally{z.delete(W.identifier.id.toLowerCase())}}))}return b.length&&await this.D(b),O.forEach(({identifier:G})=>this.v.info("Extension installed successfully:",G.id)),this.m.fire(O),O.filter(({identifier:G})=>(0,g.areSameExtensions)(G,N.identifier))[0].local}catch(z){if(y.forEach(({task:G})=>G.cancel()),O.length)try{const G=await Promise.allSettled(O.map(({local:Y})=>this.R(Y,{versionOnly:!0,profileLocation:r.profileLocation}).run()));for(let Y=0;Y<G.length;Y++){const W=G[Y],{identifier:T}=O[Y];W.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",T.id):this.v.warn("Rollback: Error while uninstalling extension",T.id,(0,k.getErrorMessage)(W.reason))}}catch(G){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(G),O.map(({identifier:Y})=>Y.id))}throw this.m.fire(y.map(({task:G})=>({identifier:G.identifier,operation:2,source:G.source,context:r.context,profileLocation:r.profileLocation}))),z}finally{for(const{task:z}of y)z.source&&!S.URI.isUri(z.source)&&this.j.delete(l(z.source))}}C(n,s){for(const[,{task:a,waitingTasks:r}]of this.j.entries())if(a===n&&(r.includes(s)||r.some(l=>this.C(l,s)))||a===s&&r[0]&&!this.C(n,r[0]))return!1;return!0}async D(n){const s=[],a=[],r=await Promise.allSettled(n);for(const l of r)l.status==="fulfilled"?s.push(l.value):a.push(l.reason);if(a.length)throw E(a);return s}async F(n,s,a,r,l){if(!this.t.isEnabled())return[];const y=await this.getInstalled(void 0,l),b=[],O=[],N=async(F,z)=>{b.push(F);const G=z.extensionDependencies||[],Y=[...G];if(z.extensionPack){const W=a?y.find(T=>(0,g.areSameExtensions)(T.identifier,F)):void 0;for(const T of z.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(B=>(0,g.areSameExtensions)({id:B},{id:T}))||Y.every(B=>!(0,g.areSameExtensions)({id:B},{id:T}))&&Y.push(T)}if(Y.length){const W=Y.filter(T=>b.every(B=>!(0,g.areSameExtensions)(B,{id:T})));if(W.length){const T=await this.t.getExtensions(W.map(B=>({id:B,preRelease:r})),c.CancellationToken.None);for(const B of T){if(b.find(x=>(0,g.areSameExtensions)(x,B.identifier)))continue;const _=G.some(x=>(0,g.areSameExtensions)({id:x},B.identifier));let q;try{q=await this.G(B,!1,r)}catch(x){if(x instanceof w.ExtensionManagementError&&x.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.v.info("Skipping the packed extension as it cannot be installed",B.identifier.id);continue}else throw x}O.push({gallery:q.extension,manifest:q.manifest}),await N(q.extension.identifier,q.manifest)}}}};return await N(n,s),O}async G(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(b=>(0,g.areSameExtensions)(n.identifier,b)))throw new w.ExtensionManagementError(I.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const b=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(b)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,s,a);if(l){if(a&&!s&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],c.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const y=await this.t.getManifest(l,c.CancellationToken.None);if(y===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(y.version!==l.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:y}}async H(n,s,a){const r=await this.getTargetPlatform();let l=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:r,compatible:!0},c.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,a,r)&&(l=n),l||(s?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:r,compatible:!0},c.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,a,r)),l}async I(n,s){const a={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},r=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.k.get(r(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const y=F=>{const z=this.R(F,a);return this.k.set(r(z.extension.identifier),z),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),z},b=(F,z)=>{z?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),z.message):this.v.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,z.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(F),error:z}),this.p.fire({identifier:F.identifier,error:z?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},O=[],N=[];try{O.push(y(n));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const z=this.M(n,F);for(const G of z)this.k.has(r(G.identifier))?this.v.info("Extensions is already requested to uninstall",G.identifier.id):O.push(y(G))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(O.map(z=>z.extension),F,n),await this.D(O.map(async z=>{try{if(await z.run(),await this.D(this.s.map(G=>G.postUninstall(z.extension,a,c.CancellationToken.None))),z.extension.identifier.uuid)try{await this.t.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}b(z.extension)}catch(G){const Y=G instanceof w.ExtensionManagementError?G:new w.ExtensionManagementError((0,k.getErrorMessage)(G),w.ExtensionManagementErrorCode.Internal);throw b(z.extension,Y),Y}finally{N.push(z)}}))}catch(F){const z=F instanceof w.ExtensionManagementError?F:new w.ExtensionManagementError((0,k.getErrorMessage)(F),w.ExtensionManagementErrorCode.Internal);for(const G of O){try{G.cancel()}catch{}N.includes(G)||b(G.extension,z)}throw z}finally{for(const F of O)this.k.delete(r(F.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(n,s,a){for(const r of n){const l=this.N(r,s);if(l.length){const y=l.filter(b=>!n.some(O=>(0,g.areSameExtensions)(O.identifier,b.identifier)));if(y.length)throw new Error(this.L(r,y,a))}}}L(n,s,a){return a===n?s.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const r=n.manifest.extensionPack?n.manifest.extensionPack:[];if(r.length){const l=s.filter(b=>!b.isBuiltin&&r.some(O=>(0,g.areSameExtensions)({id:O},b.identifier))),y=[];for(const b of l)y.push(...this.M(b,s,a));return[...l,...y]}return[]}N(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([J(0,w.IExtensionGalleryService),J(1,h.ITelemetryService),J(2,d.ILogService),J(3,v.IProductService),J(4,u.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function E(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=E;function P(t){if(t instanceof w.ExtensionManagementError)return t;const n=new w.ExtensionManagementError(t.message,w.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function i(t,n,{extensionData:s,verificationStatus:a,duration:r,error:l,durationSinceUpdate:y}){let b,O;l&&(l instanceof w.ExtensionManagementError?(b=l.code,l.code===w.ExtensionManagementErrorCode.Signature&&(O=l.message)):b=w.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...s,verificationStatus:a,success:!l,duration:r,errorcode:b,errorcodeDetail:O,durationSinceUpdate:y})}class o{constructor(){this.d=new A.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.createCancelablePromise)(n=>new Promise((s,a)=>{const r=n.onCancellationRequested(()=>{r.dispose(),a(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=o}),define(re[51],oe([0,1,6,16,2,3,37,10,29,33,14,5,11,18,30,12,8,19]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let E=class extends c.Disposable{constructor(t,n,s,a,r,l){super(),this.i=t,this.j=n,this.k=s,this.l=a,this.m=r,this.n=l,this.b=this.B(new k.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(t,n){return this.p(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],a=[];try{return await this.p(n,r=>{const l=[];for(const y of r)t.some(([b])=>(0,S.areSameExtensions)(b.identifier,y.identifier)&&b.manifest.version!==y.version)?s.push(y):l.push(y);for(const[y,b]of t)if(!l.some(O=>(0,S.areSameExtensions)(O.identifier,y.identifier)&&O.version===y.manifest.version)){const O={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:b};a.push(O),l.push(O)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),a.length&&this.c.fire({extensions:a,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),a}catch(r){throw a.length&&this.c.fire({extensions:a,error:r,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:r,profileLocation:n}),r}}async updateMetadata(t,n){const s=[];return await this.p(n,a=>{const r=[];for(const l of a){const y=t.find(([b])=>(0,S.areSameExtensions)(b.identifier,l.identifier)&&b.manifest.version===l.version);y&&(l.metadata={...l.metadata,...y[1]},s.push(l)),r.push(l)}return r}),s}async removeExtensionFromProfile(t,n){const s=[];this.f.fire({extensions:s,profileLocation:n});try{await this.p(n,a=>{const r=[];for(const l of a)(0,S.areSameExtensions)(l.identifier,t.identifier)?s.push(l):r.push(l);return s.length&&this.f.fire({extensions:s,profileLocation:n}),r}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(a){throw s.length&&this.g.fire({extensions:s,error:a,profileLocation:n}),a}}async p(t,n,s){return this.w(t).queue(async()=>{let a=[],r;try{const l=await this.j.readFile(t);r=JSON.parse(l.value.toString().trim()||"[]")}catch(l){if((0,I.toFileOperationResult)(l)!==1)throw l;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(r=await this.v()),!r&&s?.bailOutWhenFileNotFound)throw new p((0,h.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.r(t);let l=!1;for(const y of r){P(y)||this.r(t);let b;if((0,v.isString)(y.relativeLocation)&&y.relativeLocation)b=this.t(y.relativeLocation);else if((0,v.isString)(y.location))b=this.t(y.location),l=!0,y.relativeLocation=y.location,y.location=b.toJSON();else{b=R.URI.revive(y.location);const O=this.s(b);O&&(l=!0,y.relativeLocation=O)}a.push({identifier:y.identifier,location:b,version:y.version,metadata:y.metadata})}l&&await this.j.writeFile(t,A.VSBuffer.fromString(JSON.stringify(r)))}if(n){a=n(a);const l=a.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.s(y.location),metadata:y.metadata}));await this.j.writeFile(t,A.VSBuffer.fromString(JSON.stringify(l)))}return a})}r(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}t(t){return this.l.extUri.joinPath(this.i,t)}async v(){return this.u||(this.u=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(r){if((0,I.toFileOperationResult)(r)===1)return;throw r}this.n.info("Migrating extensions from old default profile location",t.toString());let a;try{const r=JSON.parse(s);Array.isArray(r)&&r.every(l=>P(l))?a=r:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",r)}catch(r){this.n.error(r)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(r){if((0,I.toFileOperationResult)(r)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw r}try{await this.j.del(t)}catch(r){(0,I.toFileOperationResult)(r)!==1&&this.n.error(r)}try{await this.j.del(n)}catch(r){(0,I.toFileOperationResult)(r)!==1&&this.n.error(r)}return a})()),this.u}w(t){let n=this.h.get(t);return n||(n=new L.Queue,this.h.set(t,n)),n}};E=ye([J(1,I.IFileService),J(2,f.IUserDataProfilesService),J(3,d.IUriIdentityService),J(4,u.ITelemetryService),J(5,g.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function P(o){return(0,v.isObject)(o)&&(0,C.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,v.isString)(o.location)&&o.location)&&((0,v.isUndefined)(o.relativeLocation)||(0,v.isString)(o.relativeLocation))&&o.version&&(0,v.isString)(o.version)}function i(o){return o?(0,v.isString)(o.path)&&(0,v.isString)(o.scheme):!1}}),define(re[77],oe([0,1,21,6,32,16,8,35,139,2,22,13,4,25,54,89,12,10,161,15,33,46,67,14,5,11,26,3,90,51,18,30,194,195]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o,t,n,s,a,r,l,y,b,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(_){function q(x,M){if(x===M)return!0;const X=Object.keys(x),Q=new Set;for(const se of Object.keys(M))Q.add(se);if(X.length!==Q.size)return!1;for(const se of X){if(x[se]!==M[se])return!1;Q.delete(se)}return Q.size===0}_.equals=q})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let z=class extends S.Disposable{constructor(q,x,M,X,Q,se,ae,V,j,U,$,H){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=x,this.l=M,this.m=X,this.n=Q,this.p=se,this.r=ae,this.s=V,this.t=j,this.u=U,this.v=$,this.w=H,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(W,(0,f.joinPath)(this.m,P.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(W,(0,f.joinPath)(this.m,P.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Y,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(q,x,M){const[X,Q]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(x)]),se=M?await this.scanExtensionsUnderDevelopment(q,[...X,...Q]):[];return this.F(X,Q,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const x=[];x.push(this.G(!!q.useCache,q.language)),x.push(this.H(q.language,!!q.checkControlFile));const[M,X]=await Promise.all(x);return this.D([...M,...X],0,q,!1)}async scanUserExtensions(q){const x=q.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",x);const M=this.v.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,X=await this.J(x,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,M),Q=q.useCache&&!X.devMode&&X.excludeObsolete?this.j:this.k;let se;try{se=await Q.scanExtensions(X)}catch(ae){if(ae instanceof l.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),se=await Q.scanExtensions(X);else throw ae}return se=await this.D(se,1,q,!0),this.s.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(q,x){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(X=>X.scheme===I.Schemas.file).map(async X=>{const Q=await this.J(X,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(ae=>(ae.type=x.find(V=>(0,E.areSameExtensions)(V.identifier,ae.identifier))?.type??ae.type,this.k.validate(ae,Q)))}))).flat();return this.D(M,"development",q,!0)}return[]}async scanExistingExtension(q,x,M){const X=await this.J(q,!1,x,!0,M.language,!0,void 0),Q=await this.k.scanExtension(X);return!Q||!M.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(q,x,M){const X=await this.J(q,!1,x,!0,M.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(X);return this.D(Q,x,M,!0)}async scanMetadata(q){const x=(0,f.joinPath)(q,"package.json"),M=(await this.r.readFile(x)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(q,x){const M=(0,f.joinPath)(q,"package.json"),X=(await this.r.readFile(M)).value.toString(),Q=JSON.parse(X);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,Q.__metadata={...Q.__metadata,...x},await this.r.writeFile((0,f.joinPath)(q,"package.json"),k.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof l.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw q}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.p.addExtensionsToProfile(q.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,o.toFileOperationResult)(x)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(x))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.s.error(q)}finally{this.z=void 0}})()),this.z}async D(q,x,M,X){return M.includeAllVersions||(q=this.F(x===0?q:void 0,x===1?q:void 0,x==="development"?q:void 0,await this.getTargetPlatform(),X)),M.includeInvalid||(q=q.filter(Q=>Q.isValid)),q.sort((Q,se)=>{const ae=w.basename(Q.location.fsPath),V=w.basename(se.location.fsPath);return ae<V?-1:ae>V?1:0})}F(q,x,M,X,Q){const se=(V,j,U)=>{if(V.isValid&&!j.isValid)return!1;if(V.isValid===j.isValid){if(Q&&d.gt(V.manifest.version,j.manifest.version))return this.s.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(d.eq(V.manifest.version,j.manifest.version)){if(V.type===0)return this.s.debug(`Skipping extension ${j.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===X)return this.s.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${V.location.path} with ${j.location.path}.`):this.s.debug(`Overwriting user extension ${V.location.path} with ${j.location.path}.`),!0},ae=new Map;return q?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get(j);(!U||se(U,V,!1))&&ae.set(j,V)}),x?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get(j);if(!U&&q&&V.type===0){this.s.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!U||se(U,V,!1))&&ae.set(j,V)}),M?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),U=ae.get(j);(!U||se(U,V,!0))&&ae.set(j,V),ae.set(j,V)}),[...ae.values()]}async G(q,x){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),Q=await(q&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(q,x){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const X=x?await this.I():{},Q=[],se=u.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of M){const j=X[V.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":Q.push((0,f.joinPath)(se,V.name));break;default:Q.push(u.URI.file(j));break}}const ae=await Promise.all(Q.map(async V=>this.k.scanExtension(await this.J(V,!1,0,!0,q,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ae.length),(0,L.coalesce)(ae)}async I(){try{const q=await this.r.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async J(q,x,M,X,Q,se,ae){const V=await this.f(Q??g.language),j=await this.L(q),U=x&&!this.v.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,$=U?await this.L(U):void 0;return new G(q,j,U,$,x,ae,M,X,se,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,V)}async L(q){try{const x=await this.r.stat(q);if(typeof x.mtime=="number")return x.mtime}catch{}}};z=ye([J(4,y.IUserDataProfilesService),J(5,l.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,n.ILogService),J(8,p.IEnvironmentService),J(9,s.IProductService),J(10,b.IUriIdentityService),J(11,t.IInstantiationService)],z),e.AbstractExtensionsScannerService=z;class G{constructor(q,x,M,X,Q,se,ae,V,j,U,$,H,ee,K,Z){this.location=q,this.mtime=x,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=X,this.profile=Q,this.profileScanOptions=se,this.type=ae,this.excludeObsolete=V,this.validate=j,this.productVersion=U,this.productDate=$,this.productCommit=H,this.devMode=ee,this.language=K,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,x){return(0,f.isEqual)(q.location,x.location)&&q.mtime===x.mtime&&(0,f.isEqual)(q.applicationExtensionslocation,x.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&q.profile===x.profile&&c.equals(q.profileScanOptions,x.profileScanOptions)&&q.type===x.type&&q.excludeObsolete===x.excludeObsolete&&q.validate===x.validate&&q.productVersion===x.productVersion&&q.productDate===x.productDate&&q.productCommit===x.productCommit&&q.devMode===x.devMode&&q.language===x.language&&F.equals(q.translations,x.translations)}}e.ExtensionScannerInput=G;let Y=class extends S.Disposable{constructor(q,x,M,X,Q){super(),this.f=q,this.g=x,this.h=M,this.i=X,this.j=Q}async scanExtensions(q){const x=q.profile?await this.l(q):await this.k(q);let M={};if(q.excludeObsolete&&q.type===1)try{const X=(await this.i.readFile(this.f)).value.toString();M=JSON.parse(X)}catch{}return(0,h.isEmptyObject)(M)?x:x.filter(X=>!M[E.ExtensionKey.create(X).toString()])}async k(q){const x=await this.i.resolve(q.location);if(!x.children?.length)return[];const M=await Promise.all(x.children.map(async X=>{if(!X.isDirectory||q.type===1&&(0,f.basename)(X.resource).indexOf(".")===0)return null;const Q=new G(X.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q)}));return(0,L.coalesce)(M).sort((X,Q)=>X.location.path<Q.location.path?-1:1)}async l(q){let x=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){x=x.filter(X=>!X.metadata?.isApplicationScoped);const M=await this.m(q.applicationExtensionslocation,X=>!!X.metadata?.isApplicationScoped,q);x.push(...M)}return x}async m(q,x,M){const X=await this.g.scanProfileExtensions(q,M.profileScanOptions);if(!X.length)return[];const Q=await Promise.all(X.map(async se=>{if(x(se)){const ae=new G(se.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ae,se.metadata)}return null}));return(0,L.coalesce)(Q)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,f.joinPath)(q.location,"package.json"))){const x=await this.scanExtension(q);return x?[x]:[]}else return await this.scanExtensions(q)}catch(x){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,D.getErrorMessage)(x)),[]}}async scanExtension(q,x){try{let M=await this.scanExtensionManifest(q.location);if(M){M.publisher||(M.publisher=P.UNDEFINED_PUBLISHER),x=x??M.__metadata,delete M.__metadata;const X=(0,E.getGalleryExtensionId)(M.publisher,M.name),Q=x?.id?{id:X,uuid:x.id}:{id:X},se=x?.isSystem?0:q.type,ae=se===0||!!x?.isBuiltin;N.ImplicitActivationEvents.updateManifest(M),M=await this.n(q.location,M,G.createNlsConfiguration(q));const V={type:se,identifier:Q,manifest:M,location:q.location,isBuiltin:ae,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return q.validate?this.validate(V,q):V}}catch(M){q.type!==0&&this.j.error(M)}return null}validate(q,x){let M=!0;const X=(0,i.validateExtensionManifest)(x.productVersion,x.productDate,x.location,q.manifest,q.isBuiltin);for(const[Q,se]of X)Q===v.default.Error&&(M=!1,this.j.error(this.t(x.location,se)));return q.isValid=M,q.validations=X,q}async scanExtensionManifest(q){const x=(0,f.joinPath)(q,"package.json");let M;try{M=(await this.i.readFile(x)).value.toString()}catch(Q){return(0,o.toFileOperationResult)(Q)!==1&&this.j.error(this.t(q,(0,m.localize)(0,null,x.path,Q.message))),null}let X;try{X=JSON.parse(M)}catch{const se=[];(0,R.parse)(M,se);for(const ae of se)this.j.error(this.t(q,(0,m.localize)(1,null,x.path,ae.offset,ae.length,(0,C.getParseErrorMessage)(ae.error))));return null}return(0,R.getNodeType)(X)!=="object"?(this.j.error(this.t(q,(0,m.localize)(2,null,x.path))),null):X}async n(q,x,M){const X=await this.p(q,x,M);if(X)try{const Q=[],se=await this.r(X.default,Q);if(Q.length>0)return Q.forEach(V=>{this.j.error(this.t(q,(0,m.localize)(3,null,X.default?.path,(0,C.getParseErrorMessage)(V.error))))}),x;if((0,R.getNodeType)(X)!=="object")return this.j.error(this.t(q,(0,m.localize)(4,null,X.default?.path))),x;const ae=X.values||Object.create(null);return(0,O.localizeManifest)(x,ae,se)}catch{}return x}async p(q,x,M){const X=(0,f.joinPath)(q,"package.nls.json"),Q=(j,U)=>{U.forEach($=>{this.j.error(this.t(q,(0,m.localize)(5,null,j?.path,(0,C.getParseErrorMessage)($.error))))})},se=j=>{this.j.error(this.t(q,(0,m.localize)(6,null,j?.path)))},ae=`${x.publisher}.${x.name}`,V=M.translations[ae];if(V)try{const j=u.URI.file(V),U=(await this.i.readFile(j)).value.toString(),$=[],H=(0,R.parse)(U,$);return $.length>0?(Q(j,$),{values:void 0,default:X}):(0,R.getNodeType)(H)!=="object"?(se(j),{values:void 0,default:X}):{values:H.contents?H.contents.package:void 0,default:X}}catch{return{values:void 0,default:X}}else{if(!await this.i.exists(X))return;let U;try{U=await this.s(q,M)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const $=(await this.i.readFile(U.localized)).value.toString(),H=[],ee=(0,R.parse)($,H);return H.length>0?(Q(U.localized,H),{values:void 0,default:U.original}):(0,R.getNodeType)(ee)!=="object"?(se(U.localized),{values:void 0,default:U.original}):{values:ee,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(q,x){if(q)try{const M=(await this.i.readFile(q)).value.toString();return(0,R.parse)(M,x)}catch{}}s(q,x){return new Promise((M,X)=>{const Q=se=>{const ae=(0,f.joinPath)(q,`package.nls.${se}.json`);this.i.exists(ae).then(V=>{V&&M({localized:ae,original:(0,f.joinPath)(q,"package.nls.json")});const j=se.lastIndexOf("-");j===-1?M({localized:(0,f.joinPath)(q,"package.nls.json"),original:null}):(se=se.substring(0,j),Q(se))})};if(x.devMode||x.pseudo||!x.language)return M({localized:(0,f.joinPath)(q,"package.nls.json"),original:null});Q(x.language)})}t(q,x){return`[${q.path}]: ${x}`}};Y=ye([J(1,l.IExtensionsProfileScannerService),J(2,b.IUriIdentityService),J(3,o.IFileService),J(4,n.ILogService)],Y);let W=class extends Y{constructor(q,x,M,X,Q,se){super(x,M,X,Q,se),this.y=q,this.v=this.B(new A.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(q){const x=await this.z();if(this.u=q,x&&x.input&&G.equals(x.input,this.u))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.v.trigger(()=>this.D()),x.result.map(X=>(X.location=u.URI.revive(X.location),X));const M=await super.scanExtensions(q);return await this.C({input:q,result:M}),M}async z(){try{const q=await this.i.readFile(this.y),x=JSON.parse(q.value.toString());return{result:x.result,input:(0,r.revive)(x.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(q))}return null}async C(q){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify(q)))}catch(x){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(x))}}async D(){if(!this.u)return;const q=await this.z();if(!q)return;const x=q.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!c.equals(M,x))try{await this.i.del(this.y),this.w.fire()}catch(X){this.j.error(X)}}};W=ye([J(2,l.IExtensionsProfileScannerService),J(3,b.IUriIdentityService),J(4,o.IFileService),J(5,n.ILogService)],W);function T(_,q){const x=(0,E.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:x,identifier:new P.ExtensionIdentifier(x),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:q,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=T;class B extends z{constructor(q,x,M,X,Q,se,ae,V,j,U,$,H){super(q,x,(0,f.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(X,P.MANIFEST_CACHE_FOLDER),Q,se,ae,V,j,U,$,H),this.M=(async()=>{if(g.translationsConfigFile)try{const ee=await this.r.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(q){return this.M}}e.NativeExtensionsScannerService=B}),define(re[269],oe([0,1,50,6,38,3,2,22,13,28,11,18]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends D.Disposable{constructor(d,v){super(),this.b=d,this.f=v,this.a=new A.Limiter(5)}async postUninstall(d){const v=this.g(d,"uninstall");v&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(h){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(h)}}));try{await S.Promises.rm(this.j(d))}catch(h){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(h)}}g(d,v){const h=`vscode:${v}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[h]=="string"){const u=d.manifest.scripts[h].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${h} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,v,h,u,m){return new Promise((p,E)=>{const P=this.i(d,v,h,m);let i;const o=t=>{i&&(clearTimeout(i),i=null),t?E(t):p(void 0)};P.on("error",t=>{o((0,c.toErrorMessage)(t)||"Unknown")}),P.on("exit",(t,n)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),u&&(i=setTimeout(()=>{i=null,P.kill(),E("timed out")},5e3))})}i(d,v,h,u){const m={silent:!0,execArgv:void 0},p=(0,L.fork)(d,[`--type=extension-post-${v}`,...h],m);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const E=k.Event.fromNodeEventEmitter(p.stdout,"data"),P=k.Event.fromNodeEventEmitter(p.stderr,"data");E(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${v}`,t)),P(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${v}`,t));const i=k.Event.any(k.Event.map(E,t=>({data:`%c${t}`,format:[""]})),k.Event.map(P,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(d){return(0,C.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};g=ye([J(0,w.IUserDataProfilesService),J(1,I.ILogService)],g),e.ExtensionsLifecycle=g}),define(re[270],oe([0,1,11,18,30,19,51,14,15,10]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends D.AbstractExtensionsProfileScannerService{constructor(g,f,d,v,h,u){super(S.URI.file(g.extensionsPath),f,d,v,h,u)}};I=ye([J(0,C.INativeEnvironmentService),J(1,R.IFileService),J(2,A.IUserDataProfilesService),J(3,c.IUriIdentityService),J(4,k.ITelemetryService),J(5,L.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(re[271],oe([0,1,10,15,51,77,14,5,11,26,30,18]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends k.NativeExtensionsScannerService{constructor(d,v,h,u,m,p,E,P){super(L.URI.file(m.builtinExtensionsPath),L.URI.file(m.extensionsPath),m.userHome,L.URI.file(m.userDataPath),d,v,h,u,m,p,E,P)}};g=ye([J(0,w.IUserDataProfilesService),J(1,c.IExtensionsProfileScannerService),J(2,D.IFileService),J(3,C.ILogService),J(4,A.INativeEnvironmentService),J(5,S.IProductService),J(6,I.IUriIdentityService),J(7,R.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(re[20],oe([0,1,6,3,2,103,12,66,5,18]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var I;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function f(m){const p=m.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=f;class d extends c.Disposable{constructor(p={flushInterval:d.a}){super(),this.j=p,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new c.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,c.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,E){if(E===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:E,target:this.F(p)[E]})}r(p){this.f.fire({reason:p})}get(p,E,P){return this.L(E)?.get(p,P)}getBoolean(p,E,P){return this.L(E)?.getBoolean(p,P)}getNumber(p,E,P){return this.L(E)?.getNumber(p,P)}store(p,E,P,i){if((0,D.isUndefinedOrNull)(E)){this.remove(p,P);return}this.t(()=>{this.u(p,P,i),this.L(P)?.set(p,E)})}remove(p,E){this.t(()=>{this.u(p,E,void 0),this.L(E)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,E){const P=[],i=this.F(p);for(const o of Object.keys(i))i[o]===E&&P.push(o);return P}u(p,E,P){const i=this.F(E);typeof P=="number"?i[p]!==P&&(i[p]=P,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[p]=="number"&&(delete i[p],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const E=this.L(p);return E?f(E):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=I.NONE){this.f.fire({reason:p});const E=this.L(-1),P=this.L(0),i=this.L(1);switch(p){case I.NONE:await L.Promises.settled([E?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await L.Promises.settled([E?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,P=this.L(1)?.items??new Map;return u(p,E,P,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,E){return this.r(I.NONE),(0,S.isUserDataProfile)(p)?this.N(p,E):this.O(p,E)}H(p,E){return!(p.id===E.id||v(E)&&v(p))}I(p,E,P,i){this.t(()=>{if(i)for(const[o,t]of p)E.set(o,t);else{const o=new Set;for(const[t,n]of p)o.add(t),E.get(t)!==n&&this.n(P,t);for(const[t]of E.items)o.has(t)||this.n(P,t)}})}}d.a=60*1e3,e.AbstractStorageService=d;function v(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class h extends d{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=h;async function u(m,p,E,P,i,o){const t=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,s=new Map;m.forEach((N,F)=>{n.set(F,N),s.set(F,t(N))});const a=new Map,r=new Map;p.forEach((N,F)=>{a.set(F,N),r.set(F,t(N))});const l=new Map,y=new Map;E.forEach((N,F)=>{l.set(F,N),y.set(F,t(N))}),console.group(P!==i?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const b=[];if(n.forEach((N,F)=>{b.push({key:F,value:N})}),console.table(b),console.groupEnd(),console.log(s),P!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const N=[];a.forEach((F,z)=>{N.push({key:z,value:F})}),console.table(N),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${o})`);const O=[];l.forEach((N,F)=>{O.push({key:F,value:N})}),console.table(O),console.groupEnd(),console.log(y)}e.logStorage=u}),define(re[119],oe([0,1,3,2,12,29,33,20]),function(te,e,L,A,c,k,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends A.Disposable{constructor(w,g){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(w)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(g.onDidInstallExtensions(f=>f.forEach(({local:d,operation:v})=>{d&&v===4&&this.f(d.identifier)})))}async enableExtension(w,g){return this.f(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}async disableExtension(w,g){return this.c(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}getDisabledExtensions(){return this.h(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(w){const g=this.getDisabledExtensions();return g.every(f=>!(0,D.areSameExtensions)(f,w))?(g.push(w),this.g(g),!0):!1}f(w){const g=this.getDisabledExtensions();for(let f=0;f<g.length;f++){const d=g[f];if((0,D.areSameExtensions)(d,w))return g.splice(f,1),this.g(g),!0}return!1}g(w){this.i(k.DISABLED_EXTENSIONS_STORAGE_PATH,w)}h(w){return this.b.get(w,0)}i(w,g){this.b.set(w,g,0)}};C=ye([J(0,R.IStorageService),J(1,k.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class S extends A.Disposable{constructor(w){super(),this.c=w,this.a=Object.create(null),this.b=this.B(new L.Emitter),this.onDidChange=this.b.event,this.B(w.onDidChangeValue(g=>this.f(g)))}get(w,g){let f;return g===0?((0,c.isUndefinedOrNull)(this.a[w])&&(this.a[w]=this.g(w,g)),f=this.a[w]):f=this.g(w,g),JSON.parse(f)}set(w,g,f){const d=JSON.stringify(g.map(({id:h,uuid:u})=>({id:h,uuid:u})));this.g(w,f)!==d&&(f===0&&(g.length?this.a[w]=d:delete this.a[w]),this.h(w,g.length?d:void 0,f))}f(w){if(w.scope===0&&!(0,c.isUndefinedOrNull)(this.a[w.key])&&this.g(w.key,w.scope)!==this.a[w.key]){const f=this.get(w.key,w.scope);delete this.a[w.key];const d=this.get(w.key,w.scope),v=f.filter(u=>!d.some(m=>(0,D.areSameExtensions)(u,m))),h=d.filter(u=>!f.some(m=>(0,D.areSameExtensions)(m,u)));(v.length||h.length)&&this.b.fire([...v,...h])}}g(w,g){return this.c.get(w,g,"[]")}h(w,g,f){g?this.c.store(w,g,f,1):this.c.remove(w,f)}}e.StorageManager=S}),define(re[272],oe([0,1,21,24,8,4,36,12,10,17,15,29,33,67,14,11,26,58,239,20,19]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const P=k.isWeb?"web":(0,w.getTargetPlatform)(k.platform,D.arch),i="X-Market-Search-Activity-Id";var o;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function t(...j){return String(j.reduce((U,$)=>U|$,0))}var n;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class y{constructor(U=l){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,$=this.d.pageSize){return new y({...this.d,pageNumber:U,pageSize:$})}withFilter(U,...$){const H=[...this.d.criteria,...$.length?$.map(ee=>({filterType:U,value:ee})):[{filterType:U}]];return new y({...this.d,criteria:H})}withSortBy(U){return new y({...this.d,sortBy:U})}withSortOrder(U){return new y({...this.d,sortOrder:U})}withFlags(...U){return new y({...this.d,flags:U.reduce(($,H)=>$|H,0)})}withAssetTypes(...U){return new y({...this.d,assetTypes:U})}withSource(U){return new y({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:$,pageSize:H,sortBy:ee,sortOrder:K,flags:Z,assetTypes:ie}=this.d;return{filters:[{criteria:U,pageNumber:$,pageSize:H,sortBy:ee,sortOrder:K}],assetTypes:ie,flags:Z}}get searchText(){const U=this.d.criteria.filter($=>$.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(j,U){const $=(j||[]).filter(H=>H.statisticName===U)[0];return $?$.value:0}function O(j){const U="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(H=>H.assetType.indexOf(U)===0).reduce((H,ee)=>{const K=z(j,ee.assetType);return K&&H.push([ee.assetType.substring(U.length),K]),H},[])}function N(j){if(j.properties){const U=j.properties.filter(ee=>ee.key===s.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=U.filter(ee=>$.test(ee.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return z(j,s.Repository)}function F(j){return{uri:`${j.fallbackAssetUri}/${s.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${s.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function z(j,U){return j.files.filter(H=>H.assetType===U)[0]?{uri:`${j.assetUri}/${U}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${U}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function G(j,U){const $=j.properties?j.properties.filter(ee=>ee.key===U):[],H=$.length>0&&$[0].value;return H?H.split(",").map(ee=>(0,g.adoptToGalleryExtensionId)(ee)):[]}function Y(j){const U=j.properties?j.properties.filter($=>$.key===a.Engine):[];return U.length>0&&U[0].value||""}function W(j){const U=j.properties?j.properties.filter($=>$.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function T(j){const U=j.properties?j.properties.filter(H=>H.key===a.LocalizedLanguages):[],$=U.length>0&&U[0].value||"";return $?$.split(","):[]}function B(j){return j.properties?.find(U=>U.key===a.SponsorLink)?.value}function _(j){return j.indexOf("preview")!==-1}function q(j){return j.targetPlatform?(0,w.toTargetPlatform)(j.targetPlatform):"undefined"}function x(j){const U=(0,L.distinct)(j.versions.map(q)),$=!!j.tags?.includes(w.WEB_EXTENSION_TAG),H=U.indexOf("web");return $?H===-1&&U.push("web"):H!==-1&&U.splice(H,1),U}function M(j,U){const $=(0,w.getFallbackTargetPlarforms)(U);for(let H=0;H<j.length;H++){const ee=j[H];if(ee.version===j[H-1]?.version){let K=H;const Z=q(ee);if(Z===U)for(;K>0&&j[K-1].version===ee.version;)K--;else if($.includes(Z))for(;K>0&&j[K-1].version===ee.version&&q(j[K-1])!==U;)K--;K!==H&&(j.splice(H,1),j.splice(K,0,ee))}}return j}e.sortExtensionVersions=M;function X(j,U,$){j.telemetryData={index:U,querySource:$,queryActivityId:j.queryContext?.[i]}}function Q(j,U,$,H){const ee=j.versions[0],K={manifest:z(U,s.Manifest),readme:z(U,s.Details),changelog:z(U,s.Changelog),license:z(U,s.License),repository:N(U),download:F(U),icon:z(U,s.Icon),signature:z(U,s.Signature),coreTranslations:O(U)};return{identifier:{id:(0,g.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:U.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ee),description:j.shortDescription||"",installCount:b(j.statistics,"install"),rating:b(j.statistics,"averagerating"),ratingCount:b(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:$,assets:K,properties:{dependencies:G(U,a.Dependency),extensionPack:G(U,a.ExtensionPack),engine:Y(U),localizedLanguages:T(U),targetPlatform:q(U),isPreReleaseVersion:W(U)},hasPreReleaseVersion:W(ee),hasReleaseVersion:!0,preview:_(j.flags),isSigned:!!K.signature,queryContext:H}}let se=class{constructor(U,$,H,ee,K,Z,ie,le){this.k=$,this.l=H,this.n=ee,this.o=K,this.q=Z,this.u=ie,this.w=le;const he=ie.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=me?he.servicePPEUrl:he?.serviceUrl,this.g=me?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(ie.version,ie,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,$,H){const ee=A.CancellationToken.isCancellationToken($)?{}:$,K=A.CancellationToken.isCancellationToken($)?$:H,Z=[],ie=[],le=[],he=[];let me=!0;for(const Ee of U){Ee.uuid?ie.push(Ee.uuid):Z.push(Ee.id);const ke=!!(Ee.version||Ee.preRelease);le.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:ke}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),me=me&&!!Ee.hasPreRelease&&!ke}if(!ie.length&&!Z.length)return[];let pe=new y().withPage(1,U.length);ie.length&&(pe=pe.withFilter(n.ExtensionId,...ie)),Z.length&&(pe=pe.withFilter(n.ExtensionName,...Z)),(ee.queryAllVersions||me)&&(pe=pe.withFlags(pe.flags,o.IncludeVersions)),ee.source&&(pe=pe.withSource(ee.source));const{extensions:we}=await this.z(pe,{targetPlatform:ee.targetPlatform??P,includePreRelease:le,versions:he,compatible:!!ee.compatible},K);return ee.source&&we.forEach((Ee,ke)=>X(Ee,ke,ee.source)),we}async getCompatibleExtension(U,$,H){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(U,$,H))return U;const ee=new y().withFlags(o.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:K}=await this.z(ee,{targetPlatform:H,compatible:!0,includePreRelease:$},A.CancellationToken.None);return K[0]||null}async isExtensionCompatible(U,$,H){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,H)||!$&&U.properties.isPreReleaseVersion)return!1;let ee=U.properties.engine;if(!ee){const K=await this.getManifest(U,A.CancellationToken.None);if(!K)throw new Error("Manifest was not found");ee=K.engines.vscode}return(0,f.isEngineValid)(ee,this.u.version,this.u.date)}async y(U,$,H,ee,K){if(!(0,w.isTargetPlatformCompatible)(q(U),ee,K)||$!=="any"&&W(U)!==($==="prerelease"))return!1;if(H)try{const Z=await this.E(U);if(!(0,f.isEngineValid)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,c.getErrorMessage)(Z)),!1}return!0}async query(U,$){let H=U.text||"";const ee=U.pageSize??50;let K=new y().withPage(1,ee);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,we)=>(K=K.withFilter(n.Category,we||pe),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,we)=>(K=K.withFilter(n.Tag,we||pe),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(n.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),K=K.withFilter(n.SearchText,H)),K=K.withSortBy(0)):U.ids?K=K.withFilter(n.ExtensionId,...U.ids):U.names?K=K.withFilter(n.ExtensionName,...U.names):K=K.withSortBy(4),typeof U.sortBy=="number"&&(K=K.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(K=K.withSortOrder(U.sortOrder)),U.source&&(K=K.withSource(U.source));const Z=async(me,pe)=>{const{extensions:we,total:Ee}=await this.z(me,{targetPlatform:P,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return we.forEach((ke,De)=>X(ke,(me.pageNumber-1)*me.pageSize+De,U.source)),{extensions:we,total:Ee}},{extensions:ie,total:le}=await Z(K,$),he=async(me,pe)=>{if(pe.isCancellationRequested)throw new c.CancellationError;const{extensions:we}=await Z(K.withPage(me+1),pe);return we};return{firstPage:ie,total:le,pageSize:K.pageSize,getPage:he}}async z(U,$,H){const ee=U.flags;!!(U.flags&o.IncludeLatestVersionOnly)&&!!(U.flags&o.IncludeVersions)&&(U=U.withFlags(U.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(U.flags&o.IncludeLatestVersionOnly)&&!(U.flags&o.IncludeVersions)&&(U=U.withFlags(U.flags,o.IncludeLatestVersionOnly)),$.versions?.length&&(U=U.withFlags(U.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),U=U.withFlags(U.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:K,total:Z,context:ie}=await this.B(U,H);if(!(U.flags&o.IncludeLatestVersionOnly)){const pe=[];for(const we of K){const Ee=await this.A(we,$,ie);Ee&&pe.push(Ee)}return{extensions:pe,total:Z}}const he=[],me=new Map;for(let pe=0;pe<K.length;pe++){const we=K[pe],Ee={id:(0,g.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},ke=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(qe=>(0,g.areSameExtensions)(qe,Ee))?.includePreRelease;if($.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(x(we),$.targetPlatform))continue;const De=await this.A(we,$,ie);!De||De.properties.isPreReleaseVersion&&(!ke||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==$.targetPlatform&&De.hasPreReleaseVersion?me.set(we.extensionId,pe):he.push([pe,De])}if(me.size){const pe=new Date().getTime(),we=new y().withFlags(ee&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:Ee}=await this.z(we,$,H);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const ke of Ee){const De=me.get(ke.identifier.uuid);he.push([De,ke])}}return{extensions:he.sort((pe,we)=>pe[0]-we[0]).map(([,pe])=>pe),total:Z}}async A(U,$,H){const ee={id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},K=$.versions?.find(he=>(0,g.areSameExtensions)(he,ee))?.version,Z=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(he=>(0,g.areSameExtensions)(he,ee))?.includePreRelease,ie=x(U),le=M(U.versions,$.targetPlatform);if($.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ie,$.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(K&&me.version!==K)){if(await this.y(me,Z?"any":"release",$.compatible,ie,$.targetPlatform))return Q(U,me,ie,H);if(K&&me.version===K)return null}}return K||$.compatible?null:Q(U,U.versions[0],ie)}async B(U,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,o.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,t(o.Unpublished));const H=await this.j,ee=JSON.stringify(U.raw),K={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ie,le,he=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&U.criteria.some(pe=>pe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:K},$),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(ie);if(me){const pe=me.results[0],we=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[i]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:le?(0,c.isCancellationError)(le)?"canceled":(0,c.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,$,H,ee){if(!this.isEnabled())return;const K=k.isWeb?this.x(`/itemName/${U}.${$}/version/${H}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${$}/${H}/stats?statType=${ee}`),Z=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:K,headers:le},A.CancellationToken.None)}catch{}}async download(U,$,H){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const ee=(0,g.getGalleryExtensionTelemetryData)(U),K=new Date().getTime(),Z=pe=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:pe}),ie=H===2?"install":H===3?"update":"",le=ie?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:U.assets.download,he=U.queryContext?.[i]?{[i]:U.queryContext[i]}:void 0,me=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile($,me.stream),Z(new Date().getTime()-K)}async downloadSignatureArchive(U,$){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const H=await this.D(U.assets.signature);await this.q.writeFile($,H.stream)}async getReadme(U,$){if(U.assets.readme){const H=await this.D(U.assets.readme,{},$);return await(0,u.asTextOrError)(H)||""}return""}async getManifest(U,$){if(U.assets.manifest){const H=await this.D(U.assets.manifest,{},$),ee=await(0,u.asTextOrError)(H);return ee?JSON.parse(ee):null}return null}async C(U,$){const H=z(U,s.Manifest);if(!H)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},K=await this.D(H,{headers:ee});return await(0,u.asJson)(K)}async getCoreTranslation(U,$){const H=U.assets.coreTranslations.filter(ee=>ee[0]===$.toUpperCase())[0];if(H){const ee=await this.D(H[1]),K=await(0,u.asTextOrError)(ee);return K?JSON.parse(K):null}return null}async getChangelog(U,$){if(U.assets.changelog){const H=await this.D(U.assets.changelog,{},$);return await(0,u.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(U,$,H){let ee=new y().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ee=ee.withFilter(n.ExtensionId,U.identifier.uuid):ee=ee.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:K}=await this.B(ee,A.CancellationToken.None);if(!K.length)return[];const Z=x(K[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Z,H))return[];const ie=[];await Promise.all(K[0].versions.map(async me=>{try{await this.y(me,$?"any":"release",!0,Z,H)&&ie.push(me)}catch{}}));const le=[],he=new Set;for(const me of M(ie,H))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:W(me)}));return le}async D(U,$={},H=A.CancellationToken.None){const ee=await this.j,K={type:"GET"},Z={...ee,...$.headers||{}};$={...$,...K,headers:Z};const ie=U.uri,le=U.fallbackUri,he={...$,url:ie};try{const me=await this.k.request(he,H);if(me.res.statusCode===200)return me;const pe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,c.isCancellationError)(me))throw me;const pe=(0,c.getErrorMessage)(me);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:pe});const we={...$,url:le};return this.k.request(we,H)}}async E(U){let $=Y(U);if(!$){const H=await this.C(U,A.CancellationToken.None);if(!H)throw new Error("Manifest was not found");$=H.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,u.asJson)(U),H=[],ee={};if($){for(const K of $.malicious)H.push({id:K});if($.migrateToPreRelease)for(const[K,Z]of Object.entries($.migrateToPreRelease))(!Z.engine||(0,f.isEngineValid)(Z.engine,this.u.version,this.u.date))&&(ee[K.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if($.deprecated)for(const[K,Z]of Object.entries($.deprecated))Z&&(ee[K.toLowerCase()]=(0,R.isBoolean)(Z)?{}:Z)}return{malicious:H,deprecated:ee}}};se=ye([J(1,u.IRequestService),J(2,v.ILogService),J(3,I.IEnvironmentService),J(4,E.ITelemetryService),J(5,d.IFileService),J(6,h.IProductService),J(7,S.IConfigurationService)],se);let ae=class extends se{constructor(U,$,H,ee,K,Z,ie,le){super(U,$,H,ee,K,Z,ie,le)}};ae=ye([J(0,p.IStorageService),J(1,u.IRequestService),J(2,v.ILogService),J(3,I.IEnvironmentService),J(4,E.ITelemetryService),J(5,d.IFileService),J(6,h.IProductService),J(7,S.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let V=class extends se{constructor(U,$,H,ee,K,Z,ie){super(void 0,U,$,H,ee,K,Z,ie)}};V=ye([J(0,u.IRequestService),J(1,v.ILogService),J(2,I.IEnvironmentService),J(3,E.ITelemetryService),J(4,d.IFileService),J(5,h.IProductService),J(6,S.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(re[78],oe([0,1,5,3,2,20,33,26,21,11,12]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class Xe extends c.Disposable{static b(d){return`extensionKeys/${(0,D.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const v=w.exec(d);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(d,v){const h=await d.getInstalled(),u=[];for(const[m,p]of Xe.f(v)){const E=h.find(P=>(0,D.areSameExtensions)(P.identifier,{id:m}))?.manifest.version;for(const P of p)E!==P&&u.push(Xe.b({id:m,version:P}))}for(const m of u)v.remove(m,0)}static f(d){const v=new Map,h=d.keys(0,1);for(const u of h){const m=Xe.c(u);if(m){let p=v.get(m.id.toLowerCase());p||v.set(m.id.toLowerCase(),p=[]),p.push(m.version)}}return v}constructor(d,v,h){super(),this.i=d,this.j=v,this.k=h,this.g=this.B(new A.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(d),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const v=Xe.c(d.key);if(v){if(this.i.get(d.key,0)===void 0)this.h.delete(v.id.toLowerCase());else{let h=this.h.get(v.id.toLowerCase());h||this.h.set(v.id.toLowerCase(),h=[]),h.push(v.version),this.g.fire()}return}}m(d){if((0,I.isString)(d))return d;const v=d.manifest?d.manifest.publisher:d.publisher,h=d.manifest?d.manifest.name:d.name;return(0,D.getExtensionId)(v,h)}getExtensionState(d,v){const h=this.m(d),u=this.getExtensionStateRaw(d,v);if(u)try{return JSON.parse(u)}catch(m){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${v}): ${m}`)}}getExtensionStateRaw(d,v){const h=this.m(d),u=this.i.get(h,v?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${v}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(d,v,h){const u=this.m(d);v===void 0?this.i.remove(u,h?0:1):this.i.store(u,JSON.stringify(v),h?0:1,1)}setKeysForSync(d,v){this.i.store(Xe.b(d),JSON.stringify(v),0,1)}getKeysForSync(d){const v=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.i.get(Xe.b(d),0),u=h?JSON.parse(h):void 0;return u&&v?(0,C.distinct)([...u,...v]):u||v}addToMigrationList(d,v){if(d!==v){const h=this.n.filter(u=>!u.includes(d)&&!u.includes(v));h.push([d,v]),this.n=h}}getSourceExtensionToMigrate(d){const v=this.n.find(([,h])=>d===h);return v?v[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(d);if(Array.isArray(v))return v}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};g.a=512*1024,g=ye([J(0,k.IStorageService),J(1,R.IProductService),J(2,S.ILogService)],g),e.ExtensionStorageService=g}),define(re[273],oe([0,1,29,14,26,15,100,56,20,19,236]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends I.AbstractNativeExtensionTipsService{constructor(f,d,v,h,u,m,p,E){super(f.userHome,u,d,v,h,m,p,E)}};w=ye([J(0,k.INativeEnvironmentService),J(1,S.ITelemetryService),J(2,L.IExtensionManagementService),J(3,C.IStorageService),J(4,R.INativeHostService),J(5,D.IExtensionRecommendationNotificationService),J(6,A.IFileService),J(7,c.IProductService)],w),e.ExtensionTipsService=w}),define(re[274],oe([0,1,6,2,25,66,20,74,18]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class S extends D.AbstractStorageService{constructor(w,g,f,d){super(),this.X=w,this.Y=g,this.Z=f,this.ab=d,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new A.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new A.DisposableStore),this.W=this.db(this.X)}bb(){const w=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),g=this.B(new k.Storage(w));return this.B(g.onDidChangeStorage(f=>this.n(-1,f))),g}cb(w){this.Q.clear(),this.P=w;let g;if((0,D.isProfileUsingDefaultStorage)(w))g=this.s;else{const f=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.Q.add(new k.Storage(f))}return this.Q.add(g.onDidChangeStorage(f=>this.n(0,f))),g}db(w){this.U.clear(),this.S=w?.id;let g;if(w){const f=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.U.add(new k.Storage(f)),this.U.add(g.onDidChangeStorage(d=>this.n(1,d)))}return g}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(w){switch(w){case-1:return this.s;case 0:return this.R;default:return this.W}}M(w){switch(w){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,c.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(D.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(w,g){if(!this.H(this.P,w))return;const f=this.R,d=f.items;f!==this.s&&await f.close(),this.R=this.cb(w),await this.R.init(),this.I(d,this.R,0,g)}async O(w,g){const f=this.W,d=f?.items??new Map;await f?.close(),this.W=this.db(w),await this.W.init(),this.I(d,this.W,1,g)}hasScope(w){return(0,C.isUserDataProfile)(w)?this.P.id===w.id:this.S===w.id}}e.RemoteStorageService=S}),define(re[275],oe([0,1,3,2,18,92]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class D{constructor(S,I){this.a=S,this.b=I}listen(S,I){const w=this.b(S);switch(I){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(f=>(0,k.transformOutgoingURIs)({...f},w)),added:g.added.map(f=>(0,k.transformOutgoingURIs)({...f},w)),removed:g.removed.map(f=>(0,k.transformOutgoingURIs)({...f},w)),updated:g.updated.map(f=>(0,k.transformOutgoingURIs)({...f},w))}))}throw new Error(`Invalid listen ${I}`)}async call(S,I,w){const g=this.b(S);switch(I){case"createProfile":{const f=await this.a.createProfile(w[0],w[1],w[2]);return(0,k.transformOutgoingURIs)({...f},g)}case"updateProfile":{let f=(0,c.reviveProfile)((0,k.transformIncomingURIs)(w[0],g),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,w[1]),(0,k.transformOutgoingURIs)({...f},g)}case"removeProfile":{const f=(0,c.reviveProfile)((0,k.transformIncomingURIs)(w[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=D;class R extends A.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(S,I,w){super(),this.profilesHome=I,this.f=w,this.a=[],this.b=this.B(new L.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=S.map(g=>(0,c.reviveProfile)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const f=g.added.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),d=g.removed.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),v=g.updated.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme));this.a=g.all.map(h=>(0,c.reviveProfile)(h,this.profilesHome.scheme)),this.b.fire({added:f,removed:d,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(S){this.c=S}isEnabled(){return this.c}async createNamedProfile(S,I,w){const g=await this.f.call("createNamedProfile",[S,I,w]);return(0,c.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(S,I,w,g){const f=await this.f.call("createProfile",[S,I,w,g]);return(0,c.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(S){const I=await this.f.call("createTransientProfile",[S]);return(0,c.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(S,I){await this.f.call("setProfileForWorkspace",[S,I])}removeProfile(S){return this.f.call("removeProfile",[S])}async updateProfile(S,I){const w=await this.f.call("updateProfile",[S,I]);return(0,c.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(re[60],oe([0,1,2,66,5,20,3,74,18]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,c.createDecorator)("IUserDataProfileStorageService");let S=class extends L.Disposable{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async d=>this.b(d))}async updateStorageData(f,d,v){return this.withProfileScopedStorageService(f,async h=>this.c(h,d,v))}async withProfileScopedStorageService(f,d){if(this.a.hasScope(f))return d(this.a);const v=await this.g(f),h=new w(v);try{await h.initialize();const u=await d(h);return await h.flush(),u}finally{h.dispose(),await this.f(v)}}b(f){const d=new Map,v=h=>{for(const u of f.keys(0,h))d.set(u,{value:f.get(u,0),target:h})};return v(0),v(1),d}c(f,d,v){for(const[h,u]of d)f.store(h,u,0,v)}async f(f){try{await f.close()}finally{(0,L.isDisposable)(f)&&f.dispose()}}};S=ye([J(0,k.IStorageService)],S),e.AbstractUserDataProfileStorageService=S;class I extends S{constructor(f,d,v,h){super(v),this.i=f;const u=f.getChannel("profileStorageListener"),m=this.B(new L.MutableDisposable);this.h=this.B(new D.Emitter({onWillAddFirstListener:()=>{m.value=u.listen("onDidChange")(p=>{h.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(E=>(0,C.reviveProfile)(E,d.profilesHome.scheme)),valueChanges:p.valueChanges.map(E=>({...E,profile:(0,C.reviveProfile)(E.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>m.value=void 0})),this.onDidChange=this.h.event}async g(f){const d=this.i.getChannel("storage");return(0,k.isProfileUsingDefaultStorage)(f)?new R.ApplicationStorageDatabaseClient(d):new R.ProfileStorageDatabaseClient(d,f)}}e.RemoteUserDataProfileStorageService=I;class w extends k.AbstractStorageService{constructor(f){super({flushInterval:100}),this.p=this.B(new A.Storage(f))}J(){return this.p.init()}L(f){return f===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[276],oe([0,1,20,11,18,70,60]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends D.RemoteUserDataProfileStorageService{constructor(S,I,w,g){super(S,I,w,g)}};R=ye([J(0,k.IMainProcessService),J(1,c.IUserDataProfilesService),J(2,L.IStorageService),J(3,A.ILogService)],R),e.NativeUserDataProfileStorageService=R}),define(re[41],oe([0,1,21,6,16,24,3,35,2,27,12,179,17,15,14,11,44,20,19,30,23,18]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(l){return!!(l&&l.ref!==void 0&&typeof l.ref=="string"&&l.ref!==""&&l.syncData!==void 0&&(l.syncData===null||o(l.syncData)))}e.isRemoteUserData=i;function o(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=o;function t(l,y){return`${(0,S.uppercaseFirstLetter)(l)}${y.isDefault?"":` (${y.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends C.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(y,b,O,N,F,z,G,Y,W,T,B,_){super(),this.syncResource=y,this.collection=b,this.C=O,this.D=N,this.F=F,this.G=z,this.H=G,this.I=Y,this.J=W,this.L=T,this.M=B,this.c=null,this.k="idle",this.l=this.B(new D.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new D.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new A.ThrottledDelayer(50),this.t=this.B(new D.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(y.syncResource,y.profile),this.h=_.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,E.getPathSegments)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,E.PREVIEW_DIR_NAME),this.u=(0,E.getLastSyncResourceUri)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,N,this.h),this.j=(0,h.getServiceMachineId)(N,O,F)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const b=await this.U(y.remoteUserData,y.lastSyncUserData,!0,this.mb());this.P(b)}else{this.L.trace(`${this.y}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.sb(y):!0)&&this.t.fire()}}P(y){this.k!==y&&(this.k=y,this.l.fire(y))}async sync(y,b={}){await this.Q(y,!0,this.mb(),b)}async preview(y,b,O={}){return this.Q(y,!1,b,O)}async apply(y,b={}){try{this.z={...b};const O=await this.Y(y);return this.P(O),this.c}finally{this.z={}}}async Q(y,b,O,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let F="idle";try{const z=await this.getLastSyncUserData(),G=await this.S(y,z);return F=await this.U(G,z,b,O),F==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(F)}}finally{this.z={}}}async replace(y){const b=this.ib(y);if(!b)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const O=await this.getLastSyncUserData(),N=await this.S(null,O),F=await this.R(N),z=await this.ob({ref:N.ref,syncData:b},O,F,this.mb(),k.CancellationToken.None),G=[];for(const Y of z){const W=await this.qb(Y,Y.remoteResource,void 0,k.CancellationToken.None),{remoteChange:T}=await this.qb(Y,Y.previewResource,Y.remoteContent,k.CancellationToken.None);G.push([Y,{...W,remoteChange:T!==0?T:2}])}await this.rb(N,O,G,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(y){const b=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===b}async S(y,b){if(b){const O=y?y[this.resource]:void 0;if(b.ref===O||O===void 0&&b.syncData===null)return b}return this.getRemoteUserData(b)}async U(y,b,O,N){if(y.syncData&&y.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new E.UserDataSyncError((0,w.localize)(0,null,this.resource,this.nb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(y,b,O,N)}catch(F){if(F instanceof E.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(y,b,O,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),b=await this.getLastSyncUserData(),this.U(y,b,O,N)}throw F}}async W(y,b,O,N){try{const F=await this.R(y),z=!F&&b===null&&this.eb()!==void 0,G=O&&!z;this.c||(this.c=(0,A.createCancelablePromise)(W=>this.cb(y,b,F,G,N,W)));let Y=await this.c;if(O&&z){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const W of Y.resourcePreviews)Y=await this.accept(W.remoteResource)||Y}return this.ab(Y.resourcePreviews),Y.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":O?await this.Y(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(y){return await this.X(y,async b=>{const O=await this.pb(b,k.CancellationToken.None);await this.C.writeFile(b.previewResource,c.VSBuffer.fromString(O?.content||""));const N=O&&!O.hasConflicts?await this.qb(b,b.previewResource,void 0,k.CancellationToken.None):void 0;return b.acceptResult=N,b.mergeState=O.hasConflicts?"conflict":N?"accepted":"preview",b.localChange=N?N.localChange:O.localChange,b.remoteChange=N?N.remoteChange:O.remoteChange,b}),this.c}async accept(y,b){return await this.X(y,async O=>{const N=await this.qb(O,y,b,k.CancellationToken.None);return O.acceptResult=N,O.mergeState="accepted",O.localChange=N.localChange,O.remoteChange=N.remoteChange,O}),this.c}async discard(y){return await this.X(y,async b=>{const O=await this.pb(b,k.CancellationToken.None);return await this.C.writeFile(b.previewResource,c.VSBuffer.fromString(O.content||"")),b.acceptResult=void 0,b.mergeState="preview",b.localChange=O.localChange,b.remoteChange=O.remoteChange,b}),this.c}async X(y,b){if(!this.c)return;let O=await this.c;const N=O.resourcePreviews.findIndex(({localResource:F,remoteResource:z,previewResource:G})=>this.h.isEqual(F,y)||this.h.isEqual(z,y)||this.h.isEqual(G,y));N!==-1&&(this.c=(0,A.createCancelablePromise)(async F=>{const z=[...O.resourcePreviews];return z[N]=await b(z[N]),{...O,resourcePreviews:z}}),O=await this.c,this.ab(O.resourcePreviews),O.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(y){if(!this.c)return"idle";const b=await this.c;return b.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":b.resourcePreviews.some(({mergeState:O})=>O!=="accepted")?"syncing":(await this.rb(b.remoteUserData,b.lastSyncUserData,b.resourcePreviews.map(O=>[O,O.acceptResult]),y),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}ab(y){const b=y.filter(({mergeState:O})=>O==="conflict");(0,L.equals)(this.m,b,(O,N)=>this.h.isEqual(O.previewResource,N.previewResource))||(this.m=b,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async bb(y){const b=this.c?await this.c:null;if(b)for(const O of b.resourcePreviews){if(this.h.isEqual(O.acceptedResource,y))return O.acceptResult?O.acceptResult.content:null;if(this.h.isEqual(O.remoteResource,y))return O.remoteContent;if(this.h.isEqual(O.localResource,y))return O.localContent;if(this.h.isEqual(O.baseResource,y))return O.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(y){(0,d.toFileOperationResult)(y)!==1&&this.L.error(y)}}async cb(y,b,O,N,F,z){const G=await this.ob(y,b,O,F,z),Y=[];for(const W of G){const T=W.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)Y.push({...W,acceptedResource:T,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const B=N?await this.pb(W,z):void 0;if(z.isCancellationRequested)break;await this.C.writeFile(W.previewResource,c.VSBuffer.fromString(B?.content||""));const _=B&&!B.hasConflicts?await this.qb(W,W.previewResource,void 0,z):void 0;Y.push({...W,acceptResult:_,mergeState:B?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:B?B.localChange:W.localChange,remoteChange:_?_.remoteChange:B?B.remoteChange:W.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:b,resourcePreviews:Y,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){let y=this.eb();if(y||(y=await this.hb()),!y)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const b=JSON.parse(y),O=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!b.version&&!!O&&b.version!==O,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${b.version} is not compatible with current sync state version ${O}.`),await this.resetLocal(),null;let N,F=1;for(;N===void 0&&F++<6;)try{const z=await this.fb();z&&(z.ref===b.ref?N=z.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof d.FileOperationError&&z.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(z instanceof E.UserDataSyncError)throw z;this.L.error(z,F)}}if(N===void 0)try{const z=await this.G.resolveResourceContent(this.resource,b.ref,this.collection,this.z);N=z===null?null:this.ib(z),await this.gb({ref:b.ref,syncData:N})}catch(z){if(z instanceof E.UserDataSyncError&&z.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw z}return N===void 0?null:{...b,syncData:N}}async db(y,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const O=this.I.getResourceSyncStateVersion(this.resource),N={ref:y.ref,version:O,...b};this.F.store(this.v,JSON.stringify(N),-1,1),await this.gb(y)}eb(){return this.F.get(this.v,-1)}async fb(){const y=(await this.C.readFile(this.u)).value.toString();try{const b=y?JSON.parse(y):void 0;if(i(b))return b}catch(b){this.L.error(b)}}async gb(y){await this.C.writeFile(this.u,c.VSBuffer.fromString(JSON.stringify(y)))}async hb(){try{const y=await this.C.readFile(this.u),b=JSON.parse(y.value.toString());await this.C.del(this.u),b.ref&&b.content!==void 0?(this.F.store(this.v,JSON.stringify({...b,content:void 0}),-1,1),await this.gb({ref:b.ref,syncData:b.content===null?null:JSON.parse(b.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,b)}catch(y){y instanceof d.FileOperationError&&y.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(y)}return this.F.get(this.v,-1)}async getRemoteUserData(y){const{ref:b,content:O}=await this.jb(y);let N=null;return O!==null&&(N=this.ib(O)),{ref:b,syncData:N}}ib(y){try{const b=JSON.parse(y);if(o(b))return b}catch(b){this.L.error(b)}throw new E.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(y){const b=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.G.readResource(this.resource,b,this.collection,this.z)}async kb(y,b){const O=await this.j,N={version:this.nb,machineId:O,content:y};try{return b=await this.G.writeResource(this.resource,JSON.stringify(N),b,this.collection,this.z),{ref:b,syncData:N}}catch(F){throw F instanceof E.UserDataSyncError&&F.code==="TooLarge"&&(F=new E.UserDataSyncError(F.message,F.code,this.resource)),F}}async lb(y){const b={version:this.nb,content:y};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(b))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(E.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=ye([J(2,d.IFileService),J(3,f.IEnvironmentService),J(4,u.IStorageService),J(5,E.IUserDataSyncStoreService),J(6,E.IUserDataSyncBackupStoreService),J(7,E.IUserDataSyncEnablementService),J(8,m.ITelemetryService),J(9,E.IUserDataSyncLogService),J(10,g.IConfigurationService),J(11,p.IUriIdentityService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(y,b,O,N,F,z,G,Y,W,T,B,_,q){super(b,O,N,F,z,G,Y,W,T,B,_,q),this.i=y,this.B(this.C.watch(this.h.dirname(y))),this.B(this.C.onDidFilesChange(x=>this.ub(x)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(y,b,O){try{b?await this.C.writeFile(this.i,c.VSBuffer.fromString(y),O?void 0:b):await this.C.createFile(this.i,c.VSBuffer.fromString(y),{overwrite:O})}catch(N){throw N instanceof d.FileOperationError&&N.fileOperationResult===1||N instanceof d.FileOperationError&&N.fileOperationResult===3?new E.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async tb(){try{await this.C.del(this.i)}catch(y){if(!(y instanceof d.FileOperationError&&y.fileOperationResult===1))throw y}}ub(y){!y.contains(this.i)||this.N()}};s=ye([J(3,d.IFileService),J(4,f.IEnvironmentService),J(5,u.IStorageService),J(6,E.IUserDataSyncStoreService),J(7,E.IUserDataSyncBackupStoreService),J(8,E.IUserDataSyncEnablementService),J(9,m.ITelemetryService),J(10,E.IUserDataSyncLogService),J(11,g.IConfigurationService),J(12,p.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(y,b,O,N,F,z,G,Y,W,T,B,_,q,x){super(y,b,O,N,F,z,G,Y,W,T,B,q,x),this.vb=_,this.xb=void 0}wb(y,b){const O=[],N=(0,R.parse)(y,O,{allowEmptyContent:!0,allowTrailingComma:!0});return O.length>0||!(0,I.isUndefined)(N)&&b!==Array.isArray(N)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};a=ye([J(3,d.IFileService),J(4,f.IEnvironmentService),J(5,u.IStorageService),J(6,E.IUserDataSyncStoreService),J(7,E.IUserDataSyncBackupStoreService),J(8,E.IUserDataSyncEnablementService),J(9,m.ITelemetryService),J(10,E.IUserDataSyncLogService),J(11,E.IUserDataSyncUtilService),J(12,g.IConfigurationService),J(13,p.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let r=class{constructor(y,b,O,N,F,z,G){this.resource=y,this.g=b,this.h=O,this.j=N,this.k=F,this.l=z,this.d=G.extUri,this.f=(0,E.getLastSyncResourceUri)(void 0,this.resource,O,this.d)}async initialize({ref:y,content:b}){if(!b){this.j.info("Remote content does not exist.",this.resource);return}const O=this.m(b);if(!!O)try{await this.o({ref:y,syncData:O})}catch(N){this.j.error(N)}}m(y){try{const b=JSON.parse(y);if(o(b))return b}catch(b){this.j.error(b)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const O={ref:y.ref,version:void 0,...b};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(O),-1,1),await this.k.writeFile(this.f,c.VSBuffer.fromString(JSON.stringify(y)))}};r=ye([J(1,P.IUserDataProfilesService),J(2,f.IEnvironmentService),J(3,v.ILogService),J(4,d.IFileService),J(5,u.IStorageService),J(6,p.IUriIdentityService)],r),e.AbstractInitializer=r}),define(re[120],oe([0,1,6,24,8,3,42,2,27,17,15,119,29,33,78,14,5,69,11,20,19,30,18,41,257,117,23,60]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o,t,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(F,z){const G=JSON.parse(F.content);if(F.version===1||F.version===2){const Y=(await z.getInstalled(0)).filter(W=>W.isBuiltin);for(const W of G)F.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),F.version===2&&Y.every(T=>!(0,f.areSameExtensions)(T.identifier,W.identifier))&&(W.installed=!0)}return G}function l(F){return JSON.parse(F.content)}e.parseExtensions=l;function y(F,z){return F.sort((G,Y)=>!G.identifier.uuid&&Y.identifier.uuid?-1:G.identifier.uuid&&!Y.identifier.uuid?1:(0,C.compare)(G.identifier.id,Y.identifier.id)),z?(0,D.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=y;let b=class extends o.AbstractSynchroniser{constructor(z,G,Y,W,T,B,_,q,x,M,X,Q,se,ae,V,j,U){super({syncResource:"extensions",profile:z},G,W,Y,T,B,_,Q,se,M,X,V),this.zb=q,this.Ab=x,this.Bb=U,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(O),this.B(k.Event.any(k.Event.filter(this.zb.onDidInstallExtensions,$=>$.some(({local:H})=>!!H)),k.Event.filter(this.zb.onDidUninstallExtension,$=>!$.error),k.Event.filter(j.onDidChange,$=>$.valueChanges.some(({profile:H,changes:ee})=>this.syncResource.profile.id===H.id&&ee.some(K=>K.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(z,G){const Y=z.syncData?await r(z.syncData,this.zb):null,W=G?.skippedExtensions??[],T=G?.builtinExtensions??null,B=G?.syncData?await r(G.syncData,this.zb):null,{localExtensions:_,ignoredExtensions:q}=await this.yb.getLocalExtensions(this.syncResource.profile);Y?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:x,remote:M}=(0,t.merge)(_,Y,B,W,q,T),X={local:x,remote:M,content:this.Eb(_,x.added,x.updated,x.removed),localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:M!==null?2:0},Q=this.Lb(_,!1);return[{skippedExtensions:W,builtinExtensions:T,baseResource:this.ub,baseContent:B?this.Lb(B,!1):Q,localResource:this.vb,localContent:Q,localExtensions:_,remoteResource:this.wb,remoteExtensions:Y,remoteContent:Y?this.Lb(Y,!1):null,previewResource:this.tb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.xb}]}async sb(z){const G=z.syncData?await r(z.syncData,this.zb):null,{localExtensions:Y,ignoredExtensions:W}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:T}=(0,t.merge)(Y,G,G,z.skippedExtensions||[],W,z.builtinExtensions||[]);return T!==null}Eb(z,G,Y,W){const T=[...G,...Y],B=new Set,_=q=>{B.add(q.id.toLowerCase()),q.uuid&&B.add(q.uuid)};T.forEach(({identifier:q})=>_(q)),W.forEach(_);for(const q of z)B.has(q.identifier.id.toLowerCase())||q.identifier.uuid&&B.has(q.identifier.uuid)||T.push(q);return this.Lb(T,!1)}async pb(z,G){return{...z.previewResult,hasConflicts:!1}}async qb(z,G,Y,W){if(this.h.isEqual(G,this.vb))return this.Hb(z);if(this.h.isEqual(G,this.wb))return this.Ib(z);if(this.h.isEqual(G,this.tb))return z.previewResult;throw new Error(`Invalid Resource: ${G.toString()}`)}async Hb(z){const G=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Ab.getIgnoredExtensions(G),W=(0,t.merge)(z.localExtensions,null,null,z.skippedExtensions,Y,z.builtinExtensions),{local:T,remote:B}=W;return{content:z.localContent,local:T,remote:B,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:B!==null?2:0}}async Ib(z){const G=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Ab.getIgnoredExtensions(G),W=z.remoteContent?JSON.parse(z.remoteContent):null;if(W!==null){const T=(0,t.merge)(z.localExtensions,W,z.localExtensions,[],Y,z.builtinExtensions),{local:B,remote:_}=T;return{content:z.remoteContent,local:B,remote:_,localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(z,G,Y,W){let{skippedExtensions:T,builtinExtensions:B,localExtensions:_}=Y[0][0];const{local:q,remote:x,localChange:M,remoteChange:X}=Y[0][1];if(M===0&&X===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),M!==0&&(await this.lb(JSON.stringify(_)),T=await this.yb.updateLocalExtensions(q.added,q.removed,q.updated,T,this.syncResource.profile)),x){this.L.trace(`${this.y}: Updating remote extensions...`);const Q=JSON.stringify(x.all);z=await this.kb(Q,W?null:z.ref),this.L.info(`${this.y}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(se=>se.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(se=>se.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(se=>se.identifier.id))}.`:""}`)}G?.ref!==z.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),B=this.Kb(_,B),await this.db(z,{skippedExtensions:T,builtinExtensions:B}),this.L.info(`${this.y}: Updated last synchronized extensions.${T.length?` Skipped: ${JSON.stringify(T.map(Q=>Q.identifier.id))}.`:""}`))}Kb(z,G){const Y=new Set,W=[];for(const T of z)Y.add(T.identifier.id.toLowerCase()),T.installed||W.push(T.identifier);if(G)for(const T of G)Y.has(T.id.toLowerCase())||W.push(T);return W}async resolveContent(z){if(this.h.isEqual(this.wb,z)||this.h.isEqual(this.ub,z)||this.h.isEqual(this.vb,z)||this.h.isEqual(this.xb,z)){const G=await this.bb(z);return G&&this.Lb(JSON.parse(G),!0)}return null}Lb(z,G){return y(z,G)}async hasLocalData(){try{const{localExtensions:z}=await this.yb.getLocalExtensions(this.syncResource.profile);if(z.some(G=>G.installed||G.disabled))return!0}catch{}return!1}};b=ye([J(2,I.IEnvironmentService),J(3,v.IFileService),J(4,p.IStorageService),J(5,s.IUserDataSyncStoreService),J(6,s.IUserDataSyncBackupStoreService),J(7,g.IExtensionManagementService),J(8,n.IIgnoredExtensionsManagementService),J(9,s.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,s.IUserDataSyncEnablementService),J(12,E.ITelemetryService),J(13,d.IExtensionStorageService),J(14,P.IUriIdentityService),J(15,a.IUserDataProfileStorageService),J(16,h.IInstantiationService)],b),e.ExtensionsSynchroniser=b;let O=class{constructor(z,G,Y,W,T,B){this.a=z,this.b=G,this.c=Y,this.d=W,this.f=T,this.g=B}async getLocalExtensions(z){const G=await this.a.getInstalled(void 0,z.extensionsResource),Y=this.d.getIgnoredExtensions(G);return{localExtensions:await this.j(z,async(T,B)=>{const _=T.getDisabledExtensions();return G.map(q=>{const{identifier:x,isBuiltin:M,manifest:X,preRelease:Q,pinned:se}=q,ae={identifier:x,preRelease:Q,version:X.version,pinned:!!se};_.some(V=>(0,f.areSameExtensions)(V,x))&&(ae.disabled=!0),M||(ae.installed=!0);try{const V=B.getKeysForSync({id:x.id,version:X.version});if(V){const j=B.getExtensionState(q,!0)||{};ae.state=Object.keys(j).reduce((U,$)=>(V.includes($)&&(U[$]=j[$]),U),{})}}catch(V){this.g.info(`${(0,o.getSyncResourceLogLabel)("extensions",z)}: Error while parsing extension state`,(0,c.getErrorMessage)(V))}return ae})}),ignoredExtensions:Y}}async updateLocalExtensions(z,G,Y,W,T){const B=(0,o.getSyncResourceLogLabel)("extensions",T),_=[],q=[],x=[],M=await this.a.getInstalled(void 0,T.extensionsResource);if((z.length||Y.length)&&await this.j(T,async(Q,se)=>{await L.Promises.settled([...z,...Y].map(async ae=>{const V=M.find($=>(0,f.areSameExtensions)($.identifier,ae.identifier));if(V&&V.isBuiltin){ae.state&&V.manifest.version===ae.version&&this.h(ae.state,V,V.manifest.version,se),Q.getDisabledExtensions().some(H=>(0,f.areSameExtensions)(H,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${B}: Disabling extension...`,ae.identifier.id),await Q.disableExtension(ae.identifier),this.g.info(`${B}: Disabled extension`,ae.identifier.id)):(this.g.trace(`${B}: Enabling extension...`,ae.identifier.id),await Q.enableExtension(ae.identifier),this.g.info(`${B}: Enabled extension`,ae.identifier.id))),q.push(ae.identifier);return}const j=ae.pinned?ae.version:void 0,U=(await this.c.getExtensions([{...ae.identifier,version:j,preRelease:j?void 0:ae.preRelease}],A.CancellationToken.None))[0];if(ae.state&&(V?V.manifest.version===ae.version:!!U)&&this.h(ae.state,V||U,V?.manifest.version,se),U)try{Q.getDisabledExtensions().some(H=>(0,f.areSameExtensions)(H,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${B}: Disabling extension...`,ae.identifier.id,U.version),await Q.disableExtension(U.identifier),this.g.info(`${B}: Disabled extension`,ae.identifier.id,U.version)):(this.g.trace(`${B}: Enabling extension...`,ae.identifier.id,U.version),await Q.enableExtension(U.identifier),this.g.info(`${B}: Enabled extension`,ae.identifier.id,U.version))),(!V||V.preRelease!==ae.preRelease||V.pinned!==ae.pinned||j&&V.manifest.version!==j)&&(await this.a.canInstall(U)?_.push([ae,U]):(this.g.info(`${B}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),x.push(ae)))}catch($){x.push(ae),this.g.error($),this.g.info(`${B}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else x.push(ae),this.g.info(`${B}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),G.length){const Q=M.filter(({identifier:se,isBuiltin:ae})=>!ae&&G.some(V=>(0,f.areSameExtensions)(se,V)));await L.Promises.settled(Q.map(async se=>{this.g.trace(`${B}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:T.extensionsResource}),this.g.info(`${B}: Uninstalled local extension.`,se.identifier.id),q.push(se.identifier)}))}for(const[Q,se]of _)try{this.g.trace(`${B}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:Q.pinned&&!!Q.version,installPreReleaseVersion:Q.preRelease,profileLocation:T.extensionsResource,context:{[g.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[g.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${B}: Installed extension.`,se.identifier.id,se.version),q.push(se.identifier)}catch(ae){x.push(Q),ae instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatiblePreRelease,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.g.info(`${B}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(ae),this.g.info(`${B}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const X=[];for(const Q of W)q.some(se=>(0,f.areSameExtensions)(se,Q.identifier))||X.push(Q);for(const Q of x)X.some(se=>(0,f.areSameExtensions)(se.identifier,Q.identifier))||X.push(Q);return X}h(z,G,Y,W){const T=W.getExtensionState(G,!0)||{},B=Y?W.getKeysForSync({id:G.identifier.id,version:Y}):void 0;B?B.forEach(_=>{T[_]=z[_]}):Object.keys(z).forEach(_=>T[_]=z[_]),W.setExtensionState(G,T,!0)}async j(z,G){return this.b.withProfileScopedStorageService(z,async Y=>{const W=new R.DisposableStore,T=this.f.createChild(new u.ServiceCollection([p.IStorageService,Y])),B=W.add(T.createInstance(w.GlobalExtensionEnablementService)),_=W.add(T.createInstance(d.ExtensionStorageService));try{return await G(B,_)}finally{W.dispose()}})}};O=ye([J(0,g.IExtensionManagementService),J(1,a.IUserDataProfileStorageService),J(2,g.IExtensionGalleryService),J(3,n.IIgnoredExtensionsManagementService),J(4,h.IInstantiationService),J(5,s.IUserDataSyncLogService)],O),e.LocalExtensionsProvider=O;let N=class extends o.AbstractInitializer{constructor(z,G,Y,W,T,B,_,q){super("extensions",W,T,B,Y,_,q),this.p=z,this.q=G}async t(z){return z.syncData?await r(z.syncData,this.p):null}u(z,G){const Y=[],W=[],T=[];for(const B of z){if(this.q.hasToNeverSyncExtension(B.identifier.id))continue;const _=G.find(q=>(0,f.areSameExtensions)(q.identifier,B.identifier));_?(Y.push(_),B.disabled&&T.push(B.identifier)):B.installed&&(W.push({...B.identifier,preRelease:!!B.preRelease}),B.disabled&&T.push(B.identifier))}return{installedExtensions:Y,newExtensions:W,disabledExtensions:T,remoteExtensions:z}}};N=ye([J(0,g.IExtensionManagementService),J(1,n.IIgnoredExtensionsManagementService),J(2,v.IFileService),J(3,i.IUserDataProfilesService),J(4,I.IEnvironmentService),J(5,m.ILogService),J(6,p.IStorageService),J(7,P.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(re[121],oe([0,1,16,8,3,35,42,4,31,17,15,14,11,44,20,19,30,41,59,261,23,18,60,5]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function s(O,N){const F=O.storage?Object.keys(O.storage).sort():[],z={};return F.forEach(G=>z[G]=O.storage[G]),O.storage=z,N?(0,D.toFormattedString)(O,{}):JSON.stringify(O)}e.stringify=s;const a=1;let r=class extends u.AbstractSynchroniser{constructor(N,F,z,G,Y,W,T,B,_,q,x,M,X,Q){super({syncResource:"globalState",profile:N},F,G,B,M,Y,W,_,q,T,x,X),this.xb=z,this.nb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=Q.createInstance(l),this.B(G.watch(this.h.dirname(this.D.argvResource))),this.B(c.Event.any(c.Event.filter(G.onDidFilesChange,se=>se.contains(this.D.argvResource)),c.Event.filter(z.onDidChange,se=>!!(se.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||se.valueChanges.some(({profile:ae,changes:V})=>this.syncResource.profile.id===ae.id&&V.some(j=>j.target===0)))))(()=>this.N()))}async ob(N,F,z){const G=N.syncData?JSON.parse(N.syncData.content):null;F=F===null&&z?N:F;const Y=F&&F.syncData?JSON.parse(F.syncData.content):null,W=await this.wb.getLocalGlobalState(this.syncResource.profile);G?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const T=await this.Fb(Y),{local:B,remote:_}=(0,p.merge)(W.storage,G?G.storage:null,Y?Y.storage:null,T,this.L),q={content:null,local:B,remote:_,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:_.all!==null?2:0},x=s(W,!1);return[{baseResource:this.r,baseContent:Y?s(Y,!1):x,localResource:this.tb,localContent:x,localUserData:W,remoteResource:this.ub,remoteContent:G?s(G,!1):null,previewResource:this.p,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.vb,storageKeys:T}]}async sb(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(F===null)return!0;const z=await this.wb.getLocalGlobalState(this.syncResource.profile),G=await this.Fb(F),{remote:Y}=(0,p.merge)(z.storage,F.storage,F.storage,G,this.L);return Y.all!==null}async pb(N,F){return{...N.previewResult,hasConflicts:!1}}async qb(N,F,z,G){if(this.h.isEqual(F,this.tb))return this.Cb(N);if(this.h.isEqual(F,this.ub))return this.Db(N);if(this.h.isEqual(F,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Cb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Db(N){if(N.remoteContent!==null){const F=JSON.parse(N.remoteContent),{local:z,remote:G}=(0,p.merge)(N.localUserData.storage,F.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:z,remote:G,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:G!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(N,F,z,G){const{localUserData:Y}=z[0][0],{local:W,remote:T,localChange:B,remoteChange:_}=z[0][1];if(B===0&&_===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),B!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(Y)),await this.wb.writeLocalGlobalState(W,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),_!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const q=JSON.stringify({storage:T.all});N=await this.kb(q,G?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${T.added.length?` Added: ${T.added}.`:""}${T.updated.length?` Updated: ${T.updated}.`:""}${T.removed.length?` Removed: ${T.removed}.`:""}`)}F?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.db(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.ub,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.tb,N)||this.h.isEqual(this.vb,N)){const F=await this.bb(N);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(N){const F=await this.xb.readStorageData(this.syncResource.profile),z=[],G=[];for(const[T,B]of F)B.target===0?z.push(T):B.target===1&&G.push(T);const Y=[...z,...G],W=N?.storage?Object.keys(N.storage).filter(T=>!T.startsWith(t)&&!Y.includes(T)&&F.get(T)!==void 0):[];if(!R.isWeb){const T=[...E.ALL_SYNC_RESOURCES.map(B=>(0,E.getEnablementKey)(B)),E.SYNC_SERVICE_URL_TYPE];W.push(...T),G.push(...T)}return{user:z,machine:G,unregistered:W}}};r=ye([J(2,i.IUserDataProfileStorageService),J(3,w.IFileService),J(4,E.IUserDataSyncStoreService),J(5,E.IUserDataSyncBackupStoreService),J(6,E.IUserDataSyncLogService),J(7,I.IEnvironmentService),J(8,E.IUserDataSyncEnablementService),J(9,v.ITelemetryService),J(10,S.IConfigurationService),J(11,d.IStorageService),J(12,h.IUriIdentityService),J(13,o.IInstantiationService)],r),e.GlobalStateSynchroniser=r;let l=class{constructor(N,F,z,G){this.a=N,this.b=F,this.c=z,this.d=G}async getLocalGlobalState(N){const F={};if(N.isDefault){const G=await this.f(),Y=(0,k.parse)(G);for(const W of n)Y[W]!==void 0&&(F[`${t}${W}`]={version:1,value:Y[W]})}const z=await this.c.readStorageData(N);for(const[G,Y]of z)Y.value&&Y.target===0&&(F[G]={version:1,value:Y.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,A.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:F,updated:z},G){const Y=(0,u.getSyncResourceLogLabel)("globalState",G),W={},T=new Map,B=await this.c.readStorageData(G),_=(q,x)=>{for(const M of q){if(M.startsWith(t)){W[M.substring(t.length)]=x?x[M].value:void 0;continue}if(x){const X=x[M];X.value!==B.get(M)?.value&&T.set(M,X.value)}else B.get(M)!==void 0&&T.set(M,void 0)}};if(_(Object.keys(N),N),_(Object.keys(z),z),_(F),Object.keys(W).length){this.d.trace(`${Y}: Updating locale...`);const q=await this.f();let x=q;for(const M of Object.keys(W))x=(0,m.edit)(x,[M],W[M],{});q!==x&&(this.d.trace(`${Y}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(x)),this.d.info(`${Y}: Updated locale.`)),this.d.info(`${Y}: Updated locale`)}T.size&&(this.d.trace(`${Y}: Updating global state...`),await this.c.updateStorageData(G,T,0),this.d.info(`${Y}: Updated global state`,[...T.keys()]))}};l=ye([J(0,w.IFileService),J(1,I.IEnvironmentService),J(2,i.IUserDataProfileStorageService),J(3,E.IUserDataSyncLogService)],l),e.LocalGlobalStateProvider=l;let y=class extends u.AbstractInitializer{constructor(N,F,z,G,Y,W){super("globalState",z,G,Y,F,N,W)}async o(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},G={};for(const Y of Object.keys(F.storage))Y.startsWith(t)?z[Y.substring(t.length)]=F.storage[Y].value:this.l.get(Y,0)===void 0&&(G[Y]=F.storage[Y].value);if(Object.keys(z).length){let Y="{}";try{Y=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const W of Object.keys(z))Y=(0,m.edit)(Y,[W],z[W],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString(Y))}if(Object.keys(G).length)for(const Y of Object.keys(G))this.l.store(Y,G[Y],0,0)}};y=ye([J(0,d.IStorageService),J(1,w.IFileService),J(2,P.IUserDataProfilesService),J(3,I.IEnvironmentService),J(4,E.IUserDataSyncLogService),J(5,h.IUriIdentityService)],y),e.GlobalStateInitializer=y;let b=class{constructor(N,F,z,G,Y){this.a=N,this.b=F,this.c=z,this.d=G,this.f=Y}getSyncStoreType(N){return this.h(N)?.storage[E.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const F=(0,E.createSyncHeaders)((0,C.generateUuid)());try{return await this.g(N,F)}catch(z){if(z instanceof E.UserDataSyncError)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,F)}throw z}}async g(N,F){const z=await this.a.readResource("globalState",null,void 0,F),G=this.h(z)||{storage:{}};G.storage[E.SYNC_SERVICE_URL_TYPE]={value:N,version:a};const Y=await(0,f.getServiceMachineId)(this.c,this.d,this.b),W={version:a,machineId:Y,content:s(G,!1)};await this.a.writeResource("globalState",JSON.stringify(W),z.ref,void 0,F)}h({content:N}){if(!N)return null;const F=JSON.parse(N);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};b=ye([J(1,d.IStorageService),J(2,I.IEnvironmentService),J(3,w.IFileService),J(4,g.ILogService)],b),e.UserDataSyncStoreTypeSynchronizer=b}),define(re[122],oe([0,1,21,16,3,35,4,12,180,17,15,14,20,19,30,18,41,258,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(i,o,t){try{const n=JSON.parse(i);if(!o)return(0,R.isUndefined)(n.all)?null:n.all;switch(D.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=p;let E=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,n,s,a,r,l,y,b,O,N,F,z){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,y,b,O,n,s,l,F,a,N,r,z),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(c.Event.filter(r.onDidChangeConfiguration,G=>G.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(o,t,n,s){const a=o.syncData?p(o.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&n?o:t;const r=t?this.Kb(t):null,l=await this.p(),y=await this.yb();let b=null,O=!1,N=!1,F=!1;if(a){let Y=l?l.value.toString():"[]";if(Y=Y||"[]",this.wb(Y,!0))throw new m.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!r||r!==Y||r!==a){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const W=await(0,u.merge)(Y,a,r,y,this.vb);W.hasChanges&&(b=W.mergeContent,F=W.hasConflicts,O=F||W.mergeContent!==Y,N=F||W.mergeContent!==a)}}else l&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=l.value.toString(),N=!0);const z={content:F?r:b,localChange:O?l?2:1:0,remoteChange:N?2:0,hasConflicts:F},G=l?l.value.toString():null;return[{fileContent:l,baseResource:this.Bb,baseContent:r,localResource:this.Cb,localContent:G,localChange:z.localChange,remoteResource:this.Db,remoteContent:a,remoteChange:z.remoteChange,previewResource:this.Ab,previewResult:z,acceptedResource:this.Eb}]}async sb(o){const t=this.Kb(o);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString():"",a=await this.yb(),r=await(0,u.merge)(s||"[]",t,t,a,this.vb);return r.hasConflicts||r.mergeContent!==t}async pb(o,t){return o.previewResult}async qb(o,t,n,s){if(this.h.isEqual(t,this.Cb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(o,t,n,s){const{fileContent:a}=n[0][0];let{content:r,localChange:l,remoteChange:y}=n[0][1];if(l===0&&y===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),r!==null&&(r=r.trim(),r=r||"[]",this.wb(r,!0)))throw new m.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),a&&await this.lb(this.Lb(a.value.toString())),await this.r(r||"[]",a,s),this.L.info(`${this.y}: Updated local keybindings`)),y!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const b=this.Lb(r||"[]",o.syncData?.content);o=await this.kb(b,s?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.Ab)}catch{}t?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.db(o,{platformSpecific:this.Mb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const t=(0,k.parse)(o.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Db,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Eb,o)?this.bb(o):null}Kb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Mb()?null:p(o.syncData.content,this.Mb(),this.L)}Lb(o,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete n.all:n.all=o,D.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}Mb(){return!!this.M.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};E=ye([J(2,m.IUserDataSyncStoreService),J(3,m.IUserDataSyncBackupStoreService),J(4,m.IUserDataSyncLogService),J(5,S.IConfigurationService),J(6,m.IUserDataSyncEnablementService),J(7,w.IFileService),J(8,I.IEnvironmentService),J(9,g.IStorageService),J(10,m.IUserDataSyncUtilService),J(11,f.ITelemetryService),J(12,d.IUriIdentityService)],E),e.KeybindingsSynchroniser=E;let P=class extends h.AbstractInitializer{constructor(o,t,n,s,a,r){super("keybindings",t,n,s,o,a,r)}async o(o){const t=o.syncData?this.p(o.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.VSBuffer.fromString(t)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,k.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}p(o){try{return p(o,!0,this.j)}catch(t){return this.j.error(t),null}}};P=ye([J(0,w.IFileService),J(1,v.IUserDataProfilesService),J(2,I.IEnvironmentService),J(3,m.IUserDataSyncLogService),J(4,g.IStorageService),J(5,d.IUriIdentityService)],P),e.KeybindingsInitializer=P}),define(re[123],oe([0,1,16,3,181,17,72,15,29,14,20,19,30,18,41,59,262,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const o=JSON.parse(i);return m(o)?o:{settings:i}}e.parseSettingsSyncContent=p;let E=class extends d.AbstractJsonFileSynchroniser{constructor(o,t,n,s,a,r,l,y,b,O,N,F,z,G){super(o.settingsResource,{syncResource:"settings",profile:o},t,n,s,a,r,l,N,F,y,b,O,G),this.Ab=z,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),n=await this.S(o,t),s=this.Hb(n),a=new D.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(o,t,n){const s=await this.p(),a=await this.yb(),r=this.Hb(o);t=t===null&&n?o:t;const l=t?this.Hb(t):null,y=await this.Lb();let b=null,O=!1,N=!1,F=!1;if(r){let W=s?s.value.toString().trim():"{}";W=W||"{}",this.Mb(W),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const T=(0,h.merge)(W,r.settings,l?l.settings:null,y,[],a);b=T.localContent||T.remoteContent,O=T.localContent!==null,N=T.remoteContent!==null,F=T.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),b=s.value.toString().trim()||"{}",this.Mb(b),N=!0);const z=s?s.value.toString():null,G=l?.settings??null,Y={content:F?G:b,localChange:O?2:0,remoteChange:N?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:G,localResource:this.localResource,localContent:z,localChange:Y.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:Y.remoteChange,previewResource:this.previewResource,previewResult:Y,acceptedResource:this.acceptedResource}]}async sb(o){const t=this.Hb(o);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",a=await this.Lb(),r=await this.yb();return(0,h.merge)(s||"{}",t.settings,t.settings,a,[],r).remoteContent!==null}async pb(o,t){const n=await this.yb(),s=await this.Lb();return{...o.previewResult,content:o.previewResult.content?(0,h.updateIgnoredSettings)(o.previewResult.content,"{}",s,n):null}}async qb(o,t,n,s){const a=await this.yb(),r=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:o.fileContent?(0,h.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",r,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,h.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n!==null?(0,h.updateIgnoredSettings)(n,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(o,t,n,s){const{fileContent:a}=n[0][0];let{content:r,localChange:l,remoteChange:y}=n[0][1];if(l===0&&y===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Mb(r),l!==0&&(this.L.trace(`${this.y}: Updating local settings...`),a&&await this.lb(JSON.stringify(this.Jb(a.value.toString()))),await this.r(r,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),y!==0){const b=await this.yb(),O=this.Hb(o),N=await this.Lb(r);r=(0,h.updateIgnoredSettings)(r,O?O.settings:"{}",N,b),this.L.trace(`${this.y}: Updating remote settings...`),o=await this.kb(JSON.stringify(this.Jb(r)),s?null:o.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.db(o),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.p();if(o){const t=await this.yb(),n=(0,v.edit)(o.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,h.isEmpty)(n)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)||this.h.isEqual(this.baseResource,o)?this.bb(o):null}async bb(o){let t=await super.bb(o);if(t){const n=await this.yb(),s=await this.Lb();t=(0,h.updateIgnoredSettings)(t,"{}",s,n)}return t}Hb(o){return o.syncData?this.Ib(o.syncData.content):null}Ib(o){try{return p(o)}catch(t){this.L.error(t)}return null}Jb(o){return{settings:o}}async Lb(o){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const n=A.Event.any(A.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),A.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,h.getIgnoredSettings)(t,this.M,o)}Mb(o){if(this.wb(o,!1))throw new u.UserDataSyncError((0,c.localize)(0,null),"LocalInvalidContent",this.resource)}};E=ye([J(2,S.IFileService),J(3,R.IEnvironmentService),J(4,I.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncLogService),J(8,u.IUserDataSyncUtilService),J(9,k.IConfigurationService),J(10,u.IUserDataSyncEnablementService),J(11,w.ITelemetryService),J(12,C.IExtensionManagementService),J(13,g.IUriIdentityService)],E),e.SettingsSynchroniser=E;let P=class extends d.AbstractInitializer{constructor(o,t,n,s,a,r){super("settings",t,n,s,o,a,r)}async o(o){const t=o.syncData?this.p(o.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,h.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}p(o){try{return p(o)}catch(t){this.j.error(t)}return null}};P=ye([J(0,S.IFileService),J(1,f.IUserDataProfilesService),J(2,R.IEnvironmentService),J(3,u.IUserDataSyncLogService),J(4,I.IStorageService),J(5,g.IUriIdentityService)],P),e.SettingsInitializer=P}),define(re[124],oe([0,1,16,3,32,17,15,14,20,19,30,18,41,259,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function v(m){return JSON.parse(m.content)}e.parseSnippets=v;let h=class extends g.AbstractSynchroniser{constructor(p,E,P,i,o,t,n,s,a,r,l,y){super({syncResource:"snippets",profile:p},E,i,P,o,t,n,r,l,s,a,y),this.nb=1,this.p=p.snippetsHome,this.B(this.C.watch(P.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(A.Event.filter(this.C.onDidFilesChange,b=>b.affects(this.p))(()=>this.N()))}async ob(p,E,P){const i=await this.Db(),o=this.Cb(i),t=p.syncData?this.Bb(p.syncData):null;E=E===null&&P?p:E;const n=E&&E.syncData?this.Bb(E.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.merge)(o,t,n);return this.xb(s,i,t||{},n||{})}async sb(p){const E=p.syncData?this.Bb(p.syncData):null;if(E===null)return!0;const P=await this.Db(),i=this.Cb(P),o=(0,f.merge)(i,E,E);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async pb(p,E){return p.previewResult}async qb(p,E,P,i){if(this.h.isEqualOrParent(E,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(E,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(E,this.g))return P===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:P,localChange:P===null?p.fileContent!==null?3:0:2,remoteChange:P===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async rb(p,E,P,i){const o=P.map(([t,n])=>({...t,acceptResult:n}));o.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.yb(o),await this.zb(o,i)),o.some(({remoteChange:t})=>t!==0)&&(p=await this.Ab(o,p,i)),E?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.db(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.C.del(t)}catch{}}xb(p,E,P,i){const o=new Map;for(const t of Object.keys(p.local.added)){const n={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const n={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const n={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const n={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const n={content:i[t]??null,hasConflicts:!0,localChange:E[t]?2:1,remoteChange:P[t]?2:1},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(E))if(!o.has(t)){const n={content:E[t]?E[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=E[t]?E[t].value.toString():null;o.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:P[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(p):null}async hasLocalData(){try{const p=await this.Db();if(Object.keys(p).length)return!0}catch{}return!1}async yb(p){const E={};for(const P of p)P.fileContent&&(E[this.h.basename(P.localResource)]=P.fileContent);await this.lb(JSON.stringify(this.Cb(E)))}async zb(p,E){for(const{fileContent:P,acceptResult:i,localResource:o,remoteResource:t,localChange:n}of p)if(n!==0){const s=t?this.h.basename(t):this.h.basename(o),a=this.h.joinPath(this.p,s);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(a)),await this.C.del(a),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(a))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(a)),await this.C.createFile(a,L.VSBuffer.fromString(i.content),{overwrite:E}),this.L.info(`${this.y}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(a)),await this.C.writeFile(a,L.VSBuffer.fromString(i.content),E?void 0:P),this.L.info(`${this.y}: Updated snippet`,this.h.basename(a)))}}async Ab(p,E,P){const i=E.syncData?this.Bb(E.syncData):{},o=(0,c.deepClone)(i);for(const{acceptResult:t,localResource:n,remoteResource:s,remoteChange:a}of p)if(a!==0){const r=n?this.h.basename(n):this.h.basename(s);a===3?delete o[r]:o[r]=t.content}return(0,f.areSame)(i,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),E=await this.kb(JSON.stringify(o),P?null:E.ref),this.L.info(`${this.y}: Updated remote snippets`)),E}Bb(p){return v(p)}Cb(p){const E={};for(const P of Object.keys(p))E[P]=p[P].value.toString();return E}async Db(){const p={};let E;try{E=await this.C.resolve(this.p)}catch(P){if(P instanceof R.FileOperationError&&P.fileOperationResult===1)return p;throw P}for(const P of E.children||[]){const i=P.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const t=this.h.relativePath(this.p,i),n=await this.C.readFile(i);p[t]=n}}return p}};h=ye([J(2,D.IEnvironmentService),J(3,R.IFileService),J(4,C.IStorageService),J(5,d.IUserDataSyncStoreService),J(6,d.IUserDataSyncBackupStoreService),J(7,d.IUserDataSyncLogService),J(8,k.IConfigurationService),J(9,d.IUserDataSyncEnablementService),J(10,S.ITelemetryService),J(11,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let u=class extends g.AbstractInitializer{constructor(p,E,P,i,o,t){super("snippets",E,P,i,p,o,t)}async o(p){const E=p.syncData?JSON.parse(p.syncData.content):null;if(!E){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(E)){const o=E[i];if(o){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,L.VSBuffer.fromString(o)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};u=ye([J(0,R.IFileService),J(1,w.IUserDataProfilesService),J(2,D.IEnvironmentService),J(3,d.IUserDataSyncLogService),J(4,C.IStorageService),J(5,I.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[125],oe([0,1,16,17,15,14,20,19,30,18,41,23]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(h,u){try{return JSON.parse(h).tasks??null}catch(m){return u.error(m),null}}e.getTasksContentFromSyncContent=g;let f=class extends I.AbstractFileSynchroniser{constructor(u,m,p,E,P,i,o,t,n,s,a,r){super(u.tasksResource,{syncResource:"tasks",profile:u},m,t,n,s,p,E,o,a,P,i,r),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,m,p,E){const P=u.syncData?g(u.syncData.content,this.L):null;m=m===null&&p?u:m;const i=m?.syncData?g(m.syncData.content,this.L):null,o=await this.p();let t=null,n=!1,s=!1,a=!1;if(u.syncData){const y=o?o.value.toString():null;if(!i||i!==y||i!==P){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const b=v(y,P,i);t=b.content,a=b.hasConflicts,n=b.hasLocalChanged,s=b.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const r={content:a?i:t,localChange:n?o?2:1:0,remoteChange:s?2:0,hasConflicts:a},l=o?o.value.toString():null;return[{fileContent:o,baseResource:this.xb,baseContent:i,localResource:this.yb,localContent:l,localChange:r.localChange,remoteResource:this.zb,remoteContent:P,remoteChange:r.remoteChange,previewResource:this.wb,previewResult:r,acceptedResource:this.Ab}]}async sb(u){const m=u?.syncData?g(u.syncData.content,this.L):null;if(m===null)return!0;const p=await this.p(),E=p?p.value.toString():null,P=v(E,m,m);return P.hasLocalChanged||P.hasRemoteChanged}async pb(u,m){return u.previewResult}async qb(u,m,p,E){if(this.h.isEqual(m,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(m,this.zb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(m,this.wb))return p===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async rb(u,m,p,E){const{fileContent:P}=p[0][0],{content:i,localChange:o,remoteChange:t}=p[0][1];if(o===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),P&&await this.lb(JSON.stringify(this.Gb(P.value.toString()))),i?await this.r(i,P,E):await this.tb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Gb(i));u=await this.kb(n,E?null:u.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.wb)}catch{}m?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.db(u),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.zb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Ab,u)?this.bb(u):null}Gb(u){return u?{tasks:u}:{}}};f=ye([J(2,w.IUserDataSyncStoreService),J(3,w.IUserDataSyncBackupStoreService),J(4,w.IUserDataSyncLogService),J(5,A.IConfigurationService),J(6,w.IUserDataSyncEnablementService),J(7,k.IFileService),J(8,c.IEnvironmentService),J(9,D.IStorageService),J(10,R.ITelemetryService),J(11,C.IUriIdentityService)],f),e.TasksSynchroniser=f;let d=class extends I.AbstractInitializer{constructor(u,m,p,E,P,i){super("tasks",m,p,E,u,P,i),this.c=this.g.defaultProfile.tasksResource}async o(u){const m=u.syncData?g(u.syncData.content,this.j):null;if(!m){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(m)),await this.n(u)}async p(){return this.k.exists(this.c)}};d=ye([J(0,k.IFileService),J(1,S.IUserDataProfilesService),J(2,c.IEnvironmentService),J(3,w.IUserDataSyncLogService),J(4,D.IStorageService),J(5,C.IUriIdentityService)],d),e.TasksInitializer=d;function v(h,u,m){if(h===null&&u===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=m!==h,E=m!==u;return!p&&!E?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!E?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:E&&!p?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[126],oe([0,1,42,17,15,14,20,19,30,18,41,260,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=class extends I.AbstractSynchroniser{constructor(u,m,p,E,P,i,o,t,n,s,a,r,l){super({syncResource:"profiles",profile:u},m,E,P,i,o,t,a,r,n,s,l),this.r=p,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?v(u.syncData):null}async getRemoteSyncedProfiles(u){const m=await this.getLastSyncUserData(),p=await this.S(u,m);return p?.syncData?v(p.syncData):null}async ob(u,m,p){if(!this.r.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const E=u.syncData?v(u.syncData):null,P=m?.syncData?v(m.syncData):null,i=this.Ab(),{local:o,remote:t}=(0,w.merge)(i,E,P,[]),n={local:o,remote:t,content:P?this.Bb(P):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=d(i,!1);return[{baseResource:this.baseResource,baseContent:P?this.Bb(P):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:E?this.Bb(E):null,remoteProfiles:E,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const m=u?.syncData?v(u.syncData):null,p=this.Ab(),{remote:E}=(0,w.merge)(p,m,m,[]);return!!E?.added.length||!!E?.removed.length||!!E?.updated.length}async pb(u,m){return{...u.previewResult,hasConflicts:!1}}async qb(u,m,p,E){if(this.h.isEqual(m,this.localResource))return this.xb(u);if(this.h.isEqual(m,this.remoteResource))return this.yb(u);if(this.h.isEqual(m,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async xb(u){const m=this.Ab(),p=(0,w.merge)(m,null,null,[]),{local:E,remote:P}=p;return{content:u.localContent,local:E,remote:P,localChange:E.added.length>0||E.removed.length>0||E.updated.length>0?2:0,remoteChange:P!==null?2:0}}async yb(u){const m=u.remoteContent?JSON.parse(u.remoteContent):null,p=[],E=[];for(const P of this.Ab()){const i=m?.find(o=>o.id===P.id);i&&(p.push({id:P.id,name:P.name,collection:i.collection}),E.push(P))}if(m!==null){const P=(0,w.merge)(E,m,p,[]),{local:i,remote:o}=P;return{content:u.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,m,p,E){const{local:P,remote:i,localChange:o,remoteChange:t}=p[0][1];o===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=p[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.lb(d(this.Ab(),!1));const s=[];for(const a of P.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.y}: Created profile '${a.name}'.`)})());for(const a of P.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.y}: Removed profile '${a.name}'.`)})());for(const a of P.updated){const r=this.r.profiles.find(l=>l.id===a.id);r?s.push((async()=>{this.L.trace(`${this.y}: Updating '${a.name}' profile...`),await this.r.updateProfile(r,{name:a.name,shortName:a.shortName}),this.L.info(`${this.y}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],a=n.length+(i?.added.length??0)<=20;if(a)for(const r of i?.added||[]){const l=await this.G.createCollection(this.z);s.push(l),n.push({id:r.id,name:r.name,collection:l,shortName:r.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const r of i?.removed||[])n.splice(n.findIndex(({id:l})=>r.id===l),1);for(const r of i?.updated||[]){const l=n.find(({id:y})=>r.id===y);l&&n.splice(n.indexOf(l),1,{id:r.id,name:r.name,collection:l.collection,shortName:r.shortName})}try{u=await this.updateRemoteProfiles(n,E?null:u.ref),this.L.info(`${this.y}: Updated remote profiles.${a&&i?.added.length?` Added: ${JSON.stringify(i.added.map(r=>r.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(r=>r.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(r=>r.name))}.`:""}`)}catch(r){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const l of s)await this.G.deleteCollection(l,this.z)}throw r}for(const r of i?.removed||[])await this.G.deleteCollection(r.collection,this.z)}m?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.db(u),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,m){return this.kb(this.Bb(u),m)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const m=await this.bb(u);return m&&(0,L.toFormattedString)(JSON.parse(m),{})}return null}Ab(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((m,p)=>m.name.localeCompare(p.name)))}};f=ye([J(2,S.IUserDataProfilesService),J(3,k.IFileService),J(4,c.IEnvironmentService),J(5,D.IStorageService),J(6,g.IUserDataSyncStoreService),J(7,g.IUserDataSyncBackupStoreService),J(8,g.IUserDataSyncLogService),J(9,A.IConfigurationService),J(10,g.IUserDataSyncEnablementService),J(11,R.ITelemetryService),J(12,C.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function d(h,u){const m=[...h].sort((p,E)=>p.name.localeCompare(E.name)).map(p=>({id:p.id,name:p.name}));return u?(0,L.toFormattedString)(m,{}):JSON.stringify(m)}e.stringifyLocalProfiles=d;function v(h){return JSON.parse(h.content)}e.parseUserDataProfilesManifest=v}),define(re[277],oe([0,1,6,16,63,2,25,17,15,14,18,23]),function(te,e,L,A,c,k,D,R,C,S,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends k.Disposable{constructor(d,v,h,u,m){super(),this.a=d,this.b=v,this.c=h,this.f=u,this.g=m,this.h()}async h(){for(const v of this.g.profiles)for(const h of w.ALL_SYNC_RESOURCES)try{await this.j(this.i(v,h))}catch(u){this.f.error(u)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(v){(0,S.toFileOperationResult)(v)!==1&&this.f.error(v);return}if(d.children){for(const v of d.children)if(v.isDirectory&&!this.g.profiles.some(h=>h.id===v.name))try{this.f.info("Deleting non existing profile from backup",v.resource.path),await this.b.del(v.resource,{recursive:!0})}catch(h){this.f.error(h)}}}async getAllRefs(d,v){const h=this.i(d,v);try{const u=await this.b.resolve(h);if(u.children)return u.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)}))}catch(u){if((0,S.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(d,v,h){const u=this.i(d,v),m=(0,D.joinPath)(u,h);try{return(await this.b.readFile(m)).value.toString()}catch(p){return this.f.error(p),null}}async backup(d,v,h){const u=this.i(d,v),m=(0,D.joinPath)(u,`${(0,c.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,A.VSBuffer.fromString(h))}catch(p){this.f.error(p)}try{this.j(u)}catch{}}i(d,v){return(0,D.joinPath)(this.a.userDataSyncHome,...d.isDefault?[v]:[d.id,v])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const v=await this.b.resolve(d);if(v.children){const h=v.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let m=h.filter(E=>Date.now()-this.k(E)>u);const p=h.length-m.length;p<10&&(m=m.slice(10-p)),await L.Promises.settled(m.map(async E=>{this.f.info("Deleting from backup",E.resource.path),await this.b.del(E.resource)}))}}catch(v){this.f.error(v)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};g=ye([J(0,C.IEnvironmentService),J(1,S.IFileService),J(2,R.IConfigurationService),J(3,w.IUserDataSyncLogService),J(4,I.IUserDataProfilesService)],g),e.UserDataSyncBackupStoreService=g}),define(re[278],oe([0,1,3,2,4,15,20,19,23]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let I=class extends A.Disposable{constructor(g,f,d,v){super(),this.c=g,this.f=f,this.g=d,this.h=v,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(h=>this.j(h)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:g}),this.c.store(S,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,C.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,f){if(this.isResourceEnabled(g)!==f){const d=(0,C.getEnablementKey)(g);this.i(d,f)}}getResourceSyncStateVersion(g){}i(g,f){this.c.store(g,f,-1,c.isWeb?0:1)}j(g){if(g.scope!==-1)return;if(S===g.key){this.a.fire(this.isEnabled());return}const f=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===g.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};I=ye([J(0,D.IStorageService),J(1,R.ITelemetryService),J(2,k.IEnvironmentService),J(3,C.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(re[79],oe([0,1,3,2,4,27,185,15,14,5,26,44,20,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",v="Safari",h="Chrome",u="Edge",m="Firefox",p="Android";function E(o){switch(o){case v:case h:case u:case m:case p:case(0,c.PlatformToString)(0):return!0}return!1}e.isWebPlatform=E;function P(){return c.isSafari?v:c.isChrome?h:c.isEdge?u:c.isFirefox?m:c.isAndroid?p:(0,c.PlatformToString)(c.isWeb?0:c.platform)}let i=class it extends A.Disposable{constructor(t,n,s,a,r,l){super(),this.h=s,this.i=a,this.j=r,this.k=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,w.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,s=await this.m(t);s.machines.some(({id:a})=>a===n)||(s.machines.push({id:n,name:this.l(s.machines),platform:P()}),await this.n(s))}async removeCurrentMachine(t){const n=await this.f,s=await this.m(t),a=s.machines.filter(({id:r})=>r!==n);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(t,n,s){const a=await this.m(s),r=a.machines.find(({id:l})=>l===t);if(r){r.name=n,await this.n(a);const l=await this.f;t===l&&this.h.store(d,n,-1,1)}}async setEnablements(t){const n=await this.m();for(const[s,a]of t){const r=n.machines.find(l=>l.id===s);r&&(r.disabled=a?void 0:!0)}await this.n(n)}l(t){const n=this.h.get(d,-1);if(n)return n;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${P()} (${this.k.nameShort})`,a=new RegExp(`${(0,k.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let r=0;for(const l of t){const y=a.exec(l.name),b=y?parseInt(y[1]):0;r=b>r?b:r}return`${s} #${r+1}`}async m(t){this.g=await this.p(t);const n=this.r(this.g);if(n.version!==it.a)throw new Error((0,D.localize)(0,null,this.k.nameLong));return n}async n(t){const n=JSON.stringify(t),s=await this.i.writeResource(it.b,n,this.g?.ref||null);this.g={ref:s,content:n},this.c.fire()}async p(t){if(this.g){const n=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.j.error(n)}return{version:it.a,machines:[]}}};i.a=1,i.b="machines",i=ye([J(0,R.IEnvironmentService),J(1,C.IFileService),J(2,g.IStorageService),J(3,f.IUserDataSyncStoreService),J(4,f.IUserDataSyncLogService),J(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(re[279],oe([0,1,6,63,38,8,3,2,4,25,10,182,26,20,19,23,76,79]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",p="sync.sessionId",E="sync.storeUrl",P="sync.productQuality";let i=class extends R.Disposable{get j(){const n=this.z.get(E,-1);return n?I.URI.parse(n):void 0}set j(n){n?this.z.store(E,n.toString(),-1,1):this.z.remove(E,-1)}get l(){return this.z.get(P,-1)}set l(n){n?this.z.store(P,n,-1,1):this.z.remove(P,-1)}constructor(n,s,a,r,l,y,b,O,N,F){super(),this.n=s,this.p=a,this.r=r,this.s=l,this.u=y,this.v=b,this.w=O,this.y=N,this.z=F,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(b.onDidChangeAccount(()=>this.C())),this.B(a.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(l.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(D.Event.filter(this.r.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:s}=this.F();n?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,s,a){try{this.v.account&&!a&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(r){if(this.u.error(r),s)this.G(!1);else throw r}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const s=v.UserDataSyncError.toUserDataSyncError(n);s instanceof v.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(m,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(m,-1,!1)}M(){this.z.remove(m,-1)}async triggerSync(n,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const r=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:r}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([J(0,g.IProductService),J(1,v.IUserDataSyncStoreManagementService),J(2,v.IUserDataSyncStoreService),J(3,v.IUserDataSyncEnablementService),J(4,v.IUserDataSyncService),J(5,v.IUserDataSyncLogService),J(6,h.IUserDataSyncAccountService),J(7,d.ITelemetryService),J(8,u.IUserDataSyncMachinesService),J(9,f.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends R.Disposable{constructor(n,s,a,r,l,y,b,O){super(),this.j=n,this.k=s,this.l=a,this.m=r,this.n=l,this.p=y,this.r=b,this.s=O,this.b=this.B(new R.MutableDisposable),this.c=this.B(new D.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new D.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}u(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(o.a,!1),this.k)}sync(n,s){const a=(0,L.createCancelablePromise)(async r=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(l){if((0,k.isCancellationError)(l))return}return this.y(n,s,r)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!n&&(!(0,S.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,S.isEqual)(s.stableUrl,n.stableUrl))}async y(n,s,a){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let r;try{await this.z(s,a)}catch(l){if(this.r.error(l),r=l,v.UserDataSyncError.toUserDataSyncError(l).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,a),r=void 0}catch(y){this.r.error(y),r=y}}this.f.fire(r)}async z(n,s){if(this.h=await this.n.createSyncTask(this.g,n),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new v.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const a=this.s.get(p,-1);if(a&&this.g&&a!==this.g.session)throw this.v()?await this.w()?new v.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const r=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const l=r.find(y=>y.isCurrent);if(l?.disabled)throw new v.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(y){throw new v.UserDataAutoSyncError((0,c.toErrorMessage)(y),y instanceof v.UserDataSyncError?y.code:"Unknown")}this.g&&this.g.session!==a&&this.s.store(p,this.g.session,-1,1),!s.isCancellationRequested&&(l||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}o.a="Interval"}),define(re[280],oe([0,1,10,186,15,14,44,20,30,23,18,41,124,123,122,17,125,120,121,5,126,42]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class He{constructor(t,n,s,a,r,l,y,b,O,N){this.e=t,this.f=n,this.g=s,this.h=r,this.i=l,this.j=y,this.k=b,this.l=O,this.m=N,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const n=this.K(t.content,"profiles");return(0,E.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.e.getAllResourceRefs(t,n?.collection)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:r,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.f.getAllRefs(n,t)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:r,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.J(t),s=n?this.k.profiles.find(a=>a.id===n.profile):void 0;return n&&s?{profile:s,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.J(t);if(!n)return[];const s=this.k.profiles.find(a=>a.id===n.profile);switch(n.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const n=this.J(t);if(!!n){if(n.remote){if(n.ref){const{content:s}=await this.L(n.syncResource,n.ref,n.collection);if(s)return this.K(s,n.syncResource)?.machineId}return}return(0,D.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const n=this.J(t);if(!n||n.node===He.a)return null;if(n.ref){const s=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&s?this.o(n.syncResource,s,n.node):s}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(t,n,s,a,r){if(t){const{content:y}=await this.L(n,r,a);return y}const l=this.k.profiles.find(y=>y.id===s);return l?this.f.resolveContent(l,n,r):null}o(t,n,s){const a=this.K(n,t);switch(t){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(t,n){const s=this.k.profiles.find(a=>a.id===n);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,n){const s=this.d.joinPath(t,"settings.json"),a=n?n.settingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}s(t,n){switch(n){case"settings.json":return(0,f.parseSettingsSyncContent)(t.content).settings}return null}t(t,n){const s=this.d.joinPath(t,"keybindings.json"),a=n?n.keybindingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}u(t,n){switch(n){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,n){const s=this.d.joinPath(t,"tasks.json"),a=n?n.tasksResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}w(t,n){switch(n){case"tasks.json":return(0,h.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,n){const s=await this.resolveContent(t);if(s){const a=this.K(s,"snippets");if(a){const r=(0,g.parseSnippets)(a),l=[];for(const y of Object.keys(r)){const b=this.d.joinPath(t,y),O=n?this.d.joinPath(n.snippetsHome,y):this.d.joinPath(t,He.a);l.push({resource:b,comparableResource:O})}return l}}return[]}y(t,n){return(0,g.parseSnippets)(t)[n]||null}z(t,n){const s=this.d.joinPath(t,"extensions.json"),a=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}A(t,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:n}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(n,!0)}C(t,n){const s=this.d.joinPath(t,"globalState.json"),a=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}D(t,n){switch(n){case"globalState.json":return(0,m.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const n=await this.m.createInstance(m.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,m.stringify)(n,!0)}F(t,n){const s=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(t,n){switch(n){case"profiles.json":return(0,P.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,E.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(t){const n=t.remote?He.b:He.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(L.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...s)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==He.c&&t.authority!==He.b)return;const n=[];for(;t.path!=="/";)n.unshift(this.d.basename(t)),t=this.d.dirname(t);if(n.length<2)return;const s=t.authority===He.b,a=n.shift(),r=n.shift();let l,y,b;for(;n.length;){const O=n.shift();O.startsWith("collection:")?l=O.substring(11):O.startsWith("ref:")?y=O.substring(4):b=O}return{remote:s,syncResource:a,profile:r,collection:l,ref:y,node:b}}K(t,n){try{const s=JSON.parse(t);if((0,w.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new S.UserDataSyncError((0,A.localize)(0,null),"IncompatibleRemoteContent",n)}async L(t,n,s){const a=await this.e.resolveResourceContent(t,n,s);return{ref:n,content:a}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncBackupStoreService),J(2,S.IUserDataSyncLogService),J(3,C.IUriIdentityService),J(4,c.IEnvironmentService),J(5,R.IStorageService),J(6,k.IFileService),J(7,I.IUserDataProfilesService),J(8,v.IConfigurationService),J(9,p.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(re[281],oe([0,1,21,6,24,38,3,2,25,12,31,17,29,5,20,19,18,120,121,122,123,124,125,126,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let s=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(b,O,N,F,z,G,Y,W,T){super(),this.v=b,this.w=O,this.y=N,this.z=F,this.C=z,this.D=G,this.F=Y,this.G=W,this.H=T,this.f="uninitialized",this.g=this.B(new D.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new D.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new D.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new D.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new D.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new D.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=O.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(b,O){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),F=(0,I.generateUuid)();try{const W=(0,t.createSyncHeaders)(F);O&&(W["Cache-Control"]="no-cache"),b=await this.v.manifest(b,W)}catch(W){const T=t.UserDataSyncError.toUserDataSyncError(W);throw l(T,F,this.w,this.C),T}const z=!1,G=this;let Y;return{manifest:b,async run(){if(z)throw new Error("Can run a task only once");Y=(0,A.createCancelablePromise)(W=>G.I(b,!1,F,W)),await Y.finally(()=>Y=void 0),G.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),G.S()},stop(){return Y?.cancel(),G.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const b=new Date().getTime(),O=(0,I.generateUuid)(),N=(0,t.createSyncHeaders)(O);let F;try{F=await this.v.manifest(null,N)}catch(Y){const W=t.UserDataSyncError.toUserDataSyncError(Y);throw l(W,O,this.w,this.C),W}await this.resetLocal();const z=this,G=new c.CancellationTokenSource;return{id:O,async merge(){return z.I(F,!0,O,G.token)},async apply(){try{try{await z.L(F,O,G.token)}catch(Y){if(t.UserDataSyncError.toUserDataSyncError(Y).code==="MethodNotFound")z.z.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.z.info("Applying manual sync again..."),await z.L(F,O,G.token);else throw Y}}catch(Y){throw z.z.error(Y),Y}z.z.info(`Sync done. Took ${new Date().getTime()-b}ms`),z.S()},async stop(){G.cancel(),await z.N(),await z.resetLocal()}}}async I(b,O,N,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(z,b,O,N,F));const G=z.enabled.find(Y=>Y.resource==="profiles");if(G){const Y=await G.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J(Y,b,O,N,F)}}finally{this.l.fire(this.k)}}async J(b,O,N,F,z){for(const G of b){if(z.isCancellationRequested)return;const Y=this.G.profiles.find(T=>T.id===G.id);if(!Y){this.z.error(`Profile with id:${G.id} and name: ${G.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",G.name);const W=this.getOrCreateActiveProfileSynchronizer(Y,G);this.k.push(...await this.M(W,O,N,F,z))}for(const[G,Y]of this.u.entries())this.G.profiles.some(W=>W.id===Y[0].profile.id)||(Y[1].dispose(),this.u.delete(G))}async L(b,O,N){const F=this.U();for(const T of F){if(N.isCancellationRequested)return;await T.apply(O,N)}const z=F.find(T=>T.profile.isDefault);if(!z)return;const G=z.enabled.find(T=>T.resource==="profiles");if(!G)return;const W=(await G.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(T=>F.every(B=>B.profile.id!==T.id));W.length&&await this.J(W,b,!1,O,N)}async M(b,O,N,F,z){return(await b.sync(O,N,F,z)).map(([Y,W])=>({profile:b.profile,syncResource:Y,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(b=>b.stop()))}async resolveContent(b){const O=await this.H.resolveContent(b);if(O)return O;for(const N of this.U())for(const F of N.enabled){const z=await F.resolveContent(b);if(z)return z}return null}async replace(b){this.X();const O=this.H.resolveUserDataSyncResource(b);if(!O)return;const N=await this.resolveContent(b.uri);!N||await this.O(O.profile,async F=>{if(O.syncResource===F.resource)return await F.replace(N),!0})}async accept(b,O,N,F){this.X(),await this.O(b.profile,async z=>{if(b.syncResource===z.resource)return await z.accept(O,N),F&&await z.apply((0,S.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(b,O){return this.H.getRemoteSyncResourceHandles(b,O)}async getLocalSyncResourceHandles(b,O){return this.H.getLocalSyncResourceHandles(b,O??this.G.defaultProfile)}async getAssociatedResources(b){return this.H.getAssociatedResources(b)}async getMachineId(b){return this.H.getMachineId(b)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(b){this.z.error(b)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[b]of this.u.values())try{await b.resetLocal()}catch(O){this.z.error(O)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const b=await this.H.getRemoteSyncedProfiles(),O=b.map(G=>G.collection),N=await this.v.getAllCollections(),F=N.filter(G=>!O.includes(G));F.length&&(this.z.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(G=>this.v.deleteCollection(G))),this.z.info("Deleted redundant collections on server"));const z=b.filter(G=>N.includes(G.collection));if(z.length!==b.length){this.z.info("Updating remote profiles with invalid collections on server");const G=this.y.createInstance(o.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await G.updateRemoteProfiles(z,null),this.z.info("Updated remote profiles on server")}finally{G.dispose()}}}async O(b,O){const N=new R.DisposableStore;try{const F=this.u.get(b.id);if(F){const T=await this.P(F[0],O,N);return(0,S.isUndefined)(T)?null:T}if(b.isDefault){const T=N.add(this.y.createInstance(a,b,void 0)),B=await this.P(T,O,N);return(0,S.isUndefined)(B)?null:B}if(this.G.isEnabled())return null;const z=N.add(this.y.createInstance(o.UserDataProfilesManifestSynchroniser,b,void 0)),G=await this.v.manifest(null),W=(await z.getRemoteSyncedProfiles(G?.latest??null)||[]).find(T=>T.id===b.id);if(W){const T=N.add(this.y.createInstance(a,b,W.collection)),B=await this.P(T,O,N);return(0,S.isUndefined)(B)?null:B}return null}finally{N.dispose()}}async P(b,O,N){const F=[...b.enabled,...b.disabled.map(z=>N.add(b.createSynchronizer(z)))];for(const z of F){const G=await O(z);if(!(0,S.isUndefined)(G))return G}}Q(b){const O=this.f;this.f!==b&&(this.f=b,this.g.fire(b),O==="hasConflicts"&&this.S())}R(){const b=this.U().map(O=>O.conflicts).flat();(0,L.equals)(this.i,b,(O,N)=>O.profile.id===N.profile.id&&O.syncResource===N.syncResource&&(0,L.equals)(O.conflicts,N.conflicts,(F,z)=>(0,C.isEqual)(F.previewResource,z.previewResource)))||(this.i=b,this.j.fire(b))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(b,O){let N=this.u.get(b.id);if(N&&N[0].collection!==O?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(b.id)),!N){const F=new R.DisposableStore,z=F.add(this.y.createInstance(a,b,O?.collection));F.add(z.onDidChangeStatus(G=>this.Q(G))),F.add(z.onDidChangeConflicts(G=>this.R())),F.add(z.onDidChangeLocal(G=>this.h.fire(G))),this.u.set(b.id,N=[z,F])}return N[0]}U(){const b=[];for(const[O]of this.u.values())b.push(O);return b}W(){this.u.forEach(([,b])=>b.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=ye([J(0,t.IUserDataSyncStoreService),J(1,t.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,t.IUserDataSyncLogService),J(4,v.ITelemetryService),J(5,d.IStorageService),J(6,t.IUserDataSyncEnablementService),J(7,h.IUserDataProfilesService),J(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends R.Disposable{get enabled(){return this.f.sort((b,O)=>b[1]-O[1]).map(([b])=>b)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(b=>!this.l.isResourceEnabled(b))}get status(){return this.g}get conflicts(){return this.j}constructor(b,O,N,F,z,G,Y,W,T,B){super(),this.profile=b,this.collection=O,this.l=N,this.m=F,this.n=z,this.r=G,this.t=Y,this.u=W,this.v=T,this.w=B,this.f=[],this.g="idle",this.h=this.B(new D.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new D.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new D.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([_,q])=>this.y(_,q))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,_])=>_.dispose())));for(const _ of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(_)&&this.z(_)}y(b,O){O?this.z(b):this.C(b)}z(b){if(this.f.some(([z])=>z.resource===b))return;if(b==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(b==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const O=new R.DisposableStore,N=O.add(this.createSynchronizer(b));O.add(N.onDidChangeStatus(()=>this.G())),O.add(N.onDidChangeConflicts(()=>this.H())),O.add(N.onDidChangeLocal(()=>this.i.fire(b)));const F=this.I(b);this.f.push([N,F,O])}C(b){const O=this.f.findIndex(([N])=>N.resource===b);if(O!==-1){const[[N,,F]]=this.f.splice(O,1);F.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,z=>this.u.error(z))}}createSynchronizer(b){switch(b){case"settings":return this.m.createInstance(E.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(P.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(m.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,O,N,F){if(F.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const G=[],Y=(0,t.createSyncHeaders)(N),W=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,T=O?await this.D(W):{};for(const B of z){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(B.resource))return[];try{if(O){const _=await B.preview(W,T,Y);if(_)for(const q of _.resourcePreviews)(q.localChange!==0||q.remoteChange!==0)&&q.mergeState==="preview"&&await B.merge(q.previewResource)}else await B.sync(W,Y)}catch(_){const q=t.UserDataSyncError.toUserDataSyncError(_);if(l(q,N,this.r,this.t),r(_))throw q;this.u.error(_),this.u.error(`${B.resource}: ${(0,k.toErrorMessage)(_)}`),G.push([B.resource,q])}}return G}finally{this.G()}}async apply(b,O){const N=(0,t.createSyncHeaders)(b);for(const F of this.enabled){if(O.isCancellationRequested)return;try{await F.apply(!1,N)}catch(z){const G=t.UserDataSyncError.toUserDataSyncError(z);if(l(G,b,this.r,this.t),r(z))throw G;this.u.error(z),this.u.error(`${F.resource}: ${(0,k.toErrorMessage)(z)}`)}}}async stop(){for(const b of this.enabled)try{b.status!=="idle"&&await b.stop()}catch(O){this.u.error(O)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(O){this.u.error(`${b.resource}: ${(0,k.toErrorMessage)(O)}`),this.u.error(O)}}async D(b){if(!this.profile.isDefault)return{};const O=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(F=>F instanceof E.SettingsSynchroniser);if(N){const F=await N.getRemoteUserDataSyncConfiguration(b);return{...O,...F}}return O}F(b){this.g!==b&&(this.g=b,this.h.fire(b))}G(){return this.H(),this.enabled.some(b=>b.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(b=>b.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const b=this.enabled.filter(O=>O.status==="hasConflicts").filter(O=>O.conflicts.conflicts.length>0).map(O=>O.conflicts);(0,L.equals)(this.j,b,(O,N)=>O.syncResource===N.syncResource&&(0,L.equals)(O.conflicts,N.conflicts,(F,z)=>(0,C.isEqual)(F.previewResource,z.previewResource)))||(this.j=b,this.k.fire(b))}I(b){switch(b){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([J(2,t.IUserDataSyncEnablementService),J(3,f.IInstantiationService),J(4,g.IExtensionGalleryService),J(5,t.IUserDataSyncStoreManagementService),J(6,v.ITelemetryService),J(7,t.IUserDataSyncLogService),J(8,h.IUserDataProfilesService),J(9,w.IConfigurationService)],a);function r(y){if(y instanceof t.UserDataSyncError)switch(y.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function l(y,b,O,N){N.publicLog2("sync/error",{code:y.code,serverCode:y instanceof t.UserDataSyncStoreError?String(y.serverCode):void 0,url:y instanceof t.UserDataSyncStoreError?y.url:void 0,resource:y.resource,executionId:b,service:O.userDataSyncStore.url.toString()})}}),define(re[282],oe([0,1,3,2,10,18,23]),function(te,e,L,A,c,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(g,f){return{...g,profile:(0,k.reviveProfile)(g.profile,f.profilesHome.scheme)}}function C(g){return{created:g.created,uri:c.URI.revive(g.uri)}}class S{constructor(f,d,v){this.c=f,this.d=d,this.f=v,this.a=new Map,this.b=new L.Emitter}listen(f,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(f,d,v){try{return await this.g(f,d,v)}catch(h){throw this.f.error(h),h}}async g(f,d,v){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(c.URI.revive(v[0]));case"accept":return this.c.accept(R(v[0],this.d),c.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(v[0],v[1]?(0,k.reviveProfile)(v[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.c.replace(C(v[0]));case"getAssociatedResources":return this.c.getAssociatedResources(C(v[0]));case"getMachineId":return this.c.getMachineId(C(v[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const h=d.substring(11),u=v[0],m=this.h(u);switch(v=v.slice(1),h){case"merge":return m.merge();case"apply":return m.apply().then(()=>this.a.delete(this.j(m.id)));case"stop":return m.stop().finally(()=>this.a.delete(this.j(m.id)))}}throw new Error("Invalid call")}h(f){const d=this.a.get(this.j(f));if(!d)throw new Error(`Manual sync taks not found: ${f}`);return d}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=S;let I=class extends A.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(v,h,u){return f.call(v,h,u).then(null,m=>{throw D.UserDataSyncError.toUserDataSyncError(m)})},listen(v,h){return f.listen(v,h)}},this.a.call("_getInitialData").then(([v,h,u])=>{this.l(v),this.m(h),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(m=>this.l(m))),this.B(this.a.listen("onDidChangeLastSyncTime")(m=>this.n(m)))}),this.B(this.a.listen("onDidChangeConflicts")(v=>this.m(v))),this.B(this.a.listen("onSyncErrors")(v=>this.j.fire(v.map(h=>({...h,error:D.UserDataSyncError.toUserDataSyncError(h.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),d=this;return new w(f,{async call(h,u,m){return d.a.call(`manualSync/${h}`,[f,...Array.isArray(u)?u:[u]],m)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,d,v,h){return this.a.call("accept",[f,d,v,h])}resolveContent(f){return this.a.call("resolveContent",[f])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,d){return(await this.a.call("getLocalSyncResourceHandles",[f,d])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getRemoteSyncResourceHandles(f,d){return(await this.a.call("getRemoteSyncResourceHandles",[f,d])).map(({created:h,uri:u})=>({created:h,uri:c.URI.revive(u)}))}async getAssociatedResources(f){return(await this.a.call("getAssociatedResources",[f])).map(({resource:v,comparableResource:h})=>({resource:c.URI.revive(v),comparableResource:c.URI.revive(h)}))}getMachineId(f){return this.a.call("getMachineId",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}async l(f){this.b=f,this.c.fire(f)}async m(f){this.f=f.map(d=>({syncResource:d.syncResource,profile:(0,k.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(v=>({...v,baseResource:c.URI.revive(v.baseResource),localResource:c.URI.revive(v.localResource),remoteResource:c.URI.revive(v.remoteResource),previewResource:c.URI.revive(v.previewResource)}))})),this.g.fire(this.f)}n(f){this.h!==f&&(this.h=f,this.i.fire(f))}};I=ye([J(1,k.IUserDataProfilesService)],I),e.UserDataSyncChannelClient=I;class w extends A.Disposable{constructor(f,d){super(),this.id=f,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[283],oe([0,1,6,24,8,3,2,141,4,25,12,10,31,17,15,14,26,58,44,20,23]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const P="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let a=class extends D.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(E.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(E.SYNC_SERVICE_URL_TYPE,N,-1,C.isWeb?0:1)}constructor(N,F,z){super(),this.f=N,this.g=F,this.h=z,this.a=this.B(new k.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(k.Event.filter(z.onDidChangeValue,G=>G.key===E.SYNC_SERVICE_URL_TYPE&&G.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[E.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(E.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,F){N=C.isWeb&&N?.web?{...N,...N.web}:N;const z={...N||{},...F||{}};if(z&&(0,I.isString)(z.url)&&(0,I.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(G=>Array.isArray(z.authenticationProviders[G].scopes))){const G=z,Y=!!G.canSwitch&&!F?.url,W=G.url===G.insidersUrl?"insiders":"stable",T=(Y?this.c:void 0)||W,B=F?.url||(T==="insiders"?G.insidersUrl:T==="stable"?G.stableUrl:G.url);return{url:w.URI.parse(B),type:T,defaultType:W,defaultUrl:w.URI.parse(G.url),stableUrl:w.URI.parse(G.stableUrl),insidersUrl:w.URI.parse(G.insidersUrl),canSwitch:Y,authenticationProviders:Object.keys(G.authenticationProviders).reduce((_,q)=>(_.push({id:q,scopes:G.authenticationProviders[q].scopes}),_),[])}}}};a=ye([J(0,h.IProductService),J(1,f.IConfigurationService),J(2,p.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let r=class extends a{constructor(N,F,z){super(N,F,z);const G=this.h.get(P,-1);G&&(this.k=JSON.parse(G));const Y=this.f[E.CONFIGURATION_SYNC_STORE_KEY];Y?this.h.store(P,JSON.stringify(Y),-1,1):this.h.remove(P,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};r=ye([J(0,h.IProductService),J(1,f.IConfigurationService),J(2,p.IStorageService)],r),e.UserDataSyncStoreManagementService=r;let l=class extends D.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,F,z,G,Y,W,T){super(),this.k=z,this.l=G,this.n=T,this.g=this.B(new k.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new k.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,m.getServiceMachineId)(Y,W,T).then(B=>{const _={"X-Client-Name":`${F.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(_["X-Client-Commit"]=F.commit),_}),this.f=new b(n,s,this.k,this.l),this.r(),this.B((0,D.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(i,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,L.createCancelablePromise)(F=>(0,L.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.t(void 0))),this.s.then(null,F=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const z=await this.w(F,{type:"GET",headers:N},[],A.CancellationToken.None);return(await(0,u.asJson)(z))?.map(({id:G})=>G)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const z=await this.w(F,{type:"POST",headers:N},[],A.CancellationToken.None),G=await(0,u.asTextOrError)(z);if(!G)throw new E.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",z.res.statusCode,z.res.headers[E.HEADER_OPERATION_ID]);return G}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();F={...F},await this.w(z,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,F,N),G={},Y=await this.w(z.toString(),{type:"GET",headers:G},[],A.CancellationToken.None);return(await(0,u.asJson)(Y)||[]).map(({url:T,created:B})=>({ref:(0,S.relativePath)(z,z.with({path:T})),created:B*1e3}))}async resolveResourceContent(N,F,z,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,S.joinPath)(this.u(this.a,z,N),F).toString();G={...G},G["Cache-Control"]="no-cache";const W=await this.w(Y,{type:"GET",headers:G},[],A.CancellationToken.None);return await(0,u.asTextOrError)(W)}async deleteResource(N,F,z){if(!this.a)throw new Error("No settings sync store url configured.");const G=F!==null?(0,S.joinPath)(this.u(this.a,z,N),F).toString():this.u(this.a,z,N).toString(),Y={};await this.w(G,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async readResource(N,F,z,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,S.joinPath)(this.u(this.a,z,N),"latest").toString();G={...G},G["Cache-Control"]="no-cache",F&&(G["If-None-Match"]=F.ref);const W=await this.w(Y,{type:"GET",headers:G},[304],A.CancellationToken.None);let T=null;if(W.res.statusCode===304&&(T=F),T===null){const B=W.res.headers.etag;if(!B)throw new E.UserDataSyncStoreError("Server did not return the ref",Y,"NoRef",W.res.statusCode,W.res.headers[E.HEADER_OPERATION_ID]);const _=await(0,u.asTextOrError)(W);if(!_&&W.res.statusCode===304)throw new E.UserDataSyncStoreError("Empty response",Y,"EmptyResponse",W.res.statusCode,W.res.headers[E.HEADER_OPERATION_ID]);T={ref:B,content:_}}return T}async writeResource(N,F,z,G,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.u(this.a,G,N).toString();Y={...Y},Y["Content-Type"]=R.Mimes.text,z&&(Y["If-Match"]=z);const T=await this.w(W,{type:"POST",data:F,headers:Y},[],A.CancellationToken.None),B=T.res.headers.etag;if(!B)throw new E.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",T.res.statusCode,T.res.headers[E.HEADER_OPERATION_ID]);return B}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,S.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const G=await this.w(z,{type:"GET",headers:F},[304],A.CancellationToken.None);let Y=null;if(G.res.statusCode===304&&(Y=N),!Y){const T=G.res.headers.etag;if(!T)throw new E.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",G.res.statusCode,G.res.headers[E.HEADER_OPERATION_ID]);const B=await(0,u.asTextOrError)(G);if(!B&&G.res.statusCode===304)throw new E.UserDataSyncStoreError("Empty response",z,"EmptyResponse",G.res.statusCode,G.res.headers[E.HEADER_OPERATION_ID]);B&&(Y={...JSON.parse(B),ref:T})}const W=this.n.get(o,-1);return W&&Y&&W!==Y.session&&this.v(),Y===null&&W&&this.v(),Y&&this.n.store(o,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,F,z){return F?(0,S.joinPath)(N,"collection",F,"resource",z):(0,S.joinPath)(N,"resource",z)}v(){this.n.remove(o,-1),this.n.remove(t,-1)}async w(N,F,z,G){if(!this.b)throw new E.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(F.headers),this.l.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(N,F,G)}catch(x){if(!(x instanceof E.UserDataSyncStoreError)){let M="RequestFailed";const X=(0,c.getErrorMessage)(x).toLowerCase();X.includes("xhr timeout")?M="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?M="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?M="RequestPathNotEscaped":X.includes("headers must be an object")?M="RequestHeadersNotObject":(0,c.isCancellationError)(x)&&(M="RequestCanceled"),x=new E.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,M,void 0,void 0)}throw this.l.info("Request failed",N),x}const T=W.res.headers[E.HEADER_OPERATION_ID],B={url:N,status:W.res.statusCode,"execution-id":F.headers[E.HEADER_EXECUTION_ID],"operation-id":T},_=(0,u.isSuccess)(W)||W.res.statusCode&&z.indexOf(W.res.statusCode)!==-1;let q="";if(_?this.l.trace("Request succeeded",B):(this.l.info("Request failed",B),q=await(0,u.asText)(W)||""),W.res.statusCode===401)throw this.b=void 0,this.g.fire(),new E.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",W.res.statusCode,T);if(this.h.fire(),W.res.statusCode===404)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",W.res.statusCode,T);if(W.res.statusCode===405)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${q}`,N,"MethodNotFound",W.res.statusCode,T);if(W.res.statusCode===409)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",W.res.statusCode,T);if(W.res.statusCode===410)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",W.res.statusCode,T);if(W.res.statusCode===412)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",W.res.statusCode,T);if(W.res.statusCode===413)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",W.res.statusCode,T);if(W.res.statusCode===426)throw new E.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",W.res.statusCode,T);if(W.res.statusCode===429){const x=W.res.headers["retry-after"];throw x?(this.t(new Date(Date.now()+parseInt(x)*1e3)),new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",W.res.statusCode,T)):new E.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",W.res.statusCode,T)}if(!_)throw new E.UserDataSyncStoreError("Server returned "+W.res.statusCode,N,"Unknown",W.res.statusCode,T);return W}y(N){let F=this.n.get(t,-1);F===void 0&&(F=(0,g.generateUuid)(),this.n.store(t,F,-1,1)),N["X-Machine-Session-Id"]=F;const z=this.n.get(o,-1);z!==void 0&&(N["X-User-Session-Id"]=z)}};l=ye([J(1,h.IProductService),J(2,u.IRequestService),J(3,E.IUserDataSyncLogService),J(4,d.IEnvironmentService),J(5,v.IFileService),J(6,p.IStorageService)],l),e.UserDataSyncStoreClient=l;let y=class extends l{constructor(N,F,z,G,Y,W,T){super(N.userDataSyncStore?.url,F,z,G,Y,W,T),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};y=ye([J(0,E.IUserDataSyncStoreManagementService),J(1,h.IProductService),J(2,u.IRequestService),J(3,E.IUserDataSyncLogService),J(4,d.IEnvironmentService),J(5,v.IFileService),J(6,p.IStorageService)],y),e.UserDataSyncStoreService=y;class b{constructor(N,F,z,G){this.c=N,this.d=F,this.f=z,this.g=G,this.a=[],this.b=void 0}request(N,F,z){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new E.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=b}),define(re[284],oe([0,1,3,56,26,20,19,279,23,76,79]),function(te,e,L,A,c,k,D,R,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends R.UserDataAutoSyncService{constructor(f,d,v,h,u,m,p,E,P,i,o){super(f,d,v,h,u,p,E,P,i,o),this.B(L.Event.debounce(L.Event.any(L.Event.map(m.onDidFocusWindow,()=>"windowFocus"),L.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=ye([J(0,c.IProductService),J(1,C.IUserDataSyncStoreManagementService),J(2,C.IUserDataSyncStoreService),J(3,C.IUserDataSyncEnablementService),J(4,C.IUserDataSyncService),J(5,A.INativeHostService),J(6,C.IUserDataSyncLogService),J(7,S.IUserDataSyncAccountService),J(8,D.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,k.IStorageService)],w),e.UserDataAutoSyncService=w}),define(re[285],oe([0,1,101,22,4,25]),function(te,e,L,A,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(S){function I(){let w=S.scheme===A.Schemas.file?(0,k.originalFSPath)(S):S.toString();return c.isLinux||(w=w.toLowerCase()),(0,L.createHash)("md5").update(w).digest("hex")}return{id:I(),configPath:S}}e.getWorkspaceIdentifier=D;function R(S,I){function w(){if(S.scheme!==A.Schemas.file)return(0,L.createHash)("md5").update(S.toString()).digest("hex");if(!I)return;let f;return c.isLinux?f=I.ino:c.isMacintosh?f=I.birthtime.getTime():c.isWindows&&(typeof I.birthtimeMs=="number"?f=Math.floor(I.birthtimeMs):f=I.birthtime.getTime()),(0,L.createHash)("md5").update(S.fsPath).update(f?String(f):"").digest("hex")}const g=w();if(typeof g=="string")return{id:g,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(re[286],oe([0,1,6,8,2,13,28,15,11,74,118,285,56,70]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends c.Disposable{constructor(h,u,m,p){super(),this.a=h,this.b=u,this.c=m,this.f=p,this.B(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=await D.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new S.StorageClient(this.f.getChannel("storage"));await Promise.all(h.map(async m=>{const p=(0,k.join)(this.a.workspaceStorageHome.fsPath,m);m.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||m===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===m)||await u.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await D.Promises.rm(p))}))}catch(h){(0,A.onUnexpectedError)(h)}}};d=ye([J(0,R.INativeEnvironmentService),J(1,C.ILogService),J(2,g.INativeHostService),J(3,f.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(re[80],oe([0,1,53,6,13,12,28,153,296,297]),function(te,e,L,A,c,k,D,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class w extends Error{constructor(o,t){let n=t.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=t}}e.ExtractError=w;function g(i){const o=i.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,n)=>t+n,o&61440)}function f(i){if(i instanceof w)return i;let o;return I.test(i.message)&&(o="CorruptZip"),new w(o,i)}function d(i,o,t,n,s,a){const r=c.dirname(o),l=c.join(n,r);if(!l.startsWith(n))return Promise.reject(new Error(R.localize(0,null,o)));const y=c.join(n,o);let b;return a.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(D.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!a.isCancellationRequested)try{b=(0,L.createWriteStream)(y,{mode:t}),b.once("close",()=>O()),b.once("error",N),i.once("error",N),i.pipe(b)}catch(F){N(F)}}))}function v(i,o,t,n){let s=(0,A.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),i.close()}),new Promise((r,l)=>{const y=new A.Sequencer,b=O=>{O.isCancellationRequested||(a++,i.readEntry())};i.once("error",l),i.once("close",()=>s.then(()=>{n.isCancellationRequested||i.entryCount===a?r():l(new w("Incomplete",new Error(R.localize(1,null,a,i.entryCount))))},l)),i.readEntry(),i.on("entry",O=>{if(n.isCancellationRequested)return;if(!t.sourcePathRegex.test(O.fileName)){b(n);return}const N=O.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(N)){const G=c.join(o,N);s=(0,A.createCancelablePromise)(Y=>D.Promises.mkdir(G,{recursive:!0}).then(()=>b(Y)).then(void 0,l));return}const F=u(i,O),z=g(O);s=(0,A.createCancelablePromise)(G=>y.queue(()=>F.then(Y=>d(Y,N,z,o,t,G).then(()=>b(G)))).then(null,l))})})}function h(i,o=!1){return new Promise((t,n)=>{(0,C.open)(i,o?{lazyEntries:!0}:void 0,(s,a)=>{s?n(f(s)):t((0,k.assertIsDefined)(a))})})}function u(i,o){return new Promise((t,n)=>{i.openReadStream(o,(s,a)=>{s?n(f(s)):t((0,k.assertIsDefined)(a))})})}function m(i,o){return new Promise((t,n)=>{const s=new S.ZipFile;o.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const a=(0,L.createWriteStream)(i);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>t(i))})}e.zip=m;function p(i,o,t={},n){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let a=h(i,!0);return t.overwrite&&(a=a.then(r=>D.Promises.rm(o).then(()=>r))),a.then(r=>v(r,o,{sourcePathRegex:s},n))}e.extract=p;function E(i,o){return h(i).then(t=>new Promise((n,s)=>{t.on("entry",a=>{a.fileName===o&&u(t,a).then(r=>n(r),r=>s(r))}),t.once("close",()=>s(new Error(R.localize(2,null,o))))}))}function P(i,o){return E(i,o).then(t=>new Promise((n,s)=>{const a=[];t.once("error",s),t.on("data",r=>a.push(r)),t.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=P}),define(re[287],oe([0,1,6,8,2,22,4,25,54,12,31,28,80,17,15,29,33,99,14,11]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class yt extends c.Disposable{constructor(i,o,t,n,s,a){super(),this.h=o,this.i=t,this.j=n,this.k=s,this.l=a,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(i,o){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.v(i));try{await this.r(i,t,s=>this.i.download(i,s,o))}catch(s){throw new v.ExtensionManagementError(s.message,v.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.m(i)){const s=await this.n(i);try{await this.k.verify(t.fsPath,s.fsPath,this.l.getLevel()===p.LogLevel.Trace)&&(n="Verified"),this.l.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`)}catch(a){const r=a,l=r.code;if(r.output&&this.l.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${r.output}`),l==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`);else{if(l==="PackageIsInvalidZip"||l==="SignatureArchiveIsInvalidZip")throw new v.ExtensionManagementError(g.CorruptZipMessage,v.ExtensionManagementErrorCode.CorruptZip);if(!r.didExecute)this.l.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n} (${l})`);else throw await this.delete(t),new v.ExtensionManagementError(l,v.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(s)}catch(a){this.l.error(a)}}}return{location:t,verificationStatus:n}}m(i){if(!i.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(o)?o:!0}async n(i){await this.g;const o=(0,R.joinPath)(this.extensionsDownloadDir,`${this.v(i)}${yt.c}`);return await this.r(i,o,t=>this.i.downloadSignatureArchive(i,t)),o}async r(i,o,t){if(await this.h.exists(o))return;if(o.scheme!==k.Schemas.file){await t(o);return}const n=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.h.exists(n)||await t(n);try{await this.t(n,o,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,A.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async t(i,o,t){try{await w.Promises.rename(i.fsPath,o.fsPath)}catch(n){if(D.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${i} to ${o} with 'EPERM' error. Trying again...`),this.t(i,o,t);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],t=[],n=[];for(const r of i.children)if(r.name.endsWith(yt.c))n.push(r.resource);else{const l=h.ExtensionKey.parse(r.name);l&&t.push([l,r])}const s=(0,h.groupByExtension)(t,([r])=>r),a=[];for(const r of s)r.sort((l,y)=>C.rcompare(l[0].version,y[0].version)),o.push(...r.slice(1).map(l=>l[1].resource)),a.push(r[0][1]);a.sort((r,l)=>r.mtime-l.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(r=>r.resource)),o.push(...n),await L.Promises.settled(o.map(r=>(this.l.trace("Deleting from cache",r.path),this.h.del(r))))}}catch(i){this.l.error(i)}}v(i){return this.f?h.ExtensionKey.create(i).toString().toLowerCase():(0,I.generateUuid)()}};E.c=".sigzip",E=ye([J(0,d.INativeEnvironmentService),J(1,m.IFileService),J(2,v.IExtensionGalleryService),J(3,f.IConfigurationService),J(4,u.IExtensionSignatureVerificationService),J(5,p.ILogService)],E),e.ExtensionsDownloader=E}),define(re[288],oe([0,1,80,163]),function(te,e,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function c(k){return(0,L.buffer)(k,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.getManifest=c}),define(re[127],oe([0,1,6,16,24,38,8,3,2,37,22,13,4,25,54,12,10,31,28,80,162,98,15,268,29,33,51,77,287,269,288,223,238,46,67,14,5,11,26,19,30,18]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o,t,n,s,a,r,l,y,b,O,N,F,z,G,Y,W,T,B,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,G.refineServiceDecorator)(t.IExtensionManagementService);let q=class extends o.AbstractExtensionManagementService{constructor(V,j,U,$,H,ee,K,Z,ie,le,he,me){super(V,j,U,le,me),this.Z=H,this.ab=ee,this.bb=K,this.cb=ie,this.db=he,this.X=this.B(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new S.ResourceSet;const pe=this.B(Z.createInstance(l.ExtensionsLifecycle));this.S=this.B(Z.createInstance(x,Ee=>pe.postUninstall(Ee))),this.U=this.B(new b.ExtensionsManifestCache($,this)),this.W=this.B(Z.createInstance(r.ExtensionsDownloader));const we=this.B(new O.ExtensionsWatcher(this,this.Z,me,ee,he,ie,U));this.B(we.onDidChangeExtensionsByAnotherSource(Ee=>this.kb(Ee))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(V){this.v.trace("ExtensionManagementService#zip",V.identifier.id);const j=await this.jb(V),U=await(0,p.zip)((0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,j);return h.URI.file(U)}async unzip(V){return this.v.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:j,cleanup:U}=await this.fb(V),$=w.resolve(j.fsPath);try{return await(0,y.getManifest)($)}finally{await U()}}getInstalled(V,j=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(V??null,j)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.S.scanUserExtensionAtLocation(V)}async install(V,j={}){this.v.trace("ExtensionManagementService#install",V.toString());const{location:U,cleanup:$}=await this.fb(V);try{const H=await(0,y.getManifest)(w.resolve(U.fsPath));if(H.engines&&H.engines.vscode&&!(0,F.isEngineValid)(H.engines.vscode,this.w.version,this.w.date))throw new Error(E.localize(0,null,(0,n.getGalleryExtensionId)(H.publisher,H.name),this.w.version));return await this.z(H,U,j)}finally{await $()}}async installFromLocation(V,j){this.v.trace("ExtensionManagementService#installFromLocation",V.toString());const U=await this.S.scanUserExtensionAtLocation(V);if(!U)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.ob([[U,void 0]],j),this.v.info("Successfully installed extension",U.identifier.id,j.toString()),U}async installExtensionsFromProfile(V,j,U){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",V,j.toString(),U.toString());const $=(await this.S.scanExtensions(1,j)).filter(H=>V.some(ee=>(0,n.areSameExtensions)(ee,H.identifier)));if($.length){const H=await Promise.all($.map(ee=>this.S.scanMetadata(ee,j)));await this.ob($.map((ee,K)=>[ee,H[K]]),U),this.v.info("Successfully installed extensions",$.map(ee=>ee.identifier.id),U.toString())}return $}async updateMetadata(V,j,U=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",V.identifier.id),j.isPreReleaseVersion&&(j.preRelease=!0),j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.pinned=j.pinned||void 0,V=await this.S.updateMetadata(V,j,U),this.U.invalidate(),this.X.fire(V),V}async reinstallFromGallery(V){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.t.isEnabled())throw new Error(E.localize(1,null));const j=await this.getTargetPlatform(),[U]=await this.t.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:j,compatible:!0},c.CancellationToken.None);if(!U)throw new Error(E.localize(2,null));await this.S.setUninstalled(V);try{await this.S.removeUninstalledExtension(V)}catch($){throw new Error(E.localize(3,null,(0,k.toErrorMessage)($)))}return this.installFromGallery(U)}copyExtensions(V,j){return this.S.copyExtensions(V,j)}markAsUninstalled(...V){return this.S.setUninstalled(...V)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(V){this.v.error(V)}}async download(V,j){const{location:U}=await this.W.download(V,j);return U}async fb(V){if(V.scheme===I.Schemas.file)return{location:V,async cleanup(){}};this.v.trace("Downloading extension from",V.toString());const j=(0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(V,j),this.v.info("Downloaded extension to",j.toString()),{location:j,cleanup:async()=>{try{await this.cb.del(j)}catch($){this.v.error($)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(V,j,U){if(h.URI.isUri(j))return new Q(V,j,U,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const $=n.ExtensionKey.create(j).toString();let H=this.Y.get($);return H||(this.Y.set($,H=new X(V,j,U,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),H.waitUntilTaskIsFinished().then(()=>this.Y.delete($))),H}R(V,j){return new se(V,j.profileLocation,this.ab)}async jb(V){const j=async $=>{let H=await m.Promises.readdir($);H=H.map(Z=>w.join($,Z));const ee=await Promise.all(H.map(Z=>m.Promises.stat(Z)));let K=Promise.resolve([]);return ee.forEach((Z,ie)=>{const le=H[ie];Z.isFile()&&(K=K.then(he=>[...he,le])),Z.isDirectory()&&(K=K.then(he=>j(le).then(me=>[...he,...me])))}),K};return(await j(V.location.fsPath)).map($=>({path:`extension/${w.relative(V.location.fsPath,$)}`,localPath:$}))}async kb({added:V,removed:j}){if(j)for(const U of j.extensions)this.v.info("Extensions removed from another source",U.id,j.profileLocation.toString()),this.p.fire({identifier:U,profileLocation:j.profileLocation});if(V){const $=(await this.S.scanExtensions(1,V.profileLocation)).filter(H=>V.extensions.some(ee=>(0,n.areSameExtensions)(ee,H.identifier)));this.m.fire($.map(H=>(this.v.info("Extensions added from another source",H.identifier.id,V.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:V.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(j=>this.lb.add(j)));const V=await this.cb.resolve(this.Z.userExtensionsLocation);for(const j of V.children??[])j.isDirectory&&this.lb.add(j.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(j=>this.nb(j)))}async nb(V){if(!V.affects(this.Z.userExtensionsLocation,1))return;const j=[];for(const U of V.rawAdded){if(this.lb.has(U)||!this.db.extUri.isEqual(this.db.extUri.dirname(U),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(U,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(U).startsWith(".")||!(await this.cb.stat(U)).isDirectory)continue;const $=await this.S.scanUserExtensionAtLocation(U);$&&$.installedTimestamp===void 0&&(this.lb.add(U),j.push($))}j.length&&(await this.ob(j.map(U=>[U,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",j.map(U=>U.identifier.id)))}async ob(V,j){const U=V.map($=>$[0]);await this.pb(U),await this.ab.addExtensionsToProfile(V,j),this.m.fire(U.map($=>({local:$,identifier:$.identifier,operation:1,profileLocation:j})))}async pb(V){const j=await this.S.getUninstalledExtensions();for(const U of V){const $=n.ExtensionKey.create(U);!j[$.toString()]||(this.v.trace("Removing the extension from uninstalled list:",$.id),await this.S.setInstalled($),this.v.info("Removed the extension from uninstalled list:",$.id))}}};q=ye([J(0,t.IExtensionGalleryService),J(1,T.ITelemetryService),J(2,Y.ILogService),J(3,i.INativeEnvironmentService),J(4,a.IExtensionsScannerService),J(5,s.IExtensionsProfileScannerService),J(6,P.IDownloadService),J(7,G.IInstantiationService),J(8,z.IFileService),J(9,W.IProductService),J(10,B.IUriIdentityService),J(11,_.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let x=class extends C.Disposable{constructor(V,j,U,$,H,ee){super(),this.k=V,this.l=j,this.m=U,this.n=$,this.p=H,this.s=ee,this.h=this.B(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,f.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(V,j){const U={includeInvalid:!0,profileLocation:j};let $=[];return V===null||V===0?$.push(...await this.m.scanAllExtensions({includeInvalid:!0},U,!1)):V===1&&$.push(...await this.m.scanUserExtensions(U)),$=V!==null?$.filter(H=>H.type===V):$,Promise.all($.map(H=>this.y(H)))}async scanAllUserExtensions(V){const j=await this.m.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(j.map(U=>this.y(U)))}async scanUserExtensionAtLocation(V){try{const j=await this.m.scanExistingExtension(V,1,{includeInvalid:!0});if(j)return await this.y(j)}catch(j){this.s.error(j)}return null}async extractUserExtension(V,j,U,$){await this.j.catch(()=>{});const H=V.toString(),ee=w.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),K=w.join(this.m.userExtensionsLocation.fsPath,H);try{await m.Promises.rm(K)}catch{throw new t.ExtensionManagementError(E.localize(4,null,K,V.id),t.ExtensionManagementErrorCode.Delete)}await this.u(V,j,ee,$),await this.m.updateMetadata(h.URI.file(ee),U);try{this.h.fire(h.URI.file(K)),await this.v(V,ee,K,Date.now()+2*60*1e3),this.s.info("Renamed to",K)}catch(Z){try{await m.Promises.rm(ee)}catch{}if(Z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.s.info(`Rename failed because of ${(0,D.getErrorMessage)(Z)}. Deleted from extracted location`,ee),Z}return this.w(h.URI.file(K),1)}async scanMetadata(V,j){return j?(await this.n.scanProfileExtensions(j)).find($=>(0,n.areSameExtensions)($.identifier,V.identifier))?.metadata:this.m.scanMetadata(V.location)}async updateMetadata(V,j,U){return U?await this.n.updateMetadata([[V,j]],U):await this.m.updateMetadata(V.location,j),this.w(V.location,V.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...V){const j=V.map(U=>n.ExtensionKey.create(U));await this.t(U=>j.forEach($=>{U[$.toString()]=!0,this.s.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(V){await this.t(j=>delete j[V.toString()])}async removeExtension(V,j){this.s.trace(`Deleting ${j} extension from disk`,V.identifier.id,V.location.fsPath);const U=this.p.extUri.joinPath(this.p.extUri.dirname(V.location),`.${(0,u.generateUuid)()}`);await this.v(V.identifier,V.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.l.del(U,{recursive:!0}),this.s.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.t(j=>delete j[n.ExtensionKey.create(V).toString()])}async copyExtensions(V,j){const U=await this.scanExtensions(1,V),$=await Promise.all(U.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,V)]));await this.n.addExtensionsToProfile($,j)}async t(V){return this.g.queue(async()=>{let j;try{j=(await this.l.readFile(this.c,"utf8")).value.toString()}catch($){if((0,z.toFileOperationResult)($)!==1)throw $}let U={};if(j)try{U=JSON.parse(j)}catch{}return V&&(V(U),Object.keys(U).length?await this.l.writeFile(this.c,A.VSBuffer.fromString(JSON.stringify(U))):await this.l.del(this.c)),U})}async u(V,j,U,$){this.s.trace(`Started extracting the extension from ${j} to ${U}`);try{await m.Promises.rm(U)}catch(H){throw new t.ExtensionManagementError(this.D(H).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(j,U,{sourcePath:"extension",overwrite:!0},$),this.s.info(`Extracted extension to ${U}:`,V.id)}catch(H){try{await m.Promises.rm(U)}catch{}let ee=t.ExtensionManagementErrorCode.Extract;throw H instanceof p.ExtractError&&(H.type==="CorruptZip"?ee=t.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(ee=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(H.message,ee)}}async v(V,j,U,$){try{await m.Promises.rename(j,U)}catch(H){if(g.isWindows&&H&&H.code==="EPERM"&&Date.now()<$)return this.s.info(`Failed renaming ${j} to ${U} with 'EPERM' error. Trying again...`,V.id),this.v(V,j,U,$);throw new t.ExtensionManagementError(H.message||E.localize(5,null,j,U),H.code||t.ExtensionManagementErrorCode.Rename)}}async w(V,j){const U=await this.m.scanExistingExtension(V,j,{includeInvalid:!0});if(U)return this.y(U);throw new Error(E.localize(6,null,V.path))}async y(V){const j=await this.l.resolve(V.location);let U,$;return j.children&&(U=j.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,$=j.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:U,changelogUrl:$,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned}}async z(){const V=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(V));const j=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const H of j)V[n.ExtensionKey.create(H).toString()]||U.add(H.identifier.id.toLowerCase());try{const H=(0,n.groupByExtension)(j,ee=>ee.identifier);await L.Promises.settled(H.map(async ee=>{const K=ee.sort((Z,ie)=>d.rcompare(Z.manifest.version,ie.manifest.version))[0];U.has(K.identifier.id.toLowerCase())||await this.k(await this.y(K))}))}catch(H){this.s.error(H)}const $=j.filter(H=>H.metadata&&V[n.ExtensionKey.create(H).toString()]);await Promise.allSettled($.map(H=>this.removeUninstalledExtension(H)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const V=[];let j;try{j=await this.l.resolve(this.m.userExtensionsLocation)}catch(U){(0,z.toFileOperationResult)(U)!==1&&this.s.error(U)}for(const U of j?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,u.isUUID)(U.name.substring(1))&&V.push((async()=>{this.s.trace("Deleting the generated extension folder",U.resource.toString());try{await this.l.del(U.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",U.resource.toString())}catch($){this.s.error($)}})());await Promise.allSettled(V)}D(V){const j=Array.isArray(V)?V:[V];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((U,$)=>new Error(`${U.message}${U.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}};x=ye([J(1,z.IFileService),J(2,a.IExtensionsScannerService),J(3,s.IExtensionsProfileScannerService),J(4,B.IUriIdentityService),J(5,Y.ILogService)],x),e.ExtensionsScanner=x;class M extends o.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,v.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(V,j,U,$,H,ee,K,Z,ie){super(),this.identifier=V,this.source=j,this.l=U,this.m=$,this.n=H,this.o=ee,this.p=K,this.q=Z,this.s=ie,this.j="Unverified",this.k=2}async h(V){const[j,U]=await this.x(V);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[j,U]],this.l.profileLocation),j}async u({zipPath:V,key:j,metadata:U},$){let H=await this.v(j);return H||(this.s.trace("Extracting extension...",j.id),H=await this.m.extractUserExtension(j,V,U,$),this.s.info("Extracting extension completed.",j.id)),H}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find($=>n.ExtensionKey.create($).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class X extends M{constructor(V,j,U,$,H,ee,K,Z,ie,le){super(j.identifier,j,U,H,ee,K,Z,ie,le),this.y=V,this.z=j,this.A=$}async x(V){const U=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,n.areSameExtensions)(K.identifier,this.z.identifier));U&&(this.k=3);const $={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,N.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||U?.isMachineScoped,isBuiltin:this.l.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,v.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.z.version)return[await this.m.updateMetadata(U,$),$];const{location:H,verificationStatus:ee}=await this.A.download(this.z,this.k);try{return this.j=ee,this.C(H.fsPath),[await this.u({zipPath:H.fsPath,key:n.ExtensionKey.create(this.z),metadata:$},V),$]}catch(K){try{await this.A.delete(H)}catch(Z){this.s.warn("Error while deleting the downloaded file",H.toString(),(0,D.getErrorMessage)(Z))}throw K}}async C(V){try{await(0,y.getManifest)(V)}catch(j){throw new t.ExtensionManagementError((0,o.joinErrors)(j).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=X;class Q extends M{constructor(V,j,U,$,H,ee,K,Z,ie,le){super({id:(0,n.getGalleryExtensionId)(V.publisher,V.name)},j,U,H,ee,K,Z,ie,le),this.y=V,this.z=j,this.A=$}async x(V){const j=new n.ExtensionKey(this.identifier,this.y.version),$=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,n.areSameExtensions)(this.identifier,K.identifier)),H=await this.C(this.identifier.id,this.y.version,V);if(H.isApplicationScoped=(0,N.isApplicationScopedExtension)(this.y),H.isMachineScoped=this.l.isMachineScoped||$?.isMachineScoped,H.isBuiltin=this.l.isBuiltin||$?.isBuiltin,H.installedTimestamp=Date.now(),H.pinned=this.l.installGivenVersion?!0:void 0,$)if(this.k=3,j.equals(new n.ExtensionKey($.identifier,$.manifest.version)))try{await this.m.removeExtension($,"existing")}catch{throw new Error(E.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&d.gt($.manifest.version,this.y.version)&&await this.m.setUninstalled($);else{const K=await this.v(j);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(E.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.resolve(this.z.fsPath),key:j,metadata:H},V),H]}async C(V,j,U){try{let[$]=await this.A.getExtensions([{id:V,version:j}],U);if($||([$]=await this.A.getExtensions([{id:V}],U)),$)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class se extends o.AbstractExtensionTask{constructor(V,j,U){super(),this.extension=V,this.j=j,this.k=U}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[289],oe([0,1,2,29,78,237,127,11,20]),function(te,e,L,A,c,k,D,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends L.Disposable{constructor(w,g,f,d,v,h){super(),w.cleanUp(),(0,k.migrateUnsupportedExtensions)(w,g,f,d,h),c.ExtensionStorageService.removeOutdatedExtensionVersions(w,v)}};S=ye([J(0,D.INativeServerExtensionManagementService),J(1,A.IExtensionGalleryService),J(2,c.IExtensionStorageService),J(3,A.IGlobalExtensionEnablementService),J(4,C.IStorageService),J(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(re[298],oe([0,1,149,230,249,34,38,8,2,22,25,10,39,151,216,217,209,210,286,199,202,17,221,97,234,98,227,15,231,119,272,29,99,201,127,100,14,212,213,68,5,208,69,71,240,11,105,106,26,58,20,111,19,112,113,114,47,243,116,252,78,117,23,76,277,263,264,79,278,281,282,283,60,276,266,110,233,75,254,225,253,109,30,255,4,256,203,219,218,77,271,18,51,215,57,275,242,267,108,280,289,7,214,265,86,104,235,270,228,196,56,284,273,70,274]),function(te,e,L,A,c,k,D,R,C,S,I,w,g,f,d,v,h,u,m,p,E,P,i,o,t,n,s,a,r,l,y,b,O,N,F,z,G,Y,W,T,B,_,q,x,M,X,Q,se,ae,V,j,U,$,H,ee,K,Z,ie,le,he,me,pe,we,Ee,ke,De,qe,Ye,ce,fe,ge,Ie,Pe,Fe,Le,Be,Me,Ne,$e,ne,ue,de,Se,ve,Ce,Re,Ae,Te,Ue,je,ze,_e,nt,kt,vt,Lt,At,Ot,St,Tt,Nt,wt,Ut,Mt,Ze,bt,Ft,jt,$t,Bt,zt,Wt,qt,Et,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Vt extends C.Disposable{constructor(be,Oe){super(),this.f=be,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.B(new f.Server):this.a=this.B(new L.Server),this.h()}h(){let be=!1;const Oe=()=>{be||(be=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,f.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",We=(st,Ve)=>{this.i(Ve)};this.g.on(xe,We),this.B((0,C.toDisposable)(()=>this.g.removeListener(xe,We)))}}i(be){this.b?.disposeWorker(be)}async init(){const be=await this.j();(0,we.registerConfiguration)(),be.invokeFunction(Oe=>{const xe=Oe.get(X.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.B((0,C.combinedDisposable)(be.createInstance(d.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(v.LanguagePackCachedDataCleaner),be.createInstance(m.UnusedWorkspaceStorageDataCleaner),be.createInstance(u.LogsDataCleaner),be.createInstance(h.LocalizationsUpdater),be.createInstance(Nt.ExtensionsContributions),be.createInstance(Ot.UserDataProfilesCleaner)))}async j(){const be=new q.ServiceCollection,Oe={_serviceBrand:void 0,...se.default};be.set(ae.IProductService,Oe);const xe=new g.StaticRouter(Ke=>Ke==="main"),We=new Et.MainProcessService(this.a,xe);be.set(Et.IMainProcessService,We);const st=this.f.policiesData?new kt.PolicyChannelClient(this.f.policiesData,We.getChannel("policy")):new vt.NullPolicyService;be.set(vt.IPolicyService,st);const Ve=new r.SharedProcessEnvironmentService(this.f.args,Oe);be.set(a.INativeEnvironmentService,Ve);const et=new Q.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers.map(Ke=>({...Ke,resource:w.URI.revive(Ke.resource)})),We.getChannel("logger"));be.set(X.ILoggerService,et);const ct=this.B(et.createLogger((0,I.joinPath)(w.URI.file(Ve.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,wt.localize)(0,null)})),ht=this.B(new X.ConsoleLogger(ct.getLevel())),Ge=this.B(new Ut.LogService(ct,[ht]));be.set(X.ILogService,Ge),this.c=this.B(new bt.SharedProcessLifecycleService(Ge)),be.set(bt.ISharedProcessLifecycleService,this.c),this.b=new A.SharedProcessWorkerService(Ge),be.set(de.ISharedProcessWorkerService,this.b);const Qe=this.B(new Y.FileService(Ge));be.set(G.IFileService,Qe);const ft=this.B(new W.DiskFileSystemProvider(Ge));Qe.registerProvider(S.Schemas.file,ft);const dt=this.B(new Re.FileUserDataProvider(S.Schemas.file,this.B(new Ae.DiskFileSystemProviderClient(We.getChannel(Ae.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Ce.isLinux})),S.Schemas.vscodeUserData,Ge));Qe.registerProvider(S.Schemas.vscodeUserData,dt);const tt=this.B(new Lt.UserDataProfilesService(this.f.profiles.all,w.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));be.set(_e.IUserDataProfilesService,tt);const Je=this.B(new i.ConfigurationService(tt.defaultProfile.settingsResource,Qe,st,Ge));be.set(P.IConfigurationService,Je);const rt=new xt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},We,Ve);be.set(j.IStorageService,rt),this.B((0,C.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const gt=new ve.UriIdentityService(Qe);be.set(Se.IUriIdentityService,gt),be.set(V.IRequestService,new $t.RequestChannelClient(We.getChannel("request"))),be.set(p.IChecksumService,new T.SyncDescriptor(E.ChecksumService,void 0,!1)),be.set(Ue.IV8InspectProfilingService,new T.SyncDescriptor(Te.InspectProfilingService,void 0,!1));const lt=g.ProxyChannel.toService(We.getChannel("nativeHost"),{context:this.f.windowId});be.set(zt.INativeHostService,lt),be.set(n.IDownloadService,new T.SyncDescriptor(s.DownloadService,void 0,!0));const mt=this.B(new Le.ActiveWindowManager(lt)),Ht=new g.StaticRouter(Ke=>mt.getActiveClientId().then(pt=>Ke===pt));be.set(z.IExtensionRecommendationNotificationService,new Bt.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Ht)));let ut;const ot=[],It=(0,Z.isInternalTelemetry)(Oe,Je);if((0,Z.supportsTelemetry)(Oe,Ve)){const Ke=new ee.TelemetryLogAppender(Ge,et,Ve,Oe);ot.push(Ke);const{installSourcePath:pt}=Ve;if(Oe.aiConfig?.ariaKey){const Rt=new At.OneDataSystemAppender(It,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.B((0,C.toDisposable)(()=>Rt.flush())),ot.push(Rt)}ut=new K.TelemetryService({appenders:ot,commonProperties:(0,U.resolveCommonProperties)(Qe,(0,k.release)(),(0,k.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,It,pt),sendErrorTelemetry:!0,piiPaths:(0,Z.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=Z.NullTelemetryService;const Ke=Z.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new H.TelemetryAppenderChannel(ot)),be.set($.ITelemetryService,ut);const Gt=new ie.CustomEndpointTelemetryService(Je,ut,Ge,et,Ve,Oe);be.set($.ICustomEndpointTelemetryService,Gt),be.set(nt.IExtensionsProfileScannerService,new T.SyncDescriptor(jt.ExtensionsProfileScannerService,void 0,!0)),be.set(je.IExtensionsScannerService,new T.SyncDescriptor(ze.ExtensionsScannerService,void 0,!0)),be.set(O.IExtensionSignatureVerificationService,new T.SyncDescriptor(O.ExtensionSignatureVerificationService,void 0,!0)),be.set(F.INativeServerExtensionManagementService,new T.SyncDescriptor(F.ExtensionManagementService,void 0,!0)),be.set(b.IExtensionGalleryService,new T.SyncDescriptor(y.ExtensionGalleryService,void 0,!0)),be.set(b.IExtensionTipsService,new T.SyncDescriptor(qt.ExtensionTipsService,void 0,!1)),be.set(x.ILanguagePackService,new T.SyncDescriptor(M.NativeLanguagePackService,void 0,!1)),be.set(o.IDiagnosticsService,new T.SyncDescriptor(t.DiagnosticsService,void 0,!1)),be.set(Ee.IUserDataSyncAccountService,new T.SyncDescriptor(Ee.UserDataSyncAccountService,void 0,!0)),be.set(we.IUserDataSyncLogService,new T.SyncDescriptor(qe.UserDataSyncLogService,void 0,!0)),be.set(we.IUserDataSyncUtilService,new De.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),be.set(b.IGlobalExtensionEnablementService,new T.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),be.set(pe.IIgnoredExtensionsManagementService,new T.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),be.set(me.IExtensionStorageService,new T.SyncDescriptor(me.ExtensionStorageService)),be.set(we.IUserDataSyncStoreManagementService,new T.SyncDescriptor(Ie.UserDataSyncStoreManagementService,void 0,!0)),be.set(we.IUserDataSyncStoreService,new T.SyncDescriptor(Ie.UserDataSyncStoreService,void 0,!0)),be.set(Ye.IUserDataSyncMachinesService,new T.SyncDescriptor(Ye.UserDataSyncMachinesService,void 0,!0)),be.set(we.IUserDataSyncBackupStoreService,new T.SyncDescriptor(ke.UserDataSyncBackupStoreService,void 0,!1)),be.set(we.IUserDataSyncEnablementService,new T.SyncDescriptor(ce.UserDataSyncEnablementService,void 0,!0)),be.set(we.IUserDataSyncService,new T.SyncDescriptor(fe.UserDataSyncService,void 0,!1)),be.set(Pe.IUserDataProfileStorageService,new T.SyncDescriptor(Fe.NativeUserDataProfileStorageService,void 0,!0)),be.set(we.IUserDataSyncResourceProviderService,new T.SyncDescriptor(Tt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new he.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,wt.localize)(1,null),Je,Ve,Ge,et);return Pt.initialize(),be.set(c.ILocalPtyService,this.B(Pt)),be.set(Be.ISignService,new T.SyncDescriptor(Me.SignService,void 0,!1)),be.set(Ne.ISharedTunnelsService,new T.SyncDescriptor($e.SharedTunnelsService)),be.set(ne.ISharedProcessTunnelService,new T.SyncDescriptor(ue.SharedProcessTunnelService)),be.set(St.IRemoteTunnelService,new T.SyncDescriptor(Ft.RemoteTunnelService)),new _.InstantiationService(be)}k(be){const Oe=new N.ExtensionManagementChannel(be.get(b.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=g.ProxyChannel.fromService(be.get(x.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const We=g.ProxyChannel.fromService(be.get(o.IDiagnosticsService));this.a.registerChannel("diagnostics",We);const st=new N.ExtensionTipsChannel(be.get(b.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=g.ProxyChannel.fromService(be.get(p.IChecksumService));this.a.registerChannel("checksum",Ve);const et=g.ProxyChannel.fromService(be.get(Ue.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",et);const ct=new De.UserDataSyncMachinesServiceChannel(be.get(Ye.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=g.ProxyChannel.fromService(be.get($.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ge=new De.UserDataSyncAccountServiceChannel(be.get(Ee.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const Qe=new De.UserDataSyncStoreManagementServiceChannel(be.get(we.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new ge.UserDataSyncChannel(be.get(we.IUserDataSyncService),be.get(_e.IUserDataProfilesService),be.get(X.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(be.get(B.IInstantiationService).createInstance(Wt.UserDataAutoSyncService)),tt=new De.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Je=be.get(c.ILocalPtyService),rt=g.ProxyChannel.fromService(Je);this.a.registerChannel(le.TerminalIpcChannels.LocalPty,rt);const gt=g.ProxyChannel.fromService(be.get(ne.ISharedProcessTunnelService));this.a.registerChannel(ne.ipcSharedProcessTunnelChannelName,gt);const lt=g.ProxyChannel.fromService(be.get(de.ISharedProcessWorkerService));this.a.registerChannel(Mt.ipcUtilityProcessWorkerChannelName,lt);const mt=g.ProxyChannel.fromService(be.get(St.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(be){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,R.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,R.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,R.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Oe=>{const xe=(0,D.toErrorMessage)(Oe,!0);!xe||be.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Ct(at){let be;(0,Ze.isUtilityProcess)(process)||(be=(await new Promise((xe,We)=>{te(["electron"],xe,We)})).ipcRenderer);const Oe=new Vt(at,be);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):be.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):be.send("vscode:shared-process->electron-main=init-done")}e.main=Ct,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Ct(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a834695686b52ddee116775560c7e12ba78482f/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
