/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Te=function(ne){for(var e=[],i=0,P=ne.length;i<P;i++)e[i]=ke[ne[i]];return e};define(ke[63],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(E,R){const y=Object.create(null);for(const k of E){const M=R(k);let D=y[M];D||(D=y[M]=[]),D.push(k)}return y}e.groupBy=i;function P(E,R){const y=[],k=[];for(const M of E)R.has(M)||y.push(M);for(const M of R)E.has(M)||k.push(M);return{removed:y,added:k}}e.diffSets=P;function I(E,R){const y=[],k=[];for(const[M,D]of E)R.has(M)||y.push(D);for(const[M,D]of R)E.has(M)||k.push(D);return{removed:y,added:k}}e.diffMaps=I;class F{constructor(){this.a=new Map}add(R,y){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(y)}delete(R,y){const k=this.a.get(R);!k||(k.delete(y),k.size===0&&this.a.delete(R))}forEach(R,y){const k=this.a.get(R);!k||k.forEach(y)}}e.SetMap=F}),define(ke[64],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(E){return(R,y,k)=>{let M=null,D=null;if(typeof k.value=="function"?(M="value",D=k.value):typeof k.get=="function"&&(M="get",D=k.get),!D)throw new Error("not supported");k[M]=E(D,y)}}function P(E,R,y){let k=null,M=null;if(typeof y.value=="function"?(k="value",M=y.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",M=y.get),!M)throw new Error("not supported");const D=`$memoize$${R}`;y[k]=function(...h){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,h)}),this[D]}}e.memoize=P;function I(E,R,y){return i((k,M)=>{const D=`$debounce$${M}`,h=`$debounce$result$${M}`;return function(...b){this[h]||(this[h]=y?y():void 0),clearTimeout(this[D]),R&&(this[h]=R(this[h],...b),b=[this[h]]),this[D]=setTimeout(()=>{k.apply(this,b),this[h]=y?y():void 0},E)}})}e.debounce=I;function F(E,R,y){return i((k,M)=>{const D=`$throttle$timer$${M}`,h=`$throttle$result$${M}`,b=`$throttle$lastRun$${M}`,m=`$throttle$pending$${M}`;return function(...o){if(this[h]||(this[h]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...o)),this[m])return;const s=this[b]+E;s<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[h]]),this[h]=y?y():void 0):(this[m]=!0,this[D]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),k.apply(this,[this[h]]),this[h]=y?y():void 0},s-Date.now()))}})}e.throttle=F}),define(ke[83],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(ke[111],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F=e.ParseOptions||(e.ParseOptions={}));function E(t,d=!1){let a=0;const l=t.length;let c="",w=0,n=16,r=0;function f(j){let L=0,g=0;for(;L<j;){const N=t.charCodeAt(a);if(N>=48&&N<=57)g=g*16+N-48;else if(N>=65&&N<=70)g=g*16+N-65+10;else if(N>=97&&N<=102)g=g*16+N-97+10;else break;a++,L++}return L<j&&(g=-1),g}function A(j){a=j,c="",w=0,n=16,r=0}function T(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&k(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&k(t.charCodeAt(a)))for(a++;a<t.length&&k(t.charCodeAt(a));)a++;else return r=3,t.substring(j,a);let L=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&k(t.charCodeAt(a))){for(a++;a<t.length&&k(t.charCodeAt(a));)a++;L=a}else r=3;return t.substring(j,L)}function H(){let j="",L=a;for(;;){if(a>=l){j+=t.substring(L,a),r=2;break}const g=t.charCodeAt(a);if(g===34){j+=t.substring(L,a),a++;break}if(g===92){if(j+=t.substring(L,a),a++,a>=l){r=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const B=f(4);B>=0?j+=String.fromCharCode(B):r=4;break}default:r=5}L=a;continue}if(g>=0&&g<=31)if(y(g)){j+=t.substring(L,a),r=2;break}else r=6;a++}return j}function Q(){if(c="",r=0,w=a,a>=l)return w=l,n=17;let j=t.charCodeAt(a);if(R(j)){do a++,c+=String.fromCharCode(j),j=t.charCodeAt(a);while(R(j));return n=15}if(y(j))return a++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),n=14;switch(j){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,c=H(),n=10;case 47:{const L=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<l&&!y(t.charCodeAt(a));)a++;return c=t.substring(L,a),n=12}if(t.charCodeAt(a+1)===42){a+=2;const g=l-1;let N=!1;for(;a<g;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,N=!0;break}a++}return N||(a++,r=1),c=t.substring(L,a),n=13}return c+=String.fromCharCode(j),a++,n=16}case 45:if(c+=String.fromCharCode(j),a++,a===l||!k(t.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),n=11;default:for(;a<l&&Z(j);)a++,j=t.charCodeAt(a);if(w!==a){switch(c=t.substring(w,a),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(j),a++,n=16}}function Z(j){if(R(j)||y(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let j;do j=Q();while(j>=12&&j<=15);return j}return{setPosition:A,getPosition:()=>a,scan:d?_:Q,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>w,getTokenLength:()=>a-w,getTokenError:()=>r}}e.createScanner=E;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function D(t,d){const a=[],l=new Object;let c;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(f,A,T,H){w.value=f,w.offset=A,w.length=T,w.type=H,w.colonOffset=void 0,c=w}try{S(t,{onObjectBegin:(f,A)=>{if(d<=f)throw l;c=void 0,n=d>f,a.push("")},onObjectProperty:(f,A,T)=>{if(d<A||(r(f,A,T,"property"),a[a.length-1]=f,d<=A+T))throw l},onObjectEnd:(f,A)=>{if(d<=f)throw l;c=void 0,a.pop()},onArrayBegin:(f,A)=>{if(d<=f)throw l;c=void 0,a.push(0)},onArrayEnd:(f,A)=>{if(d<=f)throw l;c=void 0,a.pop()},onLiteralValue:(f,A,T)=>{if(d<A||(r(f,A,T,v(f)),d<=A+T))throw l},onSeparator:(f,A,T)=>{if(d<=A)throw l;if(f===":"&&c&&c.type==="property")c.colonOffset=A,n=!1,c=void 0;else if(f===","){const H=a[a.length-1];typeof H=="number"?a[a.length-1]=H+1:(n=!0,a[a.length-1]=""),c=void 0}}})}catch(f){if(f!==l)throw f}return{path:a,previousNode:c,isAtPropertyKey:n,matches:f=>{let A=0;for(let T=0;A<f.length&&T<a.length;T++)if(f[A]===a[T]||f[A]==="*")A++;else if(f[A]!=="**")return!1;return A===f.length}}}e.getLocation=D;function h(t,d=[],a=F.DEFAULT){let l=null,c=[];const w=[];function n(f){Array.isArray(c)?c.push(f):l!==null&&(c[l]=f)}return S(t,{onObjectBegin:()=>{const f={};n(f),w.push(c),c=f,l=null},onObjectProperty:f=>{l=f},onObjectEnd:()=>{c=w.pop()},onArrayBegin:()=>{const f=[];n(f),w.push(c),c=f,l=null},onArrayEnd:()=>{c=w.pop()},onLiteralValue:n,onError:(f,A,T)=>{d.push({error:f,offset:A,length:T})}},a),c[0]}e.parse=h;function b(t,d=[],a=F.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){l.type==="property"&&(l.length=f-l.offset,l=l.parent)}function w(f){return l.children.push(f),f}S(t,{onObjectBegin:f=>{l=w({type:"object",offset:f,length:-1,parent:l,children:[]})},onObjectProperty:(f,A,T)=>{l=w({type:"property",offset:A,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:f,offset:A,length:T,parent:l})},onObjectEnd:(f,A)=>{l.length=f+A-l.offset,l=l.parent,c(f+A)},onArrayBegin:(f,A)=>{l=w({type:"array",offset:f,length:-1,parent:l,children:[]})},onArrayEnd:(f,A)=>{l.length=f+A-l.offset,l=l.parent,c(f+A)},onLiteralValue:(f,A,T)=>{w({type:v(f),offset:A,length:T,parent:l,value:f}),c(A+T)},onSeparator:(f,A,T)=>{l.type==="property"&&(f===":"?l.colonOffset=A:f===","&&c(A))},onError:(f,A,T)=>{d.push({error:f,offset:A,length:T})}},a);const r=l.children[0];return r&&delete r.parent,r}e.parseTree=b;function m(t,d){if(!t)return;let a=t;for(const l of d)if(typeof l=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const w of a.children)if(Array.isArray(w.children)&&w.children[0].value===l){a=w.children[1],c=!0;break}if(!c)return}else{const c=l;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=m;function o(t){if(!t.parent||!t.parent.children)return[];const d=o(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;d.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&d.push(a)}return d}e.getNodePath=o;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const d=Object.create(null);for(const a of t.children){const l=a.children[1];l&&(d[a.children[0].value]=s(l))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function u(t,d,a=!1){return d>=t.offset&&d<t.offset+t.length||a&&d===t.offset+t.length}e.contains=u;function p(t,d,a=!1){if(u(t,d,a)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=d;c++){const w=p(l[c],d,a);if(w)return w}return t}}e.findNodeAtOffset=p;function S(t,d,a=F.DEFAULT){const l=E(t,!1);function c(we){return we?()=>we(l.getTokenOffset(),l.getTokenLength()):()=>!0}function w(we){return we?q=>we(q,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=c(d.onObjectBegin),r=w(d.onObjectProperty),f=c(d.onObjectEnd),A=c(d.onArrayBegin),T=c(d.onArrayEnd),H=w(d.onLiteralValue),Q=w(d.onSeparator),Z=c(d.onComment),_=w(d.onError),j=a&&a.disallowComments,L=a&&a.allowTrailingComma;function g(){for(;;){const we=l.scan();switch(l.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:j||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(we){case 12:case 13:j?N(10):Z();break;case 16:N(1);break;case 15:case 14:break;default:return we}}}function N(we,q=[],x=[]){if(_(we),q.length+x.length>0){let X=l.getToken();for(;X!==17;){if(q.indexOf(X)!==-1){g();break}else if(x.indexOf(X)!==-1)break;X=g()}}}function B(we){const q=l.getTokenValue();return we?H(q):r(q),g(),!0}function J(){switch(l.getToken()){case 11:{let we=0;try{we=JSON.parse(l.getTokenValue()),typeof we!="number"&&(N(2),we=0)}catch{N(2)}H(we);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return g(),!0}function me(){return l.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),l.getToken()===6?(Q(":"),g(),ce()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function te(){n(),g();let we=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(we||N(4,[],[]),Q(","),g(),l.getToken()===2&&L)break}else we&&N(6,[],[]);me()||N(4,[],[2,5]),we=!0}return f(),l.getToken()!==2?N(7,[2],[]):g(),!0}function oe(){A(),g();let we=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(we||N(4,[],[]),Q(","),g(),l.getToken()===4&&L)break}else we&&N(6,[],[]);ce()||N(4,[],[4,5]),we=!0}return T(),l.getToken()!==4?N(8,[4],[]):g(),!0}function ce(){switch(l.getToken()){case 3:return oe();case 1:return te();case 10:return B(!0);default:return J()}}return g(),l.getToken()===17?a.allowEmptyContent?!0:(N(4,[],[]),!1):ce()?(l.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=S;function O(t,d){const a=E(t),l=[];let c,w=0,n;do switch(n=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:w!==n&&l.push(t.substring(w,n)),d!==void 0&&l.push(a.getTokenValue().replace(/[^\r\n]/g,d)),w=a.getPosition();break}while(c!==17);return l.join("")}e.stripComments=O;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(ke[28],Te([1,0]),function(ne,e){"use strict";var i,P,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function F(m,o,s){let u=m.get(o);return u===void 0&&(u=s,m.set(o,u)),u}e.getOrSet=F;function E(m){const o=[];return m.forEach((s,u)=>{o.push(`${u} => ${s}`)}),`Map(${m.size}) {${o.join(", ")}}`}e.mapToString=E;function R(m){const o=[];return m.forEach(s=>{o.push(s)}),`Set(${m.size}) {${o.join(", ")}}`}e.setToString=R;class y{constructor(o,s){this.uri=o,this.value=s}}class k{constructor(o,s){this[i]="ResourceMap",o instanceof k?(this.b=new Map(o.b),this.c=s??k.a):(this.b=new Map,this.c=o??k.a)}set(o,s){return this.b.set(this.c(o),new y(o,s)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,s){typeof s<"u"&&(o=o.bind(s));for(const[u,p]of this.b)o(p.value,p.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}k.a=m=>m.toString(),e.ResourceMap=k;class M{constructor(o,s){this[P]="ResourceSet",!o||typeof o=="function"?this.a=new k(o):(this.a=new k(s),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,s){this.a.forEach((u,p)=>o.call(s,p,p,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var D;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class h{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,s=0){const u=this.a.get(o);if(!!u)return s!==0&&this.j(u,s),u.value}set(o,s,u=0){let p=this.a.get(o);if(p)p.value=s,u!==0&&this.j(p,u);else{switch(p={key:o,value:s,next:void 0,previous:void 0},u){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(o,p),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const s=this.a.get(o);if(!!s)return this.a.delete(o),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,s){const u=this.e;let p=this.b;for(;p;){if(s?o.bind(s)(p.value,p.key,this):o(p.value,p.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const o=this,s=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.key,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return p}values(){const o=this,s=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.value,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return p}entries(){const o=this,s=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:[u.key,u.value],done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return p}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this.b,u=this.size;for(;s&&u>o;)this.a.delete(s.key),s=s.next,u--;this.b=s,this.d=u,s&&(s.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const s=o.next,u=o.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}o.next=void 0,o.previous=void 0,this.e++}j(o,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(o===this.b)return;const u=o.next,p=o.previous;o===this.c?(p.next=void 0,this.c=p):(u.previous=p,p.next=u),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(s===2){if(o===this.c)return;const u=o.next,p=o.previous;o===this.b?(u.previous=void 0,this.b=u):(u.previous=p,p.next=u),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((s,u)=>{o.push([u,s])}),o}fromJSON(o){this.clear();for(const[s,u]of o)this.set(s,u)}}e.LinkedMap=h;class b extends h{constructor(o,s=1){super(),this.k=o,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,s=2){return super.get(o,s)}peek(o){return super.get(o,0)}set(o,s){return super.set(o,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ke[112],Te([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Pe,Ie){for(var Se=0;Se<Ie.length;Se++){var ae=Ie[Se];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Pe,ae.key,ae)}}function i(Pe,Ie,Se){return Ie&&e(Pe.prototype,Ie),Se&&e(Pe,Se),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function P(Pe,Ie){if(!!Pe){if(typeof Pe=="string")return I(Pe,Ie);var Se=Object.prototype.toString.call(Pe).slice(8,-1);if(Se==="Object"&&Pe.constructor&&(Se=Pe.constructor.name),Se==="Map"||Se==="Set")return Array.from(Pe);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return I(Pe,Ie)}}function I(Pe,Ie){(Ie==null||Ie>Pe.length)&&(Ie=Pe.length);for(var Se=0,ae=new Array(Ie);Se<Ie;Se++)ae[Se]=Pe[Se];return ae}function F(Pe,Ie){var Se=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Se)return(Se=Se.call(Pe)).next.bind(Se);if(Array.isArray(Pe)||(Se=P(Pe))||Ie&&Pe&&typeof Pe.length=="number"){Se&&(Pe=Se);var ae=0;return function(){return ae>=Pe.length?{done:!0}:{done:!1,value:Pe[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=E();function R(Pe){ne.defaults=Pe}var y=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ie){return h[Ie]};function m(Pe,Ie){if(Ie){if(y.test(Pe))return Pe.replace(k,b)}else if(M.test(Pe))return Pe.replace(D,b);return Pe}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Pe){return Pe.replace(o,function(Ie,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var u=/(^|[^\[])\^/g;function p(Pe,Ie){Pe=typeof Pe=="string"?Pe:Pe.source,Ie=Ie||"";var Se={replace:function(le,ee){return ee=ee.source||ee,ee=ee.replace(u,"$1"),Pe=Pe.replace(le,ee),Se},getRegex:function(){return new RegExp(Pe,Ie)}};return Se}var S=/[^\w:]/g,O=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Pe,Ie,Se){if(Pe){var ae;try{ae=decodeURIComponent(s(Se)).replace(S,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Ie&&!O.test(Se)&&(Se=c(Ie,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var t={},d=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,Ie){t[" "+Pe]||(d.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=f(Pe,"/",!0)),Pe=t[" "+Pe];var Se=Pe.indexOf(":")===-1;return Ie.substring(0,2)==="//"?Se?Ie:Pe.replace(a,"$1")+Ie:Ie.charAt(0)==="/"?Se?Ie:Pe.replace(l,"$1")+Ie:Pe+Ie}var w={exec:function(){}};function n(Pe){for(var Ie=1,Se,ae;Ie<arguments.length;Ie++){Se=arguments[Ie];for(ae in Se)Object.prototype.hasOwnProperty.call(Se,ae)&&(Pe[ae]=Se[ae])}return Pe}function r(Pe,Ie){var Se=Pe.replace(/\|/g,function(ee,C,$){for(var W=!1,V=C;--V>=0&&$[V]==="\\";)W=!W;return W?"|":" |"}),ae=Se.split(/ \|/),le=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Ie)ae.splice(Ie);else for(;ae.length<Ie;)ae.push("");for(;le<ae.length;le++)ae[le]=ae[le].trim().replace(/\\\|/g,"|");return ae}function f(Pe,Ie,Se){var ae=Pe.length;if(ae===0)return"";for(var le=0;le<ae;){var ee=Pe.charAt(ae-le-1);if(ee===Ie&&!Se)le++;else if(ee!==Ie&&Se)le++;else break}return Pe.slice(0,ae-le)}function A(Pe,Ie){if(Pe.indexOf(Ie[1])===-1)return-1;for(var Se=Pe.length,ae=0,le=0;le<Se;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===Ie[0])ae++;else if(Pe[le]===Ie[1]&&(ae--,ae<0))return le;return-1}function T(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function H(Pe,Ie){if(Ie<1)return"";for(var Se="";Ie>1;)Ie&1&&(Se+=Pe),Ie>>=1,Pe+=Pe;return Se+Pe}function Q(Pe,Ie,Se,ae){var le=Ie.href,ee=Ie.title?m(Ie.title):null,C=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ae.state.inLink=!0;var $={type:"link",raw:Se,href:le,title:ee,text:C,tokens:ae.inlineTokens(C)};return ae.state.inLink=!1,$}return{type:"image",raw:Se,href:le,title:ee,text:m(C)}}function Z(Pe,Ie){var Se=Pe.match(/^(\s+)(?:```)/);if(Se===null)return Ie;var ae=Se[1];return Ie.split(`
`).map(function(le){var ee=le.match(/^\s+/);if(ee===null)return le;var C=ee[0];return C.length>=ae.length?le.slice(ae.length):le}).join(`
`)}var _=function(){function Pe(Se){this.options=Se||ne.defaults}var Ie=Pe.prototype;return Ie.space=function(ae){var le=this.rules.block.newline.exec(ae);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Ie.code=function(ae){var le=this.rules.block.code.exec(ae);if(le){var ee=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:f(ee,`
`)}}},Ie.fences=function(ae){var le=this.rules.block.fences.exec(ae);if(le){var ee=le[0],C=Z(ee,le[3]||"");return{type:"code",raw:ee,lang:le[2]?le[2].trim():le[2],text:C}}},Ie.heading=function(ae){var le=this.rules.block.heading.exec(ae);if(le){var ee=le[2].trim();if(/#$/.test(ee)){var C=f(ee,"#");(this.options.pedantic||!C||/ $/.test(C))&&(ee=C.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ee,tokens:this.lexer.inline(ee)}}},Ie.hr=function(ae){var le=this.rules.block.hr.exec(ae);if(le)return{type:"hr",raw:le[0]}},Ie.blockquote=function(ae){var le=this.rules.block.blockquote.exec(ae);if(le){var ee=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},Ie.list=function(ae){var le=this.rules.block.list.exec(ae);if(le){var ee,C,$,W,V,ie,fe,De,ue,ve,be,He,je=le[1].trim(),it=je.length>1,Xe={type:"list",raw:"",ordered:it,start:it?+je.slice(0,-1):"",loose:!1,items:[]};je=it?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=it?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(He=!1,!(!(le=et.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=le[0],ae=ae.substring(ee.length),De=le[2].split(`
`,1)[0],ue=ae.split(`
`,1)[0],this.options.pedantic?(W=2,be=De.trimLeft()):(W=le[2].search(/[^ ]/),W=W>4?1:W,be=De.slice(W),W+=le[1].length),ie=!1,!De&&/^ *$/.test(ue)&&(ee+=ue+`
`,ae=ae.substring(ue.length+1),He=!0),!He)for(var nt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),G=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],De=ve,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(De)||G.test(De)||nt.test(De)||Fe.test(ae)));){if(De.search(/[^ ]/)>=W||!De.trim())be+=`
`+De.slice(W);else if(!ie)be+=`
`+De;else break;!ie&&!De.trim()&&(ie=!0),ee+=ve+`
`,ae=ae.substring(ve.length+1)}Xe.loose||(fe?Xe.loose=!0:/\n *\n *$/.test(ee)&&(fe=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(be),C&&($=C[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ee,task:!!C,checked:$,loose:!1,text:be}),Xe.raw+=ee}Xe.items[Xe.items.length-1].raw=ee.trimRight(),Xe.items[Xe.items.length-1].text=be.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(V=0;V<Y;V++){this.lexer.state.top=!1,Xe.items[V].tokens=this.lexer.blockTokens(Xe.items[V].text,[]);var pe=Xe.items[V].tokens.filter(function($e){return $e.type==="space"}),We=pe.every(function($e){for(var Qe=$e.raw.split(""),Ke=0,tt=F(Qe),at;!(at=tt()).done;){var Et=at.value;if(Et===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Xe.loose&&pe.length&&We&&(Xe.loose=!0,Xe.items[V].loose=!0)}return Xe}},Ie.html=function(ae){var le=this.rules.block.html.exec(ae);if(le){var ee={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]);ee.type="paragraph",ee.text=C,ee.tokens=this.lexer.inline(C)}return ee}},Ie.def=function(ae){var le=this.rules.block.def.exec(ae);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ee=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:le[0],href:le[2],title:le[3]}}},Ie.table=function(ae){var le=this.rules.block.table.exec(ae);if(le){var ee={type:"table",header:r(le[1]).map(function(fe){return{text:fe}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=le[0];var C=ee.align.length,$,W,V,ie;for($=0;$<C;$++)/^ *-+: *$/.test(ee.align[$])?ee.align[$]="right":/^ *:-+: *$/.test(ee.align[$])?ee.align[$]="center":/^ *:-+ *$/.test(ee.align[$])?ee.align[$]="left":ee.align[$]=null;for(C=ee.rows.length,$=0;$<C;$++)ee.rows[$]=r(ee.rows[$],ee.header.length).map(function(fe){return{text:fe}});for(C=ee.header.length,W=0;W<C;W++)ee.header[W].tokens=this.lexer.inline(ee.header[W].text);for(C=ee.rows.length,W=0;W<C;W++)for(ie=ee.rows[W],V=0;V<ie.length;V++)ie[V].tokens=this.lexer.inline(ie[V].text);return ee}}},Ie.lheading=function(ae){var le=this.rules.block.lheading.exec(ae);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},Ie.paragraph=function(ae){var le=this.rules.block.paragraph.exec(ae);if(le){var ee=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ee,tokens:this.lexer.inline(ee)}}},Ie.text=function(ae){var le=this.rules.block.text.exec(ae);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},Ie.escape=function(ae){var le=this.rules.inline.escape.exec(ae);if(le)return{type:"escape",raw:le[0],text:m(le[1])}},Ie.tag=function(ae){var le=this.rules.inline.tag.exec(ae);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]}},Ie.link=function(ae){var le=this.rules.inline.link.exec(ae);if(le){var ee=le[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var C=f(ee.slice(0,-1),"\\");if((ee.length-C.length)%2===0)return}else{var $=A(le[2],"()");if($>-1){var W=le[0].indexOf("!")===0?5:4,V=W+le[1].length+$;le[2]=le[2].substring(0,$),le[0]=le[0].substring(0,V).trim(),le[3]=""}}var ie=le[2],fe="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ie);De&&(ie=De[1],fe=De[3])}else fe=le[3]?le[3].slice(1,-1):"";return ie=ie.trim(),/^</.test(ie)&&(this.options.pedantic&&!/>$/.test(ee)?ie=ie.slice(1):ie=ie.slice(1,-1)),Q(le,{href:ie&&ie.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Ie.reflink=function(ae,le){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var C=(ee[2]||ee[1]).replace(/\s+/g," ");if(C=le[C.toLowerCase()],!C||!C.href){var $=ee[0].charAt(0);return{type:"text",raw:$,text:$}}return Q(ee,C,ee[0],this.lexer)}},Ie.emStrong=function(ae,le,ee){ee===void 0&&(ee="");var C=this.rules.inline.emStrong.lDelim.exec(ae);if(!!C&&!(C[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=C[1]||C[2]||"";if(!$||$&&(ee===""||this.rules.inline.punctuation.exec(ee))){var W=C[0].length-1,V,ie,fe=W,De=0,ue=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,le=le.slice(-1*ae.length+W);(C=ue.exec(le))!=null;)if(V=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!V){if(ie=V.length,C[3]||C[4]){fe+=ie;continue}else if((C[5]||C[6])&&W%3&&!((W+ie)%3)){De+=ie;continue}if(fe-=ie,!(fe>0)){if(ie=Math.min(ie,ie+fe+De),Math.min(W,ie)%2){var ve=ae.slice(1,W+C.index+ie);return{type:"em",raw:ae.slice(0,W+C.index+ie+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=ae.slice(2,W+C.index+ie-1);return{type:"strong",raw:ae.slice(0,W+C.index+ie+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},Ie.codespan=function(ae){var le=this.rules.inline.code.exec(ae);if(le){var ee=le[2].replace(/\n/g," "),C=/[^ ]/.test(ee),$=/^ /.test(ee)&&/ $/.test(ee);return C&&$&&(ee=ee.substring(1,ee.length-1)),ee=m(ee,!0),{type:"codespan",raw:le[0],text:ee}}},Ie.br=function(ae){var le=this.rules.inline.br.exec(ae);if(le)return{type:"br",raw:le[0]}},Ie.del=function(ae){var le=this.rules.inline.del.exec(ae);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},Ie.autolink=function(ae,le){var ee=this.rules.inline.autolink.exec(ae);if(ee){var C,$;return ee[2]==="@"?(C=m(this.options.mangle?le(ee[1]):ee[1]),$="mailto:"+C):(C=m(ee[1]),$=C),{type:"link",raw:ee[0],text:C,href:$,tokens:[{type:"text",raw:C,text:C}]}}},Ie.url=function(ae,le){var ee;if(ee=this.rules.inline.url.exec(ae)){var C,$;if(ee[2]==="@")C=m(this.options.mangle?le(ee[0]):ee[0]),$="mailto:"+C;else{var W;do W=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(W!==ee[0]);C=m(ee[0]),ee[1]==="www."?$="http://"+C:$=C}return{type:"link",raw:ee[0],text:C,href:$,tokens:[{type:"text",raw:C,text:C}]}}},Ie.inlineText=function(ae,le){var ee=this.rules.inline.text.exec(ae);if(ee){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):m(ee[0]):ee[0]:C=m(this.options.smartypants?le(ee[0]):ee[0]),{type:"text",raw:ee[0],text:C}}},Pe}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=p(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=p(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=p(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=p(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=p(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=p(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=n({},j),j.gfm=n({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=p(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=p(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=n({},j.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:p(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=p(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=p(j._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=p(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=p(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=p(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=p(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=p(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=p(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=p(L.reflink).replace("label",L._label).replace("ref",j._label).getRegex(),L.nolink=p(L.nolink).replace("ref",j._label).getRegex(),L.reflinkSearch=p(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=n({},L),L.pedantic=n({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=n({},L.normal,{escape:p(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=p(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=n({},L.gfm,{br:p(L.br).replace("{2,}","*").getRegex(),text:p(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function g(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function N(Pe){var Ie="",Se,ae,le=Pe.length;for(Se=0;Se<le;Se++)ae=Pe.charCodeAt(Se),Math.random()>.5&&(ae="x"+ae.toString(16)),Ie+="&#"+ae+";";return Ie}var B=function(){function Pe(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ne.defaults,this.options.tokenizer=this.options.tokenizer||new _,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:j.normal,inline:L.normal};this.options.pedantic?(ae.block=j.pedantic,ae.inline=L.pedantic):this.options.gfm&&(ae.block=j.gfm,this.options.breaks?ae.inline=L.breaks:ae.inline=L.gfm),this.tokenizer.rules=ae}Pe.lex=function(ae,le){var ee=new Pe(le);return ee.lex(ae)},Pe.lexInline=function(ae,le){var ee=new Pe(le);return ee.inlineTokens(ae)};var Ie=Pe.prototype;return Ie.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Ie.blockTokens=function(ae,le){var ee=this;le===void 0&&(le=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(fe,De,ue){return De+"    ".repeat(ue.length)});for(var C,$,W,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(C=fe.call({lexer:ee},ae,le))?(ae=ae.substring(C.raw.length),le.push(C),!0):!1}))){if(C=this.tokenizer.space(ae)){ae=ae.substring(C.raw.length),C.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(C);continue}if(C=this.tokenizer.code(ae)){ae=ae.substring(C.raw.length),$=le[le.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+C.raw,$.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(C);continue}if(C=this.tokenizer.fences(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.heading(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.hr(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.blockquote(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.list(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.html(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.def(ae)){ae=ae.substring(C.raw.length),$=le[le.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+C.raw,$.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.lheading(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(W=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,De=ae.slice(1),ue=void 0;ee.options.extensions.startBlock.forEach(function(ve){ue=ve.call({lexer:this},De),typeof ue=="number"&&ue>=0&&(fe=Math.min(fe,ue))}),fe<1/0&&fe>=0&&(W=ae.substring(0,fe+1))}(),this.state.top&&(C=this.tokenizer.paragraph(W))){$=le[le.length-1],V&&$.type==="paragraph"?($.raw+=`
`+C.raw,$.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(C),V=W.length!==ae.length,ae=ae.substring(C.raw.length);continue}if(C=this.tokenizer.text(ae)){ae=ae.substring(C.raw.length),$=le[le.length-1],$&&$.type==="text"?($.raw+=`
`+C.raw,$.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(C);continue}if(ae){var ie="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ie);break}else throw new Error(ie)}}return this.state.top=!0,le},Ie.inline=function(ae,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ae,tokens:le}),le},Ie.inlineTokens=function(ae,le){var ee=this;le===void 0&&(le=[]);var C,$,W,V=ae,ie,fe,De;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(ie=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)ue.includes(ie[0].slice(ie[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,ie.index)+"["+H("a",ie[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ie=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,ie.index)+"["+H("a",ie[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ie=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,ie.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(fe||(De=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(C=be.call({lexer:ee},ae,le))?(ae=ae.substring(C.raw.length),le.push(C),!0):!1}))){if(C=this.tokenizer.escape(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.tag(ae)){ae=ae.substring(C.raw.length),$=le[le.length-1],$&&C.type==="text"&&$.type==="text"?($.raw+=C.raw,$.text+=C.text):le.push(C);continue}if(C=this.tokenizer.link(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(C.raw.length),$=le[le.length-1],$&&C.type==="text"&&$.type==="text"?($.raw+=C.raw,$.text+=C.text):le.push(C);continue}if(C=this.tokenizer.emStrong(ae,V,De)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.codespan(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.br(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.del(ae)){ae=ae.substring(C.raw.length),le.push(C);continue}if(C=this.tokenizer.autolink(ae,N)){ae=ae.substring(C.raw.length),le.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(ae,N))){ae=ae.substring(C.raw.length),le.push(C);continue}if(W=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,He=ae.slice(1),je=void 0;ee.options.extensions.startInline.forEach(function(it){je=it.call({lexer:this},He),typeof je=="number"&&je>=0&&(be=Math.min(be,je))}),be<1/0&&be>=0&&(W=ae.substring(0,be+1))}(),C=this.tokenizer.inlineText(W,g)){ae=ae.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(De=C.raw.slice(-1)),fe=!0,$=le[le.length-1],$&&$.type==="text"?($.raw+=C.raw,$.text+=C.text):le.push(C);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return le},i(Pe,null,[{key:"rules",get:function(){return{block:j,inline:L}}}]),Pe}(),J=function(){function Pe(Se){this.options=Se||ne.defaults}var Ie=Pe.prototype;return Ie.code=function(ae,le,ee){var C=(le||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(ae,C);$!=null&&$!==ae&&(ee=!0,ae=$)}return ae=ae.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+m(C,!0)+'">'+(ee?ae:m(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:m(ae,!0))+`</code></pre>
`},Ie.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Ie.html=function(ae){return ae},Ie.heading=function(ae,le,ee,C){if(this.options.headerIds){var $=this.options.headerPrefix+C.slug(ee);return"<h"+le+' id="'+$+'">'+ae+"</h"+le+`>
`}return"<h"+le+">"+ae+"</h"+le+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(ae,le,ee){var C=le?"ol":"ul",$=le&&ee!==1?' start="'+ee+'"':"";return"<"+C+$+`>
`+ae+"</"+C+`>
`},Ie.listitem=function(ae){return"<li>"+ae+`</li>
`},Ie.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(ae){return"<p>"+ae+`</p>
`},Ie.table=function(ae,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+le+`</table>
`},Ie.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Ie.tablecell=function(ae,le){var ee=le.header?"th":"td",C=le.align?"<"+ee+' align="'+le.align+'">':"<"+ee+">";return C+ae+("</"+ee+`>
`)},Ie.strong=function(ae){return"<strong>"+ae+"</strong>"},Ie.em=function(ae){return"<em>"+ae+"</em>"},Ie.codespan=function(ae){return"<code>"+ae+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(ae){return"<del>"+ae+"</del>"},Ie.link=function(ae,le,ee){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var C='<a href="'+m(ae)+'"';return le&&(C+=' title="'+le+'"'),C+=">"+ee+"</a>",C},Ie.image=function(ae,le,ee){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var C='<img src="'+ae+'" alt="'+ee+'"';return le&&(C+=' title="'+le+'"'),C+=this.options.xhtml?"/>":">",C},Ie.text=function(ae){return ae},Pe}(),me=function(){function Pe(){}var Ie=Pe.prototype;return Ie.strong=function(ae){return ae},Ie.em=function(ae){return ae},Ie.codespan=function(ae){return ae},Ie.del=function(ae){return ae},Ie.html=function(ae){return ae},Ie.text=function(ae){return ae},Ie.link=function(ae,le,ee){return""+ee},Ie.image=function(ae,le,ee){return""+ee},Ie.br=function(){return""},Pe}(),te=function(){function Pe(){this.seen={}}var Ie=Pe.prototype;return Ie.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(ae,le){var ee=ae,C=0;if(this.seen.hasOwnProperty(ee)){C=this.seen[ae];do C++,ee=ae+"-"+C;while(this.seen.hasOwnProperty(ee))}return le||(this.seen[ae]=C,this.seen[ee]=0),ee},Ie.slug=function(ae,le){le===void 0&&(le={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,le.dryrun)},Pe}(),oe=function(){function Pe(Se){this.options=Se||ne.defaults,this.options.renderer=this.options.renderer||new J,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new te}Pe.parse=function(ae,le){var ee=new Pe(le);return ee.parse(ae)},Pe.parseInline=function(ae,le){var ee=new Pe(le);return ee.parseInline(ae)};var Ie=Pe.prototype;return Ie.parse=function(ae,le){le===void 0&&(le=!0);var ee="",C,$,W,V,ie,fe,De,ue,ve,be,He,je,it,Xe,et,nt,Fe,rt,G,Y=ae.length;for(C=0;C<Y;C++){if(be=ae[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(G=this.options.extensions.renderers[be.type].call({parser:this},be),G!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){ee+=G||"";continue}switch(be.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(be.tokens),be.depth,s(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ue="",De="",V=be.header.length,$=0;$<V;$++)De+=this.renderer.tablecell(this.parseInline(be.header[$].tokens),{header:!0,align:be.align[$]});for(ue+=this.renderer.tablerow(De),ve="",V=be.rows.length,$=0;$<V;$++){for(fe=be.rows[$],De="",ie=fe.length,W=0;W<ie;W++)De+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:be.align[W]});ve+=this.renderer.tablerow(De)}ee+=this.renderer.table(ue,ve);continue}case"blockquote":{ve=this.parse(be.tokens),ee+=this.renderer.blockquote(ve);continue}case"list":{for(He=be.ordered,je=be.start,it=be.loose,V=be.items.length,ve="",$=0;$<V;$++)et=be.items[$],nt=et.checked,Fe=et.task,Xe="",et.task&&(rt=this.renderer.checkbox(nt),it?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=rt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=rt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:rt}):Xe+=rt),Xe+=this.parse(et.tokens,it),ve+=this.renderer.listitem(Xe,Fe,nt);ee+=this.renderer.list(ve,He,je);continue}case"html":{ee+=this.renderer.html(be.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;C+1<Y&&ae[C+1].type==="text";)be=ae[++C],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);ee+=le?this.renderer.paragraph(ve):ve;continue}default:{var pe='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return ee},Ie.parseInline=function(ae,le){le=le||this.renderer;var ee="",C,$,W,V=ae.length;for(C=0;C<V;C++){if($=ae[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){ee+=W||"";continue}switch($.type){case"escape":{ee+=le.text($.text);break}case"html":{ee+=le.html($.text);break}case"link":{ee+=le.link($.href,$.title,this.parseInline($.tokens,le));break}case"image":{ee+=le.image($.href,$.title,$.text);break}case"strong":{ee+=le.strong(this.parseInline($.tokens,le));break}case"em":{ee+=le.em(this.parseInline($.tokens,le));break}case"codespan":{ee+=le.codespan($.text);break}case"br":{ee+=le.br();break}case"del":{ee+=le.del(this.parseInline($.tokens,le));break}case"text":{ee+=le.text($.text);break}default:{var ie='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return ee},Pe}();function ce(Pe,Ie,Se){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Ie=="function"&&(Se=Ie,Ie=null),Ie=n({},ce.defaults,Ie||{}),T(Ie),Se){var ae=Ie.highlight,le;try{le=B.lex(Pe,Ie)}catch(V){return Se(V)}var ee=function(ie){var fe;if(!ie)try{Ie.walkTokens&&ce.walkTokens(le,Ie.walkTokens),fe=oe.parse(le,Ie)}catch(De){ie=De}return Ie.highlight=ae,ie?Se(ie):Se(null,fe)};if(!ae||ae.length<3||(delete Ie.highlight,!le.length))return ee();var C=0;ce.walkTokens(le,function(V){V.type==="code"&&(C++,setTimeout(function(){ae(V.text,V.lang,function(ie,fe){if(ie)return ee(ie);fe!=null&&fe!==V.text&&(V.text=fe,V.escaped=!0),C--,C===0&&ee()})},0))}),C===0&&ee();return}function $(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+m(V.message+"",!0)+"</pre>";throw V}try{var W=B.lex(Pe,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(ce.walkTokens(W,Ie.walkTokens)).then(function(){return oe.parse(W,Ie)}).catch($);ce.walkTokens(W,Ie.walkTokens)}return oe.parse(W,Ie)}catch(V){$(V)}}ce.options=ce.setOptions=function(Pe){return n(ce.defaults,Pe),R(ce.defaults),ce},ce.getDefaults=E,ce.defaults=ne.defaults,ce.use=function(){for(var Pe=arguments.length,Ie=new Array(Pe),Se=0;Se<Pe;Se++)Ie[Se]=arguments[Se];var ae=n.apply(void 0,[{}].concat(Ie)),le=ce.defaults.extensions||{renderers:{},childTokens:{}},ee;Ie.forEach(function(C){if(C.extensions&&(ee=!0,C.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var V=le.renderers?le.renderers[W.name]:null;V?le.renderers[W.name]=function(){for(var ie=arguments.length,fe=new Array(ie),De=0;De<ie;De++)fe[De]=arguments[De];var ue=W.renderer.apply(this,fe);return ue===!1&&(ue=V.apply(this,fe)),ue}:le.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[W.level]?le[W.level].unshift(W.tokenizer):le[W.level]=[W.tokenizer],W.start&&(W.level==="block"?le.startBlock?le.startBlock.push(W.start):le.startBlock=[W.start]:W.level==="inline"&&(le.startInline?le.startInline.push(W.start):le.startInline=[W.start]))}W.childTokens&&(le.childTokens[W.name]=W.childTokens)})),C.renderer&&function(){var W=ce.defaults.renderer||new J,V=function(De){var ue=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var je=C.renderer[De].apply(W,be);return je===!1&&(je=ue.apply(W,be)),je}};for(var ie in C.renderer)V(ie);ae.renderer=W}(),C.tokenizer&&function(){var W=ce.defaults.tokenizer||new _,V=function(De){var ue=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var je=C.tokenizer[De].apply(W,be);return je===!1&&(je=ue.apply(W,be)),je}};for(var ie in C.tokenizer)V(ie);ae.tokenizer=W}(),C.walkTokens){var $=ce.defaults.walkTokens;ae.walkTokens=function(W){var V=[];return V.push(C.walkTokens.call(this,W)),$&&(V=V.concat($.call(this,W))),V}}ee&&(ae.extensions=le),ce.setOptions(ae)})},ce.walkTokens=function(Pe,Ie){for(var Se=[],ae=function(){var $=ee.value;switch(Se=Se.concat(Ie.call(ce,$)),$.type){case"table":{for(var W=F($.header),V;!(V=W()).done;){var ie=V.value;Se=Se.concat(ce.walkTokens(ie.tokens,Ie))}for(var fe=F($.rows),De;!(De=fe()).done;)for(var ue=De.value,ve=F(ue),be;!(be=ve()).done;){var He=be.value;Se=Se.concat(ce.walkTokens(He.tokens,Ie))}break}case"list":{Se=Se.concat(ce.walkTokens($.items,Ie));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[$.type]?ce.defaults.extensions.childTokens[$.type].forEach(function(je){Se=Se.concat(ce.walkTokens($[je],Ie))}):$.tokens&&(Se=Se.concat(ce.walkTokens($.tokens,Ie)))}},le=F(Pe),ee;!(ee=le()).done;)ae();return Se},ce.parseInline=function(Pe,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Ie=n({},ce.defaults,Ie||{}),T(Ie);try{var Se=B.lexInline(Pe,Ie);return Ie.walkTokens&&ce.walkTokens(Se,Ie.walkTokens),oe.parseInline(Se,Ie)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+m(ae.message+"",!0)+"</pre>";throw ae}},ce.Parser=oe,ce.parser=oe.parse,ce.Renderer=J,ce.TextRenderer=me,ce.Lexer=B,ce.lexer=B.lex,ce.Tokenizer=_,ce.Slugger=te,ce.parse=ce;var we=ce.options,q=ce.setOptions,x=ce.use,X=ce.walkTokens,de=ce.parseInline,ye=ce,Ne=oe.parse,ze=B.lex;ne.Lexer=B,ne.Parser=oe,ne.Renderer=J,ne.Slugger=te,ne.TextRenderer=me,ne.Tokenizer=_,ne.getDefaults=E,ne.lexer=ze,ne.marked=ce,ne.options=we,ne.parse=ye,ne.parseInline=de,ne.parser=Ne,ne.setOptions=q,ne.use=x,ne.walkTokens=X,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ke[113],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(R,y,k){return Math.min(Math.max(R,y),k)}e.clamp=i;function P(R,y){return(y+R%y)%y}e.rot=P;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class F{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=F;class E{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const k=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=E}),function(){function ne(I){const F=[];typeof I=="number"&&F.push("code/timeOrigin",I);function E(y){F.push(y,Date.now())}function R(){const y=[];for(let k=0;k<F.length;k+=2)y.push({name:F[k],startTime:F[k+1]});return y}return{mark:E,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const E of performance.getEntriesByType("mark"))F.push({name:E.name,startTime:Math.round(I+E.startTime)});return F}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function i(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=i(P))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var P in i)(typeof exports=="object"?exports:ne)[P]=i[P]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function i(P){if(e[P])return e[P].exports;var I=e[P]={i:P,l:!1,exports:{}};return ne[P].call(I.exports,I,I.exports,i),I.l=!0,I.exports}return i.m=ne,i.c=e,i.d=function(P,I,F){i.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:F})},i.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},i.t=function(P,I){if(1&I&&(P=i(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var F=Object.create(null);if(i.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var E in P)i.d(F,E,function(R){return P[R]}.bind(null,E));return F},i.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return i.d(I,"a",I),I},i.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},i.p="",i(i.s=0)}([function(ne,e,i){(function(P){var I;e=ne.exports=x,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,E=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],k=0,M=k++;y[M]="0|[1-9]\\d*";var D=k++;y[D]="[0-9]+";var h=k++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;y[b]="("+y[M]+")\\.("+y[M]+")\\.("+y[M]+")";var m=k++;y[m]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var o=k++;y[o]="(?:"+y[M]+"|"+y[h]+")";var s=k++;y[s]="(?:"+y[D]+"|"+y[h]+")";var u=k++;y[u]="(?:-("+y[o]+"(?:\\."+y[o]+")*))";var p=k++;y[p]="(?:-?("+y[s]+"(?:\\."+y[s]+")*))";var S=k++;y[S]="[0-9A-Za-z-]+";var O=k++;y[O]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var v=k++,t="v?"+y[b]+y[u]+"?"+y[O]+"?";y[v]="^"+t+"$";var d="[v=\\s]*"+y[m]+y[p]+"?"+y[O]+"?",a=k++;y[a]="^"+d+"$";var l=k++;y[l]="((?:<|>)?=?)";var c=k++;y[c]=y[D]+"|x|X|\\*";var w=k++;y[w]=y[M]+"|x|X|\\*";var n=k++;y[n]="[v=\\s]*("+y[w]+")(?:\\.("+y[w]+")(?:\\.("+y[w]+")(?:"+y[u]+")?"+y[O]+"?)?)?";var r=k++;y[r]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[p]+")?"+y[O]+"?)?)?";var f=k++;y[f]="^"+y[l]+"\\s*"+y[n]+"$";var A=k++;y[A]="^"+y[l]+"\\s*"+y[r]+"$";var T=k++;y[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=k++;y[H]="(?:~>?)";var Q=k++;y[Q]="(\\s*)"+y[H]+"\\s+",R[Q]=new RegExp(y[Q],"g");var Z=k++;y[Z]="^"+y[H]+y[n]+"$";var _=k++;y[_]="^"+y[H]+y[r]+"$";var j=k++;y[j]="(?:\\^)";var L=k++;y[L]="(\\s*)"+y[j]+"\\s+",R[L]=new RegExp(y[L],"g");var g=k++;y[g]="^"+y[j]+y[n]+"$";var N=k++;y[N]="^"+y[j]+y[r]+"$";var B=k++;y[B]="^"+y[l]+"\\s*("+d+")$|^$";var J=k++;y[J]="^"+y[l]+"\\s*("+t+")$|^$";var me=k++;y[me]="(\\s*)"+y[l]+"\\s*("+d+"|"+y[n]+")",R[me]=new RegExp(y[me],"g");var te=k++;y[te]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var oe=k++;y[oe]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var ce=k++;y[ce]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)I(we,y[we]),R[we]||(R[we]=new RegExp(y[we]));function q(ue,ve){if(ue instanceof x)return ue;if(typeof ue!="string"||ue.length>F||!(ve?R[a]:R[v]).test(ue))return null;try{return new x(ue,ve)}catch{return null}}function x(ue,ve){if(ue instanceof x){if(ue.loose===ve)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof x))return new x(ue,ve);I("SemVer",ue,ve),this.loose=ve;var be=ue.trim().match(ve?R[a]:R[v]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>E||this.major<0)throw new TypeError("Invalid major version");if(this.minor>E||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>E||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var je=+He;if(je>=0&&je<E)return je}return He}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=q,e.valid=function(ue,ve){var be=q(ue,ve);return be?be.version:null},e.clean=function(ue,ve){var be=q(ue.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(ue){return I("SemVer.compare",this.version,this.loose,ue),ue instanceof x||(ue=new x(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},x.prototype.compareMain=function(ue){return ue instanceof x||(ue=new x(ue,this.loose)),de(this.major,ue.major)||de(this.minor,ue.minor)||de(this.patch,ue.patch)},x.prototype.comparePre=function(ue){if(ue instanceof x||(ue=new x(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],He=ue.prerelease[ve];if(I("prerelease compare",ve,be,He),be===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(be===void 0)return-1;if(be!==He)return de(be,He)}while(++ve)},x.prototype.inc=function(ue,ve){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ve,be,He){typeof be=="string"&&(He=be,be=void 0);try{return new x(ue,be).inc(ve,He).version}catch{return null}},e.diff=function(ue,ve){if(Pe(ue,ve))return null;var be=q(ue),He=q(ve);if(be.prerelease.length||He.prerelease.length){for(var je in be)if((je==="major"||je==="minor"||je==="patch")&&be[je]!==He[je])return"pre"+je;return"prerelease"}for(var je in be)if((je==="major"||je==="minor"||je==="patch")&&be[je]!==He[je])return je},e.compareIdentifiers=de;var X=/^[0-9]+$/;function de(ue,ve){var be=X.test(ue),He=X.test(ve);return be&&He&&(ue=+ue,ve=+ve),be&&!He?-1:He&&!be?1:ue<ve?-1:ue>ve?1:0}function ye(ue,ve,be){return new x(ue,be).compare(new x(ve,be))}function Ne(ue,ve,be){return ye(ue,ve,be)>0}function ze(ue,ve,be){return ye(ue,ve,be)<0}function Pe(ue,ve,be){return ye(ue,ve,be)===0}function Ie(ue,ve,be){return ye(ue,ve,be)!==0}function Se(ue,ve,be){return ye(ue,ve,be)>=0}function ae(ue,ve,be){return ye(ue,ve,be)<=0}function le(ue,ve,be,He){var je;switch(ve){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),je=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),je=ue!==be;break;case"":case"=":case"==":je=Pe(ue,be,He);break;case"!=":je=Ie(ue,be,He);break;case">":je=Ne(ue,be,He);break;case">=":je=Se(ue,be,He);break;case"<":je=ze(ue,be,He);break;case"<=":je=ae(ue,be,He);break;default:throw new TypeError("Invalid operator: "+ve)}return je}function ee(ue,ve){if(ue instanceof ee){if(ue.loose===ve)return ue;ue=ue.value}if(!(this instanceof ee))return new ee(ue,ve);I("comparator",ue,ve),this.loose=ve,this.parse(ue),this.semver===C?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ue,ve){return de(ve,ue)},e.major=function(ue,ve){return new x(ue,ve).major},e.minor=function(ue,ve){return new x(ue,ve).minor},e.patch=function(ue,ve){return new x(ue,ve).patch},e.compare=ye,e.compareLoose=function(ue,ve){return ye(ue,ve,!0)},e.rcompare=function(ue,ve,be){return ye(ve,ue,be)},e.sort=function(ue,ve){return ue.sort(function(be,He){return e.compare(be,He,ve)})},e.rsort=function(ue,ve){return ue.sort(function(be,He){return e.rcompare(be,He,ve)})},e.gt=Ne,e.lt=ze,e.eq=Pe,e.neq=Ie,e.gte=Se,e.lte=ae,e.cmp=le,e.Comparator=ee;var C={};function $(ue,ve){if(ue instanceof $)return ue.loose===ve?ue:new $(ue.raw,ve);if(ue instanceof ee)return new $(ue.value,ve);if(!(this instanceof $))return new $(ue,ve);if(this.loose=ve,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function W(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function V(ue,ve,be,He,je,it,Xe,et,nt,Fe,rt,G,Y){return((ve=W(be)?"":W(He)?">="+be+".0.0":W(je)?">="+be+"."+He+".0":">="+ve)+" "+(et=W(nt)?"":W(Fe)?"<"+(+nt+1)+".0.0":W(rt)?"<"+nt+"."+(+Fe+1)+".0":G?"<="+nt+"."+Fe+"."+rt+"-"+G:"<="+et)).trim()}function ie(ue,ve){for(var be=0;be<ue.length;be++)if(!ue[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<ue.length;be++)if(I(ue[be].semver),ue[be].semver!==C&&ue[be].semver.prerelease.length>0){var He=ue[be].semver;if(He.major===ve.major&&He.minor===ve.minor&&He.patch===ve.patch)return!0}return!1}return!0}function fe(ue,ve,be){try{ve=new $(ve,be)}catch{return!1}return ve.test(ue)}function De(ue,ve,be,He){var je,it,Xe,et,nt;switch(ue=new x(ue,He),ve=new $(ve,He),be){case">":je=Ne,it=ae,Xe=ze,et=">",nt=">=";break;case"<":je=ze,it=Se,Xe=Ne,et="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(ue,ve,He))return!1;for(var Fe=0;Fe<ve.set.length;++Fe){var rt=ve.set[Fe],G=null,Y=null;if(rt.forEach(function(pe){pe.semver===C&&(pe=new ee(">=0.0.0")),G=G||pe,Y=Y||pe,je(pe.semver,G.semver,He)?G=pe:Xe(pe.semver,Y.semver,He)&&(Y=pe)}),G.operator===et||G.operator===nt||(!Y.operator||Y.operator===et)&&it(ue,Y.semver)||Y.operator===nt&&Xe(ue,Y.semver))return!1}return!0}ee.prototype.parse=function(ue){var ve=this.loose?R[B]:R[J],be=ue.match(ve);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new x(be[2],this.loose):this.semver=C},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(ue){return I("Comparator.test",ue,this.loose),this.semver===C||(typeof ue=="string"&&(ue=new x(ue,this.loose)),le(ue,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(ue,ve){if(!(ue instanceof ee))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new $(ue.value,ve),fe(this.value,be,ve);if(ue.operator==="")return be=new $(this.value,ve),fe(ue.semver,be,ve);var He=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),it=this.semver.version===ue.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),et=le(this.semver,"<",ue.semver,ve)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),nt=le(this.semver,">",ue.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return He||je||it&&Xe||et||nt},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ue){var ve=this.loose;ue=ue.trim(),I("range",ue,ve);var be=ve?R[oe]:R[te];ue=ue.replace(be,V),I("hyphen replace",ue),ue=ue.replace(R[me],"$1$2$3"),I("comparator trim",ue,R[me]),ue=(ue=(ue=ue.replace(R[Q],"$1~")).replace(R[L],"$1^")).split(/\s+/).join(" ");var He=ve?R[B]:R[J],je=ue.split(" ").map(function(it){return function(Xe,et){return I("comp",Xe),Xe=function(nt,Fe){return nt.trim().split(/\s+/).map(function(rt){return function(G,Y){I("caret",G,Y);var pe=Y?R[N]:R[g];return G.replace(pe,function(We,$e,Qe,Ke,tt){var at;return I("caret",G,We,$e,Qe,Ke,tt),W($e)?at="":W(Qe)?at=">="+$e+".0.0 <"+(+$e+1)+".0.0":W(Ke)?at=$e==="0"?">="+$e+"."+Qe+".0 <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+".0 <"+(+$e+1)+".0.0":tt?(I("replaceCaret pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=$e==="0"?Qe==="0"?">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+Qe+"."+(+Ke+1):">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+"."+Ke+tt+" <"+(+$e+1)+".0.0"):(I("no pr"),at=$e==="0"?Qe==="0"?">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+Qe+"."+(+Ke+1):">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+"."+Ke+" <"+(+$e+1)+".0.0"),I("caret return",at),at})}(rt,Fe)}).join(" ")}(Xe,et),I("caret",Xe),Xe=function(nt,Fe){return nt.trim().split(/\s+/).map(function(rt){return function(G,Y){var pe=Y?R[_]:R[Z];return G.replace(pe,function(We,$e,Qe,Ke,tt){var at;return I("tilde",G,We,$e,Qe,Ke,tt),W($e)?at="":W(Qe)?at=">="+$e+".0.0 <"+(+$e+1)+".0.0":W(Ke)?at=">="+$e+"."+Qe+".0 <"+$e+"."+(+Qe+1)+".0":tt?(I("replaceTilde pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+(+Qe+1)+".0"):at=">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+(+Qe+1)+".0",I("tilde return",at),at})}(rt,Fe)}).join(" ")}(Xe,et),I("tildes",Xe),Xe=function(nt,Fe){return I("replaceXRanges",nt,Fe),nt.split(/\s+/).map(function(rt){return function(G,Y){G=G.trim();var pe=Y?R[A]:R[f];return G.replace(pe,function(We,$e,Qe,Ke,tt,at){I("xRange",G,We,$e,Qe,Ke,tt,at);var Et=W(Qe),Ct=Et||W(Ke),It=Ct||W(tt);return $e==="="&&It&&($e=""),Et?We=$e===">"||$e==="<"?"<0.0.0":"*":$e&&It?(Ct&&(Ke=0),It&&(tt=0),$e===">"?($e=">=",Ct?(Qe=+Qe+1,Ke=0,tt=0):It&&(Ke=+Ke+1,tt=0)):$e==="<="&&($e="<",Ct?Qe=+Qe+1:Ke=+Ke+1),We=$e+Qe+"."+Ke+"."+tt):Ct?We=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":It&&(We=">="+Qe+"."+Ke+".0 <"+Qe+"."+(+Ke+1)+".0"),I("xRange return",We),We})}(rt,Fe)}).join(" ")}(Xe,et),I("xrange",Xe),Xe=function(nt,Fe){return I("replaceStars",nt,Fe),nt.trim().replace(R[ce],"")}(Xe,et),I("stars",Xe),Xe}(it,ve)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(it){return!!it.match(He)})),je=je.map(function(it){return new ee(it,ve)})},$.prototype.intersects=function(ue,ve){if(!(ue instanceof $))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(He){return ue.set.some(function(je){return je.every(function(it){return He.intersects(it,ve)})})})})},e.toComparators=function(ue,ve){return new $(ue,ve).set.map(function(be){return be.map(function(He){return He.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new x(ue,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ie(this.set[ve],ue))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(ue,ve,be){var He=null,je=null;try{var it=new $(ve,be)}catch{return null}return ue.forEach(function(Xe){it.test(Xe)&&(He&&je.compare(Xe)!==-1||(je=new x(He=Xe,be)))}),He},e.minSatisfying=function(ue,ve,be){var He=null,je=null;try{var it=new $(ve,be)}catch{return null}return ue.forEach(function(Xe){it.test(Xe)&&(He&&je.compare(Xe)!==1||(je=new x(He=Xe,be)))}),He},e.validRange=function(ue,ve){try{return new $(ue,ve).range||"*"}catch{return null}},e.ltr=function(ue,ve,be){return De(ue,ve,"<",be)},e.gtr=function(ue,ve,be){return De(ue,ve,">",be)},e.outside=De,e.prerelease=function(ue,ve){var be=q(ue,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ve,be){return ue=new $(ue,be),ve=new $(ve,be),ue.intersects(ve)},e.coerce=function(ue){if(ue instanceof x)return ue;if(typeof ue!="string")return null;var ve=ue.match(R[T]);return ve==null?null:q((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(ne,e){var i,P,I=ne.exports={};function F(){throw new Error("setTimeout has not been defined")}function E(){throw new Error("clearTimeout has not been defined")}function R(s){if(i===setTimeout)return setTimeout(s,0);if((i===F||!i)&&setTimeout)return i=setTimeout,setTimeout(s,0);try{return i(s,0)}catch{try{return i.call(null,s,0)}catch{return i.call(this,s,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:F}catch{i=F}try{P=typeof clearTimeout=="function"?clearTimeout:E}catch{P=E}})();var y,k=[],M=!1,D=-1;function h(){M&&y&&(M=!1,y.length?k=y.concat(k):D=-1,k.length&&b())}function b(){if(!M){var s=R(h);M=!0;for(var u=k.length;u;){for(y=k,k=[];++D<u;)y&&y[D].run();D=-1,u=k.length}y=null,M=!1,function(p){if(P===clearTimeout)return clearTimeout(p);if((P===E||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(p);try{P(p)}catch{try{return P.call(null,p)}catch{return P.call(this,p)}}}(s)}}function m(s,u){this.fun=s,this.array=u}function o(){}I.nextTick=function(s){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];k.push(new m(s,u)),k.length!==1||M||R(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=o,I.addListener=o,I.once=o,I.off=o,I.removeListener=o,I.removeAllListeners=o,I.emit=o,I.prependListener=o,I.prependOnceListener=o,I.listeners=function(s){return[]},I.binding=function(s){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(s){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(ke[114],Te([1,0,11,6]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(O){const v=O;return v?typeof v.read=="function":!1}e.isReadable=I;function F(O){const v=O;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=F;function E(O){const v=O;return v?F(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=E;function R(O,v){return new y(O,v)}e.newWriteableStream=R;class y{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,i.onUnexpectedError)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let d;switch(v){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const a=d.indexOf(t);a>=0&&d.splice(a,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(O,v){const t=[];let d;for(;(d=O.read())!==null;)t.push(d);return v(t)}e.consumeReadable=k;function M(O,v,t){const d=[];let a;for(;(a=O.read())!==null&&d.length<t;)d.push(a);return a===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof a<"u"){const l=a;return a=void 0,l}return O.read()}}}e.peekReadable=M;function D(O,v){return new Promise((t,d)=>{const a=[];h(O,{onData:l=>{v&&a.push(l)},onError:l=>{v?d(l):t(void 0)},onEnd:()=>{t(v?v(a):void 0)}})})}e.consumeStream=D;function h(O,v){let t=!1;return O.on("error",d=>{t||v.onError(d)}),O.on("end",()=>{t||v.onEnd()}),O.on("data",d=>{t||v.onData(d)}),(0,P.toDisposable)(()=>t=!0)}e.listenStream=h;function b(O,v){return new Promise((t,d)=>{const a=new P.DisposableStore,l=[],c=r=>{if(l.push(r),l.length>v)return a.dispose(),O.pause(),t({stream:O,buffer:l,ended:!1})},w=r=>d(r),n=()=>t({stream:O,buffer:l,ended:!0});a.add((0,P.toDisposable)(()=>O.removeListener("error",w))),O.on("error",w),a.add((0,P.toDisposable)(()=>O.removeListener("end",n))),O.on("end",n),a.add((0,P.toDisposable)(()=>O.removeListener("data",c))),O.on("data",c)})}e.peekStream=b;function m(O,v){const t=R(v);return t.end(O),t}e.toStream=m;function o(){const O=R(()=>{throw new Error("not supported")});return O.end(),O}e.emptyStream=o;function s(O){let v=!1;return{read:()=>v?null:(v=!0,O)}}e.toReadable=s;function u(O,v,t){const d=R(t);return h(O,{onData:a=>d.write(v.data(a)),onError:a=>d.error(v.error?v.error(a):a),onEnd:()=>d.end()}),d}e.transform=u;function p(O,v,t){let d=!1;return{read:()=>{const a=v.read();return d?a:(d=!0,a!==null?t([O,a]):O)}}}e.prefixedReadable=p;function S(O,v,t){let d=!1;const a=R(t);return h(v,{onData:l=>d?a.write(l):(d=!0,a.write(t([O,l]))),onError:l=>a.error(l),onEnd:()=>{d||(d=!0,a.write(O)),a.end()}}),a}e.prefixedStream=S}),define(ke[23],Te([1,0,114]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let I,F;class E{static alloc(r){return P?new E(Buffer.allocUnsafe(r)):new E(new Uint8Array(r))}static wrap(r){return P&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new E(r)}static fromString(r,f){return!(f?.dontUseNodeBuffer||!1)&&P?new E(Buffer.from(r)):(I||(I=new TextEncoder),new E(I.encode(r)))}static fromByteArray(r){const f=E.alloc(r.length);for(let A=0,T=r.length;A<T;A++)f.buffer[A]=r[A];return f}static concat(r,f){if(typeof f>"u"){f=0;for(let H=0,Q=r.length;H<Q;H++)f+=r[H].byteLength}const A=E.alloc(f);let T=0;for(let H=0,Q=r.length;H<Q;H++){const Z=r[H];A.set(Z,T),T+=Z.byteLength}return A}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=E.alloc(this.byteLength);return r.set(this),r}toString(){return P?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(r,f){return new E(this.buffer.subarray(r,f))}set(r,f){if(r instanceof E)this.buffer.set(r.buffer,f);else if(r instanceof Uint8Array)this.buffer.set(r,f);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),f);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return k(this.buffer,r)}writeUInt32BE(r,f){M(this.buffer,r,f)}readUInt32LE(r){return D(this.buffer,r)}writeUInt32LE(r,f){h(this.buffer,r,f)}readUInt8(r){return b(this.buffer,r)}writeUInt8(r,f){m(this.buffer,r,f)}}e.VSBuffer=E;function R(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=R;function y(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255}e.writeUInt16LE=y;function k(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=k;function M(n,r,f){n[f+3]=r,r=r>>>8,n[f+2]=r,r=r>>>8,n[f+1]=r,r=r>>>8,n[f]=r}e.writeUInt32BE=M;function D(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=D;function h(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255,r=r>>>8,n[f+2]=r&255,r=r>>>8,n[f+3]=r&255}e.writeUInt32LE=h;function b(n,r){return n[r]}e.readUInt8=b;function m(n,r,f){n[f]=r}e.writeUInt8=m;function o(n){return i.consumeReadable(n,r=>E.concat(r))}e.readableToBuffer=o;function s(n){return i.toReadable(n)}e.bufferToReadable=s;function u(n){return i.consumeStream(n,r=>E.concat(r))}e.streamToBuffer=u;async function p(n){return n.ended?E.concat(n.buffer):E.concat([...n.buffer,await u(n.stream)])}e.bufferedStreamToBuffer=p;function S(n){return i.toStream(n,r=>E.concat(r))}e.bufferToStream=S;function O(n){return i.transform(n,{data:r=>typeof r=="string"?E.fromString(r):E.wrap(r)},r=>E.concat(r))}e.streamToBufferReadableStream=O;function v(n){return i.newWriteableStream(r=>E.concat(r),n)}e.newWriteableBufferStream=v;function t(n,r){return i.prefixedReadable(n,r,f=>E.concat(f))}e.prefixedBufferReadable=t;function d(n,r){return i.prefixedStream(n,r,f=>E.concat(f))}e.prefixedBufferStream=d;function a(n){let r=0,f=0,A=0;const T=new Uint8Array(Math.floor(n.length/4*3)),H=Z=>{switch(f){case 3:T[A++]=r|Z,f=0;break;case 2:T[A++]=r|Z>>>2,r=Z<<6,f=3;break;case 1:T[A++]=r|Z>>>4,r=Z<<4,f=2;break;default:r=Z<<2,f=1}};for(let Z=0;Z<n.length;Z++){const _=n.charCodeAt(Z);if(_>=65&&_<=90)H(_-65);else if(_>=97&&_<=122)H(_-97+26);else if(_>=48&&_<=57)H(_-48+52);else if(_===43||_===45)H(62);else if(_===47||_===95)H(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${n[Z]}`)}}const Q=A;for(;f>0;)H(0);return E.wrap(T).slice(0,Q)}e.decodeBase64=a;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:n},r=!0,f=!1){const A=f?c:l;let T="";const H=n.byteLength%3;let Q=0;for(;Q<n.byteLength-H;Q+=3){const Z=n[Q+0],_=n[Q+1],j=n[Q+2];T+=A[Z>>>2],T+=A[(Z<<4|_>>>4)&63],T+=A[(_<<2|j>>>6)&63],T+=A[j&63]}if(H===1){const Z=n[Q+0];T+=A[Z>>>2],T+=A[Z<<4&63],r&&(T+="==")}else if(H===2){const Z=n[Q+0],_=n[Q+1];T+=A[Z>>>2],T+=A[(Z<<4|_>>>4)&63],T+=A[_<<2&63],r&&(T+="=")}return T}e.encodeBase64=w}),define(ke[115],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ke[38],Te([1,0,84]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(E){function R(y){return y&&typeof y=="object"&&typeof y.id=="string"}E.isThemeColor=R})(P=e.ThemeColor||(e.ThemeColor={}));function I(E){return{id:E}}e.themeColorFromId=I;var F;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function y(p){const S=R.exec(p.id);if(!S)return y(i.Codicon.error);const[,O,v]=S,t=["codicon","codicon-"+O];return v&&t.push("codicon-modifier-"+v.substring(1)),t}E.asClassNameArray=y;function k(p){return y(p).join(" ")}E.asClassName=k;function M(p){return"."+y(p).join(".")}E.asCSSSelector=M;function D(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||P.isThemeColor(p.color))}E.isThemeIcon=D;const h=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function b(p){const S=h.exec(p);if(!S)return;const[,O]=S;return{id:O}}E.fromString=b;function m(p){return{id:p}}E.fromId=m;function o(p,S){let O=p.id;const v=O.lastIndexOf("~");return v!==-1&&(O=O.substring(0,v)),S&&(O=`${O}~${S}`),{id:O}}E.modify=o;function s(p){const S=p.id.lastIndexOf("~");if(S!==-1)return p.id.substring(S+1)}E.getModifier=s;function u(p,S){return p.id===S.id&&p.color?.id===S.color?.id}E.isEqual=u})(F=e.ThemeIcon||(e.ThemeIcon={}))}),define(ke[34],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(I){return i.test(I)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const F=new Uint8Array(16),E=[];for(let R=0;R<256;R++)E.push(R.toString(16).padStart(2,"0"));return function(){I(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let y=0,k="";return k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k+="-",k+=E[F[y++]],k+=E[F[y++]],k+="-",k+=E[F[y++]],k+=E[F[y++]],k+="-",k+=E[F[y++]],k+=E[F[y++]],k+="-",k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k+=E[F[y++]],k}}()}),define(ke[116],Te([1,0,16,34]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(R){return{id:(0,P.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=I;function F(R,y,k){return{id:(0,P.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=F;class E{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,k){const M=this.a.get(y);M?M.push(k):this.a.set(this.b(y),[k])}replace(y,k){this.a.set(this.b(y),[k])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,k]of this.a.entries())for(const M of k)yield[y,M]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[k,M]of this.entries())y(M,k)}b(y){return y.toLowerCase()}}e.VSDataTransfer=E,e.UriList=Object.freeze({create:R=>(0,i.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(ke[117],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[118],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class P{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,k=R.notIn.length;y<k;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(y-2),M=R.getStandardTokenType(k);return this.isOK(M)}g(R,y){for(let k=R;k<=y;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=P;class I{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)F(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),F(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),F(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),F(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&F(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function F(E,R,y){E.has(R)?E.get(R).push(y):E.set(R,[y])}}),define(ke[119],Te([13,14]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(ke[120],Te([13,14]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ke[121],Te([1,0,120]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,I=P*60,F=I*24,E=F*7,R=F*30,y=F*365;function k(D,h,b,m){typeof D!="number"&&(D=D.getTime());const o=Math.round((new Date().getTime()-D)/1e3);if(o<-30)return(0,i.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!m&&o<30)return(0,i.localize)(1,null);let s;return o<P?(s=o,h?s===1?b?(0,i.localize)(2,null,s):(0,i.localize)(3,null,s):b?(0,i.localize)(4,null,s):(0,i.localize)(5,null,s):s===1?b?(0,i.localize)(6,null,s):(0,i.localize)(7,null,s):b?(0,i.localize)(8,null,s):(0,i.localize)(9,null,s)):o<I?(s=Math.floor(o/P),h?s===1?b?(0,i.localize)(10,null,s):(0,i.localize)(11,null,s):b?(0,i.localize)(12,null,s):(0,i.localize)(13,null,s):s===1?b?(0,i.localize)(14,null,s):(0,i.localize)(15,null,s):b?(0,i.localize)(16,null,s):(0,i.localize)(17,null,s)):o<F?(s=Math.floor(o/I),h?s===1?b?(0,i.localize)(18,null,s):(0,i.localize)(19,null,s):b?(0,i.localize)(20,null,s):(0,i.localize)(21,null,s):s===1?b?(0,i.localize)(22,null,s):(0,i.localize)(23,null,s):b?(0,i.localize)(24,null,s):(0,i.localize)(25,null,s)):o<E?(s=Math.floor(o/F),h?s===1?(0,i.localize)(26,null,s):(0,i.localize)(27,null,s):s===1?(0,i.localize)(28,null,s):(0,i.localize)(29,null,s)):o<R?(s=Math.floor(o/E),h?s===1?b?(0,i.localize)(30,null,s):(0,i.localize)(31,null,s):b?(0,i.localize)(32,null,s):(0,i.localize)(33,null,s):s===1?b?(0,i.localize)(34,null,s):(0,i.localize)(35,null,s):b?(0,i.localize)(36,null,s):(0,i.localize)(37,null,s)):o<y?(s=Math.floor(o/R),h?s===1?b?(0,i.localize)(38,null,s):(0,i.localize)(39,null,s):b?(0,i.localize)(40,null,s):(0,i.localize)(41,null,s):s===1?b?(0,i.localize)(42,null,s):(0,i.localize)(43,null,s):b?(0,i.localize)(44,null,s):(0,i.localize)(45,null,s)):(s=Math.floor(o/y),h?s===1?b?(0,i.localize)(46,null,s):(0,i.localize)(47,null,s):b?(0,i.localize)(48,null,s):(0,i.localize)(49,null,s):s===1?b?(0,i.localize)(50,null,s):(0,i.localize)(51,null,s):b?(0,i.localize)(52,null,s):(0,i.localize)(53,null,s))}e.fromNow=k;function M(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(ke[122],Te([13,14]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ke[39],Te([1,0,16,9,122]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(D,h){return h&&(D.stack||D.stacktrace)?I.localize(0,null,R(D),E(D.stack)||E(D.stacktrace)):R(D)}function E(D){return Array.isArray(D)?D.join(`
`):D}function R(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function y(D=null,h=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const b=i.coalesce(D),m=y(b[0],h);return b.length>1?I.localize(4,null,m,b.length):m}if(P.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return F(b.error,h);if(b.exception)return F(b.exception,h)}return D.stack?F(D,h):D.message?D.message:I.localize(5,null)}e.toErrorMessage=y;function k(D){const h=D;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=k;function M(D,h){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=h,b}e.createErrorWithActions=M}),define(ke[123],Te([1,0,85,19]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new i.Lazy(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),F=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new i.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(r,f,A=!1){const T=r||"",H=f||"",Q=I.value.collator.compare(T,H);return I.value.collatorIsNumeric&&Q===0&&T!==H?T<H?-1:1:Q}e.compareFileNames=R;function y(r,f){const A=F.value.collator;return r=r||"",f=f||"",O(A,r,f)}e.compareFileNamesDefault=y;function k(r,f){const A=F.value.collator;return r=r||"",f=f||"",a(r,f)||O(A,r,f)}e.compareFileNamesUpper=k;function M(r,f){const A=F.value.collator;return r=r||"",f=f||"",d(r,f)||O(A,r,f)}e.compareFileNamesLower=M;function D(r,f){return r=r||"",f=f||"",r===f?0:r<f?-1:1}e.compareFileNamesUnicode=D;function h(r,f){const[A,T]=p(r),[H,Q]=p(f);let Z=I.value.collator.compare(T,Q);if(Z===0){if(I.value.collatorIsNumeric&&T!==Q)return T<Q?-1:1;if(Z=I.value.collator.compare(A,H),I.value.collatorIsNumeric&&Z===0&&A!==H)return A<H?-1:1}return Z}e.compareFileExtensions=h;function b(r,f){r=r||"",f=f||"";const A=S(r),T=S(f),H=F.value.collator,Q=E.value.collator;return O(Q,A,T)||O(H,r,f)}e.compareFileExtensionsDefault=b;function m(r,f){r=r||"",f=f||"";const A=S(r),T=S(f),H=F.value.collator,Q=E.value.collator;return O(Q,A,T)||a(r,f)||O(H,r,f)}e.compareFileExtensionsUpper=m;function o(r,f){r=r||"",f=f||"";const A=S(r),T=S(f),H=F.value.collator,Q=E.value.collator;return O(Q,A,T)||d(r,f)||O(H,r,f)}e.compareFileExtensionsLower=o;function s(r,f){r=r||"",f=f||"";const A=S(r).toLowerCase(),T=S(f).toLowerCase();return A!==T?A<T?-1:1:r!==f?r<f?-1:1:0}e.compareFileExtensionsUnicode=s;const u=/^(.*?)(\.([^.]*))?$/;function p(r,f=!1){const A=r?u.exec(r):[];let T=[A&&A[1]||"",A&&A[3]||""];return f&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function S(r){const f=r?u.exec(r):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function O(r,f,A){const T=r.compare(f,A);return T!==0?T:f.length!==A.length?f.length<A.length?-1:1:0}function v(r){const f=r.charAt(0);return f.toLocaleUpperCase()!==f}function t(r){const f=r.charAt(0);return f.toLocaleLowerCase()!==f}function d(r,f){return v(r)&&t(f)?-1:t(r)&&v(f)?1:0}function a(r,f){return t(r)&&v(f)?-1:v(r)&&t(f)?1:0}function l(r,f,A=!1){return A||(r=r&&r.toLowerCase(),f=f&&f.toLowerCase()),r===f?0:r<f?-1:1}function c(r,f,A=!1){const T=r.split(P.sep),H=f.split(P.sep),Q=T.length-1,Z=H.length-1;let _,j;for(let L=0;;L++){if(_=Q===L,j=Z===L,_&&j)return R(T[L],H[L],A);if(_)return-1;if(j)return 1;const g=l(T[L],H[L],A);if(g!==0)return g}}e.comparePaths=c;function w(r,f,A){const T=r.toLowerCase(),H=f.toLowerCase(),Q=n(r,f,A);if(Q)return Q;const Z=T.endsWith(A),_=H.endsWith(A);if(Z!==_)return Z?-1:1;const j=R(T,H);return j!==0?j:T.localeCompare(H)}e.compareAnything=w;function n(r,f,A){const T=r.toLowerCase(),H=f.toLowerCase(),Q=T.startsWith(A),Z=H.startsWith(A);if(Q!==Z)return Q?-1:1;if(Q&&Z){if(T.length<H.length)return-1;if(T.length>H.length)return 1}return 0}e.compareByPrefix=n}),define(ke[65],Te([1,0,19]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(M){const D=(0,i.extname)(M),h=P[D.toLowerCase()];return h!==void 0?h:E(M)}e.getMediaOrTextMime=F;function E(M){const D=(0,i.extname)(M);return I[D.toLowerCase()]}e.getMediaMime=E;function R(M){for(const D in I)if(I[D]===M)return D}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function k(M,D){const h=y.exec(M);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:D?void 0:M}e.normalizeMimeType=k}),define(ke[124],Te([1,0,4,6,119]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends P.Disposable{constructor(h,b="",m="",o=!0,s){super(),this.h=this.B(new i.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=b,this.u=m,this.w=o,this.C=s}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,b){this.C&&await this.C(h)}}e.Action=F;class E extends P.Disposable{constructor(){super(...arguments),this.f=this.B(new i.Emitter),this.onWillRun=this.f.event,this.h=this.B(new i.Emitter),this.onDidRun=this.h.event}async run(h,b){if(!h.enabled)return;this.f.fire({action:h});let m;try{await this.runAction(h,b)}catch(o){m=o}this.h.fire({action:h,error:m})}async runAction(h,b){await h.run(b)}}e.ActionRunner=E;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let b=[];for(const m of h)m.length&&(b.length?b=[...b,new R,...m]:b=m);return b}async run(){}}R.ID="vs.actions.separator",e.Separator=R;class y{get actions(){return this.a}constructor(h,b,m,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=b,this.class=o,this.a=m}async run(){}}e.SubmenuAction=y;class k extends F{constructor(){super(k.ID,I.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function M(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.toAction=M}),define(ke[40],Te([1,0,19,20,10,9]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(c){return c===47||c===92}e.isPathSeparator=E;function R(c){return c.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=R;function y(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function k(c,w=i.posix.sep){if(!c)return"";const n=c.length,r=c.charCodeAt(0);if(E(r)){if(E(c.charCodeAt(1))&&!E(c.charCodeAt(2))){let A=3;const T=A;for(;A<n&&!E(c.charCodeAt(A));A++);if(T!==A&&!E(c.charCodeAt(A+1))){for(A+=1;A<n;A++)if(E(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,w)}}return w}else if(u(r)&&c.charCodeAt(1)===58)return E(c.charCodeAt(2))?c.slice(0,2)+w:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(E(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=k;function M(c){if(!P.isWindows||!c||c.length<5)return!1;let w=c.charCodeAt(0);if(w!==92||(w=c.charCodeAt(1),w!==92))return!1;let n=2;const r=n;for(;n<c.length&&(w=c.charCodeAt(n),w!==92);n++);return!(r===n||(w=c.charCodeAt(n+1),isNaN(w)||w===92))}e.isUNC=M;const D=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,w=P.isWindows){const n=w?D:h;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||w&&b.test(c)||c==="."||c===".."||w&&c[c.length-1]==="."||w&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function o(c,w,n){const r=c===w;return!n||r?r:!c||!w?!1:(0,I.equalsIgnoreCase)(c,w)}e.isEqual=o;function s(c,w,n,r=i.sep){if(c===w)return!0;if(!c||!w||w.length>c.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(c,w))return!1;if(w.length===c.length)return!0;let A=w.length;return w.charAt(w.length-1)===r&&A--,c.charAt(A)===r}return w.charAt(w.length-1)!==r&&(w+=r),c.indexOf(w)===0}e.isEqualOrParent=s;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function p(c,w){return P.isWindows&&c.endsWith(":")&&(c+=i.sep),(0,i.isAbsolute)(c)||(c=(0,i.join)(w,c)),c=(0,i.normalize)(c),P.isWindows?(c=(0,I.rtrim)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,I.rtrim)(c,i.sep),c||(c=i.sep)),c}e.sanitizeFilePath=p;function S(c){const w=(0,i.normalize)(c);return P.isWindows?c.length>3?!1:O(w)&&(c.length===2||w.charCodeAt(2)===92):w===i.posix.sep}e.isRootOrDriveLetter=S;function O(c,w=P.isWindows){return w?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=O;function v(c){return O(c)?c[0]:void 0}e.getDriveLetter=v;function t(c,w,n){return w.length>c.length?-1:c===w?0:(n&&(c=c.toLowerCase(),w=w.toLowerCase()),c.indexOf(w))}e.indexOfPath=t;function d(c){const w=c.split(":");let n,r,f;for(const A of w){const T=Number(A);(0,F.isNumber)(T)?r===void 0?r=T:f===void 0&&(f=T):n=n?[n,A].join(":"):A}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:f!==void 0?f:r!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(c,w,n=8){let r="";for(let A=0;A<n;A++)r+=a.charAt(Math.floor(Math.random()*a.length));let f;return w?f=`${w}-${r}`:f=r,c?(0,i.join)(c,f):f}e.randomPath=l}),define(ke[125],Te([1,0,28,10]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ee){return function(C,$){for(let W=0,V=ee.length;W<V;W++){const ie=ee[W](C,$);if(ie)return ie}return null}}e.or=I,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ee,C,$){if(!$||$.length<C.length)return null;let W;return ee?W=P.startsWithIgnoreCase($,C):W=$.indexOf(C)===0,W?C.length>0?[{start:0,end:C.length}]:[]:null}function E(ee,C){const $=C.toLowerCase().indexOf(ee.toLowerCase());return $===-1?null:[{start:$,end:$+ee.length}]}e.matchesContiguousSubString=E;function R(ee,C){return y(ee.toLowerCase(),C.toLowerCase(),0,0)}e.matchesSubString=R;function y(ee,C,$,W){if($===ee.length)return[];if(W===C.length)return null;if(ee[$]===C[W]){let V=null;return(V=y(ee,C,$+1,W+1))?u({start:W,end:W+1},V):null}return y(ee,C,$,W+1)}function k(ee){return 97<=ee&&ee<=122}function M(ee){return 65<=ee&&ee<=90}e.isUpper=M;function D(ee){return 48<=ee&&ee<=57}function h(ee){return ee===32||ee===9||ee===10||ee===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>b.add(ee.charCodeAt(0)));function m(ee){return h(ee)||b.has(ee)}function o(ee,C){return ee===C||m(ee)&&m(C)}function s(ee){return k(ee)||M(ee)||D(ee)}function u(ee,C){return C.length===0?C=[ee]:ee.end===C[0].start?C[0].start=ee.start:C.unshift(ee),C}function p(ee,C){for(let $=C;$<ee.length;$++){const W=ee.charCodeAt($);if(M(W)||D(W)||$>0&&!s(ee.charCodeAt($-1)))return $}return ee.length}function S(ee,C,$,W){if($===ee.length)return[];if(W===C.length)return null;if(ee[$]!==C[W].toLowerCase())return null;{let V=null,ie=W+1;for(V=S(ee,C,$+1,W+1);!V&&(ie=p(C,ie))<C.length;)V=S(ee,C,$+1,ie),ie++;return V===null?null:u({start:W,end:W+1},V)}}function O(ee){let C=0,$=0,W=0,V=0,ie=0;for(let be=0;be<ee.length;be++)ie=ee.charCodeAt(be),M(ie)&&C++,k(ie)&&$++,s(ie)&&W++,D(ie)&&V++;const fe=C/ee.length,De=$/ee.length,ue=W/ee.length,ve=V/ee.length;return{upperPercent:fe,lowerPercent:De,alphaPercent:ue,numericPercent:ve}}function v(ee){const{upperPercent:C,lowerPercent:$}=ee;return $===0&&C>.6}function t(ee){const{upperPercent:C,lowerPercent:$,alphaPercent:W,numericPercent:V}=ee;return $>.2&&C<.8&&W>.6&&V<.2}function d(ee){let C=0,$=0,W=0,V=0;for(let ie=0;ie<ee.length;ie++)W=ee.charCodeAt(ie),M(W)&&C++,k(W)&&$++,h(W)&&V++;return(C===0||$===0)&&V===0?ee.length<=30:C<=5}function a(ee,C){if(!C||(C=C.trim(),C.length===0)||!d(ee)||C.length>60)return null;const $=O(C);if(!t($)){if(!v($))return null;C=C.toLowerCase()}let W=null,V=0;for(ee=ee.toLowerCase();V<C.length&&(W=S(ee,C,0,V))===null;)V=p(C,V+1);return W}e.matchesCamelCase=a;function l(ee,C,$=!1){if(!C||C.length===0)return null;let W=null,V=0;for(ee=ee.toLowerCase(),C=C.toLowerCase();V<C.length&&(W=c(ee,C,0,V,$))===null;)V=w(C,V+1);return W}e.matchesWords=l;function c(ee,C,$,W,V){if($===ee.length)return[];if(W===C.length)return null;if(o(ee.charCodeAt($),C.charCodeAt(W))){let ie=null,fe=W+1;if(ie=c(ee,C,$+1,W+1,V),!V)for(;!ie&&(fe=w(C,fe))<C.length;)ie=c(ee,C,$+1,fe,V),fe++;return ie?ee.charCodeAt($)!==C.charCodeAt(W)?ie:u({start:W,end:W+1},ie):null}else return null}function w(ee,C){for(let $=C;$<ee.length;$++)if(m(ee.charCodeAt($))||$>0&&m(ee.charCodeAt($-1)))return $;return ee.length}const n=I(e.matchesPrefix,a,E),r=I(e.matchesPrefix,a,R),f=new i.LRUCache(1e4);function A(ee,C,$=!1){if(typeof ee!="string"||typeof C!="string")return null;let W=f.get(ee);W||(W=new RegExp(P.convertSimple2RegExpPattern(ee),"i"),f.set(ee,W));const V=W.exec(C);return V?[{start:V.index,end:V.index+V[0].length}]:$?r(ee,C):n(ee,C)}e.matchesFuzzy=A;function T(ee,C){const $=Ne(ee,ee.toLowerCase(),0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?Q($):null}e.matchesFuzzy2=T;function H(ee,C,$,W,V,ie){const fe=Math.min(13,ee.length);for(;$<fe;$++){const De=Ne(ee,C,$,W,V,ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ie]}e.anyScore=H;function Q(ee){if(typeof ee>"u")return[];const C=[],$=ee[1];for(let W=ee.length-1;W>1;W--){const V=ee[W]+$,ie=C[C.length-1];ie&&ie.end===V?ie.end=V+1:C.push({start:V,end:V+1})}return C}e.createMatches=Q;const Z=128;function _(){const ee=[],C=[];for(let $=0;$<=Z;$++)C[$]=0;for(let $=0;$<=Z;$++)ee.push(C.slice(0));return ee}function j(ee){const C=[];for(let $=0;$<=ee;$++)C[$]=0;return C}const L=j(2*Z),g=j(2*Z),N=_(),B=_(),J=_(),me=!1;function te(ee,C,$,W,V){function ie(De,ue,ve=" "){for(;De.length<ue;)De=ve+De;return De}let fe=` |   |${W.split("").map(De=>ie(De,3)).join("|")}
`;for(let De=0;De<=$;De++)De===0?fe+=" |":fe+=`${C[De-1]}|`,fe+=ee[De].slice(0,V+1).map(ue=>ie(ue.toString(),3)).join("|")+`
`;return fe}function oe(ee,C,$,W){ee=ee.substr(C),$=$.substr(W),console.log(te(B,ee,ee.length,$,$.length)),console.log(te(J,ee,ee.length,$,$.length)),console.log(te(N,ee,ee.length,$,$.length))}function ce(ee,C){if(C<0||C>=ee.length)return!1;const $=ee.codePointAt(C);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise($)}}function we(ee,C){if(C<0||C>=ee.length)return!1;switch(ee.charCodeAt(C)){case 32:case 9:return!0;default:return!1}}function q(ee,C,$){return C[ee]!==$[ee]}function x(ee,C,$,W,V,ie,fe=!1){for(;C<$&&V<ie;)ee[C]===W[V]&&(fe&&(L[C]=V),C+=1),V+=1;return C===$}e.isPatternInWord=x;var X;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(X||(X={}));var de;(function(ee){ee.Default=[-100,0];function C($){return!$||$.length===2&&$[0]===-100&&$[1]===0}ee.isDefault=C})(de=e.FuzzyScore||(e.FuzzyScore={}));class ye{constructor(C,$){this.firstMatchCanBeWeak=C,this.boostFullMatch=$}}ye.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ye;function Ne(ee,C,$,W,V,ie,fe=ye.default){const De=ee.length>Z?Z:ee.length,ue=W.length>Z?Z:W.length;if($>=De||ie>=ue||De-$>ue-ie||!x(C,$,De,V,ie,ue,!0))return;ze(De,ue,$,ie,C,V);let ve=1,be=1,He=$,je=ie;const it=[!1];for(ve=1,He=$;He<De;ve++,He++){const rt=L[He],G=g[He],Y=He+1<De?g[He+1]:ue;for(be=rt-ie+1,je=rt;je<Y;be++,je++){let pe=Number.MIN_SAFE_INTEGER,We=!1;je<=G&&(pe=Pe(ee,C,He,$,W,V,je,ue,ie,N[ve-1][be-1]===0,it));let $e=0;pe!==Number.MAX_SAFE_INTEGER&&(We=!0,$e=pe+B[ve-1][be-1]);const Qe=je>rt,Ke=Qe?B[ve][be-1]+(N[ve][be-1]>0?-5:0):0,tt=je>rt+1&&N[ve][be-1]>0,at=tt?B[ve][be-2]+(N[ve][be-2]>0?-5:0):0;if(tt&&(!Qe||at>=Ke)&&(!We||at>=$e))B[ve][be]=at,J[ve][be]=3,N[ve][be]=0;else if(Qe&&(!We||Ke>=$e))B[ve][be]=Ke,J[ve][be]=2,N[ve][be]=0;else if(We)B[ve][be]=$e,J[ve][be]=1,N[ve][be]=N[ve-1][be-1]+1;else throw new Error("not possible")}}if(me&&oe(ee,$,W,ie),!it[0]&&!fe.firstMatchCanBeWeak)return;ve--,be--;const Xe=[B[ve][be],ie];let et=0,nt=0;for(;ve>=1;){let rt=be;do{const G=J[ve][rt];if(G===3)rt=rt-2;else if(G===2)rt=rt-1;else break}while(rt>=1);et>1&&C[$+ve-1]===V[ie+be-1]&&!q(rt+ie-1,W,V)&&et+1>N[ve][rt]&&(rt=be),rt===be?et++:et=1,nt||(nt=rt),ve--,be=rt-1,Xe.push(be)}ue===De&&fe.boostFullMatch&&(Xe[0]+=2);const Fe=nt-De;return Xe[0]-=Fe,Xe}e.fuzzyScore=Ne;function ze(ee,C,$,W,V,ie){let fe=ee-1,De=C-1;for(;fe>=$&&De>=W;)V[fe]===ie[De]&&(g[fe]=De,fe--),De--}function Pe(ee,C,$,W,V,ie,fe,De,ue,ve,be){if(C[$]!==ie[fe])return Number.MIN_SAFE_INTEGER;let He=1,je=!1;return fe===$-W?He=ee[$]===V[fe]?7:5:q(fe,V,ie)&&(fe===0||!q(fe-1,V,ie))?(He=ee[$]===V[fe]?7:5,je=!0):ce(ie,fe)&&(fe===0||!ce(ie,fe-1))?He=5:(ce(ie,fe-1)||we(ie,fe-1))&&(He=5,je=!0),He>1&&$===W&&(be[0]=!0),je||(je=q(fe,V,ie)||ce(ie,fe-1)||we(ie,fe-1)),$===W?fe>ue&&(He-=je?3:5):ve?He+=je?2:0:He+=je?0:1,fe+1===De&&(He-=je?3:5),He}function Ie(ee,C,$,W,V,ie,fe){return ae(ee,C,$,W,V,ie,!0,fe)}e.fuzzyScoreGracefulAggressive=Ie;function Se(ee,C,$,W,V,ie,fe){return ae(ee,C,$,W,V,ie,!1,fe)}e.fuzzyScoreGraceful=Se;function ae(ee,C,$,W,V,ie,fe,De){let ue=Ne(ee,C,$,W,V,ie,De);if(ue&&!fe)return ue;if(ee.length>=3){const ve=Math.min(7,ee.length-1);for(let be=$+1;be<ve;be++){const He=le(ee,be);if(He){const je=Ne(He,He.toLowerCase(),$,W,V,ie,De);je&&(je[0]-=3,(!ue||je[0]>ue[0])&&(ue=je))}}}return ue}function le(ee,C){if(C+1>=ee.length)return;const $=ee[C],W=ee[C+1];if($!==W)return ee.slice(0,C)+W+$+ee.slice(C+2)}}),define(ke[126],Te([1,0,125,10,38]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",E=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${E.source}`,"g");function y(u){return u.replace(R,(p,S)=>S?p:`\\${p}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${E.source}`,"g");function M(u){return u.replace(k,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=M;const D=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function h(u){return u.indexOf(F)===-1?u:u.replace(D,(p,S,O,v)=>O?p:S||v||"")}e.stripIcons=h;function b(u){return u?u.replace(/\$\((.*?)\)/g,(p,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=b;const m=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(u){m.lastIndex=0;let p="";const S=[];let O=0;for(;;){const v=m.lastIndex,t=m.exec(u),d=u.substring(v,t?.index);if(d.length>0){p+=d;for(let a=0;a<d.length;a++)S.push(O)}if(!t)break;O+=t[0].length}return{text:p,iconOffsets:S}}e.parseLabelWithIcons=o;function s(u,p,S=!1){const{text:O,iconOffsets:v}=p;if(!v||v.length===0)return(0,i.matchesFuzzy)(u,O,S);const t=(0,P.ltrim)(O," "),d=O.length-t.length,a=(0,i.matchesFuzzy)(u,t,S);if(a)for(const l of a){const c=v[l.start+d]+d;l.start+=c,l.end+=c}return a}e.matchesFuzzyIconAware=s}),define(ke[29],Te([1,0,10]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(P||(P={})),function(I){const F="error",E="warning",R="warn",y="info",k="ignore";function M(h){return h?i.equalsIgnoreCase(F,h)?I.Error:i.equalsIgnoreCase(E,h)||i.equalsIgnoreCase(R,h)?I.Warning:i.equalsIgnoreCase(y,h)?I.Info:I.Ignore:I.Ignore}I.fromValue=M;function D(h){switch(h){case I.Error:return F;case I.Warning:return E;case I.Info:return y;default:return k}}I.toString=D}(P||(P={})),e.default=P}),define(ke[48],Te([1,0,16,10]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),o=this.b.charCodeAt(this.c);return m-o}value(){return this.b[this.c]}}e.StringIterator=I;class F{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,P.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,P.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=F;class E{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const o=this.b.charCodeAt(m);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,P.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,P.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=E;var R;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,P.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,P.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,P.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,P.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(M||(M={}));class D{static forUris(b=()=>!1,m=()=>!1){return new D(new y(b,m))}static forPaths(b=!1){return new D(new E(void 0,!b))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new F)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const o=m.slice(0);(0,i.shuffle)(o);for(const s of o)this.set(s,b)}else{const o=b.slice(0);(0,i.shuffle)(o);for(const s of o)this.set(s[0],s[1])}}set(b,m){const o=this.b.reset(b);let s;this.c||(this.c=new k,this.c.segment=o.value());const u=[];for(s=this.c;;){const S=o.cmp(s.segment);if(S>0)s.left||(s.left=new k,s.left.segment=o.value()),u.push([-1,s]),s=s.left;else if(S<0)s.right||(s.right=new k,s.right.segment=o.value()),u.push([1,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new k,s.mid.segment=o.value()),u.push([0,s]),s=s.mid;else break}const p=s.value;s.value=m,s.key=b;for(let S=u.length-1;S>=0;S--){const O=u[S][1];O.updateHeight();const v=O.balanceFactor();if(v<-1||v>1){const t=u[S][0],d=u[S+1][0];if(t===1&&d===1)u[S][1]=O.rotateLeft();else if(t===-1&&d===-1)u[S][1]=O.rotateRight();else if(t===1&&d===-1)O.right=u[S+1][1]=u[S+1][1].rotateRight(),u[S][1]=O.rotateLeft();else if(t===-1&&d===1)O.left=u[S+1][1]=u[S+1][1].rotateLeft(),u[S][1]=O.rotateRight();else throw new Error;if(S>0)switch(u[S-1][0]){case-1:u[S-1][1].left=u[S][1];break;case 1:u[S-1][1].right=u[S][1];break;case 0:u[S-1][1].mid=u[S][1];break}else this.c=u[0][1]}}return p}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let o=this.c;for(;o;){const s=m.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(m.hasNext())m.next(),o=o.mid;else break}return o}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const o=this.b.reset(b),s=[];let u=this.c;for(;u;){const p=o.cmp(u.segment);if(p>0)s.push([-1,u]),u=u.left;else if(p<0)s.push([1,u]),u=u.right;else if(o.hasNext())o.next(),s.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:S,value:O,segment:v}=p;this.e(p.key,!1),u.key=S,u.value=O,u.segment=v}}else{const p=u.left??u.right;if(s.length>0){const[S,O]=s[s.length-1];switch(S){case-1:O.left=p;break;case 0:O.mid=p;break;case 1:O.right=p;break}}else this.c=p}for(let p=s.length-1;p>=0;p--){const S=s[p][1];S.updateHeight();const O=S.balanceFactor();if(O>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),s[p][1]=S.rotateLeft()):O<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),s[p][1]=S.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let o=this.c,s;for(;o;){const u=m.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(m.hasNext())m.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(b){return this.g(b,!1)}g(b,m){const o=this.b.reset(b);let s=this.c;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this.h(s.mid):m?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,o]of this)b(o,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){!b||(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const o=m.balanceFactor();return o<-1||o>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.TernarySearchTree=D}),define(ke[66],Te([1,0,23,10,2]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(k){return JSON.stringify(k,R)}e.stringify=F;function E(k){let M=JSON.parse(k);return M=y(M),M}e.parse=E;function R(k,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,P.regExpFlags)(M)}:M}function y(k,M=0){if(!k||M>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return I.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=y(k[D],M+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=y(k[D],M+1))}return k}e.revive=y}),define(ke[15],Te([1,0,11,20,2]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(F=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(M){this.d=M}setDelegate(M){this.e=M}setServerRootPath(M){this.f=`${M}/${F.vscodeRemoteResource}`}set(M,D,h){this.a[M]=D,this.b[M]=h}setConnectionToken(M,D){this.c[M]=D}getPreferredWebSchema(){return this.d}rewrite(M){if(this.e)try{return this.e(M)}catch(s){return i.onUnexpectedError(s),M}const D=M.authority;let h=this.a[D];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const b=this.b[D],m=this.c[D];let o=`path=${encodeURIComponent(M.path)}`;return typeof m=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),I.URI.from({scheme:P.isWeb?this.d:F.vscodeRemoteResource,authority:`${h}:${b}`,path:this.f,query:o})}}e.RemoteAuthorities=new E,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(M){const D=this.b(M,ne);return this.uriToBrowserUri(D)}uriToBrowserUri(M){return M.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===F.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${F.vscodeFileResource}://${R.a}`)?M.with({scheme:F.vscodeFileResource,authority:M.authority||R.a,query:null,fragment:null}):M}asFileUri(M){const D=this.b(M,ne);return this.uriToFileUri(D)}uriToFileUri(M){return M.scheme===F.vscodeFileResource?M.with({scheme:F.file,authority:M.authority!==R.a?M.authority:null,query:null,fragment:null}):M}b(M,D){return I.URI.isUri(M)?M:I.URI.parse(D.toUrl(M))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(k){const M=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(M.get("3"));const D="vscode-coi";function h(m){let o;typeof m=="string"?o=new URL(m).searchParams:m instanceof URL?o=m.searchParams:I.URI.isUri(m)&&(o=new URL(m.toString(!0)).searchParams);const s=o?.get(D);if(!!s)return M.get(s)}k.getHeadersFromQuery=h;function b(m,o,s){if(!globalThis.crossOriginIsolated)return;const u=o&&s?"3":s?"2":"1";m instanceof URLSearchParams?m.set(D,u):m[D]=u}k.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(ke[24],Te([1,0,40,15,19,20,10,2]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=y;class k{constructor(m){this.a=m}compare(m,o,s=!1){return m===o?0:(0,E.compare)(this.getComparisonKey(m,s),this.getComparisonKey(o,s))}isEqual(m,o,s=!1){return m===o?!0:!m||!o?!1:this.getComparisonKey(m,s)===this.getComparisonKey(o,s)}getComparisonKey(m,o=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,o,s=!1){if(m.scheme===o.scheme){if(m.scheme===P.Schemas.file)return i.isEqualOrParent(y(m),y(o),this.a(m))&&m.query===o.query&&(s||m.fragment===o.fragment);if((0,e.isEqualAuthority)(m.authority,o.authority))return i.isEqualOrParent(m.path,o.path,this.a(m),"/")&&m.query===o.query&&(s||m.fragment===o.fragment)}return!1}joinPath(m,...o){return R.URI.joinPath(m,...o)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return I.posix.basename(m.path)}extname(m){return I.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let o;return m.scheme===P.Schemas.file?o=R.URI.file(I.dirname(y(m))).path:(o=I.posix.dirname(m.path),m.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),o="/")),m.with({path:o})}normalizePath(m){if(!m.path.length)return m;let o;return m.scheme===P.Schemas.file?o=R.URI.file(I.normalize(y(m))).path:o=I.posix.normalize(m.path),m.with({path:o})}relativePath(m,o){if(m.scheme!==o.scheme||!(0,e.isEqualAuthority)(m.authority,o.authority))return;if(m.scheme===P.Schemas.file){const p=I.relative(y(m),y(o));return F.isWindows?i.toSlashes(p):p}let s=m.path||"/";const u=o.path||"/";if(this.a(m)){let p=0;for(const S=Math.min(s.length,u.length);p<S&&!(s.charCodeAt(p)!==u.charCodeAt(p)&&s.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);s=u.substr(0,p)+s.substr(p)}return I.posix.relative(s,u)}resolvePath(m,o){if(m.scheme===P.Schemas.file){const s=R.URI.file(I.resolve(y(m),o));return m.with({authority:s.authority,path:s.path})}return o=i.toPosixPath(o),m.with({path:I.posix.resolve(m.path,o)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,o){return m===o||m!==void 0&&o!==void 0&&(0,E.equalsIgnoreCase)(m,o)}hasTrailingPathSeparator(m,o=I.sep){if(m.scheme===P.Schemas.file){const s=y(m);return s.length>i.getRoot(s).length&&s[s.length-1]===o}else{const s=m.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,o=I.sep){return(0,e.hasTrailingPathSeparator)(m,o)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,o=I.sep){let s=!1;if(m.scheme===P.Schemas.file){const u=y(m);s=u!==void 0&&u.length===i.getRoot(u).length&&u[u.length-1]===o}else{o="/";const u=m.path;s=u.length===1&&u.charCodeAt(u.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(m,o)?m.with({path:m.path+"/"}):m}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===P.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(b,m){const o=[];for(let s=0;s<b.length;s++){const u=m(b[s]);b.some((p,S)=>S===s?!1:(0,e.isEqualOrParent)(u,m(p)))||o.push(b[s])}return o}e.distinctParents=M;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(S=>{const[O,v]=S.split(":");O&&v&&s.set(O,v)});const p=o.path.substring(0,o.path.indexOf(";"));return p&&s.set(b.META_DATA_MIME,p),s}b.parseMetaData=m})(D=e.DataUri||(e.DataUri={}));function h(b,m,o){if(m){let s=b.path;return s&&s[0]!==I.posix.sep&&(s=I.posix.sep+s),b.with({scheme:o,authority:m,path:s})}return b.with({scheme:o})}e.toLocalResource=h}),define(ke[17],Te([1,0,21,11,4,6,24,20,115]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(x){return!!x&&typeof x.then=="function"}e.isThenable=k;function M(x){const X=new i.CancellationTokenSource,de=x(X.token),ye=new Promise((Ne,ze)=>{const Pe=X.token.onCancellationRequested(()=>{Pe.dispose(),X.dispose(),ze(new P.CancellationError)});Promise.resolve(de).then(Ie=>{Pe.dispose(),X.dispose(),Ne(Ie)},Ie=>{Pe.dispose(),X.dispose(),ze(Ie)})});return new class{cancel(){X.cancel()}then(Ne,ze){return ye.then(Ne,ze)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return ye.finally(Ne)}}}e.createCancelablePromise=M;function D(x,X,de){return new Promise((ye,Ne)=>{const ze=X.onCancellationRequested(()=>{ze.dispose(),ye(de)});x.then(ye,Ne).finally(()=>ze.dispose())})}e.raceCancellation=D;function h(x,X){return new Promise((de,ye)=>{const Ne=X.onCancellationRequested(()=>{Ne.dispose(),ye(new P.CancellationError)});x.then(de,ye).finally(()=>Ne.dispose())})}e.raceCancellationError=h;async function b(x){let X=-1;const de=x.map((Ne,ze)=>Ne.then(Pe=>(X=ze,Pe))),ye=await Promise.race(de);return x.forEach((Ne,ze)=>{ze!==X&&Ne.cancel()}),ye}e.raceCancellablePromises=b;function m(x,X,de){let ye;const Ne=setTimeout(()=>{ye?.(void 0),de?.()},X);return Promise.race([x.finally(()=>clearTimeout(Ne)),new Promise(ze=>ye=ze)])}e.raceTimeout=m;function o(x){return new Promise((X,de)=>{const ye=x();k(ye)?ye.then(X,de):X(ye)})}e.asPromise=o;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(X){if(this.a){if(this.d=X,!this.b){const de=()=>{this.b=null;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(de,de).then(ye)})}return new Promise((de,ye)=>{this.b.then(de,ye)})}return this.a=X(),new Promise((de,ye)=>{this.a.then(Ne=>{this.a=null,de(Ne)},Ne=>{this.a=null,ye(Ne)})})}}e.Throttler=s;class u{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.Sequencer=u;class p{constructor(){this.a=new Map}queue(X,de){const Ne=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(X)===Ne&&this.a.delete(X)});return this.a.set(X,Ne),Ne}}e.SequencerByKey=p;const S=(x,X)=>{let de=!0;const ye=setTimeout(()=>{de=!1,X()},x);return{isTriggered:()=>de,dispose:()=>{clearTimeout(ye),de=!1}}},O=x=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,x())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class v{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,de=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((Ne,ze)=>{this.d=Ne,this.f=ze}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=de===y.MicrotaskDelay?O(ye):S(de,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(X){this.a=new v(X),this.b=new s}trigger(X,de){return this.a.trigger(()=>this.b.queue(X),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class d{constructor(){this.a=!1,this.b=new Promise((X,de)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class a extends d{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=a;function l(x,X){return X?new Promise((de,ye)=>{const Ne=setTimeout(()=>{ze.dispose(),de()},x),ze=X.onCancellationRequested(()=>{clearTimeout(Ne),ze.dispose(),ye(new P.CancellationError)})}):M(de=>l(x,de))}e.timeout=l;function c(x,X=0){const de=setTimeout(x,X);return(0,F.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=c;function w(x){const X=[];let de=0;const ye=x.length;function Ne(){return de<ye?x[de++]():null}function ze(Pe){Pe!=null&&X.push(Pe);const Ie=Ne();return Ie?Ie.then(ze):Promise.resolve(X)}return Promise.resolve(null).then(ze)}e.sequence=w;function n(x,X=ye=>!!ye,de=null){let ye=0;const Ne=x.length,ze=()=>{if(ye>=Ne)return Promise.resolve(de);const Pe=x[ye++];return Promise.resolve(Pe()).then(Se=>X(Se)?Promise.resolve(Se):ze())};return ze()}e.first=n;function r(x,X=ye=>!!ye,de=null){if(x.length===0)return Promise.resolve(de);let ye=x.length;const Ne=()=>{ye=-1;for(const ze of x)ze.cancel?.()};return new Promise((ze,Pe)=>{for(const Ie of x)Ie.then(Se=>{--ye>=0&&X(Se)?(Ne(),ze(Se)):ye===0&&ze(de)}).catch(Se=>{--ye>=0&&(Ne(),Pe(Se))})})}e.firstParallel=r;class f{constructor(X){this.a=0,this.d=X,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(X){return this.a++,new Promise((de,ye)=>{this.f.push({factory:X,c:de,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const X=this.f.shift();this.b++;const de=X.factory();de.then(X.c,X.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class A extends f{constructor(){super(1)}}e.Queue=A;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const X=new me;return this.b.add(X),X.p}d(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueFor(X,de=E.extUri){const ye=de.getComparisonKey(X);let Ne=this.a.get(ye);return Ne||(Ne=new A,I.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class H{constructor(X,de){this.a=-1,typeof X=="function"&&typeof de=="number"&&this.setIfNotSet(X,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},de)}setIfNotSet(X,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},de))}}e.TimeoutTimer=H;class Q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(X,de){this.cancel(),this.a=setInterval(()=>{X()},de)}}e.IntervalTimer=Q;class Z{constructor(X,de){this.b=-1,this.a=X,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class _{constructor(X,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=X,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=_;class j extends Z{constructor(X,de){super(X,de),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=j;class L extends F.Disposable{constructor(X,de){super(),this.g=X,this.h=de,this.a=[],this.b=this.B(new F.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of X)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,R.setTimeout0)(()=>{if(X)return;const de=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.runWhenIdle=(x,X)=>{const de=requestIdleCallback(x,typeof X=="number"?{timeout:X}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(de))}}}}();class g{constructor(X){this.d=!1,this.a=()=>{try{this.f=X()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=g;async function N(x,X,de){let ye;for(let Ne=0;Ne<de;Ne++)try{return await x()}catch(ze){ye=ze,await l(X)}throw ye}e.retry=N;class B{hasPending(X){return this.a?typeof X=="number"?this.a.taskId===X:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(X,de,ye){return this.a={taskId:X,cancel:()=>ye?.(),promise:de},de.then(()=>this.d(X),()=>this.d(X)),de}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}setNext(X){if(this.b)this.b.run=X;else{let de,ye;const Ne=new Promise((ze,Pe)=>{de=ze,ye=Pe});this.b={run:X,promise:Ne,promiseResolve:de,promiseReject:ye}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class J{constructor(X,de=()=>Date.now()){this.d=X,this.f=de,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.IntervalCounter=J;class me{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((X,de)=>{this.a=X,this.b=de})}complete(X){return new Promise(de=>{this.a(X),this.f=!0,de()})}error(X){return new Promise(de=>{this.b(X),this.d=!0,de()})}cancel(){new Promise(X=>{this.b(new P.CancellationError),this.d=!0,X()})}}e.DeferredPromise=me;var te;(function(x){async function X(ye){let Ne;const ze=await Promise.all(ye.map(Pe=>Pe.then(Ie=>Ie,Ie=>{Ne||(Ne=Ie)})));if(typeof Ne<"u")throw Ne;return ze}x.settled=X;function de(ye){return new Promise(async(Ne,ze)=>{try{await ye(Ne,ze)}catch(Pe){ze(Pe)}})}x.withAsyncBody=de})(te=e.Promises||(e.Promises={}));var oe;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(oe||(oe={}));class ce{static fromArray(X){return new ce(de=>{de.emitMany(X)})}static fromPromise(X){return new ce(async de=>{de.emitMany(await X)})}static fromPromises(X){return new ce(async de=>{await Promise.all(X.map(async ye=>de.emitOne(await ye)))})}static merge(X){return new ce(async de=>{await Promise.all(X.map(async ye=>{for await(const Ne of ye)de.emitOne(Ne)}))})}constructor(X){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const de={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(X(de)),this.j()}catch(ye){this.k(ye)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(X,de){return new ce(async ye=>{for await(const Ne of X)ye.emitOne(de(Ne))})}map(X){return ce.map(this,X)}static filter(X,de){return new ce(async ye=>{for await(const Ne of X)de(Ne)&&ye.emitOne(Ne)})}filter(X){return ce.filter(this,X)}static coalesce(X){return ce.filter(X,de=>!!de)}coalesce(){return ce.coalesce(this)}static async toPromise(X){const de=[];for await(const ye of X)de.push(ye);return de}toPromise(){return ce.toPromise(this)}g(X){this.a===0&&(this.b.push(X),this.f.fire())}h(X){this.a===0&&(this.b=this.b.concat(X),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(X){this.a===0&&(this.a=2,this.d=X,this.f.fire())}}ce.EMPTY=ce.fromArray([]),e.AsyncIterableObject=ce;class we extends ce{constructor(X,de){super(de),this.l=X}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=we;function q(x){const X=new i.CancellationTokenSource,de=x(X.token);return new we(X,async ye=>{const Ne=X.token.onCancellationRequested(()=>{Ne.dispose(),X.dispose(),ye.reject(new P.CancellationError)});try{for await(const ze of de){if(X.token.isCancellationRequested)return;ye.emitOne(ze)}Ne.dispose(),X.dispose()}catch(ze){Ne.dispose(),X.dispose(),ye.reject(ze)}})}e.createCancelableAsyncIterable=q}),define(ke[35],Te([1,0,16,17,40,28,19,20,10]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",D="[^/\\\\]",h=/\//g;function b(J,me){switch(J){case 0:return"";case 1:return`${D}*?`;default:return`(?:${M}|${D}+${M}${me?`|${M}${D}+`:""})*?`}}function m(J,me){if(!J)return[];const te=[];let oe=!1,ce=!1,we="";for(const q of J){switch(q){case me:if(!oe&&!ce){te.push(we),we="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}we+=q}return we&&te.push(we),te}e.splitGlobAware=m;function o(J){if(!J)return"";let me="";const te=m(J,e.GLOB_SPLIT);if(te.every(oe=>oe===e.GLOBSTAR))me=".*";else{let oe=!1;te.forEach((ce,we)=>{if(ce===e.GLOBSTAR){if(oe)return;me+=b(2,we===te.length-1)}else{let q=!1,x="",X=!1,de="";for(const ye of ce){if(ye!=="}"&&q){x+=ye;continue}if(X&&(ye!=="]"||!de)){let Ne;ye==="-"?Ne=ye:(ye==="^"||ye==="!")&&!de?Ne="^":ye===e.GLOB_SPLIT?Ne="":Ne=(0,y.escapeRegExpCharacters)(ye),de+=Ne;continue}switch(ye){case"{":q=!0;continue;case"[":X=!0;continue;case"}":{me+=`(?:${m(x,",").map(Pe=>o(Pe)).join("|")})`,q=!1,x="";break}case"]":{me+="["+de+"]",X=!1,de="";break}case"?":me+=D;continue;case"*":me+=b(1);continue;default:me+=(0,y.escapeRegExpCharacters)(ye)}}we<te.length-1&&(te[we+1]!==e.GLOBSTAR||we+2<te.length)&&(me+=M)}oe=ce===e.GLOBSTAR})}return me}const s=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,O=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.LRUCache(1e4),d=function(){return!1},a=function(){return null};function l(J,me){if(!J)return a;let te;typeof J!="string"?te=J.pattern:te=J,te=te.trim();const oe=`${te}_${!!me.trimForExclusions}`;let ce=t.get(oe);if(ce)return c(ce,J);let we;return s.test(te)?ce=n(te.substr(4),te):(we=u.exec(w(te,me)))?ce=r(we[1],te):(me.trimForExclusions?S:p).test(te)?ce=f(te,me):(we=O.exec(w(te,me)))?ce=A(we[1].substr(1),te,!0):(we=v.exec(w(te,me)))?ce=A(we[1],te,!1):ce=T(te),t.set(oe,ce),c(ce,J)}function c(J,me){if(typeof me=="string")return J;const te=function(oe,ce){return(0,I.isEqualOrParent)(oe,me.base,!R.isLinux)?J((0,y.ltrim)(oe.substr(me.base.length),E.sep),ce):null};return te.allBasenames=J.allBasenames,te.allPaths=J.allPaths,te.basenames=J.basenames,te.patterns=J.patterns,te}function w(J,me){return me.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function n(J,me){return function(te,oe){return typeof te=="string"&&te.endsWith(J)?me:null}}function r(J,me){const te=`/${J}`,oe=`\\${J}`,ce=function(q,x){return typeof q!="string"?null:x?x===J?me:null:q===J||q.endsWith(te)||q.endsWith(oe)?me:null},we=[J];return ce.basenames=we,ce.patterns=[me],ce.allBasenames=we,ce}function f(J,me){const te=N(J.slice(1,-1).split(",").map(x=>l(x,me)).filter(x=>x!==a),J),oe=te.length;if(!oe)return a;if(oe===1)return te[0];const ce=function(x,X){for(let de=0,ye=te.length;de<ye;de++)if(te[de](x,X))return J;return null},we=te.find(x=>!!x.allBasenames);we&&(ce.allBasenames=we.allBasenames);const q=te.reduce((x,X)=>X.allPaths?x.concat(X.allPaths):x,[]);return q.length&&(ce.allPaths=q),ce}function A(J,me,te){const oe=E.sep===E.posix.sep,ce=oe?J:J.replace(h,E.sep),we=E.sep+ce,q=E.posix.sep+J;let x;return te?x=function(X,de){return typeof X=="string"&&(X===ce||X.endsWith(we)||!oe&&(X===J||X.endsWith(q)))?me:null}:x=function(X,de){return typeof X=="string"&&(X===ce||!oe&&X===J)?me:null},x.allPaths=[(te?"*/":"./")+J],x}function T(J){try{const me=new RegExp(`^${o(J)}$`);return function(te){return me.lastIndex=0,typeof te=="string"&&me.test(te)?J:null}}catch{return a}}function H(J,me,te){return!J||typeof me!="string"?!1:Q(J)(me,void 0,te)}e.match=H;function Q(J,me={}){if(!J)return d;if(typeof J=="string"||Z(J)){const te=l(J,me);if(te===a)return d;const oe=function(ce,we){return!!te(ce,we)};return te.allBasenames&&(oe.allBasenames=te.allBasenames),te.allPaths&&(oe.allPaths=te.allPaths),oe}return L(J,me)}e.parse=Q;function Z(J){const me=J;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}e.isRelativePattern=Z;function _(J){return J.allBasenames||[]}e.getBasenameTerms=_;function j(J){return J.allPaths||[]}e.getPathTerms=j;function L(J,me){const te=N(Object.getOwnPropertyNames(J).map(x=>g(x,J[x],me)).filter(x=>x!==a)),oe=te.length;if(!oe)return a;if(!te.some(x=>!!x.requiresSiblings)){if(oe===1)return te[0];const x=function(ye,Ne){let ze;for(let Pe=0,Ie=te.length;Pe<Ie;Pe++){const Se=te[Pe](ye,Ne);if(typeof Se=="string")return Se;(0,P.isThenable)(Se)&&(ze||(ze=[]),ze.push(Se))}return ze?(async()=>{for(const Pe of ze){const Ie=await Pe;if(typeof Ie=="string")return Ie}return null})():null},X=te.find(ye=>!!ye.allBasenames);X&&(x.allBasenames=X.allBasenames);const de=te.reduce((ye,Ne)=>Ne.allPaths?ye.concat(Ne.allPaths):ye,[]);return de.length&&(x.allPaths=de),x}const ce=function(x,X,de){let ye,Ne;for(let ze=0,Pe=te.length;ze<Pe;ze++){const Ie=te[ze];Ie.requiresSiblings&&de&&(X||(X=(0,E.basename)(x)),ye||(ye=X.substr(0,X.length-(0,E.extname)(x).length)));const Se=Ie(x,X,ye,de);if(typeof Se=="string")return Se;(0,P.isThenable)(Se)&&(Ne||(Ne=[]),Ne.push(Se))}return Ne?(async()=>{for(const ze of Ne){const Pe=await ze;if(typeof Pe=="string")return Pe}return null})():null},we=te.find(x=>!!x.allBasenames);we&&(ce.allBasenames=we.allBasenames);const q=te.reduce((x,X)=>X.allPaths?x.concat(X.allPaths):x,[]);return q.length&&(ce.allPaths=q),ce}function g(J,me,te){if(me===!1)return a;const oe=l(J,te);if(oe===a)return a;if(typeof me=="boolean")return oe;if(me){const ce=me.when;if(typeof ce=="string"){const we=(q,x,X,de)=>{if(!de||!oe(q,x))return null;const ye=ce.replace("$(basename)",()=>X),Ne=de(ye);return(0,P.isThenable)(Ne)?Ne.then(ze=>ze?J:null):Ne?J:null};return we.requiresSiblings=!0,we}}return oe}function N(J,me){const te=J.filter(x=>!!x.basenames);if(te.length<2)return J;const oe=te.reduce((x,X)=>{const de=X.basenames;return de?x.concat(de):x},[]);let ce;if(me){ce=[];for(let x=0,X=oe.length;x<X;x++)ce.push(me)}else ce=te.reduce((x,X)=>{const de=X.patterns;return de?x.concat(de):x},[]);const we=function(x,X){if(typeof x!="string")return null;if(!X){let ye;for(ye=x.length;ye>0;ye--){const Ne=x.charCodeAt(ye-1);if(Ne===47||Ne===92)break}X=x.substr(ye)}const de=oe.indexOf(X);return de!==-1?ce[de]:null};we.basenames=oe,we.patterns=ce,we.allBasenames=oe;const q=J.filter(x=>!x.basenames);return q.push(we),q}function B(J,me){return(0,i.equals)(J,me,(te,oe)=>typeof te=="string"&&typeof oe=="string"?te===oe:typeof te!="string"&&typeof oe!="string"?te.base===oe.base&&te.pattern===oe.pattern:!1)}e.patternsEquals=B}),define(ke[86],Te([1,0,11,126,24,10,2]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",p=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(u,p=0){return this.value+=h(this.supportThemeIcons?(0,P.escapeIcons)(u):u).replace(/([ \t]+)/g,(S,O)=>"&nbsp;".repeat(O.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,p){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(u,p,S){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(u),")"),S&&(this.value+=` "${this.c(this.c(S,'"'),")")}"`),this.value+=")",this}c(u,p){const S=new RegExp((0,F.escapeRegExpCharacters)(p),"g");return u.replace(S,(O,v)=>u.charAt(v-1)!=="\\"?`\\${O}`:O)}}e.MarkdownString=y;function k(s){return M(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function M(s){return s instanceof y?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function D(s,u){return s===u?!0:!s||!u?!1:s.value===u.value&&s.isTrusted===u.isTrusted&&s.supportThemeIcons===u.supportThemeIcons&&s.supportHtml===u.supportHtml&&(s.baseUri===u.baseUri||!!s.baseUri&&!!u.baseUri&&(0,I.isEqual)(E.URI.from(s.baseUri),E.URI.from(u.baseUri)))}e.markdownStringEqual=D;function h(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function b(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function m(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function o(s){const u=[],p=s.split("|").map(O=>O.trim());s=p[0];const S=p[1];if(S){const O=/height=(\d+)/.exec(S),v=/width=(\d+)/.exec(S),t=O?O[1]:"",d=v?v[1]:"",a=isFinite(parseInt(d)),l=isFinite(parseInt(t));a&&u.push(`width="${d}"`),l&&u.push(`height="${t}"`)}return{href:s,dimensions:u}}e.parseHrefAndDimensions=o}),define(ke[87],Te([1,0,16,40,19,20,24,10]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(a,l){const{os:c,tildify:w,relative:n}=l;if(n){const A=k(a,n,c);if(typeof A=="string")return A}let r=a.fsPath;if(c===1&&!F.isWindows?r=r.replace(/\//g,"\\"):c!==1&&F.isWindows&&(r=r.replace(/\\/g,"/")),c!==1&&w?.userHome){const A=w.userHome.fsPath;let T;a.scheme!==w.userHome.scheme&&a.path.startsWith(I.posix.sep)?T=w.userHome.with({path:a.path}).fsPath:T=a.fsPath,r=h(T,A,c)}return(c===1?I.win32:I.posix).normalize(M(r,c===1))}e.getPathLabel=y;function k(a,l,c){const w=c===1?I.win32:I.posix,n=c===3?E.extUri:E.extUriIgnorePathCase,r=l.getWorkspace(),f=(0,i.firstOrDefault)(r.folders);if(!f)return;a.scheme!==f.uri.scheme&&a.path.startsWith(I.posix.sep)&&(a=f.uri.with({path:a.path}));const A=l.getWorkspaceFolder(a);if(!A)return;let T;if(n.isEqual(A.uri,a)?T="":T=n.relativePath(A.uri,a)??"",T&&(T=w.normalize(T)),r.folders.length>1&&!l.noPrefix){const H=A.name?A.name:n.basenameOrAuthority(A.uri);T=T?`${H} \u2022 ${T}`:H}return T}function M(a,l=F.isWindows){return(0,P.hasDriveLetter)(a,l)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=M;let D=Object.create(null);function h(a,l,c=F.OS){if(c===1||!a||!l)return a;let w=D.original===l?D.normalized:void 0;w||(w=l,F.isWindows&&(w=(0,P.toSlashes)(w)),w=`${(0,R.rtrim)(w,I.posix.sep)}${I.posix.sep}`,D={original:l,normalized:w});let n=a;return F.isWindows&&(n=(0,P.toSlashes)(n)),(c===3?n.startsWith(w):(0,R.startsWithIgnoreCase)(n,w))?`~/${n.substr(w.length)}`:a}e.tildify=h;function b(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=b;const m="\u2026",o="\\\\",s="~";function u(a,l=I.sep){const c=new Array(a.length);let w=!1;for(let n=0;n<a.length;n++){const r=a[n];if(r===""){c[n]=`.${l}`;continue}if(!r){c[n]=r;continue}w=!0;let f="",A=r;A.indexOf(o)===0?(f=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(l)===0?(f=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(s)===0&&(f=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length));const T=A.split(l);for(let H=1;w&&H<=T.length;H++)for(let Q=T.length-H;w&&Q>=0;Q--){w=!1;let Z=T.slice(Q,Q+H).join(l);for(let _=0;!w&&_<a.length;_++)if(_!==n&&a[_]&&a[_].indexOf(Z)>-1){const j=Q+H===T.length,L=Q>0&&a[_].indexOf(l)>-1?l+Z:Z,g=a[_].endsWith(L);w=!j||g}if(!w){let _="";(T[0].endsWith(":")||f!=="")&&(Q===1&&(Q=0,H++,Z=T[0]+l+Z),Q>0&&(_=T[0]+l),_=f+_),Q>0&&(_=_+m+l),_=_+Z,Q+H<T.length&&(_=_+l+m),c[n]=_}}w&&(c[n]=r)}return c}e.shorten=u;var p;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function S(a,l=Object.create(null)){const c=[];let w=!1,n="";for(const r of a)if(r==="$"||w&&r==="{")n&&c.push({value:n,type:p.TEXT}),n="",w=!0;else if(r==="}"&&w){const f=l[n];if(typeof f=="string")f.length&&c.push({value:f,type:p.VARIABLE});else if(f){const A=c[c.length-1];(!A||A.type!==p.SEPARATOR)&&c.push({value:f.label,type:p.SEPARATOR})}n="",w=!1}else n+=r;return n&&!w&&c.push({value:n,type:p.TEXT}),c.filter((r,f)=>{if(r.type===p.SEPARATOR){const A=c[f-1],T=c[f+1];return[A,T].every(H=>H&&(H.type===p.VARIABLE||H.type===p.TEXT)&&H.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=S;function O(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=O;function v(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):F.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(a){const l=a.indexOf("/")!==-1?I.posix:I.win32,c=l.basename(a),w=l.dirname(a);return c.length?{name:c,parentPath:w}:{name:w,parentPath:""}}e.splitName=d}),define(ke[127],Te([1,0,23,2]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(D){return D.toJSON()}class F{constructor(h){this.a=h}transformIncoming(h){const b=this.a.transformIncoming(h);return b===h?h:I(P.URI.from(b))}transformOutgoing(h){const b=this.a.transformOutgoing(h);return b===h?h:I(P.URI.from(b))}transformOutgoingURI(h){const b=this.a.transformOutgoing(h);return b===h?h:P.URI.from(b)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function E(D,h,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof P.URI)return h.transformOutgoing(D);for(const m in D)if(Object.hasOwnProperty.call(D,m)){const o=E(D[m],h,b+1);o!==null&&(D[m]=o)}}return null}function R(D,h){const b=E(D,h,0);return b===null?D:b}e.transformOutgoingURIs=R;function y(D,h,b,m){if(!D||m>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?P.URI.revive(h.transformIncoming(D)):h.transformIncoming(D);if(D instanceof i.VSBuffer)return null;for(const o in D)if(Object.hasOwnProperty.call(D,o)){const s=y(D[o],h,b,m+1);s!==null&&(D[o]=s)}}return null}function k(D,h){const b=y(D,h,!1,0);return b===null?D:b}e.transformIncomingURIs=k;function M(D,h){const b=y(D,h,!0,0);return b===null?D:b}e.transformAndReviveIncomingURIs=M}),define(ke[128],Te([1,0,35,19]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(F,E,R,y,k,M){if(Array.isArray(F)){let D=0;for(const h of F){const b=I(h,E,R,y,k,M);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof F=="string")return y?F==="*"?5:F===R?10:0:0;if(F){const{language:D,pattern:h,scheme:b,hasAccessToAllModels:m,notebookType:o}=F;if(!y&&!m)return 0;o&&k&&(E=k);let s=0;if(b)if(b===E.scheme)s=10;else if(b==="*")s=5;else return 0;if(D)if(D===R)s=10;else if(D==="*")s=Math.max(s,5);else return 0;if(o)if(o===M)s=10;else if(o==="*"&&M!==void 0)s=Math.max(s,5);else return 0;if(h){let u;if(typeof h=="string"?u=h:u={...h,base:(0,P.normalize)(h.base)},u===E.fsPath||(0,i.match)(u,E.fsPath))s=10;else return 0}return s}else return 0}}e.score=I}),define(ke[88],Te([1,0,23,20]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function F(D){for(let h=0,b=D.length;h<b;h+=4){const m=D[h+0],o=D[h+1],s=D[h+2],u=D[h+3];D[h+0]=u,D[h+1]=s,D[h+2]=o,D[h+3]=m}}function E(D){const h=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return P.isLittleEndian()||F(h),i.VSBuffer.wrap(h)}function R(D){const h=D.buffer;if(P.isLittleEndian()||F(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const b=new Uint8Array(h.byteLength);return b.set(h),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(D){const h=new Uint32Array(k(D));let b=0;if(h[b++]=D.id,D.type==="full")h[b++]=1,h[b++]=D.data.length,h.set(D.data,b),b+=D.data.length;else{h[b++]=2,h[b++]=D.deltas.length;for(const m of D.deltas)h[b++]=m.start,h[b++]=m.deleteCount,m.data?(h[b++]=m.data.length,h.set(m.data,b),b+=m.data.length):h[b++]=0}return E(h)}e.encodeSemanticTokensDto=y;function k(D){let h=0;if(h+=1+1,D.type==="full")h+=1+D.data.length;else{h+=1,h+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(h+=b.data.length)}return h}function M(D){const h=R(D);let b=0;const m=h[b++];if(h[b++]===1){const p=h[b++],S=h.subarray(b,b+p);return b+=p,{id:m,type:"full",data:S}}const s=h[b++],u=[];for(let p=0;p<s;p++){const S=h[b++],O=h[b++],v=h[b++];let t;v>0&&(t=h.subarray(b,b+v),b+=v),u[p]={start:S,deleteCount:O,data:t}}return{id:m,type:"delta",deltas:u}}e.decodeSemanticTokensDto=M}),define(ke[129],Te([13,14]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ke[130],Te([1,0,129,20,131,16,22,117]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class D{constructor(Y,pe,We,$e){this.id=Y,this.name=pe,this.defaultValue=We,this.schema=$e}applyUpdate(Y,pe){return b(Y,pe)}compute(Y,pe,We){return We}}class h{constructor(Y,pe){this.newValue=Y,this.didChange=pe}}e.ApplyUpdateResult=h;function b(G,Y){if(typeof G!="object"||typeof Y!="object"||!G||!Y)return new h(Y,G!==Y);if(Array.isArray(G)||Array.isArray(Y)){const We=Array.isArray(G)&&Array.isArray(Y)&&F.equals(G,Y);return new h(Y,!We)}let pe=!1;for(const We in Y)if(Y.hasOwnProperty(We)){const $e=b(G[We],Y[We]);$e.didChange&&(G[We]=$e.newValue,pe=!0)}return new h(G,pe)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,pe){return b(Y,pe)}validate(Y){return this.defaultValue}}class o{constructor(Y,pe,We,$e){this.id=Y,this.name=pe,this.defaultValue=We,this.schema=$e}applyUpdate(Y,pe){return b(Y,pe)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,pe,We){return We}}function s(G,Y){return typeof G>"u"?Y:G==="false"?!1:Boolean(G)}e.boolean=s;class u extends o{constructor(Y,pe,We,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=We),super(Y,pe,We,$e)}validate(Y){return s(Y,this.defaultValue)}}function p(G,Y,pe,We){if(typeof G>"u")return Y;let $e=parseInt(G,10);return isNaN($e)?Y:($e=Math.max(pe,$e),$e=Math.min(We,$e),$e|0)}e.clampedInt=p;class S extends o{static clampedInt(Y,pe,We,$e){return p(Y,pe,We,$e)}constructor(Y,pe,We,$e,Qe,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=We,Ke.minimum=$e,Ke.maximum=Qe),super(Y,pe,We,Ke),this.minimum=$e,this.maximum=Qe}validate(Y){return S.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class O extends o{static clamp(Y,pe,We){return Y<pe?pe:Y>We?We:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y>"u")return pe;const We=parseFloat(Y);return isNaN(We)?pe:We}constructor(Y,pe,We,$e,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=We),super(Y,pe,We,Qe),this.validationFn=$e}validate(Y){return this.validationFn(O.float(Y,this.defaultValue))}}class v extends o{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,We,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=We),super(Y,pe,We,$e)}validate(Y){return v.string(Y,this.defaultValue)}}function t(G,Y,pe){return typeof G!="string"||pe.indexOf(G)===-1?Y:G}e.stringSet=t;class d extends o{constructor(Y,pe,We,$e,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=$e,Qe.default=We),super(Y,pe,We,Qe),this.c=$e}validate(Y){return t(Y,this.defaultValue,this.c)}}class a extends D{constructor(Y,pe,We,$e,Qe,Ke,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=$e),super(Y,pe,We,tt),this.c=Qe,this.d=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function l(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,We){return We===0?Y.accessibilitySupport:We}}class w extends D{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:s(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(G){switch(G){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function T(G){switch(G){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class H extends m{constructor(){super(135)}compute(Y,pe,We){const $e=["monaco-editor"];return pe.get(36)&&$e.push(pe.get(36)),Y.extraEditorClassName&&$e.push(Y.extraEditorClassName),pe.get(70)==="default"?$e.push("mouse-default"):pe.get(70)==="copy"&&$e.push("mouse-copy"),pe.get(105)&&$e.push("showUnused"),pe.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Q extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Y,pe,We){return We&&Y.emptySelectionClipboard}}class Z extends D{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:i.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:i.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:s(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(pe.loop,this.defaultValue.loop)}}}class _ extends D{constructor(){super(48,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?_.OFF:Y==="true"?_.ON:Y:Boolean(Y)?_.ON:_.OFF}}_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on',e.EditorFontLigatures=_;class j extends D{constructor(){super(51,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?j.OFF:Y==="true"?j.TRANSLATE:Y:Boolean(Y)?j.TRANSLATE:j.OFF}compute(Y,pe,We){return Y.fontInfo.fontVariationSettings}}j.OFF="normal",j.TRANSLATE="translate",e.EditorFontVariations=j;class L extends m{constructor(){super(47)}compute(Y,pe,We){return Y.fontInfo}}class g extends o{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(Y){const pe=O.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:O.clamp(pe,6,100)}compute(Y,pe,We){return Y.fontInfo.fontSize}}class N extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.d,maximum:N.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(S.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,N.d,N.e))}}N.c=["normal","bold","100","200","300","400","500","600","700","800","900"],N.d=1,N.e=1e3;class B extends D{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:We,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:We,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:We,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:We,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:We,description:i.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{multiple:t(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??t(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??t(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??t(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??t(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??t(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends D{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:i.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),delay:S.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:s(pe.sticky,this.defaultValue.sticky),above:s(pe.above,this.defaultValue.above)}}}var me;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(me=e.RenderMinimap||(e.RenderMinimap={}));class te extends m{constructor(){super(138)}compute(Y,pe,We){return te.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,We=Math.floor(Y.paddingTop/Y.lineHeight);let $e=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&($e=Math.max($e,pe-1));const Qe=(We+Y.viewLineCount+$e)/(Y.pixelRatio*Y.height),Ke=Math.floor(Y.viewLineCount/Qe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:$e,desiredRatio:Qe,minimapLineCount:Ke}}static c(Y,pe){const We=Y.outerWidth,$e=Y.outerHeight,Qe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Ke=pe.stableMinimapLayoutInput,tt=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.paddingTop===Ke.paddingTop&&Y.paddingBottom===Ke.paddingBottom&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,at=Y.lineHeight,Et=Y.typicalHalfwidthCharacterWidth,Ct=Y.scrollBeyondLastLine,It=Y.minimap.renderCharacters;let Dt=Qe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const ut=Y.minimap.maxColumn,ft=Y.minimap.size,Kt=Y.minimap.side,Vt=Y.verticalScrollbarWidth,kt=Y.viewLineCount,ht=Y.remainingWidth,Tt=Y.isViewportWrapping,$t=It?2:3;let At=Math.floor(Qe*$e);const Ge=At/Qe;let Nt=!1,xt=!1,Ft=$t*Dt,mt=Dt/Qe,Ce=1;if(ft==="fill"||ft==="fit"){const{typicalViewportLineCount:Be,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:ct,desiredRatio:Pt,minimapLineCount:vt}=te.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Ct,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:$e,lineHeight:at,pixelRatio:Qe});if(kt/vt>1)Nt=!0,xt=!0,Dt=1,Ft=1,mt=Dt/Qe;else{let pt=!1,Rt=Dt+1;if(ft==="fit"){const bt=Math.ceil((Ze+kt+ct)*Ft);Tt&&tt&&ht<=pe.stableFitRemainingWidth?(pt=!0,Rt=pe.stableFitMaxMinimapScale):pt=bt>At}if(ft==="fill"||pt){Nt=!0;const bt=Dt;Ft=Math.min(at*Qe,Math.max(1,Math.floor(1/Pt))),Tt&&tt&&ht<=pe.stableFitRemainingWidth&&(Rt=pe.stableFitMaxMinimapScale),Dt=Math.min(Rt,Math.max(1,Math.floor(Ft/$t))),Dt>bt&&(Ce=Math.min(2,Dt/bt)),mt=Dt/Qe/Ce,At=Math.ceil(Math.max(Be,Ze+kt+ct)*Ft),Tt?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=ht,pe.stableFitMaxMinimapScale=Dt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ae=Math.floor(ut*mt),ge=Math.min(Ae,Math.max(0,Math.floor((ht-Vt-2)*mt/(Et+mt)))+e.MINIMAP_GUTTER_WIDTH);let K=Math.floor(Qe*ge);const Re=K/Qe;K=Math.floor(K*Ce);const Ue=It?1:2,Ye=Kt==="left"?0:We-ge-Vt;return{renderMinimap:Ue,minimapLeft:Ye,minimapWidth:ge,minimapHeightIsEditorHeight:Nt,minimapIsSampling:xt,minimapScale:Dt,minimapLineHeight:Ft,minimapCanvasInnerWidth:K,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Re,minimapCanvasOuterHeight:Ge}}static computeLayout(Y,pe){const We=pe.outerWidth|0,$e=pe.outerHeight|0,Qe=pe.lineHeight|0,Ke=pe.lineNumbersDigitCount|0,tt=pe.typicalHalfwidthCharacterWidth,at=pe.maxDigitWidth,Et=pe.pixelRatio,Ct=pe.viewLineCount,It=Y.get(130),Dt=It==="inherit"?Y.get(129):It,ut=Dt==="inherit"?Y.get(125):Dt,ft=Y.get(128),Kt=pe.isDominatedByLongLines,Vt=Y.get(54),kt=Y.get(64).renderType!==0,ht=Y.get(65),Tt=Y.get(99),$t=Y.get(80),At=Y.get(69),Ge=Y.get(97),Nt=Ge.verticalScrollbarSize,xt=Ge.verticalHasArrows,Ft=Ge.arrowSize,mt=Ge.horizontalScrollbarSize,Ce=Y.get(40),Ae=Y.get(104)!=="never";let ge=Y.get(62);Ce&&Ae&&(ge+=16);let K=0;if(kt){const ei=Math.max(Ke,ht);K=Math.round(ei*at)}let Re=0;Vt&&(Re=Qe);let Ue=0,Ye=Ue+Re,Be=Ye+K,Ze=Be+ge;const ct=We-Re-K-ge;let Pt=!1,vt=!1,wt=-1;Dt==="inherit"&&Kt?(Pt=!0,vt=!0):ut==="on"||ut==="bounded"?vt=!0:ut==="wordWrapColumn"&&(wt=ft);const pt=te.c({outerWidth:We,outerHeight:$e,lineHeight:Qe,typicalHalfwidthCharacterWidth:tt,pixelRatio:Et,scrollBeyondLastLine:Tt,paddingTop:$t.top,paddingBottom:$t.bottom,minimap:At,verticalScrollbarWidth:Nt,viewLineCount:Ct,remainingWidth:ct,isViewportWrapping:vt},pe.memory||new M);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Ue+=pt.minimapWidth,Ye+=pt.minimapWidth,Be+=pt.minimapWidth,Ze+=pt.minimapWidth);const Rt=ct-pt.minimapWidth,bt=Math.max(1,Math.floor((Rt-Nt-2)/tt)),ri=xt?Ft:0;return vt&&(wt=Math.max(1,bt),ut==="bounded"&&(wt=Math.min(wt,ft))),{width:We,height:$e,glyphMarginLeft:Ue,glyphMarginWidth:Re,lineNumbersLeft:Ye,lineNumbersWidth:K,decorationsLeft:Be,decorationsWidth:ge,contentLeft:Ze,contentWidth:Rt,minimap:pt,viewportColumn:bt,isWordWrapMinified:Pt,isViewportWrapping:vt,wrappingColumn:wt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:mt,overviewRuler:{top:ri,width:Nt,height:$e-2*ri,right:0}}}}e.EditorLayoutInfoComputer=te;class oe extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(Y){return t(Y,"simple",["simple","advanced"])}compute(Y,pe,We){return pe.get(2)===2?"advanced":We}}class ce extends D{constructor(){const Y={enabled:!0};super(61,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:i.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:s(Y.enabled,this.defaultValue.enabled)}}}class we extends D{constructor(){const Y={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class q extends D{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:i.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:t(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:s(pe.padding,this.defaultValue.padding)}}}class x extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):S.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,pe,We){return We<0?S.clampedInt(-We*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class X extends O{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>O.clamp(Y,0,150),{markdownDescription:i.localize(60,null)})}compute(Y,pe,We){return Y.fontInfo.lineHeight}}class de extends D{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:Y.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:i.localize(71,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),autohide:s(pe.autohide,this.defaultValue.autohide),size:t(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(pe.side,this.defaultValue.side,["right","left"]),showSlider:t(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(pe.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(pe.scale,1,1,3),maxColumn:S.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(G){return G==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ne extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:S.clampedInt(pe.top,0,0,1e3),bottom:S.clampedInt(pe.bottom,0,0,1e3)}}}class ze extends D{constructor(){const Y={enabled:!0,cycle:!0};super(81,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:i.localize(75,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),cycle:s(pe.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(Y,pe,We){return Y.pixelRatio}}class Ie extends D{constructor(){const Y={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Y.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:Y.comments,description:i.localize(80,null)},other:{anyOf:pe,default:Y.other,description:i.localize(81,null)}},default:Y,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Et=Y?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:pe,comments:We,strings:$e}=Y,Qe=["on","inline","off"];let Ke,tt,at;return typeof pe=="boolean"?Ke=pe?"on":"off":Ke=t(pe,this.defaultValue.other,Qe),typeof We=="boolean"?tt=We?"on":"off":tt=t(We,this.defaultValue.comments,Qe),typeof $e=="boolean"?at=$e?"on":"off":at=t($e,this.defaultValue.strings,Qe),{other:Ke,comments:tt,strings:at}}}var Se;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ae extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(Y){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(pe=4,We=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function le(G){const Y=G.get(92);return Y==="editable"?G.get(86):Y!=="on"}e.filterValidationDecorations=le;class ee extends D{constructor(){const Y=[],pe={type:"number",description:i.localize(88,null)};super(96,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:Y,description:i.localize(90,null)})}validate(Y){if(Array.isArray(Y)){const pe=[];for(const We of Y)if(typeof We=="number")pe.push({column:S.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const $e=We;pe.push({column:S.clampedInt($e.column,0,0,1e4),color:$e.color})}return pe.sort((We,$e)=>We.column-$e.column),pe}return this.defaultValue}}function C(G,Y){if(typeof G!="string")return Y;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends D{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:i.localize(101,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,We=S.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=S.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(pe.vertical,this.defaultValue.vertical),horizontal:C(pe.horizontal,this.defaultValue.horizontal),useShadows:s(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:S.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:S.clampedInt(pe.verticalSliderSize,$e,0,1e3),scrollByPage:s(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:i.localize(108,null)}})}applyUpdate(Y,pe){let We=!1;pe.allowedCharacters&&Y&&(E.equals(Y.allowedCharacters,pe.allowedCharacters)||(Y={...Y,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&Y&&(E.equals(Y.allowedLocales,pe.allowedLocales)||(Y={...Y,allowedLocales:pe.allowedLocales},We=!0));const $e=super.applyUpdate(Y,pe);return We?new h($e.newValue,!0):$e}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{nonBasicASCII:De(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:De(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:De(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,pe){if(typeof Y!="object"||!Y)return pe;const We={};for(const[$e,Qe]of Object.entries(Y))Qe===!0&&(We[$e]=!0);return We}}class V extends D{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:i.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[i.localize(110,null),i.localize(111,null)],description:i.localize(112,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),mode:t(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ie extends D{constructor(){const Y={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:i.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:s(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends D{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(115,null),i.localize(116,null),i.localize(117,null)],default:Y.bracketPairs,description:i.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:Y.bracketPairsHorizontal,description:i.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:i.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:i.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(125,null),i.localize(126,null),i.localize(127,null)],default:Y.highlightActiveIndentation,description:i.localize(128,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{bracketPairs:De(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:De(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:De(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function De(G,Y,pe){const We=pe.indexOf(G);return We===-1?Y:pe[We]}class ue extends D{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(129,null),i.localize(130,null)],default:Y.insertMode,description:i.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:i.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:i.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:i.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(135,null),i.localize(136,null),i.localize(137,null),i.localize(138,null)],default:Y.selectionMode,markdownDescription:i.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:i.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:i.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:i.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:i.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:i.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(176,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:t(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(pe.showIcons,this.defaultValue.showIcons),showStatusBar:s(pe.showStatusBar,this.defaultValue.showStatusBar),preview:s(pe.preview,this.defaultValue.preview),previewMode:t(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(pe.showMethods,this.defaultValue.showMethods),showFunctions:s(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:s(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(pe.showFields,this.defaultValue.showFields),showVariables:s(pe.showVariables,this.defaultValue.showVariables),showClasses:s(pe.showClasses,this.defaultValue.showClasses),showStructs:s(pe.showStructs,this.defaultValue.showStructs),showInterfaces:s(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:s(pe.showModules,this.defaultValue.showModules),showProperties:s(pe.showProperties,this.defaultValue.showProperties),showEvents:s(pe.showEvents,this.defaultValue.showEvents),showOperators:s(pe.showOperators,this.defaultValue.showOperators),showUnits:s(pe.showUnits,this.defaultValue.showUnits),showValues:s(pe.showValues,this.defaultValue.showValues),showConstants:s(pe.showConstants,this.defaultValue.showConstants),showEnums:s(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:s(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(pe.showKeywords,this.defaultValue.showKeywords),showWords:s(pe.showWords,this.defaultValue.showWords),showColors:s(pe.showColors,this.defaultValue.showColors),showFiles:s(pe.showFiles,this.defaultValue.showFiles),showReferences:s(pe.showReferences,this.defaultValue.showReferences),showFolders:s(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:s(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(pe.showSnippets,this.defaultValue.showSnippets),showUsers:s(pe.showUsers,this.defaultValue.showUsers),showIssues:s(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(177,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var be;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(178,null),i.localize(179,null),i.localize(180,null),i.localize(181,null)],description:i.localize(182,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,pe,We){return pe.get(2)===2?0:We}}class je extends m{constructor(){super(139)}compute(Y,pe,We){const $e=pe.get(138);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class it extends D{constructor(){const Y={enabled:!0};super(33,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(183,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:s(Y.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?et:P.isLinux?nt:Xe,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(G){return e.editorOptionsRegistry[G.id]=G,G}var rt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.colorDecoratorsLimit=18]="colorDecoratorsLimit",G[G.columnSelection=19]="columnSelection",G[G.comments=20]="comments",G[G.contextmenu=21]="contextmenu",G[G.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",G[G.cursorBlinking=23]="cursorBlinking",G[G.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",G[G.cursorStyle=25]="cursorStyle",G[G.cursorSurroundingLines=26]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",G[G.cursorWidth=28]="cursorWidth",G[G.disableLayerHinting=29]="disableLayerHinting",G[G.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",G[G.domReadOnly=31]="domReadOnly",G[G.dragAndDrop=32]="dragAndDrop",G[G.dropIntoEditor=33]="dropIntoEditor",G[G.emptySelectionClipboard=34]="emptySelectionClipboard",G[G.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",G[G.extraEditorClassName=36]="extraEditorClassName",G[G.fastScrollSensitivity=37]="fastScrollSensitivity",G[G.find=38]="find",G[G.fixedOverflowWidgets=39]="fixedOverflowWidgets",G[G.folding=40]="folding",G[G.foldingStrategy=41]="foldingStrategy",G[G.foldingHighlight=42]="foldingHighlight",G[G.foldingImportsByDefault=43]="foldingImportsByDefault",G[G.foldingMaximumRegions=44]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=46]="fontFamily",G[G.fontInfo=47]="fontInfo",G[G.fontLigatures=48]="fontLigatures",G[G.fontSize=49]="fontSize",G[G.fontWeight=50]="fontWeight",G[G.fontVariations=51]="fontVariations",G[G.formatOnPaste=52]="formatOnPaste",G[G.formatOnType=53]="formatOnType",G[G.glyphMargin=54]="glyphMargin",G[G.gotoLocation=55]="gotoLocation",G[G.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",G[G.hover=57]="hover",G[G.inDiffEditor=58]="inDiffEditor",G[G.inlineSuggest=59]="inlineSuggest",G[G.letterSpacing=60]="letterSpacing",G[G.lightbulb=61]="lightbulb",G[G.lineDecorationsWidth=62]="lineDecorationsWidth",G[G.lineHeight=63]="lineHeight",G[G.lineNumbers=64]="lineNumbers",G[G.lineNumbersMinChars=65]="lineNumbersMinChars",G[G.linkedEditing=66]="linkedEditing",G[G.links=67]="links",G[G.matchBrackets=68]="matchBrackets",G[G.minimap=69]="minimap",G[G.mouseStyle=70]="mouseStyle",G[G.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=72]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",G[G.multiCursorModifier=74]="multiCursorModifier",G[G.multiCursorPaste=75]="multiCursorPaste",G[G.multiCursorLimit=76]="multiCursorLimit",G[G.occurrencesHighlight=77]="occurrencesHighlight",G[G.overviewRulerBorder=78]="overviewRulerBorder",G[G.overviewRulerLanes=79]="overviewRulerLanes",G[G.padding=80]="padding",G[G.parameterHints=81]="parameterHints",G[G.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",G[G.quickSuggestions=84]="quickSuggestions",G[G.quickSuggestionsDelay=85]="quickSuggestionsDelay",G[G.readOnly=86]="readOnly",G[G.renameOnType=87]="renameOnType",G[G.renderControlCharacters=88]="renderControlCharacters",G[G.renderFinalNewline=89]="renderFinalNewline",G[G.renderLineHighlight=90]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=92]="renderValidationDecorations",G[G.renderWhitespace=93]="renderWhitespace",G[G.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",G[G.roundedSelection=95]="roundedSelection",G[G.rulers=96]="rulers",G[G.scrollbar=97]="scrollbar",G[G.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=99]="scrollBeyondLastLine",G[G.scrollPredominantAxis=100]="scrollPredominantAxis",G[G.selectionClipboard=101]="selectionClipboard",G[G.selectionHighlight=102]="selectionHighlight",G[G.selectOnLineNumbers=103]="selectOnLineNumbers",G[G.showFoldingControls=104]="showFoldingControls",G[G.showUnused=105]="showUnused",G[G.snippetSuggestions=106]="snippetSuggestions",G[G.smartSelect=107]="smartSelect",G[G.smoothScrolling=108]="smoothScrolling",G[G.stickyScroll=109]="stickyScroll",G[G.stickyTabStops=110]="stickyTabStops",G[G.stopRenderingLineAfter=111]="stopRenderingLineAfter",G[G.suggest=112]="suggest",G[G.suggestFontSize=113]="suggestFontSize",G[G.suggestLineHeight=114]="suggestLineHeight",G[G.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",G[G.suggestSelection=116]="suggestSelection",G[G.tabCompletion=117]="tabCompletion",G[G.tabIndex=118]="tabIndex",G[G.unicodeHighlighting=119]="unicodeHighlighting",G[G.unusualLineTerminators=120]="unusualLineTerminators",G[G.useShadowDOM=121]="useShadowDOM",G[G.useTabStops=122]="useTabStops",G[G.wordBreak=123]="wordBreak",G[G.wordSeparators=124]="wordSeparators",G[G.wordWrap=125]="wordWrap",G[G.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=128]="wordWrapColumn",G[G.wordWrapOverride1=129]="wordWrapOverride1",G[G.wordWrapOverride2=130]="wordWrapOverride2",G[G.wrappingIndent=131]="wrappingIndent",G[G.wrappingStrategy=132]="wrappingStrategy",G[G.showDeprecated=133]="showDeprecated",G[G.inlayHints=134]="inlayHints",G[G.editorClassName=135]="editorClassName",G[G.pixelRatio=136]="pixelRatio",G[G.tabFocusMode=137]="tabFocusMode",G[G.layoutInfo=138]="layoutInfo",G[G.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(184,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(185,null),""],markdownDescription:i.localize(186,null)})),accessibilitySupport:Fe(new c),accessibilityPageSize:Fe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",i.localize(188,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(192,null),""],description:i.localize(193,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(194,null),""],description:i.localize(195,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(196,null),i.localize(197,null),""],description:i.localize(198,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[i.localize(199,null),i.localize(200,null),i.localize(201,null),i.localize(202,null),i.localize(203,null)],description:i.localize(204,null)})),automaticLayout:Fe(new u(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(205,null),i.localize(206,null),i.localize(207,null),""],description:i.localize(208,null)})),bracketPairColorization:Fe(new ie),bracketPairGuides:Fe(new fe),stickyTabStops:Fe(new u(110,"stickyTabStops",!1,{description:i.localize(209,null)})),codeLens:Fe(new u(14,"codeLens",!0,{description:i.localize(210,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:i.localize(211,null)})),codeLensFontSize:Fe(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(212,null)})),colorDecorators:Fe(new u(17,"colorDecorators",!0,{description:i.localize(213,null)})),colorDecoratorsLimit:Fe(new S(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(214,null)})),columnSelection:Fe(new u(19,"columnSelection",!1,{description:i.localize(215,null)})),comments:Fe(new w),contextmenu:Fe(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new u(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(216,null)})),cursorBlinking:Fe(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:i.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(218,null),i.localize(219,null),i.localize(220,null)],description:i.localize(221,null)})),cursorStyle:Fe(new a(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:i.localize(222,null)})),cursorSurroundingLines:Fe(new S(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(224,null),i.localize(225,null)],description:i.localize(226,null)})),cursorWidth:Fe(new S(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(227,null)})),disableLayerHinting:Fe(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new u(31,"domReadOnly",!1)),dragAndDrop:Fe(new u(32,"dragAndDrop",!0,{description:i.localize(228,null)})),emptySelectionClipboard:Fe(new Q),dropIntoEditor:Fe(new it),stickyScroll:Fe(new we),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(229,null),i.localize(230,null),i.localize(231,null)],description:i.localize(232,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new O(37,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:i.localize(233,null)})),find:Fe(new Z),fixedOverflowWidgets:Fe(new u(39,"fixedOverflowWidgets",!1)),folding:Fe(new u(40,"folding",!0,{description:i.localize(234,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(235,null),i.localize(236,null)],description:i.localize(237,null)})),foldingHighlight:Fe(new u(42,"foldingHighlight",!0,{description:i.localize(238,null)})),foldingImportsByDefault:Fe(new u(43,"foldingImportsByDefault",!1,{description:i.localize(239,null)})),foldingMaximumRegions:Fe(new S(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(241,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(242,null)})),fontInfo:Fe(new L),fontLigatures2:Fe(new _),fontSize:Fe(new g),fontWeight:Fe(new N),fontVariations:Fe(new j),formatOnPaste:Fe(new u(52,"formatOnPaste",!1,{description:i.localize(243,null)})),formatOnType:Fe(new u(53,"formatOnType",!1,{description:i.localize(244,null)})),glyphMargin:Fe(new u(54,"glyphMargin",!0,{description:i.localize(245,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new u(56,"hideCursorInOverviewRuler",!1,{description:i.localize(246,null)})),hover:Fe(new J),inDiffEditor:Fe(new u(58,"inDiffEditor",!1)),letterSpacing:Fe(new O(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>O.clamp(G,-5,20),{description:i.localize(247,null)})),lightbulb:Fe(new ce),lineDecorationsWidth:Fe(new x),lineHeight:Fe(new X),lineNumbers:Fe(new ae),lineNumbersMinChars:Fe(new S(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new u(66,"linkedEditing",!1,{description:i.localize(248,null)})),links:Fe(new u(67,"links",!0,{description:i.localize(249,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:i.localize(250,null)})),minimap:Fe(new de),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new O(71,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:i.localize(251,null)})),mouseWheelZoom:Fe(new u(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(252,null)})),multiCursorMergeOverlapping:Fe(new u(73,"multiCursorMergeOverlapping",!0,{description:i.localize(253,null)})),multiCursorModifier:Fe(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null)],markdownDescription:i.localize(256,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(257,null),i.localize(258,null)],markdownDescription:i.localize(259,null)})),multiCursorLimit:Fe(new S(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(260,null)})),occurrencesHighlight:Fe(new u(77,"occurrencesHighlight",!0,{description:i.localize(261,null)})),overviewRulerBorder:Fe(new u(78,"overviewRulerBorder",!0,{description:i.localize(262,null)})),overviewRulerLanes:Fe(new S(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ne),parameterHints:Fe(new ze),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(263,null),i.localize(264,null)],description:i.localize(265,null)})),definitionLinkOpensInPeek:Fe(new u(83,"definitionLinkOpensInPeek",!1,{description:i.localize(266,null)})),quickSuggestions:Fe(new Ie),quickSuggestionsDelay:Fe(new S(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(267,null)})),readOnly:Fe(new u(86,"readOnly",!1)),renameOnType:Fe(new u(87,"renameOnType",!1,{description:i.localize(268,null),markdownDeprecationMessage:i.localize(269,null)})),renderControlCharacters:Fe(new u(88,"renderControlCharacters",!0,{description:i.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(271,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(272,null)],description:i.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(274,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(275,null),i.localize(276,null),i.localize(277,null),""],description:i.localize(278,null)})),revealHorizontalRightPadding:Fe(new S(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new u(95,"roundedSelection",!0,{description:i.localize(279,null)})),rulers:Fe(new ee),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new S(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(280,null)})),scrollBeyondLastLine:Fe(new u(99,"scrollBeyondLastLine",!0,{description:i.localize(281,null)})),scrollPredominantAxis:Fe(new u(100,"scrollPredominantAxis",!0,{description:i.localize(282,null)})),selectionClipboard:Fe(new u(101,"selectionClipboard",!0,{description:i.localize(283,null),included:P.isLinux})),selectionHighlight:Fe(new u(102,"selectionHighlight",!0,{description:i.localize(284,null)})),selectOnLineNumbers:Fe(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),showUnused:Fe(new u(105,"showUnused",!0,{description:i.localize(289,null)})),showDeprecated:Fe(new u(133,"showDeprecated",!0,{description:i.localize(290,null)})),inlayHints:Fe(new q),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(291,null),i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new u(108,"smoothScrolling",!1,{description:i.localize(296,null)})),stopRenderingLineAfter:Fe(new S(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ue),inlineSuggest:Fe(new V),suggestFontSize:Fe(new S(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new S(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new u(115,"suggestOnTriggerCharacters",!0,{description:i.localize(299,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(300,null),i.localize(301,null),i.localize(302,null)],description:i.localize(303,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(304,null),i.localize(305,null),i.localize(306,null)],description:i.localize(307,null)})),tabIndex:Fe(new S(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(308,null),i.localize(309,null),i.localize(310,null)],description:i.localize(311,null)})),useShadowDOM:Fe(new u(121,"useShadowDOM",!0)),useTabStops:Fe(new u(122,"useTabStops",!0,{description:i.localize(312,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(313,null),i.localize(314,null)],description:i.localize(315,null)})),wordSeparators:Fe(new v(124,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:i.localize(316,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(317,null),i.localize(318,null),i.localize(319,null),i.localize(320,null)],description:i.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new S(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(322,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new H),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new u(137,"tabFocusMode",!1,{markdownDescription:i.localize(323,null)})),layoutInfo:Fe(new te),wrappingInfo:Fe(new je),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new oe)}}),define(ke[132],Te([13,14]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[133],Te([13,14]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[134],Te([13,14]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[135],Te([13,14]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ke[136],Te([13,14]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ke[137],Te([13,14]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[138],Te([13,14]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ke[139],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[140],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[141],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[142],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[143],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[144],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[145],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[146],Te([13,14]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[147],Te([13,14]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ke[148],Te([13,14]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ke[149],Te([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[150],Te([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[151],Te([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[152],Te([13,14]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[153],Te([13,14]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[154],Te([13,14]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[155],Te([13,14]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[156],Te([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var P;(function(F){F[F.LParen=0]="LParen",F[F.RParen=1]="RParen",F[F.Neg=2]="Neg",F[F.Eq=3]="Eq",F[F.NotEq=4]="NotEq",F[F.Lt=5]="Lt",F[F.LtEq=6]="LtEq",F[F.Gt=7]="Gt",F[F.GtEq=8]="GtEq",F[F.RegexOp=9]="RegexOp",F[F.RegexStr=10]="RegexStr",F[F.True=11]="True",F[F.False=12]="False",F[F.In=13]="In",F[F.Not=14]="Not",F[F.And=15]="And",F[F.Or=16]="Or",F[F.Str=17]="Str",F[F.QuotedStr=18]="QuotedStr",F[F.Error=19]="Error",F[F.EOF=20]="EOF"})(P=e.TokenType||(e.TokenType={}));class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(E){if(E.type!==19)throw(0,i.illegalArgument)(`expected an error token but got ${JSON.stringify(E)}`);switch(E.lexeme){case"=":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '||'?`;default:{const R=E.lexeme;return R&&R.length>1&&R.startsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to close the string?`:R&&R.length>1&&R.endsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to open the string?`:`Unexpected token '${E.lexeme}' at offset ${E.offset}`}}}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,i.illegalState)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(){const E={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(E),this.f.push(E)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const R=this.c.substring(this.d,this.e),y=I.b.get(R);y?this.k(y):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,R=!1,y=!1;for(;;){if(E>=this.c.length){this.e=E,this.l();return}const M=this.c.charCodeAt(E);if(R)R=!1;else if(M===47&&!y){E++;break}else M===91?y=!0:M===92?R=!0:M===93&&(y=!1);E++}for(;E<this.c.length&&I.a.has(this.c.charCodeAt(E));)E++;this.e=E;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(F=>F.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(ke[157],Te([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this.a=new Map}register(F,E){this.a.set(F,E)}updateManifest(F){if(!(typeof F.main>"u"&&typeof F.browser>"u")&&(F.activationEvents===void 0&&Object.assign(F,{activationEvents:[]}),!(!Array.isArray(F.activationEvents)||!F.contributes)))for(const E in F.contributes){const R=this.a.get(E);if(!R)continue;const y=F.contributes[E],k=Array.isArray(y)?y:[y];try{R(k,F.activationEvents)}catch(M){(0,i.onUnexpectedError)(M)}}}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P}),define(ke[158],Te([1,0,24,29,134,258]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const E=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(u){return u=u.trim(),u==="*"||E.test(u)}e.isValidVersionStr=y;function k(u){if(!y(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(E);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function M(u){if(!u)return null;const p=u.majorBase,S=u.majorMustEqual,O=u.minorBase;let v=u.minorMustEqual;const t=u.patchBase;let d=u.patchMustEqual;u.hasCaret&&(p===0||(v=!1),d=!1);let a=0;if(u.preRelease){const l=R.exec(u.preRelease);if(l){const[,c,w,n]=l;a=Date.UTC(Number(c),Number(w)-1,Number(n))}}return{majorBase:p,majorMustEqual:S,minorBase:O,minorMustEqual:v,patchBase:t,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:a}}e.normalizeVersion=M;function D(u,p,S){let O;typeof u=="string"?O=M(k(u)):O=u;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let t;if(typeof S=="string"?t=M(k(S)):t=S,!O||!t)return!1;const d=O.majorBase,a=O.minorBase,l=O.patchBase;let c=t.majorBase,w=t.minorBase,n=t.patchBase;const r=t.notBefore;let f=t.majorMustEqual,A=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?d>c?!0:d<c?!1:a>w?!0:a<w||v&&v<r?!1:l>=n:(d===1&&c===0&&(!f||!A||!T)&&(c=1,w=0,n=0,f=!0,A=!1,T=!1),d<c?!1:d>c?!f:a<w?!1:a>w?!A:l<n?!1:l>n?!T:!(v&&v<r))}e.isValidVersion=D;function h(u,p,S,O,v){const t=[];if(typeof O.publisher<"u"&&typeof O.publisher!="string")return t.push([P.default.Error,I.localize(0,null)]),t;if(typeof O.name!="string")return t.push([P.default.Error,I.localize(1,null,"name")]),t;if(typeof O.version!="string")return t.push([P.default.Error,I.localize(2,null,"version")]),t;if(!O.engines)return t.push([P.default.Error,I.localize(3,null,"engines")]),t;if(typeof O.engines.vscode!="string")return t.push([P.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof O.extensionDependencies<"u"&&!s(O.extensionDependencies))return t.push([P.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof O.activationEvents<"u"){if(!s(O.activationEvents))return t.push([P.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof O.main>"u"&&typeof O.browser>"u")return t.push([P.default.Error,I.localize(7,null,"activationEvents","main")]),t}if(typeof O.extensionKind<"u"&&typeof O.main>"u"&&t.push([P.default.Warning,I.localize(8,null,"extensionKind")]),typeof O.main<"u"){if(typeof O.main!="string")return t.push([P.default.Error,I.localize(9,null,"main")]),t;{const l=(0,i.joinPath)(S,O.main);(0,i.isEqualOrParent)(l,S)||t.push([P.default.Warning,I.localize(10,null,l.path,S.path)])}if(typeof O.activationEvents>"u")return t.push([P.default.Error,I.localize(11,null,"activationEvents","main")]),t}if(typeof O.browser<"u"){if(typeof O.browser!="string")return t.push([P.default.Error,I.localize(12,null,"browser")]),t;{const l=(0,i.joinPath)(S,O.browser);(0,i.isEqualOrParent)(l,S)||t.push([P.default.Warning,I.localize(13,null,l.path,S.path)])}if(typeof O.activationEvents>"u")return t.push([P.default.Error,I.localize(14,null,"activationEvents","browser")]),t}if(!F.valid(O.version))return t.push([P.default.Error,I.localize(15,null)]),t;const d=[];if(!b(u,p,O,v,d))for(const l of d)t.push([P.default.Error,l]);return t}e.validateExtensionManifest=h;function b(u,p,S,O,v){return O||typeof S.main>"u"&&typeof S.browser>"u"?!0:o(u,p,S.engines.vscode,v)}e.isValidExtensionVersion=b;function m(u,p,S){return u==="*"||o(p,S,u)}e.isEngineValid=m;function o(u,p,S,O=[]){const v=M(k(S));if(!v)return O.push(I.localize(16,null,S)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return O.push(I.localize(17,null,S)),!1}else if(!v.majorMustEqual)return O.push(I.localize(18,null,S)),!1;return D(u,p,v)?!0:(O.push(I.localize(19,null,u,S)),!1)}function s(u){if(!Array.isArray(u))return!1;for(let p=0,S=u.length;p<S;p++)if(typeof u[p]!="string")return!1;return!0}}),define(ke[89],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(I,F=[],E=!1){this.ctor=I,this.staticArguments=F,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=i}),define(ke[67],Te([1,0,89]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var I;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function F(R,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),P.push([R,y])}e.registerSingleton=F;function E(){return P}e.getSingletonServiceDescriptors=E}),define(ke[159],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(F,E){this.key=F,this.data=E,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class P{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const E of this.a.values())E.outgoing.size===0&&F.push(E);return F}insertEdge(F,E){const R=this.lookupOrInsertNode(F),y=this.lookupOrInsertNode(E);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(F){const E=this.b(F);this.a.delete(E);for(const R of this.a.values())R.outgoing.delete(E),R.incoming.delete(E)}lookupOrInsertNode(F){const E=this.b(F);let R=this.a.get(E);return R||(R=new i(E,F),this.a.set(E,R)),R}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[E,R]of this.a)F.push(`${E}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,E]of this.a){const R=new Set([F]),y=this.c(E,R);if(y)return y}}c(F,E){for(const[R,y]of F.outgoing){if(E.has(R))return[...E,R].join(" -> ");E.add(R);const k=this.c(y,E);if(k)return k;E.delete(R)}}}e.Graph=P}),define(ke[3],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=R})(i=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function P(E,R,y){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:E,index:y}):(R[i.DI_DEPENDENCIES]=[{id:E,index:y}],R[i.DI_TARGET]=R)}function I(E){if(i.serviceIds.has(E))return i.serviceIds.get(E);const R=function(y,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(R,y,M)};return R.toString=()=>E,i.serviceIds.set(E,R),R}e.createDecorator=I;function F(E){return E}e.refineServiceDecorator=F}),define(ke[41],Te([1,0,9,2,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function F(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationOverrides=F;function E(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=E;var R;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(s,u){const p=Object.create(null);for(const S in s)M(p,S,s[S],u);return p}e.toValuesTree=k;function M(s,u,p,S){const O=u.split("."),v=O.pop();let t=s;for(let d=0;d<O.length;d++){const a=O[d];let l=t[a];switch(typeof l){case"undefined":l=t[a]=Object.create(null);break;case"object":break;default:S(`Ignoring ${u} as ${O.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[v]=p}catch{S(`Ignoring ${u} as ${O.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${u} as ${O.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=M;function D(s,u){const p=u.split(".");h(s,p)}e.removeFromValueTree=D;function h(s,u){const p=u.shift();if(u.length===0){delete s[p];return}if(Object.keys(s).indexOf(p)!==-1){const S=s[p];typeof S=="object"&&!Array.isArray(S)&&(h(S,u),Object.keys(S).length===0&&delete s[p])}}function b(s,u,p){function S(t,d){let a=t;for(const l of d){if(typeof a!="object"||a===null)return;a=a[l]}return a}const O=u.split("."),v=S(s,O);return typeof v>"u"?p:v}e.getConfigurationValue=b;function m(s,u,p){Object.keys(u).forEach(S=>{S!=="__proto__"&&(S in s?i.isObject(s[S])&&i.isObject(u[S])?m(s[S],u[S],p):p&&(s[S]=u[S]):s[S]=u[S])})}e.merge=m;function o(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(ke[42],Te([1,0,20,10,156,3]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",i.isMacintosh),E.set("isLinux",i.isLinux),E.set("isWindows",i.isWindows),E.set("isWeb",i.isWeb),E.set("isMacNative",i.isMacintosh&&!i.isWeb),E.set("isEdge",i.isEdge),E.set("isFirefox",i.isFirefox),E.set("isChrome",i.isChrome),E.set("isSafari",i.isSafari);const R=Object.prototype.hasOwnProperty;var y;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return m.INSTANCE}static true(){return o.INSTANCE}static has(g){return s.create(g)}static equals(g,N){return u.create(g,N)}static notEquals(g,N){return O.create(g,N)}static regex(g,N){return w.create(g,N)}static in(g,N){return p.create(g,N)}static notIn(g,N){return S.create(g,N)}static not(g){return v.create(g)}static and(...g){return f.create(g,null,!0)}static or(...g){return A.create(g,null,!0)}static greater(g,N){return d.create(g,N)}static greaterEquals(g,N){return a.create(g,N)}static smaller(g,N){return l.create(g,N)}static smallerEquals(g,N){return c.create(g,N)}static deserializeOrErrorNew(g){if(!g)return{type:"error",lexingErrors:[],parsingErrors:[]};const N=new D,B=N.parse(g);return B===void 0?{type:"error",lexingErrors:N.lexingErrors.map(J=>I.Scanner.reportError(J)),parsingErrors:N.parsingErrors}:{type:"ok",expr:B}}static deserialize(g){if(!!g)return this.c(g)}static c(g){const N=g.split("||");return A.create(N.map(B=>this.d(B)),null,!0)}static d(g){const N=g.split("&&");return f.create(N.map(B=>this.f(B)),null,!0)}static f(g){if(g=g.trim(),g.indexOf("!=")>=0){const N=g.split("!=");return O.create(N[0].trim(),this.g(N[1]))}if(g.indexOf("==")>=0){const N=g.split("==");return u.create(N[0].trim(),this.g(N[1]))}if(g.indexOf("=~")>=0){const N=g.split("=~");return w.create(N[0].trim(),this.h(N[1]))}if(g.indexOf(" not in ")>=0){const N=g.split(" not in ");return S.create(N[0].trim(),this.g(N[1]))}if(g.indexOf(" in ")>=0){const N=g.split(" in ");return p.create(N[0].trim(),this.g(N[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const N=g.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const N=g.split(">");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const N=g.split("<=");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const N=g.split("<");return l.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(g)?v.create(g.substr(1).trim()):s.create(g)}static g(g){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;const N=/^'([^']*)'$/.exec(g);return N?N[1].trim():g}static h(g){if((0,P.isFalsyOrWhitespace)(g))return null;const N=g.indexOf("/"),B=g.lastIndexOf("/");if(N===B||N<0)return null;const J=g.slice(N+1,B),me=g[B+1]==="i"?"i":"";try{return new RegExp(J,me)}catch{return null}}}e.ContextKeyExpr=k;class M extends Error{}class D{constructor(){this.c=new I.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(g){if(g===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(g).scan(),this.f=0,this.g=[];try{const N=this.h();if(!this.D())throw this.z(this.C());return N}catch(N){if(!(N instanceof M)){const B=this.C();this.g.push(`Unexpected error: ${N} for token ${I.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}h(){return this.k()}k(){const g=[this.l()];for(;this.v(16);){const N=this.l();g.push(N)}return g.length===1?g[0]:k.or(...g)}l(){const g=[this.o()];for(;this.v(15);){const N=this.o();g.push(N)}return g.length===1?g[0]:k.and(...g)}o(){if(this.v(2)){const g=this.C();switch(g.type){case 17:return this.w(),k.not(g.lexeme);case 11:return this.w(),k.false();case 12:return this.w(),k.true();default:throw this.y("KEY, 'true', or 'false'",g)}}return this.s()}s(){const g=this.C();switch(g.type){case 11:return this.w(),k.true();case 12:return this.w(),k.false();case 0:{this.w();const N=this.h();return this.x(1,"')'"),N}case 17:{const N=g.lexeme;if(this.w(),this.v(9)){const J=this.C();switch(J.type){case 10:case 19:{const me=[J.lexeme];this.w();let te=this.C(),oe=0;for(let X=0;X<J.lexeme.length;X++)J.lexeme.charCodeAt(X)===40?oe++:J.lexeme.charCodeAt(X)===41&&oe--;for(;!this.D()&&te.type!==15&&te.type!==16;){switch(te.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let X=0;X<te.lexeme.length;X++)te.lexeme.charCodeAt(X)===40?oe++:J.lexeme.charCodeAt(X)===41&&oe--}if(oe<0)break;me.push(I.Scanner.getLexeme(te)),this.w(),te=this.C()}const ce=me.join(""),we=ce.lastIndexOf("/"),q=we===ce.length-1?void 0:ce.substring(we+1),x=new RegExp(ce.substring(1,we),q);return k.regex(N,x)}case 18:{const me=J.lexeme;this.w();let te=null;if(!(0,P.isFalsyOrWhitespace)(me)){const oe=me.indexOf("/"),ce=me.lastIndexOf("/");if(oe!==ce&&oe>=0){const we=me.slice(oe+1,ce),q=me[ce+1]==="i"?"i":"";try{te=new RegExp(we,q)}catch{}}}if(te===null)throw this.y("REGEX",J);return w.create(N,te)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const J=this.t();return k.notIn(N,J)}switch(this.C().type){case 3:{this.w();const J=this.t();switch(J){case"true":return k.has(N);case"false":return k.not(N);default:return k.equals(N,J)}}case 4:{this.w();const J=this.t();switch(J){case"true":return k.not(N);case"false":return k.has(N);default:return k.notEquals(N,J)}}case 5:return this.w(),l.create(N,this.t());case 6:return this.w(),c.create(N,this.t());case 7:return this.w(),d.create(N,this.t());case 8:return this.w(),a.create(N,this.t());case 13:return this.w(),k.in(N,this.t());default:return k.has(N)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const g=this.C();switch(g.type){case 17:case 18:return this.w(),g.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(g){return this.B(g)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(g,N){if(this.B(g))return this.w();throw this.y(N,this.C())}y(g,N){return this.A(`Expected ${g} but got '${I.Scanner.getLexeme(N)}' at offset ${N.offset}.`)}z(g){return this.A(`Unexpected '${I.Scanner.getLexeme(g)}' at offset ${g.offset}.`)}A(g){return this.g.push(g),new M}B(g){return this.C().type===g}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=D;function h(L,g){const N=L?L.substituteConstants():void 0,B=g?g.substituteConstants():void 0;return!N&&!B?!0:!N||!B?!1:N.equals(B)}e.expressionsAreEqualWithConstantSubstitution=h;function b(L,g){return L.cmp(g)}class m{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return o.INSTANCE}}m.INSTANCE=new m,e.ContextKeyFalseExpr=m;class o{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return m.INSTANCE}}o.INSTANCE=new o,e.ContextKeyTrueExpr=o;class s{static create(g,N=null){const B=E.get(g);return typeof B=="boolean"?B?o.INSTANCE:m.INSTANCE:new s(g,N)}constructor(g,N){this.key=g,this.c=N,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:H(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=E.get(this.key);return typeof g=="boolean"?g?o.INSTANCE:m.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=s;class u{static create(g,N,B=null){if(typeof N=="boolean")return N?s.create(g,B):v.create(g,B);const J=E.get(g);return typeof J=="boolean"?N===(J?"true":"false")?o.INSTANCE:m.INSTANCE:new u(g,N,B)}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=E.get(this.c);if(typeof g=="boolean"){const N=g?"true":"false";return this.d===N?o.INSTANCE:m.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class p{static create(g,N){return new p(g,N)}constructor(g,N){this.d=g,this.f=N,this.type=10,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const N=g.getValue(this.f),B=g.getValue(this.d);return Array.isArray(N)?N.includes(B):typeof B=="string"&&typeof N=="object"&&N!==null?R.call(N,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class S{static create(g,N){return new S(g,N)}constructor(g,N){this.d=g,this.f=N,this.type=11,this.c=p.create(g,N)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=S;class O{static create(g,N,B=null){if(typeof N=="boolean")return N?v.create(g,B):s.create(g,B);const J=E.get(g);return typeof J=="boolean"?N===(J?"true":"false")?m.INSTANCE:o.INSTANCE:new O(g,N,B)}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=E.get(this.c);if(typeof g=="boolean"){const N=g?"true":"false";return this.d===N?m.INSTANCE:o.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=O;class v{static create(g,N=null){const B=E.get(g);return typeof B=="boolean"?B?m.INSTANCE:o.INSTANCE:new v(g,N)}constructor(g,N){this.c=g,this.d=N,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:H(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=E.get(this.c);return typeof g=="boolean"?g?m.INSTANCE:o.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=s.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function t(L,g){if(typeof L=="string"){const N=parseFloat(L);isNaN(N)||(L=N)}return typeof L=="string"||typeof L=="number"?g(L):m.INSTANCE}class d{static create(g,N,B=null){return t(N,J=>new d(g,J,B))}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=d;class a{static create(g,N,B=null){return t(N,J=>new a(g,J,B))}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=a;class l{static create(g,N,B=null){return t(N,J=>new l(g,J,B))}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=l;class c{static create(g,N,B=null){return t(N,J=>new c(g,J,B))}constructor(g,N,B){this.c=g,this.d=N,this.f=B,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=c;class w{static create(g,N){return new w(g,N)}constructor(g,N){this.d=g,this.f=N,this.type=7,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const N=this.f?this.f.source:"",B=g.f?g.f.source:"";return N<B?-1:N>B?1:0}equals(g){if(g.type===this.type){const N=this.f?this.f.source:"",B=g.f?g.f.source:"";return this.d===g.d&&N===B}return!1}substituteConstants(){return this}evaluate(g){const N=g.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=w;class n{static create(g){return new n(g)}constructor(g){this.c=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(g){return new n(this.c.map(g))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function r(L){let g=null;for(let N=0,B=L.length;N<B;N++){const J=L[N].substituteConstants();if(L[N]!==J&&g===null){g=[];for(let me=0;me<N;me++)g[me]=L[me]}g!==null&&(g[N]=J)}return g===null?L:g}class f{static create(g,N,B){return f.d(g,N,B)}constructor(g,N){this.expr=g,this.c=N,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let N=0,B=this.expr.length;N<B;N++){const J=b(this.expr[N],g.expr[N]);if(J!==0)return J}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let N=0,B=this.expr.length;N<B;N++)if(!this.expr[N].equals(g.expr[N]))return!1;return!0}return!1}substituteConstants(){const g=r(this.expr);return g===this.expr?this:f.create(g,this.c,!1)}evaluate(g){for(let N=0,B=this.expr.length;N<B;N++)if(!this.expr[N].evaluate(g))return!1;return!0}static d(g,N,B){const J=[];let me=!1;for(const te of g)if(!!te){if(te.type===1){me=!0;continue}if(te.type===0)return m.INSTANCE;if(te.type===6){J.push(...te.expr);continue}J.push(te)}if(J.length===0&&me)return o.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(b);for(let te=1;te<J.length;te++)J[te-1].equals(J[te])&&(J.splice(te,1),te--);if(J.length===1)return J[0];for(;J.length>1;){const te=J[J.length-1];if(te.type!==9)break;J.pop();const oe=J.pop(),ce=J.length===0,we=A.create(te.expr.map(q=>f.create([q,oe],null,B)),null,ce);we&&(J.push(we),J.sort(b))}if(J.length===1)return J[0];if(B){for(let te=0;te<J.length;te++)for(let oe=te+1;oe<J.length;oe++)if(J[te].negate().equals(J[oe]))return m.INSTANCE;if(J.length===1)return J[0]}return new f(J,N)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const N of this.expr)g.push(...N.keys());return g}map(g){return new f(this.expr.map(N=>N.map(g)),null)}negate(){if(!this.c){const g=[];for(const N of this.expr)g.push(N.negate());this.c=A.create(g,this,!0)}return this.c}}class A{static create(g,N,B){return A.d(g,N,B)}constructor(g,N){this.expr=g,this.c=N,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let N=0,B=this.expr.length;N<B;N++){const J=b(this.expr[N],g.expr[N]);if(J!==0)return J}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let N=0,B=this.expr.length;N<B;N++)if(!this.expr[N].equals(g.expr[N]))return!1;return!0}return!1}substituteConstants(){const g=r(this.expr);return g===this.expr?this:A.create(g,this.c,!1)}evaluate(g){for(let N=0,B=this.expr.length;N<B;N++)if(this.expr[N].evaluate(g))return!0;return!1}static d(g,N,B){let J=[],me=!1;if(g){for(let te=0,oe=g.length;te<oe;te++){const ce=g[te];if(!!ce){if(ce.type===0){me=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){J=J.concat(ce.expr);continue}J.push(ce)}}if(J.length===0&&me)return m.INSTANCE;J.sort(b)}if(J.length!==0){if(J.length===1)return J[0];for(let te=1;te<J.length;te++)J[te-1].equals(J[te])&&(J.splice(te,1),te--);if(J.length===1)return J[0];if(B){for(let te=0;te<J.length;te++)for(let oe=te+1;oe<J.length;oe++)if(J[te].negate().equals(J[oe]))return o.INSTANCE;if(J.length===1)return J[0]}return new A(J,N)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const N of this.expr)g.push(...N.keys());return g}map(g){return new A(this.expr.map(N=>N.map(g)),null)}negate(){if(!this.c){const g=[];for(const N of this.expr)g.push(N.negate());for(;g.length>1;){const N=g.shift(),B=g.shift(),J=[];for(const me of j(N))for(const te of j(B))J.push(f.create([me,te],null,!1));g.unshift(A.create(J,null,!1))}this.c=A.create(g,this,!0)}return this.c}}class T extends s{static all(){return T.d.values()}constructor(g,N,B){super(g,null),this.f=N,typeof B=="object"?T.d.push({...B,key:g}):B!==!0&&T.d.push({key:g,description:B,type:N!=null?typeof N:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return u.create(this.key,g)}notEqualsTo(g){return O.create(this.key,g)}}T.d=[],e.RawContextKey=T,e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function H(L,g){return L<g?-1:L>g?1:0}function Q(L,g,N,B){return L<N?-1:L>N?1:g<B?-1:g>B?1:0}function Z(L,g){if(L.type===0||g.type===1)return!0;if(L.type===9)return g.type===9?_(L.expr,g.expr):!1;if(g.type===9){for(const N of g.expr)if(Z(L,N))return!0;return!1}if(L.type===6){if(g.type===6)return _(g.expr,L.expr);for(const N of L.expr)if(Z(N,g))return!0;return!1}return L.equals(g)}e.implies=Z;function _(L,g){let N=0,B=0;for(;N<L.length&&B<g.length;){const J=L[N].cmp(g[B]);if(J<0)return!1;J===0&&N++,B++}return N===L.length}function j(L){return L.type===9?L.expr:[L]}}),define(ke[160],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[90],Te([1,0,133,3]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function I(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function F(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function E(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function R(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(u,p,S){return R(p,S)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===S?!0:k(S).includes(u)}e.isTargetPlatformCompatible=y;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function M(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=M;var D;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var h;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var b;(function(u){u.Install="install",u.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var o;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(o=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(p,S){super(p),this.code=S,this.name=S}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,i.localize)(1,null),original:"Preferences"}}),define(ke[43],Te([1,0,48,19,10,9,2,135,3,20,15]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function D(te){return te.create===!0}e.isFileOpenForWriteOptions=D;var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var b;(function(te){te[te.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function o(te){return!!(te.capabilities&2)}e.hasReadWriteCapability=o;function s(te){return!!(te.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(te){return!!(te.capabilities&32768)}e.hasFileCloneCapability=u;function p(te){return!!(te.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function S(te){return!!(te.capabilities&16)}e.hasFileReadStreamCapability=S;function O(te){return o(te)?!!(te.capabilities&16384):!1}e.hasFileAtomicReadCapability=O;var v;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(oe,ce){const we=new t(oe.toString(),ce);return l(we,ce),we}constructor(oe,ce){super(oe),this.code=ce}}e.FileSystemProviderError=t;function d(te,oe){return t.create(te,oe)}e.createFileSystemProviderError=d;function a(te){return te||d((0,R.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function l(te,oe){return te.name=oe?`${oe} (FileSystemError)`:"FileSystemError",te}e.markAsFileSystemProviderError=l;function c(te){if(!te)return v.Unknown;if(te instanceof t)return te.code;const oe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!oe)return v.Unknown;switch(oe[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=c;function w(te){if(te instanceof H)return te.fileOperationResult;switch(c(te)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=w;var n;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(oe,ce,we){this.resource=oe,this.operation=ce,this.target=we}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=r;var f;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class A{constructor(oe,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const we=new Map;for(const q of oe){const x=we.get(q.type);switch(x?x.push([q.resource,q]):we.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,x]of we)switch(q){case 1:this.a=i.TernarySearchTree.forUris(()=>ce),this.a.fill(x);break;case 0:this.b=i.TernarySearchTree.forUris(()=>ce),this.b.fill(x);break;case 2:this.c=i.TernarySearchTree.forUris(()=>ce),this.c.fill(x);break}}contains(oe,...ce){return this.d(oe,{includeChildren:!1},...ce)}affects(oe,...ce){return this.d(oe,{includeChildren:!0},...ce)}d(oe,ce,...we){if(!oe)return!1;const q=we.length>0;return!!((!q||we.includes(1))&&(this.a?.get(oe)||ce.includeChildren&&this.a?.findSuperstr(oe))||(!q||we.includes(0))&&(this.b?.get(oe)||ce.includeChildren&&this.b?.findSuperstr(oe))||(!q||we.includes(2))&&(this.c?.findSubstr(oe)||ce.includeChildren&&this.c?.findSuperstr(oe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=A;function T(te,oe,ce){return!te||!oe||te===oe||oe.length>te.length?!1:(oe.charAt(oe.length-1)!==P.sep&&(oe+=P.sep),ce?(0,I.startsWithIgnoreCase)(te,oe):te.indexOf(oe)===0)}e.isParent=T;class H extends Error{constructor(oe,ce,we){super(oe),this.fileOperationResult=ce,this.options=we}}e.FileOperationError=H;class Q extends H{constructor(oe,ce,we,q){super(oe,ce,q),this.fileOperationResult=ce,this.size=we}}e.TooLargeFileOperationError=Q;class Z extends H{constructor(oe,ce,we){super(oe,2,we),this.stat=ce}}e.NotModifiedSinceFileOperationError=Z;var _;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.etag=L;async function g(te,oe){if(!oe.hasProvider(E.URI.from({scheme:te.scheme})))return new Promise(ce=>{const we=oe.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===te.scheme&&q.added&&(we.dispose(),ce())})})}e.whenProviderRegistered=g,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(oe){return(0,F.isNumber)(oe)||(oe=0),oe<N.KB?(0,R.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,R.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,R.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,R.localize)(4,null,(oe/N.GB).toFixed(2)):(0,R.localize)(5,null,(oe/N.TB).toFixed(2))}}N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB,e.ByteSize=N;var B;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function J(te){return{maxFileSize:te===0?300*N.MB:16*N.GB,maxHeapSize:te===0?700*N.MB:2*700*N.MB}}e.getPlatformFileLimits=J;function me(te){const oe=typeof te=="string"||te?.scheme===M.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===M.Schemas.file?1024*N.MB:oe?10*N.MB:k.isWeb?50*N.MB:1024*N.MB}e.getLargeFileConfirmationLimit=me}),define(ke[68],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...I){this.a=new Map;for(const[F,E]of I)this.set(F,E)}set(I,F){const E=this.a.get(I);return this.a.set(I,F),E}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=i}),define(ke[161],Te([1,0,17,11,6,89,159,3,68,162]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class D extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class h{constructor(s=new y.ServiceCollection,u=!1,p,S=M){this.f=s,this.g=u,this.h=p,this.i=S,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=S?p?._globalGraph??new E.Graph(O=>O):void 0}createChild(s){return new h(s,this.g,this,this.i)}invokeFunction(s,...u){const p=m.traceInvocation(this.i,s);let S=!1;try{return s({get:v=>{if(S)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(v,p);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...u)}finally{S=!0,p.stop()}}createInstance(s,...u){let p,S;return s instanceof F.SyncDescriptor?(p=m.traceCreation(this.i,s.ctor),S=this.j(s.ctor,s.staticArguments.concat(u),p)):(p=m.traceCreation(this.i,s),S=this.j(s,u,p)),p.stop(),S}j(s,u=[],p){const S=R._util.getServiceDependencies(s).sort((t,d)=>t.index-d.index),O=[];for(const t of S){const d=this.m(t.id,p);d||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),O.push(d)}const v=S.length>0?S[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${s.name} at position ${v+1} conflicts with ${u.length} static arguments`);const t=v-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,v)}return Reflect.construct(s,u.concat(O))}k(s,u){if(this.f.get(s)instanceof F.SyncDescriptor)this.f.set(s,u);else if(this.h)this.h.k(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const u=this.f.get(s);return!u&&this.h?this.h.l(s):u}m(s,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const p=this.l(s);return p instanceof F.SyncDescriptor?this.q(s,p,u.branch(s,!0)):(u.branch(s,!1),p)}q(s,u,p){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,u,p)}finally{this.o.delete(s)}}r(s,u,p){const S=new E.Graph(t=>t.id.toString());let O=0;const v=[{id:s,desc:u,_trace:p}];for(;v.length;){const t=v.pop();if(S.lookupOrInsertNode(t),O++>1e3)throw new D(S);for(const d of R._util.getServiceDependencies(t.desc.ctor)){const a=this.l(d.id);if(a||this.u(`[createInstance] ${s} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),a instanceof F.SyncDescriptor){const l={id:d.id,desc:a,_trace:t._trace.branch(d.id,!0)};S.insertEdge(t,l),v.push(l)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new D(S);break}for(const{data:d}of t){if(this.l(d.id)instanceof F.SyncDescriptor){const l=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,l)}S.removeNode(d)}}return this.l(s)}s(s,u,p=[],S,O){if(this.f.get(s)instanceof F.SyncDescriptor)return this.t(s,u,p,S,O);if(this.h)return this.h.s(s,u,p,S,O);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(s,u,p=[],S,O){if(S){const v=new h(void 0,this.g,this,this.i);v.c=String(s);const t=new Map,d=new i.IdleValue(()=>{const a=v.j(u,p,O);for(const[l,c]of t){const w=a[l];if(typeof w=="function")for(const n of c)w.apply(a,n)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,l){if(!d.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=t.get(l);return n||(n=new k.LinkedList,t.set(l,n)),(f,A,T)=>{const H=n.push([f,A,T]);return(0,I.toDisposable)(H)}}if(l in a)return a[l];const c=d.value;let w=c[l];return typeof w!="function"||(w=w.bind(c),a[l]=w),w},set(a,l,c){return d.value[l]=c,!0},getPrototypeOf(a){return u.prototype}})}else return this.j(u,p,O)}u(s,u){if(u&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=h;var b;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(b||(b={}));class m{static traceInvocation(s,u){return s?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(s,u){return s?new m(1,u.name):m.c}constructor(s,u){this.type=s,this.name=u,this.g=Date.now(),this.h=[]}branch(s,u){const p=new m(3,s.toString());return this.h.push([s,u,p]),p}stop(){const s=Date.now()-this.g;m.f+=s;let u=!1;function p(O,v){const t=[],d=new Array(O+1).join("	");for(const[a,l,c]of v.h)if(l&&c){u=!0,t.push(`${d}CREATES -> ${a}`);const w=p(O+1,c);w&&t.push(w)}else t.push(`${d}uses -> ${a}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(s>2||u)&&m.all.add(S.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(ke[12],Te([1,0,39,4,6,28,20,9,2,3]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function M(){return new Date().toISOString()}function D(n){return(0,R.isNumber)(n)}e.isLogLevel=D;var h;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function b(n,r,f){switch(r){case h.Trace:n.trace(f);break;case h.Debug:n.debug(f);break;case h.Info:n.info(f);break;case h.Warning:n.warn(f);break;case h.Error:n.error(f);break;case h.Off:break;default:throw new Error(`Invalid log level ${r}`)}}e.log=b;function m(n){let r="";for(let f=0;f<n.length;f++){let A=n[f];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}r+=(f>0?" ":"")+A}return r}e.format=m;class o extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new P.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(r){this.b!==r&&(this.b=r,this.c.fire(this.b))}getLevel(){return this.b}f(r){return this.b!==h.Off&&this.b<=r}}e.AbstractLogger=o;class s extends o{constructor(r){super(),this.h=r}f(r){return this.h||super.f(r)}trace(r,...f){this.f(h.Trace)&&this.g(h.Trace,m([r,...f]))}debug(r,...f){this.f(h.Debug)&&this.g(h.Debug,m([r,...f]))}info(r,...f){this.f(h.Info)&&this.g(h.Info,m([r,...f]))}warn(r,...f){this.f(h.Warning)&&this.g(h.Warning,m([r,...f]))}error(r,...f){if(this.f(h.Error))if(r instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=r.stack,this.g(h.Error,m(A))}else this.g(h.Error,m([r,...f]))}flush(){}}e.AbstractMessageLogger=s;class u extends o{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.g=!E.isWindows}trace(r,...f){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,r,...f):console.log(`[main ${M()}]`,r,...f))}debug(r,...f){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,r,...f):console.log(`[main ${M()}]`,r,...f))}info(r,...f){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${M()}]\x1B[0m`,r,...f):console.log(`[main ${M()}]`,r,...f))}warn(r,...f){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${M()}]\x1B[0m`,r,...f):console.warn(`[main ${M()}]`,r,...f))}error(r,...f){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${M()}]\x1B[0m`,r,...f):console.error(`[main ${M()}]`,r,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class p extends o{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...f){this.f(h.Trace)&&console.log("%cTRACE","color: #888",r,...f)}debug(r,...f){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",r,...f)}info(r,...f){this.f(h.Info)&&console.log("%c INFO","color: #33f",r,...f)}warn(r,...f){this.f(h.Warning)&&console.log("%c WARN","color: #993",r,...f)}error(r,...f){this.f(h.Error)&&console.log("%c  ERR","color: #f33",r,...f)}dispose(){}flush(){}}e.ConsoleLogger=p;class S extends o{constructor(r,f=e.DEFAULT_LOG_LEVEL){super(),this.g=r,this.setLevel(f)}trace(r,...f){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(r),...f])}debug(r,...f){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(r),...f])}info(r,...f){this.f(h.Info)&&this.g.log(h.Info,[this.h(r),...f])}warn(r,...f){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(r),...f])}error(r,...f){this.f(h.Error)&&this.g.log(h.Error,[this.h(r),...f])}h(r){return typeof r=="string"?r:(0,i.toErrorMessage)(r,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=S;class O extends o{constructor(r){super(),this.g=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const f of this.g)f.setLevel(r);super.setLevel(r)}trace(r,...f){for(const A of this.g)A.trace(r,...f)}debug(r,...f){for(const A of this.g)A.debug(r,...f)}info(r,...f){for(const A of this.g)A.info(r,...f)}warn(r,...f){for(const A of this.g)A.warn(r,...f)}error(r,...f){for(const A of this.g)A.error(r,...f)}flush(){for(const r of this.g)r.flush()}dispose(){for(const r of this.g)r.dispose()}}e.MultiplexLogger=O;class v extends I.Disposable{constructor(r,f){if(super(),this.j=r,this.b=new F.ResourceMap,this.c=new F.ResourceMap,this.f=this.B(new P.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new P.Emitter),this.onDidChangeVisibility=this.h.event,f)for(const A of f)this.c.set(A.resource,A)}getLogger(r){return this.b.get(r)}createLogger(r,f){let A=this.b.get(r);const T=f?.logLevel==="always"?h.Trace:f?.logLevel;return A||(A=this.k(r,T??this.getLogLevel(r)??this.j,f),this.b.set(r,A)),this.registerLogger({resource:r,id:f?.id??r.toString(),logLevel:T,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId}),A}setLogLevel(r,f){if(y.URI.isUri(r)){const A=r,T=f,H=this.c.get(A);H&&T!==H.logLevel&&(H.logLevel=T===this.j?void 0:T,this.b.get(A)?.setLevel(T),this.c.set(H.resource,H),this.g.fire([A,T]))}else{this.j=r;for(const[A,T]of this.b.entries())this.c.get(A)?.logLevel===void 0&&T.setLevel(this.j);this.g.fire(this.j)}}setVisibility(r,f){const A=this.c.get(r);A&&f!==!A.hidden&&(A.hidden=!f,this.c.set(A.resource,A),this.h.fire([r,f]))}getLogLevel(r){let f;return r&&(f=this.c.get(r)?.logLevel),f??this.j}registerLogger(r){const f=this.c.get(r.resource);f?f.hidden!==r.hidden&&this.setVisibility(r.resource,!r.hidden):(this.c.set(r.resource,r),this.f.fire({added:[r],removed:[]}))}deregisterLogger(r){const f=this.c.get(r);if(f){this.c.delete(r);const A=this.b.get(r);A&&(this.b.delete(r),A.dispose()),this.f.fire({added:[],removed:[f]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(r){return this.c.get(r)}dispose(){this.b.forEach(r=>r.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(r){}getLevel(){return h.Info}trace(r,...f){}debug(r,...f){}info(r,...f){}warn(r,...f){}error(r,...f){}critical(r,...f){}dispose(){}flush(){}}e.NullLogger=t;class d extends t{}e.NullLogService=d;class a extends v{constructor(){super(h.Info)}k(r,f,A){return new t}}e.NullLoggerService=a;function l(n){if(n.verbose)return h.Trace;if(typeof n.logLevel=="string"){const r=w(n.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(n){switch(n){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=c;function w(n){switch(n){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=w}),define(ke[163],Te([1,0,6,12]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends i.Disposable{constructor(E,R=[]){super(),this.a=new P.MultiplexLogger([E,...R]),this.B(E.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(E){this.a.setLevel(E)}getLevel(){return this.a.getLevel()}trace(E,...R){this.a.trace(E,...R)}debug(E,...R){this.a.debug(E,...R)}info(E,...R){this.a.info(E,...R)}warn(E,...R){this.a.warn(E,...R)}error(E,...R){this.a.error(E,...R)}flush(){this.a.flush()}}e.LogService=I}),define(ke[91],Te([1,0,29,136,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(F=e.MarkerTag||(e.MarkerTag={}));var E;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(m,o){return o-m}y.compare=k;const M=Object.create(null);M[y.Error]=(0,P.localize)(0,null),M[y.Warning]=(0,P.localize)(1,null),M[y.Info]=(0,P.localize)(2,null);function D(m){return M[m]||""}y.toString=D;function h(m){switch(m){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=h;function b(m){switch(m){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=b}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const k="";function M(h){return D(h,!0)}y.makeKey=M;function D(h,b){const m=[k];return h.source?m.push(h.source.replace("\xA6","\\\xA6")):m.push(k),h.code?typeof h.code=="string"?m.push(h.code.replace("\xA6","\\\xA6")):m.push(h.code.value.replace("\xA6","\\\xA6")):m.push(k),h.severity!==void 0&&h.severity!==null?m.push(E.toString(h.severity)):m.push(k),h.message&&b?m.push(h.message.replace("\xA6","\\\xA6")):m.push(k),h.startLineNumber!==void 0&&h.startLineNumber!==null?m.push(h.startLineNumber.toString()):m.push(k),h.startColumn!==void 0&&h.startColumn!==null?m.push(h.startColumn.toString()):m.push(k),h.endLineNumber!==void 0&&h.endLineNumber!==null?m.push(h.endLineNumber.toString()):m.push(k),h.endColumn!==void 0&&h.endColumn!==null?m.push(h.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}y.makeKeyOptionalMessage=D})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ke[164],Te([1,0,4,29,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,I.createDecorator)("notificationService");var F;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(F=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=y}),define(ke[92],Te([1,0,10,2,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function F(k,M){return P.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,M):(0,i.startsWithIgnoreCase)(k,M+":")}e.matchesScheme=F;function E(k,...M){return M.some(D=>F(k,D))}e.matchesSomeScheme=E;function R(k,M){return k.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=R;function y(k){let M;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(M={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:M,uri:k}}e.extractSelection=y}),define(ke[165],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ne,e,i,P){var I=arguments.length,F=I<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,i):P,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ne,e,i,P);else for(var R=ne.length-1;R>=0;R--)(E=ne[R])&&(F=(I<3?E(F):I>3?E(e,i,F):E(e,i))||F);return I>3&&F&&Object.defineProperty(e,i,F),F},Ve=this&&this.__param||function(ne,e){return function(i,P){e(i,P,ne)}};define(ke[166],Te([1,0,17,21,6,3]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var E;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}R.None=Object.freeze({report(){}}),e.Progress=R;let y=class extends I.Disposable{constructor(D,h){super(),this.a=new i.DeferredPromise,h.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};y=qe([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends I.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new I.DisposableStore)}start(D){this.stop();const h=++this.a,b=new P.CancellationTokenSource;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>b.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:h,token:b.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(ke[30],Te([1,0,49,9]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(E,R){i.ok(P.isString(E)),i.ok(P.isObject(R)),i.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,R)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}e.Registry=new I}),define(ke[69],Te([1,0,4,30]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class F{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,k){this.a[I(y)]=k,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const E=new F;P.Registry.add(e.Extensions.JSONContribution,E)}),define(ke[93],Te([1,0,16,4,9,132,41,69,30]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=y.Registry.as(R.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new P.Emitter,this.onDidSchemaChange=this.i.event,this.j=new P.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const a=new Set;this.n(t,d,a),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const d=new Set;this.o(t,d),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const a=new Set;this.o(d,a),this.n(t,!1,a),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const a=[];for(const{overrides:l,source:c}of t)for(const w in l)if(d.add(w),e.OVERRIDE_PROPERTY_REGEX.test(w)){const n=this.a.get(w),r=n?.valuesSources??new Map;if(c)for(const H of Object.keys(l[w]))r.set(H,c);const f={...n?.value||{},...l[w]};this.a.set(w,{source:c,value:f,valuesSources:r});const A=(0,E.getLanguageTagSettingPlainKey)(w),T={type:"object",default:f,description:F.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:I.isString(c)?void 0:c,defaultValueSource:c};a.push(...o(w)),this.d[w]=T,this.b.properties[w]=T}else{this.a.set(w,{value:l[w],source:c});const n=this.d[w];n&&(this.w(w,n),this.r(w,n))}this.m(a)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:a,source:l}of t)for(const c in a){const w=this.a.get(c),n=I.isString(l)?l:l?.id,r=I.isString(w?.source)?w?.source:w?.source?.id;if(n===r)if(d.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const f=this.d[c];f&&(this.w(c,f),this.r(c,f))}}this.u()}deltaConfiguration(t){let d=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,a){t.forEach(l=>{this.p(l,d,l.extensionInfo,l.restrictedProperties,void 0,a),this.c.push(l),this.q(l)})}o(t,d){const a=l=>{if(l.properties)for(const c in l.properties){d.add(c);const w=this.d[c];w?.policy?.name&&this.e.delete(w.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>a(c))};for(const l of t){a(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,d=!0,a,l,c=3,w){c=I.isUndefinedOrNull(t.scope)?c:t.scope;const n=t.properties;if(n)for(const f in n){const A=n[f];if(d&&S(f,A)){delete n[f];continue}if(A.source=a,A.defaultDefaultValue=n[f].default,this.w(f,A),e.OVERRIDE_PROPERTY_REGEX.test(f)?A.scope=void 0:(A.scope=I.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=I.isUndefinedOrNull(A.restricted)?!!l?.includes(f):A.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),w.add(f)}const r=t.allOf;if(r)for(const f of r)this.p(f,d,a,l,c,w)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=a=>{const l=a.properties;if(l)for(const w in l)this.r(w,l[w]);a.allOf?.forEach(d)};d(t)}r(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,a={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,a),e.allSettings.properties[d]=a,e.applicationSettings.properties[d]=a,e.machineSettings.properties[d]=a,e.machineOverridableSettings.properties[d]=a,e.windowSettings.properties[d]=a,e.resourceSettings.properties[d]=a}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,d){const a=this.a.get(t);let l=a?.value,c=a?.source;I.isUndefined(l)&&(l=d.defaultDefaultValue,c=void 0),I.isUndefined(l)&&(l=u(d.type)),d.default=l,d.defaultValueSource=c}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=m.exec(v);for(;d?.length;){const a=d[1].trim();a&&t.push(a),d=m.exec(v)}}return(0,i.distinct)(t)}e.overrideIdentifiersFromKey=o;function s(v){return v.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=s;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new h;y.Registry.add(e.Extensions.Configuration,p);function S(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?F.localize(7,null,v):p.getConfigurationProperties()[v]!==void 0?F.localize(8,null,v):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,v,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.validateProperty=S;function O(){const v=[],t=p.getConfigurationProperties();for(const d of Object.keys(t))v.push([d,t[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=O}),define(ke[167],Te([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:R.deepFreeze(d)}class m{constructor(a={},l=[],c=[],w){this.b=a,this.c=l,this.d=c,this.raw=w,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(l=>{if(l instanceof m)return l;const c=new o("");return c.parseRaw(l),c.configurationModel});this.f=a.reduce((l,c)=>c===l?c:l.merge(c),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,M.getConfigurationValue)(this.contents,a):this.contents}inspect(a,l){const c=this.rawConfiguration.getValue(a),w=l?this.rawConfiguration.getOverrideValue(a,l):void 0,n=l?this.rawConfiguration.override(l).getValue(a):c;return{value:c,override:w,merged:n}}getOverrideValue(a,l){const c=this.i(l);return c?a?(0,M.getConfigurationValue)(c,a):c:void 0}getKeysForOverrideIdentifier(a){const l=[];for(const c of this.overrides)c.identifiers.includes(a)&&l.push(...c.keys);return i.distinct(l)}getAllOverrideIdentifiers(){const a=[];for(const l of this.overrides)a.push(...l.identifiers);return i.distinct(a)}override(a){let l=this.a.get(a);return l||(l=this.g(a),this.a.set(a,l)),l}merge(...a){const l=R.deepClone(this.contents),c=R.deepClone(this.overrides),w=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const r of a)if(n.push(...r.raw?.length?r.raw:[r]),!r.isEmpty()){this.h(l,r.contents);for(const f of r.overrides){const[A]=c.filter(T=>i.equals(T.identifiers,f.identifiers));A?(this.h(A.contents,f.contents),A.keys.push(...f.keys),A.keys=i.distinct(A.keys)):c.push(R.deepClone(f))}for(const f of r.keys)w.indexOf(f)===-1&&w.push(f)}return new m(l,w,c,n.every(r=>r instanceof m)?void 0:n)}g(a){const l=this.i(a);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const w of i.distinct([...Object.keys(this.contents),...Object.keys(l)])){let n=this.contents[w];const r=l[w];r&&(typeof n=="object"&&typeof r=="object"?(n=R.deepClone(n),this.h(n,r)):n=r),c[w]=n}return new m(c,this.keys,this.overrides)}h(a,l){for(const c of Object.keys(l)){if(c in a&&y.isObject(a[c])&&y.isObject(l[c])){this.h(a[c],l[c]);continue}a[c]=R.deepClone(l[c])}}i(a){let l=null,c=null;const w=n=>{n&&(c?this.h(c,n):c=R.deepClone(n))};for(const n of this.overrides)i.equals(n.identifiers,[a])?l=n.contents:n.identifiers.includes(a)&&w(n.contents);return w(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,l){this.j(a,l,!0)}setValue(a,l){this.j(a,l,!1)}removeValue(a){const l=this.keys.indexOf(a);l!==-1&&(this.keys.splice(l,1),(0,M.removeFromValueTree)(this.contents,a),D.OVERRIDE_PROPERTY_REGEX.test(a)&&this.overrides.splice(this.overrides.findIndex(c=>i.equals(c.identifiers,(0,D.overrideIdentifiersFromKey)(a))),1))}j(a,l,c){(0,M.addToValueTree)(this.contents,a,l,w=>console.error(w)),c=c||this.keys.indexOf(a)===-1,c&&this.keys.push(a),D.OVERRIDE_PROPERTY_REGEX.test(a)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(a),keys:Object.keys(this.contents[a]),contents:(0,M.toValuesTree)(this.contents[a],w=>console.error(w))})}}e.ConfigurationModel=m;class o{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,l){if(!y.isUndefinedOrNull(a)){const c=this.g(a);this.parseRaw(c,l)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,l){this.a=a;const{contents:c,keys:w,overrides:n,restricted:r,hasExcludedProperties:f}=this.h(a,l);this.b=new m(c,w,n,f?[a]:void 0),this.c=r||[]}g(a){let l={},c=null,w=[];const n=[],r=[];function f(T){Array.isArray(w)?w.push(T):c!==null&&(w[c]=T)}const A={onObjectBegin:()=>{const T={};f(T),n.push(w),w=T,c=null},onObjectProperty:T=>{c=T},onObjectEnd:()=>{w=n.pop()},onArrayBegin:()=>{const T=[];f(T),n.push(w),w=T,c=null},onArrayEnd:()=>{w=n.pop()},onLiteralValue:f,onError:(T,H,Q)=>{r.push({error:T,offset:H,length:Q})}};if(a)try{I.visit(a,A),l=w[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return l}h(a,l){const c=h.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),w=this.i(a,c,!0,l);a=w.raw;const n=(0,M.toValuesTree)(a,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),r=Object.keys(a),f=this.j(a,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:n,keys:r,overrides:f,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}i(a,l,c,w){let n=!1;if(!w?.scopes&&!w?.skipRestricted)return{raw:a,restricted:[],hasExcludedProperties:n};const r={},f=[];for(const A in a)if(D.OVERRIDE_PROPERTY_REGEX.test(A)&&c){const T=this.i(a[A],l,!1,w);r[A]=T.raw,n=n||T.hasExcludedProperties,f.push(...T.restricted)}else{const T=l[A],H=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&f.push(A),(H===void 0||w.scopes===void 0||w.scopes.includes(H))&&!(w.skipRestricted&&T?.restricted)?r[A]=a[A]:n=!0}return{raw:r,restricted:f,hasExcludedProperties:n}}j(a,l){const c=[];for(const w of Object.keys(a))if(D.OVERRIDE_PROPERTY_REGEX.test(w)){const n={};for(const r in a[w])n[r]=a[w][r];c.push({identifiers:(0,D.overrideIdentifiersFromKey)(w),keys:Object.keys(n),contents:(0,M.toValuesTree)(n,l)})}return c}}e.ConfigurationModelParser=o;class s extends F.Disposable{constructor(a,l,c,w){super(),this.f=a,this.g=l,this.h=w,this.c=this.B(new P.Emitter),this.onDidChange=this.c.event,this.a=new o(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(P.Event.any(P.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),P.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&c.isEqual(n.resource,a)))(()=>this.c.fire()))}async loadConfiguration(){try{const a=await this.h.readFile(this.f);return this.a.parse(a.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class u{constructor(a,l,c,w,n,r,f,A,T,H,Q,Z,_){this.a=a,this.b=l,this.c=c,this.overrideIdentifiers=w,this.d=n,this.f=r,this.g=f,this.h=A,this.i=T,this.j=H,this.k=Q,this.l=Z,this.m=_}get value(){return b(this.c)}n(a,l,c){const w=a.inspect(l,c);return{get value(){return b(w.value)},get override(){return b(w.override)},get merged(){return b(w.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(a,l,c,w,n=new m,r=new m,f=new E.ResourceMap,A=new m,T=new E.ResourceMap){this.c=a,this.d=l,this.f=c,this.g=w,this.h=n,this.i=r,this.j=f,this.l=A,this.m=T,this.a=null,this.b=new E.ResourceMap,this.n=null}getValue(a,l,c){return this.q(a,l,c).getValue(a)}updateValue(a,l,c={}){let w;c.resource?(w=this.m.get(c.resource),w||(w=new m,this.m.set(c.resource,w))):w=this.l,l===void 0?w.removeValue(a):w.setValue(a,l),c.resource||(this.a=null)}inspect(a,l,c){const w=this.q(a,l,c),n=this.u(l.resource,c),r=l.resource?this.m.get(l.resource)||this.l:this.l,f=new Set;for(const A of w.overrides)for(const T of A.identifiers)w.getOverrideValue(a,T)!==void 0&&f.add(T);return new u(a,l,w.getValue(a),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,n||void 0,r)}keys(a){const l=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,l){this.j.set(a,l),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,l){const c=[];if(!l){const{added:w,updated:n,removed:r}=v(this.c,a);l=[...w,...n,...r]}for(const w of l)for(const n of(0,D.overrideIdentifiersFromKey)(w)){const r=this.c.getKeysForOverrideIdentifier(n),f=a.getKeysForOverrideIdentifier(n),A=[...f.filter(T=>r.indexOf(T)===-1),...r.filter(T=>f.indexOf(T)===-1),...r.filter(T=>!R.equals(this.c.override(n).getValue(T),a.override(n).getValue(T)))];c.push([n,A])}return this.updateDefaultConfiguration(a),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(a){const{added:l,updated:c,removed:w}=v(this.d,a),n=[...l,...c,...w];return n.length&&this.updatePolicyConfiguration(a),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:l,updated:c,removed:w,overrides:n}=v(this.applicationConfiguration,a),r=[...l,...c,...w];return r.length&&this.updateApplicationConfiguration(a),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(a){const{added:l,updated:c,removed:w,overrides:n}=v(this.localUserConfiguration,a),r=[...l,...c,...w];return r.length&&this.updateLocalUserConfiguration(a),{keys:r,overrides:n}}compareAndUpdateRemoteUserConfiguration(a){const{added:l,updated:c,removed:w,overrides:n}=v(this.remoteUserConfiguration,a),r=[...l,...c,...w];return r.length&&this.updateRemoteUserConfiguration(a),{keys:r,overrides:n}}compareAndUpdateWorkspaceConfiguration(a){const{added:l,updated:c,removed:w,overrides:n}=v(this.workspaceConfiguration,a),r=[...l,...c,...w];return r.length&&this.updateWorkspaceConfiguration(a),{keys:r,overrides:n}}compareAndUpdateFolderConfiguration(a,l){const c=this.p.get(a),{added:w,updated:n,removed:r,overrides:f}=v(c,l),A=[...w,...n,...r];return(A.length||!c)&&this.updateFolderConfiguration(a,l),{keys:A,overrides:f}}compareAndDeleteFolderConfiguration(a){const l=this.p.get(a);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:c,updated:w,removed:n,overrides:r}=v(l,void 0);return{keys:[...c,...w,...n],overrides:r}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,l,c){let w=this.r(l,c);return l.overrideIdentifier&&(w=w.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(w=w.merge(this.d)),w}r({resource:a},l){let c=this.s();if(l&&a){const w=l.getFolder(a);w&&(c=this.t(w.uri)||c);const n=this.m.get(a);n&&(c=c.merge(n))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let l=this.b.get(a);if(!l){const c=this.s(),w=this.j.get(a);w?(l=c.merge(w),this.b.set(a,l)):l=c}return l}u(a,l){if(l&&a){const c=l.getFolder(a);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,l)=>{const{contents:c,overrides:w,keys:n}=this.j.get(l);return a.push([l,{contents:c,overrides:w,keys:n}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(l=>a.add(l)),this.userConfiguration.keys.forEach(l=>a.add(l)),this.i.keys.forEach(l=>a.add(l)),this.j.forEach(l=>l.keys.forEach(c=>a.add(c))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>a.add(c))),[...a.values()]}w(a){const l=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(a).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(a).forEach(w=>l.add(w))),[...l.values()]}static parse(a){const l=this.x(a.defaults),c=this.x(a.policy),w=this.x(a.application),n=this.x(a.user),r=this.x(a.workspace),f=a.folders.reduce((A,T)=>(A.set(k.URI.revive(T[0]),this.x(T[1])),A),new E.ResourceMap);return new p(l,c,w,n,new m,r,f,new m,new E.ResourceMap)}static x(a){return new m(a.contents,a.keys,a.overrides)}}e.Configuration=p;function S(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,l=new Map;for(const w of d)w.keys.forEach(n=>a.add(n)),w.overrides.forEach(([n,r])=>{const f=(0,E.getOrSet)(l,n,new Set);r.forEach(A=>f.add(A))});const c=[];return l.forEach((w,n)=>c.push([n,[...w.values()]])),{keys:[...a.values()],overrides:c}}e.mergeChanges=S;class O{constructor(a,l,c,w){this.change=a,this.f=l,this.g=c,this.h=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of a.keys)this.affectedKeys.add(n);for(const[,n]of a.overrides)for(const r of n)this.affectedKeys.add(r);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(a,l){const c=this.a+a,w=this.d.indexOf(c);if(w<0)return!1;const n=w+c.length;if(n>=this.d.length)return!1;const r=this.d.charCodeAt(n);if(r!==this.b&&r!==this.c)return!1;if(l){const f=this.previousConfiguration?this.previousConfiguration.getValue(a,l,this.f?.workspace):void 0,A=this.g.getValue(a,l,this.h);return!R.equals(f,A)}return!0}}e.ConfigurationChangeEvent=O;function v(d,a){const{added:l,removed:c,updated:w}=t(a?.rawConfiguration,d?.rawConfiguration),n=[],r=d?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const A=f.filter(T=>!r.includes(T));for(const T of A)n.push([T,a.getKeysForOverrideIdentifier(T)])}if(d){const A=r.filter(T=>!f.includes(T));for(const T of A)n.push([T,d.getKeysForOverrideIdentifier(T)])}if(a&&d){for(const A of r)if(f.includes(A)){const T=t({contents:d.getOverrideValue(void 0,A)||{},keys:d.getKeysForOverrideIdentifier(A)},{contents:a.getOverrideValue(void 0,A)||{},keys:a.getKeysForOverrideIdentifier(A)});n.push([A,[...T.added,...T.removed,...T.updated]])}}return{added:l,removed:c,updated:w,overrides:n}}function t(d,a){const l=d?a?d.keys.filter(n=>a.keys.indexOf(n)===-1):[...d.keys]:[],c=a?d?a.keys.filter(n=>d.keys.indexOf(n)===-1):[...a.keys]:[],w=[];if(d&&a){for(const n of a.keys)if(d.keys.indexOf(n)!==-1){const r=(0,M.getConfigurationValue)(a.contents,n),f=(0,M.getConfigurationValue)(d.contents,n);R.equals(r,f)||w.push(n)}}return{added:l,removed:c,updated:w}}}),define(ke[94],Te([1,0,11,3]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var I;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class F extends i.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof F&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof F&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof F&&y._code===I.NoResolverFound}static isHandled(y){return y instanceof F&&y.isHandled}constructor(y,k=I.Unknown,M){super(y),this._message=y,this._code=k,this._detail=M,this.isHandled=k===I.NotAvailable&&M===!0,Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F;function E(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=E}),define(ke[50],Te([1,0,15]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=P;function I(k){if(!k)return;const M=k.indexOf("+");return M<0?k:k.substr(0,M)}e.getRemoteName=I;function F(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=F;function E(k){const{host:M,port:D}=y(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:D}}e.parseAuthorityWithPort=E;function R(k,M){let{host:D,port:h}=y(k);return typeof h>"u"&&(h=M),{host:D,port:h}}e.parseAuthorityWithOptionalPort=R;function y(k){const M=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const h=k.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:k,port:void 0}}}),define(ke[26],Te([1,0,10,3,50]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const s=typeof m=="string"?m:m.value,u=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(s,u)}return m.c===o.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=y;function k(b){return M(b)}e.isApplicationScopedExtension=k;function M(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=M;function D(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function h(b,m){if(m){const o=`onResolveRemoteAuthority:${(0,I.getRemoteName)(m)}`;return!!b.activationEvents?.includes(o)}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[168],Te([1,0,20,51,2,34]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,M,D,h,b,m,o,s,u,p){const S=Object.create(null);S["common.machineId"]=o,S.sessionID=(0,F.generateUuid)()+Date.now(),S.commitHash=b,S.version=m,S["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,i.PlatformToString)(i.platform),S["common.nodePlatform"]=P.platform,S["common.nodeArch"]=h,S["common.product"]=p||"desktop",s&&(S["common.msftInternal"]=s);let O=0;const v=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>O++,enumerable:!0}}),i.isLinuxSnap&&(S["common.snap"]="true");const t=E(D);t&&(S["common.platformDetail"]=t);try{const d=await k.readFile(I.URI.file(u));S["common.source"]=d.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=R;function y(k){const M=P.env.USERDNSDOMAIN;if(!M)return!1;const D=M.toLowerCase();return k.some(h=>D===h)}e.verifyMicrosoftInternalDomain=y}),define(ke[169],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(P=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ke[52],Te([1,0,22,9,4,41,50,168,169]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(n){this.value=n}}e.TelemetryTrustedValue=k;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,r){return Promise.resolve(void 0)}publicLog2(n,r){return this.publicLog(n,r)}publicLogError(n,r){return Promise.resolve(void 0)}publicLogError2(n,r){return this.publicLogError(n,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class D{async publicLog(n,r,f){}async publicLogError(n,r,f){}}e.NullEndpointTelemetryService=D,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(w,n){return I.Event.debounce(n.onDidChangeConfiguration,(f,A)=>{const T=f?new Set([...f.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:T}},1e3,!0)(f=>{f.source!==7&&w.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(f.source),configurationKeys:O(f.affectedKeys)})})}e.configurationTelemetry=h;function b(w,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!w.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(w,n){return!(n.isBuilt||n.disableTelemetry||w.enableTelemetry&&w.aiConfig?.ariaKey)}e.isLoggingOnly=m;function o(w){const n=w.getValue(y.TELEMETRY_SETTING_ID),r=w.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(w.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=o;function s(w){const n={},r={},f={};S(w,f);for(let A in f){A=A.length>150?A.substr(A.length-149):A;const T=f[A];typeof T=="number"?r[A]=T:typeof T=="boolean"?r[A]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${T.length}`),n[A]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(n[A]=T)}return{properties:n,measurements:r}}e.validateTelemetryData=s;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(w){if(!w)return"none";const n=(0,E.getRemoteName)(w);return u.has(n)?n:"other"}e.cleanRemoteAuthority=p;function S(w,n,r=0,f){if(!!w)for(const A of Object.getOwnPropertyNames(w)){const T=w[A],H=f?f+A:A;Array.isArray(T)?n[H]=(0,i.safeStringify)(T):T instanceof Date?n[H]=T.toISOString():(0,P.isObject)(T)?r<2?S(T,n,r+1,H+"."):n[H]=(0,i.safeStringify)(T):n[H]=T}}function O(w){if(!w)return[];const n=[];return v(n,"",w),n}function v(w,n,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(f=>v(w,n?`${n}.${f}`:f,r[f])):w.push(n)}function t(w,n){const r=w.msftInternalDomains||[],f=n.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(r)||f}e.isInternalTelemetry=t;function d(w){return[w.appRoot,w.extensionsPath,w.userHome.fsPath,w.tmpDir.fsPath,w.userDataPath]}e.getPiiPathsFromEnvironment=d;function a(w,n){if(!w||!w.includes("/")&&!w.includes("\\"))return w;let r=w;const f=[];for(const Q of n)for(;;){const Z=Q.exec(w);if(!Z)break;f.push([Z.index,Q.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let H=0;for(r="";;){const Q=T.exec(w);if(!Q)break;const Z=f.some(([_,j])=>Q.index<j&&_<T.lastIndex);!A.test(Q[0])&&!Z&&(r+=w.substring(H,Q.index)+"<REDACTED: user-file-path>",H=T.lastIndex)}return H<w.length&&(r+=w.substr(H)),r}function l(w){if(!w)return w;const n=w.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of r)if(f.regex.test(n))return`<REDACTED: ${f.label}>`;return w}function c(w,n){return(0,i.cloneAndChange)(w,r=>{if(r instanceof k)return r.value;if(typeof r=="string"){let f=r.replaceAll("%20"," ");f=a(f,n);for(const A of n)f=f.replace(A,"");return f=l(f),f}})}e.cleanData=c}),define(ke[170],Te([1,0,10,90,26,20,2,11,51,52]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function M(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,i.compareIgnoreCase)(a.id,l.id)===0}e.areSameExtensions=M;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(l){const c=l.manifest?l.manifest.version:l.version,w=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new h(l.identifier,c,w)}static parse(l){const c=D.exec(l);return c&&c[1]&&c[2]?new h({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,w="undefined"){this.version=c,this.targetPlatform=w,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof h?M(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=h;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const l=b.exec(a);return l&&l[1]?[s(l[1]),l[2]]:[s(a),void 0]}e.getIdAndVersion=m;function o(a,l){return`${a}.${l}`}e.getExtensionId=o;function s(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function u(a,l){return s(o(a,l))}e.getGalleryExtensionId=u;function p(a,l){const c=[],w=n=>{for(const r of c)if(r.some(f=>M(l(f),l(n))))return r;return null};for(const n of a){const r=w(n);r?r.push(n):c.push([n])}return c}e.groupByExtension=p;function S(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function O(a){return{id:new k.TelemetryTrustedValue(a.identifier.id),name:new k.TelemetryTrustedValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=O,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function v(a,l){const c=[],w=l.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const n=w.shift();if(n&&c.every(r=>!M(r.identifier,{id:n}))){const r=a.filter(f=>M(f.identifier,{id:n}));r.length===1&&(c.push(r[0]),w.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=v;async function t(a,l){if(!F.isLinux)return!1;let c;try{c=(await a.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(a,l){const c=await t(a,l),w=(0,P.getTargetPlatform)(c?"alpine":F.platform,y.arch);return l.debug("ComputeTargetPlatform:",w),w}e.computeTargetPlatform=d}),define(ke[171],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=i;function P(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=P;function I(E){return Array.from(E.entries()).map(R=>[R[0],i(R[1].map)])}e.serializeEnvironmentVariableCollections=I;function F(E){return new Map(E.map(R=>[R[0],{map:P(R[1])}]))}e.deserializeEnvironmentVariableCollections=F}),define(ke[172],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,F,E=5){const R=F(y=>{const k=typeof y=="string"?y:y.data;let M=this.a.get(I);if(M){M.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(I),E);M={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),R.dispose()}},this.a.set(I,M)});return R}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const F=this.a.get(I);F&&(this.a.delete(I),this.b(I,F.data.join("")))}}e.TerminalDataBufferer=i}),define(ke[173],Te([1,0,17,84,38,4,9,2,137,69,30]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(O){function v(t,d){let a=t.defaults;for(;I.ThemeIcon.isThemeIcon(a);){const l=m.getIcon(a.id);if(!l)return;a=l.defaults}return a}O.getDefinition=v})(D=e.IconContribution||(e.IconContribution={}));var h;(function(O){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(a=>({format:a.format,location:a.location.toString()}))}}O.toJSONObject=v;function t(d){const a=l=>(0,E.isString)(l)?l:void 0;if(d&&Array.isArray(d.src)&&d.src.every(l=>(0,E.isString)(l.format)&&(0,E.isString)(l.location)))return{weight:a(d.weight),style:a(d.style),src:d.src.map(l=>({format:l.format,location:R.URI.parse(l.location)}))}}O.fromJSONObject=t})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new F.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,t,d,a){const l=this.b[v];if(l){if(d&&!l.description){l.description=d,this.d.properties[v].markdownDescription=`${d} $(${v})`;const n=this.e.enum.indexOf(v);n!==-1&&(this.e.enumDescriptions[n]=d),this.a.fire()}return l}const c={id:v,description:d,defaults:t,deprecationMessage:a};this.b[v]=c;const w={$ref:"#/definitions/icons"};return a&&(w.deprecationMessage=a),d&&(w.markdownDescription=`${d}: $(${v})`),this.d.properties[v]=w,this.e.enum.push(v),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const t=this.e.enum.indexOf(v);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,t){const d=this.f[v];return d||(this.f[v]=t,this.a.fire(),t)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(l,c)=>l.id.localeCompare(c.id),t=l=>{for(;I.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(l=>this.b[l]);for(const l of a.filter(c=>!!c.description).sort(v))d.push(`|<i class="${t(l)}"></i>|${l.id}|${I.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const l of a.filter(c=>!I.ThemeIcon.isThemeIcon(c.defaults)).sort(v))d.push(`|<i class="${t(l)}"></i>|${l.id}|`);return d.join(`
`)}}const m=new b;M.Registry.add(e.Extensions.IconContribution,m);function o(O,v,t,d){return m.registerIcon(O,v,t,d)}e.registerIcon=o;function s(){return m}e.getIconRegistry=s;function u(){const O=(0,P.getCodiconFontCharacters)();for(const v in O){const t="\\"+O[v].toString(16);m.registerIcon(v,{fontCharacter:t})}}u(),e.iconsSchemaId="vscode://schemas/icons";const p=M.Registry.as(k.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,m.getIconSchema());const S=new i.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{S.isScheduled()||S.schedule()}),e.widgetClose=o("widget-close",P.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",P.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",P.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=I.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=I.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(ke[174],Te([1,0,4,41,3,12]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var E;(function(o){o.Http="http",o.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=D;function h(o,s,u,p){if(u===1)return!1;if(u===2&&D(s)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(S?.length===4&&parseInt(S[1])>=18)return!1}return o<1024}e.isPortPrivileged=h;class b{constructor(s,u,p){this.remoteAddress=s,this.localAddress=u,this.b=p,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let m=class{constructor(s,u){this.i=s,this.j=u,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],u=Array.from(this.d.values());for(const p of u){const S=Array.from(p.values());for(const O of S){const v=await O.value;v&&s.push(v)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:u}of s.values())await u.then(p=>p?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,u,p,S,O){this.o(s,u,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:u,localAddress:p,privacy:S,protocol:O,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,u){(D(s)||M(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const p=this.q(s,u);if(p)return++p.refcount,p.value}openTunnel(s,u,p,S,O,v=!1,t,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${O}.`),!s)return;if(u||(u="localhost"),S||(S=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.r(s,u,p,S,O,v,t,d);return a?a.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const u=this.d.get(s.tunnelRemoteHost);if(u){const p=u.get(s.tunnelRemotePort);p&&(p.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,p))}}}}async n(s,u,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${u}.`);const S=p.value.then(async O=>{O&&(await O.dispose(!0),this.b.fire({host:O.tunnelRemoteHost,port:O.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(u),S}}async closeTunnel(s,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${u} `);const p=this.d.get(s);if(p&&p.has(u)){const S=p.get(u);S.refcount=0,await this.n(s,u,S)}}o(s,u,p){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(u,{refcount:1,value:p})}async p(s,u){const p=this.d.get(s);p&&(await p.get(u)||p.delete(u),p.size===0&&this.d.delete(s))}q(s,u){const p=[s];M(s)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):D(s)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const S=p.map(O=>this.d.get(O));for(const O of S){const v=O?.get(u);if(v)return v}}canTunnel(s){return!!k(s)}s(s,u,p,S,O,v,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${S}.`);const d=p;this.h.add(d);const a=S===void 0?p:S,l={elevationRequired:O?this.isPortPrivileged(a):!1},c={remoteAddress:{host:u,port:p},localAddressPort:S,privacy:v,public:v?v!==R.Private:void 0,protocol:t},w=s.forwardPort(c,l);return w?(this.o(u,p,w),w.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),w}};m=qe([Ve(0,F.ILogService),Ve(1,P.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ke[175],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var P;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(P=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ke[176],Te([1,0,15]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=P;function I(y){if(y.folders.length)return y.folders.every(k=>P(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&P(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function F(y){return I(y)?.scheme}e.getVirtualWorkspaceScheme=F;function E(y){return I(y)?.authority}e.getVirtualWorkspaceAuthority=E;function R(y){return I(y)!==void 0}e.isVirtualWorkspace=R}),define(ke[53],Te([1,0,138,19,48,24,2,3,15]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(l){const c=l;return typeof c?.id=="string"&&E.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=k;function M(l){return typeof l?.id=="string"&&!k(l)&&!h(l)}e.isEmptyWorkspaceIdentifier=M,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,P.basename)(l)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const w=l;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}e.toWorkspaceIdentifier=D;function h(l){const c=l;return typeof c?.id=="string"&&E.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=h;function b(l){const c=l;if(c?.uri)return{id:c.id,uri:E.URI.revive(c.uri)};const w=l;if(w?.configPath)return{id:w.id,configPath:E.URI.revive(w.configPath)};if(l?.id)return{id:l.id}}e.reviveIdentifier=b;var m;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function o(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=o;function s(l){const c=l;return!!(c&&typeof c=="object"&&E.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=s;class u{constructor(c,w,n,r,f){this.h=c,this.j=n,this.k=r,this.l=f,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=w}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class p{constructor(c,w){this.raw=w,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,F.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(l){return new p({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function O(l,c){return F.extUriBiasedIgnorePathCase.isEqualOrParent(l,c.untitledWorkspacesHome)}e.isUntitledWorkspace=O;function v(l){let c;return E.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function d(l,c){return!O(l,c)&&!v(l)}e.isSavedWorkspace=d;function a(l){return(typeof l=="string"?(0,P.extname)(l):(0,F.extname)(l))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ke[54],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const F=this.c++;return this.b.set(F,I),this.e(),F}get(I,F){return this.b.has(I)?this.b.get(I)[F]:void 0}delete(I){this.b.delete(I),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}i.a=!1,e.Cache=i}),define(ke[36],Te([1,0,15,24,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new P.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ke[27],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(ke[177],Te([1,0,12,163,27]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends P.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:y.logName}))}};F=qe([Ve(0,i.ILoggerService),Ve(1,I.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(ke[178],Te([1,0,17]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(E,R,y){this.h=new Map,this.a=E,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const D of k.values())D.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,E])=>E!==void 0).map(([E])=>E)}get whenReady(){return this.d}get(E,R){let y=this.f[E];return typeof y>"u"&&(y=R),y}update(E,R){this.f[E]=R;const y=this.h.get(E);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this.h.set(E,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=P;class I extends P{setKeysForSync(E){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},E)}constructor(E,R){super(E.identifier.value,!0,R),this.j=E}}e.ExtensionGlobalMemento=I}),define(ke[179],Te([1,0,4,2]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(E){this.c=E,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(E,R,y,k){const D=this.c.getNotebookDocument(P.URI.revive(E)).acceptModelChanged(R.value,y,k);this.b.fire(D)}$acceptDirtyStateChanged(E,R){this.c.getNotebookDocument(P.URI.revive(E)).acceptDirty(R)}$acceptModelSaved(E){const R=this.c.getNotebookDocument(P.URI.revive(E));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(ke[18],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class P{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=P});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[180],Te([1,0,26,4]),function(ne,e,i,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(R,y){I.set(this,void 0),this.b=new P.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(R.identifier),Je(this,I,y,"f"),Le(this,I,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Le(this,I,"f").get(this.a,R)}store(R,y){return Le(this,I,"f").store(this.a,R,y)}delete(R){return Le(this,I,"f").delete(this.a,R)}}e.ExtensionSecrets=F,I=new WeakMap}),define(ke[70],Te([1,0,3,174,4,18]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var E;(function(y){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:D.protocol}}y.fromApiTunnel=k;function M(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==P.TunnelPrivacyId.ConstantPrivate&&D.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}y.fromServiceTunnel=M})(E=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,M){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,M){return{dispose:()=>{}}}async $providePortAttributes(k,M,D,h,b){return[]}async $forwardPort(k,M){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,F.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(ke[55],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class P{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=P}),define(ke[181],Te([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function I(R,y){if(y.serializeBuffersForPostMessage){const k=new P,M=(b,m)=>{if(m instanceof ArrayBuffer){const o=k.add(m);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(m)){const o=F(m);if(o){const s=k.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:s,view:{type:o,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},D=JSON.stringify(R,M),h=k.buffers.map(b=>{const m=new Uint8Array(b);return i.VSBuffer.wrap(m)});return{message:D,buffers:h}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=I;function F(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function E(R,y){const k=y.map(h=>{const b=new ArrayBuffer(h.byteLength);return new Uint8Array(b).set(h.buffer),b}),M=y.length?(h,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:o}=m,s=k[o];if(m.view)switch(m.view.type){case 1:return new Int8Array(s,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(R,M),arrayBuffers:k}}e.deserializeWebviewMessage=E}),define(ke[95],Te([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function o(q){const x=q;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=o;function s(q,x,X){for(const de of X.visibleEditorPanes)if(de.group.id===x&&q.matches(de.input))return de.getViewState()}e.findViewStateForEditor=s;function u(q){if(r(q))return!1;const x=q;return I.URI.isUri(x?.resource)}e.isResourceEditorInput=u;function p(q){if(r(q))return!1;const x=q;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=p;function S(q){if(r(q)||p(q))return!1;const x=q;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function O(q){if(r(q))return!1;const x=q;return x?x.resource===void 0||x.resource.scheme===k.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=O;const v=/Untitled-\d+/;function t(q){return q.scheme===k.Schemas.untitled&&q.path.length>1&&!v.test(q.path)}e.isUntitledWithAssociatedResource=t;function d(q){if(r(q))return!1;const x=q;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=d;var a;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var l;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(x,X){let de=this.a.get(x);return de||(de={source:x,label:X},this.a.set(x,de)),de.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.SaveSourceRegistry=new c;var w;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends F.Disposable{}e.AbstractEditorInput=n;function r(q){return q instanceof n}e.isEditorInput=r;function f(q){const x=q;return I.URI.isUri(x?.preferredResource)}function A(q){const x=q;return r(x?.primary)&&r(x?.secondary)}e.isSideBySideEditorInput=A;function T(q){const x=q;return r(x?.modified)&&r(x?.original)}e.isDiffEditorInput=T;function H(q,x,X,de,ye){return we(de,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Ne={...X,limits:{size:Number.MAX_VALUE}};q.openEditor(x,Ne)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=H;function Q(q){return r(q?.editor)}e.isEditorInputWithOptions=Q;function Z(q){const x=q;return Q(q)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Z;function _(q){const x=q;return typeof x?.groupId=="number"&&r(x.editor)}e.isEditorIdentifier=_;var j;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var L;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LOCKED=2]="GROUP_LOCKED",q[q.EDITOR_OPEN=3]="EDITOR_OPEN",q[q.EDITOR_CLOSE=4]="EDITOR_CLOSE",q[q.EDITOR_MOVE=5]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=7]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=9]="EDITOR_PIN",q[q.EDITOR_STICKY=10]="EDITOR_STICKY",q[q.EDITOR_DIRTY=11]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var g;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(g=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(x,X){if(!x)return;if(d(x))return e.EditorResourceAccessor.getOriginalUri(x.result,X);if(X?.supportSideBySide){const{primary:ye,secondary:Ne}=this.a(x);if(ye&&Ne){if(X?.supportSideBySide===g.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===g.ANY)return this.getOriginalUri(ye,{filterByScheme:X.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:X.filterByScheme});x=X.supportSideBySide===g.PRIMARY?ye:Ne}}if(p(x)||S(x)||d(x))return;const de=f(x)?x.preferredResource:x.resource;return!de||!X||!X.filterByScheme?de:this.b(de,X.filterByScheme)}a(x){return A(x)||S(x)?{primary:x.primary,secondary:x.secondary}:T(x)||p(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,X){if(!x)return;if(d(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,X);if(X?.supportSideBySide){const{primary:ye,secondary:Ne}=this.a(x);if(ye&&Ne){if(X?.supportSideBySide===g.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===g.ANY)return this.getCanonicalUri(ye,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:X.filterByScheme});x=X.supportSideBySide===g.PRIMARY?ye:Ne}}if(p(x)||S(x)||d(x))return;const de=x.resource;return!de||!X||!X.filterByScheme?de:this.b(de,X.filterByScheme)}b(x,X){if(Array.isArray(X)){if(X.some(de=>x.scheme===de))return x}else if(X===x.scheme)return x}}e.EditorResourceAccessor=new N;var B;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class J{constructor(){this.c=new Map,this.d=new Map}start(x){const X=this.a=x.get(E.IInstantiationService);for(const[de,ye]of this.c)this.e(de,ye,X);this.c.clear()}e(x,X,de){const ye=de.createInstance(X);this.d.set(x,ye)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,P.assertIsDefined)(this.b)}registerEditorSerializer(x,X){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,X,this.a):this.c.set(x,X),(0,F.toDisposable)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new J);async function me(q,x,X){return!q||!q.length?[]:await Promise.all(q.map(async de=>{const ye=I.URI.revive(de.fileUri);if(!ye){X.info("Cannot resolve the path because it is not valid.",de);return}if(!await x.canHandleResource(ye)){X.info("Cannot resolve the path because it cannot be handled",de);return}let ze=de.exists,Pe=de.type;if(typeof ze!="boolean"||typeof Pe!="number")try{Pe=(await x.stat(ye)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ze=!0}catch(Se){X.error(Se),ze=!1}if(!ze&&de.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",de);return}if(Pe===y.FileType.Directory){X.info("Cannot resolve the path because it is a directory",de);return}const Ie={...de.options,pinned:!0};return ze?{resource:ye,options:Ie}:{resource:ye,options:Ie,forceUntitled:!0}}))}e.pathsToEditors=me;var te;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(te=e.EditorsOrder||(e.EditorsOrder={}));function oe(q){const x=q;if(!x)return!1;const X=x;if(X.modified)return oe(X.modified);const de=x;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=oe;function ce(q){return(0,M.isErrorWithActions)(q)}e.isEditorOpenError=ce;function we(q,x,X){const de=(0,M.createErrorWithActions)(q,x);return de.forceMessage=X?.forceMessage,de.forceSeverity=X?.forceSeverity,de.allowDialog=X?.allowDialog,de}e.createEditorOpenError=we}),define(ke[182],Te([1,0,4,148,3,6,28,30,16,63,22,84,173]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",D.Codicon.window,(0,P.localize)(0,null));var b;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var m;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function o(a){switch(a){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=o;class s extends F.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new i.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(l,c,w){const n=this.get(l.id);if(n)return n;const r=l;return r.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:r.openCommandActionDescriptor??{id:r.id},(0,E.getOrSet)(this.g,c,[]).push(r),w?.isDefault&&this.h.push(r),this.c.fire({viewContainer:r,viewContainerLocation:c}),r}deregisterViewContainer(l){for(const c of this.g.keys()){const w=this.g.get(c),n=w?.indexOf(l);if(n!==-1){w?.splice(n,1),w.length===0&&this.g.delete(c),this.f.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(w=>w?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(c=>this.getViewContainerLocation(c)===l)}}R.Registry.add(b.ViewContainersRegistry,new s);var u;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function p(a,l){const c=a.group??u.More,w=l.group??u.More;return c!==w?c.localeCompare(w):(a.order??5)-(l.order??5)}class S extends F.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new i.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new i.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:w})=>this.l(c,w)),this.c.fire(l)}deregisterViews(l,c){const w=this.m(l,c);w.length&&this.f.fire({views:w,viewContainer:c})}moveViews(l,c){for(const w of this.j.keys())if(w!==c){const n=this.m(l,w);n.length&&(this.l(n,c),this.g.fire({views:n,from:w,to:c}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const c of this.i){const w=(this.j.get(c)||[]).filter(n=>n.id===l)[0];if(w)return w}return null}getViewContainer(l){for(const c of this.i)if((this.j.get(c)||[]).filter(n=>n.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this.k.add(l,c),this.h.fire(l),(0,F.toDisposable)(()=>{this.k.delete(l,c),this.h.fire(l)})}registerViewWelcomeContent2(l,c){const w=new Map;for(const[n,r]of c)this.k.add(l,r),w.set(n,(0,F.toDisposable)(()=>{this.k.delete(l,r),this.h.fire(l)}));return this.h.fire(l),w}getViewWelcomeContent(l){const c=[];return this.k.forEach(l,w=>c.push(w)),c.sort(p)}l(l,c){let w=this.j.get(c);w||(w=[],this.j.set(c,w),this.i.push(c));for(const n of l){if(this.getView(n.id)!==null)throw new Error((0,P.localize)(1,null,n.id));w.push(n)}}m(l,c){const w=this.j.get(c);if(!w)return[];const n=[],r=[];for(const f of w)l.includes(f)?n.push(f):r.push(f);return n.length&&(r.length?this.j.set(c,r):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),n}}R.Registry.add(b.ViewsRegistry,new S),e.IViewsService=(0,I.createDecorator)("viewsService"),e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var O;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(O=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,c){this.c=!1,this.d=!1,(0,M.mixin)(this,l),this.d=!!c,this.resolve=async w=>{if(c&&!this.c){const n=await c(w);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class d extends Error{constructor(l){super((0,P.localize)(2,null,l))}}e.NoTreeViewError=d}),define(ke[183],Te([1,0,4,17,149]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,k,M){const D={command:R};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.s("request",D),typeof M=="number"){const h=setTimeout(()=>{clearTimeout(h);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const m={type:"response",seq:0,request_seq:D.seq,success:!1,command:R,message:(0,I.localize)(0,null,M,R)};b(m)}},M)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,P.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,k=this.f.get(y.request_seq);k&&(this.f.delete(y.request_seq),k(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,k)=>R.set(k,y)),await(0,P.timeout)(500),R.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=F}),define(ke[184],Te([1,0,150,42,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const F=h=>i.localize(51,null,h);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var E;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(E=e.State||(e.State={}));function R(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var D;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ke[185],Te([1,0,10,2,19,22,15,44,21,16]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const M=/{([^}]+)}/g;function D(n,r,f){return n.replace(M,function(A,T){return r&&T.length>0&&T[0]!=="_"?A:f&&f.hasOwnProperty(T)?f[T]:A})}e.formatPII=D;function h(n){const r={};for(const f of Object.keys(n))f.startsWith("!")||(r[f]=n[f]);return r}e.filterExceptionsFromTelemetry=h;function b(n){return n.configuration.request==="attach"&&!m(n)&&(!n.parentSession||b(n.parentSession))}e.isSessionAttach=b;function m(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(r,"extensionhost")||(0,i.equalsIgnoreCase)(r,"pwa-extensionhost")?n:n.parentSession?m(n.parentSession):void 0}e.getExtensionHostDebugSession=m;function o(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=o;function s(n,r,f){let A,T=0;const H=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Q=null;for(;Q=H.exec(n);){const Z=Q.index+1,_=Z+Q[0].length;if(Z<=r&&_>=f){A=Q[0],T=Z;break}}if(A){const Z=/\w+/g;let _=null;for(;(_=Z.exec(A))&&!(_.index+1+T+_[0].length>=f););_&&(A=A.substring(0,Z.lastIndex))}return A?{start:T,end:T+A.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=s;async function u(n,r,f,A){if(n.evaluatableExpressionProvider.has(r)){const T=n.evaluatableExpressionProvider.ordered(r),H=(0,k.coalesce)(await Promise.all(T.map(async Q=>{try{return await Q.provideEvaluatableExpression(r,f,A??y.CancellationToken.None)}catch{return}})));if(H.length>0){let Q=H[0].expression;const Z=H[0].range;return Q||(Q=r.getLineContent(f.lineNumber).substring(Z.startColumn-1,Z.endColumn-1)),{range:Z,matchingExpression:Q}}}else{const T=r.getLineContent(f.lineNumber),{start:H,end:Q}=s(T,f.column,f.column),Z=T.substring(H-1,Q);return{matchingExpression:Z,range:new R.Range(f.lineNumber,H,f.lineNumber,H+Z.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function S(n){return!!(n&&n.match(p))}e.isUri=S;function O(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(S(n.path))return P.URI.parse(n.path);if((0,I.isAbsolute)(n.path))return P.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const r=P.URI.revive(n.path);if(r)return r.scheme===E.Schemas.file?r.fsPath:r.toString()}return n.path}function t(n,r){const f=r?O:v,A=(0,F.deepClone)(n);return a(A,(T,H)=>{T&&H&&(H.path=f(H))}),A}e.convertToDAPaths=t;function d(n,r){const f=r?O:v,A=(0,F.deepClone)(n);return a(A,(T,H)=>{!T&&H&&(H.path=f(H))}),A}e.convertToVSCPaths=d;function a(n,r){switch(n.type){case"event":{const f=n;switch(f.event){case"output":r(!1,f.body.source);break;case"loadedSource":r(!1,f.body.source);break;case"breakpoint":r(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=n;switch(f.command){case"setBreakpoints":r(!0,f.arguments.source);break;case"breakpointLocations":r(!0,f.arguments.source);break;case"source":r(!0,f.arguments.source);break;case"gotoTargets":r(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(A=>r(!1,A));break;default:break}break}case"response":{const f=n;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(A=>r(!1,A.source));break;case"loadedSources":f.body.sources.forEach(A=>r(!1,A));break;case"scopes":f.body.scopes.forEach(A=>r(!1,A.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(A=>r(!1,A.source));break;case"setBreakpoints":f.body.breakpoints.forEach(A=>r(!1,A.source));break;case"disassemble":f.body?.instructions.forEach(T=>r(!1,T.location));break;default:break}break}}}function l(n){return n.filter(r=>!r.presentation?.hidden).sort((r,f)=>r.presentation?f.presentation?r.presentation.group?f.presentation.group?r.presentation.group!==f.presentation.group?r.presentation.group.localeCompare(f.presentation.group):c(r.presentation.order,f.presentation.order):-1:f.presentation.group?1:c(r.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=l;function c(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}async function w(n,r){const f=n.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(f!=="none"&&(await r.saveAll(),f==="allEditorsInActiveGroup")){const A=r.activeEditorPane;A&&A.input.resource?.scheme===E.Schemas.untitled&&await r.save({editor:A.input,groupId:A.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=w}),define(ke[71],Te([1,0,23,35,186,65,15,19,20,42]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(g){g[g.Unconfirmed=1]="Unconfirmed",g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeCellLanguage=5]="ChangeCellLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var p;(function(g){g.scheme=E.Schemas.vscodeNotebookCell;const N=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${N.join("")}]+`),J=7;function me(x,X){const de=X.toString(J),Ne=`${de.length<N.length?N[de.length-1]:"z"}${de}s${(0,i.encodeBase64)(i.VSBuffer.fromString(x.scheme),!0,!0)}`;return x.with({scheme:g.scheme,fragment:Ne})}g.generate=me;function te(x){if(x.scheme!==g.scheme)return;const X=x.fragment.indexOf("s");if(X<0)return;const de=parseInt(x.fragment.substring(0,X).replace(B,""),J),ye=(0,i.decodeBase64)(x.fragment.substring(X+1)).toString();if(!isNaN(de))return{handle:de,notebook:x.with({scheme:ye,fragment:null})}}g.parse=te;function oe(x,X){return x.with({scheme:E.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${x.scheme!==E.Schemas.file?x.scheme:""}`})}g.generateCellOutputUri=oe;function ce(x){if(x.scheme!==E.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!X)return;const de=X[1]&&X[1]!==""?X[1]:void 0,ye=X[2];return{outputId:de,notebook:x.with({scheme:ye||E.Schemas.file,fragment:null})}}g.parseCellOutputUri=ce;function we(x,X,de){return g.generate(x,X).with({scheme:de})}g.generateCellPropertyUri=we;function q(x,X){if(x.scheme===X)return g.parse(x.with({scheme:g.scheme}))}g.parseCellPropertyUri=q})(p=e.CellUri||(e.CellUri={}));const S=g=>y.isWindows?g.replace(/\//g,"\\"):g;class O{constructor(N=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.e=B,this.d=[...new Set(N)].map(J=>({pattern:J,matches:P.parse(S(J))}))}sort(N){const B=new Map(I.Iterable.map(N,me=>[me,S(me)]));let J=[];for(const{matches:me}of this.d)for(const[te,oe]of B)if(me(oe)){J.push(te),B.delete(te);break}return B.size&&(J=J.concat([...B.keys()].sort((me,te)=>this.e.indexOf(me)-this.e.indexOf(te)))),J}prioritize(N,B){const J=this.f(N);if(J===-1){this.d.unshift({pattern:N,matches:P.parse(S(N))});return}const me=new Set(B.map(oe=>this.f(oe,J)));me.delete(-1);const te=Array.from(me).sort();this.d.splice(J+1,0,...te.map(oe=>this.d[oe]));for(let oe=te.length-1;oe>=0;oe--)this.d.splice(te[oe],1)}toArray(){return this.d.map(N=>N.pattern)}f(N,B=this.d.length){const J=S(N);for(let me=0;me<B;me++)if(this.d[me].matches(J))return me;return-1}}e.MimeTypeDisplayOrder=O;function v(g,N,B,J=(me,te)=>me===te){const me=[];function te(we,q,x){if(q===0&&x.length===0)return;const X=me[me.length-1];X&&X.start+X.deleteCount===we?(X.deleteCount+=q,X.toInsert.push(...x)):me.push({start:we,deleteCount:q,toInsert:x})}let oe=0,ce=0;for(;;){if(oe===g.length){te(oe,0,N.slice(ce));break}if(ce===N.length){te(oe,g.length-oe,[]);break}const we=g[oe],q=N[ce];if(J(we,q)){oe+=1,ce+=1;continue}B(q)?(te(oe,1,[]),oe+=1):(te(oe,0,[q]),ce+=1)}return me}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(g){g.default="default",g.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(g){const N=g;return!!((typeof N.include=="string"||P.isRelativePattern(N.include))&&(typeof N.exclude=="string"||P.isRelativePattern(N.exclude)))}e.isDocumentExcludePattern=d;function a(g,N,B){if(Array.isArray(g.viewType)&&g.viewType.indexOf(N)>=0||g.viewType===N)return!0;if(g.filenamePattern){const J=d(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,me=d(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(P.match(J,(0,R.basename)(B.fsPath).toLowerCase()))return!(me&&P.match(me,(0,R.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var l;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(N){return`${c.d}${N}`}static parse(N){if(N.startsWith(c.d))return N.substring(c.d.length)}}c.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function w(g){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(g)}e.isTextStreamMime=w;const n=new TextDecoder;function r(g){const N=[];let B=!1;for(const J of g)(N.length===0||B)&&(N.push(J),B=!0);return H(N),L(i.VSBuffer.concat(N.map(J=>i.VSBuffer.wrap(J))))}e.compressOutputItemStreams=r;const f=`${String.fromCharCode(27)}[A`,A=f.split("").map(g=>g.charCodeAt(0)),T=10;function H(g){g.forEach((N,B)=>{if(B===0||N.length<f.length)return;const J=g[B-1],me=N.subarray(0,f.length);if(me[0]===A[0]&&me[1]===A[1]&&me[2]===A[2]){const te=J.lastIndexOf(T);if(te===-1)return;g[B-1]=J.subarray(0,te),g[B]=N.subarray(f.length)}})}function Q(g){let N=g;do g=N,N=g.replace(/[^\n]\x08/gm,"");while(N.length<g.length);return g}function Z(g){for(g=g.replace(/\r+\n/gm,`
`);g.search(/\r[^$]/g)>-1;){const N=g.match(/^(.*)\r+/m)[1];let B=g.match(/\r+(.*)$/m)[1];B=B+N.slice(B.length,N.length),g=g.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return g}const _="\b".charCodeAt(0),j="\r".charCodeAt(0);function L(g){return!g.buffer.includes(_)&&!g.buffer.includes(j)?g:i.VSBuffer.fromString(Z(Q(n.decode(g.buffer))))}}),define(ke[187],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(P=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(ke[45],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(F){F.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(E,R,y=E.parent){if(E._isRoot)return new I([R]);const k=[E.id];for(let M=y;M&&M.id!==R;M=M.parent)k.push(M.id);return k.push(R),new I(k.reverse())}static isRoot(E){return!E.includes("\0")}static root(E){const R=E.indexOf("\0");return R===-1?E:E.slice(0,R)}static fromString(E){return new I(E.split("\0"))}static join(E,R){return new I([...E.path,R])}static joinToString(E,R){return E.toString()+"\0"+R}static parentId(E){const R=E.lastIndexOf("\0");return R===-1?void 0:E.slice(0,R)}static localId(E){const R=E.lastIndexOf("\0");return R===-1?E:E.slice(R+1)}static compare(E,R){return E===R?0:R.startsWith(E+"\0")?2:E.startsWith(R+"\0")?3:1}constructor(E,R=E.length){if(this.path=E,this.d=R,E.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let E=1;E<=this.d;E++)yield new I(this.path,E)}*idsToRoot(){for(let E=this.d;E>0;E--)yield new I(this.path,E)}compare(E){if(typeof E=="string")return I.compare(this.toString(),E);for(let R=0;R<E.d&&R<this.d;R++)if(E.path[R]!==this.path[R])return 1;return E.d>this.d?2:E.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let E=1;E<this.d;E++)this.c+="\0",this.c+=this.path[E]}return this.c}}e.TestId=I}),define(ke[56],Te([1,0,2,44,45]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var F;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(F=e.TestResultState||(e.TestResultState={}));var E;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(E=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=n=>"runId"in n;e.isStartControllerTests=R;var y;(function(n){n.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),n.deserialize=r=>({range:P.Range.lift(r.range),uri:i.URI.revive(r.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var k;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var M;(function(n){n.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&y.serialize(r.location)}),n.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&y.deserialize(r.location)})})(M=e.ITestErrorMessage||(e.ITestErrorMessage={}));const D=(n,r)=>`${r?"s":"e"}${n}`;e.getMarkId=D;var h;(function(n){n.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&y.serialize(r.location)}),n.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&y.deserialize(r.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(n){n.serialize=r=>r.type===0?M.serialize(r):h.serialize(r),n.deserialize=r=>r.type===0?M.deserialize(r):h.deserialize(r)})(b=e.ITestMessage||(e.ITestMessage={}));var m;(function(n){n.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),n.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(b.serialize)}),n.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(b.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const o="\0",s=(n,r)=>n+o+r;e.namespaceTestTag=s;const u=n=>{const r=n.indexOf(o);return{ctrlId:n.slice(0,r),tagId:n.slice(r+1)}};e.denamespaceTestTag=u;var p;(function(n){n.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),n.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?i.URI.revive(r.uri):void 0,range:r.range?P.Range.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(p=e.ITestItem||(e.ITestItem={}));var S;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));var O;(function(n){n.serialize=r=>({expand:r.expand,item:p.serialize(r.item)}),n.deserialize=r=>({controllerId:I.TestId.root(r.item.extId),expand:r.expand,item:p.deserialize(r.item)})})(O=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(n){n.serialize=r=>{let f;return r.item&&(f={},r.item.label!==void 0&&(f.label=r.item.label),r.item.tags!==void 0&&(f.tags=r.item.tags),r.item.busy!==void 0&&(f.busy=r.item.busy),r.item.uri!==void 0&&(f.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(f.range=r.item.range?.toJSON()),r.item.description!==void 0&&(f.description=r.item.description),r.item.error!==void 0&&(f.error=r.item.error),r.item.sortText!==void 0&&(f.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:f}},n.deserialize=r=>{let f;return r.item&&(f={},r.item.label!==void 0&&(f.label=r.item.label),r.item.tags!==void 0&&(f.tags=r.item.tags),r.item.busy!==void 0&&(f.busy=r.item.busy),r.item.range!==void 0&&(f.range=r.item.range?P.Range.lift(r.item.range):null),r.item.description!==void 0&&(f.description=r.item.description),r.item.error!==void 0&&(f.error=r.item.error),r.item.sortText!==void 0&&(f.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:f}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(n,r)=>{r.expand!==void 0&&(n.expand=r.expand),r.item!==void 0&&(n.item=n.item?Object.assign(n.item,r.item):r.item)};e.applyTestItemUpdate=t;var d;(function(n){n.serializeWithoutMessages=r=>({...O.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(m.serializeWithoutMessages),retired:r.retired}),n.serialize=r=>({...O.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(m.serialize),retired:r.retired}),n.deserialize=r=>({...O.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(m.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var a;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(a=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(n){n.deserialize=r=>r.op===0?{op:r.op,item:O.deserialize(r.item)}:r.op===1?{op:r.op,item:v.deserialize(r.item)}:r.op===2?{op:r.op,uri:i.URI.revive(r.uri),docv:r.docv}:r,n.serialize=r=>r.op===0?{op:r.op,item:O.serialize(r.item)}:r.op===1?{op:r.op,item:v.serialize(r.item)}:r})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class w{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(r){const f=this.o();for(const A of r)switch(A.op){case 0:this.j(O.deserialize(A.item),f);break;case 1:this.k(v.deserialize(A.item),f);break;case 3:this.l(A.itemId,f);break;case 5:this.m(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}f.complete?.()}j(r,f){const A=I.TestId.parentId(r.item.extId)?.toString();let T;if(!A)T=this.p(r),this.f.add(T),this.d.set(r.item.extId,T);else if(this.d.has(A)){const H=this.d.get(A);H.children.add(r.item.extId),T=this.p(r,H),this.d.set(r.item.extId,T)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return f.add?.(T),r.expand===2&&this.g++,T}k(r,f){const A=this.d.get(r.extId);if(!!A)return r.expand!==void 0&&(A.expand===2&&this.g--,r.expand===2&&this.g++),(0,e.applyTestItemUpdate)(A,r),f.update?.(A),A}l(r,f){const A=this.d.get(r);if(!A)return;const T=I.TestId.parentId(A.item.extId)?.toString();T?this.d.get(T).children.delete(A.item.extId):this.f.delete(A);const H=[[r]];for(;H.length;)for(const Q of H.pop()){const Z=this.d.get(Q);Z&&(H.push(Z.children),this.d.delete(Q),f.remove?.(Z,Z!==A),Z.expand===2&&this.g--)}}m(r){}updatePendingRoots(r){this.h+=r}o(){return{}}}e.AbstractIncrementalTestCollection=w}),define(ke[72],Te([1,0,17,4,6,49,56,45]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(p,S)=>p===S,D=Object.entries({range:(p,S)=>p===S?!0:!p||!S?!1:p.equalsRange(S),busy:k,label:k,description:k,error:k,sortText:k,tags:(p,S)=>!(p.length!==S.length||p.some(O=>!S.includes(O)))}),h=(p,S)=>{let O;for(const[v,t]of D)t(p[v],S[v])||(O?O[v]=S[v]:O={[v]:S[v]});return O};class b extends I.Disposable{get root(){return this.m.root}constructor(S){super(),this.m=S,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new P.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(S){this.h=S;for(const O of this.tree.values())this.G(O)}get resolveHandler(){return this.h}collectDiff(){const S=this.k;return this.k=[],S}pushDiff(S){switch(S.op){case 2:{for(const O of this.k)if(O.op===2&&O.uri===S.uri){O.docv=S.docv;return}break}case 1:{const O=this.k[this.k.length-1];if(O){if(O.op===1&&O.item.extId===S.item.extId){(0,E.applyTestItemUpdate)(O.item,S.item);return}if(O.op===0&&O.item.item.extId===S.item.extId){(0,E.applyTestItemUpdate)(O.item,S.item);return}}break}}this.k.push(S),this.f.isScheduled()||this.f.schedule()}expand(S,O){const v=this.tree.get(S);if(!!v){if((v.expandLevels===void 0||O>v.expandLevels)&&(v.expandLevels=O),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,O-1):t.wait().then(()=>this.H(v,O-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,O-1)):this.H(v,O-1)}}dispose(){for(const S of this.tree.values())this.m.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(S,O){switch(O.op){case 3:this.L(R.TestId.joinToString(S.fullId,O.id));break;case 0:this.u(O.item,S);break;case 5:for(const v of O.ops)this.p(S,v);break;case 1:this.w(O.new,O.old,S.fullId.toString());break;case 2:this.G(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:O.update}});break;case 6:this.s(S.actual.uri);break;default:(0,F.assertNever)(O)}}s(S){S&&this.pushDiff({op:2,uri:S,docv:this.m.getDocumentVersion(S)})}u(S,O){const v=R.TestId.fromExtHostTestItem(S,this.root.id,O?.actual),t=this.m.getApiFor(S);t.parent&&t.parent!==O?.actual&&this.m.getChildren(t.parent).delete(S.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:S,expandLevels:O?.expandLevels?O.expandLevels-1:void 0,expand:0},S.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(S,O),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(S)}}),this.F(S,d,O);return}if(d.actual===S){this.D(S,d,O);return}if(d.actual.uri?.toString()!==S.uri?.toString())return this.L(v.toString()),this.u(S,O);const a=this.m.getChildren(d.actual),l=d.actual,c=h(this.m.toITestItem(l),this.m.toITestItem(S));this.m.getApiFor(l).listener=void 0,d.actual=S,d.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(S.tags,l.tags,v.toString()),delete c.tags),this.p(d,{op:4,update:c})),this.F(S,d,O);for(const[w,n]of a)this.m.getChildren(S).get(n.id)||this.L(R.TestId.joinToString(v,n.id));this.s(d.actual.uri)}w(S,O,v){const t=new Set(O.map(d=>d.id));for(const d of S)t.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:v,item:{tags:S.map(d=>(0,E.namespaceTestTag)(this.m.controllerId,d.id))}}}),t.forEach(this.z,this)}y(S){const O=this.j.get(S.id);O?O.refCount++:(this.j.set(S.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,E.namespaceTestTag)(this.m.controllerId,S.id)}}))}z(S){const O=this.j.get(S);O&&!--O.refCount&&(this.j.delete(S),this.pushDiff({op:7,id:(0,E.namespaceTestTag)(this.m.controllerId,S)}))}C(S,O){this.m.getApiFor(S).parent=O&&O.actual!==this.root?O.actual:void 0}D(S,O,v){this.C(S,v);const t=this.m.getApiFor(S);t.parent=v?.actual,t.listener=d=>this.p(O,d),this.G(O)}F(S,O,v){this.D(S,O,v);for(const[t,d]of this.m.getChildren(S))this.u(d,O)}G(S){let O;this.h?S.resolveBarrier?O=S.resolveBarrier.isOpen()?3:2:O=S.actual.canResolveChildren?1:0:O=0,O!==S.expand&&(S.expand=O,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:O}}),O===1&&S.expandLevels!==void 0&&this.I(S))}H(S,O){if(O<0)return;const v=[];for(const[t,d]of this.m.getChildren(S.actual)){const a=this.expand(R.TestId.joinToString(S.fullId,d.id),O);(0,i.isThenable)(a)&&v.push(a)}if(v.length)return Promise.all(v).then(()=>{})}I(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this.h){const d=new i.Barrier;return d.open(),d}S.expand=2,this.J(S);const O=S.resolveBarrier=new i.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let t;try{t=this.h(S.actual===this.root?void 0:S.actual)}catch(d){v(d)}return(0,i.isThenable)(t)?t.catch(v).then(()=>{O.open(),this.G(S)}):(O.open(),this.G(S)),S.resolveBarrier}J(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}L(S){const O=this.tree.get(S);if(!O)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:S});const v=[O];for(;v.length;){const t=v.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.z(d.id);this.tree.delete(t.fullId.toString());for(const[d,a]of this.m.getChildren(t.actual))v.push(this.tree.get(R.TestId.joinToString(t.fullId,a.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.g.fire(S)}}e.TestItemCollection=b;class m extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=m;class o extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=o;class s extends Error{constructor(S,O,v){super(`TestItem with ID "${S}" is from controller "${O}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=s;const u=(p,S,O)=>{let v=new Map;return{get size(){return v.size},forEach(t,d){for(const a of v.values())t.call(d,a,this)},[Symbol.iterator](){return v.entries()},replace(t){const d=new Map,a=new Set(v.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof O))throw new o(c.id);const w=S(c).controllerId;if(w!==p.controllerId)throw new s(c.id,w,p.controllerId);if(d.has(c.id))throw new m(c.id);d.set(c.id,c),a.delete(c.id),l.ops.push({op:0,item:c})}for(const c of a.keys())l.ops.push({op:3,id:c});p.listener?.(l),v=d},add(t){if(!(t instanceof O))throw new o(t.id);v.set(t.id,t),p.listener?.({op:0,item:t})},delete(t){v.delete(t)&&p.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=u}),define(ke[96],Te([1,0,72]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,I=(E,R)=>{const y={controllerId:R};return P.set(E,y),y};e.createPrivateApiFor=I;const F=E=>{const R=P.get(E);if(!R)throw new i.InvalidTestItemError(E?.id||"<unknown>");return R};e.getPrivateApiFor=F}),define(ke[73],Te([1,0,15,2]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(R,y){return R.scheme===i.Schemas.http||R.scheme===i.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===i.Schemas.file&&(R=P.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:R.path})),P.URI.from({scheme:i.Schemas.https,authority:`${R.scheme}+${F(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=I;function F(R){return R.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function E(R){return R.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=E}),define(ke[188],Te([1,0,4,6,73]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(R,y,k){this.d=R,this.e=y,this.f=k,this.a=0,this.b=new P.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const M=y.getVisibleTextEditors();for(const D of this.c.values())M.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,k,M,D){let h;for(const S of this.e.getVisibleTextEditors(!0))if(S.value===R){h=S;break}if(!h)throw new Error("not a visible editor");const b=this,m=this.a++,o=new i.Emitter,s=new i.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(S){return(0,I.asWebviewUri)(S,b.f)}get cspSource(){return I.webviewGenericCspSource}set options(S){this.b=S,b.d.$setOptions(m,S)}get options(){return this.b}set html(S){this.a=S,b.d.$setHtml(m,S)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(S){return b.d.$postMessage(m,S)}},p=new class{constructor(){this.editor=R,this.line=y,this.height=k,this.webview=u,this.onDidDispose=s.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),s.fire(),s.dispose(),o.dispose())}};return this.d.$createEditorInset(m,h.id,h.value.document.uri,y+1,k,M||{},D.identifier,D.extensionLocation),this.c.set(m,{editor:R,inset:p,onDidReceiveMessage:o}),p}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=F}),define(ke[189],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var P;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(P=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(E,R){super(R),this.variable=E}}e.VariableError=I}),define(ke[190],Te([1,0,19,51,9,22,20,87,153,189,10]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(b,m,o,s){this.g=new Map,this.a=b,this.b=m,this.d=o,s&&(this.c=s.then(u=>this.h(u)))}h(b){if(E.isWindows){const m=Object.create(null);return Object.keys(b).forEach(o=>{m[o.toLowerCase()]=b[o]}),m}return b}resolveWithEnvironment(b,m,o){return this.j({env:this.h(b),userHome:void 0},m?m.uri:void 0,o)}async resolveAsync(b,m){const o={env:await this.c,userHome:await this.d};return this.j(o,b?b.uri:void 0,m)}async i(b,m,o,s){const u=F.deepClone(m);E.isWindows&&u.windows?Object.keys(u.windows).forEach(S=>u[S]=u.windows[S]):E.isMacintosh&&u.osx?Object.keys(u.osx).forEach(S=>u[S]=u.osx[S]):E.isLinux&&u.linux&&Object.keys(u.linux).forEach(S=>u[S]=u.linux[S]),delete u.windows,delete u.osx,delete u.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,b?b.uri:void 0,u,o,s)}async resolveAnyAsync(b,m,o){return this.i(b,m,o)}async resolveAnyMap(b,m,o){const s=new Map;return{newConfig:await this.i(b,m,o,s),resolvedVariables:s}}resolveWithInteractionReplace(b,m,o,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,o,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,m)}async j(b,m,o,s,u){if(I.isString(o))return this.l(b,m,o,s,u);if(Array.isArray(o))return Promise.all(o.map(p=>this.j(b,m,p,s,u)));if(I.isObject(o)){const p=Object.create(null),S=await Promise.all(Object.keys(o).map(async O=>[await this.l(b,m,O,s,u),await this.j(b,m,o[O],s,u)]));for(const[O,v]of S)p[O]=v;return p}return o}l(b,m,o,s,u){return(0,M.replaceAsync)(o,D.VARIABLE_REGEXP,async(p,S)=>{if(S.includes(D.VARIABLE_LHS))return p;let O=await this.n(b,p,S,m,s);return u?.set(S,O),O!==p&&I.isString(O)&&O.match(D.VARIABLE_REGEXP)&&(O=await this.l(b,m,O,s,u)),O})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,m,o,s,u){let p;const S=o.split(":");S.length>1&&(o=S[0],p=S[1]);const O=d=>{const a=this.a.getFilePath();if(a)return(0,R.normalizeDriveLetter)(a);throw new k.VariableError(d,(0,y.localize)(0,null,m))},v=d=>{const a=O(d);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,R.normalizeDriveLetter)(l)}throw new k.VariableError(d,(0,y.localize)(1,null,m,i.basename(a)))},t=d=>{if(p){const a=this.a.getFolderUri(p);if(a)return a;throw new k.VariableError(d,(0,y.localize)(2,null,m,p))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,y.localize)(3,null,m)):new k.VariableError(d,(0,y.localize)(4,null,m))};switch(o){case"env":if(p){if(b.env){const d=b.env[E.isWindows?p.toLowerCase():p];if(I.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(p){const d=this.a.getConfigurationValue(s,p);if(I.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,m,p));if(I.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,m,p));return d}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(k.VariableKind.Command,m,p,u,"command");case"input":return this.o(k.VariableKind.Input,m,p,u,"input");case"extensionInstallFolder":if(p){const d=await this.a.getExtension(p);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,p));return this.m(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.WorkspaceFolder)));case"cwd":return s||p?(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(i.basename(this.m(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return O(k.VariableKind.File);case"fileWorkspaceFolder":return v(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||p?i.relative(this.m(t(k.VariableKind.RelativeFile)),O(k.VariableKind.RelativeFile)):O(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=i.dirname(O(k.VariableKind.RelativeFileDirname));if(s||p){const a=i.relative(this.m(t(k.VariableKind.RelativeFileDirname)),d);return a.length===0?".":a}return d}case"fileDirname":return i.dirname(O(k.VariableKind.FileDirname));case"fileExtname":return i.extname(O(k.VariableKind.FileExtname));case"fileBasename":return i.basename(O(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=i.basename(O(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-i.extname(d).length)}case"fileDirnameBasename":return i.basename(i.dirname(O(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||m}case"execInstallFolder":{const d=this.a.getAppRoot();return d||m}case"pathSeparator":return i.sep;default:try{const d=p?`${o}:${p}`:o;return this.o(k.VariableKind.Unknown,m,d,u,void 0)}catch{return m}}}}o(b,m,o,s,u){if(o&&s){const p=u===void 0?s[o]:s[u+":"+o];if(typeof p=="string")return p;throw new k.VariableError(b,(0,y.localize)(14,null,m))}return m}}D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=D}),define(ke[97],Te([1,0,3,95]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var I;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var F;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(F=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const o=m;return(0,P.isEditorInput)(o?.editor)&&(0,P.isEditorInput)(o?.replacement)}e.isEditorReplacement=k;var M;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function h(m){const o=m;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.isEditorGroup=h;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ke[191],Te([1,0,3,97]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(F){const E=F;return typeof F=="number"||(0,P.isEditorGroup)(E)}e.isPreferredGroup=I}),define(ke[192],Te([1,0,3,160]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(P.IEnvironmentService)}),define(ke[98],Te([1,0,26,4,19]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=F;class E{static isHostExtension(D,h,b){if(h.getExtensionDescription(D))return!1;const m=b.getExtensionDescription(D);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(D){this.c=new P.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let h of D.activationEvents)h==="onUri"&&(h=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,h){this.d=k(this.d,h),this.d=this.d.concat(D);const b=E.j(this.d);return this.d=k(this.d,b.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new F(b)}static j(D){const h=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,p){this.addNode(u),this.addNode(p),this.c.has(u)?this.c.get(u).push(p):this.c.set(u,[p])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,p){const S=h.getArcs(u);for(let O=0;O<S.length;O++)if(!p.has(S[O]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const u of D){const p=i.ExtensionIdentifier.toKey(u.identifier);if(b.set(p,u),u.extensionDependencies)for(const S of u.extensionDependencies){const O=i.ExtensionIdentifier.toKey(S);h.addArc(p,O)}}const m=new Set;h.getNodes().filter(u=>h.getArcs(u).length===0).forEach(u=>m.add(u));const o=h.getNodes().filter(u=>!m.has(u));let s;do{s=!1;for(let u=0;u<o.length;u++){const p=o[u];h.hasOnlyGoodArcs(p,m)&&(o.splice(u,1),u--,m.add(p),s=!0)}}while(s);return o.map(u=>b.get(u))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const h=this.g.get(D);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const h=this.e.get(i.ExtensionIdentifier.toKey(D));return h||void 0}getExtensionDescriptionByUUID(D){for(const h of this.f)if(h.uuid===D)return h}getExtensionDescriptionByIdOrUUID(D,h){return this.getExtensionDescription(D)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=E;var R;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(R||(R={}));function y(M,D){const h=M.isBuiltin?0:M.isUnderDevelopment?2:1,b=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(h!==b)return h-b;const m=I.posix.basename(M.extensionLocation.path),o=I.posix.basename(D.extensionLocation.path);return m<o?-1:m>o?1:0}function k(M,D){const h=new Set;return D.forEach(b=>h.add(i.ExtensionIdentifier.toKey(b))),M.filter(b=>!h.has(i.ExtensionIdentifier.toKey(b.identifier)))}}),define(ke[74],Te([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var I;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var F;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(F=e.MessageType||(e.MessageType={}));function E(k){const M=i.VSBuffer.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=E;function R(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=R;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ke[57],Te([1,0,3,4,12,27,74,50,52,22,2,6,143]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends D.Disposable{constructor(u,p){super(),this.m=u,this.n=p,this.a=this.B(new P.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=M.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=p.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(p.onDidChangeLogLevel(S=>{(0,I.isLogLevel)(S)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,p,S){const O=this.getTelemetryDetails(),v=new m(p,S,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:O.isUsageEnabled,isErrorsEnabled:O.isErrorsEnabled});return this.l.set(u.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(u,p,S){this.f=u,this.g=p,this.c=S??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(u){const p={};switch(p["common.extname"]=`${u.publisher}.${u.name}`,p["common.extversion"]=u.version,p["common.vscodemachineid"]=this.m.telemetryInfo.machineId,p["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,p["common.vscodeversion"]=this.m.version,p["common.isnewappinstall"]=o(this.m.telemetryInfo.firstSessionDate),p["common.product"]=this.m.environment.appHost,this.m.uiKind){case E.UIKind.Web:p["common.uikind"]="web";break;case E.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),p}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const p=this.getTelemetryDetails();this.l.forEach(S=>{S.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(u,p){const S=this.l.get(u.value);return!S||S.ignoreUnhandledExtHostErrors?!1:(S.logError(p),!0)}};b=qe([Ve(0,F.IExtHostInitDataService),Ve(1,I.ILoggerService)],b),e.ExtHostTelemetry=b;class m{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,p,S,O,v,t,d){this.g=S,this.h=O,this.i=v,this.j=t,this.a=new P.Emitter,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(u,p){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let p=u.properties??u;return p=(0,y.cleanData)(p,[]),this.c&&(p=(0,k.mixin)(p,this.c)),this.b||(p=(0,k.mixin)(p,this.j)),u.properties?u.properties=p:u=p,u}k(u,p){!this.f||(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(u,p),this.h.trace(u,p))}logUsage(u,p){!this.d.isUsageEnabled||this.k(u,p)}logError(u,p){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,p):this.f.sendErrorData(u,p))}get apiTelemetryLogger(){if(!this.e){const u=this,p={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(p)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=m;function o(s){const u=Date.now()-new Date(s).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=o,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(ke[25],Te([1,0,4,2,3,26,170]),function(ne,e,i,P,I,F,E){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class y{constructor(w){this.affinity=w,this.kind=1}equals(w){return this.kind===w.kind&&this.affinity===w.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(w){this.affinity=w,this.kind=2}equals(w){return this.kind===w.kind&&this.affinity===w.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class M{constructor(){this.kind=3,this.affinity=0}equals(w){return this.kind===w.kind}asString(){return"Remote"}}e.RemoteRunningLocation=M;class D{constructor(w){this.dependency=w}}e.MissingExtensionDependency=D;var h;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(h=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(w,n){const r=[],f=[],A=[],T=[],H=u(this.c),Q=u(w),Z=(g,N)=>g.extensionLocation.toString()===N.extensionLocation.toString()||g.isBuiltin===N.isBuiltin||g.isUserBuiltin===N.isUserBuiltin||g.isUnderDevelopment===N.isUnderDevelopment;for(const g of this.c){const N=Q.get(F.ExtensionIdentifier.toKey(g.identifier));if(!N){r.push(g.identifier),H.delete(F.ExtensionIdentifier.toKey(g.identifier));continue}if(!Z(g,N)){r.push(g.identifier),H.delete(F.ExtensionIdentifier.toKey(g.identifier));continue}}for(const g of w){const N=H.get(F.ExtensionIdentifier.toKey(g.identifier));if(!N){f.push(g);continue}if(!Z(N,g)){r.push(N.identifier),H.delete(F.ExtensionIdentifier.toKey(N.identifier));continue}}const _=s(this.d),j=s(n);for(const g of this.d)j.has(F.ExtensionIdentifier.toKey(g))||A.push(g);for(const g of n)_.has(F.ExtensionIdentifier.toKey(g))||T.push(g);const L={toRemove:r,toAdd:f,myToRemove:A,myToAdd:T};return this.delta(L),L}delta(w){const{toRemove:n,toAdd:r,myToRemove:f,myToAdd:A}=w,T=s(n),H=s(f);for(let Q=0;Q<this.c.length;Q++)T.has(F.ExtensionIdentifier.toKey(this.c[Q].identifier))&&(this.c.splice(Q,1),Q--);for(let Q=0;Q<this.d.length;Q++)H.has(F.ExtensionIdentifier.toKey(this.d[Q]))&&(this.d.splice(Q,1),Q--);for(const Q of r)this.c.push(Q);for(const Q of A)this.d.push(Q)}containsExtension(w){for(const n of this.d)if(F.ExtensionIdentifier.equals(n,w))return!0;return!1}}e.ExtensionHostExtensions=m;class o{constructor(w){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=F.ExtensionIdentifier.toKey,w)for(const n of w)this.add(n)}get size(){return this.c.size}add(w){return this.c.set(this.d(w),w),this}clear(){this.c.clear()}delete(w){return this.c.delete(this.d(w))}has(w){return this.c.has(this.d(w))}forEach(w,n){this.c.forEach(r=>w.call(n,r,r,this))}*entries(){for(const[w,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=o;function s(c){const w=new Set;for(const n of c)w.add(F.ExtensionIdentifier.toKey(n));return w}e.extensionIdentifiersArrayToSet=s;function u(c){const w=new Map;for(const n of c)w.set(F.ExtensionIdentifier.toKey(n.identifier),n);return w}function p(c,w){return c.enabledApiProposals?c.enabledApiProposals.includes(w):!1}e.isProposedApiEnabled=p;function S(c,w){if(!p(c,w))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${w}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${w}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=S;class O{constructor(w,n,r,f){this.codeLoadingTime=w,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=f}}e.ActivationTimes=O;class v{constructor(w,n){this.description=w,this.value=n}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,E.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function a(c,w){return{identifier:new F.ExtensionIdentifier((0,E.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!w,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class l{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(w){return Promise.resolve(void 0)}activationEventIsDone(w){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w,n){return Promise.resolve(0)}getInspectPorts(w,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ke[193],Te([1,0,11,98,26,25,12,17]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(u,p,S,O){this.startup=u,this.codeLoadingTime=p,this.activateCallTime=S,this.activateResolvedTime=O}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class k{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,p){return u===-1||p===-1?-1:p-u}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class M{constructor(u,p,S,O,v,t){this.activationFailed=u,this.activationFailedError=p,this.activationTimes=S,this.module=O,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=M;class D extends M{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class h extends M{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class b extends M{constructor(u){super(!0,u,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(u,p,S,O){this.g=O,this.a=u,this.b=p,this.c=S,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,p]of this.d)p.dispose()}isActivated(u){const p=this.d.get(I.ExtensionIdentifier.toKey(u));return Boolean(p&&p.value)}getActivatedExtension(u){const p=this.d.get(I.ExtensionIdentifier.toKey(u));if(!p||!p.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return p.value}async activateByEvent(u,p){if(this.f[u])return;const S=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(S.map(O=>({id:O.identifier,reason:{startup:p,extensionId:O.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,p){const S=this.a.getExtensionDescription(u);if(!S)throw new Error(`Extension '${u}' is not known`);return this.h([{id:S.identifier,reason:p}])}async h(u){const p=u.filter(S=>!this.isActivated(S.id)).map(S=>this.j(S));await Promise.all(p.map(S=>S.wait()))}j(u){if(this.d.has(I.ExtensionIdentifier.toKey(u.id)))return this.d.get(I.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const p=this.a.getExtensionDescription(u.id);if(!p){const v=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this.k(u,null,[],new b(v));return this.c.onExtensionActivationError(u.id,v,new F.MissingExtensionDependency(u.id.value)),t}const S=[],O=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const v of O){if(this.m(v))continue;const t=this.d.get(I.ExtensionIdentifier.toKey(v));if(t){S.push(t);continue}if(this.l(v)){S.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:u.reason}));continue}const d=this.a.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;S.push(this.j({id:d.identifier,reason:u.reason}));continue}const a=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${v}'`),c=this.k(u,p.displayName,[],new b(l));return this.c.onExtensionActivationError(p.identifier,l,new F.MissingExtensionDependency(v)),c}return this.k(u,p.displayName,S,null)}k(u,p,S,O){const v=new o(u.id,p,u.reason,S,O,this.c,this.g);return this.d.set(I.ExtensionIdentifier.toKey(u.id),v),v}l(u){return P.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const p=this.b.getExtensionDescription(u);return p?!p.main&&!p.browser:!1}};m=qe([Ve(3,E.ILogService)],m),e.ExtensionsActivator=m;let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,p,S,O,v,t,d){this.c=u,this.d=p,this.f=S,this.g=O,this.h=v,this.j=t,this.k=d,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const p=this.g[u];if(p.value&&!p.value.activationFailed){this.g.splice(u,1),u--;continue}if(p.value&&p.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);S.detail=p.value.activationFailedError,this.h=new b(S),this.j.onExtensionActivationError(this.c,S,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const p=new Error;if(u&&u.name&&(p.name=u.name),u&&u.message?p.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(p.stack=u.stack),this.h=new b(p),this.b&&i.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};o=qe([Ve(6,E.ILogService)],o)});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[7],Te([1,0,16,11,86,28,65,10,9,2,34,43,94,71,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m){"use strict";var o,s,u,p,S,O,v,t,d,a,l,c,w,n,r,f,A,T,H,Q,Z,_,j;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(z){return Object.assign(z,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(z,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[re,...Ee]=arguments;return Reflect.construct(z,Ee,re.constructor)}}})}var g;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(g=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var N;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(N=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=O=class{static from(...U){let re=U;return new O(function(){if(re){for(const Ee of re)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();re=void 0}})}constructor(U){o.set(this,void 0),Je(this,o,U,"f")}dispose(){typeof Le(this,o,"f")=="function"&&(Le(this,o,"f").call(this),Je(this,o,void 0,"f"))}};o=new WeakMap,B=O=qe([L],B),e.Disposable=B;let J=v=class{static Min(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let Ee=1;Ee<U.length;Ee++){const xe=U[Ee];xe.isBefore(re)&&(re=xe)}return re}static Max(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let Ee=1;Ee<U.length;Ee++){const xe=U[Ee];xe.isAfter(re)&&(re=xe)}return re}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:re,character:Ee}=U;return typeof re=="number"&&typeof Ee=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,re){if(U<0)throw(0,P.illegalArgument)("line must be non-negative");if(re<0)throw(0,P.illegalArgument)("character must be non-negative");this.c=U,this.e=re}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,re=0){if(U===null||re===null)throw(0,P.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,re=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&re===0?this:new v(this.line+Ee,this.character+re)}with(U,re=this.character){if(U===null||re===null)throw(0,P.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,re=typeof U.character=="number"?U.character:this.character),Ee===this.line&&re===this.character?this:new v(Ee,re)}toJSON(){return{line:this.line,character:this.character}}};J=v=qe([L],J),e.Position=J;let me=t=class{static isRange(U){return U instanceof t?!0:U?J.isPosition(U.start)&&J.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,re,Ee,xe){let _e,ot;if(typeof U=="number"&&typeof re=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new J(U,re),ot=new J(Ee,xe)):J.isPosition(U)&&J.isPosition(re)&&(_e=J.of(U),ot=J.of(re)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):J.isPosition(U)?!(J.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const re=J.Max(U.start,this.c),Ee=J.Min(U.end,this.e);if(!re.isAfter(Ee))return new t(re,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const re=J.Min(U.start,this.c),Ee=J.Max(U.end,this.end);return new t(re,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,re=this.end){if(U===null||re===null)throw(0,P.illegalArgument)();let Ee;return U?J.isPosition(U)?Ee=U:(Ee=U.start||this.start,re=U.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&re.isEqual(this.end)?this:new t(Ee,re)}toJSON(){return[this.start,this.end]}};me=t=qe([L],me),e.Range=me;let te=d=class extends me{static isSelection(U){return U instanceof d?!0:U?me.isRange(U)&&J.isPosition(U.anchor)&&J.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,re,Ee,xe){let _e,ot;if(typeof U=="number"&&typeof re=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new J(U,re),ot=new J(Ee,xe)):J.isPosition(U)&&J.isPosition(re)&&(_e=J.of(U),ot=J.of(re)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=d=qe([L],te),e.Selection=te;class oe{constructor(U,re,Ee){if(typeof U!="string"||U.length===0)throw(0,P.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,P.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,P.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(re),this.connectionToken=Ee}}e.ResolvedAuthority=oe;class ce extends Error{static NotAvailable(U,re){return new ce(U,h.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(U){return new ce(U,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,re=h.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=re,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var we;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(we=e.EndOfLine||(e.EndOfLine={}));var q;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=a=class{static isTextEdit(U){return U instanceof a?!0:U?me.isRange(U)&&typeof U.newText=="string":!1}static replace(U,re){return new a(U,re)}static insert(U,re){return a.replace(new me(U,U),re)}static delete(U){return a.replace(U,"")}static setEndOfLine(U){const re=new a(new me(new J(0,0),new J(0,0)),"");return re.newEol=U,re}get range(){return this.c}set range(U){if(U&&!me.isRange(U))throw(0,P.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,P.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,P.illegalArgument)("newEol");this.f=U}constructor(U,re){this.c=U,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};x=a=qe([L],x),e.TextEdit=x;let X=l=class{static isNotebookCellEdit(U){return U instanceof l?!0:U?jt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,re){return new l(U,re)}static insertCells(U,re){return new l(new jt(U,U),re)}static deleteCells(U){return new l(U,[])}static updateCellMetadata(U,re){const Ee=new l(new jt(U,U),[]);return Ee.newCellMetadata=re,Ee}static updateNotebookMetadata(U){const re=new l(new jt(0,0),[]);return re.newNotebookMetadata=U,re}constructor(U,re){this.range=U,this.newCells=re}};X=l=qe([L],X),e.NotebookEdit=X;class de{static isSnippetTextEdit(U){return U instanceof de?!0:U?me.isRange(U.range)&&ze.isSnippetString(U.snippet):!1}static replace(U,re){return new de(U,re)}static insert(U,re){return de.replace(new me(U,U),re)}constructor(U,re){this.range=U,this.snippet=re}}e.SnippetTextEdit=de;var ye;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(ye=e.FileEditType||(e.FileEditType={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,re,Ee,xe){this.c.push({_type:1,from:U,to:re,options:Ee,metadata:xe})}createFile(U,re,Ee){this.c.push({_type:1,from:void 0,to:U,options:re,metadata:Ee})}deleteFile(U,re,Ee){this.c.push({_type:1,from:U,to:void 0,options:re,metadata:Ee})}e(U,re,Ee){this.c.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:re},notebookMetadata:re})}f(U,re,Ee,xe){const _e=re.start,ot=re.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:ot-_e,cells:Ee,metadata:xe})}g(U,re,Ee,xe){this.c.push({_type:3,metadata:xe,uri:U,edit:{editType:8,index:re,metadata:Ee}})}replace(U,re,Ee,xe){this.c.push({_type:2,uri:U,edit:new x(re,Ee),metadata:xe})}insert(U,re,Ee,xe){this.replace(U,new me(re,re),Ee,xe)}delete(U,re,Ee){this.replace(U,re,"",Ee)}has(U){return this.c.some(re=>re._type===2&&re.uri.toString()===U.toString())}set(U,re){if(re)for(const Ee of re){if(!Ee)continue;let xe,_e;Array.isArray(Ee)?(xe=Ee[0],_e=Ee[1]):xe=Ee,X.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(U,xe.range.start,xe.newCellMetadata,_e):xe.newNotebookMetadata?this.e(U,xe.newNotebookMetadata,_e):this.f(U,xe.range,xe.newCells,_e):de.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:U,range:xe.range,edit:xe.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:xe,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const xe=this.c[Ee];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===U.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const re=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===U.toString()&&re.push(Ee.edit);return re}entries(){const U=new F.ResourceMap;for(const re of this.c)if(re._type===2){let Ee=U.get(re.uri);Ee||(Ee=[re.uri,[]],U.set(re.uri,Ee)),Ee[1].push(re.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ne=qe([L],Ne),e.WorkspaceEdit=Ne;let ze=c=class{static isSnippetString(U){return U instanceof c?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=c.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,re=this.e++){if(typeof U=="function"){const Ee=new c;Ee.e=this.e,U(Ee),this.e=Ee.e,U=Ee.value}else U=c.c(U);return this.value+="${",this.value+=re,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,re=this.e++){const Ee=U.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,re){if(typeof re=="function"){const Ee=new c;Ee.e=this.e,re(Ee),this.e=Ee.e,re=Ee.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,re&&(this.value+=":",this.value+=re),this.value+="}",this}};ze=c=qe([L],ze),e.SnippetString=ze;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Se=w=class{static isLocation(U){return U instanceof w?!0:U?me.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,re){if(this.uri=U,re)if(me.isRange(re))this.range=me.of(re);else if(J.isPosition(re))this.range=new me(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Se=w=qe([L],Se),e.Location=Se;let ae=class{static is(U){return U?typeof U.message=="string"&&U.location&&me.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,re){this.location=U,this.message=re}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.location.range.isEqual(re.location.range)&&U.location.uri.toString()===re.location.uri.toString()}};ae=qe([L],ae),e.DiagnosticRelatedInformation=ae;let le=class{constructor(U,re,Ee=Ie.Error){if(!me.isRange(U))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=U,this.message=re,this.severity=Ee}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.severity===re.severity&&U.code===re.code&&U.severity===re.severity&&U.source===re.source&&U.range.isEqual(re.range)&&(0,i.equals)(U.tags,re.tags)&&(0,i.equals)(U.relatedInformation,re.relatedInformation,ae.isEqual)}};le=qe([L],le),e.Diagnostic=le;let ee=class{constructor(U,re){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=re}};ee=qe([L],ee),e.Hover=ee;var C;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,re=C.Text){this.range=U,this.kind=re}toJSON(){return{range:this.range,kind:C[this.kind]}}};$=qe([L],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var V;(function(z){z[z.Deprecated=1]="Deprecated"})(V=e.SymbolTag||(e.SymbolTag={}));let ie=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,re,Ee,xe,_e){this.name=U,this.kind=re,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),xe instanceof Se?this.location=xe:Ee instanceof me&&(this.location=new Se(xe,Ee)),n.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ie=n=qe([L],ie),e.SymbolInformation=ie;let fe=r=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(r.validate)}constructor(U,re,Ee,xe,_e){this.name=U,this.detail=re,this.kind=Ee,this.range=xe,this.selectionRange=_e,this.children=[],r.validate(this)}};fe=r=qe([L],fe),e.DocumentSymbol=fe;var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ue=class{constructor(U,re){this.title=U,this.kind=re}};ue=qe([L],ue),e.CodeAction=ue;let ve=f=class{constructor(U){this.value=U}append(U){return new f(this.value?this.value+f.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+f.c)}};ve.c=".",ve=f=qe([L],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(U,re){if(this.range=U,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([L],be),e.SelectionRange=be;class He{constructor(U,re,Ee,xe,_e,ot){this.kind=U,this.name=re,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=He;class je{constructor(U,re){this.fromRanges=re,this.from=U}}e.CallHierarchyIncomingCall=je;class it{constructor(U,re){this.fromRanges=re,this.to=U}}e.CallHierarchyOutgoingCall=it;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,re){this.range=U,this.command=re}get isResolved(){return!!this.command}};et=qe([L],et),e.CodeLens=et;let nt=A=class{static isMarkdownString(U){return U instanceof A?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,re=!1){s.set(this,void 0),Je(this,s,new I.MarkdownString(U,{supportThemeIcons:re}),"f")}get value(){return Le(this,s,"f").value}set value(U){Le(this,s,"f").value=U}get isTrusted(){return Le(this,s,"f").isTrusted}set isTrusted(U){Le(this,s,"f").isTrusted=U}get supportThemeIcons(){return Le(this,s,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,s,"f").supportThemeIcons=U}get supportHtml(){return Le(this,s,"f").supportHtml}set supportHtml(U){Le(this,s,"f").supportHtml=U}get baseUri(){return Le(this,s,"f").baseUri}set baseUri(U){Le(this,s,"f").baseUri=U}appendText(U){return Le(this,s,"f").appendText(U),this}appendMarkdown(U){return Le(this,s,"f").appendMarkdown(U),this}appendCodeblock(U,re){return Le(this,s,"f").appendCodeblock(re??"",U),this}};s=new WeakMap,nt=A=qe([L],nt),e.MarkdownString=nt;let Fe=class{constructor(U,re){this.label=U,this.documentation=re}};Fe=qe([L],Fe),e.ParameterInformation=Fe;let rt=class{constructor(U,re){this.label=U,this.documentation=re,this.parameters=[]}};rt=qe([L],rt),e.SignatureInformation=rt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=qe([L],G),e.SignatureHelp=G;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(U){this.value=U}};We=qe([L],We),e.InlayHintLabelPart=We;let $e=class{constructor(U,re,Ee){this.position=U,this.label=re,this.kind=Ee}};$e=qe([L],$e),e.InlayHint=$e;var Qe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(z){z[z.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let at=class{constructor(U,re){this.label=U,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};at=qe([L],at),e.CompletionItem=at;let Et=class{constructor(U=[],re=!1){this.items=U,this.isIncomplete=re}};Et=qe([L],Et),e.CompletionList=Et;let Ct=class{constructor(U,re,Ee){this.insertText=U,this.range=re,this.command=Ee}};Ct=qe([L],Ct),e.InlineSuggestion=Ct;let It=class{constructor(U){this.commands=void 0,this.items=U}};It=qe([L],It),e.InlineSuggestionList=It;var Dt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Dt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Kt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Vt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Vt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(re){switch(re){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(U,re){if(re&&!k.URI.isUri(re))throw(0,P.illegalArgument)("target");if(!me.isRange(U)||U.isEmpty)throw(0,P.illegalArgument)("range");this.range=U,this.target=re}};$t=qe([L],$t),e.DocumentLink=$t;let At=class{constructor(U,re,Ee,xe){this.red=U,this.green=re,this.blue=Ee,this.alpha=xe}};At=qe([L],At),e.Color=At;let Ge=class{constructor(U,re){if(re&&!(re instanceof At))throw(0,P.illegalArgument)("color");if(!me.isRange(U)||U.isEmpty)throw(0,P.illegalArgument)("range");this.range=U,this.color=re}};Ge=qe([L],Ge),e.ColorInformation=Ge;let Nt=class{constructor(U){if(!U||typeof U!="string")throw(0,P.illegalArgument)("label");this.label=U}};Nt=qe([L],Nt),e.ColorPresentation=Nt;var xt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(xt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var mt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ce{constructor(U,re,Ee){if(this.startIndex=U,this.length=re,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,P.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,P.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=Ce;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class ge{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=ge;var K;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(K=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Re;var Ue;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=T=class{static from(U){switch(U){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(U,re){if(this.label=re,typeof U!="string"||typeof re!="string")throw(0,P.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new T("clean","Clean"),Be.Build=new T("build","Build"),Be.Rebuild=new T("rebuild","Rebuild"),Be.Test=new T("test","Test"),Be=T=qe([L],Be),e.TaskGroup=Be;function Ze(z){let U="";for(let re=0;re<z.length;re++)U+=z[re].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,re,Ee){if(typeof U!="string")throw(0,P.illegalArgument)("process");this.e=[],this.c=U,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Ee):this.f=re)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,P.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const re of this.e)U.push(re);return Ze(U)}};ct=qe([L],ct),e.ProcessExecution=ct;let Pt=class{constructor(U,re,Ee){if(this.f=[],Array.isArray(re)){if(!U)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,P.illegalArgument)("command");this.e=U,this.f=re,this.g=Ee}else{if(typeof U!="string")throw(0,P.illegalArgument)("commandLine");this.c=U,this.g=re}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,P.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,P.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)U.push(typeof re=="string"?re:re.value);return Ze(U)}};Pt=qe([L],Pt),e.ShellExecution=Pt;var vt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class pt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=pt;let Rt=H=class{constructor(U,re,Ee,xe,_e,ot){this.j=!1,this.k=this.definition=U;let dt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Ee,this.execution=xe,dt=_e,this.j=!0):re===wt.Global||re===wt.Workspace?(this.target=re,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,dt=ot):(this.target=re,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,dt=ot),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:H.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:H.f,id:this.n.computeId()}:this.n instanceof pt?this.k={type:H.c,id:this.n.computeId()}:this.k={type:H.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,P.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const re=this.k.type;(H.g===re||H.e===re||H.f===re||H.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};Rt.c="customExecution",Rt.e="process",Rt.f="shell",Rt.g="$empty",Rt=H=qe([L],Rt),e.Task=Rt;var bt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(z){function U(re){const Ee=re;return(0,y.isNumber)(Ee.value)?Ee.tooltip&&!(0,y.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}z.isViewBadge=U})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=Q=class{static isTreeItem(U,re){const Ee=U;if(Ee.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(re,"treeItemCheckbox");const xe=(0,y.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,y.isObject)(Ee.checkboxState)&&(0,y.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,y.isNumber)(Ee.checkboxState)&&(0,y.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(xe===void 0||xe!==si.Checked&&xe!==si.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(U instanceof Q)return!0;if(Ee.label!==void 0&&!(0,y.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,y.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,y.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,y.isString)(Ee.iconPath.id))){const xe=Ee.iconPath;if(!xe||!(0,y.isString)(xe.light)&&!k.URI.isUri(xe.light)&&!(0,y.isString)(xe.dark)&&!k.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,y.isString)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,y.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<St.None&&Ee.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,y.isString)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(U,re=St.None){this.collapsibleState=re,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};ei=Q=qe([L],ei),e.TreeItem=ei;var St;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,re){this.value=U,this.id=re??(0,M.generateUuid)()}};oi=qe([L],oi),e.DataTransferItem=oi;let _t=class{constructor(U){u.set(this,new Map);for(const[re,Ee]of U??[]){const xe=Le(this,u,"f").get(re);xe?xe.push(Ee):Le(this,u,"f").set(re,[Ee])}}get(U){return Le(this,u,"f").get(U)?.[0]}set(U,re){Le(this,u,"f").set(U,[re])}forEach(U,re){for(const[Ee,xe]of Le(this,u,"f"))for(const _e of xe)U.call(re,_e,Ee,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[U,re]of Le(this,u,"f"))for(const Ee of re)yield[U,Ee]}};_t=qe([L],_t),e.DataTransfer=_t;let vi=class{constructor(U){this.insertText=U}};vi=qe([L],vi),e.DocumentDropEdit=vi;let Ot=class{constructor(U){this.insertText=U}};Ot=qe([L],Ot),e.DocumentPasteEdit=Ot;let zt=class{constructor(U,re){this.id=U,this.color=re}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};zt=qe([L],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([L],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,re){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,P.illegalArgument)("base");if(typeof re!="string")throw(0,P.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=qe([L],Jt),e.RelativePattern=Jt;const lt=new WeakMap;function $i(z,U){lt.set(z,U)}e.setBreakpointId=$i;let Ut=class{constructor(U,re,Ee,xe){this.enabled=typeof U=="boolean"?U:!0,typeof re=="string"&&(this.condition=re),typeof Ee=="string"&&(this.hitCondition=Ee),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=lt.get(this)??(0,M.generateUuid)()),this.c}};Ut=qe([L],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(U,re,Ee,xe,_e){if(super(re,Ee,xe,_e),U===null)throw(0,P.illegalArgument)("location");this.location=U}};Xt=qe([L],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(U,re,Ee,xe,_e){super(re,Ee,xe,_e),this.functionName=U}};ci=qe([L],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,re,Ee,xe,_e,ot,dt){if(super(xe,_e,ot,dt),!re)throw(0,P.illegalArgument)("dataId");this.label=U,this.dataId=re,this.canPersist=Ee}};Ei=qe([L],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,re,Ee){this.command=U,this.args=re||[],this.options=Ee}};wi=qe([L],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,re){this.port=U,this.host=re}};ui=qe([L],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([L],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([L],li),e.DebugAdapterInlineImplementation=li;let Zt=class{constructor(U,re){this.range=U,this.expression=re}};Zt=qe([L],Zt),e.EvaluatableExpression=Zt;var Bi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(U,re){this.range=U,this.text=re}};ti=qe([L],ti),e.InlineValueText=ti;let ii=class{constructor(U,re,Ee=!0){this.range=U,this.variableName=re,this.caseSensitiveLookup=Ee}};ii=qe([L],ii),e.InlineValueVariableLookup=ii;let yi=class{constructor(U,re){this.range=U,this.expression=re}};yi=qe([L],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,re){this.frameId=U,this.stoppedLocation=re}};Di=qe([L],Di),e.InlineValueContext=Di;var ni;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ii=Z=class extends Error{static FileExists(U){return new Z(U,D.FileSystemProviderErrorCode.FileExists,Z.FileExists)}static FileNotFound(U){return new Z(U,D.FileSystemProviderErrorCode.FileNotFound,Z.FileNotFound)}static FileNotADirectory(U){return new Z(U,D.FileSystemProviderErrorCode.FileNotADirectory,Z.FileNotADirectory)}static FileIsADirectory(U){return new Z(U,D.FileSystemProviderErrorCode.FileIsADirectory,Z.FileIsADirectory)}static NoPermissions(U){return new Z(U,D.FileSystemProviderErrorCode.NoPermissions,Z.NoPermissions)}static Unavailable(U){return new Z(U,D.FileSystemProviderErrorCode.Unavailable,Z.Unavailable)}constructor(U,re=D.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,Z.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Ii=Z=qe([L],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,re,Ee){this.start=U,this.end=re,this.kind=Ee}};Ci=qe([L],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,re=[]){this.tokenTypes=U,this.tokenModifiers=re}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Me{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let re=0,Ee=U.tokenTypes.length;re<Ee;re++)this.j.set(U.tokenTypes[re],re);for(let re=0,Ee=U.tokenModifiers.length;re<Ee;re++)this.k.set(U.tokenModifiers[re],re)}}push(U,re,Ee,xe,_e){if(typeof U=="number"&&typeof re=="number"&&typeof Ee=="number"&&typeof xe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,re,Ee,xe,_e);if(me.isRange(U)&&typeof re=="string"&&Oi(Ee))return this.m(U,re,Ee);throw(0,P.illegalArgument)()}m(U,re,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const xe=U.start.line,_e=U.start.character,ot=U.end.character-U.start.character,dt=this.j.get(re);let Mt=0;if(Ee)for(const Ht of Ee){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Mt|=1<<qt>>>0}this.n(xe,_e,ot,dt,Mt)}n(U,re,Ee,xe,_e){if(this.f&&(U<this.c||U===this.c&&re<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Ht=0,qt=0;for(let Gt=0;Gt<Mt;Gt++){let Qt=this.g[5*Gt],Pi=this.g[5*Gt+1];Qt===0?(Qt=Ht,Pi+=qt):Qt+=Ht,this.g[5*Gt]=Qt,this.g[5*Gt+1]=Pi,Ht=Qt,qt=Pi}}let ot=U,dt=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(dt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=dt,this.g[this.h++]=Ee,this.g[this.h++]=xe,this.g[this.h++]=_e,this.c=U,this.e=re}static o(U){const re=[],Ee=U.length/5|0;for(let dt=0;dt<Ee;dt++)re[dt]=dt;re.sort((dt,Mt)=>{const Ht=U[5*dt],qt=U[5*Mt];if(Ht===qt){const Gt=U[5*dt+1],Qt=U[5*Mt+1];return Gt-Qt}return Ht-qt});const xe=new Uint32Array(U.length);let _e=0,ot=0;for(let dt=0;dt<Ee;dt++){const Mt=5*re[dt],Ht=U[Mt+0],qt=U[Mt+1],Gt=U[Mt+2],Qt=U[Mt+3],Pi=U[Mt+4],sn=Ht-_e,Rn=sn===0?qt-ot:qt,Ai=5*dt;xe[Ai+0]=sn,xe[Ai+1]=Rn,xe[Ai+2]=Gt,xe[Ai+3]=Qt,xe[Ai+4]=Pi,_e=Ht,ot=qt}return xe}build(U){return this.f?new Wt(new Uint32Array(this.g),U):new Wt(Me.o(this.g),U)}}e.SemanticTokensBuilder=Me;class Wt{constructor(U,re){this.resultId=re,this.data=U}}e.SemanticTokens=Wt;class Li{constructor(U,re,Ee){this.start=U,this.deleteCount=re,this.data=Ee}}e.SemanticTokensEdit=Li;class gt{constructor(U,re){this.resultId=re,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=qe([L],di),e.QuickInputButtons=di;var Ni;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let re=(0,R.nextCharLength)(U.badge,0);if(re<U.badge.length&&(re+=(0,R.nextCharLength)(U.badge,re)),U.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!zt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,re,Ee){this.badge=U,this.tooltip=re,this.color=Ee}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([L],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(U){return U instanceof jt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,re){if(U<0)throw(0,P.illegalArgument)("start must be positive");if(re<0)throw(0,P.illegalArgument)("end must be positive");U<=re?(this.c=U,this.e=re):(this.c=re,this.e=U)}with(U){let re=this.c,Ee=this.e;return U.start!==void 0&&(re=U.start),U.end!==void 0&&(Ee=U.end),re===this.c&&Ee===this.e?this:new jt(re,Ee)}}e.NotebookRange=jt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(re=>fi.isNotebookCellData(re))}static isNotebookCellData(U){return!0}constructor(U,re,Ee,xe,_e,ot,dt){this.kind=U,this.value=re,this.languageId=Ee,this.mime=xe,this.outputs=_e??[],this.metadata=ot,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Bt{static isNotebookCellOutputItem(U){return U instanceof Bt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const re={name:U.name,message:U.message,stack:U.stack};return Bt.json(re,"application/vnd.code.notebook.error")}static stdout(U){return Bt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Bt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,re="application/octet-stream"){return new Bt(U,re)}static text(U,re=E.Mimes.text){const Ee=Le(Bt,p,"f",S).encode(String(U));return new Bt(Ee,re)}static json(U,re="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return Bt.text(Ee,re)}constructor(U,re){this.data=U,this.mime=re;const Ee=(0,E.normalizeMimeType)(re,!0);if(!Ee)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}p=Bt,S={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,re=!1){const Ee=new Set,xe=new Set;for(let _e=0;_e<U.length;_e++){const ot=U[_e],dt=(0,E.normalizeMimeType)(ot.mime);if(!Ee.has(dt)||(0,b.isTextStreamMime)(dt)){Ee.add(dt);continue}xe.add(_e),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return xe.size===0?U:U.filter((_e,ot)=>!xe.has(ot))}constructor(U,re,Ee){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof re=="string"?(this.id=re,this.metadata=Ee):(this.id=(0,M.generateUuid)(),this.metadata=re??Ee)}}e.NotebookCellOutput=mi;var Gi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var se;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(se=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,re){this.text=U,this.alignment=re}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var yt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(yt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Lt{constructor(U,re=[]){this.uri=U,this.provides=(0,i.asArray)(re)}}e.NotebookRendererScript=Lt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,re){this.label=U,this.timestamp=re}};Qi=qe([L],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,re){this.ranges=U,this.wordPattern=re}}e.LinkedEditingRanges=fn;class mn{constructor(U,re){this.c=U,this.e=re}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(U=void 0,re=void 0,Ee=void 0){this.include=U,this.exclude=re,this.profile=Ee}};Fi=qe([L],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(U=void 0,re=void 0,Ee=void 0,xe=!1){super(U,re,Ee),this.continuous=xe}};Yi=qe([L],Yi),e.TestRunRequest2=Yi;let _i=_=class{static diff(U,re,Ee){const xe=new _(U);return xe.expectedOutput=re,xe.actualOutput=Ee,xe}constructor(U){this.message=U}};_i=_=qe([L],_i),e.TestMessage=_i;let Ji=class{constructor(U){this.id=U}};Ji=qe([L],Ji),e.TestTag=Ji;let gi=class{constructor(U,re){this.covered=U,this.total=re}};gi=qe([L],gi),e.CoveredCount=gi;let Zi=j=class{static fromDetails(U,re){const Ee=new gi(0,0),xe=new gi(0,0),_e=new gi(0,0);for(const dt of re)if("branches"in dt){Ee.total+=1,Ee.covered+=dt.executionCount>0?1:0;for(const Mt of dt.branches)xe.total+=1,xe.covered+=Mt.executionCount>0?1:0}else _e.total+=1,_e.covered+=dt.executionCount>0?1:0;const ot=new j(U,Ee,xe.total>0?xe:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=re,ot}constructor(U,re,Ee,xe){this.uri=U,this.statementCoverage=re,this.branchCoverage=Ee,this.functionCoverage=xe}};Zi=j=qe([L],Zi),e.FileCoverage=Zi;let en=class{constructor(U,re,Ee=[]){this.executionCount=U,this.location=re,this.branches=Ee}};en=qe([L],en),e.StatementCoverage=en;let tn=class{constructor(U,re){this.executionCount=U,this.location=re}};tn=qe([L],tn),e.BranchCoverage=tn;let nn=class{constructor(U,re){this.executionCount=U,this.location=re}};nn=qe([L],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,re,Ee,xe,_e,ot){this.kind=U,this.name=re,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,re){this.original=U,this.modified=re}}e.TextDiffTabInput=yn;class Dn{constructor(U,re,Ee,xe){this.base=U,this.input1=re,this.input2=Ee,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(U,re){this.uri=U,this.viewType=re}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,re){this.uri=U,this.notebookType=re}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,re,Ee){this.original=U,this.modified=re,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,re){this.uri=U,this.inputBoxUri=re}}e.InteractiveWindowInput=An}),define(ke[99],Te([1,0,49,15,10,259,131,7,16]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function M(m,o){o?k.set(m,o):k.delete(m)}e.setWordDefinitionFor=M;function D(m){return k.get(m)}class h extends F.MirrorTextModel{constructor(o,s,u,p,S,O,v,t){super(s,u,p,S),this.m=o,this.p=O,this.q=v,this.notebook=t,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(o){return(0,y.equals)(this.d,o)}get document(){if(!this.a){const o=this;this.a={get uri(){return o.c},get fileName(){return o.c.fsPath},get isUntitled(){return o.c.scheme===P.Schemas.untitled},get languageId(){return o.p},get version(){return o.g},get isClosed(){return o.b},get isDirty(){return o.q},save(){return o.r()},getText(s){return s?o.s(s):o.getText()},get eol(){return o.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return o.d.length},lineAt(s){return o.t(s)},offsetAt(s){return o.u(s)},positionAt(s){return o.v(s)},validateRange(s){return o.w(s)},validatePosition(s){return o.x(s)},getWordRangeAtPosition(s,u){return o.y(s,u)}}}return Object.freeze(this.a)}_acceptLanguageId(o){(0,i.ok)(!this.b),this.p=o}_acceptIsDirty(o){(0,i.ok)(!this.b),this.q=o}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(o){const s=this.w(o);if(s.isEmpty)return"";if(s.isSingleLine)return this.d[s.start.line].substring(s.start.character,s.end.character);const u=this.f,p=s.start.line,S=s.end.line,O=[];O.push(this.d[p].substring(s.start.character));for(let v=p+1;v<S;v++)O.push(this.d[v]);return O.push(this.d[S].substring(0,s.end.character)),O.join(u)}t(o){let s;if(o instanceof R.Position?s=o.line:typeof o=="number"&&(s=o),typeof s!="number"||s<0||s>=this.d.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.d[s],s===this.d.length-1)}u(o){return o=this.x(o),this.k(),this.h.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.k();const s=this.h.getIndexOf(o),u=this.d[s.index].length;return new R.Position(s.index,Math.min(s.remainder,u))}w(o){if(!(o instanceof R.Range))throw new Error("Invalid argument");const s=this.x(o.start),u=this.x(o.end);return s===o.start&&u===o.end?o:new R.Range(s.line,s.character,u.line,u.character)}x(o){if(!(o instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return o.with(0,0);let{line:s,character:u}=o,p=!1;if(s<0)s=0,u=0,p=!0;else if(s>=this.d.length)s=this.d.length-1,u=this.d[s].length,p=!0;else{const S=this.d[s].length;u<0?(u=0,p=!0):u>S&&(u=S,p=!0)}return p?new R.Position(s,u):o}y(o,s){const u=this.x(o);if(!s)s=D(this.p);else if((0,I.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const p=(0,E.getWordAtText)(u.character+1,(0,E.ensureValidWordDefinition)(s),this.d[u.line],0);if(p)return new R.Range(u.line,p.startColumn-1,u.line,p.endColumn-1)}}e.ExtHostDocumentData=h;class b{constructor(o,s,u){this.a=o,this.b=s,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(ke[194],Te([1,0,7,18,4]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(R){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};F=qe([Ve(0,P.IExtHostRpcService)],F),e.ExtHostTheming=F}),define(ke[8],Te([1,0,16,23,116,195,86,28,112,66,65,22,9,2,44,75,91,96,95,71,45,56,191,7]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Ce){function Ae(K){const{selectionStartLineNumber:Re,selectionStartColumn:Ue,positionLineNumber:Ye,positionColumn:Be}=K,Ze=new d.Position(Re-1,Ue-1),ct=new d.Position(Ye-1,Be-1);return new d.Selection(Ze,ct)}Ce.to=Ae;function ge(K){const{anchor:Re,active:Ue}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ce.from=ge})(a=e.Selection||(e.Selection={}));var l;(function(Ce){function Ae(K){if(!K)return;const{start:Re,end:Ue}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ce.from=Ae;function ge(K){if(!K)return;const{startLineNumber:Re,startColumn:Ue,endLineNumber:Ye,endColumn:Be}=K;return new d.Range(Re-1,Ue-1,Ye-1,Be-1)}Ce.to=ge})(l=e.Range||(e.Range={}));var c;(function(Ce){function Ae(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Ce.to=Ae})(c=e.TokenType||(e.TokenType={}));var w;(function(Ce){function Ae(K){return new d.Position(K.lineNumber-1,K.column-1)}Ce.to=Ae;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}Ce.from=ge})(w=e.Position||(e.Position={}));var n;(function(Ce){function Ae(Re,Ue){return(0,i.coalesce)((0,i.asArray)(Re).map(Ye=>ge(Ye,Ue)))}Ce.from=Ae;function ge(Re,Ue){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:K(Re.scheme,Ue),pattern:pe.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function K(Re,Ue){return Ue&&typeof Re=="string"?Ue.transformOutgoingScheme(Re):Re}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Ce){function Ae(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Ce.from=Ae;function ge(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ce){function Ae(K){let Re;return K.code&&((0,h.isString)(K.code)||(0,h.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),{...l.from(K.range),message:K.message,source:K.source,code:Re,severity:T.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(A.from),tags:Array.isArray(K.tags)?(0,i.coalesce)(K.tags.map(r.from)):void 0}}Ce.from=Ae;function ge(K){const Re=new d.Diagnostic(l.to(K),K.message,T.to(K.severity));return Re.source=K.source,Re.code=(0,h.isString)(K.code)?K.code:K.code?.value,Re.relatedInformation=K.relatedInformation&&K.relatedInformation.map(A.to),Re.tags=K.tags&&(0,i.coalesce)(K.tags.map(r.to)),Re}Ce.to=ge})(f=e.Diagnostic||(e.Diagnostic={}));var A;(function(Ce){function Ae(K){return{...l.from(K.location.range),message:K.message,resource:K.location.uri}}Ce.from=Ae;function ge(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,l.to(K)),K.message)}Ce.to=ge})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Ce){function Ae(K){switch(K){case d.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ce.from=Ae;function ge(K){switch(K){case s.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Ce.to=ge})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var H;(function(Ce){function Ae(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Ce.from=Ae;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(H=e.ViewColumn||(e.ViewColumn={}));function Q(Ce){return typeof Ce.range<"u"}function Z(Ce){return Ce.length===0?!0:!!Q(Ce[0])}e.isDecorationOptionsArr=Z;var _;(function(Ce){function Ae(Be){return Be.map(Ce.from)}Ce.fromMany=Ae;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function K(Be){let Ze;if(ge(Be)){const{language:wt,value:pt}=Be;Ze={value:"```"+wt+`
`+pt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Pt=wt=>{try{let pt=b.URI.parse(wt,!0);pt=pt.with({query:Re(pt.query,ct)}),ct[wt]=pt}catch{}return""},vt=new y.marked.Renderer;return vt.link=Pt,vt.image=wt=>typeof wt=="string"?Pt(E.parseHrefAndDimensions(wt).href):"",(0,y.marked)(Ze.value,{renderer:vt}),Ze}Ce.from=K;function Re(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,k.parse)(Be)}catch{}if(!ct)return Be;let Pt=!1;return ct=(0,D.cloneAndChange)(ct,vt=>{if(b.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[wt]=vt,Pt=!0,wt}else return}),Pt?JSON.stringify(ct):Be}function Ue(Be){const Ze=new d.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?b.URI.from(Be.baseUri):void 0,Ze}Ce.to=Ue;function Ye(Be){if(!!Be)return typeof Be=="string"?Be:Ce.from(Be)}Ce.fromStrict=Ye})(_=e.MarkdownString||(e.MarkdownString={}));function j(Ce){return Z(Ce)?Ce.map(Ae=>({range:l.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?_.fromMany(Ae.hoverMessage):Ae.hoverMessage?_.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ce.map(Ae=>({range:l.from(Ae)}))}e.fromRangeOrRangeWithMessage=j;function L(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.pathOrURIToURI=L;var g;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?L(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Ae})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Ce){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?g.from(ge.before):void 0,after:ge.after?g.from(ge.after):void 0}}Ce.from=Ae})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ce){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Ae})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var J;(function(Ce){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?B.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?N.from(ge.light):void 0,dark:ge.dark?N.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?g.from(ge.before):void 0,after:ge.after?g.from(ge.after):void 0}}Ce.from=Ae})(J=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var me;(function(Ce){function Ae(K){return{text:K.newText,eol:K.newEol&&nt.from(K.newEol),range:l.from(K.range)}}Ce.from=Ae;function ge(K){const Re=new d.TextEdit(l.to(K.range),K.text);return Re.newEol=typeof K.eol>"u"?void 0:nt.to(K.eol),Re}Ce.to=ge})(me=e.TextEdit||(e.TextEdit={}));var te;(function(Ce){function Ae(K,Re){const Ue={edits:[]};if(K instanceof d.WorkspaceEdit){const Ye=new R.ResourceSet;for(const Be of K._allEntries())Be._type===1&&b.URI.isUri(Be.to)&&Be.from===void 0&&Ye.add(Be.to);for(const Be of K._allEntries())Be._type===1?Ue.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,P.encodeBase64)(P.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Ue.edits.push({resource:Be.uri,textEdit:me.from(Be.edit),versionId:Ye.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Ue.edits.push({resource:Be.uri,textEdit:{range:l.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Ye.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Ue.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Ue.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(Et.from)}})}return Ue}Ce.from=Ae;function ge(K){const Re=new d.WorkspaceEdit;for(const Ue of K.edits)Ue.textEdit?Re.replace(b.URI.revive(Ue.resource),l.to(Ue.textEdit.range),Ue.textEdit.text):Re.renameFile(b.URI.revive(Ue.oldResource),b.URI.revive(Ue.newResource),Ue.options);return Re}Ce.to=ge})(te=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(Ce){const Ae=Object.create(null);Ae[d.SymbolKind.File]=0,Ae[d.SymbolKind.Module]=1,Ae[d.SymbolKind.Namespace]=2,Ae[d.SymbolKind.Package]=3,Ae[d.SymbolKind.Class]=4,Ae[d.SymbolKind.Method]=5,Ae[d.SymbolKind.Property]=6,Ae[d.SymbolKind.Field]=7,Ae[d.SymbolKind.Constructor]=8,Ae[d.SymbolKind.Enum]=9,Ae[d.SymbolKind.Interface]=10,Ae[d.SymbolKind.Function]=11,Ae[d.SymbolKind.Variable]=12,Ae[d.SymbolKind.Constant]=13,Ae[d.SymbolKind.String]=14,Ae[d.SymbolKind.Number]=15,Ae[d.SymbolKind.Boolean]=16,Ae[d.SymbolKind.Array]=17,Ae[d.SymbolKind.Object]=18,Ae[d.SymbolKind.Key]=19,Ae[d.SymbolKind.Null]=20,Ae[d.SymbolKind.EnumMember]=21,Ae[d.SymbolKind.Struct]=22,Ae[d.SymbolKind.Event]=23,Ae[d.SymbolKind.Operator]=24,Ae[d.SymbolKind.TypeParameter]=25;function ge(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}Ce.from=ge;function K(Re){for(const Ue in Ae)if(Ae[Ue]===Re)return Number(Ue);return d.SymbolKind.Property}Ce.to=K})(oe=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ce){function Ae(K){switch(K){case d.SymbolTag.Deprecated:return 1}}Ce.from=Ae;function ge(K){switch(K){case 1:return d.SymbolTag.Deprecated}}Ce.to=ge})(ce=e.SymbolTag||(e.SymbolTag={}));var we;(function(Ce){function Ae(K){return{name:K.name,kind:oe.from(K.kind),tags:K.tags&&K.tags.map(ce.from),containerName:K.containerName,location:ye.from(K.location)}}Ce.from=Ae;function ge(K){const Re=new d.SymbolInformation(K.name,oe.to(K.kind),K.containerName,ye.to(K.location));return Re.tags=K.tags&&K.tags.map(ce.to),Re}Ce.to=ge})(we=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(Ce){function Ae(K){const Re={name:K.name||"!!MISSING: name!!",detail:K.detail,range:l.from(K.range),selectionRange:l.from(K.selectionRange),kind:oe.from(K.kind),tags:K.tags?.map(ce.from)??[]};return K.children&&(Re.children=K.children.map(Ae)),Re}Ce.from=Ae;function ge(K){const Re=new d.DocumentSymbol(K.name,K.detail,oe.to(K.kind),l.to(K.range),l.to(K.selectionRange));return(0,i.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(ce.to)),K.children&&(Re.children=K.children.map(ge)),Re}Ce.to=ge})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(Ce){function Ae(K){const Re=new d.CallHierarchyItem(oe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),l.to(K.range),l.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}Ce.to=Ae;function ge(K,Re,Ue){if(Re=Re??K._sessionId,Ue=Ue??K._itemId,Re===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ue,name:K.name,detail:K.detail,kind:oe.from(K.kind),uri:K.uri,range:l.from(K.range),selectionRange:l.from(K.selectionRange),tags:K.tags?.map(ce.from)}}Ce.from=ge})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var X;(function(Ce){function Ae(ge){return new d.CallHierarchyIncomingCall(x.to(ge.from),ge.fromRanges.map(K=>l.to(K)))}Ce.to=Ae})(X=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(Ce){function Ae(ge){return new d.CallHierarchyOutgoingCall(x.to(ge.to),ge.fromRanges.map(K=>l.to(K)))}Ce.to=Ae})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ye;(function(Ce){function Ae(K){return{range:K.range&&l.from(K.range),uri:K.uri}}Ce.from=Ae;function ge(K){return new d.Location(b.URI.revive(K.uri),l.to(K.range))}Ce.to=ge})(ye=e.location||(e.location={}));var Ne;(function(Ce){function Ae(K){const Re=K,Ue=K;return{originSelectionRange:Re.originSelectionRange?l.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ue.uri,range:l.from(Re.targetRange?Re.targetRange:Ue.range),targetSelectionRange:Re.targetSelectionRange?l.from(Re.targetSelectionRange):void 0}}Ce.from=Ae;function ge(K){return{targetUri:b.URI.revive(K.uri),targetRange:l.to(K.range),targetSelectionRange:K.targetSelectionRange?l.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?l.to(K.originSelectionRange):void 0}}Ce.to=ge})(Ne=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ce){function Ae(K){return{range:l.from(K.range),contents:_.fromMany(K.contents)}}Ce.from=Ae;function ge(K){return new d.Hover(K.contents.map(_.to),l.to(K.range))}Ce.to=ge})(ze=e.Hover||(e.Hover={}));var Pe;(function(Ce){function Ae(K){return{range:l.from(K.range),expression:K.expression}}Ce.from=Ae;function ge(K){return new d.EvaluatableExpression(l.to(K.range),K.expression)}Ce.to=ge})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(Ce){function Ae(K){if(K instanceof d.InlineValueText)return{type:"text",range:l.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:l.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Ae;function ge(K){switch(K.type){case"text":return{range:l.to(K.range),text:K.text};case"variable":return{range:l.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:l.to(K.range),expression:K.expression}}}Ce.to=ge})(Ie=e.InlineValue||(e.InlineValue={}));var Se;(function(Ce){function Ae(K){return{frameId:K.frameId,stoppedLocation:l.from(K.stoppedLocation)}}Ce.from=Ae;function ge(K){return new d.InlineValueContext(K.frameId,l.to(K.stoppedLocation))}Ce.to=ge})(Se=e.InlineValueContext||(e.InlineValueContext={}));var ae;(function(Ce){function Ae(K){return{range:l.from(K.range),kind:K.kind}}Ce.from=Ae;function ge(K){return new d.DocumentHighlight(l.to(K.range),K.kind)}Ce.to=ge})(ae=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Ce){function Ae(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Ce.to=Ae})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ee;(function(Ce){function Ae(ge){return{triggerKind:le.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Ae})(ee=e.CompletionContext||(e.CompletionContext={}));var C;(function(Ce){function Ae(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}Ce.from=Ae;function ge(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}Ce.to=ge})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Ce){const Ae=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge(Ue){return Ae.get(Ue)??9}Ce.from=ge;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Ue){return K.get(Ue)??d.CompletionItemKind.Property}Ce.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(Ce){function Ae(ge,K){const Re=new d.CompletionItem(ge.label);return Re.insertText=ge.insertText,Re.kind=$.to(ge.kind),Re.tags=ge.tags?.map(C.to),Re.detail=ge.detail,Re.documentation=E.isMarkdownString(ge.documentation)?_.to(ge.documentation):ge.documentation,Re.sortText=ge.sortText,Re.filterText=ge.filterText,Re.preselect=ge.preselect,Re.commitCharacters=ge.commitCharacters,m.Range.isIRange(ge.range)?Re.range=l.to(ge.range):typeof ge.range=="object"&&(Re.range={inserting:l.to(ge.range.insert),replacing:l.to(ge.range.replace)}),Re.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Re.insertText=new d.SnippetString(ge.insertText):(Re.insertText=ge.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Re.additionalTextEdits=ge.additionalTextEdits.map(Ue=>me.to(Ue))),Re.command=K&&ge.command?K.fromInternal(ge.command):void 0,Re}Ce.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var V;(function(Ce){function Ae(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:_.fromStrict(K.documentation)}}Ce.from=Ae;function ge(K){return{label:K.label,documentation:E.isMarkdownString(K.documentation)?_.to(K.documentation):K.documentation}}Ce.to=ge})(V=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(Ce){function Ae(K){return{label:K.label,documentation:_.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Ce.from=Ae;function ge(K){return{label:K.label,documentation:E.isMarkdownString(K.documentation)?_.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Ce.to=ge})(ie=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(Ce){function Ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ie.from):[]}}Ce.from=Ae;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ie.to):[]}}Ce.to=ge})(fe=e.SignatureHelp||(e.SignatureHelp={}));var De;(function(Ce){function Ae(ge,K){const Re=new d.InlayHint(w.to(K.position),typeof K.label=="string"?K.label:K.label.map(ue.to.bind(void 0,ge)),K.kind&&ve.to(K.kind));return Re.textEdits=K.textEdits&&K.textEdits.map(me.to),Re.tooltip=E.isMarkdownString(K.tooltip)?_.to(K.tooltip):K.tooltip,Re.paddingLeft=K.paddingLeft,Re.paddingRight=K.paddingRight,Re}Ce.to=Ae})(De=e.InlayHint||(e.InlayHint={}));var ue;(function(Ce){function Ae(ge,K){const Re=new d.InlayHintLabelPart(K.label);return Re.tooltip=E.isMarkdownString(K.tooltip)?_.to(K.tooltip):K.tooltip,o.Command.is(K.command)&&(Re.command=ge.fromInternal(K.command)),K.location&&(Re.location=ye.to(K.location)),Re}Ce.to=Ae})(ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(Ce){function Ae(K){return K}Ce.from=Ae;function ge(K){return K}Ce.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(Ce){function Ae(K){return{range:l.from(K.range),url:K.target,tooltip:K.tooltip}}Ce.from=Ae;function ge(K){let Re;if(K.url)try{Re=typeof K.url=="string"?b.URI.parse(K.url,!0):b.URI.revive(K.url)}catch{}return new d.DocumentLink(l.to(K.range),Re)}Ce.to=ge})(be=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ce){function Ae(K){const Re=new d.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=me.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Ue=>me.to(Ue))),Re}Ce.to=Ae;function ge(K){return{label:K.label,textEdit:K.textEdit?me.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>me.from(Re)):void 0}}Ce.from=ge})(He=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(Ce){function Ae(K){return new d.Color(K[0],K[1],K[2],K[3])}Ce.to=Ae;function ge(K){return[K.red,K.green,K.blue,K.alpha]}Ce.from=ge})(je=e.Color||(e.Color={}));var it;(function(Ce){function Ae(K){return{range:l.from(K.range)}}Ce.from=Ae;function ge(K){return new d.SelectionRange(l.to(K.range))}Ce.to=ge})(it=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ce){function Ae(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Ce.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Ce){function Ae(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Ae;function ge(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Ce.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(Ce){function Ae(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}Ce.from=Ae;function ge(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}Ce.to=ge})(nt=e.EndOfLine||(e.EndOfLine={}));var Fe;(function(Ce){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Ae})(Fe=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Ce){function Ae(K){const Re={start:K.start+1,end:K.end+1};return K.kind&&(Re.kind=G.from(K.kind)),Re}Ce.from=Ae;function ge(K){const Re={start:K.start-1,end:K.end-1};return K.kind&&(Re.kind=G.to(K.kind)),Re}Ce.to=ge})(rt=e.FoldingRange||(e.FoldingRange={}));var G;(function(Ce){function Ae(K){if(K)switch(K){case d.FoldingRangeKind.Comment:return o.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return o.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return o.FoldingRangeKind.Region}}Ce.from=Ae;function ge(K){if(K)switch(K.value){case o.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Ce.to=ge})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Ce){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?l.from(ge.selection):void 0,override:typeof ge.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ce.from=Ae})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pe;(function(Ce){function Ae(Ue){return Ue instanceof d.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:ge(Ue)||K(Ue)?new d.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ce.from=Ae;function ge(Ue){const Ye=Ue;return Ye?b.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function K(Ue){const Ye=Ue;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Re(Ue){return typeof Ue=="string"?Ue:new d.RelativePattern(b.URI.revive(Ue.baseUri),Ue.pattern)}Ce.to=Re})(pe=e.GlobPattern||(e.GlobPattern={}));var We;(function(Ce){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:pe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ce.from=Ae})(We=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(Ce){function Ae(K){return{start:K.start,end:K.end}}Ce.from=Ae;function ge(K){return new d.NotebookRange(K.start,K.end)}Ce.to=ge})($e=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Ce){function Ae(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ce.to=Ae;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ce.from=ge})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Ce){function Ae(ge){if(ge===S.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===S.NotebookCellExecutionState.Pending)return;if(ge===S.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Ae})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var tt;(function(Ce){function Ae(K){switch(K){case d.NotebookCellKind.Markup:return S.CellKind.Markup;case d.NotebookCellKind.Code:default:return S.CellKind.Code}}Ce.from=Ae;function ge(K){switch(K){case S.CellKind.Markup:return d.NotebookCellKind.Markup;case S.CellKind.Code:default:return d.NotebookCellKind.Code}}Ce.to=ge})(tt=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Ce){function Ae(K){const Re={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)d.NotebookCellData.validate(Ue),Re.cells.push(Et.from(Ue));return Re}Ce.from=Ae;function ge(K){const Re=new d.NotebookData(K.cells.map(Et.to));return(0,h.isEmptyObject)(K.metadata)||(Re.metadata=K.metadata),Re}Ce.to=ge})(at=e.NotebookData||(e.NotebookData={}));var Et;(function(Ce){function Ae(K){return{cellKind:tt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Qe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(It.from):[]}}Ce.from=Ae;function ge(K){return new d.NotebookCellData(tt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(It.to):void 0,K.metadata,K.internalMetadata?Qe.to(K.internalMetadata):void 0)}Ce.to=ge})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ct;(function(Ce){function Ae(K){return{mime:K.mime,valueBytes:P.VSBuffer.wrap(K.data)}}Ce.from=Ae;function ge(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Ce.to=ge})(Ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(Ce){function Ae(K){return{outputId:K.id,items:K.items.map(Ct.from),metadata:K.metadata}}Ce.from=Ae;function ge(K){const Re=K.items.map(Ct.to);return new d.NotebookCellOutput(Re,K.outputId,K.metadata)}Ce.to=ge})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Dt;(function(Ce){function Ae(Re){return K(Re)?{include:(0,h.withNullAsUndefined)(pe.from(Re.include)),exclude:(0,h.withNullAsUndefined)(pe.from(Re.exclude))}:(0,h.withNullAsUndefined)(pe.from(Re))}Ce.from=Ae;function ge(Re){return K(Re)?{include:pe.to(Re.include),exclude:pe.to(Re.exclude)}:pe.to(Re)}Ce.to=ge;function K(Re){const Ue=Re;return Ue?!(0,h.isUndefinedOrNull)(Ue.include)&&!(0,h.isUndefinedOrNull)(Ue.exclude):!1}})(Dt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Ce){function Ae(ge,K,Re){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Re),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Ae})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Ce){function Ae(ge,K,Re){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:K.toInternal(Ue,Re),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Ae})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Kt;(function(Ce){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Ae})(Kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Vt;(function(Ce){function Ae(K){return{uri:K.uri,provides:K.provides}}Ce.from=Ae;function ge(K){return new d.NotebookRendererScript(b.URI.revive(K.uri),K.provides)}Ce.to=ge})(Vt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(Ce){function Ae(K){return{message:_.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:l.from(K.location.range),uri:K.location.uri}}}Ce.from=Ae;function ge(K){const Re=new d.TestMessage(typeof K.message=="string"?K.message:_.to(K.message));return Re.actualOutput=K.actual,Re.expectedOutput=K.expected,Re.location=K.location?ye.to(K.location):void 0,Re}Ce.to=ge})(kt=e.TestMessage||(e.TestMessage={}));var ht;(function(Ce){Ce.namespace=v.namespaceTestTag,Ce.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Tt;(function(Ce){function Ae(K){const Re=(0,u.getPrivateApiFor)(K).controllerId;return{extId:O.TestId.fromExtHostTestItem(K,Re).toString(),label:K.label,uri:b.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>ht.namespace(Re,Ue.id)),range:m.Range.lift(l.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&_.fromStrict(K.error)||null}}Ce.from=Ae;function ge(K){return{parent:void 0,error:void 0,id:O.TestId.fromString(K.extId).localId,label:K.label,uri:b.URI.revive(K.uri),tags:(K.tags||[]).map(Re=>{const{tagId:Ue}=ht.denamespace(Re);return new d.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ce.toPlain=ge})(Tt=e.TestItem||(e.TestItem={})),function(Ce){function Ae(K){return{id:K.id}}Ce.from=Ae;function ge(K){return new d.TestTag(K.id)}Ce.to=ge}(ht=e.TestTag||(e.TestTag={}));var $t;(function(Ce){const Ae=(K,Re)=>{const Ue=[];for(const[Be,Ze]of Re)O.TestId.compare(Ze.item.extId,Be)===2&&(Re.delete(Be),Ue.push(Ze));const Ye={...Tt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(kt.to)})),children:Ue.map(Be=>Ae(Be,Re))};for(const Be of Ye.children)Be.parent=Ye;return Ye};function ge(K){const Re=[],Ue=new Map;for(const Ye of K.items){Ue.set(Ye.item.extId,Ye);const Be=O.TestId.root(Ye.item.extId);K.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Ye.item.extId))&&Re.push(Ye)}return{completedAt:K.completedAt,results:Re.map(Ye=>Ae(Ye,Ue))}}Ce.to=ge})($t=e.TestResults||(e.TestResults={}));var At;(function(Ce){function Ae(Ue){return{covered:Ue.covered,total:Ue.covered}}function ge(Ue){return"line"in Ue?w.from(Ue):l.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ge(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&ge(Ye.location)})):void 0}:{type:0,count:Ue.executionCount,location:ge(Ue.location)}}Ce.fromDetailed=K;function Re(Ue){return{uri:Ue.uri,statement:Ae(Ue.statementCoverage),branch:Ue.branchCoverage&&Ae(Ue.branchCoverage),function:Ue.functionCoverage&&Ae(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Ce.fromFile=Re})(At=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(Ce){function Ae(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Ce.to=Ae})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ce){function Ae(K){const Re=new d.TypeHierarchyItem(oe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),l.to(K.range),l.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}Ce.to=Ae;function ge(K,Re,Ue){if(Re=Re??K._sessionId,Ue=Ue??K._itemId,Re===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ue,kind:oe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:l.from(K.range),selectionRange:l.from(K.selectionRange),tags:K.tags?.map(ce.from)}}Ce.from=ge})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var xt;(function(Ce){function Ae(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Ae})(xt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Ce){function Ae(Ue,Ye,Be){const Ze=Ye.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,F.once)(()=>Be())}}}("",Ye.id):Ue===M.Mimes.uriList&&Ye.uriListData?new d.DataTransferItem(Re(Ye.uriListData)):new d.DataTransferItem(Ye.asString)}Ce.to=Ae;async function ge(Ue,Ye){const Be=await Ye.asString();if(Ue===M.Mimes.uriList)return{id:Ye.id,asString:Be,fileData:void 0,uriListData:K(Be)};const Ze=Ye.asFile();return{id:Ye.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}Ce.from=ge;function K(Ue){return I.UriList.split(Ue).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return b.URI.parse(Ye)}catch{}return Ye})}function Re(Ue){return I.UriList.create(Ue.map(Ye=>typeof Ye=="string"?Ye:b.URI.revive(Ye)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var mt;(function(Ce){function Ae(K,Re){const Ue=K.items.map(([Ye,Be])=>[Ye,Ft.to(Ye,Be,()=>Re(Be.id))]);return new d.DataTransfer(Ue)}Ce.toDataTransfer=Ae;async function ge(K){const Re={items:[]},Ue=[];return K.forEach((Ye,Be)=>{Ue.push((async()=>{Re.items.push([Be,await Ft.from(Be,Ye)])})())}),await Promise.all(Ue),Re}Ce.toDataTransferDTO=ge})(mt=e.DataTransfer||(e.DataTransfer={}))}),define(ke[196],Te([1,0,2,11,7,8,162]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,M,D,h={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=D,this.g=h,this.a=new E.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,D,h)=>{const m={dispose:this.a.push([M,D,k])};return Array.isArray(h)&&h.push(m),m}}async $participateInSave(k,M){const D=i.URI.revive(k);let h=!1;const b=setTimeout(()=>h=!0,this.g.timeout),m=[];try{for(const o of[...this.a]){if(h)break;const s=this.d.getDocument(D),u=await this.h(o,{document:s,reason:F.TextDocumentSaveReason.to(M)});m.push(u)}}finally{clearTimeout(b)}return m}h([k,M,D],h){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,k,M,h).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const o=this.b.get(k);this.b.set(k,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,D,h){const b=[],m=Date.now(),{document:o,reason:s}=h,{version:u}=o,p=Object.freeze({document:o,reason:s,waitUntil(S){if(Object.isFrozen(b))throw(0,P.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(S))}});try{M.apply(D,[p])}catch(S){return Promise.reject(S)}return Object.freeze(b),new Promise((S,O)=>{const v=setTimeout(()=>O(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(v),S(t)}).catch(t=>{clearTimeout(v),O(t)})}).then(S=>{const O={edits:[]};for(const v of S)if(Array.isArray(v)&&v.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:d,range:a}of v)O.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:a&&F.Range.from(a),text:t,eol:d&&F.EndOfLine.from(d)}});if(O.edits.length!==0)return u===o.version?this.f.$tryApplyWorkspaceEdit(O):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(ke[197],Te([1,0,15,2,8,7,71]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(D,h,b,m){this.start=D,this.deletedCount=h,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(D,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,h,b){this.notebook=D,this.h=h,this.j=b,this.handle=b.handle,this.uri=P.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(I.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return D.g},set mime(m){D.g=m},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(I.NotebookCellOutput.to)}setOutputItems(D,h,b){const m=b.map(I.NotebookCellOutputItem.to),o=this.a.find(s=>s.id===D);if(o&&(h||(o.items.length=0),o.items.push(...m),o.items.length>1&&o.items.every(s=>E.isTextStreamMime(s.mime)))){const s=new Map,u=[];o.items.forEach(p=>{let S;s.has(p.mime)?S=s.get(p.mime):(S=[],s.set(p.mime,S),u.push(p.mime)),S.push(p.data)}),o.items.length=0,u.forEach(p=>{const S=E.compressOutputItemStreams(s.get(p));o.items.push({mime:p,data:S.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=y;class k{constructor(D,h,b,m,o){this.k=D,this.l=h,this.m=b,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,h={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(o=>o.apiCell)},save(){return D.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,h,b){this.g=D.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},o=[];for(const u of D.rawEvents)u.kind===E.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,m.contentChanges):u.kind===E.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,m.contentChanges):u.kind===E.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),o.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===E.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),o.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===E.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),o.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===E.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===E.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===E.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),o.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),o.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const s=new Map;for(let u=0;u<o.length;u++){const p=o[u],S=s.get(p.cell);if(S===void 0){const O=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});s.set(p.cell,O-1)}else m.cellChanges[S]={...m.cellChanges[S],...p}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let h=D.start|0,b=D.end|0;return h<0&&(h=0),b>this.b.length&&(b=this.b.length),D.with({start:h,end:b})}p(D){D=this.o(D);const h=[];for(let b=D.start;b<D.end;b++)h.push(this.b[b]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,h,b){if(this.j)return;const m=[],o=[],s=[];if(D.reverse().forEach(u=>{const S=u[2].map(t=>{const d=new y(this,this.l,t);return h||o.push(y.asModelAddData(this.apiNotebook,t)),d}),O=new R(u[0],u[1],[],S),v=this.b.splice(u[0],u[1],...S);for(const t of v)s.push(t.uri),O.deletedItems.push(t.apiCell);m.push(O)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:s}),b)for(const u of m)b.push(u.asApiEvent())}s(D,h,b,m){const o=this.b.splice(D,h);this.b.splice(b,0,...o);const s=[new R(D,h,o.map(u=>u.apiCell),[]),new R(b,0,[],o)];for(const u of s)m.push(u.asApiEvent())}t(D,h){this.b[D].setOutputs(h)}u(D,h,b,m){this.b[D].setOutputItems(h,b,m)}v(D,h){const b=this.b[D];b.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(b.uri,h)}w(D,h){const b=this.b[D];b.apiCell.mime=h}x(D,h){this.b[D].setMetadata(h)}y(D,h){this.b[D].setInternalMetadata(h)}getCellFromApiCell(D){return this.b.find(h=>h.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(h=>h.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}k.a=0,e.ExtHostNotebookDocument=k}),define(ke[100],Te([1,0,11,8,7]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(R,y,k,M,D,h){this.id=R,this.f=y,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=M,this.c=h}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(I.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,k){R.f.$tryRevealRange(R.id,P.NotebookRange.from(y),k??I.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(P.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}F.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=F}),define(ke[198],Te([1,0,4,12,8]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=class{constructor(R,y){this.c=R,this.d=y,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const k=this.d.getEditorById(R);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(I.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(I.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(I.ViewColumn.to(R[y]))}};F=qe([Ve(0,P.ILogService)],F),e.ExtHostNotebookEditors=F}),define(ke[199],Te([1,0,8,166,141,21,64,11]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,b,m){const o=this.b++,{title:s,location:u,cancellable:p}=b,S={label:(0,I.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(o,{location:i.ProgressLocation.from(u),title:s,source:S,cancellable:p},h.isUnderDevelopment?void 0:h.identifier.value).catch(R.onUnexpectedExternalError),this.d(o,m,!!p)}d(h,b,m){let o;m&&(o=new F.CancellationTokenSource,this.c.set(h,o));const s=p=>{this.a.$progressEnd(p),this.c.delete(p),o?.dispose()};let u;try{u=b(new M(this.a,h),m&&o?o.token:F.CancellationToken.None)}catch(p){throw s(h),p}return u.then(p=>s(h),p=>s(h)),u}$acceptProgressCanceled(h){const b=this.c.get(h);b&&(b.cancel(),this.c.delete(h))}}e.ExtHostProgress=y;function k(D,h){return D.message=h.message,typeof h.increment=="number"&&(typeof D.increment=="number"?D.increment+=h.increment:D.increment=h.increment),D}class M extends P.Progress{constructor(h,b){super(m=>this.throttledReport(m)),this.c=h,this.d=b}throttledReport(h){this.c.$progressReport(this.d,h)}}qe([(0,E.throttle)(100,(D,h)=>k(D,h),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(ke[101],Te([1,0,44,96,45,72,56,8,2]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(S,O,v,t)=>{let d=O;return{enumerable:!0,configurable:!1,get(){return d},set(a){if(!v(d,a)){const l=d;d=a,S.listener?.(t(a,l))}}}},M=(S,O)=>S===O,D={range:(S,O)=>S===O?!0:!S||!O?!1:S.isEqual(O),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(S,O)=>!(S.length!==O.length||S.some(v=>!O.find(t=>v.id===t.id)))},h=S=>O=>({op:4,update:S(O)}),b=(S,O)=>({range:(()=>{let v;const t=h(d=>({range:i.Range.lift(R.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){S.listener?.({op:6}),D.range(v,d)||(v=d,S.listener?.(t(d)))}}})(),label:k(S,O,D.label,h(v=>({label:v}))),description:k(S,void 0,D.description,h(v=>({description:v}))),sortText:k(S,void 0,D.sortText,h(v=>({sortText:v}))),canResolveChildren:k(S,!1,D.canResolveChildren,v=>({op:2,state:v})),busy:k(S,!1,D.busy,h(v=>({busy:v}))),error:k(S,void 0,D.error,h(v=>({error:R.MarkdownString.fromStrict(v)||null}))),tags:k(S,[],D.tags,(v,t)=>({op:1,new:v.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),m=S=>{const O=I.TestId.fromString(S.extId),v=new s(O.controllerId,O.localId,S.label,y.URI.revive(S.uri)||void 0);return v.range=R.Range.to(S.range||void 0),v.description=S.description||void 0,v.sortText=S.sortText||void 0,v.tags=S.tags.map(t=>R.TestTag.to({id:(0,E.denamespaceTestTag)(t).tagId})),v},o=S=>{let O;for(const v of S.tests){const t=m(v.item);(0,P.getPrivateApiFor)(t).parent=O,O=t}return O};e.toItemFromContext=o;class s{constructor(O,v,t,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const a=(0,P.createPrivateApiFor)(this,O);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof u?void 0:a.parent}},children:{value:(0,F.createTestItemChildren)(a,P.getPrivateApiFor,s),enumerable:!0,writable:!1},...b(a,t)})}}e.TestItemImpl=s;class u extends s{constructor(O,v){super(O,O,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class p extends F.TestItemCollection{constructor(O,v,t){super({controllerId:O,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:P.getPrivateApiFor,getChildren:d=>d.children,root:new u(O,v),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ke[102],Te([1,0,49,11,83,8,7]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(h,b,m){const o=R.c.nextId();h.$registerTextEditorDecorationType(b.identifier,o,F.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:o,dispose(){h.$removeTextEditorDecorationType(o)}})}}R.c=new I.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=R;class y{constructor(h,b){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,b){this.k();let m=null;if(h instanceof E.Position)m=new E.Range(h,h);else if(h instanceof E.Range)m=h;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(h,b){this.k(),this.l(new E.Range(h,h),b,!0)}delete(h){this.k();let b=null;if(h instanceof E.Range)b=h;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(h,b,m){const o=this.c.validateRange(h);this.g.push({range:o,text:b,forceMoveMarkers:m})}setEndOfLine(h){if(this.k(),h!==E.EndOfLine.LF&&h!==E.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this.h=h}}class k{constructor(h,b,m,o){this.c=h,this.d=b,this._accept(m),this.e=o;const s=this;this.value={get tabSize(){return s.f},set tabSize(u){s.m(u)},get indentSize(){return s.g},set indentSize(u){s.o(u)},get insertSpaces(){return s.h},set insertSpaces(u){s.q(u)},get cursorStyle(){return s.j},set cursorStyle(u){s.s(u)},get lineNumbers(){return s.k},set lineNumbers(u){s.t(u)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}m(h){const b=this.l(h);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}o(h){const b=this.n(h);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}q(h){const b=this.p(h);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(h)})))}assign(h){const b={};let m=!1;if(typeof h.tabSize<"u"){const o=this.l(h.tabSize);o==="auto"?(m=!0,b.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,m=!0,b.tabSize=o)}if(typeof h.indentSize<"u"){const o=this.n(h.indentSize);o==="tabSize"?(m=!0,b.indentSize=o):typeof o=="number"&&this.g!==o&&(this.g=o,m=!0,b.indentSize=o)}if(typeof h.insertSpaces<"u"){const o=this.p(h.insertSpaces);o==="auto"?(m=!0,b.insertSpaces=o):this.h!==o&&(this.h=o,m=!0,b.insertSpaces=o)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,m=!0,b.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,m=!0,b.lineNumbers=F.TextEditorLineNumbersStyle.from(h.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(h,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=k;class M{constructor(h,b,m,o,s,u,p,S){this.id=h,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=s,this.d=new k(this.j,this.id,u,m),this.e=p,this.f=S;const O=this;this.value=Object.freeze({get document(){return o.value},set document(v){throw(0,P.readonly)("document")},get selection(){return O.c&&O.c[0]},set selection(v){if(!(v instanceof E.Selection))throw(0,P.illegalArgument)("selection");O.c=[v],O.l()},get selections(){return O.c},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof E.Selection)))throw(0,P.illegalArgument)("selections");O.c=v,O.l()},get visibleRanges(){return O.e},set visibleRanges(v){throw(0,P.readonly)("visibleRanges")},get options(){return O.d.value},set options(v){O.g||O.d.assign(v)},get viewColumn(){return O.f},set viewColumn(v){throw(0,P.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(O.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(o.value,t);return v(d),O.m(d)},insertSnippet(v,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(O.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=O.c.map(l=>F.Range.from(l));else if(t instanceof E.Position){const{lineNumber:l,column:c}=F.Position.from(t);a=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof E.Range)a=[F.Range.from(t)];else{a=[];for(const l of t)if(l instanceof E.Range)a.push(F.Range.from(l));else{const{lineNumber:c,column:w}=F.Position.from(l);a.push({startLineNumber:c,startColumn:w,endLineNumber:c,endColumn:w})}}return b.$tryInsertSnippet(h,o.value.version,v.value,a,d)},setDecorations(v,t){const d=t.length===0;d&&!O.h.has(v.key)||(d?O.h.delete(v.key):O.h.add(v.key),O.n(()=>{if(F.isDecorationOptionsArr(t))return b.$trySetDecorations(h,v.key,F.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const w=t[l];a[4*l]=w.start.line+1,a[4*l+1]=w.start.character+1,a[4*l+2]=w.end.line+1,a[4*l+3]=w.end.character+1}return b.$trySetDecorationsFast(h,v.key,a)}}))},revealRange(v,t){O.n(()=>b.$tryRevealRange(h,F.Range.from(v),t||E.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(h,F.ViewColumn.from(v))},hide(){b.$tryHideEditor(h)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,i.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,i.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,i.ok)(!this.g),this.f=h}_acceptSelections(h){(0,i.ok)(!this.g),this.c=h}async l(){const h=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const b=h.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(s=>s.range);m.sort((s,u)=>s.end.line===u.end.line?s.end.character===u.end.character?s.start.line===u.start.line?s.start.character-u.start.character:s.start.line-u.start.line:s.end.character-u.end.character:s.end.line-u.end.line);for(let s=0,u=m.length-1;s<u;s++){const p=m[s].end;if(m[s+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=b.edits.map(s=>({range:F.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,o,{setEndOfLine:typeof b.setEndOfLine=="number"?F.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=M}),define(ke[200],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[201],Te([1,0,154,11,29,90,69,30,26,200,165,157]),function(ne,e,i,P,I,F,E,R,y,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=R.Registry.as(E.Extensions.JSONContribution);class b{constructor(v,t,d){this.a=v,this.b=t,this.c=d}d(v,t){this.a({type:v,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(I.default.Error,v)}warn(v){this.d(I.default.Warning,v)}info(v){this.d(I.default.Info,v)}}e.ExtensionMessageCollector=b;class m{static a(v){const t=new Set;for(let d=0,a=v.length;d<a;d++)t.add(y.ExtensionIdentifier.toKey(v[d].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new m(t,[]);if(!t||!t.length)return new m([],v);const d=this.a(v),a=this.a(t),l=t.filter(w=>!d.has(y.ExtensionIdentifier.toKey(w.description.identifier))),c=v.filter(w=>!a.has(y.ExtensionIdentifier.toKey(w.description.identifier)));return new m(l,c)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=m;class o{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=m.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,P.onUnexpectedError)(v)}}}e.ExtensionPoint=o;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new o(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,t),v.activationEventsGenerator&&D.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,h.registerSchema(u,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const S={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(S.ExtensionsRegistry,new p),e.ExtensionsRegistry=R.Registry.as(S.ExtensionsRegistry),h.registerSchema(u,e.schema),h.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ke[202],Te([1,0,151,9,22,201,42,4]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(h){function b(m,o,s){if(!m)return;const u=P.isString(m.type)?m.type:void 0;if(!u||u.length===0){s.error(i.localize(3,null));return}const p=[];if(Array.isArray(m.required))for(const S of m.required)P.isString(S)&&p.push(S);return{extensionId:o.value,taskType:u,required:p,properties:m.properties?I.deepClone(m.properties):{},when:m.when?E.ContextKeyExpr.deserialize(m.when):void 0}}h.from=b})(k||(k={}));const M=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,b)=>{for(const m of h)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class D{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{M.setHandler((o,s)=>{this.c=void 0;try{for(const u of s.removed){const p=u.value;for(const S of p)this.a&&S.type&&this.a[S.type]&&delete this.a[S.type]}for(const u of s.added){const p=u.value;for(const S of p){const O=k.from(S,u.description.identifier,u.collector);O&&(this.a[O.taskType]=O)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const o={type:"object",additionalProperties:!1};m.required.length>0&&(o.required=m.required.slice(0)),m.properties!==void 0?o.properties=I.deepClone(m.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[m.taskType]},b.push(o)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new D}),define(ke[203],Te([1,0,152,9,24,22,42,202]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new E.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function g(N){if(!N)return L.Strong;switch(N.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=g}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var M;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(L){function g(N){switch(N.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=g}(M=e.RevealKind||(e.RevealKind={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(L){function g(N){switch(N.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=g}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(L){function g(N){switch(N.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=g}(h=e.PanelKind||(e.PanelKind={}));var b;(function(L){L.defaults={echo:!0,reveal:M.Always,revealProblems:D.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(L){function g(B){switch(B.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=g;function N(B){switch(B){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=N}(m=e.RuntimeType||(e.RuntimeType={}));var o;(function(L){function g(N){return P.isString(N)?N:N.value}L.value=g})(o=e.CommandString||(e.CommandString={}));var s;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function g(B){return B===L.Clean._id||B===L.Build._id||B===L.Rebuild._id||B===L.Test._id}L.is=g;function N(B){if(B!==void 0)return P.isString(B)?g(B)?{_id:B,isDefault:!1}:void 0:B}L.from=N})(s=e.TaskGroup||(e.TaskGroup={}));var u;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var p;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function g(N){switch(N){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=g})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var S;(function(L){L.parallel="parallel",L.sequence="sequence"})(S=e.DependsOrder||(e.DependsOrder={}));var O;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(O=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:O.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(g,N,B,J,me,te){this._label="",this._id=g,N&&(this._label=N),B&&(this.type=B),this.runOptions=J,this.configurationProperties=me,this._source=te}getDefinition(g){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const g={folder:this.d(),id:this._id};return JSON.stringify(g)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(g,N=!1){if(g===void 0)return!1;if(P.isString(g))return g===this._label||g===this.configurationProperties.identifier||N&&g===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===g._key}getQualifiedLabel(){const g=this.getWorkspaceFolder();return g?`${this._label} (${g.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(g){this.c===void 0&&(this.c=[]),g&&(this.c=this.c.concat(g))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class d extends t{constructor(g,N,B,J,me,te,oe,ce){super(g,B,void 0,oe,ce,N),this.command={},this._source=N,this.hasDefinedMatchers=te,me&&(this.command=me)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(g=!1){if(g&&this._source.customizes!==void 0)return this._source.customizes;{let N;switch(this.command?this.command.runtime:void 0){case m.Shell:N="shell";break;case m.Process:N="process";break;case m.CustomExecution:N="customExecution";break;case void 0:N="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:N,_key:this._id,id:this._id}}}static is(g){return g instanceof d}getMapKey(){const g=this._source.config.workspaceFolder;return g?`${g.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const g=this.d();if(!g)return;let N=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(N+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:g,id:N};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(g){return new d(g._id,g._source,g._label,g.type,g.command,g.hasDefinedMatchers,g.runOptions,g.configurationProperties)}}e.CustomTask=d;class a extends t{constructor(g,N,B,J,me,te,oe){super(g,B,J,te,oe,N),this._source=N,this.configures=me}static is(g){return g instanceof a}f(g){return g}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const g=this.d();if(!g)return;let N=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(N+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:g,id:N};return JSON.stringify(B)}}e.ConfiguringTask=a;class l extends t{constructor(g,N,B,J,me,te,oe,ce,we){super(g,B,J,ce,we,N),this.defines=me,this.hasDefinedMatchers=oe,this.command=te,this.icon=we.icon,this.hide=we.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(g){return g instanceof l}getMapKey(){const g=this._source.workspaceFolder;return g?`${this._source.scope.toString()}|${g.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const g={type:"contributed",scope:this._source.scope,id:this._id};return g.folder=this.d(),JSON.stringify(g)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(g){return new l(g._id,g._source,g._label,g.type,g.defines,g.command,g.hasDefinedMatchers,g.runOptions,g.configurationProperties)}}e.ContributedTask=l;class c extends t{constructor(g,N,B,J,me,te){super(g,B,J,me,te,N),this._source=N}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(g){return g instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(g){return new c(g._id,g._source,g._label,g.type,g.runOptions,g.configurationProperties)}}e.InMemoryTask=c;var w;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(w=e.ExecutionEngine||(e.ExecutionEngine={})),function(L){L._default=L.Terminal}(w=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(g){this.c=new Map;for(let N=0;N<g.length;N++)this.c.set(g[N].uri.toString(),N)}compare(g,N){const B=g.getWorkspaceFolder(),J=N.getWorkspaceFolder();if(B&&J){let me=this.c.get(B.uri.toString());me=me===void 0?0:me+1;let te=this.c.get(J.uri.toString());return te=te===void 0?0:te+1,me===te?g._label.localeCompare(N._label):me-te}else return!B&&J?-1:B&&!J?1:0}}e.TaskSorter=r;var f;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(L){L.SingleRun="singleRun",L.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var T;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(T=e.TaskRunSource||(e.TaskRunSource={}));var H;(function(L){function g(N,B,J,me){if(B){const te={kind:N,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:J,__task:B};return N==="start"?te.resolvedVariables=me:N==="processStarted"?te.processId=me:N==="processEnded"&&(te.exitCode=me),Object.freeze(te)}else return Object.freeze({kind:"changed"})}L.create=g})(H=e.TaskEvent||(e.TaskEvent={}));var Q;(function(L){function g(B){const J=Object.keys(B).sort();let me="";for(const te of J){let oe=B[te];oe instanceof Object?oe=g(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),me+=te+","+oe+","}return me}function N(B){const me={_key:g(B),type:B.taskType};return Object.assign(me,B),me}L.create=N})(Q=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Z;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})(Z=e.TaskSettingId||(e.TaskSettingId={}));var _;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(_=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var j;(function(L){function g(N,B){const J=R.TaskDefinitionRegistry.get(N.type);if(J===void 0){const ce=F.deepClone(N);return delete ce._key,Q.create(ce)}const me=Object.create(null);me.type=J.taskType;const te=new Set;J.required.forEach(ce=>te.add(ce));const oe=J.properties;for(const ce of Object.keys(oe)){const we=N[ce];if(we!=null)me[ce]=we;else if(te.has(ce)){const q=oe[ce];if(q.default!==void 0)me[ce]=F.deepClone(q.default);else switch(q.type){case"boolean":me[ce]=!1;break;case"number":case"integer":me[ce]=0;break;case"string":me[ce]="";break;default:B.error(i.localize(2,null,JSON.stringify(N,void 0,0),ce));return}}}return Q.create(me)}L.createTaskIdentifier=g})(j=e.TaskDefinition||(e.TaskDefinition={}))}),define(ke[204],Te([1,0,11]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((E,R)=>{this.b=E,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(E){this.f||this.h||(this.f=!0,this.g=E,this.a&&this.b(E))}resolveErr(E){this.f||this.h||(this.h=!0,this.i=E,this.a?this.d(E):(0,i.onUnexpectedError)(E))}then(E,R){return this.j().then(E,R)}catch(E){return this.j().then(void 0,E)}finally(E){return this.j().finally(E)}}e.LazyPromise=P;class I extends P{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=I}),define(ke[46],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}i.count=0,e.ProxyIdentifier=i;const P=[];function I(R){const y=new i(R);return P[y.nid]=y,y}e.createProxyIdentifier=I;function F(R){return P[R].sid}e.getStringIdentifierForProxy=F;class E{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=E}),define(ke[5],Te([1,0,46]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var F;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(F=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(s){return s._id=D.a++,s}}D.a=0,e.IdObject=D;var h;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(ke[76],Te([1,0,3,12,5,18]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(y,k){this.c=k,this.a=new Set,this.b=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,k,M){const D=this.d(y,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}d(y,k){return`${y}-${k.identifier.value}`}};E=qe([Ve(0,F.IExtHostRpcService),Ve(1,P.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,k){}})}),define(ke[205],Te([1,0,4,5,7,26]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(y){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,k,M,D={}){const h=F.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(h)||[],m=[...M].sort().join(" ");let o=b.find(s=>s.providerId===k&&s.scopes===m);if(o)return o.result;{const s=this.g(y,h,k,M,D);o={providerId:k,scopes:m,result:s},b.push(o),this.f.set(h,b);try{await s}finally{const u=b.findIndex(p=>p.providerId===k&&p.scopes===m);u>-1&&(b.splice(u),this.f.set(h,b))}return s}}async g(y,k,M,D,h={}){await this.a.$ensureProvider(M);const b=y.displayName||y.name;return this.a.$getSession(M,D,k,b,h)}async removeSession(y,k){const M=this.b.get(y);return M?M.provider.removeSession(k):this.a.$removeSession(y,k)}registerAuthenticationProvider(y,k,M,D){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:k,provider:M,options:D??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:k});const h=M.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,k,D?.supportsMultipleAccounts??!1),new I.Disposable(()=>{h.dispose(),this.b.delete(y);const b=this.c.findIndex(m=>m.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const M=this.b.get(y);if(M)return Promise.resolve(M.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this.d.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(ke[206],Te([1,0,5,18,8]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(R,y){this.a=R.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,k){const M=I.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};F=qe([Ve(0,P.IExtHostRpcService)],F),e.ExtHostBulkEdits=F}),define(ke[207],Te([1,0,5]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(F){const E=F.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(R){return E.$writeText(R)}})}}e.ExtHostClipboard=P});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[37],Te([1,0,9,7,8,22,5,16,12,66,44,260,2,6,3,18,101,23,46,39,77,52,57]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t){"use strict";var d,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(T,H,Q){d.set(this,void 0),this.b=new Map,this.c=new Map,a.set(this,void 0),l.set(this,void 0),Je(this,d,T.getProxy(E.MainContext.MainThreadCommands),"f"),this.d=H,Je(this,l,Q,"f"),Je(this,a,T.getProxy(E.MainContext.MainThreadTelemetry),"f"),this.converter=new w(this,Z=>{const _=this.c.get(Z);return _?.result===r.Void?_:void 0},H),this.f=[{processArgument(Z){return(0,k.revive)(Z)}},{processArgument(Z){return(0,F.cloneAndChange)(Z,function(_){if(M.Range.isIRange(_))return I.Range.to(_);if(D.Position.isIPosition(_))return I.Position.to(_);if(M.Range.isIRange(_.range)&&h.URI.isUri(_.uri))return I.location.to(_);if(_ instanceof u.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(T){this.f.push(T)}registerApiCommand(T){const H=this.registerCommand(!1,T.id,async(...Q)=>{const Z=T.args.map((j,L)=>{if(!j.validate(Q[L]))throw new Error(`Invalid argument '${j.name}' when running '${T.id}', received: ${Q[L]}`);return j.convert(Q[L])}),_=await this.executeCommand(T.internalId,...Z);return T.result.convert(_,Q,this.converter)},void 0,{description:T.description,args:T.args,returns:T.result.description});return this.c.set(T.id,T),new P.Disposable(()=>{H.dispose(),this.c.delete(T.id)})}registerCommand(T,H,Q,Z,_,j){if(this.d.trace("ExtHostCommands#registerCommand",H),!H.trim().length)throw new Error("invalid id");if(this.b.has(H))throw new Error(`command '${H}' already exists`);return this.b.set(H,{callback:Q,thisArg:Z,description:_,extension:j}),T&&Le(this,d,"f").$registerCommand(H),new P.Disposable(()=>{this.b.delete(H)&&T&&Le(this,d,"f").$unregisterCommand(H)})}executeCommand(T,...H){return this.d.trace("ExtHostCommands#executeCommand",T),this.g(T,H,!0)}async g(T,H,Q){if(this.b.has(T))return Le(this,d,"f").$fireCommandActivationEvent(T),this.h(T,H,!1);{let Z=!1;const _=(0,F.cloneAndChange)(H,function(j){if(j instanceof P.Position)return I.Position.from(j);if(j instanceof P.Range)return I.Range.from(j);if(j instanceof P.Location)return I.location.from(j);if(P.NotebookRange.isNotebookRange(j))return I.NotebookRange.from(j);if(j instanceof ArrayBuffer)return Z=!0,u.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return Z=!0,u.VSBuffer.wrap(j);if(j instanceof u.VSBuffer)return Z=!0,j;if(!Array.isArray(j))return j});try{const j=await Le(this,d,"f").$executeCommand(T,Z?new p.SerializableObjectWithBuffers(_):_,Q);return(0,k.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(T,H,!1);throw j}}}async h(T,H,Q){const Z=this.b.get(T);if(!Z)throw new Error("Unknown command");const{callback:_,thisArg:j,description:L}=Z;if(L)for(let N=0;N<L.args.length;N++)try{(0,i.validateConstraint)(H[N],L.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${T}' failed. Illegal argument '${L.args[N].name}' - ${L.args[N].description}`)}const g=O.StopWatch.create();try{return await _.apply(j,H)}catch(N){if(T===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...H);B&&(T=B.command)}if(this.d.error(N,T,Z.extension?.identifier),!Q)throw N;if(Z.extension?.identifier){const B=Le(this,l,"f").onExtensionError(Z.extension.identifier,N);this.d.trace("forwarded error to extension?",B,Z.extension?.identifier)}throw new class extends Error{constructor(){super((0,S.toErrorMessage)(N)),this.id=T,this.source=Z.extension?.displayName??Z.extension?.name}}}finally{this.j(Z,T,g.elapsed())}}j(T,H,Q){!T.extension||Le(this,a,"f").$publicLog2("Extension:ActionExecuted",{extensionId:T.extension.identifier.value,id:new v.TelemetryTrustedValue(H),duration:Q})}$executeContributedCommand(T,...H){this.d.trace("ExtHostCommands#$executeContributedCommand",T);const Q=this.b.get(T);return Q?(H=H.map(Z=>this.f.reduce((_,j)=>j.processArgument(_,Q.extension?.identifier),Z)),this.h(T,H,!0)):Promise.reject(new Error(`Contributed command '${T}' does not exist.`))}getCommands(T=!1){return this.d.trace("ExtHostCommands#getCommands",T),Le(this,d,"f").$getCommands().then(H=>(T&&(H=H.filter(Q=>Q[0]!=="_")),H))}$getContributedCommandHandlerDescriptions(){const T=Object.create(null);for(const[H,Q]of this.b){const{description:Z}=Q;Z&&(T[H]=Z)}return Promise.resolve(T)}};d=new WeakMap,a=new WeakMap,l=new WeakMap,c=qe([Ve(0,o.IExtHostRpcService),Ve(1,y.ILogService),Ve(2,t.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class w{constructor(T,H,Q){this.d=T,this.f=H,this.g=Q,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(T,H){if(!T)return;const Q={$ident:void 0,id:T.command,title:T.title,tooltip:T.tooltip};if(!T.command)return Q;const Z=this.f(T.command);if(Z)Q.id=Z.internalId,Q.arguments=Z.args.map((_,j)=>_.convert(T.arguments&&T.arguments[j]));else if((0,R.isNonEmptyArray)(T.arguments)){const _=`${T.command}/${++this.c}`;this.b.set(_,T),H.add((0,b.toDisposable)(()=>{this.b.delete(_),this.g.trace("CommandsConverter#DISPOSE",_)})),Q.$ident=_,Q.id=this.delegatingCommandId,Q.arguments=[_],this.g.trace("CommandsConverter#CREATE",T.command,_)}return Q}fromInternal(T){return typeof T.$ident=="string"?this.b.get(T.$ident):{command:T.id,title:T.title,arguments:T.arguments}}getActualCommand(...T){return this.b.get(T[0])}h(...T){const H=this.getActualCommand(...T);return this.g.trace("CommandsConverter#EXECUTE",T[0],H?H.command:"MISSING"),H?this.d.executeCommand(H.command,...H.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${T[0]}`)}}e.CommandsConverter=w;class n{constructor(T,H,Q,Z){this.name=T,this.description=H,this.validate=Q,this.convert=Z}optional(){return new n(this.name,`(optional) ${this.description}`,T=>T==null||this.validate(T),T=>T===void 0?void 0:T===null?null:this.convert(T))}with(T,H){return new n(T??this.name,H??this.description,this.validate,this.convert)}}n.Uri=new n("uri","Uri of a text document",A=>h.URI.isUri(A),A=>A),n.Position=new n("position","A position in a text document",A=>P.Position.isPosition(A),I.Position.from),n.Range=new n("range","A range in a text document",A=>P.Range.isRange(A),I.Range.from),n.Selection=new n("selection","A selection in a text document",A=>P.Selection.isSelection(A),I.Selection.from),n.Number=new n("number","",A=>typeof A=="number",A=>A),n.String=new n("string","",A=>typeof A=="string",A=>A),n.CallHierarchyItem=new n("item","A call hierarchy item",A=>A instanceof P.CallHierarchyItem,I.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",A=>A instanceof P.TypeHierarchyItem,I.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",A=>A instanceof s.TestItemImpl,I.TestItem.from),e.ApiCommandArgument=n;class r{constructor(T,H){this.description=T,this.convert=H}}r.Void=new r("no result",A=>A),e.ApiCommandResult=r;class f{constructor(T,H,Q,Z,_){this.id=T,this.internalId=H,this.description=Q,this.args=Z,this.result=_}}e.ApiCommand=f}),define(ke[208],Te([1,0,2,8,7,75,37,16,88,92,15]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(P.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,s)=>{if((0,R.isFalsyOrEmpty)(o))return;class u extends I.SymbolInformation{static to(S){const O=new u(S.name,P.SymbolKind.to(S.kind),S.containerName||"",new I.Location(s[0],P.Range.to(S.range)));return O.detail=S.detail,O.range=O.location.range,O.selectionRange=P.Range.to(S.selectionRange),O.children=S.children?S.children.map(u.to):[],O}}return o.map(u.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(P.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(P.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(P.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(P.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(P.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(s=>I.Position.isPosition(s)),o=>o.map(P.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(s=>{let u;for(const p of s.reverse())u=new I.SelectionRange(P.Range.to(p),u);return u}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(P.WorkspaceSymbol.to))),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(P.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(P.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(P.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to a range and placeholder text.",o=>{if(!!o)return{range:P.Range.to(o.range),placeholder:o.text}})),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return P.WorkspaceEdit.to(o)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(P.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,y.decodeSemanticTokensDto)(o);if(s.type==="full")return new I.SemanticTokens(s.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range.optional()],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,y.decodeSemanticTokensDto)(o);if(s.type==="full")return new I.SemanticTokens(s.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,s,u)=>{if(!o)return new I.CompletionList([]);const p=o.suggestions.map(S=>P.CompletionItem.to(S,u));return new I.CompletionList(p,o.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return P.SignatureHelp.to(o)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,s,u)=>b(p=>new I.CodeLens(P.Range.to(p.range),p.command&&u.fromInternal(p.command)))(o))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.Range.isRange(o),o=>I.Selection.isSelection(o)?P.Selection.from(o):P.Range.from(o)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,s,u)=>b(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(p.command)}else{const S=new I.CodeAction(p.title,p.kind?new I.CodeActionKind(p.kind):void 0);return p.edit&&(S.edit=P.WorkspaceEdit.to(p.edit)),p.command&&(S.command=u.fromInternal(p.command)),S.isPreferred=p.isPreferred,S}})(o))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(s=>new I.ColorInformation(P.Range.to(s.range),P.Color.to(s.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",o=>o instanceof I.Color,P.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:P.Range.from(o.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(P.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",(o,s,u)=>o.map(P.InlayHint.to.bind(void 0,u)))),new E.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(o,s)=>{if(o)return o.map(P.FoldingRange.to)})),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(s=>P.NotebookExclusiveDocumentPattern.to(s))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(P.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new E.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",o=>i.URI.isUri(o)||typeof o=="string"&&(0,k.matchesSomeScheme)(o,M.Schemas.http,M.Schemas.https),o=>o),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[P.ViewColumn.from(o),void 0]:[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[P.ViewColumn.from(o),void 0]:[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[P.ViewColumn.from(o.viewColumn),P.TextEditorOpenOptions.from(o)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(P.TypeHierarchyItem.to))),new E.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[E.ApiCommandArgument.TestItem],E.ApiCommandResult.Void),new E.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[E.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],E.ApiCommandResult.Void),new E.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[E.ApiCommandArgument.String.with("name","The context key name"),new E.ApiCommandArgument("value","The context key value",()=>!0,o=>o)],E.ApiCommandResult.Void)];class h{static register(s){D.forEach(s.registerApiCommand,s)}}e.ExtHostApiCommands=h;function b(o){return s=>{if(Array.isArray(s))return s.map(o)}}function m(o){if(!Array.isArray(o))return;const s=[];for(const u of o)F.isLocationLink(u)?s.push(P.DefinitionLink.to(u)):s.push(P.location.to(u));return s}}),define(ke[209],Te([1,0,17,64,4,6,2,75,26,8,7,5]),function(ne,e,i,P,I,F,E,R,y,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(b,m,o){const s=b.getProxy(D.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const w=this.b.get(c.handle);return w?w.value:c}else if(c&&c.$mid===7){const w=this.b.get(c.commentControlHandle);if(!w)return c;const n=w.getCommentThread(c.commentThreadHandle);return n?n.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const w=this.b.get(c.thread.commentControlHandle);if(!w)return c;const n=w.getCommentThread(c.thread.commentThreadHandle);return n?c.$mid===8?n.value:{thread:n.value,text:c.text}:c}else if(c&&c.$mid===10){const w=this.b.get(c.thread.commentControlHandle);if(!w)return c;const n=w.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const r=c.commentUniqueId,f=n.getCommentByUniqueId(r);return f||c}else if(c&&c.$mid===11){const w=this.b.get(c.thread.commentControlHandle);if(!w)return c;const n=w.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const r=c.text,f=c.commentUniqueId,A=n.getCommentByUniqueId(f);return A?(typeof A.body=="string"?A.body=r:A.body=new M.MarkdownString(r),A):c}return c}})}createCommentController(c,w,n){const r=u.a++,f=new S(c,r,w,n);this.b.set(f.handle,f);const A=this.c.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return A.push(f),this.c.set(y.ExtensionIdentifier.toKey(c.identifier),A),f.value}$createCommentThreadTemplate(c,w,n){const r=this.b.get(c);!r||r.$createCommentThreadTemplate(w,n)}async $updateCommentThreadTemplate(c,w,n){const r=this.b.get(c);!r||r.$updateCommentThreadTemplate(w,n)}$deleteCommentThread(c,w){this.b.get(c)?.$deleteCommentThread(w)}$provideCommentingRanges(c,w,n){const r=this.b.get(c);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const f=o.getDocument(E.URI.revive(w));return(0,i.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(f,n)).then(A=>A?A.map(T=>k.Range.from(T)):void 0)}$toggleReaction(c,w,n,r,f){const A=this.b.get(c);return!A||!A.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const T=A.getCommentThread(w);if(T){const H=T.getCommentByUniqueId(r.uniqueIdInThread);if(A!==void 0&&H&&A.reactionHandler)return A.reactionHandler(H,t(f))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class p{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,w,n,r,f,A,T,H){this.m=w,this.n=n,this.o=r,this.p=f,this.q=A,this.extensionDescription=T,this.r=H,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.MutableDisposable,this.l.value=new F.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),s.$createCommentThread(w,this.handle,this.n,this.o,k.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=A,this.i.push({dispose:()=>{s.$deleteCommentThread(w,this.handle)}});const Q=this;this.value={get uri(){return Q.uri},get range(){return Q.range},set range(Z){Q.range=Z},get comments(){return Q.comments},set comments(Z){Q.comments=Z},get collapsibleState(){return Q.collapsibleState},set collapsibleState(Z){Q.collapsibleState=Z},get canReply(){return Q.canReply},set canReply(Z){Q.canReply=Z},get contextValue(){return Q.contextValue},set contextValue(Z){Q.contextValue=Z},get label(){return Q.label},set label(Z){Q.label=Z},get state(){return Q.state},set state(Z){Q.state=Z},dispose:()=>{Q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.DisposableStore);const c=n=>Object.prototype.hasOwnProperty.call(this.b,n),w={};c("range")&&(w.range=k.Range.from(this.p)),c("label")&&(w.label=this.label),c("contextValue")&&(w.contextValue=this.contextValue??null),c("comments")&&(w.comments=this.q.map(n=>O(this,n,this.k))),c("collapsibleState")&&(w.collapseState=d(this.g)),c("canReply")&&(w.canReply=this.canReply),c("state")&&(w.state=a(this.h)),c("isTemplate")&&(w.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,w)}getCommentByUniqueId(c){for(const w of this.k){const n=w[0],r=w[1];if(c===r)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}p.a=0,qe([(0,P.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,w,n,r){this.f=c,this.g=w,this.h=n,this.i=r,this.a=new Map,s.$registerCommentController(this.handle,n,r);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(A){f.options=A},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(A){f.commentingRangeProvider=A},get reactionHandler(){return f.reactionHandler},set reactionHandler(A){f.reactionHandler=A},createCommentThread(A,T,H){return f.createCommentThread(A,T,H).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(c,w,n,r){if(typeof c=="string"){const f=new p(this.id,this.handle,c,w,n,r,this.f,!1);return this.a.set(f.handle,f),f}else{const f=new p(this.id,this.handle,void 0,c,w,n,this.f,!1);return this.a.set(f.handle,f),f}}$createCommentThreadTemplate(c,w){const n=new p(this.id,this.handle,void 0,E.URI.revive(c),k.Range.to(w),[],this.f,!0);return n.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(c,w){const n=this.a.get(c);n&&(n.range=k.Range.to(w))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function O(l,c,w){let n=w.get(c);n||(n=++l.commentHandle,w.set(c,n));const r=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:typeof c.body=="string"?c.body:k.MarkdownString.from(c.body),userName:c.author.name,userIconPath:r,label:c.label,commentReactions:c.reactions?c.reactions.map(f=>v(f)):void 0,timestamp:c.timestamp?.toJSON()}}function v(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function t(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?E.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case M.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function a(l){if(l!==void 0)switch(l){case M.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new u}e.createExtHostComments=h}),define(ke[210],Te([1,0,22,5,27,18]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let E=class{constructor(M,D){this.a=M.getProxy(P.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,D){const h=this,b=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){h.e(M,D,b,arguments)}})}e(M,D,h,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:y(b,this.b)}),this.c&&this.f(M,h,b)}};E=qe([Ve(0,F.IExtHostRpcService),Ve(1,I.IExtHostInitDataService)],E),e.AbstractExtHostConsoleForwarder=E;const R=1e5;function y(k,M){const D=[];if(k.length)for(let h=0;h<k.length;h++){let b=k[h];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}D.push(b)}if(M){const h=new Error().stack;h&&D.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,i.safeStringify)(D);return h.length>R?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(ke[103],Te([1,0,2,5,7,3,18,12,16,10,19,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class Mi{constructor(m,o){this.h=o,this.f=new Map,this.g=m.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,o){const s=Mi.c++;this.f.set(s,{provider:m,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const u=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(s,null);return}const S=(0,y.asArray)(p);if(S.length<=Mi.d){this.g.$onDidChange(s,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,S.length);const O=S.map(d=>({uri:d,rank:(0,k.count)(d.path,"/")})),v=(0,y.groupBy)(O,(d,a)=>d.rank-a.rank||(0,k.compare)(d.uri.path,a.uri.path)),t=[];e:for(const d of v){let a;for(const l of d){const c=(0,M.dirname)(l.uri.path);if(a!==c&&(a=c,t.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(s,t)});return new I.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(m,o,s){if(!this.f.has(m))return Object.create(null);const u=Object.create(null),{provider:p,extensionDescription:S}=this.f.get(m);return await Promise.all(o.map(async O=>{try{const{uri:v,id:t}=O,d=await Promise.resolve(p.provideFileDecoration(i.URI.revive(v),s));if(!d)return;try{I.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,D.checkProposedApiEnabled)(S,"codiconDecoration"),u[t]=[d.propagate,d.tooltip,d.badge,d.color]}catch(a){this.h.warn(`INVALID decoration from extension '${S}': ${a}`)}}catch(v){this.h.error(v)}})),u}};h.c=0,h.d=250,h=qe([Ve(0,E.IExtHostRpcService),Ve(1,R.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[211],Te([1,0,139,91,2,5,7,8,4,12,28,36]),function(ne,e,i,P,I,F,E,R,y,k,M,D){"use strict";var h,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class o{constructor(p,S,O,v,t,d,a){this.d=p,this.e=S,this.f=O,this.g=v,h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new M.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,h,d,"f"),Je(this,b,a,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,h,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,S){if(!p){this.clear();return}this.h();let O=[];if(I.URI.isUri(p)){if(!S){this.delete(p);return}Le(this,m,"f").set(p,S.slice()),O=[p]}else if(Array.isArray(p)){O=[];let t;p=[...p].sort(o.j);for(const d of p){const[a,l]=d;if((!t||a.toString()!==t.toString())&&(t&&Le(this,m,"f").get(t).length===0&&Le(this,m,"f").delete(t),t=a,O.push(a),Le(this,m,"f").set(a,[])),l)Le(this,m,"f").get(a)?.push(...l);else{const c=Le(this,m,"f").get(a);c&&(c.length=0)}}}if(Le(this,b,"f").fire(O),!Le(this,h,"f"))return;const v=[];for(const t of O){let d=[];const a=Le(this,m,"f").get(t);if(a)if(a.length>this.f){d=[];const l=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const w of a)if(w.severity===l[c]&&d.push({...R.Diagnostic.from(w),modelVersionId:this.g(t)})===this.f)break e;d.push({severity:P.MarkerSeverity.Info,message:(0,i.localize)(0,null,a.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=a.map(l=>({...R.Diagnostic.from(l),modelVersionId:this.g(t)}));v.push([t,d])}Le(this,h,"f").$changeMany(this.e,v)}delete(p){this.h(),Le(this,b,"f").fire([p]),Le(this,m,"f").delete(p),Le(this,h,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,h,"f")?.$clear(this.e)}forEach(p,S){this.h();for(const[O,v]of this)p.call(S,O,v,this)}*[(h=new WeakMap,b=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const p of Le(this,m,"f").keys())yield[p,this.get(p)]}get(p){this.h();const S=Le(this,m,"f").get(p);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(p){return this.h(),Array.isArray(Le(this,m,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,S){return p[0].toString()<S[0].toString()?-1:p[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=o;let s=class pi{static _mapper(p){const S=new M.ResourceMap;for(const O of p)S.set(O,O);return{uris:Object.freeze(Array.from(S.values()))}}constructor(p,S,O,v){this.h=S,this.j=O,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,S){const{f:O,e:v,g:t,h:d,j:a,k:l}=this,c=new class{$changeMany(r,f){v.$changeMany(r,f),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,r,f.length===0?"CLEARING":f)}$clear(r){v.$clear(r),d.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,r)}dispose(){v.dispose()}};let w;if(!S)S="_generated_diagnostic_collection_name_#"+pi.c++,w=S;else if(!O.has(S))w=S;else{this.h.warn(`DiagnosticCollection with name '${S}' does already exist.`);do w=S+pi.c++;while(O.has(w))}return new class extends o{constructor(){super(S,w,pi.d,r=>l.getDocument(r)?.version,a.extUri,c,t),O.set(w,this)}dispose(){super.dispose(),O.delete(w)}}}getDiagnostics(p){if(p)return this.l(p);{const S=new Map,O=[];for(const v of this.f.values())v.forEach((t,d)=>{let a=S.get(t.toString());typeof a>"u"&&(a=O.length,S.set(t.toString(),a),O.push([t,[]])),O[a][1]=O[a][1].concat(...d)});return O}}l(p){let S=[];for(const O of this.f.values())O.has(p)&&(S=S.concat(O.get(p)));return S}$acceptMarkersChange(p){if(!this.m){const S="_generated_mirror",O=new o(S,S,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(S,O),this.m=O}for(const[S,O]of p)this.m.set(I.URI.revive(S),O.map(R.Diagnostic.to))}};s.c=0,s.d=1e3,s=qe([Ve(1,k.ILogService),Ve(2,D.IExtHostFileSystemInfo)],s),e.ExtHostDiagnostics=s}),define(ke[212],Te([1,0,2,5,25]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(R){this.a=R.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(R,y){return y?.allowUIResources&&(0,I.checkProposedApiEnabled)(R,"showLocal"),this.a.$showOpenDialog(y).then(k=>k?k.map(M=>i.URI.revive(M)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(y=>y?i.URI.revive(y):void 0)}}e.ExtHostDialogs=F}),define(ke[213],Te([1,0,11,2,7,5,15,21,10]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,h,b){this.d=h,this.e=b,this.b=new Map,this.c=D.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,h){if(Object.keys(E.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=k.a++;this.b.set(b,h),this.c.$registerTextContentProvider(b,D);let m;return typeof h.onDidChange=="function"&&(m=h.onDidChange(o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this.d.getDocument(o)&&this.$provideTextDocumentContent(b,o).then(s=>{if(!s&&typeof s!="string")return;const u=this.d.getDocument(o);if(!u)return;const p=(0,y.splitLines)(s);if(!u.equalLines(p))return this.c.$onVirtualDocumentChange(o,s)},i.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(D,h){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(P.URI.revive(h),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(ke[214],Te([1,0,4,6,2,5,99,8,9,22,7]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,m){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.DisposableStore,this.h=new Map,this.f=b.getProxy(F.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(o=>{for(const s of o)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const s of o)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let o=this.h.get(b.toString());return o||(o=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const u=I.URI.revive(s);return(0,y.assertIsDefined)(this.g.getDocument(u))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),o)),o}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>I.URI.revive(m))}$acceptModelLanguageChanged(b,m){const o=I.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(m),this.a.fire(s.document)}$acceptModelSaved(b){const m=I.URI.revive(b),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(b,m){const o=I.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,o){const s=I.URI.revive(b),u=this.g.getDocument(s);if(!u)throw new Error("unknown document");u._acceptIsDirty(o),u.onEvents(m);let p;m.isUndoing?p=M.TextDocumentChangeReason.Undo:m.isRedoing&&(p=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:u.document,contentChanges:m.changes.map(S=>({range:R.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:p}))}setWordDefinitionFor(b,m){(0,E.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=D}),define(ke[58],Te([1,0,49,4,6,2,3,5,99,18,102,8,12,28,15,186,85]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(O){this.value=O,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(O,v){this.h=O,this.i=v,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new P.Emitter,this.e=new P.Emitter,this.f=new P.Emitter,this.g=new P.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(O){this.acceptDocumentsAndEditorsDelta(O)}acceptDocumentsAndEditorsDelta(O){const v=[],t=[],d=[];if(O.removedDocuments)for(const a of O.removedDocuments){const l=F.URI.revive(a),c=this.c.get(l);c?.unref()&&(this.c.delete(l),v.push(c.value))}if(O.addedDocuments)for(const a of O.addedDocuments){const l=F.URI.revive(a.uri);let c=this.c.get(l);if(c&&l.scheme!==m.Schemas.vscodeNotebookCell&&l.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new u(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),l,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(l,c),t.push(c.value)),c.ref()}if(O.removedEditors)for(const a of O.removedEditors){const l=this.b.get(a);this.b.delete(a),l&&d.push(l)}if(O.addedEditors)for(const a of O.addedEditors){const l=F.URI.revive(a.documentUri);i.ok(this.c.has(l),`document '${l}' does not exist`),i.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(l).value,w=new M.ExtHostTextEditor(a.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new s.Lazy(()=>c.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(n=>D.Range.to(n)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,w)}O.newActiveEditor!==void 0&&(i.ok(O.newActiveEditor===null||this.b.has(O.newActiveEditor),`active editor '${O.newActiveEditor}' does not exist`),this.a=O.newActiveEditor),(0,I.dispose)(v),(0,I.dispose)(d),O.removedDocuments&&this.e.fire(v),O.addedDocuments&&this.d.fire(t),(O.removedEditors||O.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),O.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(O){return this.c.get(O)?.value}allDocuments(){return o.Iterable.map(this.c.values(),O=>O.value)}getEditor(O){return this.b.get(O)}activeEditor(O){if(!this.a)return;const v=this.b.get(this.a);return O?v:v?.value}allEditors(){return[...this.b.values()]}};p=qe([Ve(0,k.IExtHostRpcService),Ve(1,h.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[59],Te([1,0,8,5,2,4,3,7,18,9,63]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class D{constructor(s,u,p){this.e=p,this.d=u,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,u={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(s,u){this.c=[],this.d="",this.b=s,this.e=u;for(const p of s.tabs)p.isActive&&(this.d=p.id),this.c.push(new D(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,u={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return i.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(p=>p.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(p=>p.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const p=new D(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,p),s.tabDto.isActive&&(this.d=p.tabId),p}else if(s.kind===1){const p=this.c.splice(s.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(s.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,p),p}const u=this.c.find(p=>p.tabId===s.tabDto.id);if(!u)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(s.tabDto),u}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new F.Emitter,this.c=new F.Emitter,this.e=[],this.a=s.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,u={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(p=>p.apiObject))},get activeTabGroup(){const p=s.d;return(0,k.assertIsDefined)(s.e.find(O=>O.groupId===p)?.apiObject)},close:async(p,S)=>{const O=Array.isArray(p)?p:[p];return O.length?m(O[0])?this.j(O,S):this.i(O,S):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(s){const u=new Set(this.e.map(a=>a.groupId)),p=new Set(s.map(a=>a.groupId)),S=(0,M.diffSets)(u,p),O=this.e.filter(a=>S.removed.includes(a.groupId)).map(a=>a.apiObject),v=[],t=[];this.e=s.map(a=>{const l=new h(a,()=>this.d);return S.added.includes(l.groupId)?v.push(l.apiObject):t.push(l.apiObject),l});const d=(0,k.assertIsDefined)(s.find(a=>a.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:v,closed:O,changed:t}))}$acceptTabGroupUpdate(s){const u=this.e.find(p=>p.groupId===s.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const u=this.e.find(S=>S.groupId===s.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const p=u.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(s){for(const u of this.e)for(const p of u.tabs)if(p.apiObject===s)return p}h(s){return this.e.find(u=>u.apiObject===s)}async i(s,u){const p=[];for(const S of s){const O=this.g(S);if(!O)throw new Error("Tab close: Invalid tab not found!");p.push(O.tabId)}return this.a.$closeTab(p,u)}async j(s,u){const p=[];for(const S of s){const O=this.h(S);if(!O)throw new Error("Group close: Invalid group not found!");p.push(O.groupId)}return this.a.$closeGroup(p,u)}};b=qe([Ve(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function m(o){return o.tabs!==void 0}}),define(ke[215],Te([1,0,2,5,6,7,8,261,10,23,25]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const o=this.a.indexOf(m);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),o=[];let s,u,p=14,S=14;for(const O of m){let v=s?(0,y.commonPrefixLength)(s,O):0;for(v===0?u=1:u=S;v<O.length;v++)v+1===O.length?(p=S,S=9):S+=1,o.push([u,O.toUpperCase().charCodeAt(v),S]),o.push([u,O.toLowerCase().charCodeAt(v),S]),u=S;s=O,S=p}o.push([9,58,10]),o.push([10,47,12]),this.b=new R.StateMachine(o)}}provideDocumentLinks(m){this.c();const o=[],s=R.LinkComputer.computeLinks({getLineContent(u){return m.lineAt(u-1).text},getLineCount(){return m.lineCount}},this.b);for(const u of s){const p=E.DocumentLink.to(u);p.target&&o.push(p)}return o}}class h{constructor(m,o){this.i=o,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,o,s,u={}){if(h.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const p=this.h++;this.b.add(o),this.d.add(o),this.c.set(p,s);let S=2;u.isCaseSensitive&&(S+=1024),u.isReadonly&&(S+=2048),typeof s.copy=="function"&&(S+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,M.checkProposedApiEnabled)(m,"fsChunks"),S+=4),this.a.$registerFileSystemProvider(p,o,S).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${o}`),console.error(v)});const O=s.onDidChangeFile(v=>{const t=[];for(const d of v){const{uri:a,type:l}=d;if(a.scheme!==o)continue;let c;switch(l){case F.FileChangeType.Changed:c=0;break;case F.FileChangeType.Created:c=1;break;case F.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:a,type:c})}this.a.$onFileSystemChange(p,t)});return(0,I.toDisposable)(()=>{O.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(m){if(!m)throw new Error("MISSING provider");if(typeof m.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof m.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof m.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof m.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof m.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof m.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof m.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof m.rename!="function")throw new Error("Provider does NOT implement rename")}static k(m){const{type:o,ctime:s,mtime:u,size:p,permissions:S}=m;return{type:o,ctime:s,mtime:u,size:p,permissions:S}}$stat(m,o){return Promise.resolve(this.l(m).stat(i.URI.revive(o))).then(s=>h.k(s))}$readdir(m,o){return Promise.resolve(this.l(m).readDirectory(i.URI.revive(o)))}$readFile(m,o){return Promise.resolve(this.l(m).readFile(i.URI.revive(o))).then(s=>k.VSBuffer.wrap(s))}$writeFile(m,o,s,u){return Promise.resolve(this.l(m).writeFile(i.URI.revive(o),s.buffer,u))}$delete(m,o,s){return Promise.resolve(this.l(m).delete(i.URI.revive(o),s))}$rename(m,o,s,u){return Promise.resolve(this.l(m).rename(i.URI.revive(o),i.URI.revive(s),u))}$copy(m,o,s,u){const p=this.l(m);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(o),i.URI.revive(s),u))}$mkdir(m,o){return Promise.resolve(this.l(m).createDirectory(i.URI.revive(o)))}$watch(m,o,s,u){const p=this.l(m).watch(i.URI.revive(s),u);this.f.set(o,p)}$unwatch(m,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(m,o,s){const u=this.l(m);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(i.URI.revive(o),s))}$close(m,o){const s=this.l(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(m,o,s,u){const p=this.l(m);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(u);return Promise.resolve(p.read(o,s,S.buffer,0,u)).then(O=>S.slice(0,O))}$write(m,o,s,u){const p=this.l(m);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(o,s,u.buffer,0,u.byteLength))}l(m){const o=this.c.get(m);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.ExtHostFileSystem=h}),define(ke[60],Te([1,0,5,43,7,23,3,18,36,6]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class Yt{constructor(h,b){this.b=new Map,this.a=h.getProxy(i.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(o){try{const s=m.b.get(o.scheme);if(!s)return await m.a.$stat(o);await m.a.$ensureActivation(o.scheme);const u=await s.stat(o);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(s){Yt.c(s)}},async readDirectory(o){try{const s=m.b.get(o.scheme);return s?(await m.a.$ensureActivation(o.scheme),(await s.readDirectory(o)).slice()):await m.a.$readdir(o)}catch(s){return Yt.c(s)}},async createDirectory(o){try{return await m.a.$mkdir(o)}catch(s){return Yt.c(s)}},async readFile(o){try{const s=m.b.get(o.scheme);return s?(await m.a.$ensureActivation(o.scheme),(await s.readFile(o)).slice()):(await m.a.$readFile(o)).buffer}catch(s){return Yt.c(s)}},async writeFile(o,s){try{return await m.a.$writeFile(o,F.VSBuffer.wrap(s))}catch(u){return Yt.c(u)}},async delete(o,s){try{const u=m.b.get(o.scheme);return u?(await m.a.$ensureActivation(o.scheme),await u.delete(o,{recursive:!1,...s})):await m.a.$delete(o,{recursive:!1,useTrash:!1,...s})}catch(u){return Yt.c(u)}},async rename(o,s,u){try{return await m.a.$rename(o,s,{overwrite:!1,...u})}catch(p){return Yt.c(p)}},async copy(o,s,u){try{return await m.a.$copy(o,s,{overwrite:!1,...u})}catch(p){return Yt.c(p)}},isWritableFileSystem(o){const s=b.getCapabilities(o);if(typeof s=="number")return!(s&2048)}})}static c(h){if(h instanceof I.FileSystemError)throw h;if(!(h instanceof Error))throw new I.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw I.FileSystemError.Unavailable(h.message);switch(h.name){case P.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(h.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(h.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(h.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(h.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(h.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(h.message);default:throw new I.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,b){return this.b.set(h,b),(0,k.toDisposable)(()=>this.b.delete(h))}};M=qe([Ve(0,R.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[216],Te([1,0,4,35,2,5,8,7]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,h,b,m,o,s,u,p){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const S=this.h(D,b,o);this.g=0,s&&(this.g+=1),u&&(this.g+=2),p&&(this.g+=4);const O=(0,P.parse)(o),v=typeof o=="string",t=m(d=>{if(!s)for(const a of d.created){const l=I.URI.revive(a);O(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this.a.fire(l)}if(!u)for(const a of d.changed){const l=I.URI.revive(a);O(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this.b.fire(l)}if(!p)for(const a of d.deleted){const l=I.URI.revive(a);O(l.fsPath)&&(!v||h.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=R.Disposable.from(S,this.a,this.b,this.c,t)}h(D,h,b){const m=R.Disposable.from();if(typeof b=="string")return m;const o=D.getProxy(F.MainContext.MainThreadFileSystem);let s=!1;(b.pattern.includes(P.GLOBSTAR)||b.pattern.includes(P.GLOB_SPLIT))&&(s=!0);const u=Math.random();return o.$watch(h.identifier.value,u,b.baseUri,{recursive:s,excludes:[]}),R.Disposable.from({dispose:()=>o.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,h,b){this.j=D,this.k=h,this.l=b,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,h,b,m,o,s){return new y(this.j,D,h,this.a.event,E.GlobPattern.from(b),m,o,s)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,h){switch(D){case 2:this.b.fire(Object.freeze({files:h.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(b=>I.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,h){return(b,m,o)=>{const s=function(p){b.call(m,p)};return s.extension=D,h.event(s,void 0,o)}}async $onWillRunFileOperation(D,h,b,m){switch(D){case 2:return await this.n(this.g,{files:h.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))},b,m);case 1:return await this.n(this.i,{files:h.map(o=>I.URI.revive(o.target))},b,m);case 0:case 3:return await this.n(this.h,{files:h.map(o=>I.URI.revive(o.target))},b,m)}}async n(D,h,b,m){const o=new Set,s=[];if(await D.fireAsync(h,m,async(p,S)=>{const O=Date.now(),v=await Promise.resolve(p);v instanceof R.WorkspaceEdit&&(s.push([S.extension,v]),o.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-O>b&&this.k.warn("SLOW file-participant",S.extension.identifier)}),m.isCancellationRequested||s.length===0)return;const u={edits:[]};for(const[,p]of s){const{edits:S}=E.WorkspaceEdit.from(p,{getTextDocumentVersion:O=>this.l.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(S)}return{edit:u,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=k}),define(ke[217],Te([1,0,2,37]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(E,R,y,k,M){this.a=R,this.b=y,this.c=k;const D=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new P.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new P.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new P.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new P.ApiCommandResult("Notebook and input URI",h=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const b=this.a.getEditorById(h.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri),notebookEditor:b.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:i.URI.revive(h.notebookUri),inputUri:i.URI.revive(h.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(E,R,y,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:E,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(E,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[E]})}}e.ExtHostInteractive=I}),define(ke[218],Te([1,0,6,5]),function(ne,e,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(E){this.b=0,this.a=E.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,E),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=I}),define(ke[219],Te([1,0,2,22,8,7,75,5,10,44,16,9,262,21,6,88,83,54,77,11,17,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(C,$){this.d=C,this.e=$}async provideDocumentSymbols(C,$){const W=this.d.getDocument(C),V=await this.e.provideDocumentSymbols(W,$);if(!(0,M.isFalsyOrEmpty)(V))return V[0]instanceof F.DocumentSymbol?V.map(I.DocumentSymbol.from):t.f(V)}static f(C){C=C.slice(0).sort((V,ie)=>{let fe=V.location.range.start.compareTo(ie.location.range.start);return fe===0&&(fe=ie.location.range.end.compareTo(V.location.range.end)),fe});const $=[],W=[];for(const V of C){const ie={name:V.name||"!!MISSING: name!!",kind:I.SymbolKind.from(V.kind),tags:V.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:I.Range.from(V.location.range),selectionRange:I.Range.from(V.location.range),children:[]};for(;;){if(W.length===0){W.push(ie),$.push(ie);break}const fe=W[W.length-1];if(k.Range.containsRange(fe.range,ie.range)&&!k.Range.equalsRange(fe.range,ie.range)){fe.children?.push(ie),W.push(ie);break}W.pop()}}return $}}class d{constructor(C,$,W){this.g=C,this.h=$,this.j=W,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(C,$){const W=this.g.getDocument(C),V=await this.j.provideCodeLenses(W,$);if(!V||$.isCancellationRequested)return;const ie=this.e.add(V),fe=new m.DisposableStore;this.f.set(ie,fe);const De={cacheId:ie,lenses:[]};for(let ue=0;ue<V.length;ue++)De.lenses.push({cacheId:[ie,ue],range:I.Range.from(V[ue].range),command:this.h.toInternal(V[ue].command,fe)});return De}async resolveCodeLens(C,$){const W=C.cacheId&&this.e.get(...C.cacheId);if(!W)return;let V;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?V=W:V=await this.j.resolveCodeLens(W,$),V||(V=W),$.isCancellationRequested)return;const ie=C.cacheId&&this.f.get(C.cacheId[0]);if(!!ie)return C.command=this.h.toInternal(V.command??d.d,ie),C}releaseCodeLenses(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}}d.d={command:"missing",title:"!!MISSING: command!!"};function a(ee){return Array.isArray(ee)?ee.map(I.DefinitionLink.from):ee?[I.DefinitionLink.from(ee)]:[]}class l{constructor(C,$){this.d=C,this.e=$}async provideDefinition(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideDefinition(V,ie,W);return a(fe)}}class c{constructor(C,$){this.d=C,this.e=$}async provideDeclaration(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideDeclaration(V,ie,W);return a(fe)}}class w{constructor(C,$){this.d=C,this.e=$}async provideImplementation(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideImplementation(V,ie,W);return a(fe)}}class n{constructor(C,$){this.d=C,this.e=$}async provideTypeDefinition(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideTypeDefinition(V,ie,W);return a(fe)}}class r{constructor(C,$){this.d=C,this.e=$}async provideHover(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideHover(V,ie,W);if(!(!fe||(0,M.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=V.getWordRangeAtPosition(ie)),fe.range||(fe.range=new F.Range(ie,ie)),I.Hover.from(fe)}}class f{constructor(C,$){this.d=C,this.e=$}async provideEvaluatableExpression(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideEvaluatableExpression(V,ie,W);if(fe)return I.EvaluatableExpression.from(fe)}}class A{constructor(C,$){this.d=C,this.e=$}async provideInlineValues(C,$,W,V){const ie=this.d.getDocument(C),fe=await this.e.provideInlineValues(ie,I.Range.to($),I.InlineValueContext.to(W),V);if(Array.isArray(fe))return fe.map(De=>I.InlineValue.from(De))}}class T{constructor(C,$){this.d=C,this.e=$}async provideDocumentHighlights(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideDocumentHighlights(V,ie,W);if(Array.isArray(fe))return fe.map(I.DocumentHighlight.from)}}class H{constructor(C,$){this.d=C,this.e=$}async provideLinkedEditingRanges(C,$,W){const V=this.d.getDocument(C),ie=I.Position.to($),fe=await this.e.provideLinkedEditingRanges(V,ie,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,M.coalesce)(fe.ranges.map(I.Range.from)),wordPattern:fe.wordPattern}}}class Q{constructor(C,$){this.d=C,this.e=$}async provideReferences(C,$,W,V){const ie=this.d.getDocument(C),fe=I.Position.to($),De=await this.e.provideReferences(ie,fe,W,V);if(Array.isArray(De))return De.map(I.location.from)}}class Z{constructor(C,$,W,V,ie,fe,De){this.g=C,this.h=$,this.j=W,this.k=V,this.l=ie,this.m=fe,this.n=De,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(C,$,W,V){const ie=this.g.getDocument(C),fe=h.Selection.isISelection($)?I.Selection.to($):I.Range.to($),De=[];for(const it of this.j.getDiagnostics(C))if(fe.intersection(it.range)&&De.push(it)>Z.d)break;const ue={diagnostics:De,only:W.only?new F.CodeActionKind(W.only):void 0,triggerKind:I.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(ie,fe,ue,V);if(!(0,M.isNonEmptyArray)(ve)||V.isCancellationRequested)return;const be=this.e.add(ve),He=new m.DisposableStore;this.f.set(be,He);const je=[];for(let it=0;it<ve.length;it++){const Xe=ve[it];!Xe||(Z.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,He)})):(ue.only&&(Xe.kind?ue.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[be,it],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,He),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(I.Diagnostic.from),edit:Xe.edit&&I.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:be,actions:je}}async resolveCodeAction(C,$){const[W,V]=C,ie=this.e.get(W,V);if(!ie||Z.o(ie)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(ie,$)??ie;return fe?.edit?I.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}static o(C){return typeof C.command=="string"&&typeof C.title=="string"}}Z.d=1e3;class _{constructor(C,$,W,V){this.d=C,this.e=$,this.f=W,this.g=V}async prepareDocumentPaste(C,$,W,V){if(!this.f.prepareDocumentPaste)return;const ie=this.e.getDocument(C),fe=$.map(ue=>I.Range.to(ue)),De=I.DataTransfer.toDataTransfer(W,()=>{throw new S.NotImplementedError});return await this.f.prepareDocumentPaste(ie,fe,De,V),I.DataTransfer.toDataTransferDTO(De)}async providePasteEdits(C,$,W,V,ie){const fe=this.e.getDocument($),De=W.map(be=>I.Range.to(be)),ue=I.DataTransfer.toDataTransfer(V,async be=>(await this.d.$resolvePasteFileData(this.g,C,be)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,De,ue,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?I.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class j{constructor(C,$){this.d=C,this.e=$}async provideDocumentFormattingEdits(C,$,W){const V=this.d.getDocument(C),ie=await this.e.provideDocumentFormattingEdits(V,$,W);if(Array.isArray(ie))return ie.map(I.TextEdit.from)}}class L{constructor(C,$){this.d=C,this.e=$}async provideDocumentRangeFormattingEdits(C,$,W,V){const ie=this.d.getDocument(C),fe=I.Range.to($),De=await this.e.provideDocumentRangeFormattingEdits(ie,fe,W,V);if(Array.isArray(De))return De.map(I.TextEdit.from)}}class g{constructor(C,$){this.d=C,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,$,W,V,ie){const fe=this.d.getDocument(C),De=I.Position.to($),ue=await this.e.provideOnTypeFormattingEdits(fe,De,W,V,ie);if(Array.isArray(ue))return ue.map(I.TextEdit.from)}}class N{constructor(C,$){this.e=C,this.f=$,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,$){const W=await this.e.provideWorkspaceSymbols(C,$);if(!(0,M.isNonEmptyArray)(W))return{symbols:[]};const V=this.d.add(W),ie={cacheId:V,symbols:[]};for(let fe=0;fe<W.length;fe++){const De=W[fe];if(!De||!De.name){this.f.warn("INVALID SymbolInformation",De);continue}ie.symbols.push({...I.WorkspaceSymbol.from(De),cacheId:[V,fe]})}return ie}async resolveWorkspaceSymbol(C,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const W=this.d.get(...C.cacheId);if(W){const V=await this.e.resolveWorkspaceSymbol(W,$);return V&&(0,P.mixin)(C,I.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(C){this.d.delete(C)}}class B{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,$,W){this.d=C,this.e=$,this.f=W}async provideRenameEdits(C,$,W,V){const ie=this.d.getDocument(C),fe=I.Position.to($);try{const De=await this.e.provideRenameEdits(ie,fe,W,V);return De?I.WorkspaceEdit.from(De):void 0}catch(De){const ue=B.g(De);return ue?{rejectReason:ue,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(C,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(C),ie=I.Position.to($);try{const fe=await this.e.prepareRename(V,ie,W);let De,ue;if(F.Range.isRange(fe)?(De=fe,ue=V.getText(fe)):(0,D.isObject)(fe)&&(De=fe.range,ue=fe.placeholder),!De||!ue)return;if(De.start.line>ie.line||De.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(De),text:ue}}catch(fe){const De=B.g(fe);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(fe)}}static g(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class J{constructor(C,$){this.resultId=C,this.tokens=$}}class me{constructor(C,$){this.f=C,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(C,$,W){const V=this.f.getDocument(C),ie=$!==0?this.d.get($):null;let fe=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ie.resultId,W):await this.g.provideDocumentSemanticTokens(V,W);return ie&&this.d.delete($),fe?(fe=me.h(fe),this.o(me.n(ie,fe),fe)):null}async releaseDocumentSemanticColoring(C){this.d.delete(C)}static h(C){return me.j(C)?me.k(C)?C:new F.SemanticTokens(new Uint32Array(C.data),C.resultId):me.l(C)?me.m(C)?C:new F.SemanticTokensEdits(C.edits.map($=>new F.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),C.resultId):C}static j(C){return C&&!!C.data}static k(C){return C.data instanceof Uint32Array}static l(C){return C&&Array.isArray(C.edits)}static m(C){for(const $ of C.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(C,$){if(!me.j($)||!C||!C.tokens)return $;const W=C.tokens,V=W.length,ie=$.data,fe=ie.length;let De=0;const ue=Math.min(V,fe);for(;De<ue&&W[De]===ie[De];)De++;if(De===V&&De===fe)return new F.SemanticTokensEdits([],$.resultId);let ve=0;const be=ue-De;for(;ve<be&&W[V-ve-1]===ie[fe-ve-1];)ve++;return new F.SemanticTokensEdits([{start:De,deleteCount:V-De-ve,data:ie.subarray(De,fe-ve)}],$.resultId)}o(C,$){if(me.j(C)){const W=this.e++;return this.d.set(W,new J(C.resultId,C.data)),(0,o.encodeSemanticTokensDto)({id:W,type:"full",data:C.data})}if(me.l(C)){const W=this.e++;return me.j($)?this.d.set(W,new J($.resultId,$.data)):this.d.set(W,new J(C.resultId)),(0,o.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(C.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class te{constructor(C,$){this.d=C,this.e=$}async provideDocumentRangeSemanticTokens(C,$,W){const V=this.d.getDocument(C),ie=await this.e.provideDocumentRangeSemanticTokens(V,I.Range.to($),W);return ie?this.f(ie):null}f(C){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class oe{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,$,W,V,ie){this.f=C,this.g=$,this.h=W,this.j=V,this.k=ie,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(C,$,W,V){const ie=this.f.getDocument(C),fe=I.Position.to($),De=ie.getWordRangeAtPosition(fe)||new F.Range(fe,fe),ue=De.with({end:fe}),ve=new p.StopWatch(!0),be=await this.h.provideCompletionItems(ie,fe,V,I.CompletionContext.to(W));if(!be||V.isCancellationRequested)return;const He=Array.isArray(be)?new F.CompletionList(be):be,je=oe.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),it=new m.DisposableStore;this.e.set(je,it);const Xe=[],et={x:je,b:Xe,a:{replace:I.Range.from(De),insert:I.Range.from(ue)},c:He.isIncomplete||void 0,d:ve.elapsed()};for(let nt=0;nt<He.items.length;nt++){const Fe=He.items[nt],rt=this.l(Fe,[je,nt],ue,De);Xe.push(rt)}return et}async resolveCompletionItem(C,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...C);if(!W)return;const V=await this.h.resolveCompletionItem(W,$);if(!!V)return this.l(V,C)}releaseCompletionItems(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,$,W,V){const ie=this.e.get($[0]);if(!ie)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(C.command,ie),De={x:$,a:C.label,b:C.kind!==void 0?I.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(I.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:I.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(I.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};C.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),De.h=C.textEdit.newText):typeof C.insertText=="string"?De.h=C.insertText:C.insertText instanceof F.SnippetString&&(De.h=C.insertText.value,De.i|=4);let ue;return C.textEdit?ue=C.textEdit.range:C.range&&(ue=C.range),F.Range.isRange(ue)?De.j=I.Range.from(ue):ue&&(!W?.isEqual(ue.inserting)||!V?.isEqual(ue.replacing))&&(De.j={insert:I.Range.from(ue.inserting),replace:I.Range.from(ue.replacing)}),De}}class ce{async provideInlineCompletions(C,$,W,V){}disposeCompletions(C){}handleDidShowCompletionItem(C,$){}handlePartialAccept(C,$,W){}}class we extends ce{constructor(C,$,W,V){super(),this.f=C,this.g=$,this.h=W,this.j=V,this.d=new q,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[E.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[E.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,$,W,V){const ie=this.g.getDocument(C),fe=I.Position.to($),De=await this.h.provideInlineCompletionItems(ie,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:I.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},V);if(!De||V.isCancellationRequested)return;const ue=Array.isArray(De)?De:De.items,ve=this.e?Array.isArray(De)?[]:De.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:ue}),items:ue.map((je,it)=>{let Xe;je.command&&(be||(be=new m.DisposableStore),Xe=this.j.toInternal(je.command,be));const et=je.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:je.filterText,range:je.range?I.Range.from(je.range):void 0,command:Xe,idx:it,completeBracketPairs:this.e?je.completeBracketPairs:!1}}),commands:ve.map(je=>(be||(be=new m.DisposableStore),this.j.toInternal(je,be)))}}disposeCompletions(C){this.d.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,$){const W=this.d.get(C)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}handlePartialAccept(C,$,W){const V=this.d.get(C)?.items[$];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,W)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(C){const $=this.e++;return this.d.set($,C),$}disposeReferenceId(C){const $=this.d.get(C);return this.d.delete(C),$}get(C){return this.d.get(C)}}class x{constructor(C,$){this.e=C,this.f=$,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(C,$,W,V){const ie=this.e.getDocument(C),fe=I.Position.to($),De=this.g(W),ue=await this.f.provideSignatureHelp(ie,fe,V,De);if(ue){const ve=this.d.add([ue]);return{...I.SignatureHelp.from(ue),id:ve}}}g(C){let $;if(C.activeSignatureHelp){const W=I.SignatureHelp.to(C.activeSignatureHelp),V=this.d.get(C.activeSignatureHelp.id,0);V?($=V,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...C,activeSignatureHelp:$}}releaseSignatureHelp(C){this.d.delete(C)}}class X{constructor(C,$,W,V,ie){this.f=C,this.g=$,this.h=W,this.j=V,this.k=ie,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(C,$,W){const V=this.f.getDocument(C),ie=I.Range.to($),fe=await this.h.provideInlayHints(V,ie,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const De=this.d.add(fe);this.e.set(De,new m.DisposableStore);const ue={hints:[],cacheId:De};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],ie)&&ue.hints.push(this.m(fe[ve],[De,ve]));return this.j.trace(`[InlayHints] ${ue.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ue}async resolveInlayHint(C,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...C);if(!W)return;const V=await this.h.resolveInlayHint(W,$);if(!!V&&!!this.l(V))return this.m(V,C)}releaseHints(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,$){return C.label.length===0||Array.isArray(C.label)&&C.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!($&&!$.contains(C.position))}m(C,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const V={label:"",cacheId:$,tooltip:I.MarkdownString.fromStrict(C.tooltip),position:I.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(I.TextEdit.from),kind:C.kind&&I.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?V.label=C.label:V.label=C.label.map(ie=>{const fe={label:ie.value};return fe.tooltip=I.MarkdownString.fromStrict(ie.tooltip),F.Location.isLocation(ie.location)&&(fe.location=I.location.from(ie.location)),ie.command&&(fe.command=this.g.toInternal(ie.command,W)),fe}),V}}class de{constructor(C,$){this.e=C,this.f=$,this.d=new u.Cache("DocumentLink")}async provideLinks(C,$){const W=this.e.getDocument(C),V=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(V)||V.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(de.g).map(I.DocumentLink.from)};{const ie=this.d.add(V),fe={links:[],cacheId:ie};for(let De=0;De<V.length;De++){if(!de.g(V[De]))continue;const ue=I.DocumentLink.from(V[De]);ue.cacheId=[ie,De],fe.links.push(ue)}return fe}}}static g(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...C);if(!W)return;const V=await this.f.resolveDocumentLink(W,$);if(!(!V||!de.g(V)))return I.DocumentLink.from(V)}releaseLinks(C){this.d.delete(C)}}class ye{constructor(C,$){this.d=C,this.e=$}async provideColors(C,$){const W=this.d.getDocument(C),V=await this.e.provideDocumentColors(W,$);return Array.isArray(V)?V.map(fe=>({color:I.Color.from(fe.color),range:I.Range.from(fe.range)})):[]}async provideColorPresentations(C,$,W){const V=this.d.getDocument(C),ie=I.Range.to($.range),fe=I.Color.to($.color),De=await this.e.provideColorPresentations(fe,{document:V,range:ie},W);if(!!Array.isArray(De))return De.map(I.ColorPresentation.from)}}class Ne{constructor(C,$){this.d=C,this.e=$}async provideFoldingRanges(C,$,W){const V=this.d.getDocument(C),ie=await this.e.provideFoldingRanges(V,$,W);if(!!Array.isArray(ie))return ie.map(I.FoldingRange.from)}}class ze{constructor(C,$,W){this.d=C,this.e=$,this.f=W}async provideSelectionRanges(C,$,W){const V=this.d.getDocument(C),ie=$.map(I.Position.to),fe=await this.e.provideSelectionRanges(V,ie,W);if(!(0,M.isNonEmptyArray)(fe))return[];if(fe.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let ue=0;ue<ie.length;ue++){const ve=[];De.push(ve);let be=ie[ue],He=fe[ue];for(;;){if(!He.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(I.SelectionRange.from(He)),!He.parent)break;be=He.range,He=He.parent}}return De}}class Pe{constructor(C,$){this.f=C,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(C,$,W){const V=this.f.getDocument(C),ie=I.Position.to($),fe=await this.g.prepareCallHierarchy(V,ie,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(ue=>this.h(De,ue)):[this.h(De,fe)]}async provideCallsTo(C,$,W){const V=this.j(C,$);if(!V)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(V,W);if(!!ie)return ie.map(fe=>({from:this.h(C,fe.from),fromRanges:fe.fromRanges.map(De=>I.Range.from(De))}))}async provideCallsFrom(C,$,W){const V=this.j(C,$);if(!V)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(V,W);if(!!ie)return ie.map(fe=>({to:this.h(C,fe.to),fromRanges:fe.fromRanges.map(De=>I.Range.from(De))}))}releaseSession(C){this.e.delete(C)}h(C,$){const W=this.e.get(C),V=I.CallHierarchyItem.from($,C,W.size.toString(36));return W.set(V._itemId,$),V}j(C,$){return this.e.get(C)?.get($)}}class Ie{constructor(C,$){this.f=C,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(C,$,W){const V=this.f.getDocument(C),ie=I.Position.to($),fe=await this.g.prepareTypeHierarchy(V,ie,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(ue=>this.h(De,ue)):[this.h(De,fe)]}async provideSupertypes(C,$,W){const V=this.j(C,$);if(!V)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(V,W);if(!!ie)return ie.map(fe=>this.h(C,fe))}async provideSubtypes(C,$,W){const V=this.j(C,$);if(!V)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(V,W);if(!!ie)return ie.map(fe=>this.h(C,fe))}releaseSession(C){this.e.delete(C)}h(C,$){const W=this.e.get(C),V=I.TypeHierarchyItem.from($,C,W.size.toString(36));return W.set(V._itemId,$),V}j(C,$){return this.e.get(C)?.get($)}}class Se{constructor(C,$,W,V){this.d=C,this.e=$,this.f=W,this.g=V}async provideDocumentOnDropEdits(C,$,W,V,ie){const fe=this.e.getDocument($),De=I.Position.to(W),ue=I.DataTransfer.toDataTransfer(V,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,C,be)).buffer),ve=await this.f.provideDocumentDropEdits(fe,De,ue,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?I.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ae{constructor(C,$){this.adapter=C,this.extension=$}}class le{constructor(C,$,W,V,ie,fe,De,ue){this.g=$,this.h=W,this.j=V,this.k=ie,this.l=fe,this.m=De,this.n=ue,this.f=new Map,this.e=C.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(C){return I.DocumentSelector.from(C,this.g)}p(C){return new F.Disposable(()=>{this.f.delete(C),this.e.$unregister(C)})}q(){return le.d++}async s(C,$,W,V,ie,fe=!1){const De=this.f.get(C);if(!De||!(De.adapter instanceof $))return V;const ue=Date.now();fe||this.l.trace(`[${De.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(De.adapter,De.extension);return Promise.resolve(ve).catch(be=>{(0,S.isCancellationError)(be)||(this.l.error(`[${De.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(De.extension.identifier,be))}).finally(()=>{fe||this.l.trace(`[${De.extension.identifier.value}] provider DONE after ${Date.now()-ue}ms`)}),b.CancellationToken.isCancellationToken(ie)?(0,O.raceCancellationError)(ve,ie):ve}t(C,$){const W=this.q();return this.f.set(W,new ae(C,$)),W}static u(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,$,W,V){const ie=this.t(new t(this.h,W),C),fe=V&&V.label||le.u(C);return this.e.$registerDocumentSymbolProvider(ie,this.o($),fe),this.p(ie)}$provideDocumentSymbols(C,$,W){return this.s(C,t,V=>V.provideDocumentSymbols(i.URI.revive($),W),void 0,W)}registerCodeLensProvider(C,$,W){const V=this.q(),ie=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new ae(new d(this.h,this.j.converter,W),C)),this.e.$registerCodeLensSupport(V,this.o($),ie);let fe=this.p(V);if(ie!==void 0){const De=W.onDidChangeCodeLenses(ue=>this.e.$emitCodeLensEvent(ie));fe=F.Disposable.from(fe,De)}return fe}$provideCodeLenses(C,$,W){return this.s(C,d,V=>V.provideCodeLenses(i.URI.revive($),W),void 0,W)}$resolveCodeLens(C,$,W){return this.s(C,d,V=>V.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(C,$){this.s(C,d,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(C,$,W){const V=this.t(new l(this.h,W),C);return this.e.$registerDefinitionSupport(V,this.o($)),this.p(V)}$provideDefinition(C,$,W,V){return this.s(C,l,ie=>ie.provideDefinition(i.URI.revive($),W,V),[],V)}registerDeclarationProvider(C,$,W){const V=this.t(new c(this.h,W),C);return this.e.$registerDeclarationSupport(V,this.o($)),this.p(V)}$provideDeclaration(C,$,W,V){return this.s(C,c,ie=>ie.provideDeclaration(i.URI.revive($),W,V),[],V)}registerImplementationProvider(C,$,W){const V=this.t(new w(this.h,W),C);return this.e.$registerImplementationSupport(V,this.o($)),this.p(V)}$provideImplementation(C,$,W,V){return this.s(C,w,ie=>ie.provideImplementation(i.URI.revive($),W,V),[],V)}registerTypeDefinitionProvider(C,$,W){const V=this.t(new n(this.h,W),C);return this.e.$registerTypeDefinitionSupport(V,this.o($)),this.p(V)}$provideTypeDefinition(C,$,W,V){return this.s(C,n,ie=>ie.provideTypeDefinition(i.URI.revive($),W,V),[],V)}registerHoverProvider(C,$,W,V){const ie=this.t(new r(this.h,W),C);return this.e.$registerHoverProvider(ie,this.o($)),this.p(ie)}$provideHover(C,$,W,V){return this.s(C,r,ie=>ie.provideHover(i.URI.revive($),W,V),void 0,V)}registerEvaluatableExpressionProvider(C,$,W,V){const ie=this.t(new f(this.h,W),C);return this.e.$registerEvaluatableExpressionProvider(ie,this.o($)),this.p(ie)}$provideEvaluatableExpression(C,$,W,V){return this.s(C,f,ie=>ie.provideEvaluatableExpression(i.URI.revive($),W,V),void 0,V)}registerInlineValuesProvider(C,$,W,V){const ie=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new A(this.h,W),C);this.e.$registerInlineValuesProvider(fe,this.o($),ie);let De=this.p(fe);if(ie!==void 0){const ue=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ie));De=F.Disposable.from(De,ue)}return De}$provideInlineValues(C,$,W,V,ie){return this.s(C,A,fe=>fe.provideInlineValues(i.URI.revive($),W,V,ie),void 0,ie)}registerDocumentHighlightProvider(C,$,W){const V=this.t(new T(this.h,W),C);return this.e.$registerDocumentHighlightProvider(V,this.o($)),this.p(V)}$provideDocumentHighlights(C,$,W,V){return this.s(C,T,ie=>ie.provideDocumentHighlights(i.URI.revive($),W,V),void 0,V)}registerLinkedEditingRangeProvider(C,$,W){const V=this.t(new H(this.h,W),C);return this.e.$registerLinkedEditingRangeProvider(V,this.o($)),this.p(V)}$provideLinkedEditingRanges(C,$,W,V){return this.s(C,H,async ie=>{const fe=await ie.provideLinkedEditingRanges(i.URI.revive($),W,V);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?le.w(fe.wordPattern):void 0}},void 0,V)}registerReferenceProvider(C,$,W){const V=this.t(new Q(this.h,W),C);return this.e.$registerReferenceSupport(V,this.o($)),this.p(V)}$provideReferences(C,$,W,V,ie){return this.s(C,Q,fe=>fe.provideReferences(i.URI.revive($),W,V,ie),void 0,ie)}registerCodeActionProvider(C,$,W,V){const ie=new m.DisposableStore,fe=this.t(new Z(this.h,this.j.converter,this.k,W,this.l,C,this.m),C);return this.e.$registerQuickFixSupport(fe,this.o($),{providedKinds:V?.providedCodeActionKinds?.map(De=>De.value),documentation:V?.documentation?.map(De=>({kind:De.kind.value,command:this.j.converter.toInternal(De.command,ie)}))},le.u(C),Boolean(W.resolveCodeAction)),ie.add(this.p(fe)),ie}$provideCodeActions(C,$,W,V,ie){return this.s(C,Z,fe=>fe.provideCodeActions(i.URI.revive($),W,V,ie),void 0,ie)}$resolveCodeAction(C,$,W){return this.s(C,Z,V=>V.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(C,$){this.s(C,Z,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(C,$,W){const V=this.t(new j(this.h,W),C);return this.e.$registerDocumentFormattingSupport(V,this.o($),C.identifier,C.displayName||C.name),this.p(V)}$provideDocumentFormattingEdits(C,$,W,V){return this.s(C,j,ie=>ie.provideDocumentFormattingEdits(i.URI.revive($),W,V),void 0,V)}registerDocumentRangeFormattingEditProvider(C,$,W){const V=this.t(new L(this.h,W),C);return this.e.$registerRangeFormattingSupport(V,this.o($),C.identifier,C.displayName||C.name),this.p(V)}$provideDocumentRangeFormattingEdits(C,$,W,V,ie){return this.s(C,L,fe=>fe.provideDocumentRangeFormattingEdits(i.URI.revive($),W,V,ie),void 0,ie)}registerOnTypeFormattingEditProvider(C,$,W,V){const ie=this.t(new g(this.h,W),C);return this.e.$registerOnTypeFormattingSupport(ie,this.o($),V,C.identifier),this.p(ie)}$provideOnTypeFormattingEdits(C,$,W,V,ie,fe){return this.s(C,g,De=>De.provideOnTypeFormattingEdits(i.URI.revive($),W,V,ie,fe),void 0,fe)}registerWorkspaceSymbolProvider(C,$){const W=this.t(new N($,this.l),C);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(C,$,W){return this.s(C,N,V=>V.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(C,$,W){return this.s(C,N,V=>V.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(C,$){this.s(C,N,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(C,$,W){const V=this.t(new B(this.h,W,this.l),C);return this.e.$registerRenameSupport(V,this.o($),B.supportsResolving(W)),this.p(V)}$provideRenameEdits(C,$,W,V,ie){return this.s(C,B,fe=>fe.provideRenameEdits(i.URI.revive($),W,V,ie),void 0,ie)}$resolveRenameLocation(C,$,W,V){return this.s(C,B,ie=>ie.resolveRenameLocation(i.URI.revive($),W,V),void 0,V)}registerDocumentSemanticTokensProvider(C,$,W,V){const ie=this.t(new me(this.h,W),C),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o($),V,fe);let De=this.p(ie);if(fe){const ue=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));De=F.Disposable.from(De,ue)}return De}$provideDocumentSemanticTokens(C,$,W,V){return this.s(C,me,ie=>ie.provideDocumentSemanticTokens(i.URI.revive($),W,V),null,V)}$releaseDocumentSemanticTokens(C,$){this.s(C,me,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,$,W,V){const ie=this.t(new te(this.h,W),C);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o($),V),this.p(ie)}$provideDocumentRangeSemanticTokens(C,$,W,V){return this.s(C,te,ie=>ie.provideDocumentRangeSemanticTokens(i.URI.revive($),W,V),null,V)}registerCompletionItemProvider(C,$,W,V){const ie=this.t(new oe(this.h,this.j.converter,W,this.m,C),C);return this.e.$registerCompletionsProvider(ie,this.o($),V,oe.supportsResolving(W),`${C.identifier.value}(${V.join("")})`),this.p(ie)}$provideCompletionItems(C,$,W,V,ie){return this.s(C,oe,fe=>fe.provideCompletionItems(i.URI.revive($),W,V,ie),void 0,ie)}$resolveCompletionItem(C,$,W){return this.s(C,oe,V=>V.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(C,$){this.s(C,oe,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(C,$,W){const V=new we(C,this.h,W,this.j.converter),ie=this.t(V,C);return this.e.$registerInlineCompletionsSupport(ie,this.o($),V.supportsHandleEvents),this.p(ie)}$provideInlineCompletions(C,$,W,V,ie){return this.s(C,ce,fe=>fe.provideInlineCompletions(i.URI.revive($),W,V,ie),void 0,ie)}$handleInlineCompletionDidShow(C,$,W){this.s(C,ce,async V=>{V.handleDidShowCompletionItem($,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,$,W,V){this.s(C,ce,async ie=>{ie.handlePartialAccept($,W,V)},void 0,void 0)}$freeInlineCompletionsList(C,$){this.s(C,ce,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(C,$,W,V){const ie=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,fe=this.t(new x(this.h,W),C);return this.e.$registerSignatureHelpProvider(fe,this.o($),ie),this.p(fe)}$provideSignatureHelp(C,$,W,V,ie){return this.s(C,x,fe=>fe.provideSignatureHelp(i.URI.revive($),W,V,ie),void 0,ie)}$releaseSignatureHelp(C,$){this.s(C,x,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(C,$,W){const V=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new X(this.h,this.j.converter,W,this.l,C),C);this.e.$registerInlayHintsProvider(ie,this.o($),typeof W.resolveInlayHint=="function",V,le.u(C));let fe=this.p(ie);if(V!==void 0){const De=W.onDidChangeInlayHints(ue=>this.e.$emitInlayHintsEvent(V));fe=F.Disposable.from(fe,De)}return fe}$provideInlayHints(C,$,W,V){return this.s(C,X,ie=>ie.provideInlayHints(i.URI.revive($),W,V),void 0,V)}$resolveInlayHint(C,$,W){return this.s(C,X,V=>V.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(C,$){this.s(C,X,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(C,$,W){const V=this.t(new de(this.h,W),C);return this.e.$registerDocumentLinkProvider(V,this.o($),typeof W.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(C,$,W){return this.s(C,de,V=>V.provideLinks(i.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(C,$,W){return this.s(C,de,V=>V.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(C,$){this.s(C,de,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(C,$,W){const V=this.t(new ye(this.h,W),C);return this.e.$registerDocumentColorProvider(V,this.o($)),this.p(V)}$provideDocumentColors(C,$,W){return this.s(C,ye,V=>V.provideColors(i.URI.revive($),W),[],W)}$provideColorPresentations(C,$,W,V){return this.s(C,ye,ie=>ie.provideColorPresentations(i.URI.revive($),W,V),void 0,V)}registerFoldingRangeProvider(C,$,W){const V=this.q(),ie=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new ae(new Ne(this.h,W),C)),this.e.$registerFoldingRangeProvider(V,this.o($),C.identifier,ie);let fe=this.p(V);if(ie!==void 0){const De=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));fe=F.Disposable.from(fe,De)}return fe}$provideFoldingRanges(C,$,W,V){return this.s(C,Ne,ie=>ie.provideFoldingRanges(i.URI.revive($),W,V),void 0,V)}registerSelectionRangeProvider(C,$,W){const V=this.t(new ze(this.h,W,this.l),C);return this.e.$registerSelectionRangeProvider(V,this.o($)),this.p(V)}$provideSelectionRanges(C,$,W,V){return this.s(C,ze,ie=>ie.provideSelectionRanges(i.URI.revive($),W,V),[],V)}registerCallHierarchyProvider(C,$,W){const V=this.t(new Pe(this.h,W),C);return this.e.$registerCallHierarchyProvider(V,this.o($)),this.p(V)}$prepareCallHierarchy(C,$,W,V){return this.s(C,Pe,ie=>Promise.resolve(ie.prepareSession(i.URI.revive($),W,V)),void 0,V)}$provideCallHierarchyIncomingCalls(C,$,W,V){return this.s(C,Pe,ie=>ie.provideCallsTo($,W,V),void 0,V)}$provideCallHierarchyOutgoingCalls(C,$,W,V){return this.s(C,Pe,ie=>ie.provideCallsFrom($,W,V),void 0,V)}$releaseCallHierarchy(C,$){this.s(C,Pe,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(C,$,W){const V=this.t(new Ie(this.h,W),C);return this.e.$registerTypeHierarchyProvider(V,this.o($)),this.p(V)}$prepareTypeHierarchy(C,$,W,V){return this.s(C,Ie,ie=>Promise.resolve(ie.prepareSession(i.URI.revive($),W,V)),void 0,V)}$provideTypeHierarchySupertypes(C,$,W,V){return this.s(C,Ie,ie=>ie.provideSupertypes($,W,V),void 0,V)}$provideTypeHierarchySubtypes(C,$,W,V){return this.s(C,Ie,ie=>ie.provideSubtypes($,W,V),void 0,V)}$releaseTypeHierarchy(C,$){this.s(C,Ie,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(C,$,W){const V=this.q();return this.f.set(V,new ae(new Se(this.e,this.h,W,V),C)),this.e.$registerDocumentOnDropEditProvider(V,this.o($)),this.p(V)}$provideDocumentOnDropEdits(C,$,W,V,ie,fe){return this.s(C,Se,De=>Promise.resolve(De.provideDocumentOnDropEdits($,i.URI.revive(W),V,ie,fe)),void 0,void 0)}registerDocumentPasteEditProvider(C,$,W,V){const ie=this.q();return this.f.set(ie,new ae(new _(this.e,this.h,W,ie),C)),this.e.$registerPasteEditProvider(ie,this.o($),!!W.prepareDocumentPaste,V.pasteMimeTypes),this.p(ie)}$prepareDocumentPaste(C,$,W,V,ie){return this.s(C,_,fe=>fe.prepareDocumentPaste(i.URI.revive($),W,V,ie),void 0,ie)}$providePasteEdits(C,$,W,V,ie,fe){return this.s(C,_,De=>De.providePasteEdits($,i.URI.revive(W),V,ie,fe),void 0,fe)}static w(C){return{pattern:C.source,flags:(0,y.regExpFlags)(C)}}static y(C){return{decreaseIndentPattern:le.w(C.decreaseIndentPattern),increaseIndentPattern:le.w(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?le.w(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?le.w(C.unIndentedLinePattern):void 0}}static z(C){return{beforeText:le.w(C.beforeText),afterText:C.afterText?le.w(C.afterText):void 0,previousLineText:C.previousLineText?le.w(C.previousLineText):void 0,action:C.action}}static B(C){return C.map(le.z)}setLanguageConfiguration(C,$,W){const{wordPattern:V}=W;if(V&&(0,y.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor($,V):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const ie=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?le.w(W.wordPattern):void 0,indentationRules:W.indentationRules?le.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?le.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ie,$,fe),this.p(ie)}$setWordDefinitions(C){for(const $ of C)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}le.d=0,e.ExtHostLanguageFeatures=le}),define(ke[220],Te([1,0,5,8,7,29,17,6]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(M,D,h,b){this.c=D,this.d=h,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,D){await this.a.$changeLanguage(M,D);const h=this.c.getDocumentData(M);if(!h)throw new Error(`document '${M.toString()}' NOT found`);return h.document}async tokenAtPosition(M,D){const h=M.version,b=P.Position.from(D),m=await this.a.$tokensAtPosition(M.uri,b),o={type:I.StandardTokenType.Other,range:M.getWordRangeAtPosition(D)??new I.Range(D.line,D.character,D.line,D.character)};if(!m)return o;const s={range:P.Range.to(m.range),type:P.TokenType.to(m.type)};return!s.range.contains(D)||h!==M.version?o:s}createLanguageStatusItem(M,D,h){const b=this.f++,m=this.a,o=this.g,s=`${M.identifier.value}/${D}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);o.add(s);const u={selector:h,id:D,name:M.displayName??M.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const S=new R.DisposableStore,O=()=>{p?.dispose(),p=(0,E.disposableTimeout)(()=>{S.clear(),this.a.$setLanguageStatus(b,{id:s,name:u.name??M.displayName??M.name,source:M.displayName??M.name,selector:P.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===I.LanguageStatusSeverity.Error?F.default.Error:u.severity===I.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:u.command&&this.d.toInternal(u.command,S),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},v={dispose(){S.dispose(),p?.dispose(),m.$removeLanguageStatus(b),o.delete(s)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,O()},get selector(){return u.selector},set selector(t){u.selector=t,O()},get text(){return u.text},set text(t){u.text=t,O()},get detail(){return u.detail},set detail(t){u.detail=t,O()},get severity(){return u.severity},set severity(t){u.severity=t,O()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,O()},get command(){return u.command},set command(t){u.command=t,O()},get busy(){return u.busy},set busy(t){u.busy=t,O()}};return O(),v}}e.ExtHostLanguages=y}),define(ke[78],Te([1,0,20,10,2,3,12,5,27,18]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(h,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(h,b){const{message:m,args:o,comment:s}=b;if(this.c)return(0,P.format2)(m,o??{});let u=m;s&&s.length>0&&(u+=`/${Array.isArray(s)?s.join(""):s}`);const p=this.d.get(h)?.contents[u];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,P.format2)(p??m,o??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let b;const m=await this.g(h);if(!m){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(m),s=JSON.parse(o);b=h.isBuiltin?s.contents?.bundle:s}catch(o){this.f.error(`Failed to load translations for ${h.identifier.value} from ${m}: ${o.message}`);return}b&&this.d.set(h.identifier.value,{contents:b,uri:m})}async g(h){if(h.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return I.URI.revive(b)}return h.l10n?I.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([Ve(0,y.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,E.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(ke[221],Te([1,0,12,5,27,18,2,66]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends i.AbstractLoggerService{constructor(D,h){super(h.logLevel,h.loggers.map(b=>(0,R.revive)(b))),this.l=D.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(D,h){h?this.setLogLevel(E.URI.revive(h),D):this.setLogLevel(D)}setVisibility(D,h){super.setVisibility(D,h),this.l.$setVisibility(D,h)}k(D,h,b){return new k(this.l,D,h,b)}};y=qe([Ve(0,F.IExtHostRpcService),Ve(1,I.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class k extends i.AbstractMessageLogger{constructor(D,h,b,m){super(m?.logLevel==="always"),this.m=D,this.n=h,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(h,m).then(()=>{this.r(this.l),this.k=!0})}g(D,h){const b=[[D,h]];this.k?this.r(b):this.l.push(...b)}r(D){this.m.$log(this.n,D)}}}),define(ke[222],Te([1,0,5,12,25]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(R){return R&&R.title}let E=class{constructor(y,k){this.b=k,this.a=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,M,D,h){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof D=="string"||F(D)?m=[D,...h]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,m=h),b.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const o=[];for(let s=0;s<m.length;s++){const u=m[s];if(typeof u=="string")o.push({title:u,handle:s,isCloseAffordance:!1});else if(typeof u=="object"){const{title:p,isCloseAffordance:S}=u;o.push({title:p,isCloseAffordance:!!S,handle:s})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(k,M,b,o).then(s=>{if(typeof s=="number")return m[s]})}};E=qe([Ve(1,P.ILogService)],E),e.ExtHostMessageService=E}),define(ke[223],Te([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,197,100]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,O,v,t){this.q=v,this.r=t,this.f=new Map,this.g=new F.ResourceMap,this.h=new Map,this.j=new P.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=S.getProxy(M.MainContext.MainThreadNotebook),this.c=S.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=S.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=O.converter,O.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const a=d.notebookEditor?.notebookUri,l=d.cell.handle,w=this.g.get(a)?.getCell(l);if(w)return w.apiCell}if(d&&d.$mid===14){const a=d.uri,l=this.g.get(a);if(l)return l.apiNotebook}return d}}),u.x(O)}getEditorById(S){const O=this.h.get(S);if(!O)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return O}getIdByEditor(S){for(const[O,v]of this.h)if(v.apiEditor===S)return O}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,O){const v=this.g.get(S);if(!v&&!O)throw new Error(`NO notebook document for '${S}'`);return v}static s(S,O){if(!O)return;const v=O.filenamePattern.map(t=>h.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(O.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${O.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:O.displayName,filenamePattern:v,exclusive:O.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,O,v){const t=u.a++,d=typeof v.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(t,v),this.b.$registerNotebookCellStatusBarItemProvider(t,d,O);let a;return d!==void 0&&(a=v.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,d),a?.dispose()})}async createNotebookDocument(S){const O=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&h.NotebookData.from(S.content)});return y.URI.revive(O)}async openNotebookDocument(S){const O=this.g.get(S);if(O)return O.apiNotebook;const v=await this.c.$tryOpenNotebook(S),t=this.g.get(y.URI.revive(v));return(0,R.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(S,O){y.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let v;typeof O=="object"?v={position:h.ViewColumn.from(O.viewColumn),preserveFocus:O.preserveFocus,selections:O.selections&&O.selections.map(h.NotebookRange.from),pinned:typeof O.preview=="boolean"?!O.preview:void 0}:v={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,v),d=t&&this.h.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,O,v,t){const d=this.f.get(S),a=y.URI.revive(O),l=this.g.get(a);if(!l||!d)return;const c=l.getCellFromIndex(v);if(!c)return;const w=await d.provideCellStatusBarItems(c.apiCell,t);if(!w)return;const n=new I.DisposableStore,r=this.p.add([n]),A=(Array.isArray(w)?w:[w]).map(T=>h.NotebookStatusBarItem.from(T,this.i,n));return{cacheId:r,items:A}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,O,v,t,d){if((0,E.isFalsyOrWhitespace)(O))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,v),this.b.$registerNotebookSerializer(a,{id:S.identifier,location:S.extensionLocation},O,h.NotebookDocumentContentOptions.from(t),u.s(S,d)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(S,O,v){const t=this.u.get(S);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(O.buffer,v);return new m.SerializableObjectWithBuffers(h.NotebookData.from(d))}async $notebookToData(S,O,v){const t=this.u.get(S);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(h.NotebookData.to(O.value),v);return i.VSBuffer.wrap(d)}w(S,O,v){if(this.h.has(O))throw new Error(`editor with id ALREADY EXSIST: ${O}`);const t=new s.ExtHostNotebookEditor(O,this.d,S,v.visibleRanges.map(h.NotebookRange.to),v.selections.map(h.NotebookRange.to),typeof v.viewColumn=="number"?h.ViewColumn.to(v.viewColumn):void 0);this.h.set(O,t)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const v of S.value.removedDocuments){const t=y.URI.revive(v),d=this.g.get(t);d&&(d.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(d.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===t.toString()&&this.h.delete(a.id)}if(S.value.addedDocuments){const v=[];for(const t of S.value.addedDocuments){const d=y.URI.revive(t.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const a=new o.ExtHostNotebookDocument(this.c,this.q,this.r,d,t);v.push(...t.cells.map(l=>o.ExtHostCell.asModelAddData(a.apiNotebook,l))),this.g.get(d)?.dispose(),this.g.set(d,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(a.apiNotebook)}}if(S.value.addedEditors)for(const v of S.value.addedEditors){if(this.h.has(v.id))return;const t=y.URI.revive(v.documentUri),d=this.g.get(t);d&&this.w(d,v.id,v)}const O=[];if(S.value.removedEditors)for(const v of S.value.removedEditors){const t=this.h.get(v);t&&(this.h.delete(v),this.k?.id===t.id&&(this.k=void 0),O.push(t))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const v=new Set;this.l.forEach(t=>v.add(t.id));for(const t of this.h.values()){const d=v.has(t.id);t._acceptVisibility(d)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(S){const O=D.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[O,new D.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>i.VSBuffer.wrap(d))],new D.ApiCommandResult("Notebook Data",d=>h.NotebookData.to(d.value))),t=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[O,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new m.SerializableObjectWithBuffers(h.NotebookData.from(d)))],new D.ApiCommandResult("Bytes",d=>d.buffer));S.registerApiCommand(v),S.registerApiCommand(t)}}u.a=0,e.ExtHostNotebookController=u}),define(ke[224],Te([1,0,16,17,21,4,6,28,2,26,12,54,5,37,8,7,73,187,25,46]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let O=class{constructor(c,w,n,r,f){this.k=w,this.l=n,this.m=r,this.n=f,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(h.MainContext.MainThreadNotebookKernels);const A=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const H=this.l.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:H}}else if(T&&"notebookEditor"in T){const H=this.l.getIdByEditor(T.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return T})],b.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(c,w,n,r,f,A){for(const ce of this.h.values())if(ce.controller.id===w&&k.ExtensionIdentifier.equals(c.identifier,ce.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const T=this.i++,H=this;this.n.trace(`NotebookController[${T}], CREATED by ${c.identifier.value}, ${w}`);const Q=()=>console.warn(`NO execute handler from notebook controller '${g.id}' of extension: '${c.identifier}'`);let Z=!1;const _=new E.DisposableStore,j=new F.Emitter,L=new F.Emitter,g={id:a(c.identifier,w),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:r||c.identifier.value,preloads:A?A.map(m.NotebookRendererScript.from):[]};let N=f??Q,B;this.a.$addKernel(T,g).catch(ce=>{console.log(ce),Z=!0});let J=0;const me=()=>{if(Z)return;const ce=++J;Promise.resolve().then(()=>{ce===J&&this.a.$updateKernel(T,g)})},te=new R.ResourceMap,oe={get id(){return w},get notebookType(){return g.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return g.label},set label(ce){g.label=ce??c.displayName??c.name,me()},get detail(){return g.detail??""},set detail(ce){g.detail=ce,me()},get description(){return g.description??""},set description(ce){g.description=ce,me()},get kind(){return(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),g.kind??""},set kind(ce){(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),g.kind=ce,me()},get supportedLanguages(){return g.supportedLanguages},set supportedLanguages(ce){g.supportedLanguages=ce,me()},get supportsExecutionOrder(){return g.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){g.supportsExecutionOrder=ce,me()},get rendererScripts(){return g.preloads?g.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(ce){N=ce??Q},get interruptHandler(){return B},set interruptHandler(ce){B=ce,g.supportsInterrupt=Boolean(ce),me()},createNotebookCellExecution(ce){if(Z)throw new Error("notebook controller is DISPOSED");if(!te.has(ce.notebook.uri))throw H.n.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return H._createNotebookCellExecution(ce,a(c.identifier,this.id))},dispose:()=>{Z||(this.n.trace(`NotebookController[${T}], DISPOSED`),Z=!0,this.h.delete(T),_.dispose(),j.dispose(),L.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ce,we){we===o.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),H.a.$updateNotebookPriority(T,ce.uri,we)},onDidReceiveMessage:L.event,postMessage(ce,we){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),H.a.$postMessage(T,we&&H.l.getIdByEditor(we),ce)},asWebviewUri(ce){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),(0,s.asWebviewUri)(ce,H.k.remote)}};return this.h.set(T,{extensionId:c.identifier,controller:oe,onDidReceiveMessage:L,onDidChangeSelection:j,associatedNotebooks:te}),oe}getIdByController(c){for(const[w,n]of this.h)if(n.controller===c)return a(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,w){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,w);const f={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(c,w,n){const r=this.f++,f=typeof n.onDidChangeNotebookKernelSourceActions=="function"?r:void 0,A=this;this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(r,r,w);let T;return f!==void 0&&(T=n.onDidChangeNotebookKernelSourceActions(H=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.e.delete(r),A.a.$removeKernelSourceActionProvider(r,r),T?.dispose()}}}async $provideKernelSourceActions(c,w){const n=this.e.get(c);if(n){const r=new E.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(w)??[]).map(A=>m.NotebookKernelSourceAction.from(A,this.m.converter,r))}return[]}$acceptNotebookAssociation(c,w,n){const r=this.h.get(c);if(r){const f=this.l.getNotebookDocument(y.URI.revive(w));n?r.associatedNotebooks.set(f.uri,!0):r.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(c,w,n){const r=this.h.get(c);if(!r)return;const f=this.l.getNotebookDocument(y.URI.revive(w)),A=[];for(const T of n){const H=f.getCell(T);H&&A.push(H.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),A.length),await r.controller.executeHandler.call(r.controller,A,f.apiNotebook,r.controller)}catch(T){this.n.error(`NotebookController[${c}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(c,w,n){const r=this.h.get(c);if(!r)return;const f=this.l.getNotebookDocument(y.URI.revive(w));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,f.apiNotebook);else for(const A of n){const T=f.getCell(A);T&&this.b.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,w,n){const r=this.h.get(c);if(!r)return;const f=this.l.getEditorById(w);r.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(c,w,n){const f=this.l.getNotebookDocument(y.URI.revive(c)).getCell(w);if(f){const A=n?m.NotebookCellExecutionState.to(n):o.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:f.apiCell,state:A})}}_createNotebookCellExecution(c,w){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const f=new t(w,r,this.a);this.b.set(r.uri,f);const A=f.onDidChangeState(()=>{f.state===v.Resolved&&(f.dispose(),A.dispose(),this.b.delete(r.uri))});return f.asApiObject()}};O=qe([Ve(4,M.ILogService)],O),e.ExtHostNotebookKernels=O;var v;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(v||(v={}));class t extends E.Disposable{get state(){return this.f}constructor(c,w,n){super(),this.j=w,this.k=n,this.b=t.a++,this.c=new F.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new d(10,r=>this.m(r)),this.i=w.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const w=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new S.SerializableObjectWithBuffers(w))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let w=this.j;if(c&&(w=this.j.notebook.getCellFromApiCell(c)),!w)throw new Error("INVALID cell");return w.handle}s(c){return c.map(w=>{const n=o.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return n===w.items?m.NotebookCellOutput.from(w):m.NotebookCellOutput.from({items:n,id:w.id,metadata:w.metadata})})}async t(c,w,n){const r=this.r(w),f=this.s((0,i.asArray)(c));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:f})}async w(c,w,n){return c=o.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(m.NotebookCellOutputItem.from),outputId:w.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===v.Resolved||c.f===v.Started)throw new Error("Cannot call start again");c.f=v.Started,c.c.fire(),c.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(c.f===v.Resolved)throw new Error("Cannot call resolve twice");c.f=v.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new S.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,r){return c.n(),c.t(n,r,!0)},replaceOutput(n,r){return c.n(),c.t(n,r,!1)},appendOutputItems(n,r){return c.n(),c.w(n,r,!0)},replaceOutputItems(n,r){return c.n(),c.w(n,r,!1)}})}}t.a=0;class d{constructor(c,w){this.d=c,this.e=w,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new P.DeferredPromise,this.b=Date.now(),(0,P.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const w=this.a;return this.a=[],this.e(w).finally(()=>c.complete())}}function a(l,c){return`${l.value}/${c}`}e.createKernelId=a}),define(ke[225],Te([1,0,4,5,100]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,k){const M=this.c.getEditorById(R);this.a.get(y)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(M=>M.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(M,D,h)=>this.d(y).event(M,D,h),postMessage:(M,D)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,D]=[D,M]);const h=D&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(h?.id,y,M)}}}d(R){let y=this.a.get(R);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=F}),define(ke[226],Te([1,0,6,9,2,25,5]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(k){this.b=new Map,this.a=k.getProxy(E.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,M,D){if((0,F.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,D),this.a.$registerProfileContentHandler(M,D.name,D.description,k.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(k,M,D,h){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(M,D,h)}async $readProfile(k,M,D){const h=this.b.get(k);if(!h)throw new Error(`Unknown handler with id: ${k}`);return h.readProfile((0,P.isString)(M)?M:I.URI.revive(M),D)}}e.ExtHostProfileContentHandlers=R}),define(ke[227],Te([1,0,2,5,17,8]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class E{constructor(y,k){this.d=k,this.c=new Map,this.b=y.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,k,M){const D=i.URI.revive(k),h=this.c.get(y);return h?(0,I.asPromise)(()=>h.provideOriginalResource(D,M)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(y,k,M,D){const h=E.a++;return this.c.set(h,k),this.b.$registerQuickDiffProvider(h,F.DocumentSelector.from(y,this.d),M,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}E.a=0,e.ExtHostQuickDiff=E}),define(ke[228],Te([1,0,21,4,6,5,2,7,11,16,29,38,25,8]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(o,s,u){const p=o.getProxy(F.MainContext.MainThreadQuickOpen);class S{constructor(n,r){this.e=new Map,this.f=0,this.a=n,this.b=r}showQuickPick(n,r,f,A=i.CancellationToken.None){this.c=void 0;const T=Promise.resolve(r),H=++this.f,Q=p.$show(H,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},A),Z={},_=Q.then(()=>Z);return Promise.race([_,T]).then(j=>{if(j===Z)return;const L=(0,h.isProposedApiEnabled)(n,"quickPickItemTooltip");return T.then(g=>{const N=[];for(let B=0;B<g.length;B++){const J=g[B];typeof J=="string"?N.push({label:J,handle:B}):J.kind===R.QuickPickItemKind.Separator?N.push({type:"separator",label:J.label}):(J.tooltip&&!L&&console.warn(`Extension '${n.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${n.identifier.value}`),N.push({label:J.label,description:J.description,detail:J.detail,picked:J.picked,alwaysShow:J.alwaysShow,tooltip:L?b.MarkdownString.fromStrict(J.tooltip):void 0,handle:B}))}return f&&typeof f.onDidSelectItem=="function"&&(this.c=B=>{f.onDidSelectItem(g[B])}),p.$setItems(H,N),Q.then(B=>{if(typeof B=="number")return g[B];if(Array.isArray(B))return B.map(J=>g[J])})})}).then(void 0,j=>{if(!(0,y.isCancellationError)(j))return p.$setError(H,j),Promise.reject(j)})}$onItemSelected(n){this.c?.(n)}showInput(n,r=i.CancellationToken.None){return this.d=n?.validateInput,p.$input(n,typeof this.d=="function",r).then(void 0,f=>{if(!(0,y.isCancellationError)(f))return Promise.reject(f)})}async $validateInput(n){if(!this.d)return;const r=await this.d(n);if(!r||typeof r=="string")return r;let f;switch(r.severity){case R.InputBoxValidationSeverity.Info:f=M.default.Info;break;case R.InputBoxValidationSeverity.Warning:f=M.default.Warning;break;case R.InputBoxValidationSeverity.Error:f=M.default.Error;break;default:f=r.message?M.default.Error:M.default.Ignore;break}return{content:r.message,severity:f}}async showWorkspaceFolderPick(n,r=i.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const A=await this.a.getWorkspaceFolders2();if(!!A)return A.find(T=>T.uri.toString()===f.uri.toString())}createQuickPick(n){const r=new l(n,()=>this.e.delete(r._id));return this.e.set(r._id,r),r}createInputBox(n){const r=new c(n,()=>this.e.delete(r._id));return this.e.set(r._id,r),r}$onDidChangeValue(n,r){this.e.get(n)?._fireDidChangeValue(r)}$onDidAccept(n){this.e.get(n)?._fireDidAccept()}$onDidChangeActive(n,r){const f=this.e.get(n);f instanceof l&&f._fireDidChangeActive(r)}$onDidChangeSelection(n,r){const f=this.e.get(n);f instanceof l&&f._fireDidChangeSelection(r)}$onDidTriggerButton(n,r){this.e.get(n)?._fireDidTriggerButton(r)}$onDidTriggerItemButton(n,r,f){const A=this.e.get(n);A instanceof l&&A._fireDidTriggerItemButton(r,f)}$onDidHide(n){this.e.get(n)?._fireDidHide()}}class O{constructor(n,r){this.x=n,this.y=r,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.Emitter,this.q=new P.Emitter,this.r=new P.Emitter,this.s=new P.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(n){this.b=n,this.z({title:n})}get step(){return this.c}set step(n){this.c=n,this.z({step:n})}get totalSteps(){return this.d}set totalSteps(n){this.d=n,this.z({totalSteps:n})}get enabled(){return this.g}set enabled(n){this.g=n,this.z({enabled:n})}get busy(){return this.j}set busy(n){this.j=n,this.z({busy:n})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(n){this.k=n,this.z({ignoreFocusOut:n})}get value(){return this.l}set value(n){this.l=n,this.z({value:n})}get placeholder(){return this.m}set placeholder(n){this.m=n,this.z({placeholder:n})}get buttons(){return this.n}set buttons(n){this.n=n.slice(),this.o.clear(),n.forEach((r,f)=>{const A=r===R.QuickInputButtons.Back?-1:f;this.o.set(A,r)}),this.z({buttons:n.map((r,f)=>({...a(r),tooltip:r.tooltip,handle:r===R.QuickInputButtons.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(n){this.l=n,this.q.fire(n)}_fireDidTriggerButton(n){const r=this.o.get(n);r&&this.r.fire(r)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),p.$dispose(this._id))}z(n){if(!this.v){for(const r of Object.keys(n)){const f=n[r];this.u[r]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){p.$createOrUpdate(this.u),this.u={id:this._id}}}O.a=1;function v(w){if(w instanceof R.ThemeIcon)return{id:w.id};const n=d(w),r=t(w);return{dark:typeof n=="string"?E.URI.file(n):n,light:typeof r=="string"?E.URI.file(r):r}}function t(w){return typeof w=="object"&&"light"in w?w.light:w}function d(w){return typeof w=="object"&&"dark"in w?w.dark:w}function a(w){const n=v(w.iconPath);let r,f;return"id"in n?f=D.ThemeIcon.asClassName(n):r=n,{iconPath:r,iconClass:f}}class l extends O{constructor(n,r){super(n.identifier,r),this.O=n,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.Emitter,this.L=[],this.M=new P.Emitter,this.N=new P.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(n){this.B=n.slice(),this.C.clear(),this.D.clear(),n.forEach((A,T)=>{this.C.set(T,A),this.D.set(A,T)});const r=(0,h.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),f=[];for(let A=0;A<n.length;A++){const T=n[A];T.kind===R.QuickPickItemKind.Separator?f.push({type:"separator",label:T.label}):(T.tooltip&&!r&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),f.push({handle:A,label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,tooltip:r?b.MarkdownString.fromStrict(T.tooltip):void 0,buttons:T.buttons?.map((H,Q)=>({...a(H),tooltip:H.tooltip,handle:Q}))}))}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(n){this.E=n,this.z({canSelectMany:n})}get matchOnDescription(){return this.F}set matchOnDescription(n){this.F=n,this.z({matchOnDescription:n})}get matchOnDetail(){return this.G}set matchOnDetail(n){this.G=n,this.z({matchOnDetail:n})}get sortByLabel(){return this.H}set sortByLabel(n){this.H=n,this.z({sortByLabel:n})}get keepScrollPosition(){return this.I}set keepScrollPosition(n){this.I=n,this.z({keepScrollPosition:n})}get activeItems(){return this.J}set activeItems(n){this.J=n.filter(r=>this.D.has(r)),this.z({activeItems:this.J.map(r=>this.D.get(r))})}get selectedItems(){return this.L}set selectedItems(n){this.L=n.filter(r=>this.D.has(r)),this.z({selectedItems:this.L.map(r=>this.D.get(r))})}_fireDidChangeActive(n){const r=(0,k.coalesce)(n.map(f=>this.C.get(f)));this.J=r,this.K.fire(r)}_fireDidChangeSelection(n){const r=(0,k.coalesce)(n.map(f=>this.C.get(f)));this.L=r,this.M.fire(r)}_fireDidTriggerItemButton(n,r){const f=this.C.get(n);if(!f||!f.buttons||!f.buttons.length)return;const A=f.buttons[r];A&&this.N.fire({button:A,item:f})}}class c extends O{constructor(n,r){super(n.identifier,r),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(n){this.B=n,this.z({password:n})}get prompt(){return this.C}set prompt(n){this.C=n,this.z({prompt:n})}get valueSelection(){return this.D}set valueSelection(n){this.D=n,this.z({valueSelection:n})}get validationMessage(){return this.E}set validationMessage(n){this.E=n,n?typeof n=="string"?this.z({validationMessage:n,severity:M.default.Error}):this.z({validationMessage:n.message,severity:n.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new S(s,u)}e.createExtHostQuickOpen=m});var Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i};define(ke[229],Te([1,0,2,4,64,6,17,5,16,123,12,26,38,8,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m){"use strict";var o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(r){if(r)return typeof r.iconPath=="string"?i.URI.file(r.iconPath):i.URI.isUri(r.iconPath)||h.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function p(r,f){if(!r.iconPath&&!f.iconPath)return 0;if(r.iconPath){if(!f.iconPath)return 1}else return-1;const A=typeof r.iconPath=="string"?r.iconPath:i.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,T=typeof f.iconPath=="string"?f.iconPath:i.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,k.comparePaths)(A,T)}function S(r,f){let A=0;if(r.strikeThrough!==f.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==f.faded)return r.faded?1:-1;if(r.tooltip!==f.tooltip)return(r.tooltip||"").localeCompare(f.tooltip||"");if(A=p(r,f),A!==0)return A;if(r.light&&f.light)A=p(r.light,f.light);else{if(r.light)return 1;if(f.light)return-1}if(A!==0)return A;if(r.dark&&f.dark)A=p(r.dark,f.dark);else{if(r.dark)return 1;if(f.dark)return-1}return A}function O(r,f){if(r.command!==f.command)return r.command<f.command?-1:1;if(r.title!==f.title)return r.title<f.title?-1:1;if(r.tooltip!==f.tooltip){if(r.tooltip!==void 0&&f.tooltip!==void 0)return r.tooltip<f.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(r.arguments===f.arguments)return 0;if(r.arguments)if(f.arguments){if(r.arguments.length!==f.arguments.length)return r.arguments.length-f.arguments.length}else return 1;else return-1;for(let A=0;A<r.arguments.length;A++){const T=r.arguments[A],H=f.arguments[A];if(T!==H)return T<H?-1:1}return 0}function v(r,f){let A=(0,k.comparePaths)(r.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(A!==0)return A;if(r.command&&f.command)A=O(r.command,f.command);else{if(r.command)return 1;if(f.command)return-1}if(A!==0)return A;if(r.decorations&&f.decorations)A=S(r.decorations,f.decorations);else{if(r.decorations)return 1;if(f.decorations)return-1}return A}function t(r,f){for(let A=0;A<r.length;A++)if(r[A]!==f[A])return!1;return!0}function d(r,f){return r.command===f.command&&r.title===f.title&&r.tooltip===f.tooltip&&(r.arguments&&f.arguments?t(r.arguments,f.arguments):r.arguments===f.arguments)}function a(r,f){return(0,y.equals)(r,f,d)}class l{get value(){return this.d}set value(f){f=f??"",Le(this,o,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Le(this,o,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Le(this,o,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Le(this,o,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Le(this,o,"f").$setInputBoxVisibility(this.l,f))}constructor(f,A,T){this.k=f,this.l=T,o.set(this,void 0),this.d="",this.e=new P.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,o,A,"f")}showValidationMessage(f,A){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,o,"f").$showValidationMessage(this.l,f,A)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=l,o=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,A,T,H,Q){this.q=f,this.s=A,this.t=T,this.u=H,this.v=Q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,A){const T=this.h.get(f);return T?(0,E.asPromise)(()=>this.s.executeCommand(T.command,...T.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(v),T=(0,y.sortedDiff)(this.o,f,v).map(Z=>{const _=Z.toInsert.map(j=>{const L=this.e++;this.g.set(L,j);const g=j.resourceUri;let N;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const X=new F.DisposableStore;N=this.s.converter.toInternal(j.command,X),this.j.set(L,X)}else this.h.set(L,j.command);const B=u(j.decorations),J=j.decorations&&u(j.decorations.light)||B,me=j.decorations&&u(j.decorations.dark)||B,te=[J,me],oe=j.decorations&&j.decorations.tooltip||"",ce=j.decorations&&!!j.decorations.strikeThrough,we=j.decorations&&!!j.decorations.faded,q=j.contextValue||"";return{rawResource:[L,g,te,oe,ce,we,q,N],handle:L}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:_}}),H=T.map(({start:Z,deleteCount:_,toInsert:j})=>[Z,_,j.map(L=>L.rawResource)]),Q=T.reverse();for(const{start:Z,deleteCount:_,toInsert:j}of Q){const L=j.map(N=>N.handle),g=this.n.splice(Z,_,...L);for(const N of g)this.g.delete(N),this.h.delete(N),this.j.get(N)?.dispose(),this.j.delete(N)}return this.o=f,H}dispose(){this.l=!0,this.m.fire()}}c.d=0;class w{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Le(this,s,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,f?.label&&(0,m.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Le(this,s,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f,quickDiffLabel:f?.label})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Le(this,s,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new F.DisposableStore,this.l=f;const A=this.v.converter.toInternal(f,this.k.value);Le(this,s,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new F.DisposableStore,this.n=f;const A=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(T=>T.map(H=>this.v.converter.toInternal(H,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Le(this,s,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&a(this.p,f))return;this.o.value=new F.DisposableStore,this.p=f;const A=(f||[]).map(T=>this.v.converter.toInternal(T,this.o.value));Le(this,s,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(f,A,T,H,Q,Z){this.u=f,this.v=T,this.w=H,this.x=Q,this.y=Z,s.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new F.MutableDisposable,this.l=void 0,this.m=new F.MutableDisposable,this.o=new F.MutableDisposable,this.p=void 0,this.q=!1,this.s=new P.Emitter,this.onDidChangeSelection=this.s.event,this.t=w.d++,this.z=new Map,this.A=new Set,Je(this,s,A,"f"),this.f=new l(f,Le(this,s,"f"),this.t),Le(this,s,"f").$registerSourceControl(this.t,H,Q,Z)}createResourceGroup(f,A){const T=new c(Le(this,s,"f"),this.v,this.t,f,A),H=P.Event.once(T.onDidDispose)(()=>this.z.delete(T));return this.z.set(T,H),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const f=[],A=[];for(const[T,H]of this.z){H.dispose();const Q=T.onDidUpdateResourceStates(()=>{this.A.add(T),this.eventuallyUpdateResourceStates()});P.Event.once(T.onDidDispose)(()=>{this.A.delete(T),Q.dispose(),this.e.delete(T.handle),Le(this,s,"f").$unregisterGroup(this.t,T.handle)}),f.push([T.handle,T.id,T.label,T.features]);const Z=T._takeResourceStateSnapshot();Z.length>0&&A.push([T.handle,Z]),this.e.set(T.handle,T)}Le(this,s,"f").$registerGroups(this.t,f,A),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(A=>{const T=A._takeResourceStateSnapshot();T.length!==0&&f.push([A.handle,T])}),f.length>0&&Le(this,s,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Le(this,s,"f").$unregisterSourceControl(this.t)}}s=new WeakMap,w.d=0,qe([(0,I.debounce)(100)],w.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(f,A,T){this.l=A,this.m=T,this.g=new Map,this.h=new Map,this.j=new P.Emitter,this.e=f.getProxy(R.MainContext.MainThreadSCM),this.f=f.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:H=>{if(H&&H.$mid===3){const Q=this.g.get(H.sourceControlHandle);if(!Q)return H;const Z=Q.getResourceGroup(H.groupHandle);return Z?Z.getResourceState(H.handle):H}else if(H&&H.$mid===4){const Q=this.g.get(H.sourceControlHandle);return Q?Q.getResourceGroup(H.groupHandle):H}else if(H&&H.$mid===5){const Q=this.g.get(H.handle);return Q||H}return H}})}createSourceControl(f,A,T,H){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,A,T,H),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const Q=on.d++,Z=new w(f,this.e,this.l,A,T,H);this.g.set(Q,Z);const _=this.h.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return _.push(Z),this.h.set(D.ExtensionIdentifier.toKey(f.identifier),_),Z}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const A=this.h.get(D.ExtensionIdentifier.toKey(f.identifier)),T=A&&A[A.length-1];return T&&T.inputBox}$provideOriginalResource(f,A,T){const H=i.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",f,H.toString());const Q=this.g.get(f);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>Q.quickDiffProvider.provideOriginalResource(H,T)).then(Z=>Z||null)}$onInputBoxValueChange(f,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const T=this.g.get(f);return T&&T.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(f,A,T,H){this.m.trace("ExtHostSCM#$executeResourceCommand",f,A,T);const Q=this.g.get(f);if(!Q)return Promise.resolve(void 0);const Z=Q.getResourceGroup(A);return Z?Z.$executeResourceCommand(T,H):Promise.resolve(void 0)}$validateInput(f,A,T){this.m.trace("ExtHostSCM#$validateInput",f);const H=this.g.get(f);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>H.inputBox.validateInput(A,T)).then(Q=>{if(!Q)return Promise.resolve(void 0);const Z=b.MarkdownString.fromStrict(Q.message);return Z?Promise.resolve([Z,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,M.ILogService)],n),e.ExtHostSCM=n}),define(ke[79],Te([1,0,5,4,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(R){this.b=new P.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,k){return this.a.$setPassword(R,y,k)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[230],Te([1,0,7,5,142,6,8,9]),function(ne,e,i,P,I,F,E,R){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(m,o,s,u,p=i.StatusBarAlignment.Left,S){y.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new F.DisposableStore,Je(this,y,m,"f"),Je(this,k,o,"f"),this.c=M.a++,this.e=s,this.f=u,this.g=p,this.h=this.u(S)}u(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!M.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new F.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,k,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,k,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let o;this.m?o=this.m:o=(0,I.localize)(0,null,this.e.displayName||this.e.name);let s=this.n;this.o&&(s=M.b.get(this.o.id));const u=E.MarkdownString.fromStrict(this.l);Le(this,y,"f").$setEntry(this.c,m,o,this.k,u,this.r?.internal,s,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,k=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=M;class D{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const o={message:m};return this.b.unshift(o),this.c(),new i.Disposable(()=>{const s=this.b.indexOf(o);s>=0&&(this.b.splice(s,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(m,o){this.a=m.getProxy(P.MainContext.MainThreadStatusBar),this.b=o,this.c=new D(this)}createStatusBarEntry(m,o,s,u){return new M(this.a,this.b,m,o,s,u)}setStatusBarMessage(m,o){const s=this.c.setMessage(m);let u;return typeof o=="number"?u=setTimeout(()=>s.dispose(),o):typeof o<"u"&&o.then(()=>s.dispose(),()=>s.dispose()),new i.Disposable(()=>{s.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=h}),define(ke[80],Te([1,0,5,4,3]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(R,y){this.c=y,this.b=new P.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,k){const M=await this.a.$initializeExtensionStorage(R,y);let D;return M&&(D=this.d(R,y,M)),D||k}setValue(R,y,k){return this.a.$setValue(R,y,k)}$acceptValue(R,y,k){const M=this.d(R,y,k);M&&this.b.fire({shared:R,key:y,value:M})}d(R,y,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${M}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ke[81],Te([1,0,3,27,12,60,2]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,M,D){this.d=M,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(k){return E.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(E.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:E.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return E.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return E.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,P.IExtHostInitDataService),Ve(1,I.ILogService),Ve(2,F.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(ke[61],Te([1,0,4,5,3,2,18,6,7,144,11,171,21,34,172,38,9,17,8]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class S{constructor(n,r,f,A){this.k=n,this._id=r,this.l=f,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(H=>this.f=H);const T=this;this.value={get name(){return T.m||""},get processId(){return T.b},get creationOptions(){return T.l},get exitStatus(){return T.h},get state(){return T.j},sendText(H,Q=!0){T.o(),T.k.$sendText(T._id,H,Q)},show(H){T.o(),T.k.$show(T._id,H)},hide(){T.o(),T.k.$hide(T._id)},dispose(){T.a||(T.a=!0,T.k.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,s.withNullAsUndefined)(n.shellPath),shellArgs:(0,s.withNullAsUndefined)(n.shellArgs),cwd:(0,s.withNullAsUndefined)(n.cwd),env:(0,s.withNullAsUndefined)(n.env),icon:(0,s.withNullAsUndefined)(l(n.iconPath)),color:o.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,s.withNullAsUndefined)(n.message),strictEnv:(0,s.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,s.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,s.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,s.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,s.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,f,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:o.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=S;class O{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let v=1,t=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(P.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,A]of this.g)A.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const f=new S(this.a,(0,b.generateUuid)(),n,n.name),A=new O(n.pty);return f.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,l(n.iconPath),c(n.color)).then(T=>{const H=this.M(T,A);this.h[T]=H}),this.f.push(f),f.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const A=this.f.find(T=>T.value===f);A&&(r.resolvedExtHostIdentifier=A._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const A=new O(r),T=this.M(n,A);this.h[n]=T}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:r})}async $acceptTerminalDimensions(n,r,f){const A=this.O(n);A&&A.setDimensions(r,f)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,f){this.g.get(n)?.resize(r,f)}async $acceptTerminalTitleChange(n,r){const f=this.O(n);f&&(f.name=r)}async $acceptTerminalClosed(n,r,f){const A=this.Q(this.f,n);if(A!==null){const T=this.f.splice(A,1)[0];T.setExitStatus(r,f),this.C.fire(T.value)}}$acceptTerminalOpened(n,r,f,A){if(r){const Q=this.Q(this.f,r);if(Q!==null){this.f[Q]._id=n,this.D.fire(this.terminals[Q]),this.f[Q].isOpen=!0;return}}const T={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},H=new S(this.a,n,T,f);this.f.push(H),this.D.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const f=this.O(n);if(!f)return{message:(0,k.localize)(0,null,n)};f.isOpen||await new Promise(T=>{const H=this.onDidOpenTerminal(async Q=>{Q===f.value&&(H.dispose(),T())})});const A=this.g.get(n);A?A.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const f=new R.DisposableStore;f.add(r.onProcessReady(T=>this.a.$sendProcessReady(n,T.pid,T.cwd))),f.add(r.onDidChangeProperty(T=>this.a.$sendProcessProperty(n,T))),this.s.startBuffering(n,r.onProcessData),f.add(r.onProcessExit(T=>this.N(n,T))),this.g.set(n,r);const A=this.j[n];return A&&r instanceof O&&(r.startSendingEvents(A.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,f){try{this.g.get(n)?.resize(r,f)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,f){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,f),this.a.$registerProfileProvider(r,n.identifier.value),new y.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,r),new y.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const f=new h.CancellationTokenSource().token;if(f.isCancellationRequested)return;const A=this.w.get(n);if(!A)return;const T=await A.provideTerminalQuickFixes(r,f);if(T!==null)return T}async $createContributedProfileTerminal(n,r){const f=new h.CancellationTokenSource().token;let A=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,r);return}this.createTerminalFromOptions(A.options,r)}}async $provideLinks(n,r){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const T=new h.CancellationTokenSource;this.z.set(n,T);const H=[],Q={terminal:f.value,line:r},Z=[];for(const L of this.u)Z.push(u.Promises.withAsyncBody(async g=>{T.token.onCancellationRequested(()=>g({provider:L,links:[]}));const N=await L.provideTerminalLinks(Q,T.token)||[];T.token.isCancellationRequested||g({provider:L,links:N})}));const _=await Promise.all(Z);if(T.token.isCancellationRequested)return[];const j=new Map;for(const L of _)L&&L.links.length>0&&H.push(...L.links.map(g=>{const N={id:v++,startIndex:g.startIndex,length:g.length,label:g.tooltip};return j.set(N.id,{provider:L.provider,link:g}),N}));return this.y.set(n,j),H}$activateLink(n,r){const f=this.y.get(n)?.get(r);!f||f.provider.handleTerminalLink(f.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const f=this.Q(n,r);return f!==null?n[f]:null}Q(n,r){let f=null;return n.some((A,T)=>A._id===r?(f=T,!0):!1),f}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new d,this.S(n.identifier.value,r)),r}R(n,r){const f=(0,D.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const f=r[0],A=new d(r[1]);this.S(f,A)})}$acceptDefaultProfile(n,r){const f=this.m;this.m=n,this.n=r,f?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};t=qe([Ve(1,E.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}d(n,r){const f=this.map.get(n);(!f||f.value!==r.value||f.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((f,A)=>n.call(r,A,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends t{constructor(n){super(!1,n)}createTerminal(n,r,f){throw new M.NotSupportedError}createTerminalFromOptions(n,r){throw new M.NotSupportedError}};a=qe([Ve(0,E.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function l(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function c(w){return o.ThemeColor.isThemeColor(w)?w:void 0}});var Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i};define(ke[231],Te([1,0,16,17,23,21,4,195,232,6,22,9,34,5,18,101,8,7,45,72,56,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(L,g,N){this.j=N,this.c=new E.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=L.getProxy(b.MainContext.MainThreadTesting),this.h=new Q(this.f),this.g=new n(this.f),g.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const J=B,me=J.tests[J.tests.length-1].item.extId;return this.d.get(p.TestId.root(me))?.collection.tree.get(me)?.actual??(0,o.toItemFromContext)(B)}})}createTestController(L,g,N,B){if(this.d.has(g))throw new Error(`Attempt to insert a duplicate controller with ID "${g}"`);const J=new k.DisposableStore,me=J.add(new o.ExtHostTestItemCollection(g,N,this.j));me.root.label=N;const te=new Map,oe=this.f,ce={items:me.root.children,get label(){return N},set label(q){N=q,me.root.label=q,oe.$updateController(g,{label:N})},get refreshHandler(){return B},set refreshHandler(q){B=q,oe.$updateController(g,{canRefresh:!!q})},get id(){return g},createRunProfile:(q,x,X,de,ye,Ne)=>{let ze=(0,y.hash)(q);for(;te.has(ze);)ze++;return Ne!==void 0&&(0,v.checkProposedApiEnabled)(L,"testContinuousRun"),new Z(this.f,te,g,ze,q,x,X,de,ye,Ne)},createTestItem(q,x,X){return new o.TestItemImpl(g,q,x,X)},createTestRun:(q,x,X=!0)=>this.g.createTestRun(g,me,q,x,X),set resolveHandler(q){me.resolveHandler=q},get resolveHandler(){return me.resolveHandler},dispose:()=>{J.dispose()}};oe.$registerTestController(g,N,!!B),J.add((0,k.toDisposable)(()=>oe.$unregisterTestController(g)));const we={controller:ce,collection:me,profiles:te};return this.d.set(g,we),J.add((0,k.toDisposable)(()=>this.d.delete(g))),J.add(me.onDidGenerateDiff(q=>oe.$publishDiff(g,q.map(O.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.h.checkout()}async runTests(L,g=F.CancellationToken.None){const N=r(L);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(N.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(J=>p.TestId.fromExtHostTestItem(J,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:_[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:L.exclude?.map(J=>J.id)},g)}$syncTests(){for(const{collection:L}of this.d.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,g,N){return(0,i.mapFind)(this.g.trackers,J=>J.id===L?J.getCoverage(g):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(L,g,N,B){return(0,i.mapFind)(this.g.trackers,me=>me.id===L?me.getCoverage(g):void 0)?.resolveFileCoverage(N,B)??Promise.resolve([])}$configureRunProfile(L,g){this.d.get(L)?.profiles.get(g)?.configureHandler?.()}async $refreshTests(L,g){await this.d.get(L)?.controller.refreshHandler?.(g)}$publishTestResults(L){this.results=Object.freeze(L.map(g=>(0,M.deepFreeze)(s.TestResults.to(g))).concat(this.results).sort((g,N)=>N.completedAt-g.completedAt).slice(0,32)),this.c.fire()}async $expandTest(L,g){const N=this.d.get(p.TestId.fromString(L).controllerId)?.collection;N&&(await N.expand(L,g<0?1/0:g),N.flushDiff())}$acceptDiff(L){this.h.applyDiff(L.map(O.TestsDiffOp.deserialize))}async $runControllerTests(L,g){return Promise.all(L.map(N=>this.k(N,!1,g)))}async $startContinuousRun(L,g){const N=new F.CancellationTokenSource(g),B=await Promise.all(L.map(J=>this.k(J,!0,N.token)));return!g.isCancellationRequested&&!B.some(J=>J.error)&&await new Promise(J=>g.onCancellationRequested(J)),N.dispose(!0),B}async k(L,g,N){const B=this.d.get(L.controllerId);if(!B)return{};const{collection:J,profiles:me}=B,te=me.get(L.profileId);if(!te)return{};const oe=L.testIds.map(x=>J.tree.get(x)).filter(D.isDefined),ce=L.excludeExtIds.map(x=>B.collection.tree.get(x)).filter(D.isDefined).filter(x=>oe.some(X=>X.fullId.compare(x.fullId)===2));if(!oe.length)return{};const we=new u.TestRunRequest2(oe.some(x=>x.actual instanceof o.TestItemRootImpl)?void 0:oe.map(x=>x.actual),ce.map(x=>x.actual),te,g),q=(0,O.isStartControllerTests)(L)&&this.g.prepareForMainThreadTestRun(we,f.fromInternal(L,B.collection),N);try{return await te.runHandler(we,N),{}}catch(x){return{error:String(x)}}finally{q&&(q.hasRunningTasks&&!N.isCancellationRequested&&await E.Event.toPromise(q.onEnd),q.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.g.cancelAllRuns():this.g.cancelRunById(L)}};a=qe([Ve(0,m.IExtHostRpcService)],a),e.ExtHostTesting=a;const l=1e4;var c;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(c||(c={}));class w extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(L,g,N){super(),this.k=L,this.l=g,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new E.Emitter),this.onEnd=this.j.event,this.h=this.B(new F.CancellationTokenSource(N));const B=this.B(new P.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(L){return this.f.get(L)?.coverage}createRun(L){const g=this.k.id,N=this.k.controllerId,B=(0,h.generateUuid)(),J=new A(this.l,g,B),me=we=>(q,...x)=>{if(oe){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(q)||(this.s(q),we(q,...x))},te=(we,q)=>{const x=q instanceof Array?q.map(s.TestMessage.from):[s.TestMessage.from(q)];if(we.uri&&we.range){const X={range:s.Range.from(we.range),uri:we.uri};for(const de of x)de.location=de.location||X}this.l.$appendTestMessagesInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),x)};let oe=!1;const ce={isPersisted:this.k.isPersisted,token:this.h.token,name:L,get coverageProvider(){return J.coverageProvider},set coverageProvider(we){J.coverageProvider=we},enqueued:me(we=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),1)}),skipped:me(we=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),5)}),started:me(we=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),2)}),errored:me((we,q,x)=>{te(we,q),this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),6,x)}),failed:me((we,q,x)=>{te(we,q),this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,N).toString(),4,x)}),passed:me((we,q)=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(we,this.k.controllerId).toString(),3,q)}),appendOutput:(we,q,x)=>{oe||(x&&(this.k.isIncluded(x)?this.s(x):x=void 0),this.l.$appendOutputToRun(g,B,I.VSBuffer.fromString(we),q&&s.location.from(q),x&&p.TestId.fromExtHostTestItem(x,N).toString()))},end:()=>{oe||(oe=!0,this.l.$finishedTestRunTask(g,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:ce,coverage:J}),this.l.$startedTestRunTask(g,{id:B,name:L,running:!0}),ce}m(){for(const{run:L}of this.f.values())L.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(L){if(!(L instanceof o.TestItemImpl))throw new S.InvalidTestItemError(L.id);if(this.g.has(p.TestId.fromExtHostTestItem(L,this.k.controllerId).toString()))return;const g=[],N=this.k.colllection.root;for(;;){const B=s.TestItem.from(L);if(g.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),L===N))break;L=L.parent||N}this.l.$addTestsToRun(this.k.controllerId,this.k.id,g)}}class n{get trackers(){return this.c.values()}constructor(L){this.d=L,this.c=new Map}prepareForMainThreadTestRun(L,g,N){return this.f(L,g,N)}cancelRunById(L){for(const g of this.c.values())if(g.id===L){g.cancel();return}}cancelAllRuns(){for(const L of this.c.values())L.cancel()}createTestRun(L,g,N,B,J){const me=this.c.get(N);if(me)return me.createRun(B);const te=f.fromPublic(L,g,N,J),oe=r(N);this.d.$startedExtensionTestRun({controllerId:L,continuous:!!N.continuous,profile:oe&&{group:_[oe.kind],id:oe.profileId},exclude:N.exclude?.map(we=>p.TestId.fromExtHostTestItem(we,g.root.id).toString())??[],id:te.id,include:N.include?.map(we=>p.TestId.fromExtHostTestItem(we,g.root.id).toString())??[g.root.id],persist:J});const ce=this.f(N,te);return ce.onEnd(()=>{this.d.$finishedExtensionTestRun(te.id),ce.dispose()}),ce.createRun(B)}f(L,g,N){const B=new w(g,this.d,N);return this.c.set(L,B),B.onEnd(()=>this.c.delete(L)),B}}e.TestRunCoordinator=n;const r=j=>{if(!!j.profile){if(!(j.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class f{static fromPublic(L,g,N,B){return new f(L,(0,h.generateUuid)(),N.include?.map(J=>p.TestId.fromExtHostTestItem(J,L).toString())??[L],N.exclude?.map(J=>p.TestId.fromExtHostTestItem(J,L).toString())??[],B,g)}static fromInternal(L,g){return new f(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,g)}constructor(L,g,N,B,J,me){this.controllerId=L,this.id=g,this.isPersisted=J,this.colllection=me,this.c=N.map(te=>te+"\0"),this.d=B.map(te=>te+"\0")}isIncluded(L){const g=p.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const N of this.d)if(g===N||g.startsWith(N))return!1;for(const N of this.c)if(g===N||g.startsWith(N))return!0;return!1}}e.TestRunDto=f;class A{set coverageProvider(L){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this.c=L,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(L,g,N){this.f=L,this.g=g,this.h=N}async provideFileCoverage(L){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(L))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(g){throw this.d=void 0,g}}async resolveFileCoverage(L,g){const N=await this.d;let B=N?.[L];return!this.c||!N||!B?[]:(B.detailedCoverage||(B=N[L]=await this.c.resolveFileCoverage?.(B,g)??B),B.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class T{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(L){this.h=L,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(L){this.c.add(L)}update(L){Object.assign(L.revived,s.TestItem.toPlain(L.item)),this.c.has(L)||this.d.add(L)}remove(L){if(this.c.has(L)){this.c.delete(L);return}this.d.delete(L);const g=p.TestId.parentId(L.item.extId);if(g&&this.g.has(g.toString())){this.g.add(L.item.extId);return}this.f.add(L)}getChangeEvent(){const{c:L,d:g,f:N}=this;return{get added(){return[...L].map(B=>B.revived)},get updated(){return[...g].map(B=>B.revived)},get removed(){return[...N].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class H extends O.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new E.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(L){return this.d.get(L)}getMirroredTestDataByReference(L){return this.d.get(L.id)}p(L,g){return{...L,revived:s.TestItem.toPlain(L.item),depth:g?g.depth+1:0,children:new Set}}o(){return new T(this.q)}}class Q{constructor(L){this.d=L}checkout(){this.c||(this.c=this.f());const L=this.c;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(g=>g.revived)},dispose:(0,R.once)(()=>{--L.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(L){return this.c?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.c?.tests.apply(L)}f(){const L=new H;return this.d.$subscribeToDiffs(),{observers:0,tests:L}}}class Z{get label(){return this.d}set label(L){L!==this.d&&(this.d=L,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(L){L!==this.g&&(this.g=L,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this.f}set isDefault(L){L!==this.f&&(this.f=L,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?s.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.c}set configureHandler(L){L!==this.c&&(this.c=L,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,g,N,B,J,me,te,oe=!1,ce=void 0,we=!1){this.controllerId=N,this.profileId=B,this.d=J,this.kind=me,this.runHandler=te,this.f=oe,this._tag=ce,this.g=we,t.set(this,void 0),d.set(this,void 0),Je(this,t,L,"f"),Je(this,d,g,"f"),g.set(B,this);const q=_[me];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);Le(this,t,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:ce?s.TestTag.namespace(this.controllerId,ce.id):null,label:J,group:q,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:we})}dispose(){Le(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Le(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,t=new WeakMap,d=new WeakMap;const _={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ke[233],Te([1,0,16,4,5,102,8,7]),function(ne,e,i,P,I,F,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(M,D){this.i=D,this.a=new P.Emitter,this.b=new P.Emitter,this.c=new P.Emitter,this.d=new P.Emitter,this.f=new P.Emitter,this.g=new P.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(I.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const D=this.i.allEditors();return M?D:D.map(h=>h.value)}async showTextDocument(M,D,h){let b;typeof D=="number"?b={position:E.ViewColumn.from(D),preserveFocus:h}:typeof D=="object"?b={position:E.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?E.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(M.uri,b),o=m&&this.i.getEditor(m);if(o)return o.value;throw m?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,D){return new F.TextEditorDecorationType(this.h,M,D).value}$acceptEditorPropertiesChanged(M,D){const h=this.i.getEditor(M);if(!h)throw new Error("unknown text editor");if(D.options&&h._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(E.Selection.to);h._acceptSelections(b)}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(E.Range.to));h._acceptVisibleRanges(b)}if(D.options&&this.b.fire({textEditor:h.value,options:{...D.options,lineNumbers:E.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=R.TextEditorSelectionChangeKind.fromValue(D.selections.source),m=D.selections.selections.map(E.Selection.to);this.a.fire({textEditor:h.value,selections:m,kind:b})}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(E.Range.to));this.c.fire({textEditor:h.value,visibleRanges:b})}}$acceptEditorPositionData(M){for(const D in M){const h=this.i.getEditor(D);if(!h)throw new Error("Unknown text editor");const b=E.ViewColumn.to(M[D]);h.value.viewColumn!==b&&(h._acceptViewColumn(b),this.d.fire({textEditor:h.value,viewColumn:b}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=y}),define(ke[234],Te([1,0,2,3,5,6,7,8,26,9]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class M{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(I.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(o,s)=>{if(o&&o.$mid===12)if(this.b.get(o.source)&&y.ExtensionIdentifier.equals(s,this.b.get(o.source)?.extension)){const u=o.uri===void 0?void 0:i.URI.revive(o.uri);return this.c.get(o.source)?.get(D(u))?.get(o.handle)}else return;return o}})}async $getTimeline(b,m,o,s){return this.b.get(b)?.provider.provideTimeline(i.URI.revive(m),o,s)}registerTimelineProvider(b,m,o,s){const u=new F.DisposableStore,p=this.d(m.id,s,u).bind(this);let S;m.onDidChange&&(S=m.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const O=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(v,t,d){t?.resetCache&&(u.clear(),O.get(m.id)?.clear());const a=await m.provideTimeline(v,t,d);if(a==null)return;const l=p(v,t);return{...a,source:m.id,items:a.items.map(l)}},dispose(){for(const v of O.values())v.get(m.id)?.clear();S?.dispose(),u.dispose()}},o)}d(b,m,o){return(s,u)=>{let p;if(u?.cacheResults){let S=this.c.get(b);S===void 0&&(S=new Map,this.c.set(b,S));const O=D(s);p=S.get(O),p===void 0&&(p=new Map,S.set(O,p))}return S=>{const{iconPath:O,...v}=S,t=`${b}|${S.id??S.timestamp}`;p?.set(t,S);let d,a,l;S.iconPath&&(O instanceof E.ThemeIcon?l={id:O.id,color:O.color}:i.URI.isUri(O)?(d=O,a=O):{light:d,dark:a}=O);let c;return E.MarkdownString.isMarkdownString(v.tooltip)?c=R.MarkdownString.from(v.tooltip):(0,k.isString)(v.tooltip)?c=v.tooltip:E.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=R.MarkdownString.from(v.detail)):(0,k.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=v.detail),{...v,id:v.id??void 0,handle:t,source:b,command:S.command?m.toInternal(S.command,o):void 0,icon:d,iconDark:a,themeIcon:l,tooltip:c,accessibilityInformation:S.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,F.toDisposable)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=M;function D(h){return h?.toString()}}),define(ke[235],Te([1,0,6,15,2,5]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(y){this.c=new Map,this.b=y.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,M,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const h=D.schemes.find(b=>!E.a.has(b));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,D.schemes,y,D.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(y,k,M){const D=this.c.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const h=I.URI.revive(k);return D.canOpenExternalUri(h,M)}async $openUri(y,k,M){const D=this.c.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(I.URI.revive(k.resolvedUri),{sourceUri:I.URI.revive(k.sourceUri)},M)}}E.a=new Set([P.Schemas.http,P.Schemas.https]),e.ExtHostUriOpeners=E}),define(ke[236],Te([1,0,5,2,6,11,26]),function(ne,e,i,P,I,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,M){if(this.c.has(E.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=R.a++;return this.c.add(E.ExtensionIdentifier.toKey(k)),this.d.set(D,M),this.b.$registerUriHandler(D,k),(0,I.toDisposable)(()=>{this.c.delete(E.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,M){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(P.URI.revive(M))}catch(h){(0,F.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(k){return P.URI.revive(await this.b.$createAppUri(k))}}R.a=0,e.ExtHostUrls=R});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[62],Te([1,0,4,15,22,2,158,181,73,5]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";var M,D,h,b,m,o,s,u,p,S,O,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(T,H,Q,Z,_,j,L){M.set(this,void 0),D.set(this,void 0),h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,""),u.set(this,void 0),p.set(this,!1),S.set(this,!1),O.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new i.Emitter),this._onDidDispose=Le(this,t,"f").event,Je(this,M,T,"f"),Je(this,D,H,"f"),Je(this,u,Q,"f"),Je(this,b,Z,"f"),Je(this,m,_,"f"),Je(this,o,j,"f"),Je(this,O,a(j),"f"),Je(this,v,l(j),"f"),Je(this,h,L,"f")}dispose(){Je(this,p,!0,"f"),Le(this,t,"f").fire(),Le(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Je(this,S,!0,"f"),(0,y.asWebviewUri)(T,Le(this,b,"f"))}get cspSource(){const T=Le(this,o,"f").extensionLocation;if(T.scheme===P.Schemas.https||T.scheme===P.Schemas.http){let H=T.toString();return H.endsWith("/")||(H+="/"),H+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Le(this,s,"f")}set html(T){this.a(),Le(this,s,"f")!==T&&(Je(this,s,T,"f"),Le(this,v,"f")&&!Le(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Je(this,S,!0,"f"),Le(this,h,"f").report("Webview vscode-resource: uris",Le(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,D,"f").$setHtml(Le(this,M,"f"),this.b(T)))}get options(){return this.a(),Le(this,u,"f")}set options(T){this.a(),I.equals(Le(this,u,"f"),T)||Le(this,D,"f").$setOptions(Le(this,M,"f"),n(Le(this,o,"f"),Le(this,m,"f"),T)),Je(this,u,T,"f")}async postMessage(T){if(Le(this,p,"f"))return!1;const H=(0,R.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Le(this,O,"f")});return Le(this,D,"f").$postMessage(Le(this,M,"f"),H.message,...H.buffers)}a(){if(Le(this,p,"f"))throw new Error("Webview is disposed")}b(T){if(!Le(this,v,"f"))return T;const H=Le(this,o,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,Q=Le(this,o,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Le(this,o,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Z,_,j,L,g,N)=>{const B=F.URI.from({scheme:L||"file",path:decodeURIComponent(g)}),J=(0,y.asWebviewUri)(B,{isRemote:H,authority:Q}).toString();return`${_}${J}${N}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Z,_,j,L,g,N)=>{const B=F.URI.from({scheme:L||"file",path:decodeURIComponent(g)}),J=(0,y.asWebviewUri)(B,{isRemote:H,authority:Q}).toString();return`${_}${J}${N}`})}}e.ExtHostWebview=d,M=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,S=new WeakMap,O=new WeakMap,v=new WeakMap,t=new WeakMap;function a(A){try{const T=(0,E.normalizeVersion)((0,E.parseVersion)(A.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function l(A){try{const T=(0,E.normalizeVersion)((0,E.parseVersion)(A.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class c{constructor(T,H,Q,Z,_){this.c=H,this.d=Q,this.e=Z,this.f=_,this.b=new Map,this.a=T.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(T,H,Q){const Z=this.g(T);if(Z){const{message:_}=(0,R.deserializeWebviewMessage)(H,Q.value);Z._onMessageEmitter.fire(_)}}$onMissingCsp(T,H){this.e.warn(`${H} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,H,Q){const Z=new d(T,this.a,r(H),this.c,this.d,Q,this.f);return this.b.set(T,Z),Z._onDidDispose(()=>{this.b.delete(T)}),Z}deleteWebview(T){this.b.delete(T)}g(T){return this.b.get(T)}}e.ExtHostWebviews=c;function w(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=w;function n(A,T,H){return{enableCommandUris:H.enableCommandUris,enableScripts:H.enableScripts,enableForms:H.enableForms,portMapping:H.portMapping,localResourceRoots:H.localResourceRoots||f(A,T)}}e.serializeWebviewOptions=n;function r(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(T=>F.URI.from(T))}}function f(A,T){return[...(T?.getWorkspaceFolders()||[]).map(H=>H.uri),A.extensionLocation]}}),define(ke[237],Te([1,0,21,232,6,15,24,2,8,62,54,5,7]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,a){this.document=d,this.b=a,this.a=1,this.c=new M.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,a){await this.f(d).undo(),a||this.disposeBackup()}async redo(d,a){await this.f(d).redo(),a||this.disposeBackup()}disposeEdits(d){for(const a of d)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this.a++;return(0,E.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const a=this.c.get(d,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get(d,a){return this.a.get(this.b(d,a))}add(d,a,l){const c=this.b(d,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${d} resource:${a.uri}`);const w=new b(a,l);return this.a.set(c,w),w}delete(d,a){const l=this.b(d,a.uri);this.a.delete(l)}b(d,a){return`${d}@@@${a}`}}var o;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(o||(o={}));class s{constructor(){this.a=new Map}addTextProvider(d,a,l){return this.b(0,d,a,l)}addCustomProvider(d,a,l){return this.b(1,d,a,l)}get(d){return this.a.get(d)}b(d,a,l,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:d,extension:l,provider:c}),new h.Disposable(()=>this.a.delete(a))}}class u{constructor(d,a,l,c,w){this.d=a,this.f=l,this.g=c,this.h=w,this.b=new s,this.c=new m,this.a=d.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,a,l,c){const w=new I.DisposableStore;return S(l)?(w.add(this.b.addTextProvider(a,d,l)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(d),a,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(d))):(w.add(this.b.addCustomProvider(a,d,l)),p(l)&&w.add(l.onDidChangeCustomDocument(n=>{const r=this.i(a,n.document.uri);if(O(n)){const f=r.addEdit(n);this.a.$onDidEdit(n.document.uri,a,f,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(d),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(d))),h.Disposable.from(w,new h.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(d,a,l,c,w){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const r=R.URI.revive(d),f=await n.provider.openCustomDocument(r,{backupId:l,untitledDocumentData:c?.buffer},w);let A;return p(n.provider)&&this.f&&(A=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,f,A),{editable:p(n.provider)}}async $disposeCustomDocument(d,a){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=R.URI.revive(d),{document:w}=this.i(a,c);this.c.delete(a,w),w.dispose()}async $resolveCustomEditor(d,a,l,c,w,n){const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);const f=y.ViewColumn.to(w),A=this.g.createNewWebview(a,c.contentOptions,r.extension),T=this.h.createNewWebviewPanel(a,l,c.title,f,c.options,A,!0),H=R.URI.revive(d);switch(r.type){case 1:{const{document:Q}=this.i(l,H);return r.provider.resolveCustomEditor(Q,T,n)}case 0:{const Q=this.d.getDocument(H);return r.provider.resolveCustomTextEditor(Q,T,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,a,l){this.i(a,d).disposeEdits(l)}async $onMoveCustomEditor(d,a,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const w=this.h.getWebviewPanel(d);if(!w)throw new Error("No webview found");const n=R.URI.revive(a),r=this.d.getDocument(n);await c.provider.moveCustomTextEditor(r,w,i.CancellationToken.None)}async $undo(d,a,l,c){return this.i(a,d).undo(l,c)}async $redo(d,a,l,c){return this.i(a,d).redo(l,c)}async $revert(d,a,l){const c=this.i(a,d);await this.j(a).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(d,a,l){const c=this.i(a,d);await this.j(a).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(d,a,l,c){const w=this.i(a,d);return this.j(a).saveCustomDocumentAs(w.document,R.URI.revive(l),c)}async $backup(d,a,l){const c=this.i(a,d),n=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(n),n.id}i(d,a){const l=this.c.get(d,R.URI.revive(a));if(!l)throw new Error("No custom document found");return l}j(d){const l=this.b.get(d)?.provider;if(!l||!p(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=u;function p(t){return!!t.onDidChangeCustomDocument}function S(t){return typeof t.resolveCustomTextEditor=="function"}function O(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const d=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,P.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[238],Te([1,0,4,6,2,34,8,62,5,7]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";var M,D,h,b,m,o,s,u,p,S,O,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends P.Disposable{constructor(w,n,r,f){super(),M.set(this,void 0),D.set(this,void 0),h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,void 0),u.set(this,void 0),p.set(this,!0),S.set(this,void 0),O.set(this,!1),v.set(this,this.B(new i.Emitter)),this.onDidDispose=Le(this,v,"f").event,t.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,Je(this,M,w,"f"),Je(this,D,n,"f"),Je(this,b,r,"f"),Je(this,h,f.viewType,"f"),Je(this,m,f.panelOptions,"f"),Je(this,u,f.viewColumn,"f"),Je(this,o,f.title,"f"),Je(this,S,f.active,"f")}dispose(){Le(this,O,"f")||(Je(this,O,!0,"f"),Le(this,v,"f").fire(),Le(this,D,"f").$disposeWebview(Le(this,M,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,h,"f")}get title(){return this.c(),Le(this,o,"f")}set title(w){this.c(),Le(this,o,"f")!==w&&(Je(this,o,w,"f"),Le(this,D,"f").$setTitle(Le(this,M,"f"),w))}get iconPath(){return this.c(),Le(this,s,"f")}set iconPath(w){this.c(),Le(this,s,"f")!==w&&(Je(this,s,w,"f"),Le(this,D,"f").$setIconPath(Le(this,M,"f"),I.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,u,"f")=="number"&&Le(this,u,"f")<0))return Le(this,u,"f")}get active(){return this.c(),Le(this,S,"f")}get visible(){return this.c(),Le(this,p,"f")}_updateViewState(w){Le(this,O,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(Je(this,S,w.active,"f"),Je(this,p,w.visible,"f"),Je(this,u,w.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(w,n){this.c(),Le(this,D,"f").$reveal(Le(this,M,"f"),{viewColumn:typeof w>"u"?void 0:E.ViewColumn.from(w),preserveFocus:!!n})}c(){if(Le(this,O,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,S=new WeakMap,O=new WeakMap,v=new WeakMap,t=new WeakMap;class a{static c(){return(0,F.generateUuid)()}constructor(w,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=w.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(w,n,r,f,A={}){const T=typeof f=="object"?f.viewColumn:f,H={viewColumn:E.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},Q=(0,R.shouldSerializeBuffersForPostMessage)(w),Z=a.c();this.d.$createWebviewPanel((0,R.toExtensionData)(w),Z,n,{title:r,panelOptions:l(A),webviewOptions:(0,R.serializeWebviewOptions)(w,this.h,A),serializeBuffersForPostMessage:Q},H);const _=this.g.createNewWebview(Z,A,w);return this.createNewWebviewPanel(Z,n,r,T,A,_,!0)}$onDidChangeWebviewPanelViewStates(w){const n=Object.keys(w);n.sort((r,f)=>{const A=w[r],T=w[f];return A.active?1:T.active?-1:+A.visible-+T.visible});for(const r of n){const f=this.getWebviewPanel(r);if(!f)continue;const A=w[r];f._updateViewState({active:A.active,visible:A.visible,viewColumn:E.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.e.delete(w),this.g.deleteWebview(w)}registerWebviewPanelSerializer(w,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:w}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(w)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(w,n,r,f){const A=this.f.get(n);if(!A)throw new Error(`No serializer found for '${n}'`);const{serializer:T,extension:H}=A,Q=this.g.createNewWebview(w,r.webviewOptions,H),Z=this.createNewWebviewPanel(w,n,r.title,f,r.panelOptions,Q,r.active);await T.deserializeWebviewPanel(Z,r.state)}createNewWebviewPanel(w,n,r,f,A,T,H){const Q=new d(w,this.d,T,{viewType:n,title:r,viewColumn:f,panelOptions:A,active:H});return this.e.set(w,Q),Q}getWebviewPanel(w){return this.e.get(w)}}e.ExtHostWebviewPanels=a;function l(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[239],Te([1,0,4,6,62,8,5,7]),function(ne,e,i,P,I,F,E,R){"use strict";var y,k,M,D,h,b,m,o,s,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends P.Disposable{constructor(t,d,a,l,c,w){super(),y.set(this,void 0),k.set(this,void 0),M.set(this,void 0),D.set(this,void 0),h.set(this,!1),b.set(this,void 0),m.set(this,void 0),o.set(this,void 0),s.set(this,void 0),u.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Le(this,u,"f").event,p.set(this,this.B(new i.Emitter)),this.onDidDispose=Le(this,p,"f").event,Je(this,M,a,"f"),Je(this,m,l,"f"),Je(this,y,t,"f"),Je(this,k,d,"f"),Je(this,D,c,"f"),Je(this,b,w,"f")}dispose(){Le(this,h,"f")||(Je(this,h,!0,"f"),Le(this,p,"f").fire(),Le(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(t){this.a(),Le(this,m,"f")!==t&&(Je(this,m,t,"f"),Le(this,k,"f").$setWebviewViewTitle(Le(this,y,"f"),t))}get description(){return this.a(),Le(this,o,"f")}set description(t){this.a(),Le(this,o,"f")!==t&&(Je(this,o,t,"f"),Le(this,k,"f").$setWebviewViewDescription(Le(this,y,"f"),t))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,D,"f")}get viewType(){return Le(this,M,"f")}_setVisible(t){t===Le(this,b,"f")||Le(this,h,"f")||(Je(this,b,t,"f"),Le(this,u,"f").fire())}get badge(){return this.a(),Le(this,s,"f")}set badge(t){this.a(),!(t?.value===Le(this,s,"f")?.value&&t?.tooltip===Le(this,s,"f")?.tooltip)&&(Je(this,s,F.ViewBadge.from(t),"f"),Le(this,k,"f").$setWebviewViewBadge(Le(this,y,"f"),t))}show(t){this.a(),Le(this,k,"f").$show(Le(this,y,"f"),!!t)}a(){if(Le(this,h,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,M=new WeakMap,D=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap;class O{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,a,l){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:a,extension:t}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(t),d,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,a,l,c){const w=this.b.get(d);if(!w)throw new Error(`No view provider found for '${d}'`);const{provider:n,extension:r}=w,f=this.d.createNewWebview(t,{},r),A=new S(t,this.a,d,a,f,!0);this.c.set(t,A),await n.resolveWebviewView(A,{state:l},c)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=O}),define(ke[104],Te([1,0,4,5,2,15,10,3,18]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=D.getProxy(P.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,h){let b;if(typeof D=="string"){b=D;try{D=I.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,E.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,b,h)}async asExternalUri(D,h){if((0,E.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(D,h);return I.URI.from(b)}};k.a={focused:!0},k=qe([Ve(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(ke[240],Te([1,0,210,27,18]),function(ne,e,i,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends i.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,k){y.apply(console,k)}};F=qe([Ve(0,I.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],F),e.ExtHostConsoleForwarder=F}),define(ke[241],Te([1,0,17,23,21,11,4,6,127,204,46]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(A,T){try{return JSON.stringify(A,T)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class o{constructor(T,H){this.jsonString=T,this.referencedBuffers=H}}function s(A,T=null,H=!1){const Q=[];return{jsonString:(H?h:JSON.stringify)(A,(_,j)=>{if(typeof j>"u")return m;if(typeof j=="object"){if(j instanceof P.VSBuffer){const L=Q.push(j)-1;return{[b]:L}}if(T)return T(_,j)}return j}),referencedBuffers:Q}}e.stringifyJsonWithBufferRefs=s;function u(A,T,H){return JSON.parse(A,(Q,Z)=>{if(Z){const _=Z[b];if(typeof _=="number")return T[_];if(H&&Z.$mid===1)return H.transformIncoming(Z)}return Z})}e.parseJsonAndRestoreBufferRefs=u;function p(A,T){return JSON.stringify(A,T)}function S(A){return A?(T,H)=>H&&H.$mid===1?A.transformOutgoing(H):H:null}var O;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(O=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class l extends R.Disposable{constructor(T,H=null,Q=null){super(),this[D]=!0,this.b=this.B(new E.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=H,this.g=Q,this.h=S(this.g),this.j=!1,this.k=[],this.l=[];for(let Z=0,_=M.ProxyIdentifier.count;Z<_;Z++)this.k[Z]=null,this.l[Z]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(Z=>this.G(Z))}dispose(){this.j=!0,Object.keys(this.s).forEach(T=>{this.s[T].resolveErr(F.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(T){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(T){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(T){this.t!==T&&(this.t=T,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(T){return this.g?(0,y.transformIncomingURIs)(T,this.g):T}getProxy(T){const{nid:H,sid:Q}=T;return this.l[H]||(this.l[H]=this.F(H,Q)),this.l[H]}F(T,H){const Q={get:(Z,_)=>(typeof _=="string"&&!Z[_]&&_.charCodeAt(0)===36&&(Z[_]=(...j)=>this.O(T,_,j)),_===a?H:Z[_])};return new Proxy(Object.create(null),Q)}set(T,H){return this.k[T.nid]=H,H}assertRegistered(T){for(let H=0,Q=T.length;H<Q;H++){const Z=T[H];if(!this.k[Z.nid])throw new Error(`Missing proxy instance ${Z.sid}`)}}G(T){if(this.j)return;const H=T.byteLength,Q=c.read(T,0),Z=Q.readUInt8(),_=Q.readUInt32();switch(Z){case 1:case 2:{let{rpcId:j,method:L,args:g}=n.deserializeRequestJSONArgs(Q);this.g&&(g=(0,y.transformIncomingURIs)(g,this.g)),this.H(H,_,j,L,g,Z===2);break}case 3:case 4:{let{rpcId:j,method:L,args:g}=n.deserializeRequestMixedArgs(Q);this.g&&(g=(0,y.transformIncomingURIs)(g,this.g)),this.H(H,_,j,L,g,Z===4);break}case 5:{this.f?.logIncoming(H,_,0,"ack"),this.z(_);break}case 6:{this.I(H,_);break}case 7:{this.J(H,_,void 0);break}case 9:{let j=n.deserializeReplyOKJSON(Q);this.g&&(j=(0,y.transformIncomingURIs)(j,this.g)),this.J(H,_,j);break}case 10:{const j=n.deserializeReplyOKJSONWithBuffers(Q,this.g);this.J(H,_,j);break}case 8:{const j=n.deserializeReplyOKVSBuffer(Q);this.J(H,_,j);break}case 11:{let j=n.deserializeReplyErrError(Q);this.g&&(j=(0,y.transformIncomingURIs)(j,this.g)),this.L(H,_,j);break}case 12:{this.L(H,_,void 0);break}default:console.error("received unexpected message"),console.error(T)}}H(T,H,Q,Z,_,j){this.f?.logIncoming(T,H,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(Q)}.${Z}(`,_);const L=String(H);let g,N;if(j){const J=new I.CancellationTokenSource;_.push(J.token),g=this.M(Q,Z,_),N=()=>J.cancel()}else g=this.M(Q,Z,_),N=t;this.p[L]=N;const B=n.serializeAcknowledged(H);this.f?.logOutgoing(B.byteLength,H,1,"ack"),this.c.send(B),g.then(J=>{delete this.p[L];const me=n.serializeReplyOK(H,J,this.h);this.f?.logOutgoing(me.byteLength,H,1,"reply:",J),this.c.send(me)},J=>{delete this.p[L];const me=n.serializeReplyErr(H,J);this.f?.logOutgoing(me.byteLength,H,1,"replyErr:",J),this.c.send(me)})}I(T,H){this.f?.logIncoming(T,H,1,"receiveCancel");const Q=String(H);this.p[Q]?.()}J(T,H,Q){this.f?.logIncoming(T,H,0,"receiveReply:",Q);const Z=String(H);if(!this.s.hasOwnProperty(Z))return;const _=this.s[Z];delete this.s[Z],_.resolveOk(Q)}L(T,H,Q){this.f?.logIncoming(T,H,0,"receiveReplyErr:",Q);const Z=String(H);if(!this.s.hasOwnProperty(Z))return;const _=this.s[Z];delete this.s[Z];let j;Q&&(Q.$isError?(j=new Error,j.name=Q.name,j.message=Q.message,j.stack=Q.stack):j=Q),_.resolveErr(j)}M(T,H,Q){try{return Promise.resolve(this.N(T,H,Q))}catch(Z){return Promise.reject(Z)}}N(T,H,Q){const Z=this.k[T];if(!Z)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(T));const _=Z[H];if(typeof _!="function")throw new Error("Unknown method "+H+" on actor "+(0,M.getStringIdentifierForProxy)(T));return _.apply(Z,Q)}O(T,H,Q){if(this.j)return new k.CanceledLazyPromise;let Z=null;if(Q.length>0&&I.CancellationToken.isCancellationToken(Q[Q.length-1])&&(Z=Q.pop()),Z&&Z.isCancellationRequested)return Promise.reject(F.canceled());const _=n.serializeRequestArguments(Q,this.h),j=++this.m,L=String(j),g=new k.LazyPromise;Z&&Z.onCancellationRequested(()=>{const B=n.serializeCancel(j);this.f?.logOutgoing(B.byteLength,j,0,"cancel"),this.c.send(n.serializeCancel(j))}),this.s[L]=g,this.y(j);const N=n.serializeRequest(j,T,H,_,!!Z);return this.f?.logOutgoing(N.byteLength,j,0,`request: ${(0,M.getStringIdentifierForProxy)(T)}.${H}(`,Q),this.c.send(N),g}}D=d,l.a=3*1e3,e.RPCProtocol=l;class c{static alloc(T,H,Q){const Z=new c(P.VSBuffer.alloc(Q+1+4),0);return Z.writeUInt8(T),Z.writeUInt32(H),Z}static read(T,H){return new c(T,H)}get buffer(){return this.a}constructor(T,H){this.a=T,this.b=H}static sizeUInt8(){return 1}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const Q=this.a.slice(this.b,this.b+T).toString();return this.b+=T,Q}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const Q=this.a.slice(this.b,this.b+T).toString();return this.b+=T,Q}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+T);return this.b+=T,H}static sizeMixedArray(T){let H=0;H+=1;for(let Q=0,Z=T.length;Q<Z;Q++){const _=T[Q];switch(H+=1,_.type){case 1:H+=this.sizeLongString(_.value);break;case 2:H+=this.sizeVSBuffer(_.value);break;case 3:H+=this.sizeUInt32,H+=this.sizeLongString(_.value);for(let j=0;j<_.buffers.length;++j)H+=this.sizeVSBuffer(_.buffers[j]);break;case 4:break}}return H}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let H=0,Q=T.length;H<Q;H++){const Z=T[H];switch(Z.type){case 1:this.writeUInt8(1),this.writeLongString(Z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Z.buffers.length),this.writeLongString(Z.value);for(let _=0;_<Z.buffers.length;++_)this.writeBuffer(Z.buffers[_]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const H=new Array(T);for(let Q=0;Q<T;Q++)switch(this.readUInt8()){case 1:H[Q]=this.readLongString();break;case 2:H[Q]=this.readVSBuffer();break;case 3:{const _=this.readUInt32(),j=this.readLongString(),L=[];for(let g=0;g<_;++g)L.push(this.readVSBuffer());H[Q]=new M.SerializableObjectWithBuffers(u(j,L,null));break}case 4:H[Q]=void 0;break}return H}}c.sizeUInt32=4;var w;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(w||(w={}));class n{static a(T){for(let H=0,Q=T.length;H<Q;H++)if(T[H]instanceof P.VSBuffer||T[H]instanceof M.SerializableObjectWithBuffers||typeof T[H]>"u")return!0;return!1}static serializeRequestArguments(T,H){if(this.a(T)){const Q=[];for(let Z=0,_=T.length;Z<_;Z++){const j=T[Z];if(j instanceof P.VSBuffer)Q[Z]={type:2,value:j};else if(typeof j>"u")Q[Z]={type:4};else if(j instanceof M.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:g}=s(j.value,H);Q[Z]={type:3,value:P.VSBuffer.fromString(L),buffers:g}}else Q[Z]={type:1,value:P.VSBuffer.fromString(p(j,H))}}return{type:1,args:Q}}return{type:0,args:p(T,H)}}static serializeRequest(T,H,Q,Z,_){switch(Z.type){case 0:return this.b(T,H,Q,Z.args,_);case 1:return this.c(T,H,Q,Z.args,_)}}static b(T,H,Q,Z,_){const j=P.VSBuffer.fromString(Q),L=P.VSBuffer.fromString(Z);let g=0;g+=c.sizeUInt8(),g+=c.sizeShortString(j),g+=c.sizeLongString(L);const N=c.alloc(_?2:1,T,g);return N.writeUInt8(H),N.writeShortString(j),N.writeLongString(L),N.buffer}static deserializeRequestJSONArgs(T){const H=T.readUInt8(),Q=T.readShortString(),Z=T.readLongString();return{rpcId:H,method:Q,args:JSON.parse(Z)}}static c(T,H,Q,Z,_){const j=P.VSBuffer.fromString(Q);let L=0;L+=c.sizeUInt8(),L+=c.sizeShortString(j),L+=c.sizeMixedArray(Z);const g=c.alloc(_?4:3,T,L);return g.writeUInt8(H),g.writeShortString(j),g.writeMixedArray(Z),g.buffer}static deserializeRequestMixedArgs(T){const H=T.readUInt8(),Q=T.readShortString(),Z=T.readMixedArray(),_=new Array(Z.length);for(let j=0,L=Z.length;j<L;j++){const g=Z[j];typeof g=="string"?_[j]=JSON.parse(g):_[j]=g}return{rpcId:H,method:Q,args:_}}static serializeAcknowledged(T){return c.alloc(5,T,0).buffer}static serializeCancel(T){return c.alloc(6,T,0).buffer}static serializeReplyOK(T,H,Q){if(typeof H>"u")return this.d(T);if(H instanceof P.VSBuffer)return this.e(T,H);if(H instanceof M.SerializableObjectWithBuffers){const{jsonString:Z,referencedBuffers:_}=s(H.value,Q,!0);return this.g(T,Z,_)}else return this.f(T,h(H,Q))}static d(T){return c.alloc(7,T,0).buffer}static e(T,H){let Q=0;Q+=c.sizeVSBuffer(H);const Z=c.alloc(8,T,Q);return Z.writeVSBuffer(H),Z.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,H){const Q=P.VSBuffer.fromString(H);let Z=0;Z+=c.sizeLongString(Q);const _=c.alloc(9,T,Z);return _.writeLongString(Q),_.buffer}static g(T,H,Q){const Z=P.VSBuffer.fromString(H);let _=0;_+=c.sizeUInt32,_+=c.sizeLongString(Z);for(const L of Q)_+=c.sizeVSBuffer(L);const j=c.alloc(10,T,_);j.writeUInt32(Q.length),j.writeLongString(Z);for(const L of Q)j.writeBuffer(L);return j.buffer}static deserializeReplyOKJSON(T){const H=T.readLongString();return JSON.parse(H)}static deserializeReplyOKJSONWithBuffers(T,H){const Q=T.readUInt32(),Z=T.readLongString(),_=[];for(let j=0;j<Q;++j)_.push(T.readVSBuffer());return new M.SerializableObjectWithBuffers(u(Z,_,H))}static serializeReplyErr(T,H){const Q=H?h(F.transformErrorForSerialization(H),null):void 0;if(typeof Q!="string")return this.h(T);const Z=P.VSBuffer.fromString(Q);let _=0;_+=c.sizeLongString(Z);const j=c.alloc(11,T,_);return j.writeLongString(Z),j.buffer}static deserializeReplyErrError(T){const H=T.readLongString();return JSON.parse(H)}static h(T){return c.alloc(12,T,0).buffer}}var r;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var f;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(f||(f={}))}),define(ke[242],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(F){const E=R=>{globalThis.removeEventListener("message",E);const y=R.data;Object.defineProperties(globalThis,{postMessage:{value(k,M){y.postMessage(k,M)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",E)}.toString();class P extends EventTarget{constructor(F,E,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${E}'))`,k=new Blob([y],{type:"application/javascript"}),M=URL.createObjectURL(k),D=new MessageChannel,h=M,b={type:"_newWorker",id:h,port:D.port2,url:M,options:R};F(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:h}),URL.revokeObjectURL(M),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(m){D.port1.onmessage=m}},onmessageerror:{get(){return D.port1.onmessageerror},set(m){D.port1.onmessageerror=m}}}),D.port1.addEventListener("messageerror",m=>{const o=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(o)}),D.port1.addEventListener("message",m=>{const o=new MessageEvent("message",{data:m.data});this.dispatchEvent(o)}),D.port1.start()}}e.NestedWorker=P}),define(ke[243],Te([1,0,4,30,42,3]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var E;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(M=>k.push(M)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}P.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(ke[105],Te([1,0,5,3,18,26,12,243,60,27,36,121,23,9,43,4,6]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends E.AbstractMessageLogger{get disposed(){return this.l}constructor(v,t,d,a,l){super(),this.id=v,this.name=t,this.m=d,this.n=a,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.k;this.info(v),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(v,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.n.$close(this.id)}g(v,t){this.k+=h.VSBuffer.fromString(t).byteLength,(0,E.log)(this.m,v,t),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends u{appendLine(v){this.append(v)}}let S=class{constructor(v,t,d,a,l,c){this.i=t,this.j=d,this.k=a,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(v,t,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,l=(0,b.isString)(t)?t:void 0;if((0,b.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const w=this.i.environment.extensionLogLevel?.find(([r])=>F.ExtensionIdentifier.equals(d.identifier,r))?.[1];w&&(c=(0,E.parseLogLevel)(w));const n=a?this.o(v,c,d):this.n(v,l,d);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),a?this.r(v,c??this.m.getLevel(),n):this.q(v,n)}async n(v,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,l=this.k.extUri.joinPath(a,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.a.$register(v,l,t,d.identifier.value);return new u(w,v,c,this.a,d)}async o(v,t,d){const a=await this.p(d),l=this.k.extUri.joinPath(a,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=l.toString(),w=this.l.createLogger(l,{id:c,name:v,logLevel:t,extensionId:d.identifier.value});return new p(c,v,w,this.a,d)}p(v){let t=this.d.get(v.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(a){if((0,m.toFileSystemProviderErrorCode)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return d})())}return t}q(v,t){let d=!1;const a=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(l){a(),t.then(c=>c.append(l))},appendLine(l){a(),t.then(c=>c.appendLine(l))},clear(){a(),t.then(l=>l.clear())},replace(l){a(),t.then(c=>c.replace(l))},show(l,c){a(),t.then(w=>w.show(l,c))},hide(){a(),t.then(l=>l.hide())},dispose(){d=!0,t.then(l=>l.dispose())}}}r(v,t,d){const a=new s.DisposableStore,l=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new o.Emitter);function w(n){t=n,c.fire(n)}return d.then(n=>{a.add(n),n.logLevel!==t&&w(n.logLevel),a.add(n.onDidChangeLogLevel(r=>w(r)))}),{...this.q(v,d),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(n,...r){l(),d.then(f=>f.trace(n,...r))},debug(n,...r){l(),d.then(f=>f.debug(n,...r))},info(n,...r){l(),d.then(f=>f.info(n,...r))},warn(n,...r){l(),d.then(f=>f.warn(n,...r))},error(n,...r){l(),d.then(f=>f.error(n,...r))},dispose(){a.dispose()}}}};S=qe([Ve(0,I.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,y.IExtHostConsumerFileSystem),Ve(3,M.IExtHostFileSystemInfo),Ve(4,E.ILoggerService),Ve(5,E.ILogService)],S),e.ExtHostOutputService=S,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(ke[244],Te([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(ke[245],Te([1,0,40,15,19,20,24,2,3,176,53,192,244]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class cn{constructor(o,s,u,p){this.d=o,this.e=s,this.f=u,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??o})()}hasValidBasename(o,s,u){return typeof s=="string"||typeof s>"u"?this.a.then(p=>this.h(o,p,s)):this.h(o,s,u)}h(o,s,u){return o.scheme===P.Schemas.file||o.scheme===P.Schemas.vscodeRemote?(0,i.isValidBasename)(u??(0,E.basename)(o),s===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return P.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const S=s.getWorkspace().configuration;return S?S.scheme:P.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.win32:I.posix)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const p=o.indexOf("/",2);p===-1?(s=o.substring(2),o="/"):(s=o.substring(2,p),o=o.substring(p)||"/")}return R.URI.from({scheme:P.Schemas.file,authority:s,path:o,query:"",fragment:""})}};b=qe([Ve(1,h.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,M.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ke[106],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(E,R){this.line=E,this.character=R}isBefore(E){return!1}isBeforeOrEqual(E){return!1}isAfter(E){return!1}isAfterOrEqual(E){return!1}isEqual(E){return!1}compareTo(E){return 0}translate(E,R){return new i(0,0)}with(E){return new i(0,0)}}e.Position=i;class P{constructor(E,R,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(E,R),this.end=new i(y,k)}contains(E){return!1}isEqual(E){return!1}intersection(E){}union(E){return new P(0,0,0,0)}with(E){return new P(0,0,0,0)}}e.Range=P;var I;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ke[47],Te([1,0,16,35,22,40,10,3,19,11,106,17]),function(ne,e,i,P,I,F,E,R,y,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",b=" characters skipped \u27EB",m=(h.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var o;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function u(oe){return!!oe.preview}e.resultIsMatch=u;function p(oe){return!!oe.resource}e.isFileMatch=p;function S(oe){return!!oe.message}e.isProgressMessage=S;var O;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(O=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=v;class t{constructor(ce,we,q){this.ranges=we;const x=Array.isArray(we)?we:[we];if(q&&q.matchLines===1&&d(x)){ce=(0,E.getNLines)(ce,q.matchLines);let X="",de=0,ye=0;const Ne=Math.floor(q.charsPerLine/5),ze=[];for(const Pe of x){const Ie=Math.max(Pe.startColumn-Ne,0),Se=Pe.startColumn+q.charsPerLine;if(Ie>ye+Ne+m){const ae=h+(Ie-ye)+b;X+=ae+ce.slice(Ie,Se),de+=Ie-(ye+ae.length)}else X+=ce.slice(ye,Se);ze.push(new l(0,Pe.startColumn-de,Pe.endColumn-de)),ye=Se}this.preview={text:X,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const X=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ce,matches:(0,i.mapArrayOrNot)(we,de=>new a(de.startLineNumber-X,de.startColumn,de.endLineNumber-X,de.endColumn))}}}}e.TextSearchMatch=t;function d(oe){const ce=oe[0].startLineNumber;for(const we of oe)if(we.startLineNumber!==ce||we.endLineNumber!==ce)return!1;return!0}class a{constructor(ce,we,q,x){this.startLineNumber=ce,this.startColumn=we,this.endLineNumber=q,this.endColumn=x}}e.SearchRange=a;class l extends a{constructor(ce,we,q){super(ce,we,ce,q)}}e.OneLineRange=l;var c;(function(oe){oe.List="list",oe.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var w;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function n(oe,ce=!0){const we=oe&&oe.files&&oe.files.exclude,q=ce&&oe&&oe.search&&oe.search.exclude;if(!we&&!q)return;if(!we||!q)return we||q;let x=Object.create(null);return x=I.mixin(x,I.deepClone(we)),x=I.mixin(x,I.deepClone(q),!0),x}e.getExcludes=n;function r(oe,ce){return oe.excludePattern&&P.match(oe.excludePattern,ce)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&P.match(oe.includePattern,ce)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(we=>{const q=we.folder.fsPath;if(F.isEqualOrParent(ce,q)){const x=y.relative(q,ce);return!we.includePattern||!!P.match(we.includePattern,x)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var f;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(ce,we){super(ce),this.code=we}}e.SearchError=A;function T(oe){const ce=oe.message;if((0,k.isCancellationError)(oe))return new A(ce,f.canceled);try{const we=JSON.parse(ce);return new A(we.message,we.code)}catch{return new A(ce,f.other)}}e.deserializeSearchError=T;function H(oe){const ce={message:oe.message,code:oe.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=H;function Q(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=Q;function Z(oe){return oe.type==="success"}e.isSerializedSearchSuccess=Z;function _(oe){return!!oe.path}e.isSerializedFileMatch=_;function j(oe,ce){const we=oe.searchPath?oe.searchPath:oe.relativePath;return(0,E.fuzzyContains)(we,ce)}e.isFilePatternMatch=j;class L{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function g(oe,ce){const we={...oe||{},...ce||{}};return Object.keys(we).filter(q=>{const x=we[q];return typeof x=="boolean"&&x})}e.resolvePatternsForProvider=g;class N{constructor(ce,we){this.c=null,this.a={...ce.excludePattern||{},...we.excludePattern||{}},this.b=P.parse(this.a);let q=ce.includePattern;we.includePattern&&(q?q={...q,...we.includePattern}:q=we.includePattern),q&&(this.c=P.parse(q))}matchesExcludesSync(ce,we,q){return!!(this.b&&this.b(ce,we,q))}includedInQuerySync(ce,we,q){return!(this.b&&this.b(ce,we,q)||this.c&&!this.c(ce,we,q))}includedInQuery(ce,we,q){const x=this.b(ce,we,q),X=()=>this.c?!!this.c(ce,we,q):!0;return(0,D.isThenable)(x)?x.then(de=>de?!1:X()):X()}hasSiblingExcludeClauses(){return B(this.a)}}e.QueryGlobTester=N;function B(oe){for(const ce in oe)if(typeof oe[ce]!="boolean")return!0;return!1}function J(oe){if(!oe)return;let ce;return we=>(ce||(ce=(oe()||Promise.resolve([])).then(q=>q?te(q):{})),ce.then(q=>!!q[we]))}e.hasSiblingPromiseFn=J;function me(oe){if(!oe)return;let ce;return we=>{if(!ce){const q=oe();ce=q?te(q):{}}return!!ce[we]}}e.hasSiblingFn=me;function te(oe){const ce={};for(const we of oe)ce[we]=!0;return ce}}),define(ke[31],Te([1,0,16,17,21,4,6,48,15,113,24,10,9,2,146,3,12,164,53,36,27,18,8,7,55,47,5]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t,d,a,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function w(Z,_,j){return new M.ExtUri(L=>A(L,j)).isEqual(Z,_)}function n(Z,_,j){return w(Z.uri,_.uri,j)?0:(0,D.compare)(Z.uri.toString(),_.uri.toString())}function r(Z,_,j){return Z.index!==_.index?Z.index<_.index?-1:1:w(Z.uri,_.uri,j)?(0,D.compare)(Z.name,_.name):(0,D.compare)(Z.uri.toString(),_.uri.toString())}function f(Z,_,j,L){const g=Z.slice(0).sort((B,J)=>j(B,J,L)),N=_.slice(0).sort((B,J)=>j(B,J,L));return(0,i.delta)(g,N,(B,J)=>j(B,J,L))}function A(Z,_){const j=_.getCapabilities(Z.scheme);return!(j&&j&1024)}class T extends p.Workspace{static toExtHostWorkspace(_,j,L,g){if(!_)return{workspace:null,added:[],removed:[]};const{id:N,name:B,folders:J,configuration:me,transient:te,isUntitled:oe}=_,ce=[],we=j;j?J.forEach((de,ye)=>{const Ne=b.URI.revive(de.uri),ze=T.o(L||j,Ne,g);ze?(ze.name=de.name,ze.index=de.index,ce.push(ze)):ce.push({uri:Ne,name:de.name,index:ye})}):ce.push(...J.map(({uri:de,name:ye,index:Ne})=>({uri:b.URI.revive(de),name:ye,index:Ne}))),ce.sort((de,ye)=>de.index<ye.index?-1:1);const q=new T(N,B,ce,!!te,me?b.URI.revive(me):null,!!oe,de=>A(de,g)),{added:x,removed:X}=f(we?we.workspaceFolders:[],q.workspaceFolders,n,g);return{workspace:q,added:x,removed:X}}static o(_,j,L){for(let g=0;g<_.folders.length;g++){const N=_.workspaceFolders[g];if(w(N.uri,j,L))return N}}constructor(_,j,L,g,N,B,J){super(_,L.map(me=>new p.WorkspaceFolder(me)),g,N,J),this.t=j,this.u=B,this.q=[],this.s=R.TernarySearchTree.forUris(J),L.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(_,j){return j&&this.s.get(_)&&(_=(0,M.dirname)(_)),this.s.findSubstr(_)}resolveWorkspaceFolder(_){return this.s.get(_)}}let H=class{constructor(_,j,L,g,N){this.c=new F.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new F.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.AsyncEmitter,this.h=g,this.s=L,this.t=N,this.j=new k.Counter,this.k=new P.Barrier,this.o=_.getProxy(c.MainContext.MainThreadWorkspace),this.q=_.getProxy(c.MainContext.MainThreadMessageService);const B=j.workspace;this.l=B?new T(B.id,B.name,[],!!B.transient,B.configuration?b.URI.revive(B.configuration):null,!!B.isUntitled,J=>A(J,L)):void 0}$initializeWorkspace(_,j){this.v=j,this.$acceptWorkspaceData(_),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(_,j,L,...g){const N=[];if(Array.isArray(g)&&g.forEach(oe=>{b.URI.isUri(oe.uri)&&!N.some(ce=>w(ce.uri,oe.uri,this.s))&&N.push({uri:oe.uri,name:oe.name||(0,M.basenameOrAuthority)(oe.uri)})}),this.n||[j,L].some(oe=>typeof oe!="number"||oe<0)||L===0&&N.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(j+L>B.length)return!1;const J=B.slice(0);J.splice(j,L,...N.map(oe=>({uri:oe.uri,name:oe.name||(0,M.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<J.length;oe++){const ce=J[oe];if(J.some((we,q)=>q!==oe&&w(ce.uri,we.uri,this.s)))return!1}J.forEach((oe,ce)=>oe.index=ce);const{added:me,removed:te}=f(B,J,r,this.s);if(me.length===0&&te.length===0)return!1;if(this.o){const oe=_.displayName||_.name;this.o.$updateWorkspaceFolders(oe,j,L,N).then(void 0,ce=>{this.n=void 0;const we={source:{identifier:_.identifier,label:_.displayName||_.name}};this.q.$showMessage(u.Severity.Error,(0,m.localize)(0,null,oe,ce.toString()),we,[])})}return this.y(J),!0}getWorkspaceFolder(_,j){if(!!this.x)return this.x.getWorkspaceFolder(_,j)}async getWorkspaceFolder2(_,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(_,j)}async resolveWorkspaceFolder(_){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(_)}getPath(){if(!this.x)return;const{folders:_}=this.x;if(_.length!==0)return _[0].uri.fsPath}getRelativePath(_,j){let L,g="";if(typeof _=="string"?(L=b.URI.file(_),g=_):typeof _<"u"&&(L=_,g=_.fsPath),!L)return g;const N=this.getWorkspaceFolder(L,!0);if(!N)return g;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let B=(0,M.relativePath)(N.uri,L);return j&&N.name&&(B=`${N.name}/${B}`),B}y(_){this.x&&(this.n=T.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:_,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(_){const{workspace:j,added:L,removed:g}=T.toExtHostWorkspace(_,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:g}))}findFiles(_,j,L,g,N=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${g.value}, entryPoint: findFiles`);let B;if(j===null?B=!1:j&&(typeof j=="string"?B=j:B=j.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:me}=Q(t.GlobPattern.from(_));return this.o.$startFileSearch((0,h.withUndefinedAsNull)(J),(0,h.withUndefinedAsNull)(me),(0,h.withUndefinedAsNull)(B),(0,h.withUndefinedAsNull)(L),N).then(te=>Array.isArray(te)?te.map(oe=>b.URI.revive(oe)):[])}async findTextInFiles(_,j,L,g,N=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${g.value}, entryPoint: findTextInFiles`);const B=this.j.getNext(),J=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:me,folder:te}=Q(t.GlobPattern.from(j.include)),oe=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ce={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:J,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:me,excludePattern:oe},we=!1;if(this.u[B]=q=>{if(we)return;const x=b.URI.revive(q.resource);q.results.forEach(X=>{(0,l.resultIsMatch)(X)?L({uri:x,preview:{text:X.preview.text,matches:(0,i.mapArrayOrNot)(X.preview.matches,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,i.mapArrayOrNot)(X.ranges,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):L({uri:x,text:X.text,lineNumber:X.lineNumber})})},N.isCancellationRequested)return{};try{const q=await this.o.$startTextSearch(_,(0,h.withUndefinedAsNull)(te),ce,B,N);return delete this.u[B],q||{}}catch(q){throw delete this.u[B],q}}$handleTextSearchResult(_,j){this.u[j]?.(_)}saveAll(_){return this.o.$saveAll(_)}resolveProxy(_){return this.o.$resolveProxy(_)}get trusted(){return this.v}requestWorkspaceTrust(_){return this.o.$requestWorkspaceTrust(_)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(_,j){if(this.w.has(_))throw new Error(`A provider has already been registered for scheme ${_}`);this.w.set(_,j);const L=this.t.transformOutgoingScheme(_),g=this.z++;return this.o.$registerEditSessionIdentityProvider(g,L),(0,E.toDisposable)(()=>{this.w.delete(_),this.o.$unregisterEditSessionIdentityProvider(g)})}async $getEditSessionIdentifier(_,j){this.h.info("Getting edit session identifier for workspaceFolder",_);const L=await this.resolveWorkspaceFolder(b.URI.revive(_));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const g=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!g),!g)return;const N=await g.provideEditSessionIdentity(L,j);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(_,j,L,g){this.h.info("Getting edit session identifier for workspaceFolder",_);const N=await this.resolveWorkspaceFolder(b.URI.revive(_));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const J=await B.provideEditSessionIdentityMatch?.(j,L,g);if(this.h.info("Provider returned edit session identifier match result: ",J),!!J)return J}getOnWillCreateEditSessionIdentityEvent(_){return(j,L,g)=>{const N=function(J){j.call(L,J)};return N.extension=_,this.A.event(N,void 0,g)}}async $onWillCreateEditSessionIdentity(_,j,L){const g=await this.resolveWorkspaceFolder(b.URI.revive(_));if(g===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:g},j,async(N,B)=>{const J=Date.now();await Promise.resolve(N),Date.now()-J>L&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),j.isCancellationRequested}};H=qe([Ve(0,v.IExtHostRpcService),Ve(1,O.IExtHostInitDataService),Ve(2,S.IExtHostFileSystemInfo),Ve(3,s.ILogService),Ve(4,a.IURITransformerService)],H),e.ExtHostWorkspace=H,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function Q(Z){let _,j;return Z&&(typeof Z=="string"?_=Z:(_=Z.pattern,j=b.URI.revive(Z.baseUri))),{includePattern:_,folder:j}}}),define(ke[32],Te([1,0,22,4,31,5,7,167,93,9,17,3,18,12,2]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(d,a){if(a){const l=a.split(".");let c=d;for(let w=0;c&&w<l.length;w++)c=c[l[w]];return c}}function s(d){return d instanceof m.URI}function u(d){return d&&d.uri instanceof m.URI&&d.languageId&&typeof d.languageId=="string"}function p(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function S(d){return d&&d.uri instanceof m.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function O(d){if(s(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(p(d))return{overrideIdentifier:d.languageId};if(S(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(a,l,c){this.a=a.getProxy(F.MainContext.MainThreadConfiguration),this.c=l,this.b=c,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,l))}};v=qe([Ve(0,h.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,b.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(a,l,c,w){this.a=new P.Emitter,this.b=a,this.f=w,this.c=l,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(a,l,c){const w=O(l)||{},n=this.g(a?o(this.e.getValue(void 0,w,this.c.workspace),a):this.e.getValue(void 0,w,this.c.workspace));a&&this.h(a,w,c?.identifier);function r(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case E.ConfigurationTarget.Global:return 2;case E.ConfigurationTarget.Workspace:return 5;case E.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(A){return typeof o(n,A)<"u"},get:(A,T)=>{this.h(a?`${a}.${A}`:A,w,c?.identifier);let H=o(n,A);if(typeof H>"u")H=T;else{let Q;const Z=(_,j)=>{let L;const g=()=>{Q=Q||(0,i.deepClone)(n),L=L||o(Q,j)};return(0,k.isObject)(_)?new Proxy(_,{get:(N,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return g(),()=>L;if(Q)return L=L||o(Q,j),L[B];const J=N[B];return typeof B=="string"?Z(J,`${j}.${B}`):J},set:(N,B,J)=>(g(),L&&(L[B]=J),!0),deleteProperty:(N,B)=>(g(),L&&delete L[B],!0),defineProperty:(N,B,J)=>(g(),L&&Object.defineProperty(L,B,J),!0)}):_};H=Z(H,A)}return H},update:(A,T,H,Q)=>{A=a?`${a}.${A}`:A;const Z=r(H);return T!==void 0?this.b.$updateConfigurationOption(Z,A,T,w,Q):this.b.$removeConfigurationOption(Z,A,w,Q)},inspect:A=>{A=a?`${a}.${A}`:A;const T=this.e.inspect(A,w,this.c.workspace);if(T)return{key:A,defaultValue:(0,i.deepClone)(T.policy?.value??T.default?.value),globalValue:(0,i.deepClone)(T.user?.value??T.application?.value),workspaceValue:(0,i.deepClone)(T.workspace?.value),workspaceFolderValue:(0,i.deepClone)(T.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(T.default?.override),globalLanguageValue:(0,i.deepClone)(T.user?.override??T.application?.override),workspaceLanguageValue:(0,i.deepClone)(T.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(T.workspaceFolder?.override),languageIds:(0,i.deepClone)(T.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(f,n,!1),Object.freeze(f)}g(a){const l=c=>(0,k.isObject)(c)?new Proxy(c,{get:(w,n)=>l(w[n]),set:(w,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(w,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(w,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(a)}h(a,l,c){const w=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=c?`[${c.value}] `:"";if(w===4){typeof l?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){l?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,l){const c=new R.ConfigurationChangeEvent(a,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(w,n)=>c.affectsConfiguration(w,O(n))})}k(a){return a.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[107],Te([1,0,2,17,4,5,7,31,58,32,21,61,18,27,3,15,20,12,76,203,11]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(t||(t={}));var d;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(d||(d={}));var a;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(a||(a={}));var l;(function(_){function j(N){if(N){const B=N;return B&&!!B.process}else return!1}_.is=j;function L(N){if(N==null)return;const B={process:N.process,args:N.args};return N.options&&(B.options=a.from(N.options)),B}_.from=L;function g(N){if(N!=null)return new E.ProcessExecution(N.process,N.args,N.options)}_.to=g})(l||(l={}));var c;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(c||(c={}));var w;(function(_){function j(N){if(N){const B=N;return B&&(!!B.commandLine||!!B.command)}else return!1}_.is=j;function L(N){if(N==null)return;const B={};return N.commandLine!==void 0?B.commandLine=N.commandLine:(B.command=N.command,B.args=N.args),N.options&&(B.options=c.from(N.options)),B}_.from=L;function g(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new E.ShellExecution(N.commandLine,N.options):new E.ShellExecution(N.command,N.args?N.args:[],N.options)}_.to=g})(w||(w={}));var n;(function(_){function j(N){if(N){const B=N;return B&&B.customExecution==="customExecution"}else return!1}_.is=j;function L(N){return{customExecution:"customExecution"}}_.from=L;function g(N,B){return B.get(N)}_.to=g})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(_){function j(L,g){let N;return L.scope!==void 0&&typeof L.scope!="number"?N=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===E.TaskScope.Workspace&&g&&g.workspaceFile?N=g.workspaceFile:N=S.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:N}}_.from=j})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(_){function j(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}_.from=j})(f||(f={}));var A;(function(_){function j(N,B){if(N==null)return[];const J=[];for(const me of N){const te=L(me,B);te&&J.push(te)}return J}_.fromMany=j;function L(N,B){if(N==null)return;let J;N.execution instanceof E.ProcessExecution?J=l.from(N.execution):N.execution instanceof E.ShellExecution?J=w.from(N.execution):N.execution&&N.execution instanceof E.CustomExecution&&(J=n.from(N.execution));const me=t.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=E.TaskScope.Workspace,!me||!te?void 0:{_id:N._id,definition:me,name:N.name,source:{extensionId:B.identifier.value,label:N.source,scope:te},execution:J,isBackground:N.isBackground,group:f.from(N.group),presentationOptions:d.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}_.from=L;async function g(N,B,J){if(N==null)return;let me;l.is(N.execution)?me=l.to(N.execution):w.is(N.execution)?me=w.to(N.execution):n.is(N.execution)&&(me=n.to(N._id,J));const te=t.to(N.definition);let oe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?oe=N.source.scope:oe=await B.resolveWorkspaceFolder(i.URI.revive(N.source.scope)):oe=E.TaskScope.Workspace),!te||!oe)return;const ce=new E.Task(te,oe,N.name,N.source.label,me,N.problemMatchers);return N.isBackground!==void 0&&(ce.isBackground=N.isBackground),N.group!==void 0&&(ce.group=E.TaskGroup.from(N.group._id),ce.group&&N.group.isDefault&&(ce.group=new E.TaskGroup(ce.group.id,ce.group.label),N.group.isDefault===!0&&(ce.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ce.presentationOptions=d.to(N.presentationOptions)),N._id&&(ce._id=N._id),N.detail&&(ce.detail=N.detail),ce}_.to=g})(A=e.TaskDTO||(e.TaskDTO={}));var T;(function(_){function j(g){return g}_.from=j;function L(g){if(!!g)return Object.assign(Object.create(null),g)}_.to=L})(T||(T={}));class H{constructor(j,L,g){this._id=L,this.a=g,v.set(this,void 0),Je(this,v,j,"f")}get task(){return this.a}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}v=new WeakMap;let Q=class{constructor(j,L,g,N,B,J,me,te){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=j.getProxy(F.MainContext.MainThreadTask),this.b=g,this.c=N,this.d=B,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,L,g){if(!g)return new E.Disposable(()=>{});const N=this.w();return this.j.set(N,{type:L,provider:g,extension:j}),this.a.$registerTaskProvider(N,L),new E.Disposable(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(j,L){this.a.$registerTaskSystem(j,L)}fetchTasks(j){return this.a.$fetchTasks(T.from(j)).then(async L=>{const g=[];for(const N of L){const B=await A.to(N,this.b,this.m);B&&g.push(B)}return g})}get taskExecutions(){const j=[];return this.k.forEach(L=>j.push(L)),j}terminateTask(j){if(!(j instanceof H))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,L,g){const N=this.m.get(j.id);N&&(this.o.set(j.id,N),this.e.attachPtyToTerminal(L,await N.callback(g))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const L=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:L})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const L=await this.y(j.id);this.s.fire({execution:L,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const L=await this.y(j.id);this.t.fire({execution:L,exitCode:j.exitCode})}$provideTasks(j,L){const g=this.j.get(j);if(!g)return Promise.reject(new Error("no handler found"));const N=[],B=(0,P.asPromise)(()=>g.provider.provideTasks(M.CancellationToken.None)).then(J=>this.u(L,N,g,J));return new Promise(J=>{B.then(me=>{Promise.all(N).then(()=>{J(me)})})})}async $resolveTask(j,L){const g=this.j.get(j);if(!g)return Promise.reject(new Error("no handler found"));if(L.definition.type!==g.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${g.type}].`);const N=await A.to(L,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const B=await g.provider.resolveTask(N,M.CancellationToken.None);if(!B)return;this.z(B,g);const J=A.from(B,g.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(J.execution)&&await this.x(J,B,!0),await this.v(J)}w(){return this.h++}async x(j,L,g){const N=await this.a.$createTaskId(j);!g&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,L.execution)),this.m.set(N,L.execution)}async y(j,L){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new O.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const g=this.l.get(j.id);if(g)return g;const N=new Promise((B,J)=>{function me(te,oe,ce){ce?B(new H(te,oe.id,ce)):J("Unexpected: Task does not exist.")}L?me(this,j,L):A.to(j.task,this.b,this.m).then(te=>me(this,j,te))});return this.l.set(j.id,N),N.then(B=>(this.k.set(j.id,B),B),B=>Promise.reject(B))}z(j,L){j._deprecated&&this.g.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const g=this.n.values();let N=g.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=g.next()}};Q=qe([Ve(0,h.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,p.IExtHostApiDeprecationService)],Q),e.ExtHostTaskBase=Q;let Z=class extends Q{constructor(j,L,g,N,B,J,me,te){super(j,L,g,N,B,J,me,te),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(j,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const g=A.from(L,j);if(g===void 0)throw new Error("Task is not valid");if(n.is(g.execution))await this.x(g,L,!1);else throw new O.NotSupportedError;const N=await this.y(await this.a.$getTaskExecution(g),L);return this.a.$executeTask(g).catch(B=>{throw new Error(B)}),N}u(j,L,g,N){const B=[];if(N)for(const J of N){this.z(J,g),(!J.definition||!j[J.definition.type])&&this.f.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const me=A.from(J,g.extension);me&&n.is(me.execution)?(B.push(me),L.push(this.x(me,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:g.extension}}async v(j){if(n.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,L,g){}};Z=qe([Ve(0,h.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,p.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(ke[246],Te([1,0,19,21,39,35,24,77,47]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(h,b,m){this.k=h,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&F.parse(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&F.parse(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const b=this.k.folderQueries||[];return new Promise((m,o)=>{const s=u=>{this.f++,h(u)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const p=u.toString(),S=i.basename(p);this.j&&this.j(p,S)||this.v(s,{base:u,basename:S})}),Promise.all(b.map(u=>this.p(u,s))).then(u=>{m({limitHit:this.e,stats:u[0]||void 0})},u=>{o(new Error((0,I.toErrorMessage)(u)))})})}async p(h,b){const m=new P.CancellationTokenSource,o=this.q(h),s=this.r(),u=new y.QueryGlobTester(this.k,h),p=!u.hasSiblingExcludeClauses();let S;try{this.h.add(m),S=R.StopWatch.create();const O=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},o,m.token),v=S.elapsed(),t=R.StopWatch.create();return this.g&&!this.e||(O&&O.forEach(d=>{const a=i.posix.relative(h.folder.path,d.path);if(p){const l=i.basename(d.path);this.v(b,{base:h.folder,relativePath:a,basename:l});return}this.s(s,h.folder,a,b)}),this.g&&!this.e)?null:(this.u(s,u,b),{providerTime:v,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(h){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,h.includePattern),m=(0,y.resolvePatternsForProvider)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:m,includes:b,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},b,m,o){if(m===this.a){const u=i.basename(this.a);this.v(o,{base:b,relativePath:this.a,basename:u})}function s(u){const p=i.basename(u),S=i.dirname(u);let O=h[S];O||(O=h[S]=[],s(S)),O.push({base:b,relativePath:u,basename:p})}s(m)}u({rootEntries:h,pathToEntries:b},m,o){const s=this,u=this.a;function p(S){const O=(0,y.hasSiblingFn)(()=>S.map(v=>v.basename));for(let v=0,t=S.length;v<t;v++){const d=S[v],{relativePath:a,basename:l}=d;if(m.matchesExcludesSync(a,l,u!==l?O:void 0))continue;const c=b[a];if(c)p(c);else{if(a===u)continue;s.v(o,d)}if(s.e)break}}p(h)}v(h,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(b))}}class M{constructor(){this.b=new Map}fileSearch(h,b,m,o){const s=this.c(h.cacheKey),u=new k(h,b,s&&s.token);let p=0;const S=O=>{p+=O.length,m(O.map(v=>this.d(v)))};return this.e(u,M.a,S,o).then(O=>({limitHit:O.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:O.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(!!h)return this.b.has(h)||this.b.set(h,new P.CancellationTokenSource),this.b.get(h)}d(h){return h.relativePath?{resource:E.joinPath(h.base,h.relativePath)}:{resource:h.base}}e(h,b,m,o){o.onCancellationRequested(()=>{h.cancel()});const s=p=>{p&&(u.push(p),b>0&&u.length>=b&&(m(u),u=[]))};let u=[];return h.search(s).then(p=>(u.length&&m(u),p),p=>(u.length&&m(u),Promise.reject(p)))}}M.a=512,e.FileSearchManager=M}),define(ke[247],Te([1,0,16,63,35,87,28,15,19,24,10,9,2,263,155,41,12,53,97,245,47]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(A,T,H,Q,Z){this.a=A,this.b=T,this.c=H,this.d=Q,this.e=Z}text(A,T,H={}){A=this.f(A,H);const Q=this.a.getValue(),Z=T&&T.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(T?.map(u.toWorkspaceFolder),H),type:2,contentPattern:A,previewOptions:H.previewOptions,maxFileSize:H.maxFileSize,usePCRE2:Q.search.usePCRE2||Z||!1,beforeContext:H.beforeContext,afterContext:H.afterContext,userDisabledExcludesAndIgnoreFiles:H.disregardExcludeSettings&&H.disregardIgnoreFiles}}f(A,T){const H=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const Q={...A,wordSeparators:H.editor.wordSeparators};return this.j(A,T)&&(Q.isCaseSensitive=!0),this.k(A)&&(Q.isMultiline=!0),Q}file(A,T={}){return{...this.h(A,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}g(A,T){return A?(A=Array.isArray(A)?A.map(c):c(A),T?this.parseSearchPaths(A):{pattern:d(...Array.isArray(A)?A:[A])}):{}}h(A=[],T={}){const H=this.g(T.includePattern,T.expandPatterns),Q=this.g(T.excludePattern,T.expandPatterns),Z=A.length>1,_=(H.searchPaths&&H.searchPaths.length?H.searchPaths.map(g=>this.q(g,T,Q)):A.map(g=>this.r(g,T,Q,Z))).filter(g=>!!g),j={_reason:T._reason,folderQueries:_,usingSearchPaths:!!(H.searchPaths&&H.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:Q.pattern,includePattern:H.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const g=i.coalesce(i.flatten(this.c.groups.map(J=>J.editors.map(me=>me.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(g));const N=g.filter(J=>(0,O.pathIncludedInQuery)(j,J.fsPath)),B=this.i(N);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...j,...B}}const L=T.extraFileResources&&T.extraFileResources.filter(g=>(0,O.pathIncludedInQuery)(j,g.fsPath));return j.extraFileResources=L&&L.length?L:void 0,j}i(A){const T=[],H=new E.ResourceMap,Q={};let Z=!1;return A.forEach(_=>{if(_.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(_)){const L=this.b.getWorkspaceFolder(_)?.uri??_.with({path:y.dirname(_.fsPath)});let g=H.get(L);g||(Z=!0,g={folder:L,includePattern:{}},T.push(g),H.set(L,g));const N=y.relative(L.fsPath,_.fsPath);(0,D.assertIsDefined)(g.includePattern)[N.replace(/\\/g,"/")]=!0}else _.fsPath&&(Z=!0,Q[_.fsPath]=!0)}),{folderQueries:T,includePattern:Q,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(A,T){if(T.isSmartCase){if(A.isRegExp){if(M.containsUppercaseCharacter(A.pattern,!0))return!0}else if(M.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,b.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const T=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),Q=(Array.isArray(A)?A:a(A)).map(B=>{const J=this.e.resolvedUserHome;return J?(0,F.untildify)(B,J.scheme===R.Schemas.file?J.fsPath:J.path):B}),Z=P.groupBy(Q,B=>T(B)?"searchPaths":"exprSegments"),_=(Z.exprSegments||[]).map(B=>M.rtrim(B,"/")).map(B=>M.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),j={},L=this.m(Z.searchPaths||[]);L&&L.length&&(j.searchPaths=L);const g=i.flatten(_),N=d(...g);return N&&(j.pattern=N),j}l(A,T){return T.disregardExcludeSettings?void 0:(0,O.getExcludes)(A,!T.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const T=A.flatMap(Q=>{let{pathPortion:Z,globPortion:_}=t(Q);return _&&(_=w(_)),this.n(Z).flatMap(L=>this.o(L,_))}),H=new Map;return T.forEach(Q=>{const Z=Q.searchPath.toString(),_=H.get(Z);_?Q.pattern&&(_.pattern=_.pattern||{},_.pattern[Q.pattern]=!0):H.set(Z,{searchPath:Q.searchPath,pattern:Q.pattern?d(Q.pattern):void 0})}),Array.from(H.values())}n(A){if(y.isAbsolute(A)){const T=this.b.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==R.Schemas.file?[{searchPath:T[0].uri.with({path:A})}]:[{searchPath:h.URI.file(y.normalize(A))}]}if(this.b.getWorkbenchState()===2){const T=this.b.getWorkspace().folders[0].uri;if(A=c(A),A.startsWith("../")||A===".."){const Q=y.posix.resolve(T.path,A);return[{searchPath:T.with({path:Q})}]}const H=w(A);return[{searchPath:T,pattern:H}]}else{if(A==="./"||A===".\\")return[];{const T=A.replace(/^\.[\/\\]/,""),Q=this.b.getWorkspace().folders.map(Z=>{const _=T.match(new RegExp(`^${M.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return _?{match:_,folder:Z}:null}).filter(D.isDefined);if(Q.length)return Q.map(Z=>{const _=Z.match[1];return{searchPath:Z.folder.uri,pattern:_&&w(_)}});{const Z=A.match(/\.[\/\\](.+)[\/\\]?/),_=Z?Z[1]:A,j=m.localize(0,null,_);throw new Error(j)}}}}o(A,T){const H=A.pattern&&T?`${A.pattern}/${T}`:A.pattern||T,Q=[{searchPath:A.searchPath,pattern:H}];return H&&!H.endsWith("**")&&Q.push({searchPath:A.searchPath,pattern:H+"/**"}),Q}q(A,T,H){const Q=this.r((0,u.toWorkspaceFolder)(A.searchPath),T,H,!1);return Q?{...Q,includePattern:A.pattern}:null}r(A,T,H,Q){let Z;const _=h.URI.isUri(A)?A:A.uri;if(H.searchPaths){const B=H.searchPaths.filter(J=>(0,k.isEqual)(J.searchPath,_))[0];if(B&&!B.pattern)return null;B&&(Z=B.pattern)}const j=this.a.getValue({resource:_}),g={...this.l(j,T)||{},...Z||{}},N=h.URI.isUri(A)?(0,k.basename)(A):A.name;return{folder:_,folderName:Q?N:void 0,excludePattern:Object.keys(g).length>0?g:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!j.search.followSymlinks}}};v=qe([Ve(0,o.IConfigurationService),Ve(1,u.IWorkspaceContextService),Ve(2,p.IEditorGroupsService),Ve(3,s.ILogService),Ve(4,S.IPathService)],v),e.QueryBuilder=v;function t(f){const A=f.match(/[\*\{\}\(\)\[\]\?]/);if(A){const T=A.index,H=f.substr(0,T).match(/[/|\\][^/\\]*$/);if(H){let Q=f.substr(0,H.index);return Q.match(/[/\\]/)||(Q+="/"),{pathPortion:Q,globPortion:f.substr((H.index||0)+1)}}}return{pathPortion:f}}function d(...f){return f.length?f.reduce((A,T)=>(A[T]=!0,A),Object.create(null)):void 0}function a(f){return I.splitGlobAware(f,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(f){return[`**/${f}/**`,`**/${f}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function w(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(f){return f.replace(/([?*[\]])/g,"[$1]")}function r(f,A){f=i.distinct(f,Q=>Q.toString());const T=[],H=A.getWorkspace();return f&&f.forEach(Q=>{let Z;if(A.getWorkbenchState()===2)Z=(0,k.relativePath)(H.folders[0].uri,Q),Z&&Z!=="."&&(Z="./"+Z);else{const _=A.getWorkspaceFolder(Q);if(_){const j=_.name;if(H.folders.filter(g=>g.name===j).length===1){const g=(0,k.relativePath)(_.uri,Q);g===""?Z=`./${_.name}`:Z=`./${_.name}/${g}`}else Z=Q.fsPath}}Z&&T.push(n(Z))}),T}e.resolveResourcesForSearchIncludes=r}),define(ke[248],Te([1,0,24,2,21,11,3,247,47,53]),function(ne,e,i,P,I,F,E,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function D(o,s){const u=s.activationEvents;if(!u)return Promise.resolve(void 0);const p=[],S=[];for(const l of u)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||o.forceUsingSearch?S.push(c):p.push(c)}if(p.length===0&&S.length===0)return Promise.resolve(void 0);let O;const v=new Promise((l,c)=>{O=l}),t=l=>O({activationEvent:l}),d=Promise.all(p.map(l=>h(o,l,t))).then(()=>{}),a=b(o,s.identifier,S,t);return Promise.all([d,a]).then(()=>{O(void 0)}),v}e.checkActivateWorkspaceContainsExtension=D;async function h(o,s,u){for(const p of o.folders)if(await o.exists(i.joinPath(P.URI.revive(p),s))){u(`workspaceContains:${s}`);return}}async function b(o,s,u,p){if(u.length===0)return Promise.resolve(void 0);const S=new I.CancellationTokenSource,O=o.checkExists(o.folders,u,S.token),v=setTimeout(async()=>{S.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},M);let t=!1;try{t=await O}catch(d){F.isCancellationError(d)||F.onUnexpectedError(d)}S.dispose(),clearTimeout(v),t&&p(`workspaceContains:${u.join(",")}`)}function m(o,s,u,p){const S=o.get(E.IInstantiationService),O=o.get(y.ISearchService),t=S.createInstance(R.QueryBuilder).file(s.map(d=>(0,k.toWorkspaceFolder)(P.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return O.fileSearch(t,p).then(d=>!!d.limitHit,d=>F.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(ne,e,i,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ne,i):I?I.value=i:e.set(ne,i),i},Le=this&&this.__classPrivateFieldGet||function(ne,e,i,P){if(i==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!P:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?P:i==="a"?P.call(ne):P?P.value:e.get(ne)};define(ke[33],Te([1,0,140,19,82,24,17,6,48,2,12,5,32,193,80,31,25,98,11,26,23,178,7,94,3,27,81,18,68,70,61,4,248,79,180,15,78,77,20]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t,d,a,l,c,w,n,r,f,A,T,H,Q,Z,_,j,L){"use strict";var g,N,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let J=class Ui extends R.Disposable{constructor(q,x,X,de,ye,Ne,ze,Pe,Ie,Se,ae){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=x,this.g=X,this.f=ze,this.j=de,this.k=ye,this.l=Ne,this.m=Ie,this.p=Se,this.s=ae,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new E.Barrier,this.y=new E.Barrier,this.z=new E.Barrier,this.C=new E.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const le=(0,s.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(oe(this.F,le)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new H.ExtHostSecretState(this.g),this.I=Pe,this.h=q.createChild(new n.ServiceCollection([m.IExtHostStorage,this.G],[H.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ee,C,$)=>{this.v.$onExtensionActivationError(ee,p.transformErrorForSerialization(C),$)},actualActivateExtension:async(ee,C)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(ee,this.D,this.F))return await this.v.$activateExtension(ee,C),new b.HostExtension;const $=this.D.getExtensionDescription(ee);return this.Y($,C)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(q){p.onUnexpectedError(q)}}async Q(){this.I.onWillDeactivateAll();let q=[];try{q=this.D.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.X(ye))}catch{}await Promise.all(q)}terminate(q,x=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${q}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const X=this.Q();Promise.race([(0,E.timeout)(5e3),X]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.l.info(`Extension host exiting with code ${x}`),this.l.flush(),this.l.dispose(),this.c.exit(x)})}isActivated(q){return this.z.isOpen()?this.J.isActivated(q):!1}async getExtension(q){const x=await this.v.$getExtension(q);let X;if(x?.browserNlsBundleUris){X={};for(const de of Object.keys(x.browserNlsBundleUris))X[de]=k.URI.revive(x.browserNlsBundleUris[de])}return x&&{...x,identifier:new S.ExtensionIdentifier(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation),browserNlsBundleUris:X}}R(q,x){return this.J.activateByEvent(q,x)}S(q,x){return this.J.activateById(q,x)}activateByIdWithErrors(q,x){return this.S(q,x).then(()=>{const X=this.J.getActivatedExtension(q);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(q=>this.D)}getExtensionExports(q){return this.z.isOpen()?this.J.getActivatedExtension(q).exports:null}async U(q){if(q.scheme!==Z.Schemas.file)return q;const x=await this.c.realpath(q.fsPath);return k.URI.file(x)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(q=>new ce(q))),this.L}async W(q){const x=y.TernarySearchTree.forUris(X=>F.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all(q.map(async X=>{if(this.pb(X)){const de=await this.U(X.extensionLocation);x.set(de,X)}})),x}X(q){let x=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(q))return x;const X=this.J.getActivatedExtension(q);if(!X)return x;try{typeof X.module.deactivate=="function"&&(x=Promise.resolve(X.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${q.value}':`),this.l.error(de)}try{(0,R.dispose)(X.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.l.error(de)}return x}async Y(q,x){return this.f.remote.isRemote?this.v.$onWillActivateExtension(q.identifier):await this.v.$onWillActivateExtension(q.identifier),this.ab(q,x).then(X=>{const de=X.activationTimes;return this.v.$onDidActivateExtension(q.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,x),this.Z(q,x,"success",de),X},X=>{throw this.Z(q,x,"failure"),X})}Z(q,x,X,de){const ye=me(q,x);this.u.$publicLog2("extensionActivationTimes",{...ye,...de||{},outcome:X})}ab(q,x){const X=me(q,x);this.u.$publicLog2("activatePlugin",X);const de=this.pb(q);if(!de)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${q.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.l.flush();const ye=new b.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this.qb(q,(0,F.joinPath)(q.extensionLocation,de),ye),this.bb(q)]).then(Ne=>(I.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),Ui.cb(this.l,q.identifier,Ne[0],Ne[1],ye))).then(Ne=>(I.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),Ne))}bb(q){const x=new v.ExtensionGlobalMemento(q,this.G),X=new v.ExtensionMemento(q.identifier.value,!1,this.G),de=new Q.ExtensionSecrets(q,this.H),ye=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ne=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([x.whenReady,X.whenReady,this.I.whenReady]).then(()=>{const ze=this;let Pe,Ie;const Se=(0,s.isProposedApiEnabled)(q,"ipc")?this.f.messagePorts?.get(S.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:x,workspaceState:X,secrets:de,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(ae){return P.join(q.extensionLocation.fsPath,ae)},get storagePath(){return ze.I.workspaceValue(q)?.fsPath},get globalStoragePath(){return ze.I.globalValue(q).fsPath},get logPath(){return P.join(ze.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return k.URI.joinPath(ze.f.logsLocation,q.identifier.value)},get storageUri(){return ze.I.workspaceValue(q)},get globalStorageUri(){return ze.I.globalValue(q)},get extensionMode(){return ye},get extension(){return Pe===void 0&&(Pe=new te(ze,q.identifier,q,Ne,!1)),Pe},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(q,"extensionRuntime"),ze.extensionRuntime},get environmentVariableCollection(){return ze.p.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!Ie){if(!Se)return;const ae=A.Event.buffer(A.Event.fromDOMEventEmitter(Se,"message",le=>le.data));Se.start(),Ie={onDidReceiveMessage:ae,postMessage:Se.postMessage.bind(Se)}}return Ie}})})}static cb(q,x,X,de,ye){return X=X||{activate:void 0,deactivate:void 0},this.db(q,x,X,de,ye).then(Ne=>new b.ActivatedExtension(!1,null,ye.build(),X,Ne,de.subscriptions))}static db(q,x,X,de,ye){if(typeof X.activate=="function")try{ye.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${x.value}`);const Ne=typeof global=="object"?global:self,ze=X.activate.apply(Ne,[de]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(ze).then(Pe=>(ye.activateResolveStop(),Pe))}catch(Ne){return Promise.reject(Ne)}else return Promise.resolve(X)}eb(q,x){this.S(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:x}).then(void 0,X=>{this.l.error(X)})}fb(q,x=0){const de=Date.now();(0,L.setTimeout0)(()=>{for(let ye=x;ye<q.length;ye+=1){const Ne=q[ye];for(const ze of Ne.activationEvents??[])if(ze==="onStartupFinished")if(Date.now()-de>50){this.fb(q,ye);break}else this.eb(Ne,ze)}})}gb(){this.v.$setPerformanceMarks(I.getMarks()),this.k.getConfigProvider().then(q=>{const x=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this.D.getAllExtensionDescriptions();if(x)this.fb(X);else for(const de of X)if(de.activationEvents)for(const ye of de.activationEvents)ye==="onStartupFinished"&&this.eb(de,ye)})}hb(){const q=this.R("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.ib(ye.added)));const x=this.j.workspace?this.j.workspace.folders:[],X=this.ib(x),de=Promise.all([q,X]).then(()=>{});return Promise.race([de,(0,E.timeout)(1e4)]).then(()=>{this.gb()}),de}ib(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(x=>this.jb(q,x))).then(()=>{})}async jb(q,x){if(this.isActivated(x.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:q.map(Ne=>Ne.uri),forceUsingSearch:X,exists:Ne=>this.c.exists(Ne.fsPath),checkExists:(Ne,ze,Pe)=>this.t.$checkExists(Ne,ze,Pe)},ye=await(0,T.checkActivateWorkspaceContainsExtension)(de,x);if(!!ye)return this.S(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ye.activationEvent}).then(void 0,Ne=>this.l.error(Ne))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(q){throw console.error(q),q}}async kb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:x}=this.f.environment;if(!q||!x)throw new Error(i.localize(0,null));const X=await this.qb(null,x,new b.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(i.localize(1,null,x.toString()));return new Promise((de,ye)=>{const Ne=(Ie,Se)=>{Ie?ye(Ie):de(typeof Se=="number"&&Se>0?1:0)},ze=(0,F.originalFSPath)(x),Pe=X.run(ze,Ne);Pe&&Pe.then&&Pe.then(()=>{de(0)}).catch(Ie=>{ye(Ie instanceof Error&&Ie.stack?Ie.stack:String(Ie))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,x){return this.M[q]=x,(0,R.toDisposable)(()=>{delete this.M[q]})}async mb(q){const x=q.indexOf("+");if(x===-1)throw new Error("Not an authority that can be resolved!");const X=q.substr(0,x);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.M[X]}}async $resolveAuthority(q,x){const X=j.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(q)},${x})][${X.elapsed()}ms] `,ye=Se=>this.l.info(`${de()}${Se}`),Ne=(Se,ae=void 0)=>this.l.error(`${de()}${Se}`,ae);ye("activating resolver...");const{authorityPrefix:ze,resolver:Pe}=await this.mb(q);if(!Pe)return Ne("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ze}.`,detail:void 0}};const Ie=new E.IntervalTimer;try{ye("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Pe)),Ie.cancelAndSet(()=>ye("waiting..."),1e3),ye("invoking resolve()..."),I.mark(`code/extHost/willResolveAuthority/${ze}`);const Se=await Pe.resolve(q,{resolveAttempt:x});I.mark(`code/extHost/didResolveAuthorityOK/${ze}`),Ie.dispose(),ye(`returned ${Se.host}:${Se.port}`);const ae={authority:q,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},le={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:le,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(I.mark(`code/extHost/didResolveAuthorityError/${ze}`),Ie.dispose(),Ne("returned an error",Se),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(q,x){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(q)})`);const{resolver:X}=await this.mb(q);if(!X)return null;const de=k.URI.revive(x);if(typeof X.getCanonicalURI>"u")return de;const ye=await(0,E.asPromise)(()=>X.getCanonicalURI(de));return ye||de}static nb(q,x,X){const de=new u.ExtensionDescriptionRegistry(q.getAllExtensionDescriptions());de.deltaExtensions(X.toAdd,X.toRemove);const ye=(0,s.extensionIdentifiersArrayToSet)(x.getAllExtensionDescriptions().map(ze=>ze.identifier));for(const ze of X.myToRemove)ye.delete(S.ExtensionIdentifier.toKey(ze));for(const ze of X.myToAdd)ye.add(S.ExtensionIdentifier.toKey(ze));const Ne=oe(de,ye);return{globalRegistry:de,myExtensions:Ne}}$startExtensionHost(q){q.toAdd.forEach(de=>de.extensionLocation=k.URI.revive(de.extensionLocation));const{globalRegistry:x,myExtensions:X}=Ui.nb(this.F,this.D,q);return this.F.set(x.getAllExtensionDescriptions()),this.D.set(X),this.lb()}$activateByEvent(q,x){return x===1?this.R(q,!1):this.z.wait().then(X=>this.R(q,!1))}async $activate(q,x){return await this.z.wait(),this.D.getExtensionDescription(q)?(await this.S(q,x),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(Ne=>Ne.extensionLocation=k.URI.revive(Ne.extensionLocation));const{globalRegistry:x,myExtensions:X}=Ui.nb(this.F,this.D,q),de=await this.W(X);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(x.getAllExtensionDescriptions()),this.D.set(X),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const x=O.VSBuffer.alloc(q),X=Math.random()%256;for(let de=0;de<q;de++)x.writeUInt8(X,de);return x}async $updateRemoteConnectionData(q){this.P=q,this.a.fire()}};J=qe([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,w.IExtHostRpcService),Ve(3,o.IExtHostWorkspace),Ve(4,h.IExtHostConfiguration),Ve(5,M.ILogService),Ve(6,l.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,r.IExtHostTunnelService),Ve(9,f.IExtHostTerminalService),Ve(10,_.IExtHostLocalizationService)],J),e.AbstractExtHostExtensionService=J;function me(we,q){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class te{constructor(q,x,X,de,ye){g.set(this,void 0),N.set(this,void 0),B.set(this,void 0),Je(this,g,q,"f"),Je(this,N,x,"f"),Je(this,B,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=P.normalize((0,F.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=de,this.isFromDifferentExtensionHost=ye}get isActive(){return Le(this,g,"f").isActivated(Le(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,g,"f").getExtensionExports(Le(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,g,"f").activateByIdWithErrors(Le(this,B,"f"),{startup:!1,extensionId:Le(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=te,g=new WeakMap,N=new WeakMap,B=new WeakMap;function oe(we,q){return we.getAllExtensionDescriptions().filter(x=>q.has(S.ExtensionIdentifier.toKey(x.identifier)))}class ce{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.ExtensionPaths=ce}),define(ke[249],Te([1,0,82,2,5,32,25,26,18,27,3,33,51,12,10]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(v,t,d,a,l,c,w){this.c=v,this.d=t,this.e=d,this.f=a,this.g=l,this.h=c,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new u(this.c,t,this.d,v,this.i)),this.register(this.e.createInstance(p,t)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(S,t,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this.a.set(t,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(t=>v.alternativeModuleName(t))}};o=qe([Ve(2,M.IInstantiationService),Ve(3,F.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,b.ILogService)],o),e.RequireInterceptor=o;let s=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const t=(0,m.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",a=`@${d}+\\/${d}+|${d}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${l}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const t=this.b.exec(this.c(v));if(!t)return;const[,d,a,l]=t,c=rn.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),d+c+l}c(v){return v.replace(/\\/g,"/")}};s.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=qe([Ve(0,k.IExtHostInitDataService)],s);class u{constructor(v,t,d,a,l){this.c=v,this.d=t,this.e=d,this.f=a,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(v,t){const d=this.d.findSubstr(t);if(d){let a=this.a.get(R.ExtensionIdentifier.toKey(d.identifier));return a||(a=this.c(d,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(d.identifier),a)),a}if(!this.b){let a="";this.d.forEach((l,c)=>a+=`	${c} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${a}`),this.b=this.c(E.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(v,t,d){this.d=v,this.nodeModuleName="keytar",this.a=t.getProxy(I.MainContext.MainThreadTelemetry);const{environment:a}=d,l=t.getProxy(I.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;h.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,w)=>l.$getPassword(c,w),setPassword:(c,w,n)=>l.$setPassword(c,w,n),deletePassword:(c,w)=>l.$deletePassword(c,w),findPassword:c=>l.$findPassword(c),findCredentials(c){return l.$findCredentials(c)}}}load(v,t){const d=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const t=v.length;if(t<=7||!this.b)return;const d=t-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};p=qe([Ve(1,y.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],p);let S=class{constructor(v,t,d){this.e=v,this.f=t,this.nodeModuleName=["open","opn"],this.d=d.getProxy(I.MainContext.MainThreadTelemetry);const a=d.getProxy(I.MainContext.MainThreadWindow);this.c=(l,c)=>{const w=P.URI.parse(l);return c?this.g(l,c):w.scheme==="http"||w.scheme==="https"?a.$openUri(w,l,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?a.$openUri(w,l,{}):this.g(l,c)}}load(v,t,d){const a=this.e.findSubstr(t);return a&&(this.a=a.identifier.value,this.h()),this.b=d(v),this.c}g(v,t){return this.i(),this.b(v,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};S=qe([Ve(2,y.IExtHostRpcService)],S)}),define(ke[108],Te([1,0,85,6,19,51,3,58,59,33,7,31,190,32]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,E.createDecorator)("IExtHostVariableResolverProvider");class m extends h.AbstractVariableResolverService{constructor(u,p,S,O,v,t,d){function a(){if(S){const l=S.activeEditor();if(l)return l.document.uri;const c=O.tabGroups.all.find(w=>w.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof M.TextDiffTabInput||c.input instanceof M.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof M.TextTabInput||c.input instanceof M.NotebookEditorTabInput||c.input instanceof M.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(w=>w.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>v.getConfiguration(void 0,l).get(c),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=a();if(l)return I.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const l=a();if(l){const c=p.getWorkspaceFolder(l);if(c)return I.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(S){const l=S.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(S){const l=S.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>u.getExtension(l)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(F.env))}}let o=class extends P.Disposable{constructor(u,p,S,O,v){super(),this.b=u,this.c=p,this.g=S,this.h=O,this.i=v,this.a=new i.Lazy(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,t,a,this.j())})}getResolver(){return this.a.value}j(){}};o=qe([Ve(0,k.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs)],o),e.ExtHostVariableResolverProviderService=o}),define(ke[109],Te([1,0,17,4,9,2,3,5,59,33,18,7,31,183,185,32,108]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,l,c,w,n,r){this.D=l,this.E=c,this.F=w,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new P.Emitter,this.n=new P.Emitter,this.o=new P.Emitter,this.u=new P.Emitter,this.k=a.getProxy(R.MainContext.MainThreadDebugService),this.z=new P.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new S(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(A=>{this.I(f)}),this.I(f)})}asDebugSourceUri(a,l){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let w=`debug:${encodeURIComponent(c.path||"")}`,n="?";return l&&(w+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),w+=`${n}ref=${c.sourceReference}`,F.URI.parse(w)}else{if(c.path)return F.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const l=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const w=c.contributes.debuggers;if(w&&w.length>0)for(const n of w)(0,m.isDebuggerMainContribution)(n)&&l.push(n.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(l=>a.push(l)),a}addBreakpoints(a){this.T();const l=a.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(l,[],[]);const c=[],w=new Map;for(const n of l)if(n instanceof D.SourceBreakpoint){let r=w.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},w.set(n.location.uri.toString(),r),c.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.T();const l=a.filter(r=>this.w.delete(r.id));this.U([],l,[]);const c=l.filter(r=>r instanceof D.SourceBreakpoint).map(r=>r.id),w=l.filter(r=>r instanceof D.FunctionBreakpoint).map(r=>r.id),n=l.filter(r=>r instanceof D.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(c,w,n)}startDebugging(a,l,c){return this.k.$startDebugging(a?a.uri:void 0,l,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,l,c){if(!l)return new D.Disposable(()=>{});const w=this.d++;return this.f.push({type:a,handle:w,provider:l}),this.k.$registerDebugConfigurationProvider(a,c,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,w),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==l),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(a,l,c){if(!c)return new D.Disposable(()=>{});if(!this.P(a,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:l,handle:w,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(l,w),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(a,l){if(!l)return new D.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:l}),new D.Disposable(()=>{this.j=this.j.filter(w=>w.factory!==l)})}async $runInTerminal(a,l){return Promise.resolve(void 0)}async $substituteVariables(a,l){let c;const w=await this.W(a);return w&&(c={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,l)}J(a,l){if(a.type==="implementation")return new v(a.implementation)}K(){}async $startDASession(a,l){const c=this,w=await this.V(l);return this.R(this.M(w.type),w).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const r=this.L(n),f=this.J(r,w);if(!f)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const A=f;return this.A.set(a,A),this.Q(w).then(T=>(T&&this.B.set(a,T),A.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const Q=H,Z={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const _=await this.C.sign(Q.arguments.value);Z.body={signature:_},A.sendResponse(Z)}else throw new Error("no signer")}catch(_){Z.success=!1,Z.message=_.message,A.sendResponse(Z)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(H),H=(0,m.convertToVSCPaths)(H,!0),c.k.$acceptDAMessage(a,H)}),A.onError(H=>{T&&T.onError&&T.onError(H),this.k.$acceptDAError(a,H.name,H.message,H.stack)}),A.onExit(H=>{T&&T.onExit&&T.onExit((0,I.withNullAsUndefined)(H),void 0),this.k.$acceptDAExit(a,(0,I.withNullAsUndefined)(H),void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),A.startSession()))})}$sendDAMessage(a,l){l=(0,m.convertToDAPaths)(l,!1);const c=this.B.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(l),this.A.get(a)?.sendMessage(l)}$stopDASession(a){const l=this.B.get(a);this.B.delete(a),l&&l.onWillStopSession&&l.onWillStopSession();const c=this.A.get(a);return this.A.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const l=[],c=[],w=[];if(a.added)for(const n of a.added){const r=n.id;if(r&&!this.w.has(r)){let f;if(n.type==="function")f=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const A=F.URI.revive(n.uri);f=new D.SourceBreakpoint(new D.Location(A,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,D.setBreakpointId)(f,r),this.w.set(r,f),l.push(f)}}if(a.removed)for(const n of a.removed){const r=this.w.get(n);r&&(this.w.delete(n),c.push(r))}if(a.changed){for(const n of a.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof D.FunctionBreakpoint&&n.type==="function"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(r instanceof D.SourceBreakpoint&&n.type==="source"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new D.Location(F.URI.revive(n.uri),new D.Position(n.line,n.character))}w.push(r)}}}this.U(l,c,w)}$provideDebugConfigurations(a,l,c){return(0,i.asPromise)(async()=>{const w=this.O(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(l);return w.provideDebugConfigurations(n,c)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(a,l,c,w){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(l);return n.resolveDebugConfiguration(r,c,w)})}$resolveDebugConfigurationWithSubstitutedVariables(a,l,c,w){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(l);return n.resolveDebugConfigurationWithSubstitutedVariables(r,c,w)})}async $provideDebugAdapter(a,l){const c=this.N(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(l);return this.R(c,w).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const l=await this.V(a);this.m.fire(l)}async $acceptDebugSessionTerminated(a){const l=await this.V(a);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,l){(await this.V(a))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(a,l){const w={session:await this.V(a),event:l.event,body:l.body};this.u.fire(w)}L(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const l=this.h.filter(c=>c.type===a);if(l.length>0)return l[0].factory}N(a){const l=this.h.filter(c=>c.handle===a);if(l.length>0)return l[0].factory}O(a){const l=this.f.filter(c=>c.handle===a);if(l.length>0)return l[0].provider}P(a,l){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const w of c)if(w.label&&w.type&&w.type===l)return!0}}return!1}Q(a){const c=a.configuration.type,w=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(r=>r,r=>null));return Promise.race([Promise.all(w).then(n=>{const r=n.filter(f=>!!f);if(r.length>0)return new O(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,l){const c=l.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new D.DebugAdapterServer(c));if(a){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>a.createDebugAdapterDescriptor(l,this.S(l,n))).then(r=>{if(r)return r})}const w=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,w))}S(a,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,l,c){(a.length>0||l.length>0||c.length>0)&&this.z.fire(Object.freeze({added:a,removed:l,changed:c}))}async V(a){if(a)if(typeof a=="string"){const l=this.l.get(a);if(l)return l}else{let l=this.l.get(a.id);if(!l){const c=await this.W(a.folderUri),w=a.parent?this.l.get(a.parent):void 0;l=new p(this.k,a.id,a.type,a.name,c,a.configuration,w),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(a){if(a){const l=F.URI.revive(a);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};u=qe([Ve(0,M.IExtHostRpcService),Ve(1,h.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,o.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,s.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class p{constructor(a,l,c,w,n,r,f){this.d=a,this.f=l,this.g=c,this.h=w,this.i=n,this.j=r,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,l){return this.d.$customDebugAdapterRequest(this.f,a,l)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=p;class S{constructor(a){this.value=Object.freeze({append(l){a.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=S;class O{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(l=>l.onError?l.onError(a):void 0)}onExit(a,l){this.d.forEach(c=>c.onExit?c.onExit(a,l):void 0)}}class v extends b.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(a,l,c,w,n,r){super(a,l,c,w,n,r)}};t=qe([Ve(0,M.IExtHostRpcService),Ve(1,h.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,o.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,s.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(ke[250],Te([1,0,11,82,2,5,241,12,67,68,27,161,18,55,33,57]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class s{static async installEarlyHandler(S){const O=S.get(R.ILogService),t=S.get(h.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(d=>{O.error(d);const a=i.transformErrorForSerialization(d);t.$onUnexpectedError(a)})}static async installFullHandler(S){const O=S.get(R.ILogService),v=S.get(h.IExtHostRpcService),t=S.get(m.IExtHostExtensionService),d=S.get(o.IExtHostTelemetry),a=v.getProxy(F.MainContext.MainThreadExtensionService),l=v.getProxy(F.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),w=new WeakMap;Error.prepareStackTrace=(n,r)=>{let f="",A,T;for(const H of r)f+=`
	at ${H.toString()}`,T=H.getFileName(),!A&&T&&(A=c.findSubstr(I.URI.file(T)));return w.set(n,A?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},i.setUnexpectedErrorHandler(n=>{O.error(n);const r=i.transformErrorForSerialization(n),f=w.get(n);if(!f){l.$onUnexpectedError(r);return}a.$onExtensionRuntimeError(f,r);const A=d.onExtensionError(f,n);O.trace("forwarded error to extension?",A,f)})}}Error.stackTraceLimit=100;class u{constructor(S,O,v,t,d){this.a=v,this.b=new E.RPCProtocol(S,null,t),O=u.e(O,this.b);const a=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());a.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...O,messagePorts:d}),a.set(h.IExtHostRpcService,new h.ExtHostRpcService(this.b)),a.set(b.IURITransformerService,new b.URITransformerService(t)),a.set(m.IHostUtils,v);const l=new D.InstantiationService(a,!0);l.invokeFunction(s.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(R.ILogService)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",O),this.c=l.invokeFunction(c=>c.get(m.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(s.installFullHandler)}async asBrowserUri(S){const O=this.b.getProxy(F.MainContext.MainThreadExtensionService);return I.URI.revive(await O.$asBrowserUri(S))}terminate(S){this.c.terminate(S)}static e(S,O){S.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(O.transformIncomingURIs(t.extensionLocation));const d={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(a=>d[a]=I.URI.revive(O.transformIncomingURIs(t.browserNlsBundleUris[a]))),t.browserNlsBundleUris=d)}),S.environment.appRoot=I.URI.revive(O.transformIncomingURIs(S.environment.appRoot));const v=S.environment.extensionDevelopmentLocationURI;return v&&(S.environment.extensionDevelopmentLocationURI=v.map(t=>I.URI.revive(O.transformIncomingURIs(t)))),S.environment.extensionTestsLocationURI=I.URI.revive(O.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=I.URI.revive(O.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=I.URI.revive(O.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=I.URI.revive(O.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=I.URI.revive(O.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=I.URI.revive(O.transformIncomingURIs(S.logsLocation)),S.logFile=I.URI.revive(O.transformIncomingURIs(S.logFile)),S.workspace=O.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=u}),define(ke[251],Te([1,0,16,17,21,39,15,19,24,2,47]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(p,S,O,v){this.d=p,this.e=S,this.f=O,this.g=v,this.a=null,this.b=!1,this.c=0}search(p,S){const O=this.d.folderQueries||[],v=new I.CancellationTokenSource;return S.onCancellationRequested(()=>v.cancel()),new Promise((t,d)=>{this.a=new b(p);let a=!1;const l=(c,w)=>{if(!a&&!this.b){const n=this.h(c);o(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,v.cancel(),c=this.j(c,this.d.maxResults-this.c));const r=this.h(c);this.c+=r,(r>0||!o(c))&&this.a.add(c,w)}};Promise.all(O.map((c,w)=>this.k(c,n=>l(n,w),v.token))).then(c=>{v.dispose(),this.a.flush();const w=c.some(n=>!!n&&!!n.limitHit);t({limitHit:this.b||w,messages:(0,i.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{v.dispose();const w=(0,F.toErrorMessage)(c);d(new Error(w))})})}h(p){return o(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,S){const O=Array.isArray(p.ranges)?p.ranges:[p.ranges],v=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:O.slice(0,S),preview:{matches:v.slice(0,S),text:p.preview.text},uri:p.uri}}async k(p,S,O){const v=new M.QueryGlobTester(this.d,p),t=[],d={report:c=>{if(!this.l(c))return;const w=p.folder.scheme===E.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(c.uri))):void 0,n=y.relativePath(p.folder,c.uri);if(n){const r=v.includedInQuery(n,R.basename(n),w);(0,P.isThenable)(r)?t.push(r.then(f=>{f&&S(c)})):r&&S(c)}}},a=this.n(p),l=await this.e.provideTextSearchResults(h(this.d.contentPattern),a,d,O);return t.length&&await Promise.all(t),l}l(p){if(o(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const S=(0,M.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),O=(0,M.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),v={folder:k.URI.from(p.folder),excludes:O,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=D;function h(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class b{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new s(512,S=>this.g(S))}add(p,S){this.d&&(this.b!==S||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=S,this.d={resource:p.uri,results:[]}),this.d.results.push(m(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=b;function m(u){return o(u)?{preview:{matches:(0,i.mapArrayOrNot)(u.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:u.preview.text},ranges:(0,i.mapArrayOrNot)(u.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function o(u){return!!u.preview}e.extensionResultIsMatch=o;class s{constructor(p,S){this.g=p,this.h=S,this.c=0,this.d=[],this.e=0}addItem(p,S){!p||this.j(p,S)}addItems(p,S){!p||this.k(p,S)}j(p,S){this.d.push(p),this.e+=S,this.l()}k(p,S){this.d=this.d.concat(p),this.e+=S,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}s.a=4e3,s.b=50,e.BatchedCollector=s}),define(ke[110],Te([1,0,6,5,3,246,18,55,12,2,251]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let D=class{constructor(o,s,u){this.k=o,this.l=s,this.n=u,this.c=this.k.getProxy(P.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.FileSearchManager}o(o){return this.l.transformOutgoingScheme(o)}registerTextSearchProvider(o,s){if(this.g.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this.g.add(o);const u=this.d++;return this.e.set(u,s),this.c.$registerTextSearchProvider(u,this.o(o)),(0,i.toDisposable)(()=>{this.g.delete(o),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(o,s){if(this.i.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this.i.add(o);const u=this.d++;return this.h.set(u,s),this.c.$registerFileSearchProvider(u,this.o(o)),(0,i.toDisposable)(()=>{this.i.delete(o),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(o,s,u,p){const S=h(u),O=this.h.get(o);if(O)return this.j.fileSearch(S,O,v=>{this.c.$handleFileMatch(o,s,v.map(t=>t.resource))},p);throw new Error("unknown provider: "+o)}$clearCache(o){return this.j.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,s,u,p){const S=this.e.get(o);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const O=h(u);return this.q(O,S).search(t=>this.c.$handleTextMatch(o,s,t),p)}$enableExtensionHostSearch(){}q(o,s){return new M.TextSearchManager(o,s,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};D=qe([Ve(0,E.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,y.ILogService)],D),e.ExtHostSearch=D;function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(o=>k.URI.revive(o))}}e.reviveQuery=h;function b(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(ke[252],Te([1,0,67,105,31,103,32,37,58,61,107,109,110,80,70,76,104,60,36,79,57,59,221,12,177,108,78]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t,d,a,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,i.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,i.registerSingleton)(d.ILogService,a.ExtHostLogService,1),(0,i.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,i.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration,0),(0,i.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,i.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,i.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,i.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,i.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,i.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,i.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,i.registerSingleton)(O.IExtHostTelemetry,O.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ke[253],Te([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const F=this.a.get(I);return this.a.delete(I),F}}addDragOperationTransfer(I,F){this.a.set(I,F)}getRenderedTreeElement(I){if(this.b.has(I))return this.b.get(I)}addRenderedTreeItemElement(I,F){this.b.set(I,F)}removeRenderedTreeItemElement(I){this.b.has(I)&&this.b.delete(I)}}e.TreeviewsService=i}),define(ke[254],Te([1,0,145,7,24,2,4,6,182,17,7,9,16,8,21,253,25]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(O,v){if((0,D.isString)(O))return{label:O};if(O&&typeof O=="object"&&typeof O.label=="string"){let t;return Array.isArray(O.highlights)&&(t=O.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:O.label,highlights:t}}}class p{constructor(v,t,d){this.d=v,this.e=t,this.f=d,this.a=new Map,this.b=new o.TreeviewsService;function a(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>a(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(c=>a(c)?this.i(c):c):l})}registerTreeDataProvider(v,t,d){const a=this.createTreeView(v,{treeDataProvider:t},d);return{dispose:()=>a.dispose()}}createTreeView(v,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,w=!!t.dragAndDropController?.handleDrop,n=this.h(v,t,d),r=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:w});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,s.checkProposedApiEnabled)(d,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(f){n.message=f},get title(){return n.title},set title(f){n.title=f},get description(){return n.description},set description(f){n.description=f},get badge(){return n.badge},set badge(f){f!==void 0&&M.ViewBadge.isViewBadge(f)?n.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(n.badge=void 0)},reveal:(f,A)=>n.reveal(f,A),dispose:async()=>{await r,this.a.delete(v),n.dispose()}}}$getChildren(v,t){const d=this.a.get(v);return d?d.getChildren(t):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,t,d,a,l,c,w,n){const r=this.a.get(v);if(!r)return Promise.reject(new y.NoTreeViewError(v));const f=b.DataTransfer.toDataTransfer(d,async A=>(await this.d.$resolveDropFileData(v,t,A)).buffer);return w===v&&n&&await this.g(f,r,n,l,c),r.onDrop(f,a,l)}async g(v,t,d,a,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((w,n)=>{w&&v.set(n,w)});else if(l&&t.handleDrag){const w=t.handleDrag(d,v,a);this.b.addDragOperationTransfer(l,w),await w}return v}async $handleDrag(v,t,d,a){const l=this.a.get(v);if(!l)return Promise.reject(new y.NoTreeViewError(v));const c=await this.g(new P.DataTransfer,l,t,a,d);if(!!c)return b.DataTransfer.toDataTransferDTO(c)}async $hasResolve(v){const t=this.a.get(v);if(!t)throw new y.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,d){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);return a.resolveTreeItem(t,d)}$setExpanded(v,t,d){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);a.setExpanded(t,d)}$setSelection(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setSelection(t)}$setFocus(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setFocus(t)}$setVisible(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setVisible(t)}$changeCheckboxState(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setCheckboxState(t)}h(v,t,d){const a=new S(v,t,this.d,this.e.converter,this.f,d);return this.a.set(v,a),a}i(v){const t=this.a.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=p;class S extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,D.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,t,d,a,l,c){if(super(),this.C=v,this.D=d,this.F=a,this.G=l,this.H=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new E.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new E.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new E.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new E.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new E.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new E.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,c.contributes&&c.contributes.views)for(const r in c.contributes.views)for(const f of c.contributes.views[r])f.id===v&&(this.J=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(r=>this.w.fire({message:!1,element:r})));let w,n;this.B(E.Event.debounce(this.w.event,(r,f)=>(r||(r={message:!1,elements:[]}),f.element!==!1&&(w||(w=new Promise(A=>n=A),this.y=this.y.then(()=>w)),Array.isArray(f.element)?r.elements.push(...f.element):r.elements.push(f.element)),f.message&&(r.message=!0),r),200,!0)(({message:r,elements:f})=>{f.length&&(this.z=this.z.then(()=>{const A=n;return w=null,this.U(f).then(()=>A())})),r&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.Q(v);return d||(d=await this.R(t)),d?d.map(a=>a.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const d=(0,D.isUndefinedOrNull)(t.select)?!0:t.select,a=(0,D.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,D.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(c=>this.P(v,c[c.length-1]).then(w=>this.D.$reveal(this.C,{item:w.item,parentChain:c.map(n=>n.item)},{select:d,focus:a,expand:l})),c=>this.G.error(c)):this.D.$reveal(this.C,void 0,{select:d,focus:a,expand:l})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,t){const d=this.getExtensionElement(v);d&&(t?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(v){(0,h.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async d=>{const a=this.getExtensionElement(d.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:d.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,t,d){const a=[];for(const l of v){const c=this.getExtensionElement(l);c&&a.push(c)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,t,d){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(a,v,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,t){if(!this.f.resolveTreeItem)return;const d=this.i.get(v);if(d){const a=this.j.get(d);if(a){const l=await this.f.resolveTreeItem(a.extensionItem,d,t)??a.extensionItem;return this.db(l),a.item.tooltip=this.ab(l.tooltip),a.item.command=this.bb(a.disposableStore,l.command),a.item}}}N(v){return this.O(v).then(t=>t?this.N(t).then(d=>this.P(t,d[d.length-1]).then(a=>(d.push(a),d))):Promise.resolve([]))}O(v){const t=this.j.get(v);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(v))}P(v,t){const d=this.j.get(v);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.f.getTreeItem(v)).then(a=>this.gb(v,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(a);if(l){const c=this.j.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}Q(v){if(v){let t;if(typeof v=="string"){const d=this.getExtensionElement(v);t=d?this.j.get(d):void 0}else t=v;return t&&t.children||void 0}return this.h}async R(v){this.nb(v);const t=new m.CancellationTokenSource(this.S.token);try{const d=v?this.j.get(v):void 0,a=await this.f.getChildren(v);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,h.coalesce)(a||[]).map(async c=>{const w=await this.f.getTreeItem(c);return w&&!t.token.isCancellationRequested?this.Z(c,w,d):null}));return t.token.isCancellationRequested?void 0:(0,h.coalesce)(l)}finally{t.dispose()}}U(v){if(v.some(d=>!d))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(v);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(v){const t=new Set,d=v.map(l=>this.j.get(l));for(const l of d)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&d.findIndex(w=>c&&c.parent&&w&&w.item.handle===c.parent.item.handle)===-1;){const w=this.i.get(c.parent.item.handle);c=w?this.j.get(w):void 0}c&&!c.parent&&t.add(l.item.handle)}const a=[];return t.forEach(l=>{const c=this.i.get(l);if(c){const w=this.j.get(c);w&&(!w.parent||!t.has(w.parent.item.handle))&&a.push(l)}}),a}X(v){const t={};return Promise.all(v.map(d=>this.Y(d).then(a=>{a&&(t[d]=a.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(v){const t=this.getExtensionElement(v);if(t){const d=this.j.get(t);if(d)return this.nb(t),(0,k.asPromise)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const l=this.eb(t,a,d.parent);return this.lb(t,l,d,d.parent),d.dispose(),l}return null})}return Promise.resolve(null)}Z(v,t,d){const a=this.eb(v,t,d);if(t.id&&this.i.has(a.item.handle))throw new Error((0,i.localize)(0,null,t.id));return this.kb(v,a),this.mb(a,d),a}ab(v){return M.MarkdownString.isMarkdownString(v)?b.MarkdownString.from(v):v}bb(v,t){return t?{...this.F.toInternal(t,v),originalId:t.command}:void 0}cb(v){if(!v.checkboxState)return;let t,d;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:t===M.TreeItemCheckboxState.Checked,tooltip:d}}db(v){if(!M.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,t,d){this.db(t);const a=new R.DisposableStore,l=this.gb(v,t,d),c=this.hb(t);return{item:{handle:l,parentHandle:d?d.item.handle:void 0,label:u(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(a,t.command),contextValue:t.contextValue,icon:c,iconDark:this.ib(t)||c,themeIcon:this.fb(t),collapsibleState:(0,D.isUndefinedOrNull)(t.collapsibleState)?M.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:a,dispose(){a.dispose()}}}fb(v){return v.iconPath instanceof M.ThemeIcon?v.iconPath:void 0}gb(v,{id:t,label:d,resourceUri:a},l,c){if(t)return`${S.b}/${t}`;const w=u(d,this.H),n=l?l.item.handle:S.a;let r=w?w.label:a?(0,I.basename)(a):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const f=this.j.has(v)?this.j.get(v).item.handle:void 0,A=this.Q(l)||[];let T,H=0;do{if(T=`${n}/${H}:${r}`,c||!this.i.has(T)||f===T)break;H++}while(H<=A.length);return T}hb(v){if(v.iconPath&&!(v.iconPath instanceof M.ThemeIcon))return typeof v.iconPath=="string"||F.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof M.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return F.URI.isUri(v)?v:F.URI.file(v)}kb(v,t){this.i.set(t.item.handle,v),this.j.set(v,t)}lb(v,t,d,a){this.i.delete(t.item.handle),this.j.delete(v),t.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(v,t);const l=this.Q(a)||[],c=l.filter(w=>w.item.handle===d.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}mb(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const a=this.i.get(d.item.handle);a&&this.ob(a)}t.children=void 0}}else this.pb()}ob(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const a=this.i.get(d.item.handle);a&&this.ob(a)}this.j.delete(v),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}S.a="0",S.b="1"}),define(ke[255],Te([1,0,21,11,4,29,2,130,264,118,128,43,5,74,208,207,37,209,32,211,212,213,196,214,58,33,215,216,219,220,222,105,199,228,229,230,80,61,233,254,8,7,52,236,62,104,31,188,218,50,103,107,109,110,12,55,18,27,223,194,70,76,205,234,81,60,239,237,238,206,36,231,235,79,59,57,224,106,225,15,92,198,179,217,6,25,184,78,175,226,227]),function(ne,e,i,P,I,F,E,R,y,k,M,D,h,b,m,o,s,u,p,S,O,v,t,d,a,l,c,w,n,r,f,A,T,H,Q,Z,_,j,L,g,N,B,J,me,te,oe,ce,we,q,x,X,de,ye,Ne,ze,Pe,Ie,Se,ae,le,ee,C,$,W,V,ie,fe,De,ue,ve,be,He,je,it,Xe,et,nt,Fe,rt,G,Y,pe,We,$e,Qe,Ke,tt,at,Et,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Dt(ut){const ft=ut.get(Se.IExtHostInitDataService),Kt=ut.get(be.IExtHostFileSystemInfo),Vt=ut.get(ie.IExtHostConsumerFileSystem),kt=ut.get(l.IExtHostExtensionService),ht=ut.get(ce.IExtHostWorkspace),Tt=ut.get(et.IExtHostTelemetry),$t=ut.get(p.IExtHostConfiguration),At=ut.get(Pe.IURITransformerService),Ge=ut.get(Ie.IExtHostRpcService),Nt=ut.get(_.IExtHostStorage),xt=ut.get(V.IExtensionStoragePaths),Ft=ut.get(ze.ILoggerService),mt=ut.get(ze.ILogService),Ce=ut.get(ee.IExtHostTunnelService),Ae=ut.get(C.IExtHostApiDeprecationService),ge=ut.get(oe.IExtHostWindow),K=ut.get(it.IExtHostSecretState),Re=ut.get(Xe.IExtHostEditorTabs);Ge.set(h.ExtHostContext.ExtHostFileSystemInfo,Kt),Ge.set(h.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Ge.set(h.ExtHostContext.ExtHostWorkspace,ht),Ge.set(h.ExtHostContext.ExtHostConfiguration,$t),Ge.set(h.ExtHostContext.ExtHostExtensionService,kt),Ge.set(h.ExtHostContext.ExtHostStorage,Nt),Ge.set(h.ExtHostContext.ExtHostTunnelService,Ce),Ge.set(h.ExtHostContext.ExtHostWindow,ge),Ge.set(h.ExtHostContext.ExtHostSecretState,K),Ge.set(h.ExtHostContext.ExtHostTelemetry,Tt),Ge.set(h.ExtHostContext.ExtHostEditorTabs,Re);const Ue=Ge.set(h.ExtHostContext.ExtHostDecorations,ut.get(X.IExtHostDecorations)),Ye=Ge.set(h.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(a.IExtHostDocumentsAndEditors)),Be=Ge.set(h.ExtHostContext.ExtHostCommands,ut.get(s.IExtHostCommands)),Ze=Ge.set(h.ExtHostContext.ExtHostTerminalService,ut.get(j.IExtHostTerminalService)),ct=Ge.set(h.ExtHostContext.ExtHostDebugService,ut.get(ye.IExtHostDebugService)),Pt=Ge.set(h.ExtHostContext.ExtHostSearch,ut.get(Ne.IExtHostSearch)),vt=Ge.set(h.ExtHostContext.ExtHostTask,ut.get(de.IExtHostTask)),wt=Ge.set(h.ExtHostContext.ExtHostOutputService,ut.get(A.IExtHostOutputService)),pt=Ge.set(h.ExtHostContext.ExtHostLocalization,ut.get(at.IExtHostLocalizationService)),Rt=Ge.set(h.ExtHostContext.ExtHostUrls,new me.ExtHostUrls(Ge)),bt=Ge.set(h.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Ye)),ri=Ge.set(h.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Ye,mt)),ei=Ge.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(mt,bt,Ge.getProxy(h.MainContext.MainThreadBulkEdits))),St=Ge.set(h.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ge,Be,Ye,bt)),si=Ge.set(h.ExtHostContext.ExtHostNotebookDocuments,new We.ExtHostNotebookDocuments(St)),oi=Ge.set(h.ExtHostContext.ExtHostNotebookEditors,new pe.ExtHostNotebookEditors(mt,St)),_t=Ge.set(h.ExtHostContext.ExtHostNotebookKernels,new nt.ExtHostNotebookKernels(Ge,ft,St,Be,mt)),vi=Ge.set(h.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(Ge,St)),Ot=Ge.set(h.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ge,Ye)),zt=Ge.set(h.ExtHostContext.ExtHostTreeViews,new g.ExtHostTreeViews(Ge.getProxy(h.MainContext.MainThreadTreeViews),Be,mt)),bi=Ge.set(h.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(Ge.getProxy(h.MainContext.MainThreadEditorInsets),Ot,ft.remote)),ai=Ge.set(h.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ge,mt,Kt,Ye)),Jt=Ge.set(h.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Ge,bt,Be.converter,At)),lt=Ge.set(h.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,At,bt,Be,ai,mt,Ae,Tt)),$i=Ge.set(h.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,lt)),Ut=Ge.set(h.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(Ge,mt,Ye)),Xt=Ge.set(h.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Ge,ht,Be)),ci=Ge.set(h.ExtHostContext.ExtHostSCM,new Q.ExtHostSCM(Ge,Be,mt)),Ei=Ge.set(h.ExtHostContext.ExtHostQuickDiff,new It.ExtHostQuickDiff(Ge,At)),wi=Ge.set(h.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ge,Be,bt)),ui=Ge.set(h.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Ge.getProxy(h.MainContext.MainThreadProgress))),Si=Ge.set(h.ExtHostContext.ExtHosLabelService,new q.ExtHostLabelService(Ge)),li=Ge.set(h.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Ge)),Zt=Ge.set(h.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Bi=Ge.set(h.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Be)),ti=Ge.set(h.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(Ge,ft.remote,ht,mt,Ae)),ii=Ge.set(h.ExtHostContext.ExtHostWebviewPanels,new ue.ExtHostWebviewPanels(Ge,ti,ht)),yi=Ge.set(h.ExtHostContext.ExtHostCustomEditors,new De.ExtHostCustomEditors(Ge,bt,xt,ti,ii)),Di=Ge.set(h.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(Ge,ti)),ni=Ge.set(h.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ge,Be,Ye)),Ii=Ge.set(h.ExtHostContext.ExtHostUriOpeners,new je.ExtHostUriOpeners(Ge)),Ci=Ge.set(h.ExtHostContext.ExtHostProfileContentHandlers,new Ct.ExtHostProfileContentHandlers(Ge));Ge.set(h.ExtHostContext.ExtHostInteractive,new $e.ExtHostInteractive(Ge,St,Ye,Be,mt));const zi=Object.values(h.ExtHostContext);Ge.assertRegistered(zi);const Wi=new ve.ExtHostBulkEdits(Ge,Ye),Hi=new o.ExtHostClipboard(Ge),ki=new f.ExtHostMessageService(Ge,mt),Ri=new O.ExtHostDialogs(Ge),Oi=new Z.ExtHostStatusBar(Ge,Be.converter);return m.ExtHostApiCommands.register(Be),function(Me,Wt,Li){const gt=function(){let se=!Me.isUnderDevelopment;function he(){se||(mt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")he();else{const yt=st;typeof yt.scheme>"u"&&he(),typeof yt.exclusive=="boolean"&&(0,Ke.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Vi={getSession(se,he,Oe){return Zt.getSession(Me,se,he,Oe)},async hasSession(se,he){return(0,Ke.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,se,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,he,Oe,st){return Zt.registerAuthenticationProvider(se,he,Oe,st)}},di={registerCommand(se,he,Oe){return Be.registerCommand(!0,se,he,Oe,void 0,Me)},registerTextEditorCommand(se,he,Oe){return Be.registerCommand(!0,se,(...st)=>{const yt=Ot.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}return yt.edit(Lt=>{he.apply(Oe,[yt,Lt,...st])}).then(Lt=>{Lt||mt.warn("Edits from command "+se+" were not applied.")},Lt=>{mt.warn("An error occurred while running command "+se,Lt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"diffCommand"),Be.registerCommand(!0,se,async(...st)=>{const yt=Ye.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(yt.id);he.apply(Oe,[Lt,...st])},void 0,void 0,Me)),executeCommand(se,...he){return Be.executeCommand(se,...he)},getCommands(se=!1){return Be.getCommands(se)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ke.checkProposedApiEnabled)(Me,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Me,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Me,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return et.ExtHostTelemetryLogger.validateSender(se),Tt.instantiateLogger(Me,se)},openExternal(se,he){return ge.openUri(se,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ft.environment.appUriScheme)return Rt.createAppUri(se);try{return await ge.asExternalUri(se,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,Y.matchesScheme)(se,G.Schemas.http)||(0,Y.matchesScheme)(se,G.Schemas.https))return se;throw he}},get remoteName(){return(0,x.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ke.checkProposedApiEnabled)(Me,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const ji={createTestController(se,he,Oe){return ni.createTestController(Me,se,he,Oe)},createTestObserver(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.createTestObserver()},runTests(se){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.runTests(se)},get onDidChangeTestResults(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.results}},hi=ft.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,qi={getExtension(se,he){(0,Ke.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Oe=Wt.mine.getExtensionDescription(se);if(Oe)return new l.Extension(kt,Me.identifier,Oe,hi,!1);if(he){const st=Wt.all.getExtensionDescription(se);if(st)return new l.Extension(kt,Me.identifier,st,hi,!0)}},get all(){const se=[];for(const he of Wt.mine.getAllExtensionDescriptions())se.push(new l.Extension(kt,Me.identifier,he,hi,!1));return se},get allAcrossExtensionHosts(){(0,Ke.checkProposedApiEnabled)(Me,"extensionsAny");const se=new Ke.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Wt.all.getAllExtensionDescriptions()){const st=!se.has(Oe.identifier);he.push(new l.Extension(kt,Me.identifier,Oe,hi,st))}return he},get onDidChange(){return(0,Ke.isProposedApiEnabled)(Me,"extensionsAny")?I.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ti={createDiagnosticCollection(se){return ai.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:se=>ai.getDiagnostics(se),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(se,he){return Jt.changeLanguage(se.uri,he)},match(se,he){const Oe=bt.getDocumentData(he.uri)?.notebook;return(0,M.score)(N.LanguageSelector.from(se),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(se,he,Oe){return lt.registerCodeActionProvider(Me,gt(se),he,Oe)},registerDocumentPasteEditProvider(se,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,gt(se),he,Oe)},registerCodeLensProvider(se,he){return lt.registerCodeLensProvider(Me,gt(se),he)},registerDefinitionProvider(se,he){return lt.registerDefinitionProvider(Me,gt(se),he)},registerDeclarationProvider(se,he){return lt.registerDeclarationProvider(Me,gt(se),he)},registerImplementationProvider(se,he){return lt.registerImplementationProvider(Me,gt(se),he)},registerTypeDefinitionProvider(se,he){return lt.registerTypeDefinitionProvider(Me,gt(se),he)},registerHoverProvider(se,he){return lt.registerHoverProvider(Me,gt(se),he,Me.identifier)},registerEvaluatableExpressionProvider(se,he){return lt.registerEvaluatableExpressionProvider(Me,gt(se),he,Me.identifier)},registerInlineValuesProvider(se,he){return lt.registerInlineValuesProvider(Me,gt(se),he,Me.identifier)},registerDocumentHighlightProvider(se,he){return lt.registerDocumentHighlightProvider(Me,gt(se),he)},registerLinkedEditingRangeProvider(se,he){return lt.registerLinkedEditingRangeProvider(Me,gt(se),he)},registerReferenceProvider(se,he){return lt.registerReferenceProvider(Me,gt(se),he)},registerRenameProvider(se,he){return lt.registerRenameProvider(Me,gt(se),he)},registerDocumentSymbolProvider(se,he,Oe){return lt.registerDocumentSymbolProvider(Me,gt(se),he,Oe)},registerWorkspaceSymbolProvider(se){return lt.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,he){return lt.registerDocumentFormattingEditProvider(Me,gt(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return lt.registerDocumentRangeFormattingEditProvider(Me,gt(se),he)},registerOnTypeFormattingEditProvider(se,he,Oe,...st){return lt.registerOnTypeFormattingEditProvider(Me,gt(se),he,[Oe].concat(st))},registerDocumentSemanticTokensProvider(se,he,Oe){return lt.registerDocumentSemanticTokensProvider(Me,gt(se),he,Oe)},registerDocumentRangeSemanticTokensProvider(se,he,Oe){return lt.registerDocumentRangeSemanticTokensProvider(Me,gt(se),he,Oe)},registerSignatureHelpProvider(se,he,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(Me,gt(se),he,Oe):lt.registerSignatureHelpProvider(Me,gt(se),he,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(se,he,...Oe){return lt.registerCompletionItemProvider(Me,gt(se),he,Oe)},registerInlineCompletionItemProvider(se,he){return he.handleDidShowCompletionItem&&(0,Ke.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ke.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,gt(se),he)},registerDocumentLinkProvider(se,he){return lt.registerDocumentLinkProvider(Me,gt(se),he)},registerColorProvider(se,he){return lt.registerColorProvider(Me,gt(se),he)},registerFoldingRangeProvider(se,he){return lt.registerFoldingRangeProvider(Me,gt(se),he)},registerSelectionRangeProvider(se,he){return lt.registerSelectionRangeProvider(Me,se,he)},registerCallHierarchyProvider(se,he){return lt.registerCallHierarchyProvider(Me,se,he)},registerTypeHierarchyProvider(se,he){return lt.registerTypeHierarchyProvider(Me,se,he)},setLanguageConfiguration:(se,he)=>lt.setLanguageConfiguration(Me,se,he),getTokenInformationAtPosition(se,he){return(0,Ke.checkProposedApiEnabled)(Me,"tokenInformation"),Jt.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return lt.registerInlayHintsProvider(Me,se,he)},createLanguageStatusItem(se,he){return Jt.createLanguageStatusItem(Me,se,he)},registerDocumentDropEditProvider(se,he){return lt.registerDocumentOnDropEditProvider(Me,se,he)}},Ki={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(se,he,Oe){const st=await(E.URI.isUri(se)?Promise.resolve(jt.openTextDocument(se)):Promise.resolve(se));return Ot.showTextDocument(st,he,Oe)},createTextEditorDecorationType(se){return Ot.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,he,Oe){return Ot.onDidChangeActiveTextEditor(se,he,Oe)},onDidChangeVisibleTextEditors(se,he,Oe){return Ot.onDidChangeVisibleTextEditors(se,he,Oe)},onDidChangeTextEditorSelection(se,he,Oe){return Ot.onDidChangeTextEditorSelection(se,he,Oe)},onDidChangeTextEditorOptions(se,he,Oe){return Ot.onDidChangeTextEditorOptions(se,he,Oe)},onDidChangeTextEditorVisibleRanges(se,he,Oe){return Ot.onDidChangeTextEditorVisibleRanges(se,he,Oe)},onDidChangeTextEditorViewColumn(se,he,Oe){return Ot.onDidChangeTextEditorViewColumn(se,he,Oe)},onDidCloseTerminal(se,he,Oe){return Ze.onDidCloseTerminal(se,he,Oe)},onDidOpenTerminal(se,he,Oe){return Ze.onDidOpenTerminal(se,he,Oe)},onDidChangeActiveTerminal(se,he,Oe){return Ze.onDidChangeActiveTerminal(se,he,Oe)},onDidChangeTerminalDimensions(se,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(se,he,Oe)},onDidChangeTerminalState(se,he,Oe){return Ze.onDidChangeTerminalState(se,he,Oe)},onDidWriteTerminalData(se,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(se,he,Oe)},get state(){return ge.state},onDidChangeWindowState(se,he,Oe){return ge.onDidChangeWindowState(se,he,Oe)},showInformationMessage(se,...he){return ki.showMessage(Me,F.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return ki.showMessage(Me,F.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return ki.showMessage(Me,F.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Oe){return Xt.showQuickPick(Me,se,he,Oe)},showWorkspaceFolderPick(se){return Xt.showWorkspaceFolderPick(se)},showInputBox(se,he){return Xt.showInput(se,he)},showOpenDialog(se){return Ri.showOpenDialog(Me,se)},showSaveDialog(se){return Ri.showSaveDialog(se)},createStatusBarItem(se,he,Oe){let st,yt,Lt;return typeof se=="string"?(st=se,yt=he,Lt=Oe):(yt=se,Lt=he),Oi.createStatusBarEntry(Me,st,yt,Lt)},setStatusBarMessage(se,he){return Oi.setStatusBarMessage(se,he)},withScmProgress(se){return Ae.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ui.withProgress(Me,{location:B.ProgressLocation.SourceControl},(he,Oe)=>se({report(st){}}))},withProgress(se,he){return ui.withProgress(Me,se,he)},createOutputChannel(se,he){return wt.createOutputChannel(se,he,Me)},createWebviewPanel(se,he,Oe,st){return ii.createWebviewPanel(Me,se,he,Oe,st)},createWebviewTextEditorInset(se,he,Oe,st){return(0,Ke.checkProposedApiEnabled)(Me,"editorInsets"),bi.createWebviewEditorInset(se,he,Oe,st,Me)},createTerminal(se,he,Oe){return typeof se=="object"?"pty"in se?Ze.createExtensionTerminal(se):Ze.createTerminalFromOptions(se):Ze.createTerminal(se,he,Oe)},registerTerminalLinkProvider(se){return Ze.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return Ze.registerProfileProvider(Me,se,he)},registerTerminalQuickFixProvider(se,he){return(0,Ke.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(se,Me.identifier.value,he)},registerTreeDataProvider(se,he){return zt.registerTreeDataProvider(se,he,Me)},createTreeView(se,he){return zt.createTreeView(se,he,Me)},registerWebviewPanelSerializer:(se,he)=>ii.registerWebviewPanelSerializer(Me,se,he),registerCustomEditorProvider:(se,he,Oe={})=>yi.registerCustomEditorProvider(Me,se,he,Oe),registerFileDecorationProvider(se){return Ue.registerFileDecorationProvider(se,Me)},registerUriHandler(se){return Rt.registerUriHandler(Me.identifier,se)},createQuickPick(){return Xt.createQuickPick(Me)},createInputBox(){return Xt.createInputBox(Me)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(se,he,Oe){return li.onDidChangeActiveColorTheme(se,he,Oe)},registerWebviewViewProvider(se,he,Oe){return Di.registerWebviewViewProvider(Me,se,he,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Oe){return St.onDidChangeActiveNotebookEditor(se,he,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Oe){return oi.onDidChangeNotebookEditorSelection(se,he,Oe)},onDidChangeNotebookEditorVisibleRanges(se,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(se,he,Oe)},showNotebookDocument(se,he){return St.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"externalUriOpener"),Ii.registerExternalUriOpener(Me.identifier,se,he,Oe)},registerProfileContentHandler(se,he){return(0,Ke.checkProposedApiEnabled)(Me,"profileContentHandlers"),Ci.registrProfileContentHandler(Me,se,he)},registerQuickDiffProvider(se,he,Oe,st){return(0,Ke.checkProposedApiEnabled)(Me,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(se),he,Oe,st)},get tabGroups(){return Re.tabGroups}},jt={get rootPath(){return Ae.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(se){throw P.readonly()},getWorkspaceFolder(se){return ht.getWorkspaceFolder(se)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(se){throw P.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(se){throw P.readonly()},updateWorkspaceFolders:(se,he,...Oe)=>ht.updateWorkspaceFolders(Me,se,he||0,...Oe),onDidChangeWorkspaceFolders:function(se,he,Oe){return ht.onDidChangeWorkspace(se,he,Oe)},asRelativePath:(se,he)=>ht.getRelativePath(se,he),findFiles:(se,he,Oe,st)=>ht.findFiles(se,he,Oe,Me.identifier,st),findTextInFiles:(se,he,Oe,st)=>{(0,Ke.checkProposedApiEnabled)(Me,"findTextInFiles");let yt,Lt;return typeof he=="object"?(yt=he,Lt=Oe):(yt={},Lt=he,st=Oe),ht.findTextInFiles(se,yt||{},Lt,Me.identifier,st)},saveAll:se=>ht.saveAll(se),applyEdit(se,he){return Wi.applyWorkspaceEdit(se,Me,he)},createFileSystemWatcher:(se,he,Oe,st)=>Ut.createFileSystemWatcher(ht,Me,se,he,Oe,st),get textDocuments(){return bt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw P.readonly()},openTextDocument(se){let he;const Oe=se;if(typeof se=="string")he=Promise.resolve(E.URI.file(se));else if(E.URI.isUri(se))he=Promise.resolve(se);else if(!Oe||typeof Oe=="object")he=bt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>bt.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(se,he,Oe)=>bt.onDidAddDocument(se,he,Oe),onDidCloseTextDocument:(se,he,Oe)=>bt.onDidRemoveDocument(se,he,Oe),onDidChangeTextDocument:(se,he,Oe)=>bt.onDidChangeDocument(se,he,Oe),onDidSaveTextDocument:(se,he,Oe)=>bt.onDidSaveDocument(se,he,Oe),onWillSaveTextDocument:(se,he,Oe)=>ei.getOnWillSaveTextDocumentEvent(Me)(se,he,Oe),get notebookDocuments(){return St.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Oe;if(E.URI.isUri(se))Oe=se,await St.openNotebookDocument(se);else if(typeof se=="string")Oe=E.URI.revive(await St.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(se,he,Oe){return si.onDidSaveNotebookDocument(se,he,Oe)},onDidChangeNotebookDocument(se,he,Oe){return si.onDidChangeNotebookDocument(se,he,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Oe,st){return St.registerNotebookSerializer(Me,se,he,Oe,(0,Ke.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(se,he,Oe)=>Li.onDidChangeConfiguration(se,he,Oe),getConfiguration(se,he){return he=arguments.length===1?void 0:he,Li.getConfiguration(se,he,Me)},registerTextDocumentContentProvider(se,he){return ri.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(Ae.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,se,he)),registerFileSystemProvider(se,he,Oe){return(0,Qe.combinedDisposable)($i.registerFileSystemProvider(Me,se,he,Oe),Vt.addFileSystemProvider(se,he))},get fs(){return Vt.value},registerFileSearchProvider:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"fileSearchProvider"),Pt.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"textSearchProvider"),Pt.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"resolvers"),kt.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,Ke.checkProposedApiEnabled)(Me,"resolvers"),Si.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Oe)=>Ut.onDidCreateFile(se,he,Oe),onDidDeleteFiles:(se,he,Oe)=>Ut.onDidDeleteFile(se,he,Oe),onDidRenameFiles:(se,he,Oe)=>Ut.onDidRenameFile(se,he,Oe),onWillCreateFiles:(se,he,Oe)=>Ut.getOnWillCreateFileEvent(Me)(se,he,Oe),onWillDeleteFiles:(se,he,Oe)=>Ut.getOnWillDeleteFileEvent(Me)(se,he,Oe),onWillRenameFiles:(se,he,Oe)=>Ut.getOnWillRenameFileEvent(Me)(se,he,Oe),openTunnel:se=>((0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.openTunnel(Me,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(se,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.onDidChangeTunnels(se,he,Oe)),registerPortAttributesProvider:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"portsAttributes"),Ce.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"timeline"),Bi.registerTimelineProvider(se,he,Me.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:se=>((0,Ke.checkProposedApiEnabled)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Oe)=>ht.onDidGrantWorkspaceTrust(se,he,Oe),registerEditSessionIdentityProvider:(se,he)=>((0,Ke.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(se,he)),onWillCreateEditSessionIdentity:(se,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Me)(se,he,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Me)},createSourceControl(se,he,Oe){return ci.createSourceControl(Me,se,he,Oe)}},xi={createCommentController(se,he){return wi.createCommentController(Me,se,he)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(se,he,Oe){return ct.onDidStartDebugSession(se,he,Oe)},onDidTerminateDebugSession(se,he,Oe){return ct.onDidTerminateDebugSession(se,he,Oe)},onDidChangeActiveDebugSession(se,he,Oe){return ct.onDidChangeActiveDebugSession(se,he,Oe)},onDidReceiveDebugSessionCustomEvent(se,he,Oe){return ct.onDidReceiveDebugSessionCustomEvent(se,he,Oe)},onDidChangeBreakpoints(se,he,Oe){return ct.onDidChangeBreakpoints(se,he,Oe)},registerDebugConfigurationProvider(se,he,Oe){return ct.registerDebugConfigurationProvider(se,he,Oe||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return ct.registerDebugAdapterDescriptorFactory(Me,se,he)},registerDebugAdapterTrackerFactory(se,he){return ct.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(se,he,{parentSession:Oe}):ct.startDebugging(se,he,Oe||{})},stopDebugging(se){return ct.stopDebugging(se)},addBreakpoints(se){return ct.addBreakpoints(se)},removeBreakpoints(se){return ct.removeBreakpoints(se)},asDebugSourceUri(se,he){return ct.asDebugSourceUri(se,he)}},mi={registerTaskProvider:(se,he)=>vt.registerTaskProvider(Me,se,he),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Me,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,he,Oe)=>vt.onDidStartTask(se,he,Oe),onDidEndTask:(se,he,Oe)=>vt.onDidEndTask(se,he,Oe),onDidStartTaskProcess:(se,he,Oe)=>vt.onDidStartTaskProcess(se,he,Oe),onDidEndTaskProcess:(se,he,Oe)=>vt.onDidEndTaskProcess(se,he,Oe)},Gi={createNotebookController(se,he,Oe,st,yt){return _t.createNotebookController(Me,se,he,Oe,st,(0,Ke.isProposedApiEnabled)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>St.registerNotebookCellStatusBarItemProvider(Me,se,he),createRendererMessaging(se){return vi.createRendererMessaging(Me,se)},createNotebookControllerDetectionTask(se){return(0,Ke.checkProposedApiEnabled)(Me,"notebookKernelSource"),_t.createNotebookControllerDetectionTask(Me,se)},registerKernelSourceActionProvider(se,he){return(0,Ke.checkProposedApiEnabled)(Me,"notebookKernelSource"),_t.registerKernelSourceActionProvider(Me,se,he)},onDidChangeNotebookCellExecutionState(se,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),_t.onDidChangeNotebookCellExecutionState(se,he,Oe)}},Xi={t(...se){if(typeof se[0]=="string"){const he=se.shift(),Oe=!se||typeof se[0]!="object"?se:se[0];return pt.getMessage(Me.identifier.value,{message:he,args:Oe})}return pt.getMessage(Me.identifier.value,se[0])},get bundle(){return pt.getBundle(Me.identifier.value)},get uri(){return pt.getBundleUri(Me.identifier.value)}};return{version:ft.version,authentication:Vi,commands:di,comments:xi,debug:Bt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Gi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:jt,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:k.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:b.UIKind,Uri:E.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:J.TelemetryTrustedValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:Et.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Dt}),define(ke[256],Te([1,0,255,33,2,249,7,17,240]),function(ne,e,i,P,I,F,E,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends F.RequireInterceptor{j(){}getModule(b,m){for(const o of this.b){const s=o(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=E.ExtensionRuntime.Webworker}async ob(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.ub()}pb(b){return b.browser}async qb(b,m,o){m=m.with({path:D(m.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const u=I.URI.revive(await this.v.$asBrowserUri(m)),p=await fetch(u.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),p.status!==200)throw new Error(p.statusText);const S=await p.text(),O=`${m.toString(!0)}#vscode-extension`,v=`${S}
//# sourceURL=${O}`;let t;try{t=new Function("module","exports","require",v)}catch(c){throw console.error(s?`Loading code for extension ${s} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${m.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}b&&await this.s.initializeLocalizedMessages(b);const d={},a={exports:d},l=c=>{const w=this.r.getModule(c,m);if(w===void 0)throw new Error(`Cannot load module '${c}'`);return w};try{return o.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(a,d,l),a.exports!==d?a.exports:d}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),o.codeLoadingStop()}}async $setRemoteEnvironment(b){}async ub(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=M;function D(h,b){return h.endsWith(b)?h:h+b}}),define(ke[257],Te([1,0,67,33,81,256]),function(ne,e,i,P,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(P.IExtHostExtensionService,F.ExtHostExtensionService,0),(0,i.registerSingleton)(I.IExtensionStoragePaths,I.ExtensionStoragePaths,0)}),define(ke[265],Te([1,0,23,4,74,250,242,19,82,15,2,252,257]),function(ne,e,i,P,I,F,E,R,y,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function o(t){self.fetch=async function(d,a){return d instanceof Request||b(String(d))&&(d=(await t(M.URI.parse(String(d)))).toString(!0)),m(d,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,a,l,c,w){(async()=>(b(a.toString())&&(a=(await t(M.URI.parse(a.toString()))).toString(!0)),super.open(d,a,l??!0,c,w)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,a){if(/^file:/i.test(d.toString()))d=k.FileAccess.uriToBrowserUri(M.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(f){function A(Q){return typeof Q=="string"||Q instanceof URL?String(Q).replace(/^file:\/\//i,"vscode-file://vscode-app"):Q}const T=fetch.bind(self);self.fetch=function(Q,Z){return Q instanceof Request?T(Q,Z):T(A(Q),Z)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Q,Z,_,j,L){return super.open(Q,A(Z),_??!0,j,L)}};const H=importScripts.bind(self);self.importScripts=(...Q)=>{H(...Q.map(A))},H(f)}.toString()}('${d}'))`;a=a||{},a.name=a.name||R.basename(d.toString());const w=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(w);return new t(n,a)}}else self.Worker=class extends E.NestedWorker{constructor(t,d){super(h,t,{name:R.basename(t.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(t){D()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const d=new MessageChannel,a=new P.Emitter;let l=!1;h(d.port2,[d.port2]),d.port1.onmessage=c=>{const{data:w}=c;if(!(w instanceof ArrayBuffer)){console.warn("UNKNOWN data received",w);return}const n=i.VSBuffer.wrap(new Uint8Array(w,0,w.byteLength));if((0,I.isMessageOfType)(n,2)){l=!0,S("received terminate message from renderer");return}a.fire(n)},this.protocol={onMessage:a.event,send:c=>{if(!l){const w=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);d.port1.postMessage(w,[w])}}}}}function p(t){return new Promise(d=>{const a=t.onMessage(l=>{a.dispose();const c=JSON.parse(l.toString());t.send((0,I.createMessageOfType)(0)),d({protocol:t,initData:c})});t.send((0,I.createMessageOfType)(1))})}let S=t=>D();function O(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(d){!O(d)||p(t.protocol).then(a=>{y.mark("code/extHost/didWaitForInitData");const l=new F.ExtensionHostMain(a.protocol,a.initData,s,null,d.data);o(c=>l.asBrowserUri(c)),S=c=>l.terminate(c)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4a834695686b52ddee116775560c7e12ba78482f/core/vs/workbench/api/worker/extensionHostWorker.js.map
